-- name=ho_injail
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "injail" );
  game.relations[ "ho_injail" ].exitroom = "rm_square";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_injail" ] = { type = "win", room = "rm_square", zz = "ho_injail", zz_gate = "gho_square_injail" };
 
  local win_injail_func = function ()

    if ( cmn.IsEventDone( "win_injail" ) ) then
      interface.InventoryItemAdd( "inv_address", "spr_injail_win" );
      ObjSet( "inv_address", {drag = 0} );
      ObjDelete( "gho_square_injail" );
    end;

  end;
  cmn.AddSubscriber( "win_injail", win_injail_func );
-----------------------------------------------------------------------------
 
----------------------------------------------------------------------------- 
  
  local unmark_fff = function () 
    ObjSet( "spr_injail_fff", {input = 1, alp = 1} );
    ObjDelete("gfx_injail_unmark_fff_zone")
    ObjDelete("spr_injail_unmark_fff_part_1")    
    ObjDelete("spr_injail_unmark_fff_part_1_sh")
    ObjSet("anm_injail_anm_unmark_fff",{animfunc="end_ax1",frame=0})
  end;
  cmn.AddSubscriber( "injail_unmark_fff", unmark_fff, "ho_injail" );   

  local unmark_eee = function () 
    ObjSet( "spr_injail_eee", {input = 1, visible = 1} );
    ObjDelete("gfx_injail_unmark_eee_zone")
    ObjSet("anm_injail_anm_unmark_eee",{animfunc="end_close1",frame=0})    
  end;
  cmn.AddSubscriber( "injail_unmark_eee", unmark_eee, "ho_injail" ); 

  
  local unmark_mmm= function () 
    ObjSet( "spr_injail_mmm", {input = 1,visible=1} );
    ObjDelete("anm_injail_anm_stone")
    ObjDelete("gfx_injail_unmark_mmm_zone")
    --ObjDelete("gfx_injail_unmark_mmm_zone2")  
    ObjDelete("spr_injail_sh_scrap")
    ObjDelete("spr_injail_scrap")   
    ObjDelete("obj_injail_stone_clk_zone"); 
  end;
  cmn.AddSubscriber( "injail_unmark_mmm", unmark_mmm, "ho_injail" ); 
  
  local start_injail_func = function ()
  if not cmn.IsEventDone("win_injail") then
    if cmn.IsUnmarkedTask("injail","fff") then 
      unmark_fff();
    end      
    if cmn.IsUnmarkedTask("injail","eee") then 
      unmark_eee();
    end
    if cmn.IsUnmarkedTask("injail","mmm") then 
      unmark_mmm();
    else
      if #ng_global.progress["std"]["win_injail"].found >= 12 then
           int_taskpanel_impl.ShowTask13() 
        ObjSet("anm_injail_anm_stone",{animfunc="clean_stone"..ng_global.progress["std"]["win_injail"].state_mmm,frame=0})
        ObjSet("spr_injail_mmm",{alp=1}) 
       ObjSet( "gfx_injail_unmark_mmm_zone", {input = 1} ); 
       ObjSet( "obj_injail_stone_clk_zone", {input = 1} );
        if ng_global.progress["std"]["win_injail"].state_mmm > 1 then 
          --ObjSet("gfx_injail_unmark_mmm_zone",{input=0,visible=0})
          --ObjSet("gfx_injail_unmark_mmm_zone2",{input=1,visible=1})
          ObjDelete("spr_injail_sh_scrap")
          ObjDelete("spr_injail_scrap")
        end       
      end
    end     
  end
  end;
  cmn.AddSubscriber( "win_injail", start_injail_func, "ho_injail" );  

end;

 
  
function public.win_injail_close_anim()  --ho_injail.win_injail_close_anim();
  local func_end = function()
   
    ld.Lock(0);
    common.GotoRoom( game.relations[ GetCurrentRoom() ].exitroom );    
  end;  
  
  
  ld.Lock(1);
  ObjAnimate( "ho_injail", 3, 0, 0, "", {0,0,0,0, 0.5,0,-200,0} );
  ObjAnimate( "ho_injail", 6, 0, 0, func_end, {0,0,1,1, 0.5,0,1.2,1.2, 1.5,0,1.2,1.2} );
end;  
  
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  level.tutorial_question.first()
  level.tutorial_newho1.first()
  level.tutorial_hint.first()
end
function public.PreOpen()
  
  --SoundEnv( "aud_ho_injail_env" )

  if ( not cmn.IsEventDone( "opn_injail" ) ) then

    cmn.InitHo( "injail" );
    cmn.SetMarkedTask( "injail", "fff" );  
    cmn.SetMarkedTask( "injail", "eee" );  
    --cmn.SetEventDone( "opn_injail" );
    cmn.SetMarkedTask( "injail", "mmm" );  
    ng_global.progress["std"]["win_injail"].state_mmm = 1
    ng_global.progress[ "std" ].common.currentmaproom = "rm_square"
    private.SeeIntro()
  end;

 if cmn.IsEventDone("opn_injail") then 
    SoundHoTheme( true );
    SoundEnv( "aud_ho_injail_env" );
  end;  
  if ( cmn.IsEventDone( "opn_injail" ) ) then  
     private.TskPnlShow()
  end
   for j = 1, #ng_global.progress["std"]["win_injail"].found do

    local name = tostring( ng_global.progress["std"]["win_injail"].found[j]["object"] );
   
    ObjDelete( name );
    if name == "spr_injail_jjj" then
      ObjDelete("spr_injail_little")
    end
  end;

end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
  ld.ShowBbt("after_ho_jail");
  int_taskpanel_impl.ResetTaskVisible()
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  if #ng_global.progress["std"]["win_injail"].found  == 12 then
    ld.Lock(1);
    SoundSfx( "aud_ho_injail_stones" );
    ld.AnimPlay("anm_injail_anm_stone","stone",function()
      ld.Lock(0);
      ObjSet("spr_injail_lll",{alp=1});
      ObjSet( "gfx_injail_unmark_mmm_zone", {input = 1} ); 
      ObjSet( "obj_injail_stone_clk_zone", {input = 1} ); 
      end)
    int_taskpanel_impl.ShowTask13();     
  end;
end;


--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  
  ObjSet( "spr_injail_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_injail_"..task_name, task_name );

  
end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_fff() 
  if ApplyObj("spr_injail_unmark_fff_part_1","gfx_injail_unmark_fff_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "injail", "fff" );
    cmn.CallEventHandler( "injail_unmark_fff" );
  end
  ld.Lock(1) 
  ObjDelete("spr_injail_unmark_fff_part_1")
  ObjDelete("gfx_injail_unmark_fff_zone")
  SoundSfx( "aud_ho_injail_axe" );
  ld.AnimPlay("anm_injail_anm_unmark_fff","use_ax",func_end)
  else 
  ObjSet("spr_injail_unmark_fff_part_1",{pos_z = 1})
  ObjSet( "spr_injail_unmark_fff_part_1_sh", {alp = 1} );    
  end
end;


--private.injail_page_hint_zone = "gfx_injail_unmark_jjj_zone";
function public.injail_page_show_jjj()  --ho_injail.injail_page_show_jjj()
  local func_end = function()
      ld.Lock(0);
      int.InterfaceSetInput(0);
      ObjDelete("spr_injail_little");
      ObjDelete("gfx_injail_unmark_jjj_zone")
      ObjSet( "spr_injail_jjj", {input = 1, alp = 1} );
      ld.ShowBbt("injail_order");
  end;
    
  ld.Lock(1);
  
  SoundSfx( "aud_paper_open" );
   --ObjSet("anm_injail_anm_unmark_jjj",{animfunc="end_bed1",frame=0})
   --ObjSet("spr_injail_jjj_tr",{alp=1})
   ObjAnimate( "spr_injail_little", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
   ObjAnimate( "spr_injail_jjj", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );  
end;  

 function public.find_jjj(sender, task)
   int.InterfaceSetInput(1);
   cmn.HoTaskFind( sender, task );
 end


function public.unmark_eee() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "injail", "eee" );
    cmn.CallEventHandler( "injail_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_injail_unmark_eee_zone")
  SoundSfx( "aud_ho_injail_cloth" );
  ld.AnimPlay("anm_injail_anm_unmark_eee","click_close",func_end) 
end

function public.unmark_mmm() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "injail", "mmm" );
    cmn.CallEventHandler( "injail_unmark_mmm" );
  end
  local f_check = function()
    ld.Lock(0) 
    ng_global.progress["std"]["win_injail"].state_mmm = ng_global.progress["std"]["win_injail"].state_mmm + 1
    if ng_global.progress["std"]["win_injail"].state_mmm == 2 then
      func_end()
    end
  end
  ld.Lock(1) 
  local s = ng_global.progress["std"]["win_injail"].state_mmm
  ObjSet("gfx_injail_unmark_mmm_zone",{input=0,visible=0})
  --ObjSet("gfx_injail_unmark_mmm_zone2",{input=1,visible=1})
  ObjDelete("spr_injail_sh_scrap")
  ObjDelete("spr_injail_scrap")
  ObjDelete("obj_injail_stone_clk_zone");
  SoundSfx( "aud_ho_injail_remove_stones" );
  ld.AnimPlay("anm_injail_anm_stone","clean_stone"..s,f_check) 
end

function public.call_end_game_down()

  ObjSet( "spr_injail_mmm", { pos_z = 1} );
  cmn.HoTaskFind( "spr_injail_mmm", "mmm" );
  
  --event_mdown="ObjSet( ne_params.sender, { pos_z = 1,
  --event_mleave = function()ld.ShCur(CURSOR_DEFAULT) end } );
  --  cmn.HoTaskFind( ne_params.sender, "mmm" );" 
  --event_menter="ld.ShCur(CURSOR_UP);
  --ObjAnimate( "spr_injail_mmm", 8, 0, 0, "", {0,0,ObjGet("spr_injail_mmm").alp, 0.2,0,1} );"
  --event_mleave="ld.ShCur(CURSOR_DEFAULT);
  --ObjAnimate( "spr_injail_mmm", 8, 0, 0, "", {0,0,ObjGet("spr_injail_mmm").alp, 0.2,0,0} );"
  --                           
end;

function private.TskPnlShow()
    local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_injail_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_injail_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_injail_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_injail_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_injail_eee" },{"gfx_injail_unmark_eee_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_injail_fff" },{"spr_injail_unmark_fff_part_1","gfx_injail_unmark_fff_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_injail_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_injail_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_injail_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_injail_jjj" },{"spr_injail_little"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_injail_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_injail_lll" } } );
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 1, { { "spr_injail_mmm" },{"gfx_injail_unmark_mmm_zone"} } );       
  interface.TaskPanelShow( ho_items );
  --,{"gfx_injail_unmark_mmm_zone2"}
end

function private.SeeIntro()
    local widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu,
      InterfaceWidget_Btn_Diary
    }  
    local func_end = function()
      ObjDelete("tmr_injail_vid_intro");
      SoundVoice(0);
      SndStop( "assets/levels/common/audio/aud_intro_cicle", 0.25 )

      ld.Lock(1)
      ObjSet( "obj_int_dialog_video_input", {event_mdown = ""} );
      ---
      ObjAnimate( "vid_injail_vid_intro_cicle", 8, 0, 0, "", {0,0,ObjGet("vid_injail_vid_intro_cicle").alp, 0.5,0,0} );
      ObjAnimate( "vid_injail_vid_intro_after", 8, 0, 0, "", {0,0,ObjGet("vid_injail_vid_intro_after").alp, 0.5,0,0} );
      ObjAnimate( "vid_injail_vid_intro", 8, 0, 0, "", {0,0,ObjGet("vid_injail_vid_intro_cicle").alp, 0.5,0,0} );
      ---

      ObjAnimate( private.current_intro_video, 8, 0, 0, function() ObjDetach(private.current_intro_video) ld.Lock(0);  SoundHoTheme( true );  end, {0,0,1, 0.5,0,0} );
      int.DialogVideoHide();
      cmn.SetEventDone( "opn_injail" );
      cmn.CallEventHandler( "opn_injail" )
      
      
      -- SoundEnv( "aud_injail_env" )

      for i = 1, #widget_settings do

        interface.WidgetSetVisible( widget_settings[i], 1,true );

      end;

      SoundEnv( "aud_ho_injail_env" )
      private.TskPnlShow()
    end

    local func_skip_end=function()
       SndStop( "assets/levels/common/audio/aud_intro_after",0.25);
       func_end();
    end;

  
    public.func_end2 = function() 
--      ld.LogTrace( "3>>>>>" );
      SndPlay( "assets/levels/common/audio/aud_intro_after", "sfx", 0, 0.5 );
      SndStop( "assets/levels/common/audio/aud_intro_cicle", 0.25 )
      
      SoundVoice( "aud_intro_after_voc" );
      
      ObjSet( "obj_int_dialog_video_input", {event_mdown = ""} );
      private.current_intro_video = "vid_injail_vid_intro_after"
      ObjDetach("vid_injail_vid_intro_cicle")
      ObjAttach("vid_injail_vid_intro_after","ho_injail")
      VidPlay("vid_injail_vid_intro_after", func_end);

   --   int.DialogVideoShow( "", 1, func_skip_end);      
    end

    local func_end3 = function()
--      ld.LogTrace( "2>>>>>" );  
      
      private.current_intro_video = "vid_injail_vid_intro_cicle"
      ObjDetach("vid_injail_vid_intro")
      ObjAttach("vid_injail_vid_intro_cicle","ho_injail")

      local cicle_vid = 0
      private.func_cicle_vid = function()
          if cicle_vid == 0 then 
            ObjAnimate( "txt_injail_vid_intro_cicle_profile", 8, 0, 0, "", {0,0,1, 0.2,0,0} );
            public.func_end2()
          else 
            cicle_vid = cicle_vid - 1
            VidPlay("vid_injail_vid_intro_cicle",function()private.func_cicle_vid() end )
          end

      end
      ObjSet("txt_injail_vid_intro_cicle_profile",{text= GetCurrentProfile()})
      ObjAnimate( "txt_injail_vid_intro_cicle_profile", 8, 0, 0, "", {0,0,0, 0.5,0,1} );
      while  ObjGet("txt_injail_vid_intro_cicle_profile").draw_width > 200 do
        ObjSet( "txt_injail_vid_intro_cicle_profile", { fontsize = ObjGet("txt_injail_vid_intro_cicle_profile").fontsize-1 } );
      end
      
      
      VidPlay("vid_injail_vid_intro_cicle", private.func_cicle_vid );
      
      --local sfx_cicle
      --sfx_cicle = function()
      --  VidPlay("vid_injail_vid_intro_cicle",sfx_cicle)
      --  ld.LogTrace( "cicle" )
      --  SoundSfx( "aud_intro_cicle", -1 )
      --end;
      --sfx_cicle()
      --PlaySfx( "assets/levels/common/audio/aud_intro_cicle", 1, "", 0.5 )
      SndPlay( "assets/levels/common/audio/aud_intro_cicle", "sfx", 1, 0.5 );
    end
--    ld.LogTrace( "1>>>>>" );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;
    private.current_intro_video = "vid_injail_vid_intro"
    ObjAttach("vid_injail_vid_intro","ho_injail")
    ObjAnimate( "vid_injail_vid_intro", 7,0,0, function() SoundVid( "aud_intro" ); end, { 0,0,0, 0.01,0,0 } )
    VidPlay("vid_injail_vid_intro",func_end3)
    int.DialogVideoShow( "", 1, func_skip_end, 3 );

  end