-- name=mg_forks
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_forks";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_forks" ] = {type = "win", use_place = "mg_forks", room = "rm_livingroom", zz = "mg_forks", zz_gate = "gmg_livingroom_forks" };

  local win_forks_logic = function()
    if ld.CheckRequirements( {"win_forks"} ) then
      
    end
  end;
  local win_forks = function()
    if ld.CheckRequirements( {"win_forks"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_forks", win_forks, private.room_objname )
  cmn.AddSubscriber("win_forks", win_forks_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

local forks_field_left_up = {226,178};
local forks_field_first_pos={188,139};
local forks_field_step = 80.5;




private.forks_field_st = {{1,0,0,0,2,0,0},
                          {8,7,0,0,0,0,0},
                          {0,0,0,0,0,0,3},
                          {0,0,0,0,0,0,0},
                          {0,0,6,0,4,0,5}}



private.forks_fp = {{0,0,0,0,0,4,1},
                    {0,0,0,0,0,0,7},
                    {3,6,0,0,0,0,0},
                    {0,5,0,0,0,0,0},
                    {0,0,8,2,0,0,0}}

private.forks_dt_angles = {90,0,90,180,-90,180,-90,0}   
private.forks_move_array = {1,3,2,4,2,4,1,3}; -- 1-left, 2-right, 3-up,4 -down                 

private.forks_first_init_flag = false;
function private.forks_first_init()
  forks_field_first_pos ={forks_field_left_up[1]-forks_field_step/2,forks_field_left_up[2]-forks_field_step/2}
  
  if not private.forks_first_init_flag then 
    for i=1,8,1 do 
      local angle = (private.forks_dt_angles[i]/180)*math.pi; 
      
      local num=i;
      if i>4 then num=i-4; end;
      
      local obj = "spr_forks_dt_"..i; 
      ObjCreate(obj,"spr");
      ObjAttach(obj,"obj_forks_field_root");
      ObjSet( obj, {input=1, res="assets/levels/level/mg_forks/dt_"..num, inputrect_init=1, inputrect_w=80, inputrect_h=80, inputrect_x=-40, inputrect_y=-40, pos_z=5, ang=angle, 
      event_mdown="mg_forks.forks_det_move("..i..");", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
      
      local obj2 = "spr_forks_lig_dt_"..i;
      ObjCreate(obj2,"spr");
      ObjAttach(obj2,obj);
      ObjSet( obj2, {res="assets/levels/level/mg_forks/lig_dt_"..num, input=0, visible=1, alp=0} );
      
      local obj3 = "spr_forks_slot_dt_"..i;
      ObjCreate(obj3,"spr");
      ObjAttach(obj3,"obj_forks_field_root");
      ObjSet( obj3, {res="assets/levels/level/mg_forks/slot_dt"..num, input=0, visible=1, alp=1,ang=angle} );
    end;
  
  --  local count1=0;
  --  for i=1,5,1 do 
  --    for j=1,7,1 do 
  --      count1=count1+1;
  --      private.forks_field_st[i][j]=count1;
  --    end;  
  --  end;  
   
    local count = 0;
    for i=1,5,1 do 
      for j=1,7,1 do 
        if private.forks_field_st[i][j]~=0 then 
             count = count+1;
           -- local obj3 = "spr_forks_slot_dt_"..count;
           -- ObjCreate(obj3,"spr");
           -- ObjAttach(obj3,"obj_forks_field_root");
           -- ObjSet( obj3, {res="assets/levels/level/mg_forks/slot_dt1", input=0, visible=1, alp=1} );
           local pos_f = {forks_field_first_pos[1]+forks_field_step*j,forks_field_first_pos[2]+forks_field_step*i};
           ObjSet(  "spr_forks_slot_dt_".. private.forks_field_st[i][j], {pos_x = pos_f[1], pos_y=pos_f[2]} );
        end;
      end;  
    end;  
    
  end;  
  private.forks_first_init_flag = true;
end;  


function private.forks_stand_on_pos(without_win_ver)
  for i=1,5,1 do
    for j=1,7,1 do 
      if  ng_global.progress["std"]["win_forks"].state[i][j]~=0 then 
        local pos_f = {forks_field_first_pos[1]+forks_field_step*j,forks_field_first_pos[2]+forks_field_step*i};
        ObjSet(  "spr_forks_dt_"..ng_global.progress["std"]["win_forks"].state[i][j], {pos_x = pos_f[1], pos_y=pos_f[2]} );
      end;  
    end;  
  end;  
  
  private.forks_win_ver( without_win_ver);
end;  

local forks_win_ver_count = -1;
function private.forks_win_ver( without_win_ver)
  local count=0;
  for i=1,5,1 do 
    for j=1,7,1 do 
      if private.forks_field_st[i][j]==ng_global.progress["std"]["win_forks"].state[i][j] and private.forks_field_st[i][j]~=0 then
         ObjSet(  "spr_forks_dt_"..ng_global.progress["std"]["win_forks"].state[i][j], {input=0} );
         ObjSet( "spr_forks_lig_dt_"..ng_global.progress["std"]["win_forks"].state[i][j], {alp=1, color_r=0, color_g=1, color_b=0} );
         count = count+1;
      else  
         if ng_global.progress["std"]["win_forks"].state[i][j]~=0 then 
            ObjSet(  "spr_forks_dt_"..ng_global.progress["std"]["win_forks"].state[i][j], {input=1} );
            ObjSet( "spr_forks_lig_dt_"..ng_global.progress["std"]["win_forks"].state[i][j], {alp=0, color_r=1, color_g=1, color_b=1} );
         end;  
         
      end;
    end;  
  end;
  
 -- ld.LogTrace( "count = "..count ); 
  if forks_win_ver_count==-1 then 
  elseif forks_win_ver_count<count then SoundSfx( "aud_mg_fork_true" ); end;
  
  forks_win_ver_count = count;  
    
  if  without_win_ver~=1 and count == 8 then private.Win() end;  
end;  




-----------------------------------------------------------------
function private.forks_get_part_pos_f(num)
  for i=1,5,1 do 
    for j=1,7,1 do 
      local ret={i,j};
      if ng_global.progress["std"]["win_forks"].state[i][j] == num then return ret; end; 
    end;  
  end;  
  
end;  

function private.forks_show_state()
  --ld.LogTrace( "_______________________________" );
  
   for i=1,#ng_global.progress["std"]["win_forks"].state,1 do
     local my_str = ""; 
     for j=1,#ng_global.progress["std"]["win_forks"].state[i],1 do
       my_str = my_str.." "..ng_global.progress["std"]["win_forks"].state[i][j];
     end;  
     --ld.LogTrace( my_str );
   end;  
end;


local move_flag=true;
function public.forks_det_move(num, other_napr) --mg_forks.forks_det_move(num)
  
  local napr = private.forks_move_array[num]; -- 1-left, 2-right, 3-up,4 -down      
  local cur_pos = {ObjGet( "spr_forks_dt_"..num).pos_x, ObjGet( "spr_forks_dt_"..num).pos_y};
  local cur_f = private.forks_get_part_pos_f(num);
  local next_f = ld.TableCopy(cur_f);
  local next_pos = ld.TableCopy(cur_pos);
  
  if other_napr~=nil then napr = other_napr end;
  
  local func_end = function()
     ObjSet( "spr_forks_lig_dt_"..num, {color_r=1, color_g=1, color_b=1} );
  --  ng_global.progress["std"]["win_forks"].state[cur_f[1] ][cur_f[2] ]=0;
  --  ng_global.progress["std"]["win_forks"].state[next_f[1] ][next_f[2] ]=num;
    ld.Lock(0);
   --  private.forks_show_state()
    if other_napr==nil then private.forks_stand_on_pos(); move_flag=true end;
  end;  
  
  if napr==1 and cur_f[2]>1 then 
    next_f = {cur_f[1],(cur_f[2]-1)};
  elseif napr==2 and cur_f[2]<7 then 
    next_f = {cur_f[1],(cur_f[2]+1)};
  elseif napr==3 and cur_f[1]>1 then 
    next_f = {(cur_f[1]-1),cur_f[2]};
  elseif napr==4 and cur_f[1]<5 then 
    next_f = {(cur_f[1]+1),cur_f[2]};
  end;  
  
  if other_napr~=nil and cur_f[1]==next_f[1] and cur_f[2]==next_f[2] then 
    move_flag=false;
  elseif other_napr~=nil then 
    move_flag=true; 
  end;
  
  if ng_global.progress["std"]["win_forks"].state[next_f[1] ][next_f[2] ]>0 and ng_global.progress["std"]["win_forks"].state[next_f[1] ][next_f[2] ]~=num and ng_global.progress["std"]["win_forks"].state[next_f[1] ][next_f[2] ]~=nil then 
    public.forks_det_move(ng_global.progress["std"]["win_forks"].state[next_f[1] ][next_f[2] ], napr);
  end;  
  
 
  ld.Lock(1);
  if move_flag == false then next_f=ld.TableCopy(cur_f) end;
  if ng_global.progress["std"]["win_forks"].state[next_f[1] ][next_f[2] ] == num and other_napr==nil then  SoundSfx( "aud_mg_fork_wrong" ); ObjSet( "spr_forks_lig_dt_"..num, {color_r=1, color_g=0, color_b=0} ); end;
  next_pos = {forks_field_first_pos[1]+forks_field_step*next_f[2],forks_field_first_pos[2]+forks_field_step*next_f[1]};
  
  if cur_pos[1]~=next_pos[1] or cur_pos[2]~=next_pos[2] then SoundSfx( "aud_mg_fork_move" ); end;
  
  ObjAnimate( "spr_forks_dt_"..num, 3, 0, 0, func_end, {0,0,cur_pos[1],cur_pos[2], 0.3,0,next_pos[1],next_pos[2]} );
  ng_global.progress["std"]["win_forks"].state[cur_f[1] ][cur_f[2] ]=0;
  ng_global.progress["std"]["win_forks"].state[next_f[1] ][next_f[2] ]=num;
  
 
  if other_napr==nil then ObjAnimate( "spr_forks_lig_dt_"..num, 8, 0, 0, function() end, {0,0,0, 0.1,0,1, 0.2,0,1, 0.3,0,0} ); end;
end;  

--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_forks"} ) then
    SoundMgTheme( true )
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( {"win_forks"} ) then
    cmn.MiniGameShow( "forks" );
  end  
    
  
  private.forks_first_init();
  
  SoundEnv( "aud_livingroom_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_forks"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "forks" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function() 
      ng_global.progress["std"]["win_forks"].state = ld.TableCopy(private.forks_fp);
      private.forks_stand_on_pos();
      ObjAnimate( "obj_forks_field_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );  
  end
  
  ld.Lock(1);
  forks_win_ver_count =-1;
  ObjAnimate( "obj_forks_field_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function public.Skip()
  local func_end = function() 
      ng_global.progress["std"]["win_forks"].state = ld.TableCopy(private.forks_field_st);
      private.forks_stand_on_pos(1);
      ObjAnimate( "obj_forks_field_root", 8, 0, 0, function()  private.forks_stand_on_pos(); end, {0,0,0, 0.25,0,1} );
  end
  
  ld.Lock(1);
  ObjAnimate( "obj_forks_field_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  --ld.LogTrace( "winend" );
  --ld.Lock(0);
  cmn.SetEventDone( "win_forks" );
  cmn.CallEventHandler( "win_forks" );
  --  if common_impl.ZzCompleteCheck( "win_forks" ) then cmn.GotoRoom( "rm_livingroom" ); SoundSfx( "aud_open_cellar_livingroom" ); end;
  ld.StartTimer( 0.5, function() ld.Lock(0); cmn.GotoRoom( "rm_livingroom" ); SoundSfx( "aud_open_cellar_livingroom" );   end )
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_forks"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_forks"].state )
    else  
       ng_global.progress["std"]["win_forks"].state = ld.TableCopy(private.forks_fp)
    end
  
    gm.loaded  = true;
  else
  
  end;
   private.forks_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_forks"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;