-- name=mg_onroadwaymg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_onroadwaymg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_onroadwaymg" ] = {type = "win", use_place = "mg_onroadwaymg", room = "rm_nearhouse", zz = "mg_onroadwaymg", zz_gate = "gmg_nearhouse_onroadwaymg" };

  local win_onroadwaymg_logic = function()
    if ld.CheckRequirements( {"win_onroadwaymg"} ) then
      
    end
  end;
  local win_onroadwaymg = function()
    if ld.CheckRequirements( {"win_onroadwaymg"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_onroadwaymg", win_onroadwaymg, private.room_objname )
  cmn.AddSubscriber("win_onroadwaymg", win_onroadwaymg_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
end;
----------------------------------------------------------------------------------------
public.onroadway_parts_array={};
public.onroadway_parts_array[2]={{620,108},
                                 {653,210},
                                 {735,212},
                                 {727,332},
                                 {641,290},
                                 {680,360},
                                 {765,345},
                                 {665,428},
                                 {644,568},
                                 {614,552},
                                 {785,552}}
public.onroadway_parts_array[1] = {{398,107},
                                   {364,209},
                                   {283,219},
                                   {291,331},
                                   {376,290},
                                   {338,360},
                                   {253,345},
                                   {352,427},
                                   {374,568},
                                   {403,551},
                                   {232,551}}; 
   

public.onroadway_parts_light_global_pos = {};
public.onroadway_parts_light_global_pos[1]={{398,106},
                                            {364,209},
                                            {279,212},
                                            {291,331},
                                            {375,290},
                                            {338,361},
                                            {252,345},
                                            {352,425},
                                            {373,567},
                                            {403,551},
                                            {233,551}}                                   
                                 
public.onroadway_parts_light_global_pos[2]={{619,107},
                                            {654,210},
                                            {738,213},
                                            {726,331},
                                            {642,291},
                                            {680,361},
                                            {765,345},
                                            {666,426},
                                            {644,568},
                                            {614,552},
                                            {784,552}}
                                            
public.onroadway_parts_light_local_pos={};
--------------------------------------------------------------------------------------
function private.onroadway_get_local_lights_pos()
   for i=1,2,1 do 
     public.onroadway_parts_light_local_pos[i]={};
     for j=1,#public.onroadway_parts_array[i],1 do 
       public.onroadway_parts_light_local_pos[i][j] = {public.onroadway_parts_light_global_pos[i][j][1]-public.onroadway_parts_array[i][j][1],public.onroadway_parts_light_global_pos[i][j][2]-public.onroadway_parts_array[i][j][2]};
     end;  
   end;  
end;
---------------------------------------------------------------------------------------                                            

public.onroadway_parts_creat_flag = false;
function public.onroadway_parts_creat()
  if public.onroadway_parts_creat_flag == false then 
     private.onroadway_get_local_lights_pos();
     local napr={"left","right"};
     local napr2 = {"b","a"}
     for i=1,2,1 do 
       for j=1,#public.onroadway_parts_array[i],1 do 
         ObjCreate("spr_onroadway_part_"..i.."_"..j,"spr");
         ObjAttach("spr_onroadway_part_"..i.."_"..j,"obj_onroadway_"..napr[i].."_root");
         ObjSet( "spr_onroadway_part_"..i.."_"..j, {input=0,active=1, visible=1, res="assets/levels/level/mg_onroadwaymg/"..napr2[i]..j, pos_x=public.onroadway_parts_array[i][j][1], pos_y=public.onroadway_parts_array[i][j][2], 
             event_mdown="mg_onroadwaymg.onroadway_part_mdown("..i..","..j..");", event_menter="ld.SetCursor(CURSOR_HAND);",  event_mleave="ld.SetCursor(CURSOR_HAND);"} );

         ObjCreate("spr_onroadway_part_light_"..i.."_"..j,"spr");
         ObjAttach("spr_onroadway_part_light_"..i.."_"..j,"spr_onroadway_part_"..i.."_"..j);
         ObjSet( "spr_onroadway_part_light_"..i.."_"..j, {input=0,active=1, visible=1, alp=0, res="assets/levels/level/mg_onroadwaymg/lig_"..napr2[i]..j, pos_x=public.onroadway_parts_light_local_pos[i][j][1], pos_y=public.onroadway_parts_light_local_pos[i][j][2]} );
       end;  
     end;  
  end;
  public.onroadway_parts_creat_flag = true;  
end; 
---------------------------------------------------------------------------------------
function private.onroadway_stand_on_pos(without_ver)
  for i=1,2,1 do 
    for j=1,#public.onroadway_parts_array[i],1 do 
      ObjSet( "spr_onroadway_part_"..i.."_"..j, {ang=math.pi*(ng_global.progress["std"]["win_onroadwaymg"].state[i][j]/180), input=1} );
    end;  
  end;  
  ng_global.progress["std"]["win_onroadwaymg"].state[1][4]=0;
  ng_global.progress["std"]["win_onroadwaymg"].state[2][4]=0;
  ObjSet( "spr_onroadway_part_1_4", {ang=0, input=0} );
  ObjSet( "spr_onroadway_part_2_4", {ang=0, input=0} );
  if without_ver~=1 then private.onroadway_win_ver() end;
end;
-----------------------------------------------------------------------------------------
private.onroadway_true_count_last = 0;
function private.onroadway_win_ver()
  local count={0,0};
 -- local true_count=0;
  
  for i=1,2,1 do 
    for j=1,#public.onroadway_parts_array[i],1 do 
      if ng_global.progress["std"]["win_onroadwaymg"].state[i][j]==0 then count[i]=count[i]+1; 
        ObjSet( "spr_onroadway_part_light_"..i.."_"..j, {alp=1} );
      else 
        ObjSet( "spr_onroadway_part_light_"..i.."_"..j, {alp=0} );
      end;  
    end;  
  end;  
  
  private.onroadway_true_count_last = count[1]+count[2];
  
  if count[1]+count[2]==2*(#public.onroadway_parts_array[1]) then 
    private.Win();
  end;  
end;  
---------------------------------------------------------------------------------------
function public.onroadway_to_rad(ang)
  local rad_ang = math.pi*(ang/180);
  return rad_ang;
end;  

function public.onroadway_part_mdown(ii,jj)
   local angle_count = 5;
   local angle_step = 360/angle_count;
   
   ld.Lock(1);
   local current_ang = ng_global.progress["std"]["win_onroadwaymg"].state[ii][jj];
   local next_ang = current_ang+angle_step,360;
   
   local func_end = function()
     ld.Lock(0);
     ng_global.progress["std"]["win_onroadwaymg"].state[ii][jj] = math.fmod(next_ang,360); 
     local onroadway_true_count_last_copy =  private.onroadway_true_count_last;
     private.onroadway_stand_on_pos();
     if  private.onroadway_true_count_last > onroadway_true_count_last_copy then SoundSfx( "aud_mg_onroadway_true" ) end;
   end;  
   
   SoundSfx( "aud_mg_onroadway_rotate" );
   ObjAnimate( "spr_onroadway_part_"..ii.."_"..jj, 7, 0, 0, func_end, {0,0,public.onroadway_to_rad(current_ang), 0.5,0,public.onroadway_to_rad(next_ang)} );
   ObjAnimate( "spr_onroadway_part_light_"..ii.."_"..jj, 8, 0, 0, function() end, {0,0,0, 0.24,0,1, 0.48,0,0} );
   end;  

--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_onroadwaymg"} ) then
     SoundMgTheme( true );
  end;   
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( {"win_onroadwaymg"} ) then
    SoundMgTheme( true )
    cmn.MiniGameShow( "onroadwaymg" );
    --  private.onroadway_stand_on_pos();
  end
  
  public.onroadway_parts_creat()
  SoundEnv( "aud_nearhouse_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_onroadwaymg"} ) then
    cmn.MiniGameHide( "onroadwaymg" );
  end
  SoundMgTheme( false );
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
    ld.Lock(0);
    private.onroadway_stand_on_pos()
  end;  
  
  ld.Lock(1);
  private.onroadway_stand_random_fp();
  for i=1,2,1 do 
    for j=1,#public.onroadway_parts_array[i],1 do 
      if j==4 then ng_global.progress["std"]["win_onroadwaymg"].state[i][j]=0; end;
      local cur_ang = ObjGet("spr_onroadway_part_"..i.."_"..j).ang;
      local next_ang  = math.pi*(ng_global.progress["std"]["win_onroadwaymg"].state[i][j]/180)
      ObjAnimate( "spr_onroadway_part_"..i.."_"..j, 7, 0, 0, function() end, {0,0,cur_ang, 0.5,0,next_ang} );
    end;  
  end;
  ld.StartTimer( 0.6, func_end )  
end;
--*********************************************************************************************************************
function public.Skip()
  -- private.Win();
  
  
  local func_end = function()
    ld.Lock(0);
    private.onroadway_stand_on_pos()
  end;  
  
  ld.Lock(1);
  for i=1,2,1 do 
    for j=1,#public.onroadway_parts_array[i],1 do 
      local cur_ang = ObjGet("spr_onroadway_part_"..i.."_"..j).ang;
      local next_ang  = 0;
      ng_global.progress["std"]["win_onroadwaymg"].state[i][j]=0;
      ObjAnimate( "spr_onroadway_part_"..i.."_"..j, 7, 0, 0, function() end, {0,0,cur_ang, 0.5,0,next_ang} );
    end;  
  end;
  ld.StartTimer( 0.6, func_end )  
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_onroadwaymg" );
  cmn.CallEventHandler( "win_onroadwaymg" );
  if common_impl.ZzCompleteCheck( "win_onroadwaymg" ) then cmn.GotoRoom( "rm_nearhouse" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5,function() SoundSfx( "aud_mg_onroadway_win" );  ld.AnimPlay( "anm_onroadwaymg_anm_doormg", "use_close", private.WinEnd ); end  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.onroadway_stand_random_fp()
   local angle_count = 5;
   local angle_step = 360/angle_count;
   
   for i=1,2,1 do 
     ng_global.progress["std"]["win_onroadwaymg"].state[i]={};
     for j=1,#public.onroadway_parts_array[i],1 do 
       local new_ang = math.fmod(math.random(1,5)*angle_step,360);
       ng_global.progress["std"]["win_onroadwaymg"].state[i][j] = new_ang;
     end;  
   end;
   
end;  


function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_onroadwaymg"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_onroadwaymg"].state )
    else  
      ng_global.progress["std"]["win_onroadwaymg"].state={};
      private.onroadway_stand_random_fp();
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.onroadway_stand_on_pos()
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_onroadwaymg"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;