-- name=level

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 13 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 11 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 9 );

  interface.WidgetAdd( InterfaceWidget_Effects );



  interface.WidgetAdd( InterfaceWidget_DialogHo,30 );

  interface.ButtonLockAdd();
  interface.LockAdd();



  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel,9 );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,30 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo,30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory,30 );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 30 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial,32 );

  interface.WidgetAdd( InterfaceWidget_Map, 16  );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 15 );

  interface.PanelNotificationAdd(10);

  if IsCollectorsEdition() then
    if true then -- temp for version
      interface.WidgetAdd( InterfaceWidget_StrategyGuide,45 );
      interface.WidgetAdd( InterfaceWidget_BtnGuide, 12 );
    end
  end
  
  --interface.DeployInvAdd(7);
  interface.ComplexInvAdd( 9 )
  interface.DialogHintAdd(20);
  --interface.Btn_DiaryAdd(12)
  --interface.InvestigationButtonAdd( 17 );
  --interface.DiaryAdd( 18 );
  --interface.DiaryDcnAdd( 31 );

  interface.PanelhopairAdd(9)

  interface.ButtonTaskAdd(20)
  interface.DialogTaskAdd(19)

  private.Init();


  ModLoad( "assets/levels/level/mod_level_inv" );
  level_inv.Init()

  private.TutorInit()--тутор
  --
  interface.ArrCards()
  interface.ArrPuzzles()

  common.LevelLoad( "level", "std", "ho_injail", param );
  --ModLoad( "assets/interface/map/mod_map" );



  interface.ArrInvPlus()  -- проверка состояния плюсика для деплойных инв предметов

  interface.KeyUpdate();

  --временно залочена кнопка SG
  interface.WidgetSetInput(InterfaceWidget_BtnGuide, 1)

  ObjSet( "txt_int_dialog_character", {param0 = GetCurrentProfile()} );
  --автоподствновка имени игрока в диалоги

  interface.CheckPuzzles()
  interface.CheckMorphing()
  interface.CheckCards()


end;

function public.CubeAdd() -- get_casket
  
  interface.CubeAdd( -999 )
  cmn.CallEventHandler( "LevelLoaded" )

end

function public.SimonAdd() -- get_simon
  
  interface.SimonAdd(14)
 -- int_simon.LoadAnotherPrg()
end

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_square"
    ,"rm_outro"


--[[AUTO]]  ,"ho_injail"
--[[AUTO]]  ,"rm_nearhouse"
--[[AUTO]]  ,"mg_behindglass"
--[[AUTO]]  ,"ho_tree"
--[[AUTO]]  ,"rm_housedoctor"
--[[AUTO]]  ,"rm_laboratory"
--[[AUTO]]  ,"rm_roadway"
--[[AUTO]]  ,"rm_livingroom"
--[[AUTO]]  ,"ho_toys"
--[[AUTO]]  ,"rm_bedroomboy"
--[[AUTO]]  ,"rm_balcony"
--[[AUTO]]  ,"mg_onbalcony"
--[[AUTO]]  ,"mg_onroadwaymg"
--[[AUTO]]  ,"rm_cellar"
--[[AUTO]]  ,"ho_winestore"
--[[AUTO]]  ,"rm_backyard"
--[[AUTO]]  ,"ho_chimera"
--[[AUTO]]  ,"rm_seafront"
--[[AUTO]]  ,"rm_terrace"
--[[AUTO]]  ,"ho_marine"
--[[AUTO]]  ,"rm_pub"
--[[AUTO]]  ,"mg_dolls"
--[[AUTO]]  ,"mg_forks"
--[[AUTO]]  ,"mg_prison"
--[[AUTO]]  ,"ho_deal"
--[[AUTO]]  ,"rm_grove"
--[[AUTO]]  ,"rm_cave"
--[[AUTO]]  ,"rm_hut"
--[[AUTO]]  ,"ho_utilityroomho"
--[[AUTO]]  ,"rm_bytheriver"
--[[AUTO]]  ,"rm_residence"
--[[AUTO]]  ,"ho_pantryho"
--[[AUTO]]  ,"rm_secondfloor"
--[[AUTO]]  ,"mg_incabinetmg"
--[[AUTO]]  ,"mg_hutdoor"
--[[AUTO]]  ,"mg_toriver"
  };

  game.progress_names =
  {
    "opn_square"


--[[AUTO]]  ,"opn_injail"
--[[AUTO]]  ,"win_injail"
            ,"clk_addressopn"
            ,"win_address"
            ,"get_fulladress"
--[[AUTO]]  ,"clk_anmfly"
--[[AUTO]]  ,"get_carvedhandle"
--[[AUTO]]  --,"get_goldhorseshoe1"
--[[AUTO]]  ,"use_carvedhandle"
--[[AUTO]]  ,"get_necklace"
--[[AUTO]] -- ,"get_camomile1"
--[[AUTO]]  ,"get_goldhorseshoe2"
--[[AUTO]]  --,"use_goldhorseshoe1"
--[[AUTO]]  ,"use_goldhorseshoe2"
--[[AUTO]]  ,"get_beetle"
--[[AUTO]]  ,"use_beetle"
--[[AUTO]]  ,"win_clamp"
--[[AUTO]]  ,"get_torch"
--[[AUTO]]  ,"use_torch"
--[[AUTO]]  ,"use_fulladress"
--[[AUTO]]  ,"opn_nearhouse"
--[[AUTO]]  ,"clk_nearmonument"
--[[AUTO]]  ,"get_leathergloves"
            ,"get_medicinebook"
--[[AUTO]]--  ,"get_camomile2"
--[[AUTO]]  ,"use_leathergloves"
--[[AUTO]]  ,"get_button"
--[[AUTO]]  ,"use_button"
--[[AUTO]]  ,"win_behindglass"
--[[AUTO]]  ,"get_package"
--[[AUTO]]  ,"get_tubule"
--[[AUTO]]  ,"use_tubule"
--[[AUTO]]  ,"get_emblem"
--[[AUTO]]  ,"get_camomile1"
--[[AUTO]] -- ,"get_necklace"
--[[AUTO]]  ,"use_emblem"
--[[AUTO]]  ,"get_camomile3"
--[[AUTO]]  ,"get_checker"
--[[AUTO]]  ,"use_checker"
--[[AUTO]]  ,"get_bird"
--[[AUTO]]  ,"use_bird"
--[[AUTO]]  ,"get_acid"
--[[AUTO]]  ,"use_acid"
--[[AUTO]]  ,"get_star"
--[[AUTO]]  ,"use_star"
--[[AUTO]]  ,"get_camomile4"
--[[AUTO]]  ,"get_scissors"
--[[AUTO]]  ,"use_scissors"
--[[AUTO]]  ,"get_paw1"
--[[AUTO]]  ,"use_scissors2"
--[[AUTO]]  ,"get_bee"
--[[AUTO]]  ,"use_bee"
--[[AUTO]]  ,"win_bees"
--[[AUTO]]  ,"opn_tree"
--[[AUTO]]  ,"win_tree"
--[[AUTO]]  ,"clk_onpaper"
--[[AUTO]]  ,"use_keyhouse"
--[[AUTO]]  ,"clk_onkeyhouse"
--[[AUTO]]  ,"opn_housedoctor"
--[[AUTO]]  ,"get_paten"
--[[AUTO]]  ,"get_redberry"
--[[AUTO]]  ,"use_paten"
--[[AUTO]]  ,"get_sickle"
--[[AUTO]]  ,"use_sickle"
--[[AUTO]]  ,"get_horn"
            ,"get_branches"
--[[AUTO]]  ,"use_horn"
--[[AUTO]]  ,"get_blackkey"
--[[AUTO]]  ,"use_blackkey"
--[[AUTO]]  ,"get_book"
--[[AUTO]]  ,"get_yellowberry"
            ,"get_camomile2"
--[[AUTO]]--  ,"get_medicinebook"
--[[AUTO]]  ,"use_book"
--[[AUTO]]  ,"win_books"
--[[AUTO]]  ,"get_medal"
--[[AUTO]]  ,"use_medal"
--[[AUTO]]  ,"get_brush"
--[[AUTO]]  ,"use_brush"
--[[AUTO]]  ,"get_bridle"
--[[AUTO]]  ,"get_mainland1"
--[[AUTO]]  ,"use_bridle"
--[[AUTO]]  ,"get_coin"
--[[AUTO]]  ,"get_camomile5"
--[[AUTO]]  ,"use_coin"
--[[AUTO]]  ,"get_paw2"
--[[AUTO]]  ,"use_paw1"
--[[AUTO]]  ,"use_paw2"
--[[AUTO]]  ,"get_camomile6"
--[[AUTO]]  ,"get_greenberry"
--[[AUTO]]  ,"use_redberry"
--[[AUTO]]  ,"use_yellowberry"
--[[AUTO]]  ,"use_greenberry"
--[[AUTO]]  ,"get_laboratorykey"
--[[AUTO]]  ,"use_laboratorykey"
--[[AUTO]]  ,"clk_onlaboratorykey"
--[[AUTO]]  ,"opn_laboratory"
            ,"clk_animshadows"
--[[AUTO]]  ,"get_camomile7"
--[[AUTO]]  ,"use_camomile"
--[[AUTO]]  ,"clk_bookopn"
--[[AUTO]]  ,"clk_orderstory"
--[[AUTO]]  ,"get_partpattern"
--[[AUTO]]  ,"get_clover"
--[[AUTO]]  ,"use_partpattern"
--[[AUTO]]  ,"win_onroadwaymg"
            ,"win_onroadwaymg_nearhouse"
--[[AUTO]]  ,"opn_roadway"
            ,"clk_doorpalace"
--[[AUTO]]  ,"get_tongs"
--[[AUTO]]  ,"get_bantik"
--[[AUTO]]  ,"use_tongs"
--[[AUTO]]  ,"get_eye"
--[[AUTO]]  ,"use_eye"
--[[AUTO]]  ,"get_handledragon"
--[[AUTO]]  ,"use_handledragon"
--[[AUTO]]  ,"get_ruler"
--[[AUTO]]  ,"use_ruler"
--[[AUTO]]  ,"get_fish"
--[[AUTO]]  ,"use_fish"
--[[AUTO]]  ,"get_tweezers"
--[[AUTO]]  ,"get_container"
--[[AUTO]]  ,"get_medecinechest"
--[[AUTO]]  ,"use_tweezers"
--[[AUTO]]  ,"get_petal"
--[[AUTO]]  ,"use_petal"
--[[AUTO]]  ,"get_ruby1"
--[[AUTO]]  ,"get_gaff"
--[[AUTO]]  ,"use_gaff"
--[[AUTO]]  ,"get_bag"
--[[AUTO]]  ,"clk_bagopn1"
            ,"clk_bagopn2"
--[[AUTO]]  ,"get_latch"
--[[AUTO]]  ,"get_cork"
--[[AUTO]]  ,"get_powder1"
--[[AUTO]]  ,"get_littlechest"
--[[AUTO]]  ,"use_cork"
--[[AUTO]]  ,"win_corks"
--[[AUTO]]  ,"get_amuletinfinity"
--[[AUTO]]  ,"use_amuletinfinity"
--[[AUTO]]  ,"get_maple"
--[[AUTO]]  ,"use_maple"
--[[AUTO]]  ,"get_redbutton1"
--[[AUTO]]  ,"get_powder2"
--[[AUTO]]  ,"use_powder1"
--[[AUTO]]  ,"use_powder2"
--[[AUTO]]  ,"clk_shake"
--[[AUTO]]  ,"get_soporific"
--[[AUTO]]  ,"use_soporific"
--[[AUTO]]--  ,"clk_doorpalace"
--[[AUTO]]  ,"opn_livingroom"
--[[AUTO]]  ,"dlg_livingroom_lady1"
--[[AUTO]]  ,"get_code"
--[[AUTO]]  ,"get_redbutton2"
--[[AUTO]]  ,"use_code"
            ,"win_code"
--[[AUTO]]  ,"get_crystal"
--[[AUTO]]  ,"get_plate1"
--[[AUTO]]  ,"use_crystal"
--[[AUTO]]  ,"get_redbutton3"
--[[AUTO]]  ,"get_amuletsnake"
--[[AUTO]]  ,"use_amuletsnake"
--[[AUTO]]  ,"get_bearseye1"
--[[AUTO]]  ,"use_redbutton"
--[[AUTO]]  ,"clk_onredbutton1"
            ,"clk_onredbutton2"
            ,"clk_onredbutton3"
--[[AUTO]]  ,"get_handlepart"
--[[AUTO]]  ,"get_brooch"
--[[AUTO]]  ,"get_tornbear"
--[[AUTO]]  ,"use_brooch"
--[[AUTO]]  ,"win_lodge"
--[[AUTO]]  ,"opn_toys"
--[[AUTO]]  ,"win_toys"
--[[AUTO]]  ,"clk_brokenhadle"
--[[AUTO]]  ,"use_handlepart"
--[[AUTO]]  ,"get_needlecotton"
--[[AUTO]]  ,"get_mainland2"
--[[AUTO]]  ,"use_mainland1"
--[[AUTO]]  ,"use_mainland2"
--[[AUTO]]  ,"get_bearseye2"
--[[AUTO]]  ,"use_needlecotton"
--[[AUTO]]  ,"use_bantik"
--[[AUTO]]  ,"use_bearseye1"
--[[AUTO]]  ,"use_bearseye2"
--[[AUTO]]  ,"get_teddybear"
--[[AUTO]]  ,"use_teddybear"
--[[AUTO]]  ,"dlg_livingroom_lady2"
--[[AUTO]]  ,"opn_bedroomboy"
--[[AUTO]]  --,"clk_receptionmed"
--[[AUTO]]  ,"get_dove1"
--[[AUTO]]  ,"get_duck"
--[[AUTO]]  ,"use_duck"
--[[AUTO]]  ,"get_samvignette"
--[[AUTO]]  ,"use_samvignette"
--[[AUTO]]  ,"win_lock"
--[[AUTO]]  ,"clk_epidemystory"
--[[AUTO]]  ,"get_wings"
--[[AUTO]]  ,"use_wings"
--[[AUTO]]  ,"get_dove2"
--[[AUTO]]  ,"use_dove1"
--[[AUTO]]  ,"use_dove2"
--[[AUTO]]  ,"get_sammedallion"
--[[AUTO]]  ,"clk_sammedallionopn"
--[[AUTO]]  ,"clk_picture"
--[[AUTO]]  ,"clk_picturebackward"
--[[AUTO]]  ,"get_amuletbunny"
--[[AUTO]]  ,"use_amuletbunny"
--[[AUTO]]  ,"get_ruby2"
--[[AUTO]]  ,"use_ruby1"
--[[AUTO]]  ,"use_ruby2"
--[[AUTO]]  ,"use_latch"

--[[AUTO]]  ,"clk_latchclk"
--[[AUTO]]  ,"get_plate2"
--[[AUTO]]  ,"use_plate1"
--[[AUTO]]  ,"use_plate2"
--[[AUTO]]  ,"win_onbalcony"
--[[AUTO]]  ,"opn_balcony"
--[[AUTO]]  ,"clk_outro1"


--[[AUTO]]  ,"dlg_balcony_lord1"
--[[AUTO]]  ,"clk_eliminating"
            ,"clk_portrait"
--[[AUTO]]  ,"get_portrait"
--[[AUTO]]  ,"get_fork1"
--[[AUTO]]  ,"get_royallily"
--[[AUTO]]  ,"use_necklace"
--[[AUTO]]  ,"get_fang"
--[[AUTO]]  ,"get_fork2"
--[[AUTO]]  ,"use_royallily"
--[[AUTO]]  --,"win_flowers"
--[[AUTO]]  ,"get_wire"
--[[AUTO]]  ,"use_fang"
--[[AUTO]]  ,"get_raggedshawl"
--[[AUTO]]  ,"clk_incellaranm"
--[[AUTO]]  ,"use_raggedshawl"
--[[AUTO]]  ,"get_gryphoneye"
--[[AUTO]]  ,"use_gryphoneye"
--[[AUTO]]  ,"get_lever"
--[[AUTO]]  ,"use_lever"
--[[AUTO]]  ,"get_fork3"
--[[AUTO]]  ,"use_fork"
--[[AUTO]]  ,"win_forks"
--[[AUTO]]  ,"opn_cellar"
--[[AUTO]]  ,"clk_animshadows2"
            ,"clk_slipofpaper_open"
            ,"clk_slipofpaper_close"
--[[AUTO]]  ,"get_slipofpaper"
--[[AUTO]]  ,"use_wire"
--[[AUTO]]  ,"get_grape1"
--[[AUTO]]  ,"get_letterl"
--[[AUTO]]  ,"use_clover"
--[[AUTO]]  ,"get_tonguebell"
--[[AUTO]]  ,"use_tonguebell"
--[[AUTO]]  ,"clk_callbell"
--[[AUTO]]  ,"get_bat"
--[[AUTO]]  ,"use_bat"
--[[AUTO]]  ,"get_spatula"
--[[AUTO]]  ,"get_axe"
--[[AUTO]]  ,"get_penknife"
--[[AUTO]]  ,"use_spatula"
--[[AUTO]]  ,"get_corkscrew"
--[[AUTO]]  ,"get_owl"
--[[AUTO]]  ,"use_corkscrew_warehouse"

--[[AUTO]]  ,"opn_winestore"
--[[AUTO]]  ,"win_winestore"
--[[AUTO]]  ,"use_slipofpaper"
--[[AUTO]]  ,"use_corkscrew_glassdoor"
--[[AUTO]]  ,"clk_reslipofpaper"
--[[AUTO]]  ,"clk_keyonkeyhole"
--[[AUTO]]  ,"opn_backyard"
--[[AUTO]]  ,"get_closebottle"
--[[AUTO]]  ,"use_owl"
--[[AUTO]]  ,"get_lettere"
--[[AUTO]]  ,"get_tuftpeacock"
--[[AUTO]]  ,"get_brokenknife"
--[[AUTO]]  ,"use_tuftpeacock"
            ,"clk_doorstorage"
--[[AUTO]]  ,"get_buttonstorage"
--[[AUTO]]  ,"use_buttonstorage"
--[[AUTO]]  ,"get_feather1"
--[[AUTO]]  ,"get_basket"
--[[AUTO]]  ,"get_lettern"
--[[AUTO]]  ,"clk_coachstars"
--[[AUTO]]  ,"win_coachdoor"
            ,"clk_coachdress1"
            ,"clk_coachdress2"
--[[AUTO]]  ,"get_opener"
--[[AUTO]]  ,"use_opener"
--[[AUTO]]  ,"get_oil"
--[[AUTO]]  ,"use_oil"
--[[AUTO]]  ,"use_penknife"
--[[AUTO]]  ,"get_knife"
--[[AUTO]]  ,"use_knife"
--[[AUTO]]  ,"get_milk"
--[[AUTO]]  ,"use_milk"
            ,"clk_collar"
--[[AUTO]]  ,"get_collar"
--[[AUTO]]  ,"get_grape2"
--[[AUTO]]  ,"use_grape1"
--[[AUTO]]  ,"use_grape2"
--[[AUTO]]  ,"get_feather2"
--[[AUTO]]  ,"get_sunflower"
--[[AUTO]]  ,"use_sunflower"
--[[AUTO]]  ,"get_letterr"
--[[AUTO]]  ,"use_feather1"
--[[AUTO]]  ,"use_feather2"
--[[AUTO]]  ,"get_emblemcat"
--[[AUTO]]  ,"use_emblemcat"
--[[AUTO]]  ,"get_lettera"
--[[AUTO]]  ,"get_wrench"
--[[AUTO]]  ,"use_letterl"
--[[AUTO]]  ,"use_lettern"
--[[AUTO]]  ,"use_lettere"
--[[AUTO]]  ,"use_letterr"
--[[AUTO]]  ,"use_lettera"
--[[AUTO]]  ,"clk_storyplan"
--[[AUTO]]  ,"get_puzzlepiece"
--[[AUTO]]  ,"use_puzzlepiece"
--[[AUTO]]  ,"win_prison"
--[[AUTO]]  ,"use_portrait"
--[[AUTO]]  ,"dlg_cellar_lekar1"
--[[AUTO]]  ,"get_notelekar"
--[[AUTO]]  ,"use_notelekar_nursery"
--[[AUTO]]  ,"win_nurserydoor"
--[[AUTO]]  ,"opn_chimera"
--[[AUTO]]  ,"win_chimera"
            ,"clk_susiediaryopen"
            ,"clk_storysusiediary"
            ,"get_traderaddress"
--[[AUTO]]  ,"use_traderaddress"
--[[AUTO]]  ,"opn_seafront"
--[[AUTO]]  ,"use_axe_pier"
--[[AUTO]]  ,"get_board1"
--[[AUTO]]  ,"get_dolly1"
--[[AUTO]]  ,"use_axe_handrail"
--[[AUTO]]  ,"get_board2"
--[[AUTO]] -- ,"use_wrench"
--[[AUTO]] -- ,"get_ironarc"
--[[AUTO]]  ,"get_tile"
--[[AUTO]]  ,"use_wrench"
--[[AUTO]]  ,"get_dolly2"
--[[AUTO]]  ,"use_tile"
--[[AUTO]]  ,"win_hidingplace"
--[[AUTO]]  ,"get_board3"
--[[AUTO]]  ,"get_starfish"
--[[AUTO]]  ,"use_starfish"
--[[AUTO]]  ,"get_rope"
--[[AUTO]]  ,"get_hacksaw"
--[[AUTO]]  ,"use_board"
--[[AUTO]]  ,"use_rope"
--[[AUTO]]  ,"opn_terrace"
--[[AUTO]]  ,"clk_animshadows3"
--[[AUTO]]  ,"get_dollhat"
--[[AUTO]]  ,"use_hacksaw"
--[[AUTO]]  ,"get_padlock1"
--[[AUTO]]  ,"use_dollhat"
--[[AUTO]]  ,"get_valve"
--[[AUTO]]  ,"use_valve"
--[[AUTO]]  --,"clk_turnvalve"
--[[AUTO]]  ,"get_glass"
--[[AUTO]]  ,"use_glass"

--[[AUTO]]  ,"get_grains"
--[[AUTO]]  ,"use_grains"
--[[AUTO]]  ,"get_schilling1"
--[[AUTO]]  ,"get_padlock2"
--[[AUTO]]  ,"use_padlock1"
--[[AUTO]]  ,"use_padlock2"
--[[AUTO]]  ,"win_locks"
--[[AUTO]]  ,"get_tube"
--[[AUTO]]  ,"use_tube"
--[[AUTO]]  ,"get_shirt"
--[[AUTO]]  ,"clk_opnshirt"
--[[AUTO]]  ,"clk_opnshirt2"
--[[AUTO]]  ,"get_schilling2"
--[[AUTO]]  ,"get_bracelet"
--[[AUTO]]  ,"use_bracelet"
--[[AUTO]]  ,"get_fishingrod"
--[[AUTO]]  ,"use_fishingrod"
--[[AUTO]]  ,"opn_marine"
--[[AUTO]]  ,"win_marine"

--[[AUTO]]  ,"use_schilling"
            ,"clk_openpubdoor"
--[[AUTO]]  ,"opn_pub"
--[[AUTO]]  ,"dlg_pub_trader1"
--[[AUTO]]  ,"get_dolly3"
--[[AUTO]]  ,"use_collar"
--[[AUTO]]  ,"get_ovalhandle"
--[[AUTO]]  ,"get_roosterpart"
--[[AUTO]]  ,"use_ovalhandle"
--[[AUTO]]  ,"get_hook"
--[[AUTO]]  ,"use_roosterpart"
--[[AUTO]]  ,"get_rooster"
--[[AUTO]]  ,"use_rooster"
--[[AUTO]] -- ,"clk_cleancounter"
--[[AUTO]]  ,"get_vanepart"
--[[AUTO]]  ,"use_vanepart"
--[[AUTO]]  ,"get_spoke"
--[[AUTO]]  ,"use_spoke"
--[[AUTO]]  ,"get_archandle"
--[[AUTO]]  ,"use_archandle"
--[[AUTO]]  ,"get_apple"
--[[AUTO]]  ,"use_apple"
--[[AUTO]]  ,"get_dolly4"
--[[AUTO]]  ,"use_dolly"
--[[AUTO]]  ,"win_dolls"
--[[AUTO]]  ,"get_barkey"
--[[AUTO]]  ,"use_barkey"
--[[AUTO]]  ,"get_whiskey"
--[[AUTO]]  ,"use_whiskey"
            ,"dlg_pub_trader2"
--[[AUTO]]  ,"get_notetrader"
            ,"clk_notetrader"
--[[AUTO]]  ,"use_notelekar_notetrader"
--[[AUTO]]  ,"clk_storytrader"
--[[AUTO]]  ,"get_notebook"
--[[AUTO]]  ,"use_notebook"
--[[AUTO]]  ,"dlg_bedroomboy_lady3"
--[[AUTO]]  ,"clk_outro2"
--[[AUTO]]  ,"dlg_square_lady4"
--[[AUTO]]  ,"get_lordkey"
--[[AUTO]]  ,"use_lordkey"
            ,"clk_cabinetlordopn"
--[[AUTO]]  ,"opn_deal"
--[[AUTO]]  ,"win_deal"
            ,"win_deal_task"
--[[AUTO]]  ,"get_oakleaf"
--[[AUTO]]  ,"use_oakleaf"
--[[AUTO]]  ,"opn_grove"
--[[AUTO]]  ,"clk_animbeast"
--[[AUTO]]  ,"use_hook"
--[[AUTO]]  ,"get_fringe"
--[[AUTO]]  ,"use_fringe"
--[[AUTO]]  ,"get_feathermg1"
--[[AUTO]]  ,"get_eyepupil"
--[[AUTO]]  ,"use_eyepupil"
--[[AUTO]] -- ,"clk_eyetotem"
--[[AUTO]]  ,"get_hairpin"
--[[AUTO]]  ,"use_hairpin"
--[[AUTO]]  ,"get_beak"
--[[AUTO]]  ,"use_beak"
--[[AUTO]]  ,"win_totemgame"
--[[AUTO]]  ,"get_flint"
--[[AUTO]]  ,"use_flint"
--[[AUTO]]  ,"opn_cave"
--[[AUTO]]  ,"get_wingemblem"
--[[AUTO]]  ,"use_wingemblem"
--[[AUTO]]  ,"get_piecebas"
--[[AUTO]]  ,"get_leatherbag"
--[[AUTO]]  ,"use_piecebas"
--[[AUTO]]  ,"get_chisel"
--[[AUTO]]  ,"use_chisel"
--[[AUTO]]  ,"get_feathermg2"
--[[AUTO]]  ,"get_partchimeras"
--[[AUTO]]  ,"use_partchimeras"
--[[AUTO]]  ,"win_threeheads"
--[[AUTO]]  ,"get_shamrock"
--[[AUTO]]  ,"use_shamrock"
            ,"clk_emptyflask"
--[[AUTO]]  ,"get_emptyflask"
--[[AUTO]]  ,"get_yellowring"
--[[AUTO]]  ,"use_emptyflask"
--[[AUTO]]  ,"get_waterflask"
--[[AUTO]]  ,"use_waterflask_cave"
--[[AUTO]]  ,"dlg_cave_lekar2"
--[[AUTO]]  ,"get_feathermg3"
--[[AUTO]]  ,"use_feathermg"
--[[AUTO]]  ,"win_hutdoor"
--[[AUTO]]  ,"opn_hut"
--[[AUTO]]  ,"clk_turnherbs"
--[[AUTO]]  ,"get_nailpuller"


--[[AUTO]]  ,"use_nailpuller"
            ,"clk_nailboard"
--[[AUTO]]  ,"get_hammer"            
--[[AUTO]]  ,"get_goldcrow1"
--[[AUTO]]  ,"get_goldcrow2"
--[[AUTO]]  ,"use_yellowring"
--[[AUTO]]  ,"get_wedge"
--[[AUTO]]  ,"use_wedge"
--[[AUTO]]  ,"use_hammer"
--[[AUTO]]  ,"get_amuletlion"
--[[AUTO]]  ,"use_amuletlion"
--[[AUTO]]  ,"get_ironhandle"
--[[AUTO]]  ,"clk_breakhandle"
--[[AUTO]]  ,"use_ironhandle"
--[[AUTO]]  ,"opn_utilityroomho"
--[[AUTO]]  ,"win_utilityroomho"
--[[AUTO]]  ,"use_quatrefoil"
--[[AUTO]]  ,"get_clip"
--[[AUTO]]  ,"use_clip_scarecrow"
--[[AUTO]]  ,"get_medallionedward"
--[[AUTO]]  ,"use_clip_medallionedward"
--[[AUTO]]  ,"clk_fotosusie"
            ,"clk_fotosusie2"
--[[AUTO]]  ,"get_diamondcube"
--[[AUTO]]  ,"use_diamondcube"
--[[AUTO]]  ,"win_diamonds"
--[[AUTO]]  ,"clk_storycavebefore"
--[[AUTO]]  ,"get_plummet"
            ,"clk_storycave"
--[[AUTO]]  ,"use_plummet"
--[[AUTO]]  ,"get_poisonspice"
--[[AUTO]]  ,"use_poisonspice"
--[[AUTO]]  ,"dlg_roadway_warder3"
--[[AUTO]]  ,"get_mappaper"
--[[AUTO]]  ,"use_mappaper"
--[[AUTO]]  ,"win_toriver"
--[[AUTO]]  ,"opn_bytheriver"
--[[AUTO]]  ,"get_flag"
--[[AUTO]]  ,"use_flag"
--[[AUTO]]  ,"get_dancinggirl"
--[[AUTO]]  ,"get_goldcrow3"
--[[AUTO]]  ,"use_dancinggirl"
--[[AUTO]]  ,"get_stonebracelet"
--[[AUTO]]  ,"use_stonebracelet"
--[[AUTO]]  ,"get_sail"
--[[AUTO]]  ,"use_sail"
--[[AUTO]]  ,"get_cinquefoil"
--[[AUTO]]  ,"get_cathead"
--[[AUTO]]  ,"use_cinquefoil"
--[[AUTO]]  ,"get_inhibitor"
--[[AUTO]]  ,"use_inhibitor"
--[[AUTO]]  ,"dlg_cave_lekar3"
--[[AUTO]]  ,"get_recipemedicine"
--[[AUTO]]  ,"get_twoswords"
--[[AUTO]]  ,"use_twoswords"
--[[AUTO]]  ,"get_goldcrow4"
--[[AUTO]]  ,"get_residencekey"
--[[AUTO]]  ,"use_residencekey"
--[[AUTO]]  ,"opn_residence"
--[[AUTO]]  ,"get_pouch"
--[[AUTO]]  ,"use_cathead"
--[[AUTO]]  ,"get_bladehandle"
--[[AUTO]]  ,"use_bladehandle"
--[[AUTO]]  ,"get_blade"
--[[AUTO]]  ,"use_blade"
--[[AUTO]]  ,"get_pliers"
--[[AUTO]]  ,"get_blackheart1"
--[[AUTO]]  ,"get_vial"
--[[AUTO]]  ,"use_pliers"
            ,"clk_furnacedoor"
--[[AUTO]]  ,"get_blackheart2"
--[[AUTO]]  ,"get_greenbutton"
--[[AUTO]]  ,"use_greenbutton"
--[[AUTO]]  ,"get_goldcrow5"
--[[AUTO]]  ,"use_goldcrow"
--[[AUTO]]  ,"clk_storypoison"
--[[AUTO]]  ,"get_poisonformula"

--[[AUTO]]  ,"use_poisonformula"
--[[AUTO]]  ,"dlg_bedroomboy_lady5"
--[[AUTO]]  ,"get_glassrose"
--[[AUTO]]  ,"use_glassrose"
--[[AUTO]]  ,"get_blackheart3"
--[[AUTO]]  ,"use_blackheart"
--[[AUTO]]  ,"win_pantrydoor"
--[[AUTO]]  ,"opn_pantryho"
--[[AUTO]]  ,"win_pantryho"
--[[AUTO]]  ,"use_fireiron"
--[[AUTO]]  ,"use_waterflask_furnace"
--[[AUTO]]  ,"get_screwdriver"
--[[AUTO]]  ,"get_ingredientq"
--[[AUTO]]  ,"use_screwdriver"
--[[AUTO]]  ,"get_numeral"
--[[AUTO]]  ,"use_numeral"
--[[AUTO]]  ,"win_codelock"
--[[AUTO]]  ,"opn_secondfloor"
            ,"clk_winderwallcabinet"
--[[AUTO]]  ,"get_winder"
--[[AUTO]]  ,"use_winder"
            ,"clk_winder"
--[[AUTO]]  ,"get_cuckoo"
--[[AUTO]]  ,"clk_parsecuckoo"
--[[AUTO]]  ,"get_mechanismpart1"
--[[AUTO]]  ,"clk_parsecuckoo2"
--[[AUTO]]  ,"get_pawcuckoo"
--[[AUTO]]  ,"use_pawcuckoo"
--[[AUTO]]  ,"get_spanner"
--[[AUTO]]  ,"get_ingredientr"
--[[AUTO]]  ,"use_spanner"
--[[AUTO]]  ,"get_saplingshovel"
--[[AUTO]]  ,"use_saplingshovel"
--[[AUTO]]  ,"get_shovel"
--[[AUTO]]  ,"use_shovel"
--[[AUTO]]  ,"get_secateurs"
--[[AUTO]]  ,"get_ingredients"
--[[AUTO]]  ,"use_secateurs"
--[[AUTO]]  ,"get_moon"
--[[AUTO]]  ,"use_moon"
          --  ,"clk_suitcase1"
            ,"clk_suitcase2"
            ,"clk_suitcase3"
--[[AUTO]]  ,"get_mechanismpart2"
--[[AUTO]]  ,"use_mechanismpart1"
--[[AUTO]]  ,"use_mechanismpart2"
--[[AUTO]]  ,"win_incabinetmg"
--[[AUTO]]  ,"get_ingredientt"
--[[AUTO]]  ,"use_recipemedicine"
--[[AUTO]]  ,"use_ingredientq"
--[[AUTO]]  ,"use_ingredients"
--[[AUTO]]  ,"use_ingredientr"
--[[AUTO]]  ,"use_ingredientt"
--[[AUTO]]  ,"get_medicine"
--[[AUTO]]  ,"use_medicine"
--[[AUTO]]  ,"dlg_bedroomboy_lady6"
--[[AUTO]]  ,"clk_outro3"
  };


  game.relations = {};

 --{ prg_true; prg_false; };
game.level_tasks = {

----------LVL--1----------
--[[01]]  "opn_injail";
--[[02]]  "clk_anmfly";
--[[03]]  "clk_nearmonument";
--[[04]]  "clk_orderstory";
--[[05]]  "clk_doorpalace";
--[[06]]  "dlg_livingroom_lady1";
--[[07]]  "dlg_livingroom_lady2";
----------LVL--2----------
--[[08]]  "dlg_balcony_lord1";
--[[09]]  "get_notelekar";
--[[10]]  "get_traderaddress";
--[[11]]  "dlg_pub_trader1";
--[[12]]  "get_notebook";
--[[13]]  "dlg_bedroomboy_lady3";
----------LVL--3----------
--[[14]]  "clk_outro2";
--[[15]]  "dlg_square_lady4";
--[[16]]  "win_deal_task";
--[[17]]  "opn_grove";
--[[18]]  "opn_cave";
--[[19]]  "dlg_cave_lekar2";
--[[20]]  "get_poisonspice";
--[[21]]  "dlg_roadway_warder3";

--[[22]]  "dlg_cave_lekar3";
--[[23]]  "get_medicine";


};

end;

function Test ()

  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------tutorial----------------------------------------------

function private.TutorInit()

----------------------progress for tutorial
  game.tutorial_progress =
  {
    ["tutorial_question"]     = { unchecked = true, lock = 1, pos_x = 500, pos_y = 180 }

    ,["tutorial_newho1"]      = { special = false, pos_x = 512, pos_y = 350, tut_arrows= {{pos_x = 0, pos_y = 250, ang = 3.14}} }
    ,["tutorial_hint"]        = { gamemode_custom = "hint", pos_x = 410, pos_y = 430, tut_arrows= {{pos_x =  -260, pos_y =  170, ang =  2.32}} }

    -->>карты пока нет туториал не вызывается
    ,["tutorial_map1"]        = { pos_x = 700, pos_y = 350, tut_arrows= {{pos_x = 210, pos_y =  250, ang =  -2.36}} }
    ,["tutorial_map2"]        = { pos_x = 600, pos_y = 200 }
    --<<

    ,["tutorial_zz"]          = { pos_x = 594, pos_y = 177, tut_arrows= {{pos_x = 161, pos_y =   209, ang =  4.56}} }    
    ,["tutorial_get"]         = { pos_x = 512, pos_y = 100, tut_arrows= {{pos_x =  0, pos_y = 230, ang = 3.14}} }
    ,["tutorial_use"]         = { pos_x = 512, pos_y = 130, tut_arrows= {{pos_x = -290, pos_y =  500, ang =  3.14},{pos_x = 0, pos_y =  250, ang =  3.14}} }
    ,["tutorial_mg"]          = { gamemode_custom = "skip", gamemodeoff = 2, pos_x = 531, pos_y = 380, tut_arrows= {{pos_x =  290, pos_y =   40, ang =  4.71}, {pos_x =  -359, pos_y =   230, ang =  2.12}} }
    ,["tutorial_deploy"]      = { gamemode_custom = "plus_inv", special = true, pos_x = 480, pos_y = 430, tut_arrows= {{pos_x = -250, pos_y =  200, ang =  3.14}} }
    ,["tutorial_hosparkles"]  = { gamemode_custom = "sparkle_area", gamemodeoff = 2, pos_x = 640, pos_y = 169, tut_arrows= {{pos_x = 50, pos_y =  230, ang =  4.44}} }

    ,["tutorial_clk"]         = { pos_x = 450, pos_y = 100, tut_arrows= {{pos_x =  0, pos_y = 219, ang = -1.57}} }

    ,["tutorial_ach"]         = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
    ,["tutorial_puzzle"]      = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
    ,["tutorial_morph"]       = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
    ,["tutorial_card"]       = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }

-----------------------Не используются но могут понадобиться

--    ,["tutorial_task"]        = { pos_x = 467, pos_y = 381, tut_arrows= {{pos_x =  -120, pos_y =  200, ang =  -3}} }
--    ,["tutorial_navigation"]  = { gamemode_custom = "cursor", pos_x = 680, pos_y = 140, tut_arrows= {{pos_x = 168, pos_y =  190, ang =  4.54}} }

  };
  
  for i,o in pairs(game.tutorial_progress) do

    table.insert(   game.progress_names, i );

    level[ i ] = {}
  end;
  level.tutorial_current = "";
----------------------------------------------------------------------------------------
  function private.TutorialShow(name, offset) -- set current and Show
    if game.tutorial_progress[name].unchecked or ( private.TutorialGameModeCheck( name ) ) then
      level.tutorial_current = name;
      local tut_params = game.tutorial_progress[name];
      if offset then
        for i = 1,#offset-1 do
          tut_params.tut_arrows[i].pos_x = tut_params.tut_arrows[i].pos_x + offset[i+1];
        end
        tut_params.pos_x = tut_params.pos_x + offset[1]
      end
      if tut_params.gamemodeoff then
        if ng_global.gamemode == tut_params.gamemodeoff then
          cmn.SetEventDone( name );
          return false
        end
      end
      if tut_params.gamemode_custom then
        if ng_global.gamemode == 3 and not ng_global.gamemode_custom[ tut_params.gamemode_custom ] then
          cmn.SetEventDone( name );
          return false
        end
      end
      interface.TutorialShow( "str_"..name, tut_params.lock, tut_params.pos_x, tut_params.pos_y, tut_params.tut_arrows );
      return true
    else
      cmn.SetEventDone( name );
      return false
    end
  end

  function private.TutorialHide() -- set current nil and Hide
    cmn.SetEventDone( level.tutorial_current );
    level.tutorial_current = nil
    interface.TutorialHide();
  end

  function public.TutorialDisable() -- skip tutor all
    level.tutorial_current = nil
    if private.panel_notification_on_screen then
      ObjSet( "tmr_int_panel_notification", {playing = 1} );
    end
    for i,o in pairs(game.tutorial_progress) do

      cmn.SetEventDone( i );

    end;

  end;

  function public.TutorialSpecialDisable() --  вырубает только стандартные
    cmn.SetEventDone( level.tutorial_current );
    if private.panel_notification_on_screen then
      ObjSet( "tmr_int_panel_notification", {playing = 1} );
    end
    level.tutorial_current = nil
    for i,o in pairs(game.tutorial_progress) do

      if not o.special then
        cmn.SetEventDone( i );
      end

    end;
    level.tutorial_sp_skiped = true
  end;

  function private.TutorialGameModeCheck(tutorial_name)  -- проверка на кастом режим и выключен ли туториал
    if ng_global.gamemode == 3 and not ng_global.gamemode_custom["tutorial"] then
      cmn.SetEventDone(tutorial_name)
    end
    if not cmn.IsEventDone(tutorial_name) and cmn.IsEventDone( "tutorial_question" ) then
      return true
    else
      return false
    end
  end
----------------------------------------------------------------------------------------
  function public.tutorial_question.first()

    if ( ng_global.gamemode == 0 ) or (ng_global.gamemode == 3) then

      if ng_global.gamemode == 3 and not ng_global.gamemode_custom["tutorial"] then  --
        for i,o in pairs(game.tutorial_progress) do
          cmn.SetEventDone( i );
        end;
      end
      if  ( cmn.IsEventDone( "opn_injail" ) )
      and ( not cmn.IsEventDone( "tutorial_question" ) )
      then
        private.TutorialShow("tutorial_question");
      end;

    else
      level.TutorialDisable();
    end;

  end;

  function public.tutorial_question.click() -- событие по клику на да
    private.TutorialHide()
    --ld.LockRm(1)
    --ld.StartTimer( 0.3, function() ld.LockRm(0);level.tutorial_newho1.first() end )
      level.tutorial_newho1.first()
  end
  function public.tutorial_question.click_no() --не обязательно
    --some code
    interface.TutorialHide();
    level.TutorialDisable();

  end
--------------------------------------------------------------------------------------------
  function public.tutorial_zz.first()
    if  ( cmn.IsEventDone( "clk_anmfly" ) ) and ld.CheckRequirements( {"tutorial_deploy"} ) then 
        private.TutorialShow("tutorial_zz");
      end
  end

  function public.tutorial_zz.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_clk.first()
    if  ( cmn.IsEventDone( "opn_roadway"  ) ) then
        private.TutorialShow("tutorial_clk");
      end
  end

  function public.tutorial_clk.click()
    private.TutorialHide()
  end

--------------------------------------------------------------------------------------------
  function public.tutorial_get.first()
      private.TutorialShow("tutorial_get");
  end

  function public.tutorial_get.click()
    private.TutorialHide()
  end
  
  function public.tutorial_use.first()
    if ld.CheckRequirements( {"get_carvedhandle"} ) and not ld.CheckRequirements( {"tutorial_use"} ) then
        local offset = ObjGet("hub_int_inventory_carvedhandle") and ObjGet("hub_int_inventory_carvedhandle").pos_x
        int_inventory_impl.TempLock(true)
        private.TutorialShow("tutorial_use",{0,offset});
      end
  end

  function public.tutorial_use.click()

    private.TutorialHide()
    int_inventory_impl.TempLock(false)
  end  
--------------------------------------------------------------------------------------------
  function public.tutorial_deploy.first()
      if  ( cmn.IsEventDone( "clk_anmfly" ) ) and not ld.CheckRequirements( {"tutorial_deploy"} ) then
        int_inventory_impl.TempLock(true)
        local offset = ObjGet("hub_int_inventory_address") and ObjGet("hub_int_inventory_address").pos_x
        private.TutorialShow("tutorial_deploy",{0,offset});
      end
  end

  function public.tutorial_deploy.click()
    private.TutorialHide()
    int_inventory_impl.TempLock(false)      
  local func_end = function ()
      if int_complex_inv.GetCurrentName() == "" and not (subroom.open_anim) then
         level.tutorial_zz.first()
      end
    end
    ld.StartTimer( "tmr_tutorial_zz", 0.2, func_end )
  end

--------------------------------------------------------------------------------------------
  function public.tutorial_mg.first()
    if  ( cmn.IsEventDone( "clk_addressopn" ) ) or ( cmn.IsEventDone( "use_beetle" ) )then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_mg",{0,offset, -offset});
      end
  end

  function public.tutorial_mg.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function public.tutorial_hint.first()
      if  ( cmn.IsEventDone( "tutorial_newho1" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_hint",{-offset});
      end
  end

  function public.tutorial_hint.click()
    private.TutorialHide()
  end

--------------------------------------------------------------------------------------------
  function public.tutorial_map1.first()
      if  ( cmn.IsEventDone( "clk_nearmonument" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_map1",{offset});
      end
  end

  function public.tutorial_map1.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_map2.first()
      if  ( cmn.IsEventDone( "tutorial_question" ) ) then
        private.TutorialShow("tutorial_map2");
      end
  end

  function public.tutorial_map2.click()
    private.TutorialHide()
    cmn.SetEventDone( "tutorial_map1" );
    
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_hosparkles.first()
    if  ( cmn.IsEventDone( "win_bees" ) )and not cmn.IsEventDone("win_tree") then
        private.TutorialShow("tutorial_hosparkles");
      end
  end

  function public.tutorial_hosparkles.click()
    private.TutorialHide()
  end

--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function private.tutorial_notification_first(type)
    if  ( cmn.IsEventDone( "tutorial_question" ) ) then
      local func_end = function()
        if level.tutorial_current == type then
          ObjSet( "tmr_int_panel_notification", {playing = 0} );
          private.panel_notification_on_screen = true;
        end
      end
      if private.TutorialShow(type) then
        ld.StartTimer( "tmr_tutorial_panel_notification", 0.7 , func_end )
      end
    end
  end

  function private.tutorial_notification_click()
    private.panel_notification_on_screen = false;
    ObjSet( "tmr_int_panel_notification", {playing = 1} );
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_ach.first()
    private.tutorial_notification_first("tutorial_ach")
  end

  function public.tutorial_ach.click()
    private.tutorial_notification_click()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_puzzle.first()
    private.tutorial_notification_first("tutorial_puzzle")
  end

  function public.tutorial_puzzle.click()
    private.tutorial_notification_click()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_morph.first()
    private.tutorial_notification_first("tutorial_morph")
  end

  function public.tutorial_morph.click()
    private.tutorial_notification_click()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_card.first()
    private.tutorial_notification_first("tutorial_card")
  end

  function public.tutorial_card.click()
    private.tutorial_notification_click()
  end
--------------------------------------------------------------------------------------------
--                SPECIAL FEATURES
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function public.tutorial_newho1.first()
      if  ( cmn.IsEventDone( "tutorial_question" ) ) then
        private.TutorialShow("tutorial_newho1");
      end
  end

  function public.tutorial_newho1.click()
    private.TutorialHide()
    --ld.LockRm(1)
    --ld.StartTimer( 0.3, function() ld.LockRm(0);level.tutorial_hint.first() end )
      level.tutorial_hint.first()
  end


--------------------------------------------------------------------------------------------
--                CUT
--------------------------------------------------------------------------------------------
--------------------CUT------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--  function public.tutorial_task.first()
--      if  ( cmn.IsEventDone( "win_casket1" ) ) then
--        if private.TutorialShow("tutorial_task") then
--          int_inventory_impl.TempLock(true)
--        end
--      end
--  end
--
--  function public.tutorial_task.click()
--    int_inventory_impl.TempLock(false)
--    private.TutorialHide()
--    --ld.LockRm(1)
--    --ld.StartTimer( 0.3, function() ld.LockRm(0) level.tutorial_hint.first() end )
--  end
--------------------------------------------------------------------------------------------
--  function public.tutorial_navigation.first()
--      if  ( cmn.IsEventDone( "use_elf_window" ) ) then
--        private.TutorialShow("tutorial_navigation");
--      end
--  end
--
--  function public.tutorial_navigation.click()
--    private.TutorialHide()
--  end
-- end
end