-- name=rm_backyard
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_backyard";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_summertable_text_mini", "spr_summertable_text","sam_picture_clk")
  ld.NoteInit("spr_oldcoach_text_min", "spr_oldcoach_text","ladysdiaripage_clk")
  --------------------------------------------------------------------------------------------
function private.opn_backyard()
  if not ( cmn.IsEventDone( "opn_backyard" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_backyard" );
      cmn.CallEventHandler( "opn_backyard" )
      -- ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opn_backyard");
      SoundTheme( "aud_adventure1_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_backyard = function() end;
local opn_backyard_logic = function() end;
cmn.AddSubscriber( "opn_backyard", opn_backyard_logic )
cmn.AddSubscriber( "opn_backyard", opn_backyard, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_summertable *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_closebottle" ] = { type = "get", get_obj = "spr_summertable_closebottle", room = "rm_backyard", zz = "zz_summertable", zz_gate = "gzz_backyard_summertable" };

private.get_closebottle_logic = function()
  
end;
private.get_closebottle_inv = function()
  interface.InventoryItemAdd("inv_closebottle","spr_summertable_closebottle");
  ObjSet( "inv_closebottle", { drag = 0 } );
end;
private.get_closebottle_beg = function()
  ObjDelete("gfx_summertable_closebottle")
end;
private.get_closebottle_end = function()
  if common_impl.ZzCompleteCheck("get_closebottle") then ObjSet( common_impl.hint["get_closebottle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_summertable_closebottle_sh");
  ObjDelete("spr_backyard_milk_m");
end;

cmn.AddSubscriber( "get_closebottle", private.get_closebottle_inv );
cmn.AddSubscriber( "get_closebottle", private.get_closebottle_beg, private.room_objname );
cmn.AddSubscriber( "get_closebottle", private.get_closebottle_end, private.room_objname );
cmn.AddSubscriber( "get_closebottle", private.get_closebottle_logic );
--------------------------------------------------------------------
function public.get_closebottle()
  cmn.SetEventDone( "get_closebottle" );
  cmn.CallEventHandler( "get_closebottle" );
  if common_impl.ZzCompleteCheck("get_closebottle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_owl_zone_clk()  -- rm_backyard.use_owl_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_owl' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_summertable_anm_owl", "idle_cklik", func_end )
end;  


common_impl.hint[ "use_owl" ] = { type = "use", inv_obj = "inv_owl", use_place = "gfx_summertable_owl_zone", room = "rm_backyard", zz = "zz_summertable", zz_gate = "gzz_backyard_summertable" };

private.use_owl_logic = function()
  ObjSet( "spr_summertable_lettere", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_summertable_tuftpeacock", { visible = 1, input = 1, active = 1 } )

end;
private.use_owl_inv = function()
  common_impl.ProcessMultiUseAll("owl", "owl")
end;
private.use_owl_beg = function()
  ObjDelete( "gfx_summertable_owl_zone" );
end;
private.use_owl_end = function()
  if common_impl.ZzCompleteCheck("use_owl") then ObjSet( common_impl.hint["use_owl"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_summertable_anm_owl", {animfunc = "end_owl", frame = 999 } );
  ObjSet( "spr_summertable_tuftpeacock_sh", {visible=1} );
  ObjSet( "spr_summertable_lettere_sh", {visible = 1} );
  ObjSet( "spr_summertable_text_mini", {input = 1} );
  ObjDelete("spr_backyard_cover_m1");
  ObjSet( "spr_backyard_cover_m", {visible = 1} );
  ObjSet( "spr_backyard_lettere_m", {visible = 1} );
  ObjSet( "spr_backyard_tuftpeacock_m", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_owl", private.use_owl_inv );
cmn.AddSubscriber( "use_owl", private.use_owl_beg, private.room_objname );
cmn.AddSubscriber( "use_owl", private.use_owl_end, private.room_objname );
cmn.AddSubscriber( "use_owl", private.use_owl_logic );
cmn.AddSubscriber( "use_owl_inv", private.use_owl_inv, private.room_objname );
cmn.AddSubscriber( "use_owl_beg", private.use_owl_beg, private.room_objname );
cmn.AddSubscriber( "use_owl_end", private.use_owl_end, private.room_objname );
cmn.AddSubscriber( "use_owl_end", private.use_owl_logic );
--------------------------------------------------------------------------------------------
function public.use_owl( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_owl" );
    cmn.CallEventHandler( "use_owl_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_owl") then ld.CloseSubRoom() end;
--  if not cmn.IsEventDone("get_closebottle") then 
--    ObjSet( "spr_summertable_closebottle", {pos_z = 14} );
--  end;  
--  if not cmn.IsEventDone("use_opener") then 
--    ObjSet( "anm_summertable_anm_opener", {pos_z = 13} );
--  end;   
--  
-- if cmn.IsEventDone("use_opener") and not cmn.IsEventDone("get_oil") then 
--   ObjSet( "spr_summertable_oil", {pos_z = 31} );
-- end;  
    ObjSet( "anm_summertable_anm_owl", {pos_z=10} );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_owl_inv" );
  cmn.CallEventHandler( "use_owl_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_summertable_anm_owl", {pos_z=20} );
 -- if not cmn.IsEventDone("get_closebottle") then 
 --   ObjSet( "spr_summertable_closebottle", {pos_z = 9} );
 -- end; 
 --
 -- if not cmn.IsEventDone("use_opener") then 
 --   ObjSet( "anm_summertable_anm_opener", {pos_z = 8} );
 -- end;  
 -- 
 -- if cmn.IsEventDone("use_opener") and not cmn.IsEventDone("get_oil") then 
 --   ObjSet( "spr_summertable_oil", {pos_z = 8} );
 -- end;  
  
  ld.AnimPlay( "anm_summertable_anm_owl", "use_owl", func_end );
  SoundSfx( "aud_use_owl_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lettere" ] = { type = "get", get_obj = "spr_summertable_lettere", room = "rm_backyard", zz = "zz_summertable", zz_gate = "gzz_backyard_summertable" };

private.get_lettere_logic = function()
  
end;
private.get_lettere_inv = function()
  interface.InventoryItemAdd("inv_lettere","spr_summertable_lettere");
end;
private.get_lettere_beg = function()
  ObjDelete("gfx_summertable_lettere")
end;
private.get_lettere_end = function()
  if common_impl.ZzCompleteCheck("get_lettere") then ObjSet( common_impl.hint["get_lettere"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_summertable_lettere_sh");
  ObjDelete("spr_backyard_lettere_m");
end;

cmn.AddSubscriber( "get_lettere", private.get_lettere_inv );
cmn.AddSubscriber( "get_lettere", private.get_lettere_beg, private.room_objname );
cmn.AddSubscriber( "get_lettere", private.get_lettere_end, private.room_objname );
cmn.AddSubscriber( "get_lettere", private.get_lettere_logic );
--------------------------------------------------------------------
function public.get_lettere()
  cmn.SetEventDone( "get_lettere" );
  cmn.CallEventHandler( "get_lettere" );
  if common_impl.ZzCompleteCheck("get_lettere") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tuftpeacock" ] = { type = "get", get_obj = "spr_summertable_tuftpeacock", room = "rm_backyard", zz = "zz_summertable", zz_gate = "gzz_backyard_summertable" };

private.get_tuftpeacock_logic = function()
  
end;
private.get_tuftpeacock_inv = function()
  interface.InventoryItemAdd("inv_tuftpeacock","spr_summertable_tuftpeacock");
end;
private.get_tuftpeacock_beg = function()
  ObjDelete("gfx_summertable_tuftpeacock")
end;
private.get_tuftpeacock_end = function()
  if common_impl.ZzCompleteCheck("get_tuftpeacock") then ObjSet( common_impl.hint["get_tuftpeacock"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_summertable_tuftpeacock_sh")
  ObjDelete("spr_backyard_tuftpeacock_m");
end;

cmn.AddSubscriber( "get_tuftpeacock", private.get_tuftpeacock_inv );
cmn.AddSubscriber( "get_tuftpeacock", private.get_tuftpeacock_beg, private.room_objname );
cmn.AddSubscriber( "get_tuftpeacock", private.get_tuftpeacock_end, private.room_objname );
cmn.AddSubscriber( "get_tuftpeacock", private.get_tuftpeacock_logic );
--------------------------------------------------------------------
function public.get_tuftpeacock()
  cmn.SetEventDone( "get_tuftpeacock" );
  cmn.CallEventHandler( "get_tuftpeacock" );
  if common_impl.ZzCompleteCheck("get_tuftpeacock") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_opener" ] = { type = "use", inv_obj = "inv_opener", use_place = "gfx_summertable_opener_zone", room = "rm_backyard", zz = "zz_summertable", zz_gate = "gzz_backyard_summertable" };

private.use_opener_logic = function()
  ObjSet( "spr_summertable_oil", { visible = 1, input = 1, active = 1 } )

end;
private.use_opener_inv = function()
  common_impl.ProcessMultiUseAll("opener", "opener")
end;
private.use_opener_beg = function()
  ObjDelete( "gfx_summertable_opener_zone" );
end;
private.use_opener_end = function()
  if common_impl.ZzCompleteCheck("use_opener") then ObjSet( common_impl.hint["use_opener"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_summertable_anm_opener");
  ObjSet( "spr_summertable_oil_sh", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_opener", private.use_opener_inv );
cmn.AddSubscriber( "use_opener", private.use_opener_beg, private.room_objname );
cmn.AddSubscriber( "use_opener", private.use_opener_end, private.room_objname );
cmn.AddSubscriber( "use_opener", private.use_opener_logic );
cmn.AddSubscriber( "use_opener_inv", private.use_opener_inv, private.room_objname );
cmn.AddSubscriber( "use_opener_beg", private.use_opener_beg, private.room_objname );
cmn.AddSubscriber( "use_opener_end", private.use_opener_end, private.room_objname );
cmn.AddSubscriber( "use_opener_end", private.use_opener_logic );
--------------------------------------------------------------------------------------------
function public.use_opener( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_opener" );
    cmn.CallEventHandler( "use_opener_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_opener") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_opener_inv" );
  cmn.CallEventHandler( "use_opener_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_summertable_anm_opener", "use_opener", func_end );
  SoundSfx( "aud_use_opener_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_oil" ] = { type = "get", get_obj = "spr_summertable_oil", room = "rm_backyard", zz = "zz_summertable", zz_gate = "gzz_backyard_summertable" };

private.get_oil_logic = function()
  
end;
private.get_oil_inv = function()
  interface.InventoryItemAdd("inv_oil","spr_summertable_oil");
end;
private.get_oil_beg = function()
  ObjDelete("gfx_summertable_oil")
end;
private.get_oil_end = function()
  if common_impl.ZzCompleteCheck("get_oil") then ObjSet( common_impl.hint["get_oil"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_summertable_oil_sh")
  ObjDelete("spr_backyard_oil_m");
end;

cmn.AddSubscriber( "get_oil", private.get_oil_inv );
cmn.AddSubscriber( "get_oil", private.get_oil_beg, private.room_objname );
cmn.AddSubscriber( "get_oil", private.get_oil_end, private.room_objname );
cmn.AddSubscriber( "get_oil", private.get_oil_logic );
--------------------------------------------------------------------
function public.get_oil()
  cmn.SetEventDone( "get_oil" );
  cmn.CallEventHandler( "get_oil" );
  if common_impl.ZzCompleteCheck("get_oil") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_peacock *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_brokenknife" ] = { type = "get", get_obj = "spr_peacock_brokenknife", room = "rm_backyard", zz = "zz_peacock", zz_gate = "gzz_backyard_peacock" };

private.get_brokenknife_logic = function()
  
end;
private.get_brokenknife_inv = function()
  interface.InventoryItemAdd("inv_brokenknife","spr_peacock_brokenknife");
  ObjSet( "inv_brokenknife", { drag = 0 } );
end;
private.get_brokenknife_beg = function()
  ObjDelete("gfx_peacock_brokenknife")
end;
private.get_brokenknife_end = function()
  if common_impl.ZzCompleteCheck("get_brokenknife") then ObjSet( common_impl.hint["get_brokenknife"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_backyard_brokenknife_m");
end;

cmn.AddSubscriber( "get_brokenknife", private.get_brokenknife_inv );
cmn.AddSubscriber( "get_brokenknife", private.get_brokenknife_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenknife", private.get_brokenknife_end, private.room_objname );
cmn.AddSubscriber( "get_brokenknife", private.get_brokenknife_logic );
--------------------------------------------------------------------
function public.get_brokenknife()
  cmn.SetEventDone( "get_brokenknife" );
  cmn.CallEventHandler( "get_brokenknife" );
  if common_impl.ZzCompleteCheck("get_brokenknife") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_tuftpeacock_zone_clk()  --rm_backyard.use_tuftpeacock_zone_clk();
    local func_end = function() 
      ld.Lock(0);
      common_impl.ShowBbt( 'need_tuftpeacock' );
    end
    
    ld.Lock(1);
    ld.AnimPlay( "anm_peacock_anm_crest", "idle_cklik", func_end )
    SoundSfx( "aud_touch_very_small_metal" );
end;  


common_impl.hint[ "use_tuftpeacock" ] = { type = "use", inv_obj = "inv_tuftpeacock", use_place = "gfx_peacock_tuftpeacock_zone", room = "rm_backyard", zz = "zz_peacock", zz_gate = "gzz_backyard_peacock" };

private.use_tuftpeacock_logic = function()
  ObjSet( "spr_peacock_buttonstorage", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_peacock_buttonstorage", { active = 1, visible = 1} );
end;
private.use_tuftpeacock_inv = function()
  common_impl.ProcessMultiUseAll("tuftpeacock", "tuftpeacock")
end;
private.use_tuftpeacock_beg = function()
  ObjDelete( "gfx_peacock_tuftpeacock_zone" );
end;
private.use_tuftpeacock_end = function()
  if common_impl.ZzCompleteCheck("use_tuftpeacock") then ObjSet( common_impl.hint["use_tuftpeacock"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_peacock_anm_crest", {animfunc = "use_crest", frame = 999 } );
  ObjSet( "spr_backyard_tuftpeacock_m2", {visible = 1} );
  ObjDelete("spr_backyard_beak_m2");
  ObjSet( "spr_backyard_beak_m", {visible = 1} );
  ObjSet( "spr_backyard_buttonstorage_m", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tuftpeacock", private.use_tuftpeacock_inv );
cmn.AddSubscriber( "use_tuftpeacock", private.use_tuftpeacock_beg, private.room_objname );
cmn.AddSubscriber( "use_tuftpeacock", private.use_tuftpeacock_end, private.room_objname );
cmn.AddSubscriber( "use_tuftpeacock", private.use_tuftpeacock_logic );
cmn.AddSubscriber( "use_tuftpeacock_inv", private.use_tuftpeacock_inv, private.room_objname );
cmn.AddSubscriber( "use_tuftpeacock_beg", private.use_tuftpeacock_beg, private.room_objname );
cmn.AddSubscriber( "use_tuftpeacock_end", private.use_tuftpeacock_end, private.room_objname );
cmn.AddSubscriber( "use_tuftpeacock_end", private.use_tuftpeacock_logic );
--------------------------------------------------------------------------------------------
function public.use_tuftpeacock( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tuftpeacock" );
    cmn.CallEventHandler( "use_tuftpeacock_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tuftpeacock") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tuftpeacock_inv" );
  cmn.CallEventHandler( "use_tuftpeacock_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_peacock_anm_crest", "use_crest", func_end );
  SoundSfx( "aud_use_tuftpeacock_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_buttonstorage" ] = { type = "get", get_obj = "spr_peacock_buttonstorage", room = "rm_backyard", zz = "zz_peacock", zz_gate = "gzz_backyard_peacock" };

private.get_buttonstorage_logic = function()
  
end;
private.get_buttonstorage_inv = function()
  interface.InventoryItemAdd("inv_buttonstorage","spr_peacock_buttonstorage");
end;
private.get_buttonstorage_beg = function()
  ObjDelete("gfx_peacock_buttonstorage")
end;
private.get_buttonstorage_end = function()
  if common_impl.ZzCompleteCheck("get_buttonstorage") then ObjSet( common_impl.hint["get_buttonstorage"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_peacock_anm_crest", {animfunc = "end_crest", frame = 0 } );
  ObjDelete("spr_backyard_buttonstorage_m");
end;

cmn.AddSubscriber( "get_buttonstorage", private.get_buttonstorage_inv );
cmn.AddSubscriber( "get_buttonstorage", private.get_buttonstorage_beg, private.room_objname );
cmn.AddSubscriber( "get_buttonstorage", private.get_buttonstorage_end, private.room_objname );
cmn.AddSubscriber( "get_buttonstorage", private.get_buttonstorage_logic );
--------------------------------------------------------------------
function public.get_buttonstorage()
  ObjSet( "spr_peacock_buttonstorage", {visible = 1} );
  cmn.SetEventDone( "get_buttonstorage" );
  cmn.CallEventHandler( "get_buttonstorage" );
  if common_impl.ZzCompleteCheck("get_buttonstorage") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_feather_zone_clk(num)  -- rm_backyard.use_feather1_zone_clk(num);
  local func_end = function()
     common_impl.ShowBbt( 'need_feather'..num )
     ld.Lock(0);
  end
  
  ld.Lock(1);
  ld.AnimPlay( "anm_peacock_anm_open", "idle_cklik1", func_end )
  SoundSfx( "aud_touch_very_small_metal" );
end;  



common_impl.hint[ "use_feather1" ] = { type = "use", inv_obj = "inv_feather1", use_place = "gfx_peacock_feather1_zone", room = "rm_backyard", zz = "zz_peacock", zz_gate = "gzz_backyard_peacock" };

private.use_feather1_logic = function()
  if ld.CheckRequirements( {"use_feather1","use_feather2"} ) then
    ObjSet( "spr_peacock_emblemcat", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_feather1_inv = function()
  common_impl.ProcessMultiUseAll("feather1", "feather1")
end;
private.use_feather1_beg = function()
  ObjDelete( "gfx_peacock_feather1_zone" );
end;
private.use_feather1_end = function()
  if common_impl.ZzCompleteCheck("use_feather1") then ObjSet( common_impl.hint["use_feather1"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_feather1","use_feather2"} ) then
    ObjDelete("anm_peacock_anm_feather2");
    ObjDelete("anm_peacock_anm_feather1");
    ObjSet( "anm_peacock_anm_open", {animfunc = "end_feaser", frame = 0 } );
    ObjSet( "spr_peacock_emblemcat_sh", {visible = 1} );
    ObjSet( "spr_backyard_wing_m1", {visible = 1} );
    ObjDelete("spr_backyard_wing_m2");
    ObjSet( "spr_backyard_catamulet_m2", {visible = 1} );
  else  
    ObjSet( "anm_peacock_anm_feather1", {animfunc = "use_fiather1", frame = 999 } );
  end;  
  ObjSet( "spr_backyard_feather_m1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_feather1", private.use_feather1_inv );
cmn.AddSubscriber( "use_feather1", private.use_feather1_beg, private.room_objname );
cmn.AddSubscriber( "use_feather1", private.use_feather1_end, private.room_objname );
cmn.AddSubscriber( "use_feather1", private.use_feather1_logic );
cmn.AddSubscriber( "use_feather1_inv", private.use_feather1_inv, private.room_objname );
cmn.AddSubscriber( "use_feather1_beg", private.use_feather1_beg, private.room_objname );
cmn.AddSubscriber( "use_feather1_end", private.use_feather1_end, private.room_objname );
cmn.AddSubscriber( "use_feather1_end", private.use_feather1_logic );
--------------------------------------------------------------------------------------------
function public.use_feather1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_feather1" );
    cmn.CallEventHandler( "use_feather1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_feather1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_feather1_inv" );
  cmn.CallEventHandler( "use_feather1_beg" );

  local func_preend  = function()
    if cmn.IsEventDone("use_feather2") then 
      SoundSfx( "aud_touch_feather_backyard" );
      ld.AnimPlay( "anm_peacock_anm_open", "open", func_end )
    else
      func_end()
    end;  
  end;  
  
  
  common_impl.Lock(1);

  ld.AnimPlay( "anm_peacock_anm_feather1", "use_fiather1", func_preend );
  SoundSfx( "aud_use_feather1_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_feather2" ] = { type = "use", inv_obj = "inv_feather2", use_place = "gfx_peacock_feather2_zone", room = "rm_backyard", zz = "zz_peacock", zz_gate = "gzz_backyard_peacock" };

private.use_feather2_logic = function()
  if ld.CheckRequirements( {"use_feather2","use_feather1"} ) then
    ObjSet( "spr_peacock_emblemcat", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_feather2_inv = function()
  common_impl.ProcessMultiUseAll("feather2", "feather2")
end;
private.use_feather2_beg = function()
  ObjDelete( "gfx_peacock_feather2_zone" );
end;
private.use_feather2_end = function()
  if common_impl.ZzCompleteCheck("use_feather2") then ObjSet( common_impl.hint["use_feather2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_feather1","use_feather2"} ) then
    ObjDelete("anm_peacock_anm_feather2");
    ObjDelete("anm_peacock_anm_feather1");
    ObjSet( "anm_peacock_anm_open", {animfunc = "end_feaser", frame = 0 } );
    ObjSet( "spr_peacock_emblemcat_sh", {visible = 1} );
    ObjSet( "spr_backyard_wing_m1", {visible = 1} );
    ObjDelete("spr_backyard_wing_m2");
    ObjSet( "spr_backyard_catamulet_m2", {visible = 1} );
  else  
    ObjSet( "anm_peacock_anm_feather2", {animfunc = "use_fiather", frame = 999 } );
  end;  
  ObjSet( "spr_backyard_feather_m2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_feather2", private.use_feather2_inv );
cmn.AddSubscriber( "use_feather2", private.use_feather2_beg, private.room_objname );
cmn.AddSubscriber( "use_feather2", private.use_feather2_end, private.room_objname );
cmn.AddSubscriber( "use_feather2", private.use_feather2_logic );
cmn.AddSubscriber( "use_feather2_inv", private.use_feather2_inv, private.room_objname );
cmn.AddSubscriber( "use_feather2_beg", private.use_feather2_beg, private.room_objname );
cmn.AddSubscriber( "use_feather2_end", private.use_feather2_end, private.room_objname );
cmn.AddSubscriber( "use_feather2_end", private.use_feather2_logic );
--------------------------------------------------------------------------------------------
function public.use_feather2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_feather2" );
    cmn.CallEventHandler( "use_feather2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_feather2") then ld.CloseSubRoom() end;
  end;

  local func_preend  = function()
    if cmn.IsEventDone("use_feather1") then 
      SoundSfx( "aud_touch_feather_backyard" );
      ld.AnimPlay( "anm_peacock_anm_open", "open", func_end )
    else
      func_end()
    end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_feather2_inv" );
  cmn.CallEventHandler( "use_feather2_beg" );
  
  
  common_impl.Lock(1);
  ld.AnimPlay( "anm_peacock_anm_feather2", "use_fiather", func_preend );
  
  SoundSfx( "aud_use_feather2_backyard" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_emblemcat" ] = { type = "get", get_obj = "spr_peacock_emblemcat", room = "rm_backyard", zz = "zz_peacock", zz_gate = "gzz_backyard_peacock" };

private.get_emblemcat_logic = function()
  
end;
private.get_emblemcat_inv = function()
  interface.InventoryItemAdd("inv_emblemcat","spr_peacock_emblemcat");
end;
private.get_emblemcat_beg = function()
  ObjDelete("gfx_peacock_emblemcat")
end;
private.get_emblemcat_end = function()
  if common_impl.ZzCompleteCheck("get_emblemcat") then ObjSet( common_impl.hint["get_emblemcat"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_peacock_emblemcat_sh");
  ObjDelete("spr_backyard_catamulet_m2");
end;

cmn.AddSubscriber( "get_emblemcat", private.get_emblemcat_inv );
cmn.AddSubscriber( "get_emblemcat", private.get_emblemcat_beg, private.room_objname );
cmn.AddSubscriber( "get_emblemcat", private.get_emblemcat_end, private.room_objname );
cmn.AddSubscriber( "get_emblemcat", private.get_emblemcat_logic );
--------------------------------------------------------------------
function public.get_emblemcat()
  cmn.SetEventDone( "get_emblemcat" );
  cmn.CallEventHandler( "get_emblemcat" );
  if common_impl.ZzCompleteCheck("get_emblemcat") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_oldcoach *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_basket" ] = { type = "get", get_obj = "spr_oldcoach_basket", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };

private.get_basket_logic = function()
  
end;
private.get_basket_inv = function()
  interface.InventoryItemAdd("inv_basket","spr_oldcoach_basket");
  ObjSet( "inv_basket", { drag = 0 } );
end;
private.get_basket_beg = function()
  ObjDelete("gfx_oldcoach_basket")
end;
private.get_basket_end = function()
  if common_impl.ZzCompleteCheck("get_basket") then ObjSet( common_impl.hint["get_basket"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_oldcoach_basket_sh");
  ObjDelete("spr_backyard_basket_m");
end;

cmn.AddSubscriber( "get_basket", private.get_basket_inv );
cmn.AddSubscriber( "get_basket", private.get_basket_beg, private.room_objname );
cmn.AddSubscriber( "get_basket", private.get_basket_end, private.room_objname );
cmn.AddSubscriber( "get_basket", private.get_basket_logic );
--------------------------------------------------------------------
function public.get_basket()
  cmn.SetEventDone( "get_basket" );
  cmn.CallEventHandler( "get_basket" );
  if common_impl.ZzCompleteCheck("get_basket") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lettern" ] = { type = "get", get_obj = "spr_oldcoach_lettern", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };

private.get_lettern_logic = function()
  
end;
private.get_lettern_inv = function()
  interface.InventoryItemAdd("inv_lettern","spr_oldcoach_lettern");
end;
private.get_lettern_beg = function()
  ObjDelete("gfx_oldcoach_lettern")
end;
private.get_lettern_end = function()
  if common_impl.ZzCompleteCheck("get_lettern") then ObjSet( common_impl.hint["get_lettern"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_oldcoach_lettern_sh");
  ObjDelete("spr_backyard_lettern_m")
end;

cmn.AddSubscriber( "get_lettern", private.get_lettern_inv );
cmn.AddSubscriber( "get_lettern", private.get_lettern_beg, private.room_objname );
cmn.AddSubscriber( "get_lettern", private.get_lettern_end, private.room_objname );
cmn.AddSubscriber( "get_lettern", private.get_lettern_logic );
--------------------------------------------------------------------
function public.get_lettern()
  cmn.SetEventDone( "get_lettern" );
  cmn.CallEventHandler( "get_lettern" );
  if common_impl.ZzCompleteCheck("get_lettern") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_coachstars" ] = { type = "click", use_place = "gfx_oldcoach_clk_coachstars_zone", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };

private.clk_coachstars_logic = function()
  ObjSet( "obj_coachdoormmg_root", { visible = 1, input = 1, active = 1, alp = 1 } )

end;
private.clk_coachstars_beg = function()
  ObjDelete( "gfx_oldcoach_clk_coachstars_zone" );
end;
private.clk_coachstars_end = function()
  if common_impl.ZzCompleteCheck("clk_coachstars") then ObjSet( common_impl.hint["clk_coachstars"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_coachstars", private.clk_coachstars_beg, private.room_objname );
cmn.AddSubscriber( "clk_coachstars", private.clk_coachstars_end, private.room_objname );
cmn.AddSubscriber( "clk_coachstars", private.clk_coachstars_logic );
cmn.AddSubscriber( "clk_coachstars_beg", private.clk_coachstars_beg, private.room_objname );
cmn.AddSubscriber( "clk_coachstars_end", private.clk_coachstars_end, private.room_objname );
cmn.AddSubscriber( "clk_coachstars_end", private.clk_coachstars_logic );
--------------------------------------------------------------------------------------------
function public.clk_coachstars()

  local func_end = function()
    cmn.SetEventDone( "clk_coachstars" );
    cmn.CallEventHandler( "clk_coachstars_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_coachstars") then ld.CloseSubRoom() end;
    cmn.MiniGameShow( "coachdoor" );
    public.init_win_coachdoor(1);  
  end;

  cmn.CallEventHandler( "clk_coachstars_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  -- SoundSfx( "aud_clk_coachstars_backyard" )
  --func_end()
  ObjSet( "obj_coachdoormmg_root", {active=1, visible=1, alp=0} );
  ObjAnimate( "obj_coachdoormmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
end;
--------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------
--common_impl.hint[ "win_coachdoor" ] = { type = "click", use_place = "gfx_oldcoach_win_coachdoor_zone", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };
--
--private.win_coachdoor_logic = function()
--  -- ObjSet( "spr_oldcoach_opener", { visible = 1, input = 1, active = 1 } )
--  ObjSet( "gfx_oldcoach_clk_coachdress1_zone", {active=1, input = 1, visible = 1} );
--end;
--private.win_coachdoor_beg = function()
--  ObjDelete( "gfx_oldcoach_win_coachdoor_zone" );
--end;
--private.win_coachdoor_end = function()
--  if common_impl.ZzCompleteCheck("win_coachdoor") then ObjSet( common_impl.hint["win_coachdoor"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjSet( "anm_oldcoach_anm_raccon1", {animfunc = "raccon_01", frame = 0, active=1, visible=1, playing=1 } );
--  ObjSet( "anm_oldcoach_anm_raccon2", {animfunc = "raccon_02", frame = 0, active=1, visible=1, playing=1 } );
--  ObjDelete("anm_oldcoach_anm_door");
--  ObjSet( "obj_oldcoach_raccons_root", {input=1} );
--  ObjSet( "anm_oldcoach_anm_dress", {animfunc = "cklick_cloth", frame = 0, visible = 1, active = 1 } );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "win_coachdoor", private.win_coachdoor_beg, private.room_objname );
--cmn.AddSubscriber( "win_coachdoor", private.win_coachdoor_end, private.room_objname );
--cmn.AddSubscriber( "win_coachdoor", private.win_coachdoor_logic );
--cmn.AddSubscriber( "win_coachdoor_beg", private.win_coachdoor_beg, private.room_objname );
--cmn.AddSubscriber( "win_coachdoor_end", private.win_coachdoor_end, private.room_objname );
--cmn.AddSubscriber( "win_coachdoor_end", private.win_coachdoor_logic );
----------------------------------------------------------------------------------------------
--function public.win_coachdoor()
--
--  local func_end = function()
--    cmn.SetEventDone( "win_coachdoor" );
--    cmn.CallEventHandler( "win_coachdoor_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("win_coachdoor") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "win_coachdoor_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_oldcoach_anm_door", "open_cover", func_end );
--  --SoundSfx( 0 )
--  --func_end()
--
--end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_coachdoor" ] = { type = "click", use_place = "obj_coachdoormmg_root", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };

private.win_coachdoor_logic = function()
    if cmn.IsEventDone("win_coachdoor") then 
      ObjSet( "gfx_oldcoach_clk_coachdress1_zone", {active=1, input = 1, visible = 1} );
    end;
 
end;
private.win_coachdoor_beg = function()
 -- ObjDelete( "gfx_coachdoor_win_coachdoor_zone" );
end;
private.win_coachdoor_end = function()
  if cmn.IsEventDone("win_coachdoor") then 
    if common_impl.ZzCompleteCheck("win_coachdoor") then ObjSet( common_impl.hint["win_coachdoor"].zz_gate, { visible = 0, input = 0 } ); end;
    if common_impl.ZzCompleteCheck("win_coachdoor") then ObjSet( common_impl.hint["win_coachdoor"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjSet( "anm_oldcoach_anm_raccon1", {animfunc = "raccon_01", frame = 0, active=1, visible=1, playing=1 } );
    ObjSet( "anm_oldcoach_anm_raccon2", {animfunc = "raccon_02", frame = 0, active=1, visible=1, playing=1 } );
    ObjSet("anm_oldcoach_anm_door",{animfunc = "default1", frame=0, playing = 0});
    ObjSet( "obj_oldcoach_raccons_root", {input=1} );
    ObjSet( "anm_oldcoach_anm_dress", {animfunc = "cklick_cloth", frame = 0, visible = 1, active = 1 } );
    ObjDelete("obj_coachdoormmg_root");
    ObjSet( "spr_backyard_hat_m", {visible = 1} );
    ObjSet( "spr_backyard_opendoor_m", {visible = 1} );
    ObjSet( "spr_oldcoach_text_min", {visible = 1, input = 1} );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_coachdoor", private.win_coachdoor_beg, private.room_objname );
cmn.AddSubscriber( "win_coachdoor", private.win_coachdoor_end, private.room_objname );
cmn.AddSubscriber( "win_coachdoor", private.win_coachdoor_logic );
cmn.AddSubscriber( "win_coachdoor_beg", private.win_coachdoor_beg, private.room_objname );
cmn.AddSubscriber( "win_coachdoor_end", private.win_coachdoor_end, private.room_objname );
cmn.AddSubscriber( "win_coachdoor_end", private.win_coachdoor_logic );
--------------------------------------------------------------------------------------------
function public.win_coachdoor( obj )

  local func_end = function()
    cmn.SetEventDone( "win_coachdoor" );
    cmn.CallEventHandler( "win_coachdoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_coachdoor") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_coachdoor_beg" );
  common_impl.Lock(1);

  --AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;

--local button_pos_coord = {{-86,-50},{72,-51},{-6,84}};
--local coachdoor_parts_rot_root_ang_array={60,300,180};
local coachdoor_parts_rot_root_ang_array={0,240,120};
local button_fp = {{6,1,4},{1,5,2},{4,2,3}};
local coachdoor_button_pos={{0,0,0},{0,0,0},{0,0,0}};
local coachdoor_button_attached_array={0,0,0,0,0,0}
local coachdoor_button_win_pos={{5,2,4},{2,3,6},{4,6,1}};

function private.coachdoor_mmg_parts_init()
   local attached_array={};
   for i=1,6,1 do 
     ObjCreate("spr_coachdoor_butn_"..i,"spr");
     ObjSet( "spr_coachdoor_butn_"..i, {res="assets/levels/level/rm_backyard/zz_oldcoach/mmg/b"..i, input=0, pos_z=30} );
     attached_array[i]=0;
   end;

   for i=1,3,1 do 
      ObjSet( "obj_coachdoor_round"..i, {input = 1, inputrect_init=1, inputrect_w=100, inputrect_h=100, inputrect_x=-50, inputrect_y=-50,
      event_mdown="rm_backyard.coachdoor_part_mdown("..i..")", event_menter="rm_backyard.coachdoor_round_menter("..i..");", event_mleave="rm_backyard.coachdoor_round_mleave("..i..");", alp=0} );
     for j=1,3,1 do 
       ObjCreate("obj_coachdoor_parts_rot_root_"..i.."_"..j,"obj");
       ObjAttach("obj_coachdoor_parts_rot_root_"..i.."_"..j, "obj_coachdoor_round"..i);
       ObjSet( "obj_coachdoor_parts_rot_root_"..i.."_"..j, {ang=math.pi*coachdoor_parts_rot_root_ang_array[j]/180} ); 
       ObjCreate("obj_coachdoor_little_round_"..i.."_"..j,"obj");
       ObjAttach("obj_coachdoor_little_round_"..i.."_"..j,"obj_coachdoor_parts_rot_root_"..i.."_"..j);
       ObjSet( "obj_coachdoor_little_round_"..i.."_"..j, {pos_x=0, pos_y=-80, pos_z=30, input=0, ang=-math.pi*coachdoor_parts_rot_root_ang_array[j]/180} );
       if attached_array[button_fp[i][j] ]==0 then ObjAttach("spr_coachdoor_butn_"..button_fp[i][j],"obj_coachdoor_little_round_"..i.."_"..j); attached_array[button_fp[i][j] ]=i; end;
--       ObjCreate("pfx_coachdoor_pm_btn_"..i.."_"..j,"partsys_pm");
--       ObjAttach("pfx_coachdoor_pm_btn_"..i.."_"..j,"spr_coachdoor_butn_"..button_fp[i][j]);
--       ObjSet( "pfx_coachdoor_pm_btn_"..i.."_"..j, {input=0, res="assets/levels/level/rm_neartemple/zz_coachdoor/pm_btn"} );
     end;
   end;

end;

function public.coachdoor_round_menter(num)
  ObjSet( "spr_coachdoor_light_"..num, {alp=1} );
  ld.SetCursor(CURSOR_HAND);
end;

function public.coachdoor_round_mleave(num)
  ObjSet( "spr_coachdoor_light_"..num, {alp=0} );
  ld.SetCursor(CURSOR_DEFAULT);
end;


function public.init_win_coachdoor(first_start)
       if first_start==1 then
          
       end;
       if not (cmn.IsEventStart("win_coachdoor")) or first_start==1 then
         ng_global.progress[ "std" ][ "win_coachdoor" ].state={{0,0,0},{0,0,0},{0,0,0}};
         private.win_coachdoor_on_first_pos();
         if first_start==1 then private.coachdoor_first_start_anim(); end;
       else 
         if ld.CheckRequirements( {"clk_coachstars"} ) then
            private.win_coachdoor_stand_on_pos()
            for i=1,3,1 do 
              ObjSet( "obj_coachdoor_round"..i,{alp=1});
            end;
         end
       end   
end

function private.coachdoor_first_start_anim()
  local func_end=function()
    ld.Lock(0);
  end;

  for i=1,3,1 do 
    ObjAnimate( "obj_coachdoor_round"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
  end;
  ld.StartTimer( 0.5, func_end )
  ld.Lock(1)
end;

function private.win_coachdoor_on_first_pos()
  coachdoor_button_pos= ld.TableCopy(button_fp);
  ng_global.progress[ "std" ][ "win_coachdoor" ].state=coachdoor_button_pos;
  coachdoor_button_attached_array={0,0,0,0,0,0};
  for i=1,3,1 do 
     for j=1,3,1 do 
       if coachdoor_button_attached_array[coachdoor_button_pos[i][j] ]==0 then ObjAttach("spr_coachdoor_butn_"..coachdoor_button_pos[i][j],"obj_coachdoor_little_round_"..i.."_"..j); coachdoor_button_attached_array[coachdoor_button_pos[i][j] ]=i; end;
        ObjSet( "obj_coachdoor_little_round_"..i.."_"..j, {ang=-ObjGet("obj_coachdoor_parts_rot_root_"..i.."_"..j).ang} );
     end;
  end;
end; 

  --local coachdoor_round_conq_array={{0,1,1},{2,0,2},{3,3,0}};
 -- local coachdoor_round_conq_array={{1,1,0},{2,0,2},{0,3,3}};

function private.win_coachdoor_stand_on_pos()
  coachdoor_button_pos = ng_global.progress[ "std" ][ "win_coachdoor" ].state;
  -- coachdoor_button_attached_array={0,0,0,0,0,0};
  for i=1,3,1 do 
     for j=1,3,1 do 
       if coachdoor_button_attached_array[coachdoor_button_pos[i][j] ]==0 then ObjAttach("spr_coachdoor_butn_"..coachdoor_button_pos[i][j],"obj_coachdoor_little_round_"..i.."_"..j); coachdoor_button_attached_array[coachdoor_button_pos[i][j] ]=i; end;
         ObjSet( "obj_coachdoor_little_round_"..i.."_"..j, {ang=-ObjGet("obj_coachdoor_parts_rot_root_"..i.."_"..j).ang} );
     end;
     ObjSet( "obj_coachdoor_round"..i, {ang=0} );
  end;
  
  private.coachdoor_win_ver();
end;



function public.coachdoor_part_mdown(num)
  local step_ang=-(120/180)*math.pi;

  local func_end=function()
     local a,b,c = coachdoor_button_pos[num][1],coachdoor_button_pos[num][2],coachdoor_button_pos[num][3];
     coachdoor_button_pos[num][1], coachdoor_button_pos[num][2], coachdoor_button_pos[num][3] = c,a,b;

     for i=1,3,1 do 
       if i~=num then 
           coachdoor_button_pos[i][num]=coachdoor_button_pos[num][i];
       end;
     end;
     
     for i=1,3,1 do 
       ObjAttach("spr_coachdoor_butn_"..coachdoor_button_pos[num][i],"obj_coachdoor_little_round_"..num.."_"..i);
     end;
     ObjSet( "obj_coachdoor_round"..num, {ang=0} );
     private.win_coachdoor_stand_on_pos();
     ld.Lock(0);
  end;


  for i=1,3,1 do 
    if num~=i then 
      if coachdoor_button_attached_array[coachdoor_button_pos[num][i] ]~=num then 
        ObjAttach("spr_coachdoor_butn_"..coachdoor_button_pos[num][i],"obj_coachdoor_little_round_"..num.."_"..i);
        coachdoor_button_attached_array[coachdoor_button_pos[num][i] ]=num;
      end;
    end;
  end;
  
  ld.Lock(1);
  local cogewheel_ang = ObjGet("spr_coachdoor_cogwheel_"..num).ang;
  local new_cog_ang = math.fmod(cogewheel_ang+2*math.pi, 2*math.pi);
  ObjSet("spr_coachdoor_cogwheel_"..num,{ang=new_cog_ang});

 for i=1,3,1 do 
   ObjAnimate(  "obj_coachdoor_little_round_"..num.."_"..i, 7, 0, 0, function() end, {0,0,ObjGet("obj_coachdoor_little_round_"..num.."_"..i).ang, 0.5,0,ObjGet("obj_coachdoor_little_round_"..num.."_"..i).ang-step_ang} );
 end; 

  ObjAnimate( "spr_coachdoor_cogwheel_"..num, 7, 0, 0, function() end, {0,0,new_cog_ang, 0.5,0,new_cog_ang+step_ang} );
  ObjAnimate( "obj_coachdoor_round"..num, 7, 0, 0, func_end, {0,0,0, 0.5,0,step_ang} );  
  
  SoundSfx( "aud_mg_oldcoach_rotate" ); 
end;

function private.coachdoor_win_ver()
  local count=0;
  for i=1,3,1 do 
     for j=1,3,1 do 
        if coachdoor_button_pos[i][j]==coachdoor_button_win_pos[i][j] then count=count+1; end;
     end;
  end;

  if count==9 then private.WinAnim_win_coachdoor(); end;
end;


function private.WinAnim_win_coachdoor()

      local func_end = function ()
        private.Win_win_coachdoor();
      end;

      local func_preend = function()
        cmn.MiniGameHide("coachdoor",1);  
        ld.StartTimer( 0.5, function() SoundSfx( "aud_mg_oldcoach_open" ); ld.AnimPlay( "anm_oldcoach_anm_door", "open_cover", func_end ); end )
      end;
 


      ld.Lock(1);
     --SoundSfx( "aud_mg_coachdoor_win" );
      ObjAnimate( "obj_coachdoormmg_root", 8, 0, 0, func_preend, {0,0,1, 0.5,0,0} );
   end;

function private.Win_win_coachdoor()
      local func_end=function()
        common_impl.Lock(0);
        cmn.SetEventDone("win_coachdoor");
        cmn.CallEventHandler( "win_coachdoor_end" );
      --  if common_impl.ZzCompleteCheck("win_coachdoor") then ld.CloseSubRoom() end; 
      end;

     func_end();
end;
----------------------------------------------------------------------------------------------
function public.oldcoach_raccon1_clk()  --rm_backyard.oldcoach_raccon1_clk()
  local func_end = function()
     ObjSet( "anm_oldcoach_anm_raccon1", {animfunc = "raccon_01", frame = 0, active=1, visible=1, playing=1 } );
     ObjSet( "obj_oldcoach_raccon1_clk_zone", {input = 1} );
  end;  
  
  ObjSet( "obj_oldcoach_raccon1_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_oldcoach_anm_raccon1", "cklik_raccon_01", func_end )
  SoundSfx( "aud_touch_raccoon_1" );
end;  
--------------------------------------------------------------------------------------------
function public.oldcoach_raccon2_clk()  --rm_backyard.oldcoach_raccon2_clk()
  local func_end = function()
    ObjSet( "anm_oldcoach_anm_raccon2", {animfunc = "raccon_02", frame = 0, active=1, visible=1, playing=1 } );
    ObjSet( "obj_oldcoach_raccon2_clk_zone", {input = 1} );
  end;  
  
  ObjSet( "obj_oldcoach_raccon2_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_oldcoach_anm_raccon2", "cklik_raccon_02", func_end )
  SoundSfx( "aud_touch_raccoon_2" );
end;  
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_coachdress1" ] = { type = "click", use_place = "gfx_oldcoach_clk_coachdress1_zone", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };

private.clk_coachdress1_logic = function()
  ObjSet( "gfx_oldcoach_clk_coachdress2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_coachdress1_beg = function()
  ObjDelete( "gfx_oldcoach_clk_coachdress1_zone" );
end;
private.clk_coachdress1_end = function()
  if common_impl.ZzCompleteCheck("clk_coachdress1") then ObjSet( common_impl.hint["clk_coachdress1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_oldcoach_anm_dress", {animfunc = "cklick_cloth1", frame = 0 } );
  ObjDelete("spr_backyard_hat_m");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_coachdress1", private.clk_coachdress1_beg, private.room_objname );
cmn.AddSubscriber( "clk_coachdress1", private.clk_coachdress1_end, private.room_objname );
cmn.AddSubscriber( "clk_coachdress1", private.clk_coachdress1_logic );
cmn.AddSubscriber( "clk_coachdress1_beg", private.clk_coachdress1_beg, private.room_objname );
cmn.AddSubscriber( "clk_coachdress1_end", private.clk_coachdress1_end, private.room_objname );
cmn.AddSubscriber( "clk_coachdress1_end", private.clk_coachdress1_logic );
--------------------------------------------------------------------------------------------
function public.clk_coachdress1()

  local func_end = function()
    cmn.SetEventDone( "clk_coachdress1" );
    cmn.CallEventHandler( "clk_coachdress1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_coachdress1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_coachdress1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_oldcoach_anm_dress", "cklick_cloth", func_end );
  SoundSfx( "aud_touch_cloth_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_coachdress2" ] = { type = "click", use_place = "gfx_oldcoach_clk_coachdress2_zone", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };

private.clk_coachdress2_logic = function()
  ObjSet( "spr_oldcoach_opener", { visible = 1, input = 1, active = 1 } )

end;
private.clk_coachdress2_beg = function()
  ObjDelete( "gfx_oldcoach_clk_coachdress2_zone" );
end;
private.clk_coachdress2_end = function()
  if common_impl.ZzCompleteCheck("clk_coachdress2") then ObjSet( common_impl.hint["clk_coachdress2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_oldcoach_anm_dress", {animfunc = "end_cloth", frame = 0 } );
  ObjSet( "spr_oldcoach_opener_sh", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_coachdress2", private.clk_coachdress2_beg, private.room_objname );
cmn.AddSubscriber( "clk_coachdress2", private.clk_coachdress2_end, private.room_objname );
cmn.AddSubscriber( "clk_coachdress2", private.clk_coachdress2_logic );
cmn.AddSubscriber( "clk_coachdress2_beg", private.clk_coachdress2_beg, private.room_objname );
cmn.AddSubscriber( "clk_coachdress2_end", private.clk_coachdress2_end, private.room_objname );
cmn.AddSubscriber( "clk_coachdress2_end", private.clk_coachdress2_logic );
--------------------------------------------------------------------------------------------
function public.clk_coachdress2()

  local func_end = function()
    cmn.SetEventDone( "clk_coachdress2" );
    cmn.CallEventHandler( "clk_coachdress2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_coachdress2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_coachdress2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_oldcoach_anm_dress", "cklick_cloth1", func_end );
  SoundSfx( "aud_touch_cloth_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "get_opener" ] = { type = "get", get_obj = "spr_oldcoach_opener", room = "rm_backyard", zz = "zz_oldcoach", zz_gate = "gzz_backyard_oldcoach" };

private.get_opener_logic = function()
  
end;
private.get_opener_inv = function()
  interface.InventoryItemAdd("inv_opener","spr_oldcoach_opener");
end;
private.get_opener_beg = function()
  ObjDelete("gfx_oldcoach_opener")
end;
private.get_opener_end = function()
  if common_impl.ZzCompleteCheck("get_opener") then ObjSet( common_impl.hint["get_opener"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_oldcoach_opener_sh");
end;

cmn.AddSubscriber( "get_opener", private.get_opener_inv );
cmn.AddSubscriber( "get_opener", private.get_opener_beg, private.room_objname );
cmn.AddSubscriber( "get_opener", private.get_opener_end, private.room_objname );
cmn.AddSubscriber( "get_opener", private.get_opener_logic );
--------------------------------------------------------------------
function public.get_opener()
  cmn.SetEventDone( "get_opener" );
  cmn.CallEventHandler( "get_opener" );
  if common_impl.ZzCompleteCheck("get_opener") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cathouse *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_milk_zone_clk() --rm_backyard.use_milk_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_milk' );
    ObjSet( "anm_cathouse_anm_cat", {animfunc = "statick", frame = 0, playing = 1 } );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_cat_backyard" );
  ld.AnimPlay( "anm_cathouse_anm_cat", "cat_cklik", func_end )
end;  


common_impl.hint[ "use_milk" ] = { type = "use", inv_obj = "inv_milk", use_place = "gfx_cathouse_milk_zone", room = "rm_backyard", zz = "zz_cathouse", zz_gate = "gzz_backyard_cathouse" };

private.use_milk_logic = function()
  --ObjSet( "spr_cathouse_collar", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_cathouse_grape2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_cathouse_clk_collar_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_milk_inv = function()
  common_impl.ProcessMultiUseAll("milk", "milk")
end;
private.use_milk_beg = function()
  ObjDelete( "gfx_cathouse_milk_zone" );
end;
private.use_milk_end = function()
  if common_impl.ZzCompleteCheck("use_milk") then ObjSet( common_impl.hint["use_milk"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cathouse_anm_cat", {animfunc = "end_milk", frame = 0, playing = 1 } );
  ObjSet( "anm_cathouse_anm_collar", {visible = 1} );
  ObjSet( "spr_cathouse_grape2_sh", {visible = 1} );
  ObjDelete("spr_backyard_cat_m");
  ObjSet( "spr_backyard_catsip_m", {visible = 1} );
  ObjSet( "spr_backyard_collar_m", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_milk", private.use_milk_inv );
cmn.AddSubscriber( "use_milk", private.use_milk_beg, private.room_objname );
cmn.AddSubscriber( "use_milk", private.use_milk_end, private.room_objname );
cmn.AddSubscriber( "use_milk", private.use_milk_logic );
cmn.AddSubscriber( "use_milk_inv", private.use_milk_inv, private.room_objname );
cmn.AddSubscriber( "use_milk_beg", private.use_milk_beg, private.room_objname );
cmn.AddSubscriber( "use_milk_end", private.use_milk_end, private.room_objname );
cmn.AddSubscriber( "use_milk_end", private.use_milk_logic );
--------------------------------------------------------------------------------------------
function public.use_milk( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_milk" );
    cmn.CallEventHandler( "use_milk_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_milk") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_milk_inv" );
  cmn.CallEventHandler( "use_milk_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_cathouse_anm_collar", {visible = 1, alp=0} );
  ObjAnimate( "anm_cathouse_anm_collar", 8, 0, 0, function() end, {0,0,0, 5.5,0,0, 6,0,1} );
  
  ld.AnimPlay( "anm_cathouse_anm_cat", "use_milk", func_end );
  SoundSfx( "aud_use_milk_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_collar" ] = { type = "click", use_place = "gfx_cathouse_clk_collar_zone", room = "rm_backyard", zz = "zz_cathouse", zz_gate = "gzz_backyard_cathouse" };

private.clk_collar_logic = function()
  ObjSet( "spr_cathouse_collar", { visible = 1, input = 1, active = 1 } )
  if not cmn.IsEventDone("use_emblemcat") then 
    ObjSet( "gfx_cathouse_emblemcat_zone", {input = 0, active = 0 , visible = 0} );
  end;  
end;
private.clk_collar_beg = function()
  ObjDelete( "gfx_cathouse_clk_collar_zone" );
end;
private.clk_collar_end = function()
  if common_impl.ZzCompleteCheck("clk_collar") then ObjSet( common_impl.hint["clk_collar"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cathouse_anm_collar", {pos_z=40, animfunc = "collar_end", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_collar", private.clk_collar_beg, private.room_objname );
cmn.AddSubscriber( "clk_collar", private.clk_collar_end, private.room_objname );
cmn.AddSubscriber( "clk_collar", private.clk_collar_logic );
cmn.AddSubscriber( "clk_collar_beg", private.clk_collar_beg, private.room_objname );
cmn.AddSubscriber( "clk_collar_end", private.clk_collar_end, private.room_objname );
cmn.AddSubscriber( "clk_collar_end", private.clk_collar_logic );
--------------------------------------------------------------------------------------------
function public.clk_collar()

  local func_end = function()
    cmn.SetEventDone( "clk_collar" );
    cmn.CallEventHandler( "clk_collar_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_collar") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_collar_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_cathouse_anm_collar", {pos_z=40} );
  ld.AnimPlay( "anm_cathouse_anm_collar", "collar", func_end )
  SoundSfx( "aud_touch_cat_collar_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_collar" ] = { type = "get", get_obj = "spr_cathouse_collar", room = "rm_backyard", zz = "zz_cathouse", zz_gate = "gzz_backyard_cathouse" };

private.get_collar_logic = function()
  if not cmn.IsEventDone("use_emblemcat") then 
    ObjSet( "gfx_cathouse_emblemcat_zone", {input = 1, active = 1 , visible = 1} );
  end;  
end;
private.get_collar_inv = function()
  interface.InventoryItemAdd("inv_collar","spr_cathouse_collar");
end;
private.get_collar_beg = function()
  ObjDelete("gfx_cathouse_collar")
end;
private.get_collar_end = function()
  if common_impl.ZzCompleteCheck("get_collar") then ObjSet( common_impl.hint["get_collar"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_cathouse_anm_collar");
  ObjDelete("spr_backyard_collar_m")
end;

cmn.AddSubscriber( "get_collar", private.get_collar_inv );
cmn.AddSubscriber( "get_collar", private.get_collar_beg, private.room_objname );
cmn.AddSubscriber( "get_collar", private.get_collar_end, private.room_objname );
cmn.AddSubscriber( "get_collar", private.get_collar_logic );
cmn.AddSubscriber( "get_collar_beg", private.get_collar_inv );
cmn.AddSubscriber( "get_collar_beg", private.get_collar_beg, private.room_objname );
cmn.AddSubscriber( "get_collar_end", private.get_collar_end, private.room_objname );
cmn.AddSubscriber( "get_collar_end", private.get_collar_logic );
--------------------------------------------------------------------
function public.get_collar()
  local func_end = function()
      ld.Lock(0);
      cmn.SetEventDone( "get_collar" );
      cmn.CallEventHandler( "get_collar_end" );
      if common_impl.ZzCompleteCheck("get_collar") then ld.CloseSubRoom() end;
  end;
  
  cmn.CallEventHandler( "get_collar_beg" );
  ld.Lock(1);
  ld.AnimPlay( "anm_cathouse_anm_collar", "collar_end", func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_grape2" ] = { type = "get", get_obj = "spr_cathouse_grape2", room = "rm_backyard", zz = "zz_cathouse", zz_gate = "gzz_backyard_cathouse" };

private.get_grape2_logic = function()
  
end;
private.get_grape2_inv = function()
  interface.InventoryItemAdd("inv_grape2","spr_cathouse_grape2");
end;
private.get_grape2_beg = function()
  ObjDelete("gfx_cathouse_grape2")
end;
private.get_grape2_end = function()
  if common_impl.ZzCompleteCheck("get_grape2") then ObjSet( common_impl.hint["get_grape2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cathouse_grape2_sh");
  ObjDelete("spr_backyard_grape2_m");
end;

cmn.AddSubscriber( "get_grape2", private.get_grape2_inv );
cmn.AddSubscriber( "get_grape2", private.get_grape2_beg, private.room_objname );
cmn.AddSubscriber( "get_grape2", private.get_grape2_end, private.room_objname );
cmn.AddSubscriber( "get_grape2", private.get_grape2_logic );
--------------------------------------------------------------------
function public.get_grape2()
  cmn.SetEventDone( "get_grape2" );
  cmn.CallEventHandler( "get_grape2" );
  if common_impl.ZzCompleteCheck("get_grape2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_emblemcat_zone_clk()  --rm_backyard.use_emblemcat_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_emblemcat' )
  end;

  ld.Lock(1);  
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_cathouse_anm_emblem", "cklick_house", func_end )
end;  

common_impl.hint[ "use_emblemcat" ] = { type = "use", inv_obj = "inv_emblemcat", use_place = "gfx_cathouse_emblemcat_zone", room = "rm_backyard", zz = "zz_cathouse", zz_gate = "gzz_backyard_cathouse" };

private.use_emblemcat_logic = function()
  ObjSet( "spr_cathouse_lettera", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_cathouse_wrench", { visible = 1, input = 1, active = 1 } )

end;
private.use_emblemcat_inv = function()
  common_impl.ProcessMultiUseAll("emblemcat", "emblemcat")
end;
private.use_emblemcat_beg = function()
  ObjDelete( "gfx_cathouse_emblemcat_zone" );
end;
private.use_emblemcat_end = function()
  if common_impl.ZzCompleteCheck("use_emblemcat") then ObjSet( common_impl.hint["use_emblemcat"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cathouse_anm_emblem", {animfunc = "end_am", frame = 0 } );
  ObjSet( "spr_cathouse_sh_lettera", {visible=1} );
  ObjSet( "spr_cathouse_sh_wrench", {visible = 1} );
  ObjSet( "spr_backyard_catamulet_m", {visible = 1} );
  ObjDelete("spr_backyard_board_m");
  ObjSet( "spr_backyard_board_m1", {visible = 1} );
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_emblemcat", private.use_emblemcat_inv );
cmn.AddSubscriber( "use_emblemcat", private.use_emblemcat_beg, private.room_objname );
cmn.AddSubscriber( "use_emblemcat", private.use_emblemcat_end, private.room_objname );
cmn.AddSubscriber( "use_emblemcat", private.use_emblemcat_logic );
cmn.AddSubscriber( "use_emblemcat_inv", private.use_emblemcat_inv, private.room_objname );
cmn.AddSubscriber( "use_emblemcat_beg", private.use_emblemcat_beg, private.room_objname );
cmn.AddSubscriber( "use_emblemcat_end", private.use_emblemcat_end, private.room_objname );
cmn.AddSubscriber( "use_emblemcat_end", private.use_emblemcat_logic );
--------------------------------------------------------------------------------------------
function public.use_emblemcat( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_emblemcat" );
    cmn.CallEventHandler( "use_emblemcat_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_emblemcat") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_emblemcat_inv" );
  cmn.CallEventHandler( "use_emblemcat_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cathouse_anm_emblem", "use_am", func_end );
  SoundSfx( "aud_use_emblemcat_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lettera" ] = { type = "get", get_obj = "spr_cathouse_lettera", room = "rm_backyard", zz = "zz_cathouse", zz_gate = "gzz_backyard_cathouse" };

private.get_lettera_logic = function()
  
end;
private.get_lettera_inv = function()
  interface.InventoryItemAdd("inv_lettera","spr_cathouse_lettera");
end;
private.get_lettera_beg = function()
  ObjDelete("gfx_cathouse_lettera")
end;
private.get_lettera_end = function()
  if common_impl.ZzCompleteCheck("get_lettera") then ObjSet( common_impl.hint["get_lettera"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cathouse_sh_lettera")
  ObjDelete("spr_backyard_lettera_m")
end;

cmn.AddSubscriber( "get_lettera", private.get_lettera_inv );
cmn.AddSubscriber( "get_lettera", private.get_lettera_beg, private.room_objname );
cmn.AddSubscriber( "get_lettera", private.get_lettera_end, private.room_objname );
cmn.AddSubscriber( "get_lettera", private.get_lettera_logic );
--------------------------------------------------------------------
function public.get_lettera()
  cmn.SetEventDone( "get_lettera" );
  cmn.CallEventHandler( "get_lettera" );
  if common_impl.ZzCompleteCheck("get_lettera") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wrench" ] = { type = "get", get_obj = "spr_cathouse_wrench", room = "rm_backyard", zz = "zz_cathouse", zz_gate = "gzz_backyard_cathouse" };

private.get_wrench_logic = function()
  
end;
private.get_wrench_inv = function()
  interface.InventoryItemAdd("inv_wrench","spr_cathouse_wrench");
end;
private.get_wrench_beg = function()
  ObjDelete("gfx_cathouse_wrench")
end;
private.get_wrench_end = function()
  if common_impl.ZzCompleteCheck("get_wrench") then ObjSet( common_impl.hint["get_wrench"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cathouse_sh_wrench");
  ObjDelete("spr_backyard_wrench_m")
end;

cmn.AddSubscriber( "get_wrench", private.get_wrench_inv );
cmn.AddSubscriber( "get_wrench", private.get_wrench_beg, private.room_objname );
cmn.AddSubscriber( "get_wrench", private.get_wrench_end, private.room_objname );
cmn.AddSubscriber( "get_wrench", private.get_wrench_logic );
--------------------------------------------------------------------
function public.get_wrench()
  cmn.SetEventDone( "get_wrench" );
  cmn.CallEventHandler( "get_wrench" );
  if common_impl.ZzCompleteCheck("get_wrench") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.Reset()
      local mg_name = common.GetCurrentSubRoom();
     

      if ( mg_name == "zz_oldcoach" ) then
        local func_end=function()
          private.win_coachdoor_on_first_pos();
           for i=1,6,1 do 
             ObjAnimate( "spr_coachdoor_butn_"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
           end;
           ld.StartTimer( 0.5,function() ld.Lock(0); end);
        end;
           

        ld.Lock(1);
        for i=1,6,1 do 
          ObjAnimate( "spr_coachdoor_butn_"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
        end;
        ld.StartTimer( 0.5, func_end );
      end;


 end;  
  
-----------------------------------------------------------------------------------  
function public.Skip()
      local mg_name = common.GetCurrentSubRoom();
         
      if ( mg_name == "zz_oldcoach" ) then
      --  local func_end=function()
      --     private.WinAnim_win_slab();
      --  end;
       
        local func_preend = function()
          slab_button_pos= ld.TableCopy(coachdoor_button_win_pos);
           ng_global.progress[ "std" ][ "win_coachdoor" ].state=slab_button_pos;
           private.win_coachdoor_stand_on_pos();
           for i=1,6,1 do 
             ObjAnimate( "spr_coachdoor_butn_"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
           end;
           
        end;

        ld.Lock(1);
        for i=1,6,1 do 
          ObjAnimate( "spr_coachdoor_butn_"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
        end;
        ld.StartTimer( 0.5, func_preend );
      end;
  end;
    

end;
--*********************************************************************************************************************
function public.Load()
  if not cmn.IsEventDone("win_coachdoor") then 
    private.coachdoor_mmg_parts_init();
  end;
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_backyard();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_backyard_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_cathouse" );
  function zz_cathouse.Open()
  end;
  function zz_cathouse.PreOpen()
  end;
  function zz_cathouse.PreClose()
  end;
  function zz_cathouse.Close()
  end;

  subroom.Define( "zz_oldcoach" );
  function zz_oldcoach.Open()
  end;
  function zz_oldcoach.PreOpen()
    if cmn.IsEventStart("win_coachdoor") and not cmn.IsEventDone("win_coachdoor") then 
        public.init_win_coachdoor();
        cmn.MiniGameShow( "coachdoor" );
    end;  
  end;
  function zz_oldcoach.PreClose()
    if cmn.IsEventStart("win_coachdoor") and not cmn.IsEventDone("win_coachdoor") then 
      cmn.MiniGameHide( "coachdoor" );
    end; 
  end;
  function zz_oldcoach.Close()
  end;

  subroom.Define( "zz_peacock" );
  function zz_peacock.Open()
  end;
  function zz_peacock.PreOpen()
  end;
  function zz_peacock.PreClose()
  end;
  function zz_peacock.Close()
  end;

  subroom.Define( "zz_summertable" );
  function zz_summertable.Open()
  end;
  function zz_summertable.PreOpen()
  end;
  function zz_summertable.PreClose()
  end;
  function zz_summertable.Close()
  end;
  
end;