-- name=rm_cave
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cave";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("obj_treechimeras_text_root", "spr_threechimeras_big_text","chimera_page_clk");
  ld.NoteInit("obj_stalactites_page_root", "spr_stalactites_op_parcel_big");
  --------------------------------------------------------------------------------------------
function private.opn_cave()
  if not ( cmn.IsEventDone( "opn_cave" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_cave" );
      cmn.CallEventHandler( "opn_cave" )
      ld.ShowBbt( "opn_cave" );
      SoundTheme( "aud_adventure2_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_cave = function() end;
local opn_cave_logic = function() end;
cmn.AddSubscriber( "opn_cave", opn_cave_logic )
cmn.AddSubscriber( "opn_cave", opn_cave, private.room_objname )
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "lekar2" then
      if count_txt == 1 then
        
      elseif count_txt == 2 then    
        ld.Lock(1);
        ld.AnimPlay( "anm_cave_lekar2", "giv_twoswords1", function() ld.Lock(0);  end);
        SoundSfx( "aud_get_to_us" )  
      elseif  count_txt == 3 then
        ld.Lock(1);
        ld.AnimPlay( "anm_cave_lekar2", "giv1", function() ld.Lock(0);   end);  
        ObjSet( "spr_cave_feathermg3", {visible = 1, activ = 1 } );       
        private.get_feathermg3_check = true   
        cmn.CallEventHandler( "get_feathermg3" );
        
      elseif count_txt == 4 then 
       --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" )  
        
      end; 
  elseif   
      dlg_name == "lekar3" then
      if count_txt == 1 then
        
      elseif count_txt == 2 then    
        ld.Lock(1);
        ld.AnimPlay( "anm_cave_lekar3", "giv_recip", function() ld.Lock(0);  end);
        SoundSfx( "aud_get_to_us" )  
      elseif  count_txt == 3 then
        ld.Lock(1);
        ld.AnimPlay( "anm_cave_lekar3", "giv1", function() 
          ld.AnimPlay( "anm_cave_lekar3", "giv_twoswords", function() ld.Lock(0);  end);
          SoundSfx( "aud_get_to_us" );
          ld.AnimPlay( "anm_cave_lekar3_text", "text_2", function() ObjSet( "spr_cave_recipemedicine", {visible = 1, activ = 1 } );  end )  
        end);   
      elseif count_txt == 4 then 
        ld.Lock(1);
        ld.AnimPlay( "anm_cave_lekar3", "giv1", function() ld.Lock(0);   end);   
       --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" ) 
        cmn.CallEventHandler( "get_recipemedicine" ); 
        cmn.CallEventHandler( "get_twoswords" );
        ObjSet( "spr_cave_twoswords", {visible = 1, activ = 1 } );
      end; 
     
  end;
end;


common_impl.hint[ "dlg_cave_lekar2" ] = { type = "click", use_place = "gfx_cave_dlg_cave_lekar2_zone", room = "rm_cave" };

private.dlg_cave_lekar2_logic = function()
  ObjSet( "spr_cave_feathermg3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_cave_inhibitor_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_cave_lekar2_beg = function()
  ObjDelete( "gfx_cave_dlg_cave_lekar2_zone" );
end;
private.dlg_cave_lekar2_end = function()
  ObjSet( "anm_cave_lekar_loc_anm", {animfunc = "default", frame = 0, playing=1, visible=1, alp=1 } );
  if common_impl.ZzCompleteCheck("use_waterflask_cave") then ObjSet( common_impl.hint["use_waterflask_cave"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_cave_lekar2", private.dlg_cave_lekar2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar2", private.dlg_cave_lekar2_end, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar2", private.dlg_cave_lekar2_logic );
cmn.AddSubscriber( "dlg_cave_lekar2_beg", private.dlg_cave_lekar2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar2_end", private.dlg_cave_lekar2_end, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar2_end", private.dlg_cave_lekar2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_cave_lekar2( obj )

--  local func_end = function()
--    cmn.SetEventDone( "dlg_cave_lekar2" );
--    cmn.CallEventHandler( "dlg_cave_lekar2_end" );
--    common_impl.Lock(0);
--  end;
--
--  cmn.CallEventHandler( "dlg_cave_lekar2_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  --SoundSfx( 0 )
--  func_end()
--

 local func_end = function()
   cmn.SetEventDone( "use_waterflask_cave" );
   cmn.SetEventDone( "dlg_cave_lekar2" );
   cmn.CallEventHandler( "dlg_cave_lekar2_end" );
    cmn.SetEventDone( "get_feathermg3" );
    if not private.get_feathermg3_check  then
        ObjSet( "spr_cave_feathermg3", {visible = 1} );
        cmn.CallEventHandler( "get_feathermg3" );
      end
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_lekar2");
  end;

  function public.dlg_cave_lekar2_end()
    ObjSet( "dlg_cave_lekar2", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_cave_lekar2_beg" );
  
  common_impl.dialog_character_loc = "anm_cave_lekar_loc_anm"
  common_impl.continue_visible = false;
  common_impl.Start( "lekar2", 3, nil, nil, true, "dlg_cave_lekar2_end",{"aud_barnes_4_voc","aud_barnes_5_voc"} );
  ObjSet( "anm_cave_lekar_loc_anm", {visible=1, playing = 1} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_feathermg3" ] = { type = "get", get_obj = "spr_cave_feathermg3", room = "rm_cave" };

private.get_feathermg3_logic = function()
  
end;
private.get_feathermg3_inv = function()
  interface.InventoryItemAdd("inv_feathermg","spr_cave_feathermg3",function() level_inv.ProcessGetFeathermgAll( "get_feathermg3" ) end);
end;
private.get_feathermg3_beg = function()
  ObjDelete("gfx_cave_feathermg3")
end;
private.get_feathermg3_end = function()
  
end;

cmn.AddSubscriber( "get_feathermg3", private.get_feathermg3_inv );
cmn.AddSubscriber( "get_feathermg3", private.get_feathermg3_beg, private.room_objname );
cmn.AddSubscriber( "get_feathermg3", private.get_feathermg3_end, private.room_objname );
cmn.AddSubscriber( "get_feathermg3", private.get_feathermg3_logic );
--------------------------------------------------------------------
function public.get_feathermg3()
  cmn.SetEventDone( "get_feathermg3" );
  cmn.CallEventHandler( "get_feathermg3" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_inhibitor" ] = { type = "use", inv_obj = "inv_inhibitor", use_place = "gfx_cave_inhibitor_zone", room = "rm_cave" };

private.use_inhibitor_logic = function()
  ObjSet( "gfx_cave_dlg_cave_lekar3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_inhibitor_inv = function()
  common_impl.ProcessMultiUseAll("inhibitor", "inhibitor")
end;
private.use_inhibitor_beg = function()
  ObjDelete( "gfx_cave_inhibitor_zone" );
end;
private.use_inhibitor_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_inhibitor", private.use_inhibitor_inv );
cmn.AddSubscriber( "use_inhibitor", private.use_inhibitor_beg, private.room_objname );
cmn.AddSubscriber( "use_inhibitor", private.use_inhibitor_end, private.room_objname );
cmn.AddSubscriber( "use_inhibitor", private.use_inhibitor_logic );
cmn.AddSubscriber( "use_inhibitor_inv", private.use_inhibitor_inv, private.room_objname );
cmn.AddSubscriber( "use_inhibitor_beg", private.use_inhibitor_beg, private.room_objname );
cmn.AddSubscriber( "use_inhibitor_end", private.use_inhibitor_end, private.room_objname );
cmn.AddSubscriber( "use_inhibitor_end", private.use_inhibitor_logic );
--------------------------------------------------------------------------------------------
function public.use_inhibitor( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_inhibitor" );
    cmn.CallEventHandler( "use_inhibitor_end" );
    common_impl.Lock(0);
    public.dlg_cave_lekar3();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_inhibitor_inv" );
  cmn.CallEventHandler( "use_inhibitor_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_inhibitor_cave" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_cave_lekar3" ] = { type = "click", use_place = "gfx_cave_dlg_cave_lekar3_zone", room = "rm_cave" };

private.dlg_cave_lekar3_logic = function()
  ObjSet( "spr_cave_recipemedicine", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_cave_twoswords", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_cave_lekar3_beg = function()
  ObjDelete( "gfx_cave_dlg_cave_lekar3_zone" );
end;
private.dlg_cave_lekar3_end = function()
  ObjDelete("anm_cave_lekar_loc_anm");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_cave_lekar3", private.dlg_cave_lekar3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar3", private.dlg_cave_lekar3_end, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar3", private.dlg_cave_lekar3_logic );
cmn.AddSubscriber( "dlg_cave_lekar3_beg", private.dlg_cave_lekar3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar3_end", private.dlg_cave_lekar3_end, private.room_objname );
cmn.AddSubscriber( "dlg_cave_lekar3_end", private.dlg_cave_lekar3_logic );
--------------------------------------------------------------------------------------------
function public.dlg_cave_lekar3( obj )

-- local func_end = function()
--   cmn.SetEventDone( "dlg_cave_lekar3" );
--   cmn.CallEventHandler( "dlg_cave_lekar3_end" );
--   common_impl.Lock(0);
-- end;
--
-- cmn.CallEventHandler( "dlg_cave_lekar3_beg" );
-- common_impl.Lock(1);
--
-- --ld.AnimPlay( "", "", func_end );
-- --SoundSfx( 0 )
-- func_end()

  local func_end = function()
    cmn.SetEventDone( "dlg_cave_lekar3" );
    cmn.CallEventHandler( "dlg_cave_lekar3_end" );
    cmn.SetEventDone( "get_recipemedicine" );
    cmn.SetEventDone( "get_twoswords" );
      if ObjGetRelations( "inv_recipemedicine" ).parent == "level_inv_hub" then
        ObjSet( "spr_cave_recipemedicine", {visible = 1} );
        cmn.CallEventHandler( "get_recipemedicine" );
      end
      if ObjGetRelations( "inv_twoswords" ).parent == "level_inv_hub" then
        ObjSet( "spr_cave_twoswords", {visible = 1} );
        cmn.CallEventHandler( "get_twoswords" );
      end
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_lekar3");
  end;

  function public.dlg_cave_lekar3_end()
    ObjSet( "dlg_cave_lekar3", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_cave_lekar3_beg" );
  

  --common_impl.dialog_character_loc = "anm_cave_lekar_loc_anm"
  ObjAnimate( "anm_cave_lekar_loc_anm", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  common_impl.continue_visible = false;
  common_impl.Start( "lekar3", 4, nil, nil, true, "dlg_cave_lekar3_end",{"aud_barnes_6_voc","aud_barnes_7_voc","aud_barnes_8_voc"} );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_recipemedicine" ] = { type = "get", get_obj = "spr_cave_recipemedicine", room = "rm_cave" };

private.get_recipemedicine_logic = function()
  
end;
private.get_recipemedicine_inv = function()
  interface.InventoryItemAdd("inv_recipemedicine","spr_cave_recipemedicine");
end;
private.get_recipemedicine_beg = function()
  ObjDelete("gfx_cave_recipemedicine")
end;
private.get_recipemedicine_end = function()
  
end;

cmn.AddSubscriber( "get_recipemedicine", private.get_recipemedicine_inv );
cmn.AddSubscriber( "get_recipemedicine", private.get_recipemedicine_beg, private.room_objname );
cmn.AddSubscriber( "get_recipemedicine", private.get_recipemedicine_end, private.room_objname );
cmn.AddSubscriber( "get_recipemedicine", private.get_recipemedicine_logic );
--------------------------------------------------------------------
function public.get_recipemedicine()
  cmn.SetEventDone( "get_recipemedicine" );
  cmn.CallEventHandler( "get_recipemedicine" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_twoswords" ] = { type = "get", get_obj = "spr_cave_twoswords", room = "rm_cave" };

private.get_twoswords_logic = function()
  
end;
private.get_twoswords_inv = function()
  interface.InventoryItemAdd("inv_twoswords","spr_cave_twoswords");
end;
private.get_twoswords_beg = function()
  ObjDelete("gfx_cave_twoswords")
end;
private.get_twoswords_end = function()
  
end;

cmn.AddSubscriber( "get_twoswords", private.get_twoswords_inv );
cmn.AddSubscriber( "get_twoswords", private.get_twoswords_beg, private.room_objname );
cmn.AddSubscriber( "get_twoswords", private.get_twoswords_end, private.room_objname );
cmn.AddSubscriber( "get_twoswords", private.get_twoswords_logic );
--------------------------------------------------------------------
function public.get_twoswords()
  cmn.SetEventDone( "get_twoswords" );
  cmn.CallEventHandler( "get_twoswords" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_lekar *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_wingemblem" ] = { type = "get", get_obj = "spr_lekar_wingemblem", room = "rm_cave", zz = "zz_lekar", zz_gate = "gzz_cave_lekar" };

private.get_wingemblem_logic = function()
  ObjSet( "gfx_lekar_waterflask_cave_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_wingemblem_inv = function()
  interface.InventoryItemAdd("inv_wingemblem","spr_lekar_wingemblem");
end;
private.get_wingemblem_beg = function()
  ObjDelete("gfx_lekar_wingemblem")
end;
private.get_wingemblem_end = function()
  if common_impl.ZzCompleteCheck("get_wingemblem") then ObjSet( common_impl.hint["get_wingemblem"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_lekar_wingemblem_sh");
  ObjDelete("spr_cave_dragon_m");
end;

cmn.AddSubscriber( "get_wingemblem", private.get_wingemblem_inv );
cmn.AddSubscriber( "get_wingemblem", private.get_wingemblem_beg, private.room_objname );
cmn.AddSubscriber( "get_wingemblem", private.get_wingemblem_end, private.room_objname );
cmn.AddSubscriber( "get_wingemblem", private.get_wingemblem_logic );
--------------------------------------------------------------------
function public.get_wingemblem()
  cmn.SetEventDone( "get_wingemblem" );
  cmn.CallEventHandler( "get_wingemblem" );
  if common_impl.ZzCompleteCheck("get_wingemblem") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_waterflask_cave_zone_clk()  --rm_cave.use_waterflask_cave_zone_clk()
  local func_end = function()
    ld.Lock(0);
    ObjSet( "anm_lekar_anm", {animfunc = "statick", playing = 1, frame = 0 } );
    common_impl.ShowBbt( 'need_waterflask_cave' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_man_cave" );
  ld.AnimPlay( "anm_lekar_anm", "idle_lekar", func_end )
end;  


common_impl.hint[ "use_waterflask_cave" ] = { type = "use", inv_obj = "inv_waterflask", use_place = "gfx_lekar_waterflask_cave_zone", room = "rm_cave",zz = "zz_lekar", zz_gate = "gzz_cave_lekar"  };

private.use_waterflask_cave_logic = function()
  ObjSet( "gfx_cave_dlg_cave_lekar2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_waterflask_cave_inv = function()
  common_impl.ProcessMultiUseAll("waterflask", "waterflask_cave")
end;
private.use_waterflask_cave_beg = function()
  ObjDelete( "gfx_cave_waterflask_cave_zone" );
end;
private.use_waterflask_cave_end = function()
   if common_impl.ZzCompleteCheck("use_waterflask_cave") then ObjSet( common_impl.hint["use_waterflask_cave"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjDelete("spr_cave_lekar_m");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_waterflask_cave", private.use_waterflask_cave_inv );
cmn.AddSubscriber( "use_waterflask_cave", private.use_waterflask_cave_beg, private.room_objname );
cmn.AddSubscriber( "use_waterflask_cave", private.use_waterflask_cave_end, private.room_objname );
cmn.AddSubscriber( "use_waterflask_cave", private.use_waterflask_cave_logic );
cmn.AddSubscriber( "use_waterflask_cave_inv", private.use_waterflask_cave_inv, private.room_objname );
cmn.AddSubscriber( "use_waterflask_cave_beg", private.use_waterflask_cave_beg, private.room_objname );
cmn.AddSubscriber( "use_waterflask_cave_end", private.use_waterflask_cave_end, private.room_objname );
cmn.AddSubscriber( "use_waterflask_cave_end", private.use_waterflask_cave_logic );
--------------------------------------------------------------------------------------------
function public.use_waterflask_cave( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    -- cmn.SetEventDone( "use_waterflask_cave" );
    cmn.CallEventHandler( "use_waterflask_cave_end" );
    --common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_waterflask_cave") then
      ld.Lock(0);  
  end;
      
  local func_preend = function()
      ld.CloseSubRoom();
      ld.StartTimer( 1, function() ObjAnimate( "spr_cave_lekar_m", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );    public.dlg_cave_lekar2(); func_end();  end )
  end;    

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_waterflask_cave_inv" );
  cmn.CallEventHandler( "use_waterflask_cave_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lekar_anm", "use_botl", func_preend );
  SoundSfx( "aud_use_waterflask_cave" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_threechimeras *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_wingemblem_zone_clk() --rm_cave.use_wingemblem_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_wingemblem' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay( "anm_threechimeras_anm_door", "idle_wingemblem1", func_end )
end;  



common_impl.hint[ "use_wingemblem" ] = { type = "use", inv_obj = "inv_wingemblem", use_place = "gfx_threechimeras_wingemblem_zone", room = "rm_cave", zz = "zz_threechimeras", zz_gate = "gzz_cave_threechimeras" };

private.use_wingemblem_logic = function()
  ObjSet( "spr_threechimeras_piecebas", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_threechimeras_piecebas", {visible = 1, active = 1} );
end;
private.use_wingemblem_inv = function()
  common_impl.ProcessMultiUseAll("wingemblem", "wingemblem")
end;
private.use_wingemblem_beg = function()
  ObjDelete( "gfx_threechimeras_wingemblem_zone" );
end;
private.use_wingemblem_end = function()
  if common_impl.ZzCompleteCheck("use_wingemblem") then ObjSet( common_impl.hint["use_wingemblem"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_threechimeras_anm_door", {animfunc = "use_wingemblem", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wingemblem", private.use_wingemblem_inv );
cmn.AddSubscriber( "use_wingemblem", private.use_wingemblem_beg, private.room_objname );
cmn.AddSubscriber( "use_wingemblem", private.use_wingemblem_end, private.room_objname );
cmn.AddSubscriber( "use_wingemblem", private.use_wingemblem_logic );
cmn.AddSubscriber( "use_wingemblem_inv", private.use_wingemblem_inv, private.room_objname );
cmn.AddSubscriber( "use_wingemblem_beg", private.use_wingemblem_beg, private.room_objname );
cmn.AddSubscriber( "use_wingemblem_end", private.use_wingemblem_end, private.room_objname );
cmn.AddSubscriber( "use_wingemblem_end", private.use_wingemblem_logic );
--------------------------------------------------------------------------------------------
function public.use_wingemblem( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wingemblem" );
    cmn.CallEventHandler( "use_wingemblem_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wingemblem") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wingemblem_inv" );
  cmn.CallEventHandler( "use_wingemblem_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_threechimeras_anm_door", "use_wingemblem", func_end );
  SoundSfx( "aud_use_wingemblem_cave" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_piecebas" ] = { type = "get", get_obj = "spr_threechimeras_piecebas", room = "rm_cave", zz = "zz_threechimeras", zz_gate = "gzz_cave_threechimeras" };

private.get_piecebas_logic = function()
  
end;
private.get_piecebas_inv = function()
  interface.InventoryItemAdd("inv_piecebas","spr_threechimeras_piecebas");
end;
private.get_piecebas_beg = function()
  ObjDelete("gfx_threechimeras_piecebas")
end;
private.get_piecebas_end = function()
  if common_impl.ZzCompleteCheck("get_piecebas") then ObjSet( common_impl.hint["get_piecebas"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_threechimeras_anm_door", {animfunc = "end_wingemblem1", frame = 0 } );
end;

cmn.AddSubscriber( "get_piecebas", private.get_piecebas_inv );
cmn.AddSubscriber( "get_piecebas", private.get_piecebas_beg, private.room_objname );
cmn.AddSubscriber( "get_piecebas", private.get_piecebas_end, private.room_objname );
cmn.AddSubscriber( "get_piecebas", private.get_piecebas_logic );
--------------------------------------------------------------------
function public.get_piecebas()
  ObjSet( "spr_threechimeras_piecebas", {visible = 1} );
  cmn.SetEventDone( "get_piecebas" );
  cmn.CallEventHandler( "get_piecebas" );
  if common_impl.ZzCompleteCheck("get_piecebas") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_partchimeras_zone_clk()  -- rm_cave.use_partchimeras_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_partchimeras' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay( "anm_threechimeras_anm_partchimera", "idle_cash1", func_end )
end;  


common_impl.hint[ "use_partchimeras" ] = { type = "use", inv_obj = "inv_partchimeras", use_place = "gfx_threechimeras_partchimeras_zone", room = "rm_cave", zz = "zz_threechimeras", zz_gate = "gzz_cave_threechimeras" };

private.use_partchimeras_logic = function()
  --  ObjSet( "gfx_threechimeras_win_threeheads_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "obj_threechimeras_mg_root", {active = 1, input = 1, visible = 1} );
end;
private.use_partchimeras_inv = function()
  common_impl.ProcessMultiUseAll("partchimeras", "partchimeras")
end;
private.use_partchimeras_beg = function()
  ObjDelete( "gfx_threechimeras_partchimeras_zone" );
end;
private.use_partchimeras_end = function()
  if common_impl.ZzCompleteCheck("use_partchimeras") then ObjSet( common_impl.hint["use_partchimeras"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_threechimeras_anm_partchimera", {animfunc = "use_partchimeras", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_partchimeras", private.use_partchimeras_inv );
cmn.AddSubscriber( "use_partchimeras", private.use_partchimeras_beg, private.room_objname );
cmn.AddSubscriber( "use_partchimeras", private.use_partchimeras_end, private.room_objname );
cmn.AddSubscriber( "use_partchimeras", private.use_partchimeras_logic );
cmn.AddSubscriber( "use_partchimeras_inv", private.use_partchimeras_inv, private.room_objname );
cmn.AddSubscriber( "use_partchimeras_beg", private.use_partchimeras_beg, private.room_objname );
cmn.AddSubscriber( "use_partchimeras_end", private.use_partchimeras_end, private.room_objname );
cmn.AddSubscriber( "use_partchimeras_end", private.use_partchimeras_logic );
--------------------------------------------------------------------------------------------
function public.use_partchimeras( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_partchimeras" );
    cmn.CallEventHandler( "use_partchimeras_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_partchimeras") then ld.CloseSubRoom() end;
    
    cmn.MiniGameShow( "threeheads" ); 
  end;
  
  local func_preend = function()
    private.init_threeheads();
    ObjSet( "obj_threechimeras_mg_root", {active = 1, visible = 1, alp=0} );
    ObjAnimate( "obj_threechimeras_mg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end;  

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_partchimeras_inv" );
  cmn.CallEventHandler( "use_partchimeras_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_threechimeras_anm_partchimera", "use_partchimeras", func_preend );
  SoundSfx( "aud_use_partchimeras_cave" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_threeheads" ] = { type = "click", use_place = "obj_threechimeras_mg_root", room = "rm_cave", zz = "zz_threechimeras", zz_gate = "gzz_cave_threechimeras" };

private.win_threeheads_logic = function()
  if cmn.IsEventDone("win_threeheads") then 
    ObjSet( "spr_threechimeras_shamrock", { visible = 0, input = 1, active = 1 } )
    ObjSet( "gfx_threechimeras_shamrock", {active = 1, visible = 1} );
    ObjDelete("obj_threechimeras_mg_root");
  end;
end;
private.win_threeheads_beg = function()
 
end;
private.win_threeheads_end = function()
  if cmn.IsEventDone("win_threeheads") then 
    if common_impl.ZzCompleteCheck("win_threeheads") then ObjSet( common_impl.hint["win_threeheads"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjSet( "anm_threechimeras_anm_partchimera", {animfunc = "open_cash", frame = 999 } );
    ObjSet( "spr_cave_chimera_m", {visible = 1} );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_threeheads", private.win_threeheads_beg, private.room_objname );
cmn.AddSubscriber( "win_threeheads", private.win_threeheads_end, private.room_objname );
cmn.AddSubscriber( "win_threeheads", private.win_threeheads_logic );
cmn.AddSubscriber( "win_threeheads_beg", private.win_threeheads_beg, private.room_objname );
cmn.AddSubscriber( "win_threeheads_end", private.win_threeheads_end, private.room_objname );
cmn.AddSubscriber( "win_threeheads_end", private.win_threeheads_logic );
--------------------------------------------------------------------------------------------
function public.win_threeheads()

  local func_end = function()
    cmn.SetEventDone( "win_threeheads" );
    cmn.CallEventHandler( "win_threeheads_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_threeheads") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_threeheads_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "threeheads",true ); 
  
  ObjSet( "anm_threechimeras_anm_partchimera", {animfunc = "open_cash", frame = 0 } );
  ObjAnimate( "obj_threechimeras_mg_root", 8, 0, 0, function()
    ld.StartTimer( 0.3, function() SoundSfx( "aud_open_chimera_chest_cave" ); ld.AnimPlay( "anm_threechimeras_anm_partchimera", "open_cash", func_end ); end )
      end, {0,0,1, 1,0,0, 1.5,0,0} );
 
  --SoundSfx( 0 )
  --func_end()

end;
-------------------------------------------
local threeheads_color_array = {"g","r","v"}; --1,2,3
local threeheads_roots_part_count = {3,4,3};

private.threeheads_fp_array={{3,2,1,1},{2,1,2,3},{1,3,3,2}};


private.threeheads_first_init_flag = false;
function private.threeheads_first_init()  
  if private.threeheads_first_init_flag == false then 
    for i=1,3,1 do 
      for j=1,3,1 do 
        for ii=1,4,1 do 
          if not (i==1 and ii==3) and not (i==3 and ii==2) then            
             ObjSet( "spr_threechimeras_dragon"..i.."_"..threeheads_color_array[j]..ii, {input=0, visible=0, event_menter = "ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown = "rm_cave.threeheads_part_mdown("..i..","..ii..");"} );
          end;
        end;  
      end;  
    end;  
    
  end;  
    
  private.threeheads_first_init_flag = true; 
end;  

----------------------------------------------
private.threeheads_select_part = {0,0};

function private.win_threeheads_stand_on_pos(without_win_ver, without_light_show)
  for i=1,3,1 do 
      for j=1,3,1 do 
        for ii=1,4,1 do 
          if not (i==1 and ii==3) and not (i==3 and ii==2) then
             if j == ng_global.progress["std"]["win_threeheads"].state[i][ii] then 
               -- ld.LogTrace( "spr_threechimeras_dragon"..i.."_"..threeheads_color_array[j]..ii.." input=1" );
               ObjSet( "spr_threechimeras_dragon"..i.."_"..threeheads_color_array[j]..ii, {input=1, visible=1} );
             else 
               ObjSet( "spr_threechimeras_dragon"..i.."_"..threeheads_color_array[j]..ii, {input=0, visible=0} );
             end; 
             if without_light_show~=1 then  
                 if private.threeheads_select_part[1]==i and private.threeheads_select_part[2]==ii then 
                    ObjSet( "spr_threechimeras_dragon"..i.."_l"..ii, {alp=1} );
                 else 
                    ObjSet( "spr_threechimeras_dragon"..i.."_l"..ii, {alp=0} );
                 end;  
             end; 
           end;
        end;  
      end;  
   end;   
      
   if without_win_ver~=1 then private.win_threeheads_win_ver(); end;
 --  private.threeheads_show_state();     
end;  
    
------------------------------------
private.threeheads_win_array = {{1,1,1,1},{2,2,2,2},{3,3,3,3}};

function private.win_threeheads_win_ver()
  local count = 0;
  for i=1,3,1 do 
    for j=1,4,1 do 
      if ng_global.progress["std"]["win_threeheads"].state[i][j]==i then count=count+1; end;
    end;  
  end;  
  if count == 12 then public.win_threeheads(); end;
end;  
-------------------------------------

function private.win_threeheads_skip()
  local func_end = function()
    private.threeheads_select_part = {0,0};
    ng_global.progress["std"]["win_threeheads"].state = ld.TableCopy(private.threeheads_win_array);
    private.win_threeheads_stand_on_pos(1);
    ObjAnimate( "obj_threechimeras_dragons_root", 8, 0, 0, function() private.win_threeheads_stand_on_pos(); end, {0,0,0, 0.3,0,1} );
  end;

  ld.Lock(1);
  ObjAnimate( "obj_threechimeras_dragons_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );  
end;  
--------------------------
function private.win_threeheads_reset()
  local func_end = function()
    private.threeheads_select_part = {0,0};
    ng_global.progress["std"]["win_threeheads"].state = ld.TableCopy(private.threeheads_fp_array);
    private.win_threeheads_stand_on_pos();
    ObjAnimate( "obj_threechimeras_dragons_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  end;

  ld.Lock(1);
  ObjAnimate( "obj_threechimeras_dragons_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );  
end;  


function private.threeheads_show_state()
  local my_text = ""
  for i=1,3,1 do 
    my_text = my_text.."{"
    for j=1,4,1 do 
      my_text = my_text..ng_global.progress["std"]["win_threeheads"].state[i][j]..",";
    end; 
    my_text = my_text.."},"; 
  end; 

--  ld.LogTrace( my_text ); 
--  ld.LogTrace( "private.threeheads_select_part = "..private.threeheads_select_part[1].." "..private.threeheads_select_part[2] );
end;  
    
    
function private.init_threeheads()
  
  if not (cmn.IsEventStart("win_threeheads")) then
    ng_global.progress["std"]["win_threeheads"].state = ld.TableCopy(private.threeheads_fp_array);
    
  else  
   
  end
  private.win_threeheads_stand_on_pos()
end;


function public.threeheads_arrow_mdown(napr) --rm_cave.threeheads_arrow_mdown()  1-left, 2-right
  local func_end = function()
    local buf1 = ld.TableCopy(ng_global.progress["std"]["win_threeheads"].state[1]);  
    local buf2 = ld.TableCopy(ng_global.progress["std"]["win_threeheads"].state[2]);  
    local buf3 = ld.TableCopy(ng_global.progress["std"]["win_threeheads"].state[3]);  
    
    if napr==1 then 
     local gavno_array = {3,1,2};
     if  private.threeheads_select_part[1]~=0 then 
        private.threeheads_select_part[1] = gavno_array[private.threeheads_select_part[1] ];  
     end;   
     
     ng_global.progress["std"]["win_threeheads"].state[1] = ld.TableCopy(buf2); 
     ng_global.progress["std"]["win_threeheads"].state[2] = ld.TableCopy(buf3); 
     ng_global.progress["std"]["win_threeheads"].state[3] = ld.TableCopy(buf1);  
    elseif napr==2 then 
     local gavno_array = {2,3,1};
     if  private.threeheads_select_part[1]~=0 then 
       private.threeheads_select_part[1] = gavno_array[private.threeheads_select_part[1] ]; 
     end;  
     ng_global.progress["std"]["win_threeheads"].state[1] = ld.TableCopy(buf3); 
     ng_global.progress["std"]["win_threeheads"].state[2] = ld.TableCopy(buf1); 
     ng_global.progress["std"]["win_threeheads"].state[3] = ld.TableCopy(buf2);
    end; 
  
    private.win_threeheads_stand_on_pos(1);
    ObjAnimate( "obj_threechimeras_dragons_root", 8, 0, 0, function() ld.Lock(0);ObjSet( "spr_threechimeras_light_arrow"..napr, {alp=0} ); private.win_threeheads_stand_on_pos();  end, {0,0,0, 0.2,0,1} ); 
  end;  
  
  if private.threeheads_select_part[1]~=0 then   
    ObjSet( "spr_threechimeras_dragon"..private.threeheads_select_part[1].."_l"..private.threeheads_select_part[2], {alp=1} );  
    private.threeheads_select_part = {0,0}; 
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_mg_threechimeras_rotate" );
  ObjSet( "spr_threechimeras_light_arrow"..napr, {alp=1} );
  ObjAnimate( "spr_threechimeras_arrow"..napr, 6, 0, 0, function() end, {0,0,1,1, 0.2,0,0.8,0.8, 0.4,0,1,1} );
  ObjAnimate( "obj_threechimeras_dragons_root", 8, 0, 0, func_end, {0,0,1, 0.2,0,0} );
end;  

-------------------------------------------------------------

function public.threeheads_part_mdown(dragon,num)
  SoundSfx( "aud_mg_threechimeras_click" );
  
  if private.threeheads_select_part[1]==0 then
    -- ld.LogTrace( "1 sl" );
    private.threeheads_select_part = {dragon,num};
    ObjSet( "spr_threechimeras_dragon"..dragon.."_l"..num, {alp=1} );
  elseif private.threeheads_select_part[1]~=0 and private.threeheads_select_part[1]~=dragon and private.threeheads_select_part[2]==num then 
    --  ld.LogTrace( "2 sl" );
    SoundSfx( "aud_mg_threechimeras_move" );
    
    local func_end2 = function()
        ld.Lock(0);
        private.win_threeheads_stand_on_pos();
        ObjSet( "spr_threechimeras_dragon"..dragon.."_l"..num, {alp=0} );   
        ObjSet( "spr_threechimeras_dragon"..private.threeheads_select_part[1].."_l"..private.threeheads_select_part[2], {alp=0} ); 
        private.threeheads_select_part = {0,0};
    end;  
    
    local func_end = function()
        private.win_threeheads_stand_on_pos(1,1);
        ObjAnimate( "spr_threechimeras_dragon"..dragon.."_l"..num, 8, 0, 0, function() end, {0,0,0, 0.3,0,1, 0.6,0,0} );
        ObjAnimate( "spr_threechimeras_dragon"..private.threeheads_select_part[1].."_l"..private.threeheads_select_part[2], 8, 0, 0, func_end2, {0,0,0, 0.3,0,1, 0.6,0,0} );
        
        ObjSet( "spr_threechimeras_dragon"..dragon.."_"..threeheads_color_array[ng_global.progress["std"]["win_threeheads"].state[dragon][num] ]..num, {alp=0} );
        ObjSet( "spr_threechimeras_dragon"..private.threeheads_select_part[1].."_"..threeheads_color_array[ng_global.progress["std"]["win_threeheads"].state[private.threeheads_select_part[1] ][private.threeheads_select_part[2] ] ]..num, {alp=0} );
        ObjAnimate( "spr_threechimeras_dragon"..dragon.."_"..threeheads_color_array[ng_global.progress["std"]["win_threeheads"].state[dragon][num] ]..num, 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
        ObjAnimate( "spr_threechimeras_dragon"..private.threeheads_select_part[1].."_"..threeheads_color_array[ng_global.progress["std"]["win_threeheads"].state[private.threeheads_select_part[1] ][private.threeheads_select_part[2] ] ]..num, 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
    end;  
    
    ld.Lock(1);
    ObjSet( "spr_threechimeras_dragon"..dragon.."_l"..num, {alp=1} );
    local buf = ld.TableCopy(ng_global.progress["std"]["win_threeheads"].state[dragon][num]);
    ng_global.progress["std"]["win_threeheads"].state[dragon][num] = ld.TableCopy(ng_global.progress["std"]["win_threeheads"].state[private.threeheads_select_part[1] ][private.threeheads_select_part[2] ]);
    ng_global.progress["std"]["win_threeheads"].state[private.threeheads_select_part[1] ][private.threeheads_select_part[2] ] = ld.TableCopy(buf);
   
    ObjAnimate( "spr_threechimeras_dragon"..dragon.."_l"..num, 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
    ObjAnimate( "spr_threechimeras_dragon"..private.threeheads_select_part[1].."_l"..private.threeheads_select_part[2], 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
      
    ObjAnimate( "spr_threechimeras_dragon"..dragon.."_"..threeheads_color_array[ng_global.progress["std"]["win_threeheads"].state[dragon][num] ]..num, 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
    ObjAnimate( "spr_threechimeras_dragon"..private.threeheads_select_part[1].."_"..threeheads_color_array[ng_global.progress["std"]["win_threeheads"].state[private.threeheads_select_part[1] ][private.threeheads_select_part[2] ] ]..num, 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
    
  else 
    --  ld.LogTrace( "3 sl" );
     ObjSet( "spr_threechimeras_dragon".. private.threeheads_select_part[1].."_l"..private.threeheads_select_part[2], {alp=0} );
     private.threeheads_select_part = {0,0};
    
  end;  
end;  

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_shamrock" ] = { type = "get", get_obj = "spr_threechimeras_shamrock", room = "rm_cave", zz = "zz_threechimeras", zz_gate = "gzz_cave_threechimeras" };

private.get_shamrock_logic = function()
  
end;
private.get_shamrock_inv = function()
  interface.InventoryItemAdd("inv_shamrock","spr_threechimeras_shamrock");
end;
private.get_shamrock_beg = function()
  ObjDelete("gfx_threechimeras_shamrock")
end;
private.get_shamrock_end = function()
  if common_impl.ZzCompleteCheck("get_shamrock") then ObjSet( common_impl.hint["get_shamrock"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_threechimeras_anm_partchimera", {animfunc = "end_cash1", frame = 0 } );
end;

cmn.AddSubscriber( "get_shamrock", private.get_shamrock_inv );
cmn.AddSubscriber( "get_shamrock", private.get_shamrock_beg, private.room_objname );
cmn.AddSubscriber( "get_shamrock", private.get_shamrock_end, private.room_objname );
cmn.AddSubscriber( "get_shamrock", private.get_shamrock_logic );
--------------------------------------------------------------------
function public.get_shamrock()
  ObjSet( "spr_threechimeras_shamrock", {visible = 1} );
  cmn.SetEventDone( "get_shamrock" );
  cmn.CallEventHandler( "get_shamrock" );
  if common_impl.ZzCompleteCheck("get_shamrock") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_basrelief *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_leatherbag" ] = { type = "get", get_obj = "spr_basrelief_leatherbag", room = "rm_cave", zz = "zz_basrelief", zz_gate = "gzz_cave_basrelief" };

private.get_leatherbag_logic = function()
  
end;
private.get_leatherbag_inv = function()
  interface.InventoryItemAdd("inv_leatherbag","spr_basrelief_leatherbag");
  ObjSet( "inv_leatherbag", { drag = 0 } );
end;
private.get_leatherbag_beg = function()
  ObjDelete("gfx_basrelief_leatherbag")
end;
private.get_leatherbag_end = function()
  if common_impl.ZzCompleteCheck("get_leatherbag") then ObjSet( common_impl.hint["get_leatherbag"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_basrelief_sh_leatherbag");
  ObjDelete("spr_cave_bag_m");
end;

cmn.AddSubscriber( "get_leatherbag", private.get_leatherbag_inv );
cmn.AddSubscriber( "get_leatherbag", private.get_leatherbag_beg, private.room_objname );
cmn.AddSubscriber( "get_leatherbag", private.get_leatherbag_end, private.room_objname );
cmn.AddSubscriber( "get_leatherbag", private.get_leatherbag_logic );
--------------------------------------------------------------------
function public.get_leatherbag()
  cmn.SetEventDone( "get_leatherbag" );
  cmn.CallEventHandler( "get_leatherbag" );
  if common_impl.ZzCompleteCheck("get_leatherbag") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_piecebas_zone_clk()  --rm_cave.use_piecebas_zone_clk();
  local func_end = function()
    common_impl.ShowBbt( 'need_piecebas' );
    ld.Lock(0);
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay( "anm_basrelief_anm_piecebas", "idle_piecebas1", func_end )  
end;  


common_impl.hint[ "use_piecebas" ] = { type = "use", inv_obj = "inv_piecebas", use_place = "gfx_basrelief_piecebas_zone", room = "rm_cave", zz = "zz_basrelief", zz_gate = "gzz_cave_basrelief" };

private.use_piecebas_logic = function()
  ObjSet( "spr_basrelief_chisel", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_basrelief_chisel", { active = 1, visible = 1} );
end;
private.use_piecebas_inv = function()
  common_impl.ProcessMultiUseAll("piecebas", "piecebas")
end;
private.use_piecebas_beg = function()
  ObjDelete( "gfx_basrelief_piecebas_zone" );
end;
private.use_piecebas_end = function()
  if common_impl.ZzCompleteCheck("use_piecebas") then ObjSet( common_impl.hint["use_piecebas"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_basrelief_anm_piecebas", {animfunc = "use_piecebas", frame = 999 } );
  ObjSet( "spr_cave_pattern_m", {visible = 1} );
  ObjDelete( "spr_cave_cover_m3" );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_piecebas", private.use_piecebas_inv );
cmn.AddSubscriber( "use_piecebas", private.use_piecebas_beg, private.room_objname );
cmn.AddSubscriber( "use_piecebas", private.use_piecebas_end, private.room_objname );
cmn.AddSubscriber( "use_piecebas", private.use_piecebas_logic );
cmn.AddSubscriber( "use_piecebas_inv", private.use_piecebas_inv, private.room_objname );
cmn.AddSubscriber( "use_piecebas_beg", private.use_piecebas_beg, private.room_objname );
cmn.AddSubscriber( "use_piecebas_end", private.use_piecebas_end, private.room_objname );
cmn.AddSubscriber( "use_piecebas_end", private.use_piecebas_logic );
--------------------------------------------------------------------------------------------
function public.use_piecebas( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_piecebas" );
    cmn.CallEventHandler( "use_piecebas_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_piecebas") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_piecebas_inv" );
  cmn.CallEventHandler( "use_piecebas_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_basrelief_anm_piecebas", "use_piecebas", func_end );
  SoundSfx( "aud_use_piecebas_cave" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_chisel" ] = { type = "get", get_obj = "spr_basrelief_chisel", room = "rm_cave", zz = "zz_basrelief", zz_gate = "gzz_cave_basrelief" };

private.get_chisel_logic = function()
  
end;
private.get_chisel_inv = function()
  interface.InventoryItemAdd("inv_chisel","spr_basrelief_chisel");
end;
private.get_chisel_beg = function()
  ObjDelete("gfx_basrelief_chisel")
end;
private.get_chisel_end = function()
  if common_impl.ZzCompleteCheck("get_chisel") then ObjSet( common_impl.hint["get_chisel"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_basrelief_anm_piecebas",{animfunc = "end_piecebas1", frame = 0})
  ObjDelete("spr_cave_chisel_m");
end;

cmn.AddSubscriber( "get_chisel", private.get_chisel_inv );
cmn.AddSubscriber( "get_chisel", private.get_chisel_beg, private.room_objname );
cmn.AddSubscriber( "get_chisel", private.get_chisel_end, private.room_objname );
cmn.AddSubscriber( "get_chisel", private.get_chisel_logic );
--------------------------------------------------------------------
function public.get_chisel()
  ObjSet( "spr_basrelief_chisel", {visible = 1} );
  cmn.SetEventDone( "get_chisel" );
  cmn.CallEventHandler( "get_chisel" );
  if common_impl.ZzCompleteCheck("get_chisel") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuletlion_zone_clk()  --rm_cave.use_amuletlion_zone_clk()
  local func_end = function()
    common_impl.ShowBbt( 'need_amuletlion' );
    ld.Lock(0);
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay( "anm_basrelief_anm_amuletlion", "idle_amuletlion1", func_end )  
end;  


common_impl.hint[ "use_amuletlion" ] = { type = "use", inv_obj = "inv_amuletlion", use_place = "gfx_basrelief_amuletlion_zone", room = "rm_cave", zz = "zz_basrelief", zz_gate = "gzz_cave_basrelief" };

private.use_amuletlion_logic = function()
  ObjSet( "spr_basrelief_ironhandle", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_basrelief_ironhandle", { active = 1, visible = 1} );
end;
private.use_amuletlion_inv = function()
  common_impl.ProcessMultiUseAll("amuletlion", "amuletlion")
end;
private.use_amuletlion_beg = function()
  ObjDelete( "gfx_basrelief_amuletlion_zone" );
end;
private.use_amuletlion_end = function()
  if common_impl.ZzCompleteCheck("use_amuletlion") then ObjSet( common_impl.hint["use_amuletlion"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_basrelief_anm_amuletlion", {animfunc = "use_amuletlion", frame = 999 } );
  ObjDelete("spr_cave_cover_m4");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletlion", private.use_amuletlion_inv );
cmn.AddSubscriber( "use_amuletlion", private.use_amuletlion_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletlion", private.use_amuletlion_end, private.room_objname );
cmn.AddSubscriber( "use_amuletlion", private.use_amuletlion_logic );
cmn.AddSubscriber( "use_amuletlion_inv", private.use_amuletlion_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletlion_beg", private.use_amuletlion_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletlion_end", private.use_amuletlion_end, private.room_objname );
cmn.AddSubscriber( "use_amuletlion_end", private.use_amuletlion_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletlion( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletlion" );
    cmn.CallEventHandler( "use_amuletlion_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletlion") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletlion_inv" );
  cmn.CallEventHandler( "use_amuletlion_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_basrelief_anm_amuletlion", "use_amuletlion", func_end );
  SoundSfx( "aud_use_amuletlion_cave" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ironhandle" ] = { type = "get", get_obj = "spr_basrelief_ironhandle", room = "rm_cave", zz = "zz_basrelief", zz_gate = "gzz_cave_basrelief" };

private.get_ironhandle_logic = function()
  
end;
private.get_ironhandle_inv = function()
  interface.InventoryItemAdd("inv_ironhandle","spr_basrelief_ironhandle");
end;
private.get_ironhandle_beg = function()
  ObjDelete("gfx_basrelief_ironhandle")
end;
private.get_ironhandle_end = function()
  if common_impl.ZzCompleteCheck("get_ironhandle") then ObjSet( common_impl.hint["get_ironhandle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_basrelief_anm_amuletlion", {animfunc = "end_amuletlion1", frame = 0 } );
  ObjDelete("spr_cave_ironhandle_m")
end;

cmn.AddSubscriber( "get_ironhandle", private.get_ironhandle_inv );
cmn.AddSubscriber( "get_ironhandle", private.get_ironhandle_beg, private.room_objname );
cmn.AddSubscriber( "get_ironhandle", private.get_ironhandle_end, private.room_objname );
cmn.AddSubscriber( "get_ironhandle", private.get_ironhandle_logic );
--------------------------------------------------------------------
function public.get_ironhandle()
  ObjSet( "spr_basrelief_ironhandle", {visible = 1} );
  cmn.SetEventDone( "get_ironhandle" );
  cmn.CallEventHandler( "get_ironhandle" );
  if common_impl.ZzCompleteCheck("get_ironhandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_stalactites *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_wedge_zone_clk()  -- rm_cave.use_wedge_zone_clk()
  local func_end = function()
    common_impl.ShowBbt( 'need_wedge' );
    ld.Lock(0);
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_stalactites_anm_hammer", "idle_hammer1", func_end )
end;  

common_impl.hint[ "use_wedge" ] = { type = "use", inv_obj = "inv_wedge", use_place = "gfx_stalactites_wedge_zone", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.use_wedge_logic = function()
  ObjSet( "gfx_stalactites_hammer_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_wedge_inv = function()
  common_impl.ProcessMultiUseAll("wedge", "wedge")
end;
private.use_wedge_beg = function()
  ObjDelete( "gfx_stalactites_wedge_zone" );
end;
private.use_wedge_end = function()
  if common_impl.ZzCompleteCheck("use_wedge") then ObjSet( common_impl.hint["use_wedge"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_stalactites_anm_hammer", {animfunc = "use_wedge", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wedge", private.use_wedge_inv );
cmn.AddSubscriber( "use_wedge", private.use_wedge_beg, private.room_objname );
cmn.AddSubscriber( "use_wedge", private.use_wedge_end, private.room_objname );
cmn.AddSubscriber( "use_wedge", private.use_wedge_logic );
cmn.AddSubscriber( "use_wedge_inv", private.use_wedge_inv, private.room_objname );
cmn.AddSubscriber( "use_wedge_beg", private.use_wedge_beg, private.room_objname );
cmn.AddSubscriber( "use_wedge_end", private.use_wedge_end, private.room_objname );
cmn.AddSubscriber( "use_wedge_end", private.use_wedge_logic );
--------------------------------------------------------------------------------------------
function public.use_wedge( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wedge" );
    cmn.CallEventHandler( "use_wedge_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wedge") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wedge_inv" );
  cmn.CallEventHandler( "use_wedge_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_stalactites_anm_hammer", "use_wedge", func_end );
  SoundSfx( "aud_use_wedge_cave" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hammer" ] = { type = "use", inv_obj = "inv_hammer", use_place = "gfx_stalactites_hammer_zone", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.use_hammer_logic = function()
  ObjSet( "spr_stalactites_amuletlion", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_stalactites_amuletlion", { active = 1, visible = 1} );
end;
private.use_hammer_inv = function()
  common_impl.ProcessMultiUseAll("hammer", "hammer")
end;
private.use_hammer_beg = function()
  ObjDelete( "gfx_stalactites_hammer_zone" );
end;
private.use_hammer_end = function()
  if common_impl.ZzCompleteCheck("use_hammer") then ObjSet( common_impl.hint["use_hammer"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjDelete("anm_stalactites_anm_hammer");
  --  ObjSet( "spr_stalactites_sh_amuletlion", {visible = 1} );
  ObjSet( "anm_stalactites_anm_hammer", {animfunc = "use_hammer", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hammer", private.use_hammer_inv );
cmn.AddSubscriber( "use_hammer", private.use_hammer_beg, private.room_objname );
cmn.AddSubscriber( "use_hammer", private.use_hammer_end, private.room_objname );
cmn.AddSubscriber( "use_hammer", private.use_hammer_logic );
cmn.AddSubscriber( "use_hammer_inv", private.use_hammer_inv, private.room_objname );
cmn.AddSubscriber( "use_hammer_beg", private.use_hammer_beg, private.room_objname );
cmn.AddSubscriber( "use_hammer_end", private.use_hammer_end, private.room_objname );
cmn.AddSubscriber( "use_hammer_end", private.use_hammer_logic );
--------------------------------------------------------------------------------------------
function public.use_hammer( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hammer" );
    cmn.CallEventHandler( "use_hammer_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hammer") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hammer_inv" );
  cmn.CallEventHandler( "use_hammer_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_stalactites_anm_hammer", "use_hammer", func_end );
  SoundSfx( "aud_use_hammer_cave" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletlion" ] = { type = "get", get_obj = "spr_stalactites_amuletlion", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.get_amuletlion_logic = function()
  
end;
private.get_amuletlion_inv = function()
  interface.InventoryItemAdd("inv_amuletlion","spr_stalactites_amuletlion");
end;
private.get_amuletlion_beg = function()
  ObjDelete("gfx_stalactites_amuletlion")
end;
private.get_amuletlion_end = function()
  if common_impl.ZzCompleteCheck("get_amuletlion") then ObjSet( common_impl.hint["get_amuletlion"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_stalactites_anm_hammer");
  ObjDelete("spr_cave_amuletlion_m");
end;

cmn.AddSubscriber( "get_amuletlion", private.get_amuletlion_inv );
cmn.AddSubscriber( "get_amuletlion", private.get_amuletlion_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletlion", private.get_amuletlion_end, private.room_objname );
cmn.AddSubscriber( "get_amuletlion", private.get_amuletlion_logic );
--------------------------------------------------------------------
function public.get_amuletlion()
  ObjSet( "spr_stalactites_amuletlion", {visible = 1} );
  cmn.SetEventDone( "get_amuletlion" );
  cmn.CallEventHandler( "get_amuletlion" );
  if common_impl.ZzCompleteCheck("get_amuletlion") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_diamondcube_zone_clk() --rm_cave.use_diamondcube_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_diamondcube' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_metal" );
  ld.AnimPlay( "anm_stalactites_anm_door", "idle_diamondcube1", func_end )
end;  


common_impl.hint[ "use_diamondcube" ] = { type = "use", inv_obj = "inv_diamondcube", use_place = "gfx_stalactites_diamondcube_zone", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.use_diamondcube_logic = function()
  -- ObjSet( "gfx_stalactites_win_diamonds_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "obj_stalactites_mg_root", {active = 1, input = 1, visible = 1, alp=1} );
end;
private.use_diamondcube_inv = function()
  common_impl.ProcessMultiUseAll("diamondcube", "diamondcube")
end;
private.use_diamondcube_beg = function()
  ObjDelete( "gfx_stalactites_diamondcube_zone" );
end;
private.use_diamondcube_end = function()
  if common_impl.ZzCompleteCheck("use_diamondcube") then ObjSet( common_impl.hint["use_diamondcube"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_stalactites_anm_door", {animfunc = "use_diamondcube", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_diamondcube", private.use_diamondcube_inv );
cmn.AddSubscriber( "use_diamondcube", private.use_diamondcube_beg, private.room_objname );
cmn.AddSubscriber( "use_diamondcube", private.use_diamondcube_end, private.room_objname );
cmn.AddSubscriber( "use_diamondcube", private.use_diamondcube_logic );
cmn.AddSubscriber( "use_diamondcube_inv", private.use_diamondcube_inv, private.room_objname );
cmn.AddSubscriber( "use_diamondcube_beg", private.use_diamondcube_beg, private.room_objname );
cmn.AddSubscriber( "use_diamondcube_end", private.use_diamondcube_end, private.room_objname );
cmn.AddSubscriber( "use_diamondcube_end", private.use_diamondcube_logic );
--------------------------------------------------------------------------------------------
function public.use_diamondcube( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_diamondcube" );
    cmn.CallEventHandler( "use_diamondcube_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_diamondcube") then ld.CloseSubRoom() end;
    cmn.MiniGameShow( "diamonds" ); 
  end;

  local func_preend = function()
    private.diamonds_first_init();
    private.init_diamonds();
    ObjSet( "obj_stalactites_mg_root", {active = 1, visible = 1, alp=0} );
    ObjAnimate( "obj_stalactites_mg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_diamondcube_inv" );
  cmn.CallEventHandler( "use_diamondcube_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_stalactites_anm_door", "use_diamondcube", func_preend );
  SoundSfx( "aud_use_diamondcube_cave" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_diamonds" ] = { type = "click", use_place = "obj_stalactites_mg_root", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.win_diamonds_logic = function()
  if cmn.IsEventDone("win_diamonds") then 
    --  ObjSet( "gfx_stalactites_clk_storycave_zone", { visible = 1, input = 1, active = 1 } )
     ObjDelete("obj_stalactites_mg_root");
     ObjSet( "gfx_stalactites_clk_storycavebefore_zone", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.win_diamonds_beg = function()
  -- ObjDelete( "gfx_stalactites_win_diamonds_zone" );
end;
private.win_diamonds_end = function()
  if cmn.IsEventDone("win_diamonds") then 
    if common_impl.ZzCompleteCheck("win_diamonds") then ObjSet( common_impl.hint["win_diamonds"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjSet( "anm_stalactites_anm_door", {animfunc = "end_door1", frame = 0 } );
    ObjDelete("spr_cave_door_m2");
    ObjSet( "spr_cave_door_m1", {visible = 1} );
  end;   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_diamonds", private.win_diamonds_beg, private.room_objname );
cmn.AddSubscriber( "win_diamonds", private.win_diamonds_end, private.room_objname );
cmn.AddSubscriber( "win_diamonds", private.win_diamonds_logic );
cmn.AddSubscriber( "win_diamonds_beg", private.win_diamonds_beg, private.room_objname );
cmn.AddSubscriber( "win_diamonds_end", private.win_diamonds_end, private.room_objname );
cmn.AddSubscriber( "win_diamonds_end", private.win_diamonds_logic );
--------------------------------------------------------------------------------------------
function public.win_diamonds()

  local func_end = function()
    cmn.SetEventDone( "win_diamonds" );
    cmn.CallEventHandler( "win_diamonds_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_diamonds") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_diamonds_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "diamonds", true ); 
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_mg_stalactites_win" )
  --func_end()
  
  local func_preend = function()
      ObjSet( "anm_stalactites_anm_door", {animfunc = "open_door", frame = 0 } );
      ObjAnimate( "obj_stalactites_mg_root", 8, 0, 0, function()
            SoundSfx( "aud_open_stalactites_cave" );
            ld.AnimPlay( "anm_stalactites_anm_door", "open_door", func_end )
            end, {0,0,1, 0.5,0,0, 1,0,0} ); 
  end;   
       
  for i=1,4,1 do 
    for j=1,3,1 do 
      ObjSet( "spr_stalactites_part_"..i.."_"..j.."_light", {alp=0, color_r=0, color_g=1, color_b=0} );
      ObjAnimate( "spr_stalactites_part_"..i.."_"..j.."_light", 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} );
    end;  
  end;    
  ld.StartTimer( 1, func_preend );  
end;

--empty field
--{9,9,9,9,9,9,9},
--{9,9,9,0,0,9,9},
--{9,9,9,0,0,0,9},
--{9,0,0,0,0,0,9},
--{9,0,0,0,9,9,9},
--{9,9,0,0,9,9,9},
--{9,9,9,9,9,9,9}

private.diamonds_color_array={"y","v","g","r","y"}; -- "n - nill value (empty part)"
private.diamonds_fp_array_after = {
  {9,9,9,9,9,9,9},
  {9,9,9,2,3,9,9},
  {9,9,9,4,5,1,9},
  {9,2,4,5,3,4,9},
  {9,1,5,1,9,9,9},
  {9,9,3,2,9,9,9},
  {9,9,9,9,9,9,9}
}

private.diamonds_f_pos_coord={-494,3};
private.diamonds_step=61;

private.diamonds_win_array = {
  {9,9,9,9,9,9,9},
  {9,9,9,1,1,9,9},
  {9,9,9,1,5,2,9},
  {9,3,3,5,2,2,9},
  {9,3,5,4,9,9,9},
  {9,9,4,4,9,9,9},
  {9,9,9,9,9,9,9}
}


--------------------------------
function private.init_diamonds()
  
  if not (cmn.IsEventStart("win_diamonds")) then
    ng_global.progress["std"]["win_diamonds"].state = ld.TableCopy(private.diamonds_fp_array_after);
    
  else  
   
  end
  private.win_diamonds_stand_on_pos()
end;

--------------------------------
private.diamonds_first_init_flag = false; 
function private.diamonds_first_init()
  if private.diamonds_first_init_flag == false then 
      
      ------------ reformate fp_array
      local  parts_count_array = {0,0,0,0,0};
      for i=1,#private.diamonds_fp_array_after,1 do 
        for j=1,#private.diamonds_fp_array_after[i],1 do 
          if private.diamonds_fp_array_after[i][j]==9 then private.diamonds_fp_array_after[i][j]={private.diamonds_fp_array_after[i][j],0};
          else 
            parts_count_array[private.diamonds_fp_array_after[i][j] ] = parts_count_array[private.diamonds_fp_array_after[i][j] ]+1; 
            private.diamonds_fp_array_after[i][j] = {private.diamonds_fp_array_after[i][j], parts_count_array[private.diamonds_fp_array_after[i][j] ]};
          end;  
        end;  
      end;  
      ------------ reformate win_array
      local  parts_count_array2 = {0,0,0,0,0};
      for i=1,#private.diamonds_win_array,1 do 
        for j=1,#private.diamonds_win_array[i],1 do 
          if private.diamonds_win_array[i][j]==9 then private.diamonds_win_array[i][j]={private.diamonds_win_array[i][j],0};
          else 
            parts_count_array2[private.diamonds_win_array[i][j] ] = parts_count_array2[private.diamonds_win_array[i][j] ]+1; 
            private.diamonds_win_array[i][j] = {private.diamonds_win_array[i][j], parts_count_array2[private.diamonds_win_array[i][j] ]};
          end;  
        end;  
      end;  
      ----------------------------------------------------
      --- create parts
      for i=1,5,1 do 
        for j=1,3,1 do 
          ObjCreate("spr_stalactites_part_"..i.."_"..j,"spr");
          ObjAttach("spr_stalactites_part_"..i.."_"..j,"obj_stalactites_field_root");
          ObjSet( "spr_stalactites_part_"..i.."_"..j, {res="assets/levels/level/rm_cave/zz_stalactites/zoom/"..private.diamonds_color_array[i].."1", input=1, 
            event_mdown="rm_cave.diamonds_part_mdown("..i..","..j..");", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
          
          if i==5 then  ObjSet( "spr_stalactites_part_"..i.."_"..j, {visible = 0}); end;
          
          ObjCreate("spr_stalactites_part_"..i.."_"..j.."_light","spr");
          ObjAttach("spr_stalactites_part_"..i.."_"..j.."_light","spr_stalactites_part_"..i.."_"..j);
          ObjSet( "spr_stalactites_part_"..i.."_"..j.."_light", {res="assets/levels/level/rm_cave/zz_stalactites/zoom/light", input=0, alp=0, color_r=0, color_g=1, color_b=0} );
        end;  
      end;  
  
      
  end;
  private.diamonds_first_init_flag = true;
end;  
------------------------------------------------------
function private.diamonds_get_parts_coord(ip,jp)
  --- get row nill pos 
  local xnil = private.diamonds_f_pos_coord[1] + private.diamonds_step*ip;
  local ynil = private.diamonds_f_pos_coord[2] + private.diamonds_step*ip;
  
  local p_x = xnil + private.diamonds_step*jp;
  local p_y = ynil - private.diamonds_step*jp;
  local pos_ar = {p_x, p_y};
  
  return pos_ar; 
end;  
----------------------------------------------------
function public.diamonds_get_part_ipjp(ptype,pnum)
   for i=1,#ng_global.progress["std"]["win_diamonds"].state,1 do 
        for j=1,#ng_global.progress["std"]["win_diamonds"].state[i],1 do 
           if ng_global.progress["std"]["win_diamonds"].state[i][j][1] == ptype and ng_global.progress["std"]["win_diamonds"].state[i][j][2] == pnum then return {i,j}; end;       
        end;
   end;     
end;  

----------------------------------------------------
function private.win_diamonds_stand_on_pos(without_win_ver)
   for i=1,#ng_global.progress["std"]["win_diamonds"].state,1 do 
        for j=1,#ng_global.progress["std"]["win_diamonds"].state[i],1 do 
            if ng_global.progress["std"]["win_diamonds"].state[i][j][1]~=9 and ng_global.progress["std"]["win_diamonds"].state[i][j][1]~=0 then
              local part_pos = private.diamonds_get_parts_coord(i,j);
              ObjSet( "spr_stalactites_part_"..ng_global.progress["std"]["win_diamonds"].state[i][j][1].."_"..ng_global.progress["std"]["win_diamonds"].state[i][j][2], {pos_x=part_pos[1], pos_y=part_pos[2] } );
              ObjSet( "spr_stalactites_part_"..ng_global.progress["std"]["win_diamonds"].state[i][j][1].."_"..ng_global.progress["std"]["win_diamonds"].state[i][j][2].."_light",{alp=0});
            end;        
        end;
   end; 
    
   if without_win_ver~=1 then private.win_diamonds_win_ver(); end;     
end;  

------------------------------------------------------------
function private.win_diamonds_win_ver()
   local count = 0;
   for i=1,#ng_global.progress["std"]["win_diamonds"].state,1 do 
     for j=1,#ng_global.progress["std"]["win_diamonds"].state[i],1 do 
       if ng_global.progress["std"]["win_diamonds"].state[i][j][1] == private.diamonds_win_array[i][j][1] and ng_global.progress["std"]["win_diamonds"].state[i][j][1]~=9 then count=count+1 end;        
     end;
   end;     
   if count == 15 then   public.win_diamonds(); end;
end;  
------------------------------------------------------------      
      
private.diamonds_select_part={0,0};      
function public.diamonds_part_mdown(ptype,pnum)
  SoundSfx( "aud_mg_stalactites_click" );
  
  local p_pos_on_field =  public.diamonds_get_part_ipjp(ptype,pnum);
  local ip,jp = p_pos_on_field[1],p_pos_on_field[2];
  
  if private.diamonds_select_part[1]==0 and ng_global.progress["std"]["win_diamonds"].state[ip][jp][1]~=5 then 
    private.diamonds_select_part = {ip,jp}
    ObjSet( "spr_stalactites_part_"..ng_global.progress["std"]["win_diamonds"].state[ip][jp][1].."_"..ng_global.progress["std"]["win_diamonds"].state[ip][jp][2].."_light",{alp=1});
  elseif private.diamonds_select_part[1]~=0 and not (private.diamonds_select_part[1]==ip and private.diamonds_select_part[2]==jp) then
   
    if math.abs(ip - private.diamonds_select_part[1])<=1 and math.abs(jp - private.diamonds_select_part[2])<=1 and math.abs(ip - private.diamonds_select_part[1])+math.abs(jp - private.diamonds_select_part[2])<2 then 
    
        local func_end = function()
           ObjSet( "spr_stalactites_part_"..ptype.."_"..pnum.."_light",{alp=0});
           ObjSet(  "spr_stalactites_part_"..ng_global.progress["std"]["win_diamonds"].state[private.diamonds_select_part[1] ][private.diamonds_select_part[2] ][1].."_"..ng_global.progress["std"]["win_diamonds"].state[private.diamonds_select_part[1] ][private.diamonds_select_part[2] ][2].."_light", {alp=0} );
           local buf = ld.TableCopy(ng_global.progress["std"]["win_diamonds"].state[private.diamonds_select_part[1] ][private.diamonds_select_part[2] ]);
           ng_global.progress["std"]["win_diamonds"].state[private.diamonds_select_part[1] ][private.diamonds_select_part[2] ] = ld.TableCopy(ng_global.progress["std"]["win_diamonds"].state[ip][jp]);
           ng_global.progress["std"]["win_diamonds"].state[ip][jp] = ld.TableCopy(buf);
           private.diamonds_select_part={0,0}; 
           ld.Lock(0); 
           private.win_diamonds_stand_on_pos();
         end;  
        
        SoundSfx( "aud_mg_stalactites_move" );
        ld.Lock(1);
        local fpart_pos = private.diamonds_get_parts_coord(private.diamonds_select_part[1],private.diamonds_select_part[2]);
        local spart_pos = private.diamonds_get_parts_coord(ip,jp);
        ObjSet( "spr_stalactites_part_"..ptype.."_"..pnum.."_light",{alp=1});
        ObjAnimate( "spr_stalactites_part_"..ptype.."_"..pnum, 3, 0, 0, function() end, {0,0,spart_pos[1],spart_pos[2], 0.3,0,fpart_pos[1],fpart_pos[2]} );
          ObjAnimate( "spr_stalactites_part_"..ng_global.progress["std"]["win_diamonds"].state[private.diamonds_select_part[1] ][private.diamonds_select_part[2] ][1].."_"..ng_global.progress["std"]["win_diamonds"].state[private.diamonds_select_part[1] ][private.diamonds_select_part[2] ][2], 3, 0, 0, func_end, {0,0,fpart_pos[1],fpart_pos[2], 0.3,0,spart_pos[1],spart_pos[2]} );  
        
    else
        ld.Lock(1);
        SoundSfx( "aud_mg_stalactites_wrong" );
        ObjSet( "spr_stalactites_part_"..ptype.."_"..pnum.."_light",{color_r=1, color_g=0, color_b=0});
        ObjAnimate( "spr_stalactites_part_"..ptype.."_"..pnum.."_light", 8, 0, 0, function() ObjSet( "spr_stalactites_part_"..ptype.."_"..pnum.."_light",{color_r=0, color_g=1, color_b=0}); ld.Lock(0); end, {0,0,0, 0.25,0,1, 0.5,0,0} );
    end;
    
  elseif private.diamonds_select_part[1]==ip and private.diamonds_select_part[2]==jp  then
    ObjSet( "spr_stalactites_part_"..ng_global.progress["std"]["win_diamonds"].state[ip][jp][1].."_"..ng_global.progress["std"]["win_diamonds"].state[ip][jp][2].."_light",{alp=0});
    private.diamonds_select_part={0,0}; 
  end;  
end;  

function private.win_diamonds_reset()
  local func_end = function()
    private.diamonds_select_part={0,0}; 
    ng_global.progress["std"]["win_diamonds"].state = ld.TableCopy(private.diamonds_fp_array_after);
    private.win_diamonds_stand_on_pos();
    ObjAnimate( "obj_stalactites_field_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  end
  
  
  ld.Lock(1);
  ObjAnimate( "obj_stalactites_field_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;

function private.win_diamonds_skip()
  local func_end = function()
    ng_global.progress["std"]["win_diamonds"].state = ld.TableCopy(private.diamonds_win_array);
    private.win_diamonds_stand_on_pos(1);
    ObjAnimate( "obj_stalactites_field_root", 8, 0, 0, function() private.win_diamonds_stand_on_pos(); end, {0,0,0, 0.3,0,1} );
  end
  
  
  ld.Lock(1);
  ObjAnimate( "obj_stalactites_field_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_storycavebefore" ] = { type = "click", use_place = "gfx_stalactites_clk_storycavebefore_zone", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.clk_storycavebefore_logic = function()
  ObjSet( "spr_stalactites_plummet", { visible = 1, input = 1, active = 1 } )

end;
private.clk_storycavebefore_beg = function()
  ObjDelete( "gfx_stalactites_clk_storycavebefore_zone" );
end;
private.clk_storycavebefore_end = function()
  if common_impl.ZzCompleteCheck("clk_storycavebefore") then ObjSet( common_impl.hint["clk_storycavebefore"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_stalactites_anm_door", {animfunc = "end_parcel1", frame = 0 } );
  ObjSet( "spr_stalactites_sh_plummet", {visible = 1} );
  ObjSet( "anm_stalactites_anm_spider", {input = 1} );
  ObjDelete("spr_cave_bundle_m1");
  ObjSet( "spr_cave_plummet_m", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_storycavebefore", private.clk_storycavebefore_beg, private.room_objname );
cmn.AddSubscriber( "clk_storycavebefore", private.clk_storycavebefore_end, private.room_objname );
cmn.AddSubscriber( "clk_storycavebefore", private.clk_storycavebefore_logic );
cmn.AddSubscriber( "clk_storycavebefore_beg", private.clk_storycavebefore_beg, private.room_objname );
cmn.AddSubscriber( "clk_storycavebefore_end", private.clk_storycavebefore_end, private.room_objname );
cmn.AddSubscriber( "clk_storycavebefore_end", private.clk_storycavebefore_logic );
--------------------------------------------------------------------------------------------
function public.clk_storycavebefore()

    local func_end = function()
      cmn.SetEventDone( "clk_storycavebefore" );
      cmn.CallEventHandler( "clk_storycavebefore_end" );
      common_impl.Lock(0);
      if common_impl.ZzCompleteCheck("clk_storycavebefore") then ld.CloseSubRoom() end;
    end;
  
    cmn.CallEventHandler( "clk_storycavebefore_beg" );
    common_impl.Lock(1);
  
    ld.AnimPlay( "anm_stalactites_anm_door", "click_parcel", func_end );
    SoundSfx( "aud_touch_papers_cave" )
    --func_end()
    cmn.CallEventHandler( "clk_storycavebefore_beg" );
  end;
-- ---------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_plummet" ] = { type = "get", get_obj = "spr_stalactites_plummet", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.get_plummet_logic = function()
  ObjSet( "gfx_stalactites_clk_storycave_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_plummet_inv = function()
  interface.InventoryItemAdd("inv_plummet","spr_stalactites_plummet");
end;
private.get_plummet_beg = function()
  ObjDelete("gfx_stalactites_plummet")
end;
private.get_plummet_end = function()
   if common_impl.ZzCompleteCheck("get_plummet") then ObjSet( common_impl.hint["get_plummet"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_stalactites_sh_plummet")
  ObjDelete("spr_cave_plummet_m");
end;

cmn.AddSubscriber( "get_plummet", private.get_plummet_inv );
cmn.AddSubscriber( "get_plummet", private.get_plummet_beg, private.room_objname );
cmn.AddSubscriber( "get_plummet", private.get_plummet_end, private.room_objname );
cmn.AddSubscriber( "get_plummet", private.get_plummet_logic );
--------------------------------------------------------------------
function public.get_plummet()
  ld.Lock(1);
  -- cmn.SetEventDone( "get_plummet" );
  cmn.CallEventHandler( "get_plummet" );
  -- if common_impl.ZzCompleteCheck("get_plummet") then ld.CloseSubRoom() end;
  ld.StartTimer( 0.3, function() public.clk_storycave(); end ) 
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_storycave" ] = { type = "click", use_place = "gfx_stalactites_clk_storycave_zone", room = "rm_cave", zz = "zz_stalactites", zz_gate = "gzz_cave_stalactites" };

private.clk_storycave_logic = function()
  --ObjSet( "spr_stalactites_plummet", { visible = 1, input = 1, active = 1 } )

end;
private.clk_storycave_beg = function()
  ObjDelete( "gfx_stalactites_clk_storycave_zone" );
end;
private.clk_storycave_end = function()

  if common_impl.ZzCompleteCheck("clk_storycave") then ObjSet( common_impl.hint["clk_storycave"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjSet( "anm_stalactites_anm_door", {animfunc = "end_parcel1", frame = 0 } );
  -- ObjSet( "spr_stalactites_sh_plummet", {visible = 1} );
  -- ObjSet( "anm_stalactites_anm_spider", {input = 1} );
  ObjDelete("anm_stalactites_anm_door");
  ObjDelete("anm_stalactites_anm_spider");
  
  ObjSet( "obj_stalactites_page_root", { active = 1, input = 1, visible = 1} );
  ObjSet( "spr_stalactites_op_parcel_big", {active = 1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_storycave", private.clk_storycave_beg, private.room_objname );
cmn.AddSubscriber( "clk_storycave", private.clk_storycave_end, private.room_objname );
cmn.AddSubscriber( "clk_storycave", private.clk_storycave_logic );
cmn.AddSubscriber( "clk_storycave_beg", private.clk_storycave_beg, private.room_objname );
cmn.AddSubscriber( "clk_storycave_end", private.clk_storycave_end, private.room_objname );
cmn.AddSubscriber( "clk_storycave_end", private.clk_storycave_logic );
--------------------------------------------------------------------------------------------
function public.clk_storycave()

--  local func_end = function()
--    cmn.SetEventDone( "clk_storycave" );
--    cmn.CallEventHandler( "clk_storycave_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_storycave") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_storycave_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_stalactites_anm_door", "click_parcel", func_end );
--  SoundSfx( "aud_clk_storycave_cave" )
--  --func_end()
    cmn.CallEventHandler( "clk_storycave_beg" );

-- ---------------------------------------------------------------------------------------------
  local func_end_end_end = function()
    ld.Lock( 0 ); 
    cmn.SetEventDone( "get_plummet" );
    cmn.SetEventDone( "clk_storycave" );
    cmn.CallEventHandler( "clk_storycave_end" ); 
    ld.ShowBbt("after_flashback_cave");
    if common_impl.ZzCompleteCheck("clk_storycave") then ld.CloseSubRoom() end;
    SoundTheme( "aud_adventure1_mus" )
  end;
  
  
  local func_end_end = function() 
    --ObjSet( "anm_lordbag_anm_use_l", {animfunc = "big_plan_go", frame = 0 } );
    ld.StartTimer( 0.3, function() func_end_end_end();  end )
      --  func_end_end_end();
      SoundTheme( 0 );
  end;


  local func_end = function()
    --  ObjSet( "anm_lordbag_anm_use_l", {animfunc = "big_plan_go", frame = 0 } );
    ld.Lock(1);
    SoundSfx( 0 )
    -- SoundTheme( 0 )
    -- SoundEnv( "aud_wingedbookext_flashback_1_env", -1 )
    int_blackbartext.Hide()
    interface.DialogStoryHide()
    SoundEnvHide(0);
    SoundVoice( 0 )
    ld.StartTimer( 1, 
    function() 
      ObjSet( "dlg_cave_flashback", { alp = 0 } )
      for i = 1, 3 do
        ObjDelete( "vid_cave_vid_flashback_"..i )
        --   ObjDelete( "vid_purse_vid_flashback_"..i.."_voc" )
      end;
      func_end_end();
    end );
   
  end;


  local vid_static = function( func, n )
    --ObjAnimate( "vid_museum_vid_flashback_5", 6,0,0, function() 
    local d = 25;
    local o = ObjGet( "vid_cave_vid_flashback_"..n );
    local t = math.random(4000,5000)/1000;
    local sc = math.random(2050,2150)/1000;
      ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t,3,sc,sc } )
      ObjAnimate( o.name, 3,0,0, function() func(func,n) end, { 0,0,o.pos_x,o.pos_y, t,3,512+math.random(-d,d),384+math.random(-d,d) } )
    --end, { 0,0,1,1, 1,0,1.05,1.05 } )
  end

  local vid_play = function( n )
    vid_ended = true 
    -- local lip_vid_1 = "vid_purse_vid_flashback_"..n.."_voc"
    -- local lip_vid_0 = "vid_purse_vid_flashback_"..(n-1).."_voc"
    --  ObjSet( lip_vid_1, { pos_x = ObjGet( "obj_int_dialog_story_continue" ).pos_x - 90, pos_y = 210, pos_z = 33} )
     ObjAttach( "vid_cave_vid_flashback_"..n, "dlg_cave_flashback" )
     
    -- ObjAttach( lip_vid_1, "obj_int_dialog_story" )
    ----SoundSfx( "aud_museum_flashback_"..n )
    SoundVoice( 0 )
    local flshbck_voc={"aud_clk_storycave_cave_voc","aud_clk_storycave_cave_2_voc","aud_clk_storycave_cave_3_voc"};
    ld.Lock(1);
    ld.StartTimer( 1, function() SoundVoice( flshbck_voc[n]); ld.Lock(0)  end ) 

    VidPlay( "vid_cave_vid_flashback_"..n, function() 
      vid_ended = true 
      ObjAnimate( "vid_cave_vid_flashback_"..n, 6,0,0, function() vid_static(vid_static,n) end, { 0,0,2,2, 1,0,2.05,2.05 } )
    end )
    VidPlay( lip_vid_1, "" )
    
    ObjAnimate( "vid_cave_vid_flashback_"..n, 8,0,0, function() ObjDetach( "vid_cave_vid_flashback_"..(n-1) ); end, { 0,0,0, vid_ended and 0.5 or 0,0,1 } )
    ObjAnimate( lip_vid_1, 8,0,0, _, { 0,0,0, vid_ended and 0.5 or 0,2,1 } )
    ObjAnimate( lip_vid_0, 8,0,0, function() ObjDetach( lip_vid_0 ); end, { 0,0,1, vid_ended and 0.5 or 0,1,0 } )

  end

  local func_step_3 = function()
    SoundSfx( 0, 0.25 )
    SoundSfx( "aud_clk_storycave_cave_3", 0.25 )
    vid_play( 3 )
    interface.DialogStoryShow( "dlg_cave_flashback", "str_storycave_vid_flashback_3", func_end, func_end, 0.5 )
    vid_ended = false
  end;
  local func_step_2 = function()
    SoundSfx( 0, 0.25 )
    SoundSfx( "aud_clk_storycave_cave_2", 0.25 )
    vid_play( 2 )
    interface.DialogStoryShow( "dlg_cave_flashback", "str_storycave_vid_flashback_2", func_step_3, func_end, 0.5 )
    vid_ended = false
  end;

  local func_step_1 = function()
    --SoundTheme( "aud_adventure1_mus" );
    --SoundEnv( "aud_wingedbookext_flashback_1_env", -1 )
    ld.Lock( 0 )
    int_blackbartext.Hide()
    SoundSfx( "aud_clk_storycave_cave" )
    vid_play( 1 )
    interface.DialogStoryShow( "dlg_cave_flashback", "str_storycave_vid_flashback_1", func_step_2, func_end, 0.5 )
    vid_ended = false
  end;

 -- local cur_room = GetCurrentRoom();
 -- ObjAttach("dlg_wingetbook_flashback",cur_room);

  local func_step_0 = function()
    SoundEnvHide(1);
    --ld.Lock(1);
    --common_impl.HideComplexItem();
    ld.StartTimer( 0.5, function()  SoundTheme( "aud_flashback_mus",1 ); func_step_1();  end );
    --SoundTheme( "aud_flashback_mus", 1 )
  end;
  
  ld.Lock(1);
  --func_step_0();
  SoundSfx( "aud_turn_page_1" );
  ld.AnimPlay( "anm_stalactites_anm_door", "big_parcel2", function() ld.CloseSubRoom(); func_step_0(); end );
  --ld.StartTimer( 0.3, func_step_0 );
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_threechimeras" ) and not ld.CheckRequirements( { "win_threeheads" } ) then  
     private.win_threeheads_reset()
  end;

  if ( mg_name == "zz_stalactites" ) and not ld.CheckRequirements( { "win_diamonds" } ) then  
    private.win_diamonds_reset()
  end; 
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_threechimeras" ) and not ld.CheckRequirements( { "win_threeheads" } ) then  
    private.win_threeheads_skip()
  end;
  
  if ( mg_name == "zz_stalactites" ) and not ld.CheckRequirements( { "win_diamonds" } ) then  
    private.win_diamonds_skip()
  end;
end



function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_cave();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_cave_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_stalactites" );
  function zz_stalactites.Open()
  end;
  function zz_stalactites.PreOpen()
    if not cmn.IsEventDone("win_diamonds") then 
      private.diamonds_first_init(); 
    end;  
    
    if cmn.IsEventStart("win_diamonds") and not cmn.IsEventDone("win_diamonds") then 
      cmn.MiniGameShow( "diamonds" ); 
      private.init_diamonds()
    end;  
  end;
  function zz_stalactites.PreClose()
  end;
  function zz_stalactites.Close()
    if cmn.IsEventStart("win_diamonds") and not cmn.IsEventDone("win_diamonds") then 
        cmn.MiniGameHide( "diamonds" ); 
     end;  
  end;

  subroom.Define( "zz_basrelief" );
  function zz_basrelief.Open()
  end;
  function zz_basrelief.PreOpen()
  end;
  function zz_basrelief.PreClose()
  end;
  function zz_basrelief.Close()
  end;

  subroom.Define( "zz_threechimeras" );
  function zz_threechimeras.Open()
  end;
  function zz_threechimeras.PreOpen()
    if not cmn.IsEventDone("win_threeheads") then 
      private.threeheads_first_init(); 
    end;  
    
    if cmn.IsEventStart("win_threeheads") and not cmn.IsEventDone("win_threeheads") then 
      cmn.MiniGameShow( "threeheads" ); 
      private.init_threeheads()
    end;  
  end;
  function zz_threechimeras.PreClose()
  end;
  function zz_threechimeras.Close()
    if cmn.IsEventStart("win_threeheads") and not cmn.IsEventDone("win_threeheads") then 
        cmn.MiniGameHide( "threeheads" ); 
     end;  
  end;

  subroom.Define( "zz_lekar" );
  function zz_lekar.Open()
  end;
  function zz_lekar.PreOpen()
  end;
  function zz_lekar.PreClose()
  end;
  function zz_lekar.Close()
  end;
  
end;
--*********************************************************************************************************************