-- name=rm_hut
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hut";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_scarecrow_paper1", "spr_scarecrow_paper","scarecrow_page_clk")  
  --------------------------------------------------------------------------------------------
function private.opn_hut()
  if not ( cmn.IsEventDone( "opn_hut" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_hut" );
      cmn.CallEventHandler( "opn_hut" )
      ld.ShowBbt( "opn_hut" )
      SoundTheme( "aud_danger1_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_hut = function() end;
local opn_hut_logic = function() end;
cmn.AddSubscriber( "opn_hut", opn_hut_logic )
cmn.AddSubscriber( "opn_hut", opn_hut, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_herbs *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_turnherbs" ] = { type = "click", use_place = "gfx_herbs_clk_turnherbs_zone", room = "rm_hut", zz = "zz_herbs", zz_gate = "gzz_hut_herbs" };

private.clk_turnherbs_logic = function()
  if cmn.IsEventDone( "clk_turnherbs" ) then    
    ObjSet( "spr_herbs_nailpuller", { visible = 1, input = 1, active = 1 } )
    
  end
end;
private.clk_turnherbs_beg = function()
  if cmn.IsEventDone( "clk_turnherbs" ) then   
    ObjDelete( "gfx_herbs_clk_turnherbs_zone" );
  end
end;
private.clk_turnherbs_end = function()
  if cmn.IsEventDone( "clk_turnherbs" ) then  
    ObjDelete( "gfx_herbs_clk_turnherbs_zone" ); 
    ObjSet( "gfx_herbs_nailpuller", {visible = 1} );
  
    ObjSet("anm_herbs_turnherbs",{frame=999,animfunc="use_grass3"})
    ObjDelete("spr_hut_grass")
    if common_impl.ZzCompleteCheck("clk_turnherbs") then ObjSet( common_impl.hint["clk_turnherbs"].zz_gate, { visible = 0, input = 0 } ); end;
  elseif ng_global.progress["std"]["clk_turnherbs"].state then
    ObjSet("anm_herbs_turnherbs",{frame=0,animfunc="use_grass"..(ng_global.progress["std"]["clk_turnherbs"].state+1)})
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_turnherbs", private.clk_turnherbs_beg, private.room_objname );
cmn.AddSubscriber( "clk_turnherbs", private.clk_turnherbs_end, private.room_objname );
cmn.AddSubscriber( "clk_turnherbs", private.clk_turnherbs_logic );
cmn.AddSubscriber( "clk_turnherbs_beg", private.clk_turnherbs_beg, private.room_objname );
cmn.AddSubscriber( "clk_turnherbs_end", private.clk_turnherbs_end, private.room_objname );
cmn.AddSubscriber( "clk_turnherbs_end", private.clk_turnherbs_logic );
--------------------------------------------------------------------------------------------
function public.clk_turnherbs()

  local func_end = function()
    ng_global.progress["std"]["clk_turnherbs"].state = ng_global.progress["std"]["clk_turnherbs"].state + 1    
    if ng_global.progress["std"]["clk_turnherbs"].state == 3 then
      cmn.SetEventDone( "clk_turnherbs" );
    end
    cmn.CallEventHandler( "clk_turnherbs_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_turnherbs") then ld.CloseSubRoom() end;
  end;
  if not ng_global.progress["std"]["clk_turnherbs"].state then 
    ng_global.progress["std"]["clk_turnherbs"].state = 0
    cmn.SetEventStart("clk_turnherbs")
  end
  local num = ng_global.progress["std"]["clk_turnherbs"].state + 1
  cmn.CallEventHandler( "clk_turnherbs_beg" );
  common_impl.Lock(1);
  ld.AnimPlay( "anm_herbs_turnherbs", "use_grass"..num, func_end );

  SoundSfx( "aud_clk_turnherbs_hut" )  
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_nailpuller" ] = { type = "get", get_obj = "spr_herbs_nailpuller", room = "rm_hut", zz = "zz_herbs", zz_gate = "gzz_hut_herbs" };

private.get_nailpuller_logic = function()
  
end;
private.get_nailpuller_inv = function()
  interface.InventoryItemAdd("inv_nailpuller","spr_herbs_nailpuller");
end;
private.get_nailpuller_beg = function()
  ObjDelete("gfx_herbs_nailpuller")
end;
private.get_nailpuller_end = function()
  ObjDelete("spr_herbs_sh_nailpuller")
  if common_impl.ZzCompleteCheck("get_nailpuller") then ObjSet( common_impl.hint["get_nailpuller"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_inv );
cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_beg, private.room_objname );
cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_end, private.room_objname );
cmn.AddSubscriber( "get_nailpuller", private.get_nailpuller_logic );
--------------------------------------------------------------------
function public.get_nailpuller()
  cmn.SetEventDone( "get_nailpuller" );
  cmn.CallEventHandler( "get_nailpuller" );
  if common_impl.ZzCompleteCheck("get_nailpuller") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_plummet" ] = { type = "use", inv_obj = "inv_plummet", use_place = "gfx_herbs_plummet_zone", room = "rm_hut", zz = "zz_herbs", zz_gate = "gzz_hut_herbs" };

private.use_plummet_logic = function()
  ObjSet( "spr_herbs_poisonspice", { visible = 1, input = 1, active = 1 } )

end;
private.use_plummet_inv = function()
  common_impl.ProcessMultiUseAll("plummet", "plummet")
end;
private.use_plummet_beg = function()
  ObjDelete( "gfx_herbs_plummet_zone" );
end;
private.use_plummet_end = function()
  ObjSet( "gfx_herbs_poisonspice", {visible = 1} );
  ObjSet("anm_herbs_scales",{frame=999,animfunc="use_scales2"})
  ObjDelete("spr_hut_close")
  ObjSet( "spr_hut_open", {alp = 1} );
  ObjSet( "spr_hut_weight", {alp = 1} );  
  if common_impl.ZzCompleteCheck("use_plummet") then ObjSet( common_impl.hint["use_plummet"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_plummet", private.use_plummet_inv );
cmn.AddSubscriber( "use_plummet", private.use_plummet_beg, private.room_objname );
cmn.AddSubscriber( "use_plummet", private.use_plummet_end, private.room_objname );
cmn.AddSubscriber( "use_plummet", private.use_plummet_logic );
cmn.AddSubscriber( "use_plummet_inv", private.use_plummet_inv, private.room_objname );
cmn.AddSubscriber( "use_plummet_beg", private.use_plummet_beg, private.room_objname );
cmn.AddSubscriber( "use_plummet_end", private.use_plummet_end, private.room_objname );
cmn.AddSubscriber( "use_plummet_end", private.use_plummet_logic );
--------------------------------------------------------------------------------------------
function public.use_plummet( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_plummet" );
    cmn.CallEventHandler( "use_plummet_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_plummet") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_plummet_inv" );
  cmn.CallEventHandler( "use_plummet_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_herbs_scales", "use_scales2", func_end );
  SoundSfx( "aud_use_plummet_hut" )


end;
--------------------------------------------------------------------------------------------
function public.anim_poisonspice()
  local f_end = function ()
    private.anim_poisonspice_zoom = true
    ld.Lock(0) 
    ObjSet( "spr_herbs_poisonspice", {input = 0} );
    ObjSet( "spr_herbs_poisonspice_big", {input = 1} );
      ld.ShowBbt("herbs_note_clk");
    common_impl.hint[ "get_poisonspice" ]["get_obj"] = "spr_herbs_poisonspice_big"
  end
  ld.Lock(1)
  ObjAnimate( "spr_herbs_sh_poisonspice", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  ObjAnimate( "spr_herbs_poisonspice", "alp", 0, 0, "",{0,0,1, 0.5,0,0} );
  ObjAnimate( "spr_herbs_poisonspice_big", 8, 0, 0, "", {0,0,0, 0.5,0,1} );
  ObjAnimate( "spr_herbs_poisonspice_big", "pos_xy", 0, 0, "",{
    0.0, 3, ObjGet("spr_herbs_poisonspice_big").pos_x, ObjGet("spr_herbs_poisonspice_big").pos_y,0.5, 3, 0,0
  } );
  ObjAnimate( "spr_herbs_poisonspice_big", "scale_xy", 0, 0, f_end,{0.0, 3, 0.6, 0.6, 0.5, 3, 1, 1} ); 
  
  
end

--------------------------------------------------------------------
common_impl.hint[ "get_poisonspice" ] = { type = "get", get_obj = "spr_herbs_poisonspice", room = "rm_hut", zz = "zz_herbs", zz_gate = "gzz_hut_herbs" };

private.get_poisonspice_logic = function()
  

end;
private.get_poisonspice_inv = function()
  interface.InventoryItemAdd("inv_poisonspice","spr_herbs_poisonspice_big");

end;
private.get_poisonspice_beg = function()
  ObjDelete("gfx_herbs_poisonspice")
end;
private.get_poisonspice_end = function()
  ObjDelete("spr_herbs_poisonspice")  
  ObjDelete("spr_herbs_sh_poisonspice")
  if common_impl.ZzCompleteCheck("get_poisonspice") then ObjSet( common_impl.hint["get_poisonspice"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_poisonspice", private.get_poisonspice_inv );
cmn.AddSubscriber( "get_poisonspice", private.get_poisonspice_beg, private.room_objname );
cmn.AddSubscriber( "get_poisonspice", private.get_poisonspice_end, private.room_objname );
cmn.AddSubscriber( "get_poisonspice", private.get_poisonspice_logic );
--------------------------------------------------------------------
function public.get_poisonspice()
  cmn.SetEventDone( "get_poisonspice" );
  cmn.CallEventHandler( "get_poisonspice" );
  if common_impl.ZzCompleteCheck("get_poisonspice") then ld.CloseSubRoom() end;

end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_utilityroom *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_nailpuller" ] = { type = "use", inv_obj = "inv_nailpuller", use_place = "gfx_utilityroom_nailpuller_zone", room = "rm_hut", zz = "zz_utilityroom", zz_gate = "gzz_hut_utilityroom" };

private.use_nailpuller_logic = function()
  ObjSet( "gfx_utilityroom_clk_nailboard_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_nailpuller_inv = function()
  common_impl.ProcessMultiUseAll("nailpuller", "nailpuller")
end;
private.use_nailpuller_beg = function()
  ObjDelete( "gfx_utilityroom_nailpuller_zone" );
end;
private.use_nailpuller_end = function()
  ObjSet("anm_utilityroom_use_nailpuller",{animfunc="click_board",frame=0})
  if common_impl.ZzCompleteCheck("use_nailpuller") then ObjSet( common_impl.hint["use_nailpuller"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_inv );
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_beg, private.room_objname );
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_end, private.room_objname );
cmn.AddSubscriber( "use_nailpuller", private.use_nailpuller_logic );
cmn.AddSubscriber( "use_nailpuller_inv", private.use_nailpuller_inv, private.room_objname );
cmn.AddSubscriber( "use_nailpuller_beg", private.use_nailpuller_beg, private.room_objname );
cmn.AddSubscriber( "use_nailpuller_end", private.use_nailpuller_end, private.room_objname );
cmn.AddSubscriber( "use_nailpuller_end", private.use_nailpuller_logic );
--------------------------------------------------------------------------------------------
function public.use_nailpuller( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_nailpuller" );
    cmn.CallEventHandler( "use_nailpuller_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_nailpuller") then ld.CloseSubRoom() end;
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_nailpuller_inv" );
  cmn.CallEventHandler( "use_nailpuller_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_utilityroom_use_nailpuller", "use_nailpuller", func_end );
  SoundSfx( "aud_use_nailpuller_hut" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_nailboard" ] = { type = "click", use_place = "gfx_utilityroom_clk_nailboard_zone", room = "rm_hut", zz = "zz_utilityroom", zz_gate = "gzz_hut_utilityroom" };

private.clk_nailboard_logic = function()
  ObjSet( "spr_utilityroom_goldcrow1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_utilityroom_hammer", { visible = 1, input = 1, active = 1 } )

end;
private.clk_nailboard_beg = function()
  ObjDelete( "gfx_utilityroom_clk_nailboard_zone" );
end;
private.clk_nailboard_end = function()
  ObjSet("anm_utilityroom_use_nailpuller",{animfunc="click_board",frame=999})
  ObjSet( "gfx_utilityroom_goldcrow1", {visible = 1} );
    ObjSet( "gfx_utilityroom_hammer", {visible = 1} );    
  ObjDelete("spr_hut_board")
  if common_impl.ZzCompleteCheck("clk_nailboard") then ObjSet( common_impl.hint["clk_nailboard"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_nailboard", private.clk_nailboard_beg, private.room_objname );
cmn.AddSubscriber( "clk_nailboard", private.clk_nailboard_end, private.room_objname );
cmn.AddSubscriber( "clk_nailboard", private.clk_nailboard_logic );
cmn.AddSubscriber( "clk_nailboard_beg", private.clk_nailboard_beg, private.room_objname );
cmn.AddSubscriber( "clk_nailboard_end", private.clk_nailboard_end, private.room_objname );
cmn.AddSubscriber( "clk_nailboard_end", private.clk_nailboard_logic );
--------------------------------------------------------------------------------------------
function public.clk_nailboard()

  local func_end = function()
    cmn.SetEventDone( "clk_nailboard" );
    cmn.CallEventHandler( "clk_nailboard_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_nailboard") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_nailboard_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_utilityroom_use_nailpuller", "click_board", func_end );
  SoundSfx( "aud_touch_desk_hut" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goldcrow1" ] = { type = "get", get_obj = "spr_utilityroom_goldcrow1", room = "rm_hut", zz = "zz_utilityroom", zz_gate = "gzz_hut_utilityroom" };

private.get_goldcrow1_logic = function()
  
end;
private.get_goldcrow1_inv = function()
  interface.InventoryItemAdd("inv_goldcrow","spr_utilityroom_goldcrow1",function() level_inv.ProcessGetGoldcrowAll( "get_goldcrow1" ) end);
end;
private.get_goldcrow1_beg = function()
  ObjDelete("gfx_utilityroom_goldcrow1")
end;
private.get_goldcrow1_end = function()
  ObjDelete("spr_utilityroom_sh_goldcrow1")
  if common_impl.ZzCompleteCheck("get_goldcrow1") then ObjSet( common_impl.hint["get_goldcrow1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_goldcrow1", private.get_goldcrow1_inv );
cmn.AddSubscriber( "get_goldcrow1", private.get_goldcrow1_beg, private.room_objname );
cmn.AddSubscriber( "get_goldcrow1", private.get_goldcrow1_end, private.room_objname );
cmn.AddSubscriber( "get_goldcrow1", private.get_goldcrow1_logic );
--------------------------------------------------------------------
function public.get_goldcrow1()
  cmn.SetEventDone( "get_goldcrow1" );
  cmn.CallEventHandler( "get_goldcrow1" );
  if common_impl.ZzCompleteCheck("get_goldcrow1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hammer" ] = { type = "get", get_obj = "spr_utilityroom_hammer", room = "rm_hut", zz = "zz_utilityroom", zz_gate = "gzz_hut_utilityroom" };

private.get_hammer_logic = function()
  
end;
private.get_hammer_inv = function()
  interface.InventoryItemAdd("inv_hammer","spr_utilityroom_hammer");
end;
private.get_hammer_beg = function()
  ObjDelete("gfx_utilityroom_hammer")
end;
private.get_hammer_end = function()
  ObjDelete("spr_utilityroom_sh_hammer")  
  if common_impl.ZzCompleteCheck("get_hammer") then ObjSet( common_impl.hint["get_hammer"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_hammer", private.get_hammer_inv );
cmn.AddSubscriber( "get_hammer", private.get_hammer_beg, private.room_objname );
cmn.AddSubscriber( "get_hammer", private.get_hammer_end, private.room_objname );
cmn.AddSubscriber( "get_hammer", private.get_hammer_logic );
--------------------------------------------------------------------
function public.get_hammer()
  cmn.SetEventDone( "get_hammer" );
  cmn.CallEventHandler( "get_hammer" );
  if common_impl.ZzCompleteCheck("get_hammer") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_breakhandle" ] = { type = "click", use_place = "gfx_utilityroom_clk_breakhandle_zone", room = "rm_hut", zz = "zz_utilityroom", zz_gate = "gzz_hut_utilityroom" };

private.clk_breakhandle_logic = function()
  ObjSet( "gfx_utilityroom_ironhandle_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_breakhandle_beg = function()
  ObjDelete( "gfx_utilityroom_clk_breakhandle_zone" );
end;
private.clk_breakhandle_end = function()
  ObjSet("anm_utilityroom_handle",{animfunc="idle_door",frame=0})
  ObjDelete("spr_hut_doorpen")
  if common_impl.ZzCompleteCheck("clk_breakhandle") then ObjSet( common_impl.hint["clk_breakhandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_breakhandle", private.clk_breakhandle_beg, private.room_objname );
cmn.AddSubscriber( "clk_breakhandle", private.clk_breakhandle_end, private.room_objname );
cmn.AddSubscriber( "clk_breakhandle", private.clk_breakhandle_logic );
cmn.AddSubscriber( "clk_breakhandle_beg", private.clk_breakhandle_beg, private.room_objname );
cmn.AddSubscriber( "clk_breakhandle_end", private.clk_breakhandle_end, private.room_objname );
cmn.AddSubscriber( "clk_breakhandle_end", private.clk_breakhandle_logic );
--------------------------------------------------------------------------------------------
function public.clk_breakhandle()

  local func_end = function()
    cmn.SetEventDone( "clk_breakhandle" );
    cmn.CallEventHandler( "clk_breakhandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_breakhandle") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_breakhandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_utilityroom_handle", "idle_doorpen", func_end );
  SoundSfx( "aud_clk_breakhandle_hut" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ironhandle" ] = { type = "use", inv_obj = "inv_ironhandle", use_place = "gfx_utilityroom_ironhandle_zone", room = "rm_hut", zz = "zz_utilityroom", zz_gate = "gzz_hut_utilityroom" };

private.use_ironhandle_logic = function()
  ObjSet( "gho_hut_utilityroomho", { visible = 1, input = 1, active = 1 } )
end;
private.use_ironhandle_inv = function()
  common_impl.ProcessMultiUseAll("ironhandle", "ironhandle")
end;
private.use_ironhandle_beg = function()
  ObjDelete( "gfx_utilityroom_ironhandle_zone" );
end;
private.use_ironhandle_end = function()
  ObjSet( "spr_hut_open_door", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_ironhandle") then ObjSet( common_impl.hint["use_ironhandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ironhandle", private.use_ironhandle_inv );
cmn.AddSubscriber( "use_ironhandle", private.use_ironhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_ironhandle", private.use_ironhandle_end, private.room_objname );
cmn.AddSubscriber( "use_ironhandle", private.use_ironhandle_logic );
cmn.AddSubscriber( "use_ironhandle_inv", private.use_ironhandle_inv, private.room_objname );
cmn.AddSubscriber( "use_ironhandle_beg", private.use_ironhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_ironhandle_end", private.use_ironhandle_end, private.room_objname );
cmn.AddSubscriber( "use_ironhandle_end", private.use_ironhandle_logic );
--------------------------------------------------------------------------------------------
function public.use_ironhandle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ironhandle" );
    cmn.CallEventHandler( "use_ironhandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ironhandle") then ld.CloseSubRoom() ld.StartTimer( 0.3, function() SoundSfx( "aud_touch_ironhandle_hut" );  end ) end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ironhandle_inv" );
  cmn.CallEventHandler( "use_ironhandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_utilityroom_handle", "use_doorpen", func_end );
  SoundSfx( "aud_use_ironhandle_hut" )


end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_scarecrow *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_goldcrow2" ] = { type = "get", get_obj = "spr_scarecrow_goldcrow2", room = "rm_hut", zz = "zz_scarecrow", zz_gate = "gzz_hut_scarecrow" };

private.get_goldcrow2_logic = function()
  
end;
private.get_goldcrow2_inv = function()
  interface.InventoryItemAdd("inv_goldcrow","spr_scarecrow_goldcrow2",function() level_inv.ProcessGetGoldcrowAll( "get_goldcrow2" ) end);
end;
private.get_goldcrow2_beg = function()
  ObjDelete("gfx_scarecrow_goldcrow2")
end;
private.get_goldcrow2_end = function()
  ObjDelete("spr_scarecrow_sh_goldcrow2")
  ObjDelete("spr_hut_tr_crow")
  ObjSet( "spr_scarecrow_paper1", {input = 1, visible = 1} );
  if common_impl.ZzCompleteCheck("get_goldcrow2") then ObjSet( common_impl.hint["get_goldcrow2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_goldcrow2", private.get_goldcrow2_inv );
cmn.AddSubscriber( "get_goldcrow2", private.get_goldcrow2_beg, private.room_objname );
cmn.AddSubscriber( "get_goldcrow2", private.get_goldcrow2_end, private.room_objname );
cmn.AddSubscriber( "get_goldcrow2", private.get_goldcrow2_logic );
--------------------------------------------------------------------
function public.get_goldcrow2()
  cmn.SetEventDone( "get_goldcrow2" );
  cmn.CallEventHandler( "get_goldcrow2" );
  if common_impl.ZzCompleteCheck("get_goldcrow2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_yellowring" ] = { type = "use", inv_obj = "inv_yellowring", use_place = "gfx_scarecrow_yellowring_zone", room = "rm_hut", zz = "zz_scarecrow", zz_gate = "gzz_hut_scarecrow" };

private.use_yellowring_logic = function()
  ObjSet( "spr_scarecrow_wedge", {input = 1, active = 1 } )

end;
private.use_yellowring_inv = function()
  common_impl.ProcessMultiUseAll("yellowring", "yellowring")
end;
private.use_yellowring_beg = function()
  ObjDelete( "gfx_scarecrow_yellowring_zone" );
end;
private.use_yellowring_end = function()
  ObjSet("anm_scarecrow_hand",{animfunc="use_hand",frame=999})
  ObjSet("gfx_scarecrow_wedge",{visible=1})
  ObjSet( "spr_hut_tr_hand", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_yellowring") then ObjSet( common_impl.hint["use_yellowring"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_yellowring", private.use_yellowring_inv );
cmn.AddSubscriber( "use_yellowring", private.use_yellowring_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowring", private.use_yellowring_end, private.room_objname );
cmn.AddSubscriber( "use_yellowring", private.use_yellowring_logic );
cmn.AddSubscriber( "use_yellowring_inv", private.use_yellowring_inv, private.room_objname );
cmn.AddSubscriber( "use_yellowring_beg", private.use_yellowring_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowring_end", private.use_yellowring_end, private.room_objname );
cmn.AddSubscriber( "use_yellowring_end", private.use_yellowring_logic );
--------------------------------------------------------------------------------------------
function public.use_yellowring( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_yellowring" );
    cmn.CallEventHandler( "use_yellowring_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_yellowring") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_yellowring_inv" );
  cmn.CallEventHandler( "use_yellowring_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_scarecrow_hand", "use_hand", func_end );
  SoundSfx( "aud_use_yellowring_hut" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wedge" ] = { type = "get", get_obj = "spr_scarecrow_wedge", room = "rm_hut", zz = "zz_scarecrow", zz_gate = "gzz_hut_scarecrow" };

private.get_wedge_logic = function()
  
end;
private.get_wedge_inv = function()
  interface.InventoryItemAdd("inv_wedge","spr_scarecrow_wedge");
end;
private.get_wedge_beg = function()
  ObjDelete("gfx_scarecrow_wedge")
end;
private.get_wedge_end = function()
  ObjSet("spr_scarecrow_wedge",{visible=1})
  ObjSet("anm_scarecrow_hand",{animfunc="end_hand",frame=0})  
  if common_impl.ZzCompleteCheck("get_wedge") then ObjSet( common_impl.hint["get_wedge"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_wedge", private.get_wedge_inv );
cmn.AddSubscriber( "get_wedge", private.get_wedge_beg, private.room_objname );
cmn.AddSubscriber( "get_wedge", private.get_wedge_end, private.room_objname );
cmn.AddSubscriber( "get_wedge", private.get_wedge_logic );
--------------------------------------------------------------------
function public.get_wedge()
  cmn.SetEventDone( "get_wedge" );
  cmn.CallEventHandler( "get_wedge" );
  if common_impl.ZzCompleteCheck("get_wedge") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_clip_scarecrow" ] = { type = "use", inv_obj = "inv_clip", use_place = "gfx_scarecrow_clip_scarecrow_zone", room = "rm_hut", zz = "zz_scarecrow", zz_gate = "gzz_hut_scarecrow" };

private.use_clip_scarecrow_logic = function()
  ObjSet( "spr_scarecrow_medallionedward", {  input = 1, active = 1 } )

end;
private.use_clip_scarecrow_inv = function()
  common_impl.ProcessMultiUseAll("clip", "clip_scarecrow")
end;
private.use_clip_scarecrow_beg = function()
  ObjDelete( "gfx_scarecrow_clip_scarecrow_zone" );
end;
private.use_clip_scarecrow_end = function()
  ObjSet("anm_scarecrow_close",{animfunc= "use_close",frame=999})
  ObjSet("gfx_scarecrow_medallionedward",{visible=1})
  if common_impl.ZzCompleteCheck("use_clip_scarecrow") then ObjSet( common_impl.hint["use_clip_scarecrow"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_clip_scarecrow", private.use_clip_scarecrow_inv );
cmn.AddSubscriber( "use_clip_scarecrow", private.use_clip_scarecrow_beg, private.room_objname );
cmn.AddSubscriber( "use_clip_scarecrow", private.use_clip_scarecrow_end, private.room_objname );
cmn.AddSubscriber( "use_clip_scarecrow", private.use_clip_scarecrow_logic );
cmn.AddSubscriber( "use_clip_scarecrow_inv", private.use_clip_scarecrow_inv, private.room_objname );
cmn.AddSubscriber( "use_clip_scarecrow_beg", private.use_clip_scarecrow_beg, private.room_objname );
cmn.AddSubscriber( "use_clip_scarecrow_end", private.use_clip_scarecrow_end, private.room_objname );
cmn.AddSubscriber( "use_clip_scarecrow_end", private.use_clip_scarecrow_logic );
--------------------------------------------------------------------------------------------
function public.use_clip_scarecrow( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_clip_scarecrow" );
    cmn.CallEventHandler( "use_clip_scarecrow_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_clip_scarecrow") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_clip_scarecrow_inv" );
  cmn.CallEventHandler( "use_clip_scarecrow_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_scarecrow_close", "use_close", func_end );
  SoundSfx( "aud_use_clip_scarecrow" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_medallionedward" ] = { type = "get", get_obj = "spr_scarecrow_medallionedward", room = "rm_hut", zz = "zz_scarecrow", zz_gate = "gzz_hut_scarecrow" };

private.get_medallionedward_logic = function()
  
end;
private.get_medallionedward_inv = function()
  interface.InventoryItemAdd("inv_medallionedward","spr_scarecrow_medallionedward");
  ObjSet( "inv_medallionedward", { drag = 0 } );
end;
private.get_medallionedward_beg = function()
  ObjDelete("gfx_scarecrow_medallionedward")
end;
private.get_medallionedward_end = function()
  ObjSet("spr_scarecrow_medallionedward",{visible=1})  
  ObjSet("anm_scarecrow_close",{animfunc= "end_open",frame=0})  
  if common_impl.ZzCompleteCheck("get_medallionedward") then ObjSet( common_impl.hint["get_medallionedward"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_medallionedward", private.get_medallionedward_inv );
cmn.AddSubscriber( "get_medallionedward", private.get_medallionedward_beg, private.room_objname );
cmn.AddSubscriber( "get_medallionedward", private.get_medallionedward_end, private.room_objname );
cmn.AddSubscriber( "get_medallionedward", private.get_medallionedward_logic );
--------------------------------------------------------------------
function public.get_medallionedward()
  cmn.SetEventDone( "get_medallionedward" );
  cmn.CallEventHandler( "get_medallionedward" );
  if common_impl.ZzCompleteCheck("get_medallionedward") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_utilityroomho_for_hut = function()
    if ld.CheckRequirements( {"win_utilityroomho"} ) then
      ObjSet( "gho_hut_utilityroomho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_utilityroomho", win_utilityroomho_for_hut, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_hut();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_hut_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_scarecrow" );
  function zz_scarecrow.Open()
  end;
  function zz_scarecrow.PreOpen()
  end;
  function zz_scarecrow.PreClose()
  end;
  function zz_scarecrow.Close()
  end;

  subroom.Define( "zz_utilityroom" );
  function zz_utilityroom.Open()
  end;
  function zz_utilityroom.PreOpen()
  end;
  function zz_utilityroom.PreClose()
  end;
  function zz_utilityroom.Close()
  end;

  subroom.Define( "zz_herbs" );
  function zz_herbs.Open()
  end;
  function zz_herbs.PreOpen()
  end;
  function zz_herbs.PreClose()
    if private.anim_poisonspice_zoom and not cmn.IsEventDone("get_poisonspice") then
      public.get_poisonspice()
    end
  end;
  function zz_herbs.Close()
  end;
  
end;
--*********************************************************************************************************************