-- name=rm_livingroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_livingroom";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  
  ld.NoteInit("spr_globe_text", "spr_globe_text_big","globe_text")
    -- ld.NoteRelaseLock( "spr_globe_text" )
  --------------------------------------------------------------------------------------------
function private.opn_livingroom()
  if not ( cmn.IsEventDone( "opn_livingroom" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_livingroom" );
      cmn.CallEventHandler( "opn_livingroom" )
      ld.ShowBbtOpn( private.room_objname )
      SoundTheme( "aud_adventure2_mus" );
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_livingroom = function() end;
local opn_livingroom_logic = function() end;
cmn.AddSubscriber( "opn_livingroom", opn_livingroom_logic )
cmn.AddSubscriber( "opn_livingroom", opn_livingroom, private.room_objname )

function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "lady1" then
    if count_txt == 1 then
      
    elseif count_txt == 2 then    
      
    elseif count_txt == 3 then 
      
    end;  
   
  elseif dlg_name == "lady2" then
    if count_txt == 1 then
      
    elseif count_txt == 2 then      
      
    end;  
  end
end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_livingroom_lady1" ] = { type = "click", use_place = "gfx_livingroom_dlg_livingroom_lady1_zone", room = "rm_livingroom" };

private.dlg_livingroom_lady1_logic = function()
  ObjSet( "gfx_livingroom_teddybear_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_livingroom_toyhouse", {input = 1, visible = 1} );
  ObjSet( "gzz_livingroom_globe", {input = 1, visible = 1} );
  ObjSet( "gzz_livingroom_cell", {input = 1, visible = 1} );
  ObjSet( "gzz_livingroom_balconyexit", {input = 1, visible = 1} );
end;
private.dlg_livingroom_lady1_beg = function()
  ObjDelete( "gfx_livingroom_dlg_livingroom_lady1_zone" );
end;
private.dlg_livingroom_lady1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_livingroom_lady1", private.dlg_livingroom_lady1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady1", private.dlg_livingroom_lady1_end, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady1", private.dlg_livingroom_lady1_logic );
cmn.AddSubscriber( "dlg_livingroom_lady1_beg", private.dlg_livingroom_lady1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady1_end", private.dlg_livingroom_lady1_end, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady1_end", private.dlg_livingroom_lady1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_livingroom_lady1(obj)
  local func_end = function()
    cmn.SetEventDone( "dlg_livingroom_lady1" );
    cmn.CallEventHandler( "dlg_livingroom_lady1_end" );
    common_impl.Lock(0);
    --ld.ShowBbt("")
  end;
  
  function public.dlg_livingroom_lady1_end()
    ObjSet( "dlg_livingroom_lady1", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_livingroom_lady1_beg" );
 
  common_impl.dialog_character_loc = "anim_livingroom_anim_lady"
  common_impl.continue_visible = false;
  common_impl.Start( "lady1", 4, nil, nil, true, "dlg_livingroom_lady1_end",{"aud_lady_lankerman_1_voc","aud_lady_lankerman_2_voc","aud_lady_lankerman_3_voc"} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_teddybear" ] = { type = "use", inv_obj = "inv_teddybear", use_place = "gfx_livingroom_teddybear_zone", room = "rm_livingroom" };

private.use_teddybear_logic = function()
  ObjSet( "gfx_livingroom_dlg_livingroom_lady2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_teddybear_inv = function()
  common_impl.ProcessMultiUseAll("teddybear", "teddybear")
end;
private.use_teddybear_beg = function()
  ObjDelete( "gfx_livingroom_teddybear_zone" );
end;
private.use_teddybear_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_teddybear", private.use_teddybear_inv );
cmn.AddSubscriber( "use_teddybear", private.use_teddybear_beg, private.room_objname );
cmn.AddSubscriber( "use_teddybear", private.use_teddybear_end, private.room_objname );
cmn.AddSubscriber( "use_teddybear", private.use_teddybear_logic );
cmn.AddSubscriber( "use_teddybear_inv", private.use_teddybear_inv, private.room_objname );
cmn.AddSubscriber( "use_teddybear_beg", private.use_teddybear_beg, private.room_objname );
cmn.AddSubscriber( "use_teddybear_end", private.use_teddybear_end, private.room_objname );
cmn.AddSubscriber( "use_teddybear_end", private.use_teddybear_logic );
--------------------------------------------------------------------------------------------
function public.use_teddybear( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_teddybear" );
    cmn.CallEventHandler( "use_teddybear_end" );
    common_impl.Lock(0);
    public.dlg_livingroom_lady2();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_teddybear_inv" );
  cmn.CallEventHandler( "use_teddybear_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_teddybear_livingroom" )
  ld.StartTimer( 0.5, func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_livingroom_lady2" ] = { type = "click", use_place = "gfx_livingroom_dlg_livingroom_lady2_zone", room = "rm_livingroom" };

private.dlg_livingroom_lady2_logic = function()
  ObjSet( "grm_livingroom_bedroomboy", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_livingroom_bedroomboy_focus");
  end;
  --  ObjSet( "gzz_livingroom_tocellar", {active = 1, input = 1, visible = 1} );
end;
private.dlg_livingroom_lady2_beg = function()
  ObjDelete( "gfx_livingroom_dlg_livingroom_lady2_zone" );
end;
private.dlg_livingroom_lady2_end = function()
  ObjDelete("anim_livingroom_anim_lady");  
  ObjDelete("spr_livingroom_tr_ladder")
  -- ObjDelete("obj_livingroom_cellar_clk_zone")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_livingroom_lady2", private.dlg_livingroom_lady2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady2", private.dlg_livingroom_lady2_end, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady2", private.dlg_livingroom_lady2_logic );
cmn.AddSubscriber( "dlg_livingroom_lady2_beg", private.dlg_livingroom_lady2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady2_end", private.dlg_livingroom_lady2_end, private.room_objname );
cmn.AddSubscriber( "dlg_livingroom_lady2_end", private.dlg_livingroom_lady2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_livingroom_lady2(obj)

   local func_end = function()
    cmn.SetEventDone( "dlg_livingroom_lady2" );
    cmn.CallEventHandler( "dlg_livingroom_lady2_end" );
    common_impl.Lock(0);
    --ld.ShowBbt("")
  end;

  cmn.CallEventHandler( "dlg_livingroom_lady2_beg" );
  
  function public.dlg_livingroom_lady2_end()
    ObjSet( "dlg_livingroom_lady2", {bake=1} );
    common_impl.Lock(1);
    func_end()
    
    
  end
  
  cmn.CallEventHandler( "dlg_livingroom_lady2_beg" );
  
  -- common_impl.dialog_character_loc = "anim_livingroom_anim_lady"
  ObjAnimate( "anim_livingroom_anim_lady", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  common_impl.continue_visible = false;
 
  common_impl.Start( "lady2", 2, nil, nil, true, "dlg_livingroom_lady2_end",{"aud_lady_lankerman_4_voc"});    
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_incellaranm" ] = { type = "click", use_place = "gfx_livingroom_clk_incellaranm_zone", room = "rm_livingroom" };

private.clk_incellaranm_logic = function()
  ObjSet("gzz_livingroom_tocellar", { visible = 1, input = 1, active = 1 }) 
  
end;
private.clk_incellaranm_beg = function()
  ObjDelete( "gfx_livingroom_clk_incellaranm_zone" );
end;
private.clk_incellaranm_end = function()
  ObjDelete("anm_livingroom_anm_door");
  ObjSet( "obj_livingroom_tocellar_tr_root", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_incellaranm", private.clk_incellaranm_beg, private.room_objname );
cmn.AddSubscriber( "clk_incellaranm", private.clk_incellaranm_end, private.room_objname );
cmn.AddSubscriber( "clk_incellaranm", private.clk_incellaranm_logic );
cmn.AddSubscriber( "clk_incellaranm_beg", private.clk_incellaranm_beg, private.room_objname );
cmn.AddSubscriber( "clk_incellaranm_end", private.clk_incellaranm_end, private.room_objname );
cmn.AddSubscriber( "clk_incellaranm_end", private.clk_incellaranm_logic );
--------------------------------------------------------------------------------------------
function public.clk_incellaranm()

  local func_end = function()
    cmn.SetEventDone( "clk_incellaranm" );
    cmn.CallEventHandler( "clk_incellaranm_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_anmtocellar");
    SoundTheme( "aud_danger_moment3_mus" );
  end;

  cmn.CallEventHandler( "clk_incellaranm_beg" );
  common_impl.Lock(1);

  ld.StartTimer(1.5,function() ld.AnimPlay( "anm_livingroom_anm_door", "door", function() end );end);
  SoundSfx( "aud_clk_incellaranm_livingroom" )
  --  func_end()
  ObjAnimate( "rm_livingroom", 6, 0, 0, func_end, {0,0,1,1, 0.8,0,1,1, 1.8,0,1.2,1.2, 3,0,1.2,1.2, 4,0,1,1} );
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_balconyexit *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_code" ] = { type = "get", get_obj = "spr_balconyexit_code", room = "rm_livingroom", zz = "zz_balconyexit", zz_gate = "gzz_livingroom_balconyexit" };

private.get_code_logic = function()
  
end;
private.get_code_inv = function()
  interface.InventoryItemAdd("inv_code","spr_balconyexit_code");
end;
private.get_code_beg = function()
  ObjDelete("gfx_balconyexit_code")
end;
private.get_code_end = function()
  if common_impl.ZzCompleteCheck("get_code") then ObjSet( common_impl.hint["get_code"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_balconyexit_sh_cod");
end;

cmn.AddSubscriber( "get_code", private.get_code_inv );
cmn.AddSubscriber( "get_code", private.get_code_beg, private.room_objname );
cmn.AddSubscriber( "get_code", private.get_code_end, private.room_objname );
cmn.AddSubscriber( "get_code", private.get_code_logic );
--------------------------------------------------------------------
function public.get_code()
  cmn.SetEventDone( "get_code" );
  cmn.CallEventHandler( "get_code" );
  if common_impl.ZzCompleteCheck("get_code") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_plate1_zone_clk()  --rm_livingroom.use_plate1_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_plate1' );
  end;  
  
  if cmn.IsEventDone("get_code") and not cmn.IsEventDone("use_plate2") then
    ld.Lock(1);    
    SoundSfx( "aud_touch_balcony_door_livingroom" );
    ld.AnimPlay( "anm_balconyexit_anm_balconyexit", "idle_door", func_end )
  else 
    func_end();
  end;  
end;  

common_impl.hint[ "use_plate1" ] = { type = "use", inv_obj = "inv_plate1", use_place = "gfx_balconyexit_plate1_zone", room = "rm_livingroom", zz = "zz_balconyexit", zz_gate = "gzz_livingroom_balconyexit" };

private.use_plate1_logic = function()
  if ld.CheckRequirements( {"use_plate1","use_plate2"} ) then
    ObjSet( "gmg_livingroom_onbalcony", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_plate1_inv = function()
  common_impl.ProcessMultiUseAll("plate1", "plate1")
end;
private.use_plate1_beg = function()
  ObjDelete( "gfx_balconyexit_plate1_zone" );
end;
private.use_plate1_end = function()
  if common_impl.ZzCompleteCheck("use_plate1") then ObjSet( common_impl.hint["use_plate1"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_plate1","use_plate2"} ) then
    ObjDelete("obj_balconyexit_anm_root");
    ObjSet( "anm_balconyexit_anm_balconyexit", {animfunc = "open_door", frame = 999 } );
    ObjDelete("spr_livingroom_door2");
    ObjDelete("spr_livingroom_door1");
    ObjDelete("spr_livingroom_am1");
    ObjDelete("spr_livingroom_am2"); 
  else 
    ObjSet( "spr_livingroom_am1", {visible = 1} );
    ObjSet( "anm_balconyexit_anm_balconyexit", {visible = 0} );
    ObjSet( "obj_balconyexit_anm_root", {visible = 1} );
    ObjSet( "anm_balconyexit_anm_balconyexit_anm1", {animfunc = "end_am1", frame = 0 } );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_plate1", private.use_plate1_inv );
cmn.AddSubscriber( "use_plate1", private.use_plate1_beg, private.room_objname );
cmn.AddSubscriber( "use_plate1", private.use_plate1_end, private.room_objname );
cmn.AddSubscriber( "use_plate1", private.use_plate1_logic );
cmn.AddSubscriber( "use_plate1_inv", private.use_plate1_inv, private.room_objname );
cmn.AddSubscriber( "use_plate1_beg", private.use_plate1_beg, private.room_objname );
cmn.AddSubscriber( "use_plate1_end", private.use_plate1_end, private.room_objname );
cmn.AddSubscriber( "use_plate1_end", private.use_plate1_logic );
--------------------------------------------------------------------------------------------
function public.use_plate1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_plate1" );
    cmn.CallEventHandler( "use_plate1_end" );
    --common_impl.Lock(0);
    
    if ld.CheckRequirements( {"use_plate1","use_plate2"} ) then
      ld.CloseSubRoom();
      ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_onbalcony" ); end )
    else 
      common_impl.Lock(0);  
      if common_impl.ZzCompleteCheck("use_plate1") then ld.CloseSubRoom() end;
    end;  
    
    
  end;

 local func_preend = function() 
   if cmn.IsEventDone("use_plate1") or  cmn.IsEventDone("use_plate2") then 
      ObjSet( "anm_balconyexit_anm_balconyexit", {visible = 1} );
      ObjSet( "obj_balconyexit_anm_root", {visible = 0} );
      SoundSfx( "aud_touch_plate_livingroom" );
      ld.AnimPlay( "anm_balconyexit_anm_balconyexit", "open_door", func_end )
   else 
      func_end();
   end;  
 end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_plate1_inv" );
  cmn.CallEventHandler( "use_plate1_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_balconyexit_anm_balconyexit", {visible = 0} );
  ObjSet( "obj_balconyexit_anm_root", {visible = 1} );
  ld.AnimPlay( "anm_balconyexit_anm_balconyexit_anm1", "use_am1", func_preend );
  SoundSfx( "aud_use_plate_livingroom" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_plate2_zone_clk()  --rm_livingroom.use_plate2_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_plate2' );
  end;  
  
  if cmn.IsEventDone("get_code") and  not cmn.IsEventDone("use_plate1") then
    ld.Lock(1);
    SoundSfx( "aud_touch_balcony_door_livingroom" );
    ld.AnimPlay( "anm_balconyexit_anm_balconyexit", "idle_door", func_end )
  else 
    func_end();
  end;  
end;  


common_impl.hint[ "use_plate2" ] = { type = "use", inv_obj = "inv_plate2", use_place = "gfx_balconyexit_plate2_zone", room = "rm_livingroom", zz = "zz_balconyexit", zz_gate = "gzz_livingroom_balconyexit" };

private.use_plate2_logic = function()
  if ld.CheckRequirements( {"use_plate2","use_plate1"} ) then
  ObjSet( "gmg_livingroom_onbalcony", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_plate2_inv = function()
  common_impl.ProcessMultiUseAll("plate2", "plate2")
end;
private.use_plate2_beg = function()
  ObjDelete( "gfx_balconyexit_plate2_zone" );
end;
private.use_plate2_end = function()
  if common_impl.ZzCompleteCheck("use_plate2") then ObjSet( common_impl.hint["use_plate2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_plate1","use_plate2"} ) then
    ObjDelete("obj_balconyexit_anm_root");
    ObjSet( "anm_balconyexit_anm_balconyexit", {animfunc = "open_door", frame = 999 } );
    ObjDelete("spr_livingroom_door2");
    ObjDelete("spr_livingroom_door1");
    ObjDelete("spr_livingroom_am1");
    ObjDelete("spr_livingroom_am2"); 
  else 
    ObjSet( "spr_livingroom_am2", {visible = 1} );
    ObjSet( "anm_balconyexit_anm_balconyexit", {visible = 0} );
    ObjSet( "obj_balconyexit_anm_root", {visible = 1} );
    ObjSet( "anm_balconyexit_anm_balconyexit_anm2", {animfunc = "end_am2", frame = 0 } );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_plate2", private.use_plate2_inv );
cmn.AddSubscriber( "use_plate2", private.use_plate2_beg, private.room_objname );
cmn.AddSubscriber( "use_plate2", private.use_plate2_end, private.room_objname );
cmn.AddSubscriber( "use_plate2", private.use_plate2_logic );
cmn.AddSubscriber( "use_plate2_inv", private.use_plate2_inv, private.room_objname );
cmn.AddSubscriber( "use_plate2_beg", private.use_plate2_beg, private.room_objname );
cmn.AddSubscriber( "use_plate2_end", private.use_plate2_end, private.room_objname );
cmn.AddSubscriber( "use_plate2_end", private.use_plate2_logic );
--------------------------------------------------------------------------------------------
function public.use_plate2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_plate2" );
    cmn.CallEventHandler( "use_plate2_end" );
    --common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_plate2") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_plate1","use_plate2"} ) then
      ld.CloseSubRoom();
      ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_onbalcony" ); end )
    else 
      common_impl.Lock(0);  
      if common_impl.ZzCompleteCheck("use_plate2") then ld.CloseSubRoom() end;
    end;  
  end;

  local func_preend = function() 
     if cmn.IsEventDone("use_plate1") or  cmn.IsEventDone("use_plate2") then 
        ObjSet( "anm_balconyexit_anm_balconyexit", {visible = 1} );
        ObjSet( "obj_balconyexit_anm_root", {visible = 0} );
        SoundSfx( "aud_touch_plate_livingroom" );
        ld.AnimPlay( "anm_balconyexit_anm_balconyexit", "open_door", func_end )
     else 
        func_end();
     end;  
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_plate2_inv" );
  cmn.CallEventHandler( "use_plate2_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_balconyexit_anm_balconyexit", {visible = 0} );
  ObjSet( "obj_balconyexit_anm_root", {visible = 1} );
  ld.AnimPlay( "anm_balconyexit_anm_balconyexit_anm2", "use_am2", func_preend );
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_plate_livingroom" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cell *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_redbutton2" ] = { type = "get", get_obj = "spr_cell_redbutton2", room = "rm_livingroom", zz = "zz_cell", zz_gate = "gzz_livingroom_cell" };

private.get_redbutton2_logic = function()
  ObjSet("gfx_cell_duck_zone", { visible = 1, input = 1, active = 1 })
end;
private.get_redbutton2_inv = function()
  interface.InventoryItemAdd("inv_redbutton","spr_cell_redbutton2",function() level_inv.ProcessGetRedbuttonAll( "get_redbutton2" ) end);
end;
private.get_redbutton2_beg = function()
  ObjDelete("gfx_cell_redbutton2")
end;
private.get_redbutton2_end = function()
  ObjDelete("spr_cell_sh_redbutton2"); 
  ObjDelete("spr_livingroom_redbutton2") ; 
  if common_impl.ZzCompleteCheck("get_redbutton2") then ObjSet( common_impl.hint["get_redbutton2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_redbutton2", private.get_redbutton2_inv );
cmn.AddSubscriber( "get_redbutton2", private.get_redbutton2_beg, private.room_objname );
cmn.AddSubscriber( "get_redbutton2", private.get_redbutton2_end, private.room_objname );
cmn.AddSubscriber( "get_redbutton2", private.get_redbutton2_logic );
--------------------------------------------------------------------
function public.get_redbutton2()
  cmn.SetEventDone( "get_redbutton2" );
  cmn.CallEventHandler( "get_redbutton2" );
  if common_impl.ZzCompleteCheck("get_redbutton2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_duck" ] = { type = "use", inv_obj = "inv_duck", use_place = "gfx_cell_duck_zone", room = "rm_livingroom", zz = "zz_cell", zz_gate = "gzz_livingroom_cell" };

private.use_duck_logic = function()
  ObjSet( "spr_cell_samvignette", { visible = 1, input = 1, active = 1 } )

end;
private.use_duck_inv = function()
  common_impl.ProcessMultiUseAll("duck", "duck")
end;
private.use_duck_beg = function()
  ObjDelete( "gfx_cell_duck_zone" );
end;
private.use_duck_end = function()
  ObjSet("anm_cell_use_duck",{frame=0,animfunc="end_duck1"})
  ObjDelete("spr_livingroom_duck");
  ObjDelete("spr_livingroom_open_doorduck");
  ObjSet( "spr_livingroom_doorduck", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_duck") then ObjSet( common_impl.hint["use_duck"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_duck", private.use_duck_inv );
cmn.AddSubscriber( "use_duck", private.use_duck_beg, private.room_objname );
cmn.AddSubscriber( "use_duck", private.use_duck_end, private.room_objname );
cmn.AddSubscriber( "use_duck", private.use_duck_logic );
cmn.AddSubscriber( "use_duck_inv", private.use_duck_inv, private.room_objname );
cmn.AddSubscriber( "use_duck_beg", private.use_duck_beg, private.room_objname );
cmn.AddSubscriber( "use_duck_end", private.use_duck_end, private.room_objname );
cmn.AddSubscriber( "use_duck_end", private.use_duck_logic );
--------------------------------------------------------------------------------------------
function public.use_duck( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_duck" );
    cmn.CallEventHandler( "use_duck_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_duck") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_duck_inv" );
  cmn.CallEventHandler( "use_duck_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cell_use_duck", "use_duck", func_end );
  SoundSfx( "aud_use_duck_livingroom" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_samvignette" ] = { type = "get", get_obj = "spr_cell_samvignette", room = "rm_livingroom", zz = "zz_cell", zz_gate = "gzz_livingroom_cell" };

private.get_samvignette_logic = function()
  
end;
private.get_samvignette_inv = function()
  interface.InventoryItemAdd("inv_samvignette","spr_cell_samvignette");
end;
private.get_samvignette_beg = function()
  ObjDelete("gfx_cell_samvignette")
end;
private.get_samvignette_end = function()
  ObjDelete("spr_cell_sh_samvignette")  
  if common_impl.ZzCompleteCheck("get_samvignette") then ObjSet( common_impl.hint["get_samvignette"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_samvignette", private.get_samvignette_inv );
cmn.AddSubscriber( "get_samvignette", private.get_samvignette_beg, private.room_objname );
cmn.AddSubscriber( "get_samvignette", private.get_samvignette_end, private.room_objname );
cmn.AddSubscriber( "get_samvignette", private.get_samvignette_logic );
--------------------------------------------------------------------
function public.get_samvignette()
  cmn.SetEventDone( "get_samvignette" );
  cmn.CallEventHandler( "get_samvignette" );
  if common_impl.ZzCompleteCheck("get_samvignette") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dove1" ] = { type = "use", inv_obj = "inv_dove1", use_place = "gfx_cell_dove1_zone", room = "rm_livingroom", zz = "zz_cell", zz_gate = "gzz_livingroom_cell" };

private.use_dove1_logic = function()
  if ld.CheckRequirements( {"use_dove1","use_dove2"} ) then
    ObjSet( "spr_cell_sammedallion", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_dove1_inv = function()
  common_impl.ProcessMultiUseAll("dove1", "dove1")
end;
private.use_dove1_beg = function()
  ObjDelete( "gfx_cell_dove1_zone" );
end;
private.use_dove1_end = function()
  if ld.CheckRequirements( {"use_dove2","use_dove1"} ) then
    ObjDelete("anm_cell_dove_1")    
    ObjDelete("anm_cell_dove_2")
    ObjSet("anm_cell_open_door",{frame=999,animfunc="open_door"})  
    ObjDelete("spr_livingroom_dove2");
    ObjDelete("spr_livingroom_dove1");
    ObjDelete("spr_livingroom_door");
    ObjSet( "spr_livingroom_open_door", {visible = 1} );
  else 
    ObjSet("anm_cell_dove_1",{frame=0,animfunc="end_dove_3"})
    ObjSet( "spr_livingroom_dove1", {visible = 1} );
  end    
  if common_impl.ZzCompleteCheck("use_dove1") then ObjSet( common_impl.hint["use_dove1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dove1", private.use_dove1_inv );
cmn.AddSubscriber( "use_dove1", private.use_dove1_beg, private.room_objname );
cmn.AddSubscriber( "use_dove1", private.use_dove1_end, private.room_objname );
cmn.AddSubscriber( "use_dove1", private.use_dove1_logic );
cmn.AddSubscriber( "use_dove1_inv", private.use_dove1_inv, private.room_objname );
cmn.AddSubscriber( "use_dove1_beg", private.use_dove1_beg, private.room_objname );
cmn.AddSubscriber( "use_dove1_end", private.use_dove1_end, private.room_objname );
cmn.AddSubscriber( "use_dove1_end", private.use_dove1_logic );
--------------------------------------------------------------------------------------------
function public.use_dove1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dove1" );
    cmn.CallEventHandler( "use_dove1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dove1") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    if ld.CheckRequirements( {"use_dove2"}) then
      ObjDelete("anm_cell_dove_1")
      ObjDelete("anm_cell_dove_2")   
      SoundSfx( "aud_touch_dove_livingroom" );         
      ld.AnimPlay( "anm_cell_open_door", "open_door",func_end  );      
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dove1_inv" );
  cmn.CallEventHandler( "use_dove1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cell_dove_1", "use_dove_1",f_step  );
  SoundSfx( "aud_use_dove1_livingroom" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dove2" ] = { type = "use", inv_obj = "inv_dove2", use_place = "gfx_cell_dove2_zone", room = "rm_livingroom", zz = "zz_cell", zz_gate = "gzz_livingroom_cell" };

private.use_dove2_logic = function()
  if ld.CheckRequirements( {"use_dove2","use_dove1"} ) then
    ObjSet( "spr_cell_sammedallion", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_dove2_inv = function()
  common_impl.ProcessMultiUseAll("dove2", "dove2")
end;
private.use_dove2_beg = function()
  ObjDelete( "gfx_cell_dove2_zone" );
end;
private.use_dove2_end = function()
  if ld.CheckRequirements( {"use_dove2","use_dove1"} ) then
    ObjDelete("anm_cell_dove_1")    
    ObjDelete("anm_cell_dove_2")
    ObjSet("anm_cell_open_door",{frame=999,animfunc="open_door"})  
    ObjDelete("spr_livingroom_dove2");
    ObjDelete("spr_livingroom_dove1");
    ObjDelete("spr_livingroom_door");
    ObjSet( "spr_livingroom_open_door", {visible = 1} );  
  else 
    ObjSet("anm_cell_dove_2",{frame=0,animfunc="end_dove_4"})
    ObjSet( "spr_livingroom_dove1", {visible = 1} );
  end  
  if common_impl.ZzCompleteCheck("use_dove2") then ObjSet( common_impl.hint["use_dove2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dove2", private.use_dove2_inv );
cmn.AddSubscriber( "use_dove2", private.use_dove2_beg, private.room_objname );
cmn.AddSubscriber( "use_dove2", private.use_dove2_end, private.room_objname );
cmn.AddSubscriber( "use_dove2", private.use_dove2_logic );
cmn.AddSubscriber( "use_dove2_inv", private.use_dove2_inv, private.room_objname );
cmn.AddSubscriber( "use_dove2_beg", private.use_dove2_beg, private.room_objname );
cmn.AddSubscriber( "use_dove2_end", private.use_dove2_end, private.room_objname );
cmn.AddSubscriber( "use_dove2_end", private.use_dove2_logic );
--------------------------------------------------------------------------------------------
function public.use_dove2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dove2" );
    cmn.CallEventHandler( "use_dove2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dove2") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    if ld.CheckRequirements( {"use_dove1"}) then
      ObjDelete("anm_cell_dove_1")
      ObjDelete("anm_cell_dove_2")  
      SoundSfx( "aud_touch_dove_livingroom" );      
      ld.AnimPlay( "anm_cell_open_door", "open_door",func_end  );      
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dove2_inv" );
  cmn.CallEventHandler( "use_dove2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cell_dove_2", "use_dove_2",f_step  );
  SoundSfx( "aud_use_dove2_livingroom" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sammedallion" ] = { type = "get", get_obj = "spr_cell_sammedallion", room = "rm_livingroom", zz = "zz_cell", zz_gate = "gzz_livingroom_cell" };

private.get_sammedallion_logic = function()
  
end;
private.get_sammedallion_inv = function()
  interface.InventoryItemAdd("inv_sammedallion","spr_cell_sammedallion");
  ObjSet( "inv_sammedallion", { drag = 0 } );
end;
private.get_sammedallion_beg = function()
  ObjDelete("gfx_cell_sammedallion")
end;
private.get_sammedallion_end = function()
  ObjDelete("spr_cell_sh_sammedallion");
  ObjDelete("spr_livingroom_sammedallion");
  if common_impl.ZzCompleteCheck("get_sammedallion") then ObjSet( common_impl.hint["get_sammedallion"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sammedallion", private.get_sammedallion_inv );
cmn.AddSubscriber( "get_sammedallion", private.get_sammedallion_beg, private.room_objname );
cmn.AddSubscriber( "get_sammedallion", private.get_sammedallion_end, private.room_objname );
cmn.AddSubscriber( "get_sammedallion", private.get_sammedallion_logic );
--------------------------------------------------------------------
function public.get_sammedallion()
  cmn.SetEventDone( "get_sammedallion" );
  cmn.CallEventHandler( "get_sammedallion" );
  if common_impl.ZzCompleteCheck("get_sammedallion") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_globe *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_plate1" ] = { type = "get", get_obj = "spr_globe_plate1", room = "rm_livingroom", zz = "zz_globe", zz_gate = "gzz_livingroom_globe" };

private.get_plate1_logic = function()
  
end;
private.get_plate1_inv = function()
  interface.InventoryItemAdd("inv_plate1","spr_globe_plate1");
end;
private.get_plate1_beg = function()
  ObjDelete("gfx_globe_plate1")
end;
private.get_plate1_end = function()
  ObjDelete("spr_globe_sh_plate1")
  ObjDelete( "spr_livingroom_plate1");
  if common_impl.ZzCompleteCheck("get_plate1") then ObjSet( common_impl.hint["get_plate1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_plate1", private.get_plate1_inv );
cmn.AddSubscriber( "get_plate1", private.get_plate1_beg, private.room_objname );
cmn.AddSubscriber( "get_plate1", private.get_plate1_end, private.room_objname );
cmn.AddSubscriber( "get_plate1", private.get_plate1_logic );
--------------------------------------------------------------------
function public.get_plate1()
  cmn.SetEventDone( "get_plate1" );
  cmn.CallEventHandler( "get_plate1" );
  if common_impl.ZzCompleteCheck("get_plate1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crystal" ] = { type = "use", inv_obj = "inv_crystal", use_place = "gfx_globe_crystal_zone", room = "rm_livingroom", zz = "zz_globe", zz_gate = "gzz_livingroom_globe" };

private.use_crystal_logic = function()
  ObjSet( "spr_globe_redbutton3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_globe_amuletsnake", { visible = 1, input = 1, active = 1 } )

end;
private.use_crystal_inv = function()
  common_impl.ProcessMultiUseAll("crystal", "crystal")
end;
private.use_crystal_beg = function()
  ObjDelete( "gfx_globe_crystal_zone" );
end;
private.use_crystal_end = function()
  ObjSet("anm_globe_crystal",{animfunc="end_crystal1",frame=0})
  ObjSet( "spr_livingroom_open_globe", {visible = 1} );
  ObjSet( "spr_globe_sh_amuletsnake", {visible = 1} );
  ObjSet( "spr_globe_sh_redbutton3", {visible = 1} );  
  if common_impl.ZzCompleteCheck("use_crystal") then ObjSet( common_impl.hint["use_crystal"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crystal", private.use_crystal_inv );
cmn.AddSubscriber( "use_crystal", private.use_crystal_beg, private.room_objname );
cmn.AddSubscriber( "use_crystal", private.use_crystal_end, private.room_objname );
cmn.AddSubscriber( "use_crystal", private.use_crystal_logic );
cmn.AddSubscriber( "use_crystal_inv", private.use_crystal_inv, private.room_objname );
cmn.AddSubscriber( "use_crystal_beg", private.use_crystal_beg, private.room_objname );
cmn.AddSubscriber( "use_crystal_end", private.use_crystal_end, private.room_objname );
cmn.AddSubscriber( "use_crystal_end", private.use_crystal_logic );
--------------------------------------------------------------------------------------------
function public.use_crystal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crystal" );
    cmn.CallEventHandler( "use_crystal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_crystal") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crystal_inv" );
  cmn.CallEventHandler( "use_crystal_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_globe_crystal", "use_crystal", func_end );
  SoundSfx( "aud_use_crystal_livingroom" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_redbutton3" ] = { type = "get", get_obj = "spr_globe_redbutton3", room = "rm_livingroom", zz = "zz_globe", zz_gate = "gzz_livingroom_globe" };

private.get_redbutton3_logic = function()
  
end;
private.get_redbutton3_inv = function()
  interface.InventoryItemAdd("inv_redbutton","spr_globe_redbutton3",function() level_inv.ProcessGetRedbuttonAll( "get_redbutton3" ) end);
end;
private.get_redbutton3_beg = function()
  ObjDelete("gfx_globe_redbutton3")
end;
private.get_redbutton3_end = function()
  ObjDelete("spr_globe_sh_redbutton3")  
  if common_impl.ZzCompleteCheck("get_redbutton3") then ObjSet( common_impl.hint["get_redbutton3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_redbutton3", private.get_redbutton3_inv );
cmn.AddSubscriber( "get_redbutton3", private.get_redbutton3_beg, private.room_objname );
cmn.AddSubscriber( "get_redbutton3", private.get_redbutton3_end, private.room_objname );
cmn.AddSubscriber( "get_redbutton3", private.get_redbutton3_logic );
--------------------------------------------------------------------
function public.get_redbutton3()
  cmn.SetEventDone( "get_redbutton3" );
  cmn.CallEventHandler( "get_redbutton3" );
  if common_impl.ZzCompleteCheck("get_redbutton3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletsnake" ] = { type = "get", get_obj = "spr_globe_amuletsnake", room = "rm_livingroom", zz = "zz_globe", zz_gate = "gzz_livingroom_globe" };

private.get_amuletsnake_logic = function()
  
end;
private.get_amuletsnake_inv = function()
  interface.InventoryItemAdd("inv_amuletsnake","spr_globe_amuletsnake");
end;
private.get_amuletsnake_beg = function()
  ObjDelete("gfx_globe_amuletsnake")
end;
private.get_amuletsnake_end = function()
  ObjDelete("spr_globe_sh_amuletsnake")    
  if common_impl.ZzCompleteCheck("get_amuletsnake") then ObjSet( common_impl.hint["get_amuletsnake"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletsnake", private.get_amuletsnake_inv );
cmn.AddSubscriber( "get_amuletsnake", private.get_amuletsnake_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletsnake", private.get_amuletsnake_end, private.room_objname );
cmn.AddSubscriber( "get_amuletsnake", private.get_amuletsnake_logic );
--------------------------------------------------------------------
function public.get_amuletsnake()
  cmn.SetEventDone( "get_amuletsnake" );
  cmn.CallEventHandler( "get_amuletsnake" );
  if common_impl.ZzCompleteCheck("get_amuletsnake") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mainland1" ] = { type = "use", inv_obj = "inv_mainland1", use_place = "gfx_globe_mainland1_zone", room = "rm_livingroom", zz = "zz_globe", zz_gate = "gzz_livingroom_globe" };

private.use_mainland1_logic = function()
  if ld.CheckRequirements( {"use_mainland1","use_mainland2"} ) then
    ObjSet( "spr_globe_bearseye2", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_globe_text", {input = 1, visible = 1} );    
  end;

end;
private.use_mainland1_inv = function()
  common_impl.ProcessMultiUseAll("mainland1", "mainland1")
end;
private.use_mainland1_beg = function()
  ObjDelete( "gfx_globe_mainland1_zone" );
end;
private.use_mainland1_end = function()
  if ld.CheckRequirements( {"use_mainland1","use_mainland2"} ) then
    ObjDelete("anm_globe_mainland1")    
    ObjDelete("anm_globe_mainland2")
    ObjSet("anm_globe_open_globe",{animfunc="end_globe1",frame=0});
    ObjDelete("spr_livingroom_mainland2");
    ObjDelete("spr_livingroom_mainland1");
    ObjDelete("spr_livingroom_tr_globe");
    ObjSet( "spr_livingroom_tr_globe_open", {visible = 1} );
    ObjSet( "spr_livingroom_bearseye2", {visible = 1} );
  else 
    ObjSet( "spr_livingroom_mainland1", {visible = 1} );
    ObjSet("anm_globe_mainland1",{frame=0,animfunc="end_mainland3"})
  end   
  if common_impl.ZzCompleteCheck("use_mainland1") then ObjSet( common_impl.hint["use_mainland1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mainland1", private.use_mainland1_inv );
cmn.AddSubscriber( "use_mainland1", private.use_mainland1_beg, private.room_objname );
cmn.AddSubscriber( "use_mainland1", private.use_mainland1_end, private.room_objname );
cmn.AddSubscriber( "use_mainland1", private.use_mainland1_logic );
cmn.AddSubscriber( "use_mainland1_inv", private.use_mainland1_inv, private.room_objname );
cmn.AddSubscriber( "use_mainland1_beg", private.use_mainland1_beg, private.room_objname );
cmn.AddSubscriber( "use_mainland1_end", private.use_mainland1_end, private.room_objname );
cmn.AddSubscriber( "use_mainland1_end", private.use_mainland1_logic );
--------------------------------------------------------------------------------------------
function public.use_mainland1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mainland1" );
    cmn.CallEventHandler( "use_mainland1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mainland1") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    if ld.CheckRequirements( {"use_mainland2"}) then
      ObjDelete("anm_globe_mainland1")
      ObjDelete("anm_globe_mainland2")    
      SoundSfx( "aud_touch_mainland_livingroom" );  
      ld.AnimPlay( "anm_globe_open_globe", "open_globe",func_end  );      
    else
      func_end()
    end
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mainland1_inv" );
  cmn.CallEventHandler( "use_mainland1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_globe_mainland1", "use_mainland1", f_step );
  SoundSfx( "aud_use_mainland_livingroom" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mainland2" ] = { type = "use", inv_obj = "inv_mainland2", use_place = "gfx_globe_mainland2_zone", room = "rm_livingroom", zz = "zz_globe", zz_gate = "gzz_livingroom_globe" };

private.use_mainland2_logic = function()
  if ld.CheckRequirements( {"use_mainland2","use_mainland1"} ) then
    ObjSet( "spr_globe_bearseye2", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_globe_text", {input = 1, visible = 1} );    
  end;

end;
private.use_mainland2_inv = function()
  common_impl.ProcessMultiUseAll("mainland2", "mainland2")
end;
private.use_mainland2_beg = function()
  ObjDelete( "gfx_globe_mainland2_zone" );
end;
private.use_mainland2_end = function()
  if ld.CheckRequirements( {"use_mainland1","use_mainland2"} ) then
    ObjDelete("anm_globe_mainland1")    
    ObjDelete("anm_globe_mainland2")
    ObjSet("anm_globe_open_globe",{animfunc="end_globe1",frame=0})
    ObjDelete("spr_livingroom_mainland2");
    ObjDelete("spr_livingroom_mainland1");
    ObjDelete("spr_livingroom_tr_globe");
    ObjSet( "spr_livingroom_tr_globe_open", {visible = 1} );
    ObjSet( "spr_livingroom_bearseye2", {visible = 1} );
  else 
    ObjSet( "spr_livingroom_mainland2", {visible = 1} );
    ObjSet("anm_globe_mainland2",{frame=0,animfunc="end_mainland4"})
  end   
  if common_impl.ZzCompleteCheck("use_mainland2") then ObjSet( common_impl.hint["use_mainland2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mainland2", private.use_mainland2_inv );
cmn.AddSubscriber( "use_mainland2", private.use_mainland2_beg, private.room_objname );
cmn.AddSubscriber( "use_mainland2", private.use_mainland2_end, private.room_objname );
cmn.AddSubscriber( "use_mainland2", private.use_mainland2_logic );
cmn.AddSubscriber( "use_mainland2_inv", private.use_mainland2_inv, private.room_objname );
cmn.AddSubscriber( "use_mainland2_beg", private.use_mainland2_beg, private.room_objname );
cmn.AddSubscriber( "use_mainland2_end", private.use_mainland2_end, private.room_objname );
cmn.AddSubscriber( "use_mainland2_end", private.use_mainland2_logic );
--------------------------------------------------------------------------------------------
function public.use_mainland2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mainland2" );
    cmn.CallEventHandler( "use_mainland2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mainland2") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    if ld.CheckRequirements( {"use_mainland1"}) then
      ObjDelete("anm_globe_mainland1")
      ObjDelete("anm_globe_mainland2")      
      SoundSfx( "aud_touch_mainland_livingroom" );
      ld.AnimPlay( "anm_globe_open_globe", "open_globe",func_end  );      
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mainland2_inv" );
  cmn.CallEventHandler( "use_mainland2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_globe_mainland2", "use_mainland2", f_step );
  SoundSfx( "aud_use_mainland_livingroom" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bearseye2" ] = { type = "get", get_obj = "spr_globe_bearseye2", room = "rm_livingroom", zz = "zz_globe", zz_gate = "gzz_livingroom_globe" };

private.get_bearseye2_logic = function()
  
end;
private.get_bearseye2_inv = function()
  interface.InventoryItemAdd("inv_bearseye2","spr_globe_bearseye2");
end;
private.get_bearseye2_beg = function()
  ObjDelete("gfx_globe_bearseye2")
end;
private.get_bearseye2_end = function()
  ObjDelete("spr_globe_sh_bearseye2")
  ObjDelete("spr_livingroom_bearseye2");
  if common_impl.ZzCompleteCheck("get_bearseye2") then ObjSet( common_impl.hint["get_bearseye2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bearseye2", private.get_bearseye2_inv );
cmn.AddSubscriber( "get_bearseye2", private.get_bearseye2_beg, private.room_objname );
cmn.AddSubscriber( "get_bearseye2", private.get_bearseye2_end, private.room_objname );
cmn.AddSubscriber( "get_bearseye2", private.get_bearseye2_logic );
--------------------------------------------------------------------
function public.get_bearseye2()
  cmn.SetEventDone( "get_bearseye2" );
  cmn.CallEventHandler( "get_bearseye2" );
  if common_impl.ZzCompleteCheck("get_bearseye2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_toyhouse *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_tornbear" ] = { type = "get", get_obj = "spr_toyhouse_tornbear", room = "rm_livingroom", zz = "zz_toyhouse", zz_gate = "gzz_livingroom_toyhouse" };

private.get_tornbear_logic = function()
  
  ObjSet( "gfx_toyhouse_brooch_zone", { visible = 1, input = 1, active = 1 } )  
end;
private.get_tornbear_inv = function()
  interface.InventoryItemAdd("inv_tornbear","spr_toyhouse_tornbear");
  ObjSet( "inv_tornbear", { drag = 0 } );
end;
private.get_tornbear_beg = function()
  ObjDelete("gfx_toyhouse_tornbear")
end;
private.get_tornbear_end = function()
  ObjDelete("spr_toyhouse_sh_tornbear");
  ObjDelete("spr_livingroom_bear");
  if common_impl.ZzCompleteCheck("get_tornbear") then ObjSet( common_impl.hint["get_tornbear"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_tornbear", private.get_tornbear_inv );
cmn.AddSubscriber( "get_tornbear", private.get_tornbear_beg, private.room_objname );
cmn.AddSubscriber( "get_tornbear", private.get_tornbear_end, private.room_objname );
cmn.AddSubscriber( "get_tornbear", private.get_tornbear_logic );
--------------------------------------------------------------------
function public.get_tornbear()
  cmn.SetEventDone( "get_tornbear" );
  cmn.CallEventHandler( "get_tornbear" );
  if common_impl.ZzCompleteCheck("get_tornbear") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_brooch" ] = { type = "use", inv_obj = "inv_brooch", use_place = "gfx_toyhouse_brooch_zone", room = "rm_livingroom", zz = "zz_toyhouse", zz_gate = "gzz_livingroom_toyhouse" };

private.use_brooch_logic = function()
  ObjSet( "gfx_toyhouse_win_lodge_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_brooch_inv = function()
  common_impl.ProcessMultiUseAll("brooch", "brooch")
end;
private.use_brooch_beg = function()
  ObjDelete( "gfx_toyhouse_brooch_zone" );
end;
private.use_brooch_end = function()
  ObjAttach("spr_toyhouse_mmg_root","zz_toyhouse")  
  ObjSet( "spr_toyhouse_mmg_root", {input = 1, alp = 1,pos_z=45} );   
  ObjSet("anm_toyhouse_door",{animfunc="open_door",frame=0})
  ObjSet( "spr_livingroom_open_house", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_brooch") then ObjSet( common_impl.hint["use_brooch"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_brooch", private.use_brooch_inv );
cmn.AddSubscriber( "use_brooch", private.use_brooch_beg, private.room_objname );
cmn.AddSubscriber( "use_brooch", private.use_brooch_end, private.room_objname );
cmn.AddSubscriber( "use_brooch", private.use_brooch_logic );
cmn.AddSubscriber( "use_brooch_inv", private.use_brooch_inv, private.room_objname );
cmn.AddSubscriber( "use_brooch_beg", private.use_brooch_beg, private.room_objname );
cmn.AddSubscriber( "use_brooch_end", private.use_brooch_end, private.room_objname );
cmn.AddSubscriber( "use_brooch_end", private.use_brooch_logic );
--------------------------------------------------------------------------------------------
function public.use_brooch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_brooch" );
    cmn.CallEventHandler( "use_brooch_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "lodge" );    
    public.toyhouse_load()
    if common_impl.ZzCompleteCheck("use_brooch") then ld.CloseSubRoom() end;
  end;
  
  local f_step = function ()
    ObjAttach("spr_toyhouse_mmg_root","zz_toyhouse")
    ObjSet("spr_toyhouse_mmg_root",{pos_z=45})
    ObjAnimate( "spr_toyhouse_mmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );    
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_brooch_inv" );
  cmn.CallEventHandler( "use_brooch_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_toyhouse_door", "use_brooch", f_step );
  SoundSfx( "aud_use_brooch_livingroom" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_lodge" ] = { type = "click", use_place = "gfx_toyhouse_win_lodge_zone", room = "rm_livingroom", zz = "zz_toyhouse", zz_gate = "gzz_livingroom_toyhouse" };

private.win_lodge_logic = function()
  if cmn.IsEventDone("win_lodge") then    
    ObjSet( "gho_livingroom_toys", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_lodge_beg = function()
  if cmn.IsEventDone("win_lodge") then   
    ObjDelete( "gfx_toyhouse_win_lodge_zone" );
  end
end;
private.win_lodge_end = function()
  if cmn.IsEventDone("win_lodge") then   
    ObjDetach("spr_toyhouse_mmg_root");
    ObjSet( "spr_livingroom_tr_game", {visible = 1} );
    ObjSet("anm_toyhouse_door",{frame=0,animfunc="end_door1"})
    if common_impl.ZzCompleteCheck("win_lodge") then ObjSet( common_impl.hint["win_lodge"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_lodge", private.win_lodge_beg, private.room_objname );
cmn.AddSubscriber( "win_lodge", private.win_lodge_end, private.room_objname );
cmn.AddSubscriber( "win_lodge", private.win_lodge_logic );
cmn.AddSubscriber( "win_lodge_beg", private.win_lodge_beg, private.room_objname );
cmn.AddSubscriber( "win_lodge_end", private.win_lodge_end, private.room_objname );
cmn.AddSubscriber( "win_lodge_end", private.win_lodge_logic );
--------------------------------------------------------------------------------------------
function public.win_lodge()

  local func_end = function()
    cmn.SetEventDone( "win_lodge" );
    cmn.CallEventHandler( "win_lodge_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_lodge") then ld.CloseSubRoom() end;
  end;
    cmn.MiniGameHide( "lodge", true );   
  cmn.CallEventHandler( "win_lodge_beg" );
  common_impl.Lock(1);
  
  SoundSfx( "aud_mmg_lodge_win" );
  ObjAnimate( "spr_toyhouse_mmg_root", 8, 0, 0,function() ld.AnimPlay("anm_toyhouse_door","open_door",func_end)end , {0,0,1, 0.5,0,0} );


end;
--------------------------------------------------------------------------------------------
private.cur_toyhouse_brooch = 0;

function public.toyhouse_load(skip)
  if not ng_global.progress["std"]["win_lodge"].state then
    ng_global.progress["std"]["win_lodge"].state = {3,6,5,1,9,8,7,4,2}
  end
  local x_arr={-127,1,129}
  local y_arr={-127,-4,121}  
  for i=1,3 do
    for j = 1,3 do
      ObjSet("spr_toyhouse_brooch_"..ng_global.progress["std"]["win_lodge"].state[(j*3-3+i)],{pos_x=x_arr[i],pos_y=y_arr[j]})
    end
  end    
  if not skip then
  private.toyhouse_check()
  end
end
function public.toyhouse_mdown(obj)
  SoundSfx( "aud_mmg_lodge_select" );
  
  local num1 = tonumber(ld.StringDivide(obj)[4])
  if private.cur_toyhouse_brooch == 0 then
    private.cur_toyhouse_brooch = num1
    local index
    for i=1,9 do
      if num1==ng_global.progress["std"]["win_lodge"].state[i] then
        index = i 
      end
      ObjSet( "spr_toyhouse_brooch_"..i, {input = 0} );
    end

    local arr = {}
    if index-3>0 then table.insert(arr,index-3) end
    if index-1>0 and (index%3)~=1 then table.insert(arr,index-1) end
    if index+3<10 then table.insert(arr,index+3) end
    if index+1<10 and (index%3)~=0 then table.insert(arr,index+1) end      
      
    for j=1,#arr do
      ObjSet( "spr_toyhouse_brooch_"..ng_global.progress["std"]["win_lodge"].state[arr[j] ], {input = 1} );    
      ObjAnimate( "spr_toyhouse_brooch_"..ng_global.progress["std"]["win_lodge"].state[arr[j] ].."_light_way", 8, 0, 0, "", {0,0,0, 0.3,0,1} );     
    end
    if #arr~= 0 then
      ld.Lock(1)
      ld.StartTimer( 0.3, function()ld.Lock(0)end )  
    end
  else 
    local index1,index2
    local num2 = private.cur_toyhouse_brooch    
    for i=1,9 do
      if num1==ng_global.progress["std"]["win_lodge"].state[i] then
        index1 = i 
      end
      if num2==ng_global.progress["std"]["win_lodge"].state[i] then
        index2 = i 
      end      
    end     

    local param1 = ObjGet("spr_toyhouse_brooch_"..num1)
    local param2 = ObjGet("spr_toyhouse_brooch_"..num2) 
    ld.Lock(1)
    SoundSfx( "aud_mmg_lodge_move" );
    ObjAnimate( param1.name, 3, 0, 0, function()ld.Lock(0);private.toyhouse_check()end, {0,0,param1.pos_x,param1.pos_y, 0.4,0,param2.pos_x,param2.pos_y,} );
    ObjAnimate( param2.name, 3, 0, 0, "", {0,0,param2.pos_x,param2.pos_y, 0.4,0,param1.pos_x,param1.pos_y,} );    

    for i=1,9 do
      ObjSet( "spr_toyhouse_brooch_"..i, {input = 1} );
      ObjSet( "spr_toyhouse_brooch_"..i.."_light_way", {alp = 0} );       
    end
    local tmp= ng_global.progress["std"]["win_lodge"].state[index1]
    ng_global.progress["std"]["win_lodge"].state[index1]=ng_global.progress["std"]["win_lodge"].state[index2]
    ng_global.progress["std"]["win_lodge"].state[index2] = tmp
    private.cur_toyhouse_brooch = 0    
  end
end
function private.toyhouse_check()
  local count = 0
  for i=1,9 do
    if i==ng_global.progress["std"]["win_lodge"].state[i] then count=count + 1 end
  end
  
  if count == 9 then 
    public.win_lodge()
  end
end
function public.toyhouse_menter(obj)
  ld.ShCur(CURSOR_HAND)
  if ObjGet(obj) then
    ObjAnimate( obj.."_light", 8, 0, 0, "", {0,0,ObjGet(obj.."_light").alp, 0.3,0,1} );
  end
end
function public.toyhouse_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  if ObjGet(obj) then
    ObjAnimate( obj.."_light", 8, 0, 0, "", {0,0,ObjGet(obj.."_light").alp, 0.3,0,0} );  
  end
end

function  private.win_lodge_reset()
    ng_global.progress["std"]["win_lodge"].state = {3,6,5,1,9,8,7,4,2}
    local f_end = function ()
      ld.Lock(0)
      public.toyhouse_load()
      
      ObjAnimate( "obj_toyhouse_mmg_root", 8, 0, 0, "", {0,0,0, 0.3,0,1} );  
    end
    ld.Lock(1)
    ObjAnimate( "obj_toyhouse_mmg_root", 8, 0, 0, f_end, {0,0,1, 0.3,0,0} );
end
function  private.win_lodge_skip()
  ng_global.progress["std"]["win_lodge"].state = {1,2,3,4,5,6,7,8,9}
    local f_end = function ()
      ld.Lock(0)
      public.toyhouse_load(true)
      ObjAnimate( "obj_toyhouse_mmg_root", 8, 0, 0, private.toyhouse_check, {0,0,0, 0.3,0,1,0.5,0,1} );  
    end
    ld.Lock(1)
    ObjAnimate( "obj_toyhouse_mmg_root", 8, 0, 0, f_end, {0,0,1, 0.3,0,0} ); 
end

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tocellar *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_raggedshawl_zone_clk()  --rm_livingroom.use_raggedshawl_zone_clk()
  local func_end = function() 
    ld.Lock(0);
    common_impl.ShowBbt( 'need_raggedshawl' );
  end
  
  ld.Lock(1);
  ld.AnimPlay( "anm_tocellar_anm_door", "idle_gryphoneye", func_end )
  SoundSfx( "aud_touch_statuette" );
end;  


common_impl.hint[ "use_raggedshawl" ] = { type = "use", inv_obj = "inv_raggedshawl", use_place = "gfx_tocellar_raggedshawl_zone", room = "rm_livingroom", zz = "zz_tocellar", zz_gate = "gzz_livingroom_tocellar" };

private.use_raggedshawl_logic = function()
  ObjSet( "spr_tocellar_gryphoneye", { visible = 1, input = 1, active = 1 } )

end;
private.use_raggedshawl_inv = function()
  common_impl.ProcessMultiUseAll("raggedshawl", "raggedshawl")
end;
private.use_raggedshawl_beg = function()
  ObjDelete( "gfx_tocellar_raggedshawl_zone" );
end;
private.use_raggedshawl_end = function()
  if common_impl.ZzCompleteCheck("use_raggedshawl") then ObjSet( common_impl.hint["use_raggedshawl"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_tocellar_anm_door", {animfunc = "use_dt", frame = 0 } );
  ObjSet( "spr_tocellar_sh_gryphoneye", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_raggedshawl", private.use_raggedshawl_inv );
cmn.AddSubscriber( "use_raggedshawl", private.use_raggedshawl_beg, private.room_objname );
cmn.AddSubscriber( "use_raggedshawl", private.use_raggedshawl_end, private.room_objname );
cmn.AddSubscriber( "use_raggedshawl", private.use_raggedshawl_logic );
cmn.AddSubscriber( "use_raggedshawl_inv", private.use_raggedshawl_inv, private.room_objname );
cmn.AddSubscriber( "use_raggedshawl_beg", private.use_raggedshawl_beg, private.room_objname );
cmn.AddSubscriber( "use_raggedshawl_end", private.use_raggedshawl_end, private.room_objname );
cmn.AddSubscriber( "use_raggedshawl_end", private.use_raggedshawl_logic );
--------------------------------------------------------------------------------------------
function public.use_raggedshawl( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_raggedshawl" );
    cmn.CallEventHandler( "use_raggedshawl_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_raggedshawl") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_raggedshawl_inv" );
  cmn.CallEventHandler( "use_raggedshawl_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tocellar_anm_door", "use_rag", func_end );
  SoundSfx( "aud_use_raggedshawl_livingroom" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_gryphoneye" ] = { type = "get", get_obj = "spr_tocellar_gryphoneye", room = "rm_livingroom", zz = "zz_tocellar", zz_gate = "gzz_livingroom_tocellar" };

private.get_gryphoneye_logic = function()
  
end;
private.get_gryphoneye_inv = function()
  interface.InventoryItemAdd("inv_gryphoneye","spr_tocellar_gryphoneye");
end;
private.get_gryphoneye_beg = function()
  ObjDelete("gfx_tocellar_gryphoneye")
end;
private.get_gryphoneye_end = function()
  if common_impl.ZzCompleteCheck("get_gryphoneye") then ObjSet( common_impl.hint["get_gryphoneye"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tocellar_sh_gryphoneye")
  ObjDelete("spr_livingroom_stone");
end;

cmn.AddSubscriber( "get_gryphoneye", private.get_gryphoneye_inv );
cmn.AddSubscriber( "get_gryphoneye", private.get_gryphoneye_beg, private.room_objname );
cmn.AddSubscriber( "get_gryphoneye", private.get_gryphoneye_end, private.room_objname );
cmn.AddSubscriber( "get_gryphoneye", private.get_gryphoneye_logic );
--------------------------------------------------------------------
function public.get_gryphoneye()
  cmn.SetEventDone( "get_gryphoneye" );
  cmn.CallEventHandler( "get_gryphoneye" );
  if common_impl.ZzCompleteCheck("get_gryphoneye") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fork" ] = { type = "use", inv_obj = "inv_fork", use_place = "gfx_tocellar_fork_zone", room = "rm_livingroom", zz = "zz_tocellar", zz_gate = "gzz_livingroom_tocellar" };

private.use_fork_logic = function()
  ObjSet( "gmg_livingroom_forks", { visible = 1, input = 1, active = 1 } )
end;
private.use_fork_inv = function()
  common_impl.ProcessMultiUseAll("fork", "fork")
end;
private.use_fork_beg = function()
  ObjDelete( "gfx_tocellar_fork_zone" );
end;
private.use_fork_end = function()
  if common_impl.ZzCompleteCheck("use_fork") then ObjSet( common_impl.hint["use_fork"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_tocellar_anm_door", {animfunc = "use_dt", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fork", private.use_fork_inv );
cmn.AddSubscriber( "use_fork", private.use_fork_beg, private.room_objname );
cmn.AddSubscriber( "use_fork", private.use_fork_end, private.room_objname );
cmn.AddSubscriber( "use_fork", private.use_fork_logic );
cmn.AddSubscriber( "use_fork_inv", private.use_fork_inv, private.room_objname );
cmn.AddSubscriber( "use_fork_beg", private.use_fork_beg, private.room_objname );
cmn.AddSubscriber( "use_fork_end", private.use_fork_end, private.room_objname );
cmn.AddSubscriber( "use_fork_end", private.use_fork_logic );
--------------------------------------------------------------------------------------------
function public.use_fork( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fork" );
    cmn.CallEventHandler( "use_fork_end" );
    -- common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fork") then ld.CloseSubRoom() end;
    ld.CloseSubRoom();
    ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_forks" ); end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fork_inv" );
  cmn.CallEventHandler( "use_fork_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tocellar_anm_door", "use_dt", func_end );
  SoundSfx( "aud_use_fork_livingroom" )
  --func_end()
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cabinetlord *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lordkey" ] = { type = "use", inv_obj = "inv_lordkey", use_place = "gfx_cabinetlord_lordkey_zone", room = "rm_livingroom", zz = "zz_cabinetlord", zz_gate = "gzz_livingroom_cabinetlord" };

private.use_lordkey_logic = function()
  ObjSet( "gfx_cabinetlord_clk_cabinetlordopn_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_lordkey_inv = function()
  common_impl.ProcessMultiUseAll("lordkey", "lordkey")
end;
private.use_lordkey_beg = function()
  ObjDelete( "gfx_cabinetlord_lordkey_zone" );
end;
private.use_lordkey_end = function()
  if common_impl.ZzCompleteCheck("use_lordkey") then ObjSet( common_impl.hint["use_lordkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cabinetlord_door", {animfunc = "key", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lordkey", private.use_lordkey_inv );
cmn.AddSubscriber( "use_lordkey", private.use_lordkey_beg, private.room_objname );
cmn.AddSubscriber( "use_lordkey", private.use_lordkey_end, private.room_objname );
cmn.AddSubscriber( "use_lordkey", private.use_lordkey_logic );
cmn.AddSubscriber( "use_lordkey_inv", private.use_lordkey_inv, private.room_objname );
cmn.AddSubscriber( "use_lordkey_beg", private.use_lordkey_beg, private.room_objname );
cmn.AddSubscriber( "use_lordkey_end", private.use_lordkey_end, private.room_objname );
cmn.AddSubscriber( "use_lordkey_end", private.use_lordkey_logic );
--------------------------------------------------------------------------------------------
function public.use_lordkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lordkey" );
    cmn.CallEventHandler( "use_lordkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lordkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lordkey_inv" );
  cmn.CallEventHandler( "use_lordkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cabinetlord_door", "key", func_end );
  SoundSfx( "aud_use_lordkey_livingroom" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cabinetlordopn" ] = { type = "click", use_place = "gfx_cabinetlord_clk_cabinetlordopn_zone", room = "rm_livingroom", zz = "zz_cabinetlord", zz_gate = "gzz_livingroom_cabinetlord" };

private.clk_cabinetlordopn_logic = function()
  ObjSet( "gho_livingroom_deal", { visible = 1, input = 1, active = 1 } )
end;
private.clk_cabinetlordopn_beg = function()
  ObjDelete("gfx_cabinetlord_clk_cabinetlordopn_zone");
end;
private.clk_cabinetlordopn_end = function()
  ObjSet( "spr_livingroom_open_doorlord", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_lordkey") then ObjSet( common_impl.hint["use_lordkey"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cabinetlordopn", private.clk_cabinetlordopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_cabinetlordopn", private.clk_cabinetlordopn_end, private.room_objname );
cmn.AddSubscriber( "clk_cabinetlordopn", private.clk_cabinetlordopn_logic );
cmn.AddSubscriber( "clk_cabinetlordopn_beg", private.clk_cabinetlordopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_cabinetlordopn_end", private.clk_cabinetlordopn_end, private.room_objname );
cmn.AddSubscriber( "clk_cabinetlordopn_end", private.clk_cabinetlordopn_logic );
--------------------------------------------------------------------------------------------
function public.clk_cabinetlordopn()

  local func_end = function()
    cmn.SetEventDone( "clk_cabinetlordopn" );
    cmn.CallEventHandler( "clk_cabinetlordopn_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_cabinetlordopn") then ld.CloseSubRoom() end;

  end;
 
  SoundSfx( "aud_touch_key_door_livingroom" );
  cmn.CallEventHandler( "clk_cabinetlordopn_beg" );
  common_impl.Lock(1);
  ld.AnimPlay( "anm_cabinetlord_door", "key2", func_end )

end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_deal_for_livingroom = function()
    if ld.CheckRequirements( {"win_deal"} ) then
      ObjSet( "gho_livingroom_deal", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_deal", win_deal_for_livingroom, private.room_objname )
  local win_forks_for_livingroom = function()
    if ld.CheckRequirements( {"win_forks"} ) then
      ObjSet( "gmg_livingroom_forks", {input = 0, visible = 0} );
      ObjSet( "grm_livingroom_cellar", { visible = 1, input = 1, active = 1 } ) 
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroom_cellar_focus");
      end;
      ObjDelete("spr_livingroom_door_2");
      ObjSet( "spr_livingroom_door_1", {visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_forks", win_forks_for_livingroom, private.room_objname )
  
  
  local win_onbalcony_for_livingroom = function()
    if ld.CheckRequirements( {"win_onbalcony"} ) then
      ObjSet( "gmg_livingroom_onbalcony", {active=0, input = 0, visible = 0} );
      -- ObjSet( "spr_livingroom_open_balcony", {visible = 1} );
      ObjSet( "grm_livingroom_balcony", { visible = 1, input = 1, active = 1 } )   
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroom_balcony_focus");
      end;
      ObjSet( "anm_livingroom_anm_him", {animfunc = "him", frame = 0, playing = 1, active=1, visible=1 } );   
    end
  end;
  cmn.AddSubscriber("win_onbalcony", win_onbalcony_for_livingroom, private.room_objname )
  local win_toys_for_livingroom = function()
    if ld.CheckRequirements( {"win_toys"} ) then
      ObjSet( "gho_livingroom_toys", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_toys", win_toys_for_livingroom, private.room_objname )

end;
---------------------------------------------------------------------------------
private.clk_outro1_end_for_livingroom = function()
  ObjDelete("anm_livingroom_anm_him");
  ObjSet( "spr_livingroom_open_balcony", {active=1, visible = 1} );
end;

cmn.AddSubscriber( "clk_outro1", private.clk_outro1_end_for_livingroom, private.room_objname );
cmn.AddSubscriber( "clk_outro1_end", private.clk_outro1_end_for_livingroom, private.room_objname );

---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_toyhouse" ) and not ld.CheckRequirements( { "win_lodge" } ) then  
    private.win_lodge_reset();
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_toyhouse" ) and not ld.CheckRequirements( { "win_lodge" } ) then
    private.win_lodge_skip();
  end;
  
end
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_livingroom();
  if cmn.IsEventDone("dlg_balcony_lord1") and not cmn.IsEventDone("clk_incellaranm") then
    public.clk_incellaranm();
  end;  
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_livingroom_env" )
  if cmn.IsEventDone("dlg_balcony_lord1") and not cmn.IsEventDone("clk_incellaranm") then
    ObjSet( "obj_livingroom_tocellar_tr_root", {visible = 0} );
    ObjSet( "anm_livingroom_anm_door", {visible = 1} );
  end;  
  if cmn.IsEventDone("win_deal") and not cmn.IsEventDone("win_deal_task") then  
      cmn.SetEventDone("win_deal_task")
  end
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_cabinetlord" );
  function zz_cabinetlord.Open()
  end;
  function zz_cabinetlord.PreOpen()
  end;
  function zz_cabinetlord.PreClose()
  end;
  function zz_cabinetlord.Close()
  end;

  subroom.Define( "zz_tocellar" );
  function zz_tocellar.Open()
  end;
  function zz_tocellar.PreOpen()
  end;
  function zz_tocellar.PreClose()
  end;
  function zz_tocellar.Close()
  end;

  subroom.Define( "zz_toyhouse" );
  function zz_toyhouse.Open()
  end;
  function zz_toyhouse.PreOpen()
    
     if cmn.IsEventStart("win_lodge") and not cmn.IsEventDone("win_lodge") then 
       cmn.MiniGameShow( "lodge" ); 
       public.toyhouse_load()
     end;     
  end;
  function zz_toyhouse.PreClose()
  end;
  function zz_toyhouse.Close()
  end;

  subroom.Define( "zz_globe" );
  function zz_globe.Open()
  end;
  function zz_globe.PreOpen()
  end;
  function zz_globe.PreClose()
  end;
  function zz_globe.Close()
  end;

  subroom.Define( "zz_cell" );
  function zz_cell.Open()
  end;
  function zz_cell.PreOpen()
  end;
  function zz_cell.PreClose()
  end;
  function zz_cell.Close()
  end;

  subroom.Define( "zz_balconyexit" );
  function zz_balconyexit.Open()
  end;
  function zz_balconyexit.PreOpen()
  end;
  function zz_balconyexit.PreClose()
  end;
  function zz_balconyexit.Close()
  end;
  
end;
--*********************************************************************************************************************