-- name=rm_pub
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_pub";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_behindcounter_teext_min", "spr_behindcounter_text","notetrader_page_clk")
  --------------------------------------------------------------------------------------------
function private.opn_pub()
  if not ( cmn.IsEventDone( "opn_pub" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_pub" );
      cmn.CallEventHandler( "opn_pub" )
      ld.ShowBbtOpn( private.room_objname )
      SoundTheme( "aud_danger_moment1_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_pub = function() end;
local opn_pub_logic = function() end;
cmn.AddSubscriber( "opn_pub", opn_pub_logic )
cmn.AddSubscriber( "opn_pub", opn_pub, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "trader1" then
    if count_txt == 1 then
  
    end;
  end;  
  if dlg_name == "trader2" then    
    if count_txt == 1 then    
      ld.Lock(1);
      ld.StartTimer( 1, function() AnimPlay( "anm_pub_trader2", "give", function() ld.Lock(0);  end);
         SoundSfx( "aud_get_to_us" );  end )  
     
    elseif count_txt == 2 then 
       ObjSet( "spr_pub_notetrader", {active=1, visible = 1} );
       cmn.CallEventHandler( "get_notetrader" );
      --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" )  
      AnimPlay( "anm_pub_trader2", "hand", function()   end);
    end;  
  end;
end;


common_impl.hint[ "dlg_pub_trader1" ] = { type = "click", use_place = "gfx_pub_dlg_pub_trader1_zone", room = "rm_pub" };

private.dlg_pub_trader1_logic = function()
  ObjSet( "gfx_pub_whiskey_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_pub_bar", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_pub_behindcounter", { visible = 1, input = 1, active = 1 } ) 
  ObjSet( "gzz_pub_crockery", { visible = 1, input = 1, active = 1 } )  
end;
private.dlg_pub_trader1_beg = function()
  ObjDelete( "gfx_pub_dlg_pub_trader1_zone" );
end;
private.dlg_pub_trader1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_pub_trader1", private.dlg_pub_trader1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader1", private.dlg_pub_trader1_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader1", private.dlg_pub_trader1_logic );
cmn.AddSubscriber( "dlg_pub_trader1_beg", private.dlg_pub_trader1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader1_end", private.dlg_pub_trader1_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader1_end", private.dlg_pub_trader1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_pub_trader1( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_pub_trader1" );
    cmn.CallEventHandler( "dlg_pub_trader1_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_trader1");
  end;

  function public.dlg_pub_trader1_end()
    ObjSet( "dlg_pub_trader1", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_pub_trader1_beg" );
  -- common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  common_impl.dialog_character_loc = "anm_pub_anm_dealer"
  common_impl.continue_visible = false;
  common_impl.Start( "trader1", 3, nil, nil, true, "dlg_pub_trader1_end",{"aud_merchant_1_voc","aud_merchant_2_voc"} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_whiskey" ] = { type = "use", inv_obj = "inv_whiskey", use_place = "gfx_pub_whiskey_zone", room = "rm_pub" };

private.use_whiskey_logic = function()
  ObjSet( "gfx_pub_dlg_pub_trader2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_whiskey_inv = function()
  common_impl.ProcessMultiUseAll("whiskey", "whiskey")
end;
private.use_whiskey_beg = function()
  ObjDelete( "gfx_pub_whiskey_zone" );
end;
private.use_whiskey_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_whiskey", private.use_whiskey_inv );
cmn.AddSubscriber( "use_whiskey", private.use_whiskey_beg, private.room_objname );
cmn.AddSubscriber( "use_whiskey", private.use_whiskey_end, private.room_objname );
cmn.AddSubscriber( "use_whiskey", private.use_whiskey_logic );
cmn.AddSubscriber( "use_whiskey_inv", private.use_whiskey_inv, private.room_objname );
cmn.AddSubscriber( "use_whiskey_beg", private.use_whiskey_beg, private.room_objname );
cmn.AddSubscriber( "use_whiskey_end", private.use_whiskey_end, private.room_objname );
cmn.AddSubscriber( "use_whiskey_end", private.use_whiskey_logic );
--------------------------------------------------------------------------------------------
function public.use_whiskey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_whiskey" );
    cmn.CallEventHandler( "use_whiskey_end" );
    common_impl.Lock(0);
    public.dlg_pub_trader2();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_whiskey_inv" );
  cmn.CallEventHandler( "use_whiskey_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_whiskey_pub" )
  func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_pub_trader2" ] = { type = "click", use_place = "gfx_pub_dlg_pub_trader2_zone", room = "rm_pub" };

private.dlg_pub_trader2_logic = function()
  ObjSet( "spr_pub_notetrader", { visible = 1, input = 1, active = 1 } )
end;
private.dlg_pub_trader2_beg = function()
  ObjDelete( "gfx_pub_dlg_pub_trader2_zone" );
end;
private.dlg_pub_trader2_end = function()
  ObjDelete("anm_pub_anm_dealer");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_pub_trader2", private.dlg_pub_trader2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader2", private.dlg_pub_trader2_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader2", private.dlg_pub_trader2_logic );
cmn.AddSubscriber( "dlg_pub_trader2_beg", private.dlg_pub_trader2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader2_end", private.dlg_pub_trader2_end, private.room_objname );
cmn.AddSubscriber( "dlg_pub_trader2_end", private.dlg_pub_trader2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_pub_trader2( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_pub_trader2" );
    cmn.CallEventHandler( "dlg_pub_trader2_end" );
    cmn.SetEventDone( "get_notetrader" );
    if ObjGetRelations( "inv_notetrader" ).parent == "level_inv_hub" then
        ObjSet( "spr_pub_notetrader", {visible = 1} );
        cmn.CallEventHandler( "get_notetrader" );
    end
    common_impl.Lock(0);
    
  end;

  function public.dlg_pub_trader2_end()
    ObjSet( "dlg_pub_trader2", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_pub_trader2_beg" );
  -- common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  --common_impl.dialog_character_loc = "anm_pub_anm_dealer"
  ObjAnimate( "anm_pub_anm_dealer", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  common_impl.continue_visible = false;
  common_impl.Start( "trader2", 2, nil, nil, true, "dlg_pub_trader2_end",{"aud_merchant_3_voc"} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_notetrader" ] = { type = "get", get_obj = "spr_pub_notetrader", room = "rm_pub" };

private.get_notetrader_logic = function()
  
end;
private.get_notetrader_inv = function()
  interface.InventoryItemAdd("inv_notetrader","spr_pub_notetrader");
  ObjSet( "inv_notetrader", { drag = 0 } );
end;
private.get_notetrader_beg = function()
  ObjDelete("gfx_pub_notetrader")
end;
private.get_notetrader_end = function()
  
end;

cmn.AddSubscriber( "get_notetrader", private.get_notetrader_inv );
cmn.AddSubscriber( "get_notetrader", private.get_notetrader_beg, private.room_objname );
cmn.AddSubscriber( "get_notetrader", private.get_notetrader_end, private.room_objname );
cmn.AddSubscriber( "get_notetrader", private.get_notetrader_logic );
--------------------------------------------------------------------
function public.get_notetrader()
  cmn.SetEventDone( "get_notetrader" );
  cmn.CallEventHandler( "get_notetrader" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_crockery *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_dolly3" ] = { type = "get", get_obj = "spr_crockery_dolly3", room = "rm_pub", zz = "zz_crockery", zz_gate = "gzz_pub_crockery" };

private.get_dolly3_logic = function()
  
end;
private.get_dolly3_inv = function()
  interface.InventoryItemAdd("inv_dolly","spr_crockery_dolly3",function() level_inv.ProcessGetDollyAll( "get_dolly3" ) end);
end;
private.get_dolly3_beg = function()
  ObjDelete("gfx_crockery_dolly3")
end;
private.get_dolly3_end = function()
  if common_impl.ZzCompleteCheck("get_dolly3") then ObjSet( common_impl.hint["get_dolly3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_crockery_dolly3_sh");
  ObjDelete("spr_pub_dolly3");
end;

cmn.AddSubscriber( "get_dolly3", private.get_dolly3_inv );
cmn.AddSubscriber( "get_dolly3", private.get_dolly3_beg, private.room_objname );
cmn.AddSubscriber( "get_dolly3", private.get_dolly3_end, private.room_objname );
cmn.AddSubscriber( "get_dolly3", private.get_dolly3_logic );
--------------------------------------------------------------------
function public.get_dolly3()
  cmn.SetEventDone( "get_dolly3" );
  cmn.CallEventHandler( "get_dolly3" );
  if common_impl.ZzCompleteCheck("get_dolly3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_collar_zone_clk()  --rm_pub.use_collar_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_collar' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_crockery_anm_collar", "door_r_idle", func_end )  
end;  

common_impl.hint[ "use_collar" ] = { type = "use", inv_obj = "inv_collar", use_place = "gfx_crockery_collar_zone", room = "rm_pub", zz = "zz_crockery", zz_gate = "gzz_pub_crockery" };

private.use_collar_logic = function()
  ObjSet( "spr_crockery_ovalhandle", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_crockery_roosterpart", { visible = 1, input = 1, active = 1 } )

end;
private.use_collar_inv = function()
  common_impl.ProcessMultiUseAll("collar", "collar")
end;
private.use_collar_beg = function()
  ObjDelete( "gfx_crockery_collar_zone" );
end;
private.use_collar_end = function()
  if common_impl.ZzCompleteCheck("use_collar") then ObjSet( common_impl.hint["use_collar"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_crockery_anm_collar", {animfunc = "use_pendent", frame = 999 } );
  ObjSet( "spr_pub_doorr_open", {visible = 1} );
  ObjDelete("spr_pub_doorr_close")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_collar", private.use_collar_inv );
cmn.AddSubscriber( "use_collar", private.use_collar_beg, private.room_objname );
cmn.AddSubscriber( "use_collar", private.use_collar_end, private.room_objname );
cmn.AddSubscriber( "use_collar", private.use_collar_logic );
cmn.AddSubscriber( "use_collar_inv", private.use_collar_inv, private.room_objname );
cmn.AddSubscriber( "use_collar_beg", private.use_collar_beg, private.room_objname );
cmn.AddSubscriber( "use_collar_end", private.use_collar_end, private.room_objname );
cmn.AddSubscriber( "use_collar_end", private.use_collar_logic );
--------------------------------------------------------------------------------------------
function public.use_collar( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_collar" );
    cmn.CallEventHandler( "use_collar_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_collar") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_collar_inv" );
  cmn.CallEventHandler( "use_collar_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_crockery_anm_collar", "use_pendent", func_end );
  SoundSfx( "aud_use_heart_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ovalhandle" ] = { type = "get", get_obj = "spr_crockery_ovalhandle", room = "rm_pub", zz = "zz_crockery", zz_gate = "gzz_pub_crockery" };

private.get_ovalhandle_logic = function()
  
end;
private.get_ovalhandle_inv = function()
  interface.InventoryItemAdd("inv_ovalhandle","spr_crockery_ovalhandle");
end;
private.get_ovalhandle_beg = function()
  ObjDelete("gfx_crockery_ovalhandle")
end;
private.get_ovalhandle_end = function()
  if common_impl.ZzCompleteCheck("get_ovalhandle") then ObjSet( common_impl.hint["get_ovalhandle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_crockery_ovalhandle_sh");
  ObjDelete("spr_pub_ovalhandle");
end;

cmn.AddSubscriber( "get_ovalhandle", private.get_ovalhandle_inv );
cmn.AddSubscriber( "get_ovalhandle", private.get_ovalhandle_beg, private.room_objname );
cmn.AddSubscriber( "get_ovalhandle", private.get_ovalhandle_end, private.room_objname );
cmn.AddSubscriber( "get_ovalhandle", private.get_ovalhandle_logic );
--------------------------------------------------------------------
function public.get_ovalhandle()
  cmn.SetEventDone( "get_ovalhandle" );
  cmn.CallEventHandler( "get_ovalhandle" );
  if common_impl.ZzCompleteCheck("get_ovalhandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_roosterpart" ] = { type = "get", get_obj = "spr_crockery_roosterpart", room = "rm_pub", zz = "zz_crockery", zz_gate = "gzz_pub_crockery" };

private.get_roosterpart_logic = function()
  
end;
private.get_roosterpart_inv = function()
  interface.InventoryItemAdd("inv_roosterpart","spr_crockery_roosterpart");
end;
private.get_roosterpart_beg = function()
  ObjDelete("gfx_crockery_roosterpart")
end;
private.get_roosterpart_end = function()
  if common_impl.ZzCompleteCheck("get_roosterpart") then ObjSet( common_impl.hint["get_roosterpart"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_crockery_roosterpart_sh");
  ObjDelete("spr_pub_roosterpart");
end;

cmn.AddSubscriber( "get_roosterpart", private.get_roosterpart_inv );
cmn.AddSubscriber( "get_roosterpart", private.get_roosterpart_beg, private.room_objname );
cmn.AddSubscriber( "get_roosterpart", private.get_roosterpart_end, private.room_objname );
cmn.AddSubscriber( "get_roosterpart", private.get_roosterpart_logic );
--------------------------------------------------------------------
function public.get_roosterpart()
  cmn.SetEventDone( "get_roosterpart" );
  cmn.CallEventHandler( "get_roosterpart" );
  if common_impl.ZzCompleteCheck("get_roosterpart") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_spoke_zone_clk()  --rm_pub.use_spoke_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_spoke' );
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_crockery_anm_spoke", "door_l_idle", func_end )  
end;  


common_impl.hint[ "use_spoke" ] = { type = "use", inv_obj = "inv_spoke", use_place = "gfx_crockery_spoke_zone", room = "rm_pub", zz = "zz_crockery", zz_gate = "gzz_pub_crockery" };

private.use_spoke_logic = function()
  ObjSet( "spr_crockery_archandle", { visible = 1, input = 1, active = 1 } )

end;
private.use_spoke_inv = function()
  common_impl.ProcessMultiUseAll("spoke", "spoke")
end;
private.use_spoke_beg = function()
  ObjDelete( "gfx_crockery_spoke_zone" );
end;
private.use_spoke_end = function()
  if common_impl.ZzCompleteCheck("use_spoke") then ObjSet( common_impl.hint["use_spoke"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_crockery_anm_spoke", {animfunc = "use_spoke", frame = 999 } );
  ObjSet( "spr_pub_doorl_open", {visible = 1} );
  ObjDelete("spr_pub_doorl_close");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_spoke", private.use_spoke_inv );
cmn.AddSubscriber( "use_spoke", private.use_spoke_beg, private.room_objname );
cmn.AddSubscriber( "use_spoke", private.use_spoke_end, private.room_objname );
cmn.AddSubscriber( "use_spoke", private.use_spoke_logic );
cmn.AddSubscriber( "use_spoke_inv", private.use_spoke_inv, private.room_objname );
cmn.AddSubscriber( "use_spoke_beg", private.use_spoke_beg, private.room_objname );
cmn.AddSubscriber( "use_spoke_end", private.use_spoke_end, private.room_objname );
cmn.AddSubscriber( "use_spoke_end", private.use_spoke_logic );
--------------------------------------------------------------------------------------------
function public.use_spoke( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_spoke" );
    cmn.CallEventHandler( "use_spoke_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_spoke") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_spoke_inv" );
  cmn.CallEventHandler( "use_spoke_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_crockery_anm_spoke", "use_spoke", func_end );
  SoundSfx( "aud_use_spoke_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_archandle" ] = { type = "get", get_obj = "spr_crockery_archandle", room = "rm_pub", zz = "zz_crockery", zz_gate = "gzz_pub_crockery" };

private.get_archandle_logic = function()
  
end;
private.get_archandle_inv = function()
  interface.InventoryItemAdd("inv_archandle","spr_crockery_archandle");
end;
private.get_archandle_beg = function()
  ObjDelete("gfx_crockery_archandle")
end;
private.get_archandle_end = function()
  if common_impl.ZzCompleteCheck("get_archandle") then ObjSet( common_impl.hint["get_archandle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_crockery_archandle_sh");
  ObjDelete("spr_pub_archandle");
end;

cmn.AddSubscriber( "get_archandle", private.get_archandle_inv );
cmn.AddSubscriber( "get_archandle", private.get_archandle_beg, private.room_objname );
cmn.AddSubscriber( "get_archandle", private.get_archandle_end, private.room_objname );
cmn.AddSubscriber( "get_archandle", private.get_archandle_logic );
--------------------------------------------------------------------
function public.get_archandle()
  cmn.SetEventDone( "get_archandle" );
  cmn.CallEventHandler( "get_archandle" );
  if common_impl.ZzCompleteCheck("get_archandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_behindcounter *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_ovalhandle_zone_clk()  --rm_pub.use_ovalhandle_zone_clk()
  local func_end = function() 
    ld.Lock(0); 
    common_impl.ShowBbt( 'need_ovalhandle' )
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_behindcounter_anm_handle", "idle_1", func_end )
   --func_end();
end;  


common_impl.hint[ "use_ovalhandle" ] = { type = "use", inv_obj = "inv_ovalhandle", use_place = "gfx_behindcounter_ovalhandle_zone", room = "rm_pub", zz = "zz_behindcounter", zz_gate = "gzz_pub_behindcounter" };

private.use_ovalhandle_logic = function()
  ObjSet( "spr_behindcounter_hook", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_behindcounter_hook", {active  = 1, visible = 1} );
  
end;
private.use_ovalhandle_inv = function()
  common_impl.ProcessMultiUseAll("ovalhandle", "ovalhandle")
end;
private.use_ovalhandle_beg = function()
  ObjDelete( "gfx_behindcounter_ovalhandle_zone" );
end;
private.use_ovalhandle_end = function()
  if common_impl.ZzCompleteCheck("use_ovalhandle") then ObjSet( common_impl.hint["use_ovalhandle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_behindcounter_anm_handle", {animfunc = "use_handl", frame = 999 } );
  ObjSet( "spr_behindcounter_hook_sh", {visible = 1} );
  ObjDelete("spr_pub_handle");
  ObjSet( "spr_pub_handle_open", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ovalhandle", private.use_ovalhandle_inv );
cmn.AddSubscriber( "use_ovalhandle", private.use_ovalhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_ovalhandle", private.use_ovalhandle_end, private.room_objname );
cmn.AddSubscriber( "use_ovalhandle", private.use_ovalhandle_logic );
cmn.AddSubscriber( "use_ovalhandle_inv", private.use_ovalhandle_inv, private.room_objname );
cmn.AddSubscriber( "use_ovalhandle_beg", private.use_ovalhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_ovalhandle_end", private.use_ovalhandle_end, private.room_objname );
cmn.AddSubscriber( "use_ovalhandle_end", private.use_ovalhandle_logic );
--------------------------------------------------------------------------------------------
function public.use_ovalhandle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ovalhandle" );
    cmn.CallEventHandler( "use_ovalhandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ovalhandle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ovalhandle_inv" );
  cmn.CallEventHandler( "use_ovalhandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_behindcounter_anm_handle", "use_handl", func_end );
  SoundSfx( "aud_use_ovalhandle_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hook" ] = { type = "get", get_obj = "spr_behindcounter_hook", room = "rm_pub", zz = "zz_behindcounter", zz_gate = "gzz_pub_behindcounter" };

private.get_hook_logic = function()
  
end;
private.get_hook_inv = function()
  interface.InventoryItemAdd("inv_hook","spr_behindcounter_hook");
end;
private.get_hook_beg = function()
  ObjDelete("gfx_behindcounter_hook")
end;
private.get_hook_end = function()
  if common_impl.ZzCompleteCheck("get_hook") then ObjSet( common_impl.hint["get_hook"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_behindcounter_hook_sh");
  ObjSet( "anm_behindcounter_anm_handle", {animfunc = "end_handl", frame = 0 } );
  ObjSet( "spr_behindcounter_teext_min", {input = 1, visible = 0} );
end;

cmn.AddSubscriber( "get_hook", private.get_hook_inv );
cmn.AddSubscriber( "get_hook", private.get_hook_beg, private.room_objname );
cmn.AddSubscriber( "get_hook", private.get_hook_end, private.room_objname );
cmn.AddSubscriber( "get_hook", private.get_hook_logic );
--------------------------------------------------------------------
function public.get_hook()
  ObjSet( "spr_behindcounter_hook", {visible = 1} );
  cmn.SetEventDone( "get_hook" );
  cmn.CallEventHandler( "get_hook" );
  if common_impl.ZzCompleteCheck("get_hook") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_rooster_zone_clk()  --rm_pub.use_rooster_zone_clk()
  local func_end = function() 
    ld.Lock(0); 
    common_impl.ShowBbt( 'need_rooster' )
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_behindcounter_anm_rooster", "idle_2", func_end )
   --func_end();
end;  

common_impl.hint[ "use_rooster" ] = { type = "use", inv_obj = "inv_rooster", use_place = "gfx_behindcounter_rooster_zone", room = "rm_pub", zz = "zz_behindcounter", zz_gate = "gzz_pub_behindcounter" };

private.use_rooster_logic = function()
  -- ObjSet( "gfx_behindcounter_clk_cleancounter_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_behindcounter_vanepart", { visible = 1, input = 1, active = 1 } )
end;
private.use_rooster_inv = function()
  common_impl.ProcessMultiUseAll("rooster", "rooster")
end;
private.use_rooster_beg = function()
  ObjDelete( "gfx_behindcounter_rooster_zone" );
end;
private.use_rooster_end = function()
  if common_impl.ZzCompleteCheck("use_rooster") then ObjSet( common_impl.hint["use_rooster"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_behindcounter_anm_rooster", {animfunc = "end_cock", frame = 0 } );
  ObjSet( "spr_behindcounter_vanepart_sh", {visible = 1} );
  ObjSet( "spr_pub_cover2_open", {visible = 1} );
  ObjDelete("spr_pub_cover4");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rooster", private.use_rooster_inv );
cmn.AddSubscriber( "use_rooster", private.use_rooster_beg, private.room_objname );
cmn.AddSubscriber( "use_rooster", private.use_rooster_end, private.room_objname );
cmn.AddSubscriber( "use_rooster", private.use_rooster_logic );
cmn.AddSubscriber( "use_rooster_inv", private.use_rooster_inv, private.room_objname );
cmn.AddSubscriber( "use_rooster_beg", private.use_rooster_beg, private.room_objname );
cmn.AddSubscriber( "use_rooster_end", private.use_rooster_end, private.room_objname );
cmn.AddSubscriber( "use_rooster_end", private.use_rooster_logic );
--------------------------------------------------------------------------------------------
function public.use_rooster( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rooster" );
    cmn.CallEventHandler( "use_rooster_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rooster") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rooster_inv" );
  cmn.CallEventHandler( "use_rooster_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_behindcounter_anm_rooster", "use_cock", func_end );
  SoundSfx( "aud_use_rooster_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_cleancounter" ] = { type = "click", use_place = "gfx_behindcounter_clk_cleancounter_zone", room = "rm_pub", zz = "zz_behindcounter", zz_gate = "gzz_pub_behindcounter" };
--
--private.clk_cleancounter_logic = function()
--  ObjSet( "spr_behindcounter_vanepart", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.clk_cleancounter_beg = function()
--  ObjDelete( "gfx_behindcounter_clk_cleancounter_zone" );
--end;
--private.clk_cleancounter_end = function()
--  if common_impl.ZzCompleteCheck("clk_cleancounter") then ObjSet( common_impl.hint["clk_cleancounter"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_cleancounter", private.clk_cleancounter_beg, private.room_objname );
--cmn.AddSubscriber( "clk_cleancounter", private.clk_cleancounter_end, private.room_objname );
--cmn.AddSubscriber( "clk_cleancounter", private.clk_cleancounter_logic );
--cmn.AddSubscriber( "clk_cleancounter_beg", private.clk_cleancounter_beg, private.room_objname );
--cmn.AddSubscriber( "clk_cleancounter_end", private.clk_cleancounter_end, private.room_objname );
--cmn.AddSubscriber( "clk_cleancounter_end", private.clk_cleancounter_logic );
----------------------------------------------------------------------------------------------
--function public.clk_cleancounter()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_cleancounter" );
--    cmn.CallEventHandler( "clk_cleancounter_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_cleancounter") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_cleancounter_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  SoundSfx( "aud_clk_cleancounter_pub" )
--  func_end()
--
--end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_vanepart" ] = { type = "get", get_obj = "spr_behindcounter_vanepart", room = "rm_pub", zz = "zz_behindcounter", zz_gate = "gzz_pub_behindcounter" };

private.get_vanepart_logic = function()
  
end;
private.get_vanepart_inv = function()
  interface.InventoryItemAdd("inv_vanepart","spr_behindcounter_vanepart");
end;
private.get_vanepart_beg = function()
  ObjDelete("gfx_behindcounter_vanepart")
end;
private.get_vanepart_end = function()
  if common_impl.ZzCompleteCheck("get_vanepart") then ObjSet( common_impl.hint["get_vanepart"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_behindcounter_vanepart_sh");
end;

cmn.AddSubscriber( "get_vanepart", private.get_vanepart_inv );
cmn.AddSubscriber( "get_vanepart", private.get_vanepart_beg, private.room_objname );
cmn.AddSubscriber( "get_vanepart", private.get_vanepart_end, private.room_objname );
cmn.AddSubscriber( "get_vanepart", private.get_vanepart_logic );
--------------------------------------------------------------------
function public.get_vanepart()
  cmn.SetEventDone( "get_vanepart" );
  cmn.CallEventHandler( "get_vanepart" );
  if common_impl.ZzCompleteCheck("get_vanepart") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_apple_zone_clk()  --rm_pub.use_apple_zone_clk()
  local func_end = function() 
    ld.Lock(0); 
    common_impl.ShowBbt( 'need_apple' )
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_behindcounter_anm_apple", "idle_3", func_end )
  -- func_end();
end;  


common_impl.hint[ "use_apple" ] = { type = "use", inv_obj = "inv_apple", use_place = "gfx_behindcounter_apple_zone", room = "rm_pub", zz = "zz_behindcounter", zz_gate = "gzz_pub_behindcounter" };

private.use_apple_logic = function()
  ObjSet( "spr_behindcounter_dolly4", { visible = 1, input = 1, active = 1 } )

end;
private.use_apple_inv = function()
  common_impl.ProcessMultiUseAll("apple", "apple")
end;
private.use_apple_beg = function()
  ObjDelete( "gfx_behindcounter_apple_zone" );
end;
private.use_apple_end = function()
  if common_impl.ZzCompleteCheck("use_apple") then ObjSet( common_impl.hint["use_apple"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_behindcounter_anm_apple", {animfunc = "end_apple", frame = 0 } );
  ObjSet( "spr_behindcounter_dolly4_sh", {visible = 1} );
  ObjSet( "spr_pub_cover_open", {visible = 1} );
  ObjDelete("spr_pub_cover3");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_apple", private.use_apple_inv );
cmn.AddSubscriber( "use_apple", private.use_apple_beg, private.room_objname );
cmn.AddSubscriber( "use_apple", private.use_apple_end, private.room_objname );
cmn.AddSubscriber( "use_apple", private.use_apple_logic );
cmn.AddSubscriber( "use_apple_inv", private.use_apple_inv, private.room_objname );
cmn.AddSubscriber( "use_apple_beg", private.use_apple_beg, private.room_objname );
cmn.AddSubscriber( "use_apple_end", private.use_apple_end, private.room_objname );
cmn.AddSubscriber( "use_apple_end", private.use_apple_logic );
--------------------------------------------------------------------------------------------
function public.use_apple( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_apple" );
    cmn.CallEventHandler( "use_apple_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_apple") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_apple_inv" );
  cmn.CallEventHandler( "use_apple_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_behindcounter_anm_apple", "use_apple", func_end );
  SoundSfx( "aud_use_apple_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dolly4" ] = { type = "get", get_obj = "spr_behindcounter_dolly4", room = "rm_pub", zz = "zz_behindcounter", zz_gate = "gzz_pub_behindcounter" };

private.get_dolly4_logic = function()
  
end;
private.get_dolly4_inv = function()
  interface.InventoryItemAdd("inv_dolly","spr_behindcounter_dolly4",function() level_inv.ProcessGetDollyAll( "get_dolly4" ) end);
end;
private.get_dolly4_beg = function()
  ObjDelete("gfx_behindcounter_dolly4")
end;
private.get_dolly4_end = function()
  if common_impl.ZzCompleteCheck("get_dolly4") then ObjSet( common_impl.hint["get_dolly4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_behindcounter_dolly4_sh");
end;

cmn.AddSubscriber( "get_dolly4", private.get_dolly4_inv );
cmn.AddSubscriber( "get_dolly4", private.get_dolly4_beg, private.room_objname );
cmn.AddSubscriber( "get_dolly4", private.get_dolly4_end, private.room_objname );
cmn.AddSubscriber( "get_dolly4", private.get_dolly4_logic );
--------------------------------------------------------------------
function public.get_dolly4()
  cmn.SetEventDone( "get_dolly4" );
  cmn.CallEventHandler( "get_dolly4" );
  if common_impl.ZzCompleteCheck("get_dolly4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bar *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_archandle_zone_clk()  --rm_pub.use_archandle_zone_clk()
  local func_end = function()
    ld.Lock(0);   
    common_impl.ShowBbt( 'need_archandle' ); 
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_bar_anm_handle", "idle_cover1", func_end )
end;  



common_impl.hint[ "use_archandle" ] = { type = "use", inv_obj = "inv_archandle", use_place = "gfx_bar_archandle_zone", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.use_archandle_logic = function()
  ObjSet( "spr_bar_apple", { visible = 1, input = 1, active = 1 } )

end;
private.use_archandle_inv = function()
  common_impl.ProcessMultiUseAll("archandle", "archandle")
end;
private.use_archandle_beg = function()
  ObjDelete( "gfx_bar_archandle_zone" );
end;
private.use_archandle_end = function()
  if common_impl.ZzCompleteCheck("use_archandle") then ObjSet( common_impl.hint["use_archandle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_bar_anm_handle", {animfunc = "end_handle", frame = 0 } );
  ObjSet( "spr_bar_apple_sh", {visible = 1} );
  ObjDelete("spr_pub_bar_close_2");
  ObjSet( "spr_pub_bar_open2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_archandle", private.use_archandle_inv );
cmn.AddSubscriber( "use_archandle", private.use_archandle_beg, private.room_objname );
cmn.AddSubscriber( "use_archandle", private.use_archandle_end, private.room_objname );
cmn.AddSubscriber( "use_archandle", private.use_archandle_logic );
cmn.AddSubscriber( "use_archandle_inv", private.use_archandle_inv, private.room_objname );
cmn.AddSubscriber( "use_archandle_beg", private.use_archandle_beg, private.room_objname );
cmn.AddSubscriber( "use_archandle_end", private.use_archandle_end, private.room_objname );
cmn.AddSubscriber( "use_archandle_end", private.use_archandle_logic );
--------------------------------------------------------------------------------------------
function public.use_archandle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_archandle" );
    cmn.CallEventHandler( "use_archandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_archandle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_archandle_inv" );
  cmn.CallEventHandler( "use_archandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bar_anm_handle", "use_handle", func_end );
  SoundSfx( "aud_use_archandle_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_apple" ] = { type = "get", get_obj = "spr_bar_apple", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.get_apple_logic = function()
  
end;
private.get_apple_inv = function()
  interface.InventoryItemAdd("inv_apple","spr_bar_apple");
end;
private.get_apple_beg = function()
  ObjDelete("gfx_bar_apple")
end;
private.get_apple_end = function()
  if common_impl.ZzCompleteCheck("get_apple") then ObjSet( common_impl.hint["get_apple"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bar_apple_sh");
end;

cmn.AddSubscriber( "get_apple", private.get_apple_inv );
cmn.AddSubscriber( "get_apple", private.get_apple_beg, private.room_objname );
cmn.AddSubscriber( "get_apple", private.get_apple_end, private.room_objname );
cmn.AddSubscriber( "get_apple", private.get_apple_logic );
--------------------------------------------------------------------
function public.get_apple()
  cmn.SetEventDone( "get_apple" );
  cmn.CallEventHandler( "get_apple" );
  if common_impl.ZzCompleteCheck("get_apple") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_barkey_zone_clk()  --rm_pub.use_barkey_zone_clk()
  local func_end = function()
    ld.Lock(0);   
    common_impl.ShowBbt( 'need_barkey' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_bar_anm_barkey", "idle_cover", func_end )
end;  


common_impl.hint[ "use_barkey" ] = { type = "use", inv_obj = "inv_barkey", use_place = "gfx_bar_barkey_zone", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.use_barkey_logic = function()
  ObjSet( "spr_bar_whiskey", { visible = 1, input = 1, active = 1 } )

end;
private.use_barkey_inv = function()
  common_impl.ProcessMultiUseAll("barkey", "barkey")
end;
private.use_barkey_beg = function()
  ObjDelete( "gfx_bar_barkey_zone" );
end;
private.use_barkey_end = function()
  if common_impl.ZzCompleteCheck("use_barkey") then ObjSet( common_impl.hint["use_barkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_bar_anm_barkey", {animfunc = "end_key", frame = 0 } );
  ObjSet( "spr_bar_whiskey_sh", {visible = 1} );
  ObjDelete("spr_pub_bar_open");
  ObjDelete("spr_pub_bar_close");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_barkey", private.use_barkey_inv );
cmn.AddSubscriber( "use_barkey", private.use_barkey_beg, private.room_objname );
cmn.AddSubscriber( "use_barkey", private.use_barkey_end, private.room_objname );
cmn.AddSubscriber( "use_barkey", private.use_barkey_logic );
cmn.AddSubscriber( "use_barkey_inv", private.use_barkey_inv, private.room_objname );
cmn.AddSubscriber( "use_barkey_beg", private.use_barkey_beg, private.room_objname );
cmn.AddSubscriber( "use_barkey_end", private.use_barkey_end, private.room_objname );
cmn.AddSubscriber( "use_barkey_end", private.use_barkey_logic );
--------------------------------------------------------------------------------------------
function public.use_barkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_barkey" );
    cmn.CallEventHandler( "use_barkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_barkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_barkey_inv" );
  cmn.CallEventHandler( "use_barkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bar_anm_barkey", "use_key", func_end );
  SoundSfx( "aud_use_barkey_pub" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_whiskey" ] = { type = "get", get_obj = "spr_bar_whiskey", room = "rm_pub", zz = "zz_bar", zz_gate = "gzz_pub_bar" };

private.get_whiskey_logic = function()
  
end;
private.get_whiskey_inv = function()
  interface.InventoryItemAdd("inv_whiskey","spr_bar_whiskey");
end;
private.get_whiskey_beg = function()
  ObjDelete("gfx_bar_whiskey")
end;
private.get_whiskey_end = function()
  if common_impl.ZzCompleteCheck("get_whiskey") then ObjSet( common_impl.hint["get_whiskey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bar_whiskey_sh");
  ObjDelete("spr_pub_whiskey");
end;

cmn.AddSubscriber( "get_whiskey", private.get_whiskey_inv );
cmn.AddSubscriber( "get_whiskey", private.get_whiskey_beg, private.room_objname );
cmn.AddSubscriber( "get_whiskey", private.get_whiskey_end, private.room_objname );
cmn.AddSubscriber( "get_whiskey", private.get_whiskey_logic );
--------------------------------------------------------------------
function public.get_whiskey()
  cmn.SetEventDone( "get_whiskey" );
  cmn.CallEventHandler( "get_whiskey" );
  if common_impl.ZzCompleteCheck("get_whiskey") then ld.CloseSubRoom() end;
  if port.isPortable()==1 then
    iOS_RateMe();
  end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_pub();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_pub_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_bar" );
  function zz_bar.Open()
  end;
  function zz_bar.PreOpen()
  end;
  function zz_bar.PreClose()
  end;
  function zz_bar.Close()
  end;

  subroom.Define( "zz_behindcounter" );
  function zz_behindcounter.Open()
  end;
  function zz_behindcounter.PreOpen()
  end;
  function zz_behindcounter.PreClose()
  end;
  function zz_behindcounter.Close()
  end;

  subroom.Define( "zz_crockery" );
  function zz_crockery.Open()
  end;
  function zz_crockery.PreOpen()
  end;
  function zz_crockery.PreClose()
  end;
  function zz_crockery.Close()
  end;
  
end;
--*********************************************************************************************************************