-- name=rm_residence
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_residence";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("obj_flowerdecor_text", "spr_flowerdecor_text_big","herbs_page_clk")    
  --------------------------------------------------------------------------------------------
function private.opn_residence()
  if not ( cmn.IsEventDone( "opn_residence" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_residence" );
      cmn.CallEventHandler( "opn_residence" )
      ld.ShowBbt( "opn_residence" )
      SoundTheme( "aud_danger_moment3_mus" );
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_residence = function() end;
local opn_residence_logic = function() end;
cmn.AddSubscriber( "opn_residence", opn_residence_logic )
cmn.AddSubscriber( "opn_residence", opn_residence, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_upstairsdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_pouch" ] = { type = "get", get_obj = "spr_upstairsdoor_pouch", room = "rm_residence", zz = "zz_upstairsdoor", zz_gate = "gzz_residence_upstairsdoor" };

private.get_pouch_logic = function()
  
end;
private.get_pouch_inv = function()
  interface.InventoryItemAdd("inv_pouch","spr_upstairsdoor_pouch");
  ObjSet( "inv_pouch", { drag = 0 } );
end;
private.get_pouch_beg = function()
  ObjDelete("gfx_upstairsdoor_pouch")
end;
private.get_pouch_end = function()
  ObjDelete("spr_upstairsdoor_pouch_sh2")
  if common_impl.ZzCompleteCheck("get_pouch") then ObjSet( common_impl.hint["get_pouch"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pouch", private.get_pouch_inv );
cmn.AddSubscriber( "get_pouch", private.get_pouch_beg, private.room_objname );
cmn.AddSubscriber( "get_pouch", private.get_pouch_end, private.room_objname );
cmn.AddSubscriber( "get_pouch", private.get_pouch_logic );
--------------------------------------------------------------------
function public.get_pouch()
  cmn.SetEventDone( "get_pouch" );
  cmn.CallEventHandler( "get_pouch" );
  if common_impl.ZzCompleteCheck("get_pouch") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cathead" ] = { type = "use", inv_obj = "inv_cathead", use_place = "gfx_upstairsdoor_cathead_zone", room = "rm_residence", zz = "zz_upstairsdoor", zz_gate = "gzz_residence_upstairsdoor" };

private.use_cathead_logic = function()
  ObjSet( "spr_upstairsdoor_bladehandle", { visible = 1, input = 1, active = 1 } )

end;
private.use_cathead_inv = function()
  common_impl.ProcessMultiUseAll("cathead", "cathead")
end;
private.use_cathead_beg = function()
  ObjDelete( "gfx_upstairsdoor_cathead_zone" );
end;
private.use_cathead_end = function()
  ObjSet("anm_pantry_cathead",{animfunc="cat_end",frame=0})
  ObjSet("spr_upstairsdoor_bladehandle_sh",{visible=1})
  if common_impl.ZzCompleteCheck("use_cathead") then ObjSet( common_impl.hint["use_cathead"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cathead", private.use_cathead_inv );
cmn.AddSubscriber( "use_cathead", private.use_cathead_beg, private.room_objname );
cmn.AddSubscriber( "use_cathead", private.use_cathead_end, private.room_objname );
cmn.AddSubscriber( "use_cathead", private.use_cathead_logic );
cmn.AddSubscriber( "use_cathead_inv", private.use_cathead_inv, private.room_objname );
cmn.AddSubscriber( "use_cathead_beg", private.use_cathead_beg, private.room_objname );
cmn.AddSubscriber( "use_cathead_end", private.use_cathead_end, private.room_objname );
cmn.AddSubscriber( "use_cathead_end", private.use_cathead_logic );
--------------------------------------------------------------------------------------------
function public.use_cathead( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cathead" );
    cmn.CallEventHandler( "use_cathead_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cathead") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cathead_inv" );
  cmn.CallEventHandler( "use_cathead_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pantry_cathead", "use_cat_head", func_end );
  SoundSfx( "aud_use_cathead_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bladehandle" ] = { type = "get", get_obj = "spr_upstairsdoor_bladehandle", room = "rm_residence", zz = "zz_upstairsdoor", zz_gate = "gzz_residence_upstairsdoor" };

private.get_bladehandle_logic = function()
  
end;
private.get_bladehandle_inv = function()
  interface.InventoryItemAdd("inv_bladehandle","spr_upstairsdoor_bladehandle");
end;
private.get_bladehandle_beg = function()
  ObjDelete("gfx_upstairsdoor_bladehandle")
end;
private.get_bladehandle_end = function()
  ObjDelete("spr_upstairsdoor_bladehandle_sh")
  if common_impl.ZzCompleteCheck("get_bladehandle") then ObjSet( common_impl.hint["get_bladehandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bladehandle", private.get_bladehandle_inv );
cmn.AddSubscriber( "get_bladehandle", private.get_bladehandle_beg, private.room_objname );
cmn.AddSubscriber( "get_bladehandle", private.get_bladehandle_end, private.room_objname );
cmn.AddSubscriber( "get_bladehandle", private.get_bladehandle_logic );
--------------------------------------------------------------------
function public.get_bladehandle()
  cmn.SetEventDone( "get_bladehandle" );
  cmn.CallEventHandler( "get_bladehandle" );
  if common_impl.ZzCompleteCheck("get_bladehandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_numeral" ] = { type = "use", inv_obj = "inv_numeral", use_place = "gfx_upstairsdoor_numeral_zone", room = "rm_residence", zz = "zz_upstairsdoor", zz_gate = "gzz_residence_upstairsdoor" };

private.use_numeral_logic = function()
  ObjSet( "gfx_upstairsdoor_win_codelock_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_numeral_inv = function()
  common_impl.ProcessMultiUseAll("numeral", "numeral")
end;
private.use_numeral_beg = function()
  ObjDelete( "gfx_upstairsdoor_numeral_zone" );
end;
private.use_numeral_end = function()
  ObjSet("anm_pantry_numeral",{animfunc="mmg_win",frame=0})
  ObjSet("obj_upstairsdoor_codelock_mmg_root",{input=1})
  if common_impl.ZzCompleteCheck("use_numeral") then ObjSet( common_impl.hint["use_numeral"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_numeral", private.use_numeral_inv );
cmn.AddSubscriber( "use_numeral", private.use_numeral_beg, private.room_objname );
cmn.AddSubscriber( "use_numeral", private.use_numeral_end, private.room_objname );
cmn.AddSubscriber( "use_numeral", private.use_numeral_logic );
cmn.AddSubscriber( "use_numeral_inv", private.use_numeral_inv, private.room_objname );
cmn.AddSubscriber( "use_numeral_beg", private.use_numeral_beg, private.room_objname );
cmn.AddSubscriber( "use_numeral_end", private.use_numeral_end, private.room_objname );
cmn.AddSubscriber( "use_numeral_end", private.use_numeral_logic );
--------------------------------------------------------------------------------------------
function public.use_numeral( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_numeral" );
    cmn.CallEventHandler( "use_numeral_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_numeral") then ld.CloseSubRoom() end;
    cmn.MiniGameShow( "codelock" );
    private.codelock_loadstate()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_numeral_inv" );
  cmn.CallEventHandler( "use_numeral_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pantry_numeral", "use_5", func_end );
  SoundSfx( "aud_use_numeral_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_codelock" ] = { type = "click", use_place = "gfx_upstairsdoor_win_codelock_zone", room = "rm_residence", zz = "zz_upstairsdoor", zz_gate = "gzz_residence_upstairsdoor" };

private.win_codelock_logic = function()
  if cmn.IsEventDone( "win_codelock" ) then
    ObjSet( "grm_residence_secondfloor", { visible = 1, input = 1, active = 1 } )
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_residence_secondfloor_focus");
    end;
  end
end;
private.win_codelock_beg = function()
  if cmn.IsEventDone( "win_codelock" ) then  
    ObjDelete( "gfx_upstairsdoor_win_codelock_zone" );
  end
end;
private.win_codelock_end = function()
  if cmn.IsEventDone( "win_codelock" ) then
    ObjSet("spr_residence_second_floor_door",{alp=1})
    if common_impl.ZzCompleteCheck("win_codelock") then ObjSet( common_impl.hint["win_codelock"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_codelock", private.win_codelock_beg, private.room_objname );
cmn.AddSubscriber( "win_codelock", private.win_codelock_end, private.room_objname );
cmn.AddSubscriber( "win_codelock", private.win_codelock_logic );
cmn.AddSubscriber( "win_codelock_beg", private.win_codelock_beg, private.room_objname );
cmn.AddSubscriber( "win_codelock_end", private.win_codelock_end, private.room_objname );
cmn.AddSubscriber( "win_codelock_end", private.win_codelock_logic );
--------------------------------------------------------------------------------------------
function public.win_codelock()

  local func_end = function()
    cmn.SetEventDone( "win_codelock" );
    cmn.CallEventHandler( "win_codelock_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_codelock") then ld.CloseSubRoom() end;
    
  end;
      cmn.MiniGameHide( "codelock", true );  
  cmn.CallEventHandler( "win_codelock_beg" );
  common_impl.Lock(1);

  
  ld.AnimPlay( "anm_pantry_numeral", "mmg_win", func_end );
  SoundSfx( "aud_mg_upstairsdoor_win" )


end;
--------------------------------------------------------------------------------------------
--mmg_codelock

private.codelock_pos = {
  {5,-124},{81,-124},{158,-125},
  {4,-58}, {81,-58}, {159,-58},
  {3,8},   {81,8},   {158,8},  
}

function private.codelock_loadstate()
  if not ng_global.progress["std"]["win_codelock"].state then
    ng_global.progress["std"]["win_codelock"].state = {7,8,9,4,5,6,1,2,3}
  end
  
  
  local s = ng_global.progress["std"]["win_codelock"].state
  if not private.codelock_creatobj then
    private.codelock_creat()
  end
  for j=1,9 do
    local part = "spr_upstairsdoor_codelock_part_"..s[j]
    ObjSet(part,{pos_x=private.codelock_pos[j][1],pos_y=private.codelock_pos[j][2]})
  end
  private.codelock_check()
end

function private.codelock_creat()
  private.codelock_creatobj=true
  local s = ng_global.progress["std"]["win_codelock"].state
    for i=1,9 do
    local obj = "obj_upstairsdoor_codelock_clk_zone_part_"..i
    ObjCreate(obj,"obj")
    ObjAttach(obj,"obj_upstairsdoor_codelock_mmg_root")
    ObjSet(obj,{pos_x=private.codelock_pos[i][1],pos_y=private.codelock_pos[i][2],pos_z=3,
    event_mdown = function()rm_residence.codelock_mdown(obj) end ,
    event_menter = function()rm_residence.codelock_menter(obj) end ,
    event_mleave = function()rm_residence.codelock_mleave(obj) end ,
      inputrect_init = 1, inputrect_x=-30,inputrect_y=-30,
     inputrect_w=60,inputrect_h=60 
    
    })
   local spr = "spr_upstairsdoor_codelock_part_"..i
    ObjCreate(spr,"spr")
    ObjAttach(spr,"obj_upstairsdoor_codelock_mmg_root")
    ObjSet(spr,{input=0,res="assets/levels/level/rm_residence/zz_upstairsdoor/"..i})
   local spr_focus = "spr_upstairsdoor_codelock_part_"..i.."_focus"    
    ObjCreate(spr_focus,"spr")
    ObjAttach(spr_focus,spr)
    ObjSet(spr_focus,{input=0,blendmode="2",alp=0,res="assets/levels/level/rm_residence/zz_upstairsdoor/"..i})
    
  end
  
end
private.codelock_check_old_win_count = 0; -- for sound
private.codelock_check_first_start_flag = false; 
function private.codelock_check()
  local s=ng_global.progress["std"]["win_codelock"].state
   
  local win_count = 0
  if (s[1]-s[2]+s[3])==4 then
    win_count = win_count +1 
    ObjAnimate( "spr_upstairsdoor_4_win_light", 8, 0, 0, "", {0,0,ObjGet("spr_upstairsdoor_4_win_light").alp, 0.2,0,1} );
  else   
    ObjAnimate( "spr_upstairsdoor_4_win_light", 8, 0, 0, "", {0,0,ObjGet("spr_upstairsdoor_4_win_light").alp, 0.2,0,0} );    
  end
  if (s[4]+s[5]+s[6])==10 then
    win_count = win_count +1 
    ObjAnimate( "spr_upstairsdoor_10_win_light", 8, 0, 0, "", {0,0,ObjGet("spr_upstairsdoor_10_win_light").alp, 0.2,0,1} );    
  else   
    ObjAnimate( "spr_upstairsdoor_10_win_light", 8, 0, 0, "", {0,0,ObjGet("spr_upstairsdoor_10_win_light").alp, 0.2,0,0} );    
  end
  if (s[7]-s[8]+s[9])==11 then
    win_count = win_count +1  
    ObjAnimate( "spr_upstairsdoor_11_win_light", 8, 0, 0, "", {0,0,ObjGet("spr_upstairsdoor_11_win_light").alp, 0.2,0,1} );
  else   
    ObjAnimate( "spr_upstairsdoor_11_win_light", 8, 0, 0, "", {0,0,ObjGet("spr_upstairsdoor_11_win_light").alp, 0.2,0,0} );    
  end
  ld.Lock(1)

  if win_count == 3 then
    
    ld.StartTimer( "tmr_codelock_check", 0.45,function()public.win_codelock() end)
  else
    ld.StartTimer( "tmr_codelock_check", 0.45,function()ld.Lock(0); end)
  end
  
  if private.codelock_check_first_start_flag==true then
     if private.codelock_check_old_win_count<win_count then 
         SoundSfx( "aud_mg_upstairsdoor_true" );
     end;
  else 
     private.codelock_check_first_start_flag = true;    
  end; 
  private.codelock_check_old_win_count = win_count; 
end
private.codelock_curpart = nil
function public.codelock_mdown(obj)
  SoundSfx( "aud_mg_upstairsdoor_click" );
  
  local s = ng_global.progress["std"]["win_codelock"].state
  local num = tonumber(ld.StringDivide(obj)[7])
    
  if not private.codelock_curpart then
    private.codelock_curpart = num
    ld.Lock(1)
    ObjAnimate( "spr_upstairsdoor_codelock_part_"..s[num], 6, 0, 0, function()ld.Lock(0)end, {0,0,1,1, 0.1,0,0.9,0.9} );    
  elseif private.codelock_curpart and private.codelock_curpart ~= num then
    local obj1 = "spr_upstairsdoor_codelock_part_"..s[num]
    local obj2 = "spr_upstairsdoor_codelock_part_"..s[private.codelock_curpart]
    local temp_num = ng_global.progress["std"]["win_codelock"].state[num]
    ld.Lock(1)
    ObjAnimate( "spr_upstairsdoor_codelock_part_"..s[num], 6, 0, 0, function()end, {0,0,1,1, 0.1,0,0.9,0.9} );    
    ng_global.progress["std"]["win_codelock"].state[num]=ng_global.progress["std"]["win_codelock"].state[private.codelock_curpart]
    ng_global.progress["std"]["win_codelock"].state[private.codelock_curpart]=temp_num
    

    
    local f_end = function ()
      private.codelock_loadstate()
      private.codelock_curpart = nil
      ObjAnimate( obj1, 6, 0, 0, "", {0,0,0.9,0.9, 0.1,0,1,1} );
      ObjAnimate( obj2, 6, 0, 0, "", {0,0,0.9,0.9, 0.1,0,1,1} );      
      ObjAnimate( obj1, 8, 0, 0, "", {0,0,1, 0.3,0,1} );
      ObjAnimate( obj2, 8, 0, 0, function()end, {0,0,1, 0.4,0,1} );  
    end
    local obj_focus = obj1.."_focus"   
    ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,0} ); 
  
    ObjAnimate( obj1, 8, 0, 0, "", {0,0,1,0.1,0,1, 0.5,0,0} );
    ObjAnimate( obj2, 8, 0, 0, f_end, {0,0,1,0.1,0,1, 0.5,0,0} ); 
    SoundSfx( "aud_mg_upstairsdoor_move" );
  elseif private.codelock_curpart and private.codelock_curpart == num then  
    ld.Lock(1)
    private.codelock_curpart = nil
    ObjAnimate( "spr_upstairsdoor_codelock_part_"..s[num], 6, 0, 0, function()ld.Lock(0)end, {0,0,0.9,0.9, 0.1,0,1,1} );    
  end
 
end



function public.codelock_menter(obj)
  ld.ShCur(CURSOR_HAND)
  local s = ng_global.progress["std"]["win_codelock"].state
  local num = tonumber(ld.StringDivide(obj)[7])
  local obj_focus = "spr_upstairsdoor_codelock_part_"..s[num].."_focus" 

  ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,1} );
end
function public.codelock_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  local s = ng_global.progress["std"]["win_codelock"].state
  local num = tonumber(ld.StringDivide(obj)[7])
  local obj_focus = "spr_upstairsdoor_codelock_part_"..s[num].."_focus"   
  ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,0} );  
end

function private.win_codelock_skip()
  ng_global.progress["std"]["win_codelock"].state = {9,6,1,5,3,2,7,4,8}
  private.codelock_curpart = nil
  private.codelock_skipreset_anim()
end

function private.win_codelock_reset()
  private.codelock_check_old_win_count = 0;
  private.codelock_check_first_start_flag = false;
  ng_global.progress["std"]["win_codelock"].state = {7,8,9,4,5,6,1,2,3}
  private.codelock_curpart = nil
  private.codelock_skipreset_anim()
end

function private.codelock_skipreset_anim()
  local f_end = function()
    private.codelock_loadstate()
    for j=1,9 do
      local obj= "spr_upstairsdoor_codelock_part_"..j 
      ObjAnimate( obj, 8, 0, 0, "", {0,0,0, 0.4,0,1} );
      ObjAnimate( obj, 6, 0, 0, "", {0,0,ObjGet(obj).scale_x,ObjGet(obj).scale_y, 0.1,0,1,1} );
    end   
   ld.StartTimer( "tmr_codelock_skipreset_lock", 0.4, function()end ) 
  end
  ld.Lock(1)
  for i=1,9 do
    local obj= "spr_upstairsdoor_codelock_part_"..i 
    ObjAnimate( obj, 8, 0, 0, "", {0,0,1, 0.4,0,0} );
    local obj_focus = obj.."_focus" 
    ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,0} );    
  end
  ld.StartTimer( "tmr_codelock_skipreset", 0.4, f_end )
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pantry *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bladehandle" ] = { type = "use", inv_obj = "inv_bladehandle", use_place = "gfx_pantry_bladehandle_zone", room = "rm_residence", zz = "zz_pantry", zz_gate = "gzz_residence_pantry" };

private.use_bladehandle_logic = function()
  ObjSet( "spr_pantry_blade", { visible = 1, input = 1, active = 1 } )

end;
private.use_bladehandle_inv = function()
  common_impl.ProcessMultiUseAll("bladehandle", "bladehandle")
end;
private.use_bladehandle_beg = function()
  ObjDelete( "gfx_pantry_bladehandle_zone" );
end;
private.use_bladehandle_end = function()
  ObjDelete("anm_pantry_blade")
  if common_impl.ZzCompleteCheck("use_bladehandle") then ObjSet( common_impl.hint["use_bladehandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bladehandle", private.use_bladehandle_inv );
cmn.AddSubscriber( "use_bladehandle", private.use_bladehandle_beg, private.room_objname );
cmn.AddSubscriber( "use_bladehandle", private.use_bladehandle_end, private.room_objname );
cmn.AddSubscriber( "use_bladehandle", private.use_bladehandle_logic );
cmn.AddSubscriber( "use_bladehandle_inv", private.use_bladehandle_inv, private.room_objname );
cmn.AddSubscriber( "use_bladehandle_beg", private.use_bladehandle_beg, private.room_objname );
cmn.AddSubscriber( "use_bladehandle_end", private.use_bladehandle_end, private.room_objname );
cmn.AddSubscriber( "use_bladehandle_end", private.use_bladehandle_logic );
--------------------------------------------------------------------------------------------
function public.use_bladehandle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bladehandle" );
    cmn.CallEventHandler( "use_bladehandle_end" );
    public.get_blade()
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bladehandle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bladehandle_inv" );
  cmn.CallEventHandler( "use_bladehandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pantry_blade", "blade", func_end );
  SoundSfx( "aud_use_bladehandle_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_blade" ] = { type = "get", get_obj = "spr_pantry_blade", room = "rm_residence", zz = "zz_pantry", zz_gate = "gzz_residence_pantry" };

private.get_blade_logic = function()
  
end;
private.get_blade_inv = function()
  interface.InventoryItemAdd("inv_blade","spr_pantry_blade");
end;
private.get_blade_beg = function()
  ObjDelete("gfx_pantry_blade")
end;
private.get_blade_end = function()
  ObjDelete("spr_residence_blade")
  if common_impl.ZzCompleteCheck("get_blade") then ObjSet( common_impl.hint["get_blade"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_blade", private.get_blade_inv );
cmn.AddSubscriber( "get_blade", private.get_blade_beg, private.room_objname );
cmn.AddSubscriber( "get_blade", private.get_blade_end, private.room_objname );
cmn.AddSubscriber( "get_blade", private.get_blade_logic );
--------------------------------------------------------------------
function public.get_blade()
  cmn.SetEventDone( "get_blade" );
  cmn.CallEventHandler( "get_blade" );
  if common_impl.ZzCompleteCheck("get_blade") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_blackheart" ] = { type = "use", inv_obj = "inv_blackheart", use_place = "gfx_pantry_blackheart_zone", room = "rm_residence", zz = "zz_pantry", zz_gate = "gzz_residence_pantry" };

private.use_blackheart_logic = function()
  ObjSet( "gfx_pantry_win_pantrydoor_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_blackheart_inv = function()
  common_impl.ProcessMultiUseAll("blackheart", "blackheart")
end;
private.use_blackheart_beg = function()
  ObjDelete( "gfx_pantry_blackheart_zone" );
end;
private.use_blackheart_end = function()
  ObjAttach("spr_pantry_pantrydoor_mmg_root","zz_pantry")
  ObjSet("spr_pantry_pantrydoor_mmg_root",{input=1})
  if common_impl.ZzCompleteCheck("use_blackheart") then ObjSet( common_impl.hint["use_blackheart"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_blackheart", private.use_blackheart_inv );
cmn.AddSubscriber( "use_blackheart", private.use_blackheart_beg, private.room_objname );
cmn.AddSubscriber( "use_blackheart", private.use_blackheart_end, private.room_objname );
cmn.AddSubscriber( "use_blackheart", private.use_blackheart_logic );
cmn.AddSubscriber( "use_blackheart_inv", private.use_blackheart_inv, private.room_objname );
cmn.AddSubscriber( "use_blackheart_beg", private.use_blackheart_beg, private.room_objname );
cmn.AddSubscriber( "use_blackheart_end", private.use_blackheart_end, private.room_objname );
cmn.AddSubscriber( "use_blackheart_end", private.use_blackheart_logic );
--------------------------------------------------------------------------------------------
function public.use_blackheart( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_blackheart" );
    cmn.CallEventHandler( "use_blackheart_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_blackheart") then ld.CloseSubRoom() end;
    cmn.MiniGameShow( "pantrydoor" );
    private.pantrydoor_loadstate()
  end;
  local f_step = function ()
    ObjAttach("spr_pantry_pantrydoor_mmg_root","zz_pantry")
    ObjAnimate( "spr_pantry_pantrydoor_mmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_blackheart_inv" );
  cmn.CallEventHandler( "use_blackheart_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pantry_door", "black_heart", f_step );
  SoundSfx( "aud_use_blackheart_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_pantrydoor" ] = { type = "click", use_place = "gfx_pantry_win_pantrydoor_zone", room = "rm_residence", zz = "zz_pantry", zz_gate = "gzz_residence_pantry" };

private.win_pantrydoor_logic = function()
  if cmn.IsEventDone( "win_pantrydoor" ) then  
    ObjSet( "gho_residence_pantryho", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_pantrydoor_beg = function()
  if cmn.IsEventDone( "win_pantrydoor" ) then    
    ObjDelete( "gfx_pantry_win_pantrydoor_zone" );
  end
end;
private.win_pantrydoor_end = function()
  if cmn.IsEventDone( "win_pantrydoor" ) then    
    ObjSet("spr_residence_ho_door",{alp=1})
    if common_impl.ZzCompleteCheck("win_pantrydoor") then ObjSet( common_impl.hint["win_pantrydoor"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_pantrydoor", private.win_pantrydoor_beg, private.room_objname );
cmn.AddSubscriber( "win_pantrydoor", private.win_pantrydoor_end, private.room_objname );
cmn.AddSubscriber( "win_pantrydoor", private.win_pantrydoor_logic );
cmn.AddSubscriber( "win_pantrydoor_beg", private.win_pantrydoor_beg, private.room_objname );
cmn.AddSubscriber( "win_pantrydoor_end", private.win_pantrydoor_end, private.room_objname );
cmn.AddSubscriber( "win_pantrydoor_end", private.win_pantrydoor_logic );
--------------------------------------------------------------------------------------------
function public.win_pantrydoor()

  local func_end = function()
    cmn.SetEventDone( "win_pantrydoor" );
    cmn.CallEventHandler( "win_pantrydoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_pantrydoor") then ld.CloseSubRoom() end;
  end;
  cmn.MiniGameHide( "pantrydoor", true );  
  cmn.CallEventHandler( "win_pantrydoor_beg" );
  common_impl.Lock(1);

  ObjAnimate( "spr_pantry_heart_"..1, 6, 0, 0, "", {0,0,1,1, 0.3,0,0.9,0.9,0.6,0,1,1} );
  ObjAnimate( "spr_pantry_heart_"..2, 6, 0, 0, "", {0,0,1,1, 0.3,0,0.9,0.9,0.6,0,1,1} );
  ObjAnimate( "spr_pantry_heart_"..3, 6, 0, 0, func_end, {0,0,1,1, 0.3,0,0.9,0.9,0.6,0,1,1} );  
  SoundSfx( "aud_mg_pantry_win" );


end;
--------------------------------------------------------------------------------------------

private.pantrydoor_point_pos={
  {0,-131},
  {115,63},  
  {-115,63},
  {0,0} 
}

function private.pantrydoor_way(start_p,end_p,obj)
  local way
  if end_p == 4 or start_p == 4 then
    way = {0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y,0.5,0, private.pantrydoor_point_pos[end_p][1],private.pantrydoor_point_pos[end_p][2]}
  elseif (start_p==2 and end_p == 3)or (start_p==3 and end_p == 2) then
    way = {
      0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y,
      0.25,0,0,131,
      0.5,0,private.pantrydoor_point_pos[end_p][1],private.pantrydoor_point_pos[end_p][2]
    } 
  elseif (start_p==1 and end_p == 3)or (start_p==3 and end_p == 1) then
    way = {
      0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y,
      0.25,0,-115,-63,
      0.5,0,private.pantrydoor_point_pos[end_p][1],private.pantrydoor_point_pos[end_p][2]
    }   
  elseif (start_p==1 and end_p == 2)or (start_p==2 and end_p == 1) then
    way = {
      0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y,
      0.25,0,115,-63,
      0.5,30,private.pantrydoor_point_pos[end_p][1],private.pantrydoor_point_pos[end_p][2]
    }     
  else 
    way = {
      0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y,
      0.5,0,private.pantrydoor_point_pos[end_p][1],private.pantrydoor_point_pos[end_p][2]
    } 
  end
  return way
end


function private.pantrydoor_loadstate()
  if not ng_global.progress["std"]["win_pantrydoor"].state then
    ng_global.progress["std"]["win_pantrydoor"].state = {1,2,3,0}
  end
  
  for i=1,4 do
    ObjSet("spr_pantry_heart_"..ng_global.progress["std"]["win_pantrydoor"].state[i],{pos_x=private.pantrydoor_point_pos[i][1],pos_y=private.pantrydoor_point_pos[i][2]})
  end

end
function public.pantrydoor_mdown(obj)
  local s = ng_global.progress["std"]["win_pantrydoor"].state
  local num = tonumber(ld.StringDivide(obj)[4])
  local index
  local num_index
  for i=1,4 do 
    if ng_global.progress["std"]["win_pantrydoor"].state[i] == 0 then
      index = i
    elseif ng_global.progress["std"]["win_pantrydoor"].state[i] == num then
      num_index=i  
    end
  end

  local way = private.pantrydoor_way(num_index,index,obj)
  ld.Lock(1)
  ObjAnimate( obj, 3, 0, 0, function()private.pantrydoor_check()end, way );
  -- ObjSet(obj,{pos_x=private.pantrydoor_point_pos[index][1],pos_y=private.pantrydoor_point_pos[index][2]})
  ng_global.progress["std"]["win_pantrydoor"].state[index]=num
  ng_global.progress["std"]["win_pantrydoor"].state[num_index]=0  
  
  SoundSfx( "aud_mg_pantry_move" );

end

function private.pantrydoor_check()
  local s = ng_global.progress["std"]["win_pantrydoor"].state
  if s[1]==3 and s[2]==1 and s[3]==2 then
    public.win_pantrydoor()
    --ld.LogTrace( "win" );
  else 
    ld.Lock(0)
  end
end

function public.pantrydoor_menter(obj)
  ld.ShCur(CURSOR_HAND)
  local obj_focus = obj.."_focus" 
  ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,1} );
end
function public.pantrydoor_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  local obj_focus = obj.."_focus" 
  ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,0} );  
end

function private.win_pantrydoor_skip()
  ng_global.progress["std"]["win_pantrydoor"].state  = {3,1,2,0}
  private.pantrydoor_skipreset_anim()
end

function private.win_pantrydoor_reset()
  ng_global.progress["std"]["win_pantrydoor"].state  = {1,2,3,0}
  private.pantrydoor_skipreset_anim()
end

function private.pantrydoor_skipreset_anim()
  local f_end = function()
    private.pantrydoor_loadstate()
    for j=1,3 do
      local obj= "spr_pantry_heart_"..j 
      ObjAnimate( obj, 8, 0, 0, "", {0,0,0, 0.3,0,1} );
    end   
    ld.StartTimer( "tmr_pantrydoor_skipreset_lock", 0.3, function()private.pantrydoor_check()end ) 
  end
  ld.Lock(1)
  for i=1,3 do
    local obj= "spr_pantry_heart_"..i 
    ObjAnimate( obj, 8, 0, 0, "", {0,0,1, 0.3,0,0} );
  end
  ld.StartTimer( "tmr_pantrydoor_skipreset", 0.4, f_end )
end
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_furnace *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_vial" ] = { type = "get", get_obj = "spr_furnace_vial", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.get_vial_logic = function()
  
end;
private.get_vial_inv = function()
  interface.InventoryItemAdd("inv_vial","spr_furnace_vial");
  ObjSet( "inv_vial", { drag = 0 } );
end;
private.get_vial_beg = function()
  ObjDelete("gfx_furnace_vial")
end;
private.get_vial_end = function()
  ObjDelete("spr_furnace_vial_sh")
  ObjDelete("spr_residence_vial")
  if common_impl.ZzCompleteCheck("get_vial") then ObjSet( common_impl.hint["get_vial"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_vial", private.get_vial_inv );
cmn.AddSubscriber( "get_vial", private.get_vial_beg, private.room_objname );
cmn.AddSubscriber( "get_vial", private.get_vial_end, private.room_objname );
cmn.AddSubscriber( "get_vial", private.get_vial_logic );
--------------------------------------------------------------------
function public.get_vial()
  cmn.SetEventDone( "get_vial" );
  cmn.CallEventHandler( "get_vial" );
  if common_impl.ZzCompleteCheck("get_vial") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pliers" ] = { type = "use", inv_obj = "inv_pliers", use_place = "gfx_furnace_pliers_zone", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.use_pliers_logic = function()
  ObjSet( "gfx_furnace_clk_furnacedoor_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_pliers_inv = function()
  common_impl.ProcessMultiUseAll("pliers", "pliers")
end;
private.use_pliers_beg = function()
  ObjDelete( "gfx_furnace_pliers_zone" );
end;
private.use_pliers_end = function()
  ObjSet("anm_furnace_door",{animfunc="open_door",frame=0})
  if common_impl.ZzCompleteCheck("use_pliers") then ObjSet( common_impl.hint["use_pliers"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pliers", private.use_pliers_inv );
cmn.AddSubscriber( "use_pliers", private.use_pliers_beg, private.room_objname );
cmn.AddSubscriber( "use_pliers", private.use_pliers_end, private.room_objname );
cmn.AddSubscriber( "use_pliers", private.use_pliers_logic );
cmn.AddSubscriber( "use_pliers_inv", private.use_pliers_inv, private.room_objname );
cmn.AddSubscriber( "use_pliers_beg", private.use_pliers_beg, private.room_objname );
cmn.AddSubscriber( "use_pliers_end", private.use_pliers_end, private.room_objname );
cmn.AddSubscriber( "use_pliers_end", private.use_pliers_logic );
--------------------------------------------------------------------------------------------
function public.use_pliers( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pliers" );
    cmn.CallEventHandler( "use_pliers_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pliers") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pliers_inv" );
  cmn.CallEventHandler( "use_pliers_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_furnace_door", "use_pliers", func_end );
  SoundSfx( "aud_use_pliers_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_furnacedoor" ] = { type = "click", use_place = "gfx_furnace_clk_furnacedoor_zone", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.clk_furnacedoor_logic = function()
  ObjSet( "gfx_furnace_fireiron_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_furnace_blackheart2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_furnace_greenbutton", { visible = 1, input = 1, active = 1 } )
end;
private.clk_furnacedoor_beg = function()
  ObjDelete( "gfx_furnace_clk_furnacedoor_zone" );
end;
private.clk_furnacedoor_end = function()
  ObjSet("anm_furnace_door",{animfunc="use_poker",frame=0})
  ObjDelete("spr_residence_door_furnace")
  if common_impl.ZzCompleteCheck("clk_furnacedoor") then ObjSet( common_impl.hint["clk_furnacedoor"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_furnacedoor", private.clk_furnacedoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_furnacedoor", private.clk_furnacedoor_end, private.room_objname );
cmn.AddSubscriber( "clk_furnacedoor", private.clk_furnacedoor_logic );
cmn.AddSubscriber( "clk_furnacedoor_beg", private.clk_furnacedoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_furnacedoor_end", private.clk_furnacedoor_end, private.room_objname );
cmn.AddSubscriber( "clk_furnacedoor_end", private.clk_furnacedoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_furnacedoor()

  local func_end = function()
    cmn.SetEventDone( "clk_furnacedoor" );
    cmn.CallEventHandler( "clk_furnacedoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_furnacedoor") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_furnacedoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_furnace_door", "open_door", func_end );
  SoundSfx( "aud_touch_cover_furnace_residence" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_blackheart2" ] = { type = "get", get_obj = "spr_furnace_blackheart2", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.get_blackheart2_logic = function()
  
end;
private.get_blackheart2_inv = function()
  interface.InventoryItemAdd("inv_blackheart","spr_furnace_blackheart2",function() level_inv.ProcessGetBlackheartAll( "get_blackheart2" ) end);
end;
private.get_blackheart2_beg = function()
  ObjDelete("gfx_furnace_blackheart2")
end;
private.get_blackheart2_end = function()
  ObjDelete("spr_furnace_blackheart2_sh")
  ObjDelete("spr_residence_blackheart2")
  if common_impl.ZzCompleteCheck("get_blackheart2") then ObjSet( common_impl.hint["get_blackheart2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_blackheart2", private.get_blackheart2_inv );
cmn.AddSubscriber( "get_blackheart2", private.get_blackheart2_beg, private.room_objname );
cmn.AddSubscriber( "get_blackheart2", private.get_blackheart2_end, private.room_objname );
cmn.AddSubscriber( "get_blackheart2", private.get_blackheart2_logic );
--------------------------------------------------------------------
function public.get_blackheart2()
  cmn.SetEventDone( "get_blackheart2" );
  cmn.CallEventHandler( "get_blackheart2" );
  if common_impl.ZzCompleteCheck("get_blackheart2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_greenbutton" ] = { type = "get", get_obj = "spr_furnace_greenbutton", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.get_greenbutton_logic = function()
  
end;
private.get_greenbutton_inv = function()
  interface.InventoryItemAdd("inv_greenbutton","spr_furnace_greenbutton");
end;
private.get_greenbutton_beg = function()
  ObjDelete("gfx_furnace_greenbutton")
end;
private.get_greenbutton_end = function()
  ObjDelete("spr_furnace_greenbutton_sh")
  ObjDelete("spr_residence_greenbutton")
  if common_impl.ZzCompleteCheck("get_greenbutton") then ObjSet( common_impl.hint["get_greenbutton"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_greenbutton", private.get_greenbutton_inv );
cmn.AddSubscriber( "get_greenbutton", private.get_greenbutton_beg, private.room_objname );
cmn.AddSubscriber( "get_greenbutton", private.get_greenbutton_end, private.room_objname );
cmn.AddSubscriber( "get_greenbutton", private.get_greenbutton_logic );
--------------------------------------------------------------------
function public.get_greenbutton()
  cmn.SetEventDone( "get_greenbutton" );
  cmn.CallEventHandler( "get_greenbutton" );
  if common_impl.ZzCompleteCheck("get_greenbutton") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fireiron" ] = { type = "use", inv_obj = "inv_fireiron", use_place = "gfx_furnace_fireiron_zone", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.use_fireiron_logic = function()
  ObjSet( "gfx_furnace_waterflask_furnace_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_fireiron_inv = function()
  common_impl.ProcessMultiUseAll("fireiron", "fireiron")
end;
private.use_fireiron_beg = function()
  ObjDelete( "gfx_furnace_fireiron_zone" );
end;
private.use_fireiron_end = function()
    
    ObjSet("anm_furnace_door",{animfunc="use_water",frame=0})
    ObjDelete("spr_residence_ingredientq_fire")
    ObjSet( "spr_residence_ingredientq_hot", {alp = 1} );
    ObjDelete("spr_residence_screwdriver_fire")
    ObjSet( "spr_residence_screwdriver_hot", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_fireiron") then ObjSet( common_impl.hint["use_fireiron"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fireiron", private.use_fireiron_inv );
cmn.AddSubscriber( "use_fireiron", private.use_fireiron_beg, private.room_objname );
cmn.AddSubscriber( "use_fireiron", private.use_fireiron_end, private.room_objname );
cmn.AddSubscriber( "use_fireiron", private.use_fireiron_logic );
cmn.AddSubscriber( "use_fireiron_inv", private.use_fireiron_inv, private.room_objname );
cmn.AddSubscriber( "use_fireiron_beg", private.use_fireiron_beg, private.room_objname );
cmn.AddSubscriber( "use_fireiron_end", private.use_fireiron_end, private.room_objname );
cmn.AddSubscriber( "use_fireiron_end", private.use_fireiron_logic );
--------------------------------------------------------------------------------------------
function public.use_fireiron( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fireiron" );
    cmn.CallEventHandler( "use_fireiron_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fireiron") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fireiron_inv" );
  cmn.CallEventHandler( "use_fireiron_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_furnace_door", "use_poker", func_end );
  SoundSfx( "aud_use_fireiron_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_waterflask_furnace" ] = { type = "use", inv_obj = "inv_waterflask", use_place = "gfx_furnace_waterflask_furnace_zone", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.use_waterflask_furnace_logic = function()
  ObjSet( "spr_furnace_screwdriver", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_furnace_ingredientq", { visible = 1, input = 1, active = 1 } )

end;
private.use_waterflask_furnace_inv = function()
  common_impl.ProcessMultiUseAll("waterflask", "waterflask_furnace")
end;
private.use_waterflask_furnace_beg = function()
  ObjDelete( "gfx_furnace_waterflask_furnace_zone" );
end;
private.use_waterflask_furnace_end = function()
  ObjDelete("anm_furnace_door")
  ObjSet( "spr_furnace_ingredientq_sh", {alp = 1} );
  ObjSet( "spr_furnace_screwdriver_sh", {alp = 1} );  
  if common_impl.ZzCompleteCheck("use_waterflask_furnace") then ObjSet( common_impl.hint["use_waterflask_furnace"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_waterflask_furnace", private.use_waterflask_furnace_inv );
cmn.AddSubscriber( "use_waterflask_furnace", private.use_waterflask_furnace_beg, private.room_objname );
cmn.AddSubscriber( "use_waterflask_furnace", private.use_waterflask_furnace_end, private.room_objname );
cmn.AddSubscriber( "use_waterflask_furnace", private.use_waterflask_furnace_logic );
cmn.AddSubscriber( "use_waterflask_furnace_inv", private.use_waterflask_furnace_inv, private.room_objname );
cmn.AddSubscriber( "use_waterflask_furnace_beg", private.use_waterflask_furnace_beg, private.room_objname );
cmn.AddSubscriber( "use_waterflask_furnace_end", private.use_waterflask_furnace_end, private.room_objname );
cmn.AddSubscriber( "use_waterflask_furnace_end", private.use_waterflask_furnace_logic );
--------------------------------------------------------------------------------------------
function public.use_waterflask_furnace( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_waterflask_furnace" );
    cmn.CallEventHandler( "use_waterflask_furnace_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_waterflask_furnace") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_waterflask_furnace_inv" );
  cmn.CallEventHandler( "use_waterflask_furnace_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_furnace_door", "use_water", func_end );
  SoundSfx( "aud_use_waterflask_furnace" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_screwdriver" ] = { type = "get", get_obj = "spr_furnace_screwdriver", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.get_screwdriver_logic = function()
  
end;
private.get_screwdriver_inv = function()
  interface.InventoryItemAdd("inv_screwdriver","spr_furnace_screwdriver");
end;
private.get_screwdriver_beg = function()
  ObjDelete("gfx_furnace_screwdriver")
end;
private.get_screwdriver_end = function()
  ObjDelete("spr_furnace_screwdriver_sh")
  ObjDelete("spr_residence_screwdriver_hot")
  if common_impl.ZzCompleteCheck("get_screwdriver") then ObjSet( common_impl.hint["get_screwdriver"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_inv );
cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_beg, private.room_objname );
cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_end, private.room_objname );
cmn.AddSubscriber( "get_screwdriver", private.get_screwdriver_logic );
--------------------------------------------------------------------
function public.get_screwdriver()
  cmn.SetEventDone( "get_screwdriver" );
  cmn.CallEventHandler( "get_screwdriver" );
  if common_impl.ZzCompleteCheck("get_screwdriver") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ingredientq" ] = { type = "get", get_obj = "spr_furnace_ingredientq", room = "rm_residence", zz = "zz_furnace", zz_gate = "gzz_residence_furnace" };

private.get_ingredientq_logic = function()
  
end;
private.get_ingredientq_inv = function()
  interface.InventoryItemAdd("inv_ingredientq","spr_furnace_ingredientq");
end;
private.get_ingredientq_beg = function()
  ObjDelete("gfx_furnace_ingredientq")
end;
private.get_ingredientq_end = function()
  ObjDelete("spr_furnace_ingredientq_sh")
  ObjDelete("spr_residence_ingredientq_hot")
  if common_impl.ZzCompleteCheck("get_ingredientq") then ObjSet( common_impl.hint["get_ingredientq"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ingredientq", private.get_ingredientq_inv );
cmn.AddSubscriber( "get_ingredientq", private.get_ingredientq_beg, private.room_objname );
cmn.AddSubscriber( "get_ingredientq", private.get_ingredientq_end, private.room_objname );
cmn.AddSubscriber( "get_ingredientq", private.get_ingredientq_logic );
--------------------------------------------------------------------
function public.get_ingredientq()
  cmn.SetEventDone( "get_ingredientq" );
  cmn.CallEventHandler( "get_ingredientq" );
  if common_impl.ZzCompleteCheck("get_ingredientq") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_flowerdecor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_glassrose" ] = { type = "use", inv_obj = "inv_glassrose", use_place = "gfx_flowerdecor_glassrose_zone", room = "rm_residence", zz = "zz_flowerdecor", zz_gate = "gzz_residence_flowerdecor" };

private.use_glassrose_logic = function()
  ObjSet( "spr_flowerdecor_blackheart3", {  input = 1, active = 1 } )

end;
private.use_glassrose_inv = function()
  common_impl.ProcessMultiUseAll("glassrose", "glassrose")
end;
private.use_glassrose_beg = function()
  ObjDelete( "gfx_flowerdecor_glassrose_zone" );
end;
private.use_glassrose_end = function()
  ObjSet("anm_flowerdecor_box",{animfunc="use_am",frame=999})
  ObjSet("gfx_flowerdecor_blackheart3",{visible=1})
  ObjDelete("spr_residence_cover")
  ObjSet( "spr_residence_cover_open_chest", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_glassrose") then ObjSet( common_impl.hint["use_glassrose"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_glassrose", private.use_glassrose_inv );
cmn.AddSubscriber( "use_glassrose", private.use_glassrose_beg, private.room_objname );
cmn.AddSubscriber( "use_glassrose", private.use_glassrose_end, private.room_objname );
cmn.AddSubscriber( "use_glassrose", private.use_glassrose_logic );
cmn.AddSubscriber( "use_glassrose_inv", private.use_glassrose_inv, private.room_objname );
cmn.AddSubscriber( "use_glassrose_beg", private.use_glassrose_beg, private.room_objname );
cmn.AddSubscriber( "use_glassrose_end", private.use_glassrose_end, private.room_objname );
cmn.AddSubscriber( "use_glassrose_end", private.use_glassrose_logic );
--------------------------------------------------------------------------------------------
function public.use_glassrose( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_glassrose" );
    cmn.CallEventHandler( "use_glassrose_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_glassrose") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_glassrose_inv" );
  cmn.CallEventHandler( "use_glassrose_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowerdecor_box", "use_am", func_end );
  SoundSfx( "aud_use_glassrose_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_blackheart3" ] = { type = "get", get_obj = "spr_flowerdecor_blackheart3", room = "rm_residence", zz = "zz_flowerdecor", zz_gate = "gzz_residence_flowerdecor" };

private.get_blackheart3_logic = function()
  
end;
private.get_blackheart3_inv = function()
  interface.InventoryItemAdd("inv_blackheart","spr_flowerdecor_blackheart3",function() level_inv.ProcessGetBlackheartAll( "get_blackheart3" ) end);
end;
private.get_blackheart3_beg = function()
    ObjSet( "spr_flowerdecor_blackheart3", {visible = 1} );
  ObjDelete("gfx_flowerdecor_blackheart3")
end;
private.get_blackheart3_end = function()
  ObjSet("anm_flowerdecor_box",{animfunc="end_am",frame=0})  
  if common_impl.ZzCompleteCheck("get_blackheart3") then ObjSet( common_impl.hint["get_blackheart3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_blackheart3", private.get_blackheart3_inv );
cmn.AddSubscriber( "get_blackheart3", private.get_blackheart3_beg, private.room_objname );
cmn.AddSubscriber( "get_blackheart3", private.get_blackheart3_end, private.room_objname );
cmn.AddSubscriber( "get_blackheart3", private.get_blackheart3_logic );
--------------------------------------------------------------------
function public.get_blackheart3()
  cmn.SetEventDone( "get_blackheart3" );
  cmn.CallEventHandler( "get_blackheart3" );
  if common_impl.ZzCompleteCheck("get_blackheart3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_spanner" ] = { type = "use", inv_obj = "inv_spanner", use_place = "gfx_flowerdecor_spanner_zone", room = "rm_residence", zz = "zz_flowerdecor", zz_gate = "gzz_residence_flowerdecor" };

private.use_spanner_logic = function()
  ObjSet( "spr_flowerdecor_saplingshovel", { input = 1, active = 1 } )

end;
private.use_spanner_inv = function()
  common_impl.ProcessMultiUseAll("spanner", "spanner")
end;
private.use_spanner_beg = function()
  ObjDelete( "gfx_flowerdecor_spanner_zone" );
end;
private.use_spanner_end = function()
  ObjSet("gfx_flowerdecor_saplingshovel",{visible=1})
  ObjSet("anm_flowerdecor_cover",{animfunc="use_w",frame=999})
  ObjDelete("spr_residence_cover_close")
    ObjSet("spr_residence_cover_open",{alp=1})
  if common_impl.ZzCompleteCheck("use_spanner") then ObjSet( common_impl.hint["use_spanner"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_spanner", private.use_spanner_inv );
cmn.AddSubscriber( "use_spanner", private.use_spanner_beg, private.room_objname );
cmn.AddSubscriber( "use_spanner", private.use_spanner_end, private.room_objname );
cmn.AddSubscriber( "use_spanner", private.use_spanner_logic );
cmn.AddSubscriber( "use_spanner_inv", private.use_spanner_inv, private.room_objname );
cmn.AddSubscriber( "use_spanner_beg", private.use_spanner_beg, private.room_objname );
cmn.AddSubscriber( "use_spanner_end", private.use_spanner_end, private.room_objname );
cmn.AddSubscriber( "use_spanner_end", private.use_spanner_logic );
--------------------------------------------------------------------------------------------
function public.use_spanner( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_spanner" );
    cmn.CallEventHandler( "use_spanner_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_spanner") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_spanner_inv" );
  cmn.CallEventHandler( "use_spanner_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowerdecor_cover", "use_w", func_end );
  SoundSfx( "aud_use_spanner_residence" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_saplingshovel" ] = { type = "get", get_obj = "spr_flowerdecor_saplingshovel", room = "rm_residence", zz = "zz_flowerdecor", zz_gate = "gzz_residence_flowerdecor" };

private.get_saplingshovel_logic = function()
  
end;
private.get_saplingshovel_inv = function()
  interface.InventoryItemAdd("inv_saplingshovel","spr_flowerdecor_saplingshovel");
end;
private.get_saplingshovel_beg = function()
  ObjSet( "spr_flowerdecor_saplingshovel", {visible = 1} );
  ObjDelete("gfx_flowerdecor_saplingshovel")
end;
private.get_saplingshovel_end = function()
  ObjDelete("spr_residence_saplingshovel")  
    ObjSet("anm_flowerdecor_cover",{animfunc="end_w",frame=0})
  if common_impl.ZzCompleteCheck("get_saplingshovel") then ObjSet( common_impl.hint["get_saplingshovel"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_saplingshovel", private.get_saplingshovel_inv );
cmn.AddSubscriber( "get_saplingshovel", private.get_saplingshovel_beg, private.room_objname );
cmn.AddSubscriber( "get_saplingshovel", private.get_saplingshovel_end, private.room_objname );
cmn.AddSubscriber( "get_saplingshovel", private.get_saplingshovel_logic );
--------------------------------------------------------------------
function public.get_saplingshovel()
  cmn.SetEventDone( "get_saplingshovel" );
  cmn.CallEventHandler( "get_saplingshovel" );
  if common_impl.ZzCompleteCheck("get_saplingshovel") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_pantryho_for_residence = function()
    if ld.CheckRequirements( {"win_pantryho"} ) then
      ObjSet( "gho_residence_pantryho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_pantryho", win_pantryho_for_residence, private.room_objname )

end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_upstairsdoor" ) and not ld.CheckRequirements( { "win_codelock" } ) then  
    private.win_codelock_reset();
  elseif ( mg_name == "zz_pantry" ) and not ld.CheckRequirements( { "win_pantrydoor" } ) then    
    private.win_pantrydoor_reset();
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_upstairsdoor" ) and not ld.CheckRequirements( { "win_codelock" } ) then
    private.win_codelock_skip();
  elseif ( mg_name == "zz_pantry" ) and not ld.CheckRequirements( { "win_pantrydoor" } ) then    
    private.win_pantrydoor_skip()
  end;
  
end
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_residence();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_residence_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_flowerdecor" );
  function zz_flowerdecor.Open()
  end;
  function zz_flowerdecor.PreOpen()
  end;
  function zz_flowerdecor.PreClose()
  end;
  function zz_flowerdecor.Close()
  end;

  subroom.Define( "zz_furnace" );
  function zz_furnace.Open()
  end;
  function zz_furnace.PreOpen()
  end;
  function zz_furnace.PreClose()
  end;
  function zz_furnace.Close()
  end;

  subroom.Define( "zz_pantry" );
  function zz_pantry.Open()
     if cmn.IsEventStart("win_pantrydoor") and not cmn.IsEventDone("win_pantrydoor") then 
       cmn.MiniGameShow( "pantrydoor" ); 
         private.pantrydoor_check()
     end;     
  end;
  function zz_pantry.PreOpen()
     if cmn.IsEventStart("win_pantrydoor") and not cmn.IsEventDone("win_pantrydoor") then 
       private.pantrydoor_loadstate()
     end;    
  end;
  function zz_pantry.PreClose()
  end;
  function zz_pantry.Close()
  end;

  subroom.Define( "zz_upstairsdoor" );
  function zz_upstairsdoor.Open()
     if cmn.IsEventStart("win_codelock") and not cmn.IsEventDone("win_codelock") then 
       cmn.MiniGameShow( "codelock" ); 
       private.codelock_check()
     end; 
  end;
  function zz_upstairsdoor.PreOpen()
     if cmn.IsEventStart("win_codelock") and not cmn.IsEventDone("win_codelock") then 
       private.codelock_loadstate()
     end;    
  end;
  function zz_upstairsdoor.PreClose()
  end;
  function zz_upstairsdoor.Close()
  end;
  
end;
--*********************************************************************************************************************