-- name=rm_roadway
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_roadway";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_roadway()
  if not ( cmn.IsEventDone( "opn_roadway" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_roadway" );
      cmn.CallEventHandler( "opn_roadway" )
      --ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opn_roadway");
      SoundTheme( "aud_adventure1_mus" );
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_roadway = function() end;
local opn_roadway_logic = function() end;
cmn.AddSubscriber( "opn_roadway", opn_roadway_logic )
cmn.AddSubscriber( "opn_roadway", opn_roadway, private.room_objname )

function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "warder" then
    if count_txt == 1 then
      
    elseif count_txt == 2 then    
      
    end; 
  elseif  dlg_name == "warder2" then 
    if count_txt == 1 then
      
    elseif count_txt == 2 then    
      
    end; 
  elseif  dlg_name == "warder3" then 
    if count_txt == 3 then
      ld.Lock(1);
      ld.StartTimer( 1, function() AnimPlay( "anm_roadway_warder3", "giv", function() ld.StartTimer( 0.5, function() AnimPlay( "anm_roadway_warder3", "hand", function()   end); ld.AnimPlay( "anm_roadway_warder3_text", "text_big", function()  ld.Lock(0); end )  end )   end);
         SoundSfx( "aud_get_to_us" );  end )  
    elseif count_txt == 4 then    
      ObjSet( "spr_roadway_mappaper", {active=1, visible = 1} );
       cmn.CallEventHandler( "get_mappaper" );
      --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" )  
      --AnimPlay( "anm_roadway_warder3", "hand", function()   end);
    end; 
  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_doorpalace" ] = { type = "click", use_place = "gfx_roadway_clk_doorpalace_zone", room = "rm_roadway" };

private.clk_doorpalace_logic = function()
  
  ObjSet( "gfx_roadway_soporific_zone", {active = 1, input = 1, visible = 1} );

end;
private.clk_doorpalace_beg = function()
  ObjDelete( "gfx_roadway_clk_doorpalace_zone" );
end;
private.clk_doorpalace_end = function()
  --if common_impl.ZzCompleteCheck("clk_doorpalace") then ObjSet( common_impl.hint["clk_doorpalace"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_doorpalace", private.clk_doorpalace_beg, private.room_objname );
cmn.AddSubscriber( "clk_doorpalace", private.clk_doorpalace_end, private.room_objname );
cmn.AddSubscriber( "clk_doorpalace", private.clk_doorpalace_logic );
cmn.AddSubscriber( "clk_doorpalace_beg", private.clk_doorpalace_beg, private.room_objname );
cmn.AddSubscriber( "clk_doorpalace_end", private.clk_doorpalace_end, private.room_objname );
cmn.AddSubscriber( "clk_doorpalace_end", private.clk_doorpalace_logic );
--------------------------------------------------------------------------------------------
function public.clk_doorpalace()

  local func_end = function()
    cmn.SetEventDone( "clk_doorpalace" );
    cmn.CallEventHandler( "clk_doorpalace_end" );
    common_impl.Lock(0);
    --  if common_impl.ZzCompleteCheck("clk_doorpalace") then ld.CloseSubRoom() end;
  end;
  
  function public.dlg_roadway_warder_end()
    ObjSet( "dlg_roadway_warder", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "clk_doorpalace_beg" );
  

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_clk_doorpalace" )
  common_impl.dialog_character_loc = "anim_roadway_anim_warder"
  common_impl.continue_visible = false;
  common_impl.Start( "warder", 2, nil, nil, true, "dlg_roadway_warder_end",{"aud_guard_1_voc"} );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_soporific" ] = { type = "use", inv_obj = "inv_soporific", use_place = "gfx_roadway_soporific_zone", room = "rm_roadway"};

private.use_soporific_logic = function()
  
  ObjSet( "grm_roadway_livingroom", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_roadway_livingroom_focus");
  end;
end;
private.use_soporific_inv = function()
  common_impl.ProcessMultiUseAll("soporific", "soporific")
end;
private.use_soporific_beg = function()
  ObjDelete( "gfx_roadway_soporific_zone" );
end;
private.use_soporific_end = function()
  ObjSet( "anim_roadway_anim_warder", {animfunc = "anm_sleep", frame = 0, playing=1 } );
  --  if common_impl.ZzCompleteCheck("use_soporific") then ObjSet( common_impl.hint["use_soporific"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "obj_roadway_sleepwarder_clk_zone", {active=1, input = 1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_soporific", private.use_soporific_inv );
cmn.AddSubscriber( "use_soporific", private.use_soporific_beg, private.room_objname );
cmn.AddSubscriber( "use_soporific", private.use_soporific_end, private.room_objname );
cmn.AddSubscriber( "use_soporific", private.use_soporific_logic );
cmn.AddSubscriber( "use_soporific_inv", private.use_soporific_inv, private.room_objname );
cmn.AddSubscriber( "use_soporific_beg", private.use_soporific_beg, private.room_objname );
cmn.AddSubscriber( "use_soporific_end", private.use_soporific_end, private.room_objname );
cmn.AddSubscriber( "use_soporific_end", private.use_soporific_logic );
--------------------------------------------------------------------------------------------
function public.use_soporific( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_soporific" );
    cmn.CallEventHandler( "use_soporific_end" );
    common_impl.Lock(0);
    
    --  if common_impl.ZzCompleteCheck("use_soporific") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_soporific_inv" );
  cmn.CallEventHandler( "use_soporific_beg" );
  
  
  function public.dlg_roadway_warder2_end()
    ObjSet( "dlg_roadway_warder2", {bake=1} );
    ObjSet( "anim_roadway_anim_warder", {animfunc = "anm_sleep", frame = 0 } );
    common_impl.Lock(1);
    func_end()
  end
  
  --ObjSet( "anm_roadway_anm_rodway", {animfunc = "anm_sleep", frame = 0, playing = 1 } );
  
  SoundSfx( "aud_use_soporific_roadway" );
  common_impl.dialog_character_loc = "anim_roadway_anim_warder"
  common_impl.continue_visible = false;
  common_impl.Start( "warder2", 2, nil, nil, true, "dlg_roadway_warder2_end",{"aud_guard_2_voc"} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_poisonspice" ] = { type = "use", inv_obj = "inv_poisonspice", use_place = "gfx_roadway_poisonspice_zone", room = "rm_roadway" };

private.use_poisonspice_logic = function()
  ObjSet( "gfx_roadway_dlg_roadway_warder3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_poisonspice_inv = function()
  common_impl.ProcessMultiUseAll("poisonspice", "poisonspice")
end;
private.use_poisonspice_beg = function()
  ObjDelete( "gfx_roadway_poisonspice_zone" );
end;
private.use_poisonspice_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_poisonspice", private.use_poisonspice_inv );
cmn.AddSubscriber( "use_poisonspice", private.use_poisonspice_beg, private.room_objname );
cmn.AddSubscriber( "use_poisonspice", private.use_poisonspice_end, private.room_objname );
cmn.AddSubscriber( "use_poisonspice", private.use_poisonspice_logic );
cmn.AddSubscriber( "use_poisonspice_inv", private.use_poisonspice_inv, private.room_objname );
cmn.AddSubscriber( "use_poisonspice_beg", private.use_poisonspice_beg, private.room_objname );
cmn.AddSubscriber( "use_poisonspice_end", private.use_poisonspice_end, private.room_objname );
cmn.AddSubscriber( "use_poisonspice_end", private.use_poisonspice_logic );
--------------------------------------------------------------------------------------------
function public.use_poisonspice( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_poisonspice" );
    cmn.CallEventHandler( "use_poisonspice_end" );
    common_impl.Lock(0);
    public.dlg_roadway_warder3();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_poisonspice_inv" );
  cmn.CallEventHandler( "use_poisonspice_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_poisonspice_roadway" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_roadway_warder3" ] = { type = "click", use_place = "gfx_roadway_dlg_roadway_warder3_zone", room = "rm_roadway" };

private.dlg_roadway_warder3_logic = function()
  ObjSet( "spr_roadway_mappaper", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_roadway_mappaper_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_roadway_warder3_beg = function()
  ObjDelete( "gfx_roadway_dlg_roadway_warder3_zone" );
end;
private.dlg_roadway_warder3_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_roadway_warder3", private.dlg_roadway_warder3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_roadway_warder3", private.dlg_roadway_warder3_end, private.room_objname );
cmn.AddSubscriber( "dlg_roadway_warder3", private.dlg_roadway_warder3_logic );
cmn.AddSubscriber( "dlg_roadway_warder3_beg", private.dlg_roadway_warder3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_roadway_warder3_end", private.dlg_roadway_warder3_end, private.room_objname );
cmn.AddSubscriber( "dlg_roadway_warder3_end", private.dlg_roadway_warder3_logic );
--------------------------------------------------------------------------------------------
function public.dlg_roadway_warder3( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_roadway_warder3" );
    cmn.CallEventHandler( "dlg_roadway_warder3_end" );
    cmn.SetEventDone( "get_mappaper" );
    if ObjGetRelations( "inv_mappaper" ).parent == "level_inv_hub" then
        ObjSet( "spr_roadway_mappaper", {visible = 1} );
        cmn.CallEventHandler( "get_mappaper" );
    end
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_gvard3");
  end;

  function public.dlg_roadway_warder3_end()
    ObjSet( "dlg_roadway_warder3", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_roadway_warder3_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  -- func_end()
  common_impl.dialog_character_loc = "anim_roadway_anim_warder"
  common_impl.continue_visible = false;
  common_impl.Start( "warder3", 4, nil, nil, true, "dlg_roadway_warder3_end",{"aud_guard_3_voc","aud_guard_4_voc","aud_guard_5_voc"} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mappaper" ] = { type = "get", get_obj = "spr_roadway_mappaper", room = "rm_roadway" };

private.get_mappaper_logic = function()
  
end;
private.get_mappaper_inv = function()
  interface.InventoryItemAdd("inv_mappaper","spr_roadway_mappaper");
end;
private.get_mappaper_beg = function()
  ObjDelete("gfx_roadway_mappaper")
end;
private.get_mappaper_end = function()
  
end;

cmn.AddSubscriber( "get_mappaper", private.get_mappaper_inv );
cmn.AddSubscriber( "get_mappaper", private.get_mappaper_beg, private.room_objname );
cmn.AddSubscriber( "get_mappaper", private.get_mappaper_end, private.room_objname );
cmn.AddSubscriber( "get_mappaper", private.get_mappaper_logic );
--------------------------------------------------------------------
function public.get_mappaper()
  cmn.SetEventDone( "get_mappaper" );
  cmn.CallEventHandler( "get_mappaper" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mappaper" ] = { type = "use", inv_obj = "inv_mappaper", use_place = "gfx_roadway_mappaper_zone", room = "rm_roadway" };

private.use_mappaper_logic = function()
  ObjSet( "gmg_roadway_toriver", { visible = 1, input = 1, active = 1 } )

end;
private.use_mappaper_inv = function()
  common_impl.ProcessMultiUseAll("mappaper", "mappaper")
end;
private.use_mappaper_beg = function()
  ObjDelete( "gfx_roadway_mappaper_zone" );
end;
private.use_mappaper_end = function()
  ObjSet( "anm_roadway_anm_rodway_leftdoor", {animfunc = "open_doormg", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mappaper", private.use_mappaper_inv );
cmn.AddSubscriber( "use_mappaper", private.use_mappaper_beg, private.room_objname );
cmn.AddSubscriber( "use_mappaper", private.use_mappaper_end, private.room_objname );
cmn.AddSubscriber( "use_mappaper", private.use_mappaper_logic );
cmn.AddSubscriber( "use_mappaper_inv", private.use_mappaper_inv, private.room_objname );
cmn.AddSubscriber( "use_mappaper_beg", private.use_mappaper_beg, private.room_objname );
cmn.AddSubscriber( "use_mappaper_end", private.use_mappaper_end, private.room_objname );
cmn.AddSubscriber( "use_mappaper_end", private.use_mappaper_logic );
--------------------------------------------------------------------------------------------
function public.use_mappaper( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mappaper" );
    cmn.CallEventHandler( "use_mappaper_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mappaper_inv" );
  cmn.CallEventHandler( "use_mappaper_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_roadway_anm_rodway_leftdoor", "open_doormg", func_end );
  SoundSfx( "aud_use_mappaper_roadway" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_precipice *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_tongs" ] = { type = "get", get_obj = "spr_precipice_tongs", room = "rm_roadway", zz = "zz_precipice", zz_gate = "gzz_roadway_precipice" };

private.get_tongs_logic = function()
  
end;
private.get_tongs_inv = function()
  interface.InventoryItemAdd("inv_tongs","spr_precipice_tongs");
end;
private.get_tongs_beg = function()
  ObjDelete("gfx_precipice_tongs")
end;
private.get_tongs_end = function()
  if common_impl.ZzCompleteCheck("get_tongs") then ObjSet( common_impl.hint["get_tongs"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_precipice_tongs_shadow");
end;

cmn.AddSubscriber( "get_tongs", private.get_tongs_inv );
cmn.AddSubscriber( "get_tongs", private.get_tongs_beg, private.room_objname );
cmn.AddSubscriber( "get_tongs", private.get_tongs_end, private.room_objname );
cmn.AddSubscriber( "get_tongs", private.get_tongs_logic );
--------------------------------------------------------------------
function public.get_tongs()
  cmn.SetEventDone( "get_tongs" );
  cmn.CallEventHandler( "get_tongs" );
  if common_impl.ZzCompleteCheck("get_tongs") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_gaff" ] = { type = "use", inv_obj = "inv_gaff", use_place = "gfx_precipice_gaff_zone", room = "rm_roadway", zz = "zz_precipice", zz_gate = "gzz_roadway_precipice" };

private.use_gaff_logic = function()
  ObjSet( "spr_precipice_bag", { visible = 1, input = 1, active = 1 } )

end;
private.use_gaff_inv = function()
  common_impl.ProcessMultiUseAll("gaff", "gaff")
end;
private.use_gaff_beg = function()
  ObjDelete( "gfx_precipice_gaff_zone" );
end;
private.use_gaff_end = function()
  
  if common_impl.ZzCompleteCheck("use_gaff") then ObjSet( common_impl.hint["use_gaff"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_precipice_anm");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_gaff", private.use_gaff_inv );
cmn.AddSubscriber( "use_gaff", private.use_gaff_beg, private.room_objname );
cmn.AddSubscriber( "use_gaff", private.use_gaff_end, private.room_objname );
cmn.AddSubscriber( "use_gaff", private.use_gaff_logic );
cmn.AddSubscriber( "use_gaff_inv", private.use_gaff_inv, private.room_objname );
cmn.AddSubscriber( "use_gaff_beg", private.use_gaff_beg, private.room_objname );
cmn.AddSubscriber( "use_gaff_end", private.use_gaff_end, private.room_objname );
cmn.AddSubscriber( "use_gaff_end", private.use_gaff_logic );
--------------------------------------------------------------------------------------------
function public.use_gaff( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    --cmn.SetEventDone( "use_gaff" );
    cmn.CallEventHandler( "use_gaff_end" );
    
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_gaff") then ld.CloseSubRoom() end;

  end;

  local func_preend = function()
    ObjSet( "spr_precipice_bag", {active=1,visible=1} );
  cmn.SetEventDone( "use_gaff" );
  public.get_bag()
    ld.AnimPlay( "anm_precipice_anm", "hook_end", func_end )
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_gaff_inv" );
  cmn.CallEventHandler( "use_gaff_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_precipice_anm", "use_hook", func_preend );
  SoundSfx( "aud_use_gaff_roadway" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bag" ] = { type = "get", get_obj = "spr_precipice_bag", room = "rm_roadway", zz = "zz_precipice", zz_gate = "gzz_roadway_precipice" };

private.get_bag_logic = function()
  
end;
private.get_bag_inv = function()
  interface.InventoryItemAdd("inv_bag","spr_precipice_bag");
  ObjSet( "inv_bag", { drag = 0 } );
end;
private.get_bag_beg = function()
  ObjDelete("gfx_precipice_bag")
end;
private.get_bag_end = function()
  if common_impl.ZzCompleteCheck("get_bag") then ObjSet( common_impl.hint["get_bag"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bag", private.get_bag_inv );
cmn.AddSubscriber( "get_bag", private.get_bag_beg, private.room_objname );
cmn.AddSubscriber( "get_bag", private.get_bag_end, private.room_objname );
cmn.AddSubscriber( "get_bag", private.get_bag_logic );

cmn.AddSubscriber( "get_bag_end", private.get_bag_end, private.room_objname );
--------------------------------------------------------------------
function public.get_bag()
  cmn.SetEventDone( "get_bag" );
  cmn.CallEventHandler( "get_bag" );
  if common_impl.ZzCompleteCheck("get_bag") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sewerage *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_ruler_zone_clk() --rm_roadway.use_ruler_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_ruler' );
  end;

  SoundSfx( "aud_touch_figure_roadway" );
  ld.Lock(1);
  ld.AnimPlay( "anm_sewerage_anm_fish", "idle_1", func_end ); 
end;  

common_impl.hint[ "use_ruler" ] = { type = "use", inv_obj = "inv_ruler", use_place = "gfx_sewerage_ruler_zone", room = "rm_roadway", zz = "zz_sewerage", zz_gate = "gzz_roadway_sewerage" };

private.use_ruler_logic = function()
  ObjSet( "spr_sewerage_fish", { visible = 1, input = 1, active = 1 } )

end;
private.use_ruler_inv = function()
  common_impl.ProcessMultiUseAll("ruler", "ruler")
end;
private.use_ruler_beg = function()
  ObjDelete( "gfx_sewerage_ruler_zone" );
end;
private.use_ruler_end = function()
  if common_impl.ZzCompleteCheck("use_ruler") then ObjSet( common_impl.hint["use_ruler"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_sewerage_anm_fish", {animfunc = "end_ruler", frame = 0 } );
  ObjSet( "spr_sewerage_sh_fish", {visible = 1} );
  ObjSet( "spr_roadway_fish", {pos_x=272, pos_y = 508} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ruler", private.use_ruler_inv );
cmn.AddSubscriber( "use_ruler", private.use_ruler_beg, private.room_objname );
cmn.AddSubscriber( "use_ruler", private.use_ruler_end, private.room_objname );
cmn.AddSubscriber( "use_ruler", private.use_ruler_logic );
cmn.AddSubscriber( "use_ruler_inv", private.use_ruler_inv, private.room_objname );
cmn.AddSubscriber( "use_ruler_beg", private.use_ruler_beg, private.room_objname );
cmn.AddSubscriber( "use_ruler_end", private.use_ruler_end, private.room_objname );
cmn.AddSubscriber( "use_ruler_end", private.use_ruler_logic );
--------------------------------------------------------------------------------------------
function public.use_ruler( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ruler" );
    cmn.CallEventHandler( "use_ruler_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ruler") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ruler_inv" );
  cmn.CallEventHandler( "use_ruler_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewerage_anm_fish", "use_ruler", func_end );
  SoundSfx( "aud_use_ruler_roadway" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fish" ] = { type = "get", get_obj = "spr_sewerage_fish", room = "rm_roadway", zz = "zz_sewerage", zz_gate = "gzz_roadway_sewerage" };

private.get_fish_logic = function()
  
end;
private.get_fish_inv = function()
  interface.InventoryItemAdd("inv_fish","spr_sewerage_fish");
end;
private.get_fish_beg = function()
  ObjDelete("gfx_sewerage_fish")
end;
private.get_fish_end = function()
  if common_impl.ZzCompleteCheck("get_fish") then ObjSet( common_impl.hint["get_fish"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewerage_sh_fish");
  ObjDelete("spr_roadway_fish");
end;

cmn.AddSubscriber( "get_fish", private.get_fish_inv );
cmn.AddSubscriber( "get_fish", private.get_fish_beg, private.room_objname );
cmn.AddSubscriber( "get_fish", private.get_fish_end, private.room_objname );
cmn.AddSubscriber( "get_fish", private.get_fish_logic );
--------------------------------------------------------------------
function public.get_fish()
  cmn.SetEventDone( "get_fish" );
  cmn.CallEventHandler( "get_fish" );
  if common_impl.ZzCompleteCheck("get_fish") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_maple_zone_clk()  --rm_roadway.use_maple_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_maple' );
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_doors_roadway" );
  ld.AnimPlay( "anm_sewerage_anm_maple", "idle_2", func_end )  
end;  

common_impl.hint[ "use_maple" ] = { type = "use", inv_obj = "inv_maple", use_place = "gfx_sewerage_maple_zone", room = "rm_roadway", zz = "zz_sewerage", zz_gate = "gzz_roadway_sewerage" };

private.use_maple_logic = function()
  ObjSet( "spr_sewerage_redbutton1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_sewerage_powder2", { visible = 1, input = 1, active = 1 } )

end;
private.use_maple_inv = function()
  common_impl.ProcessMultiUseAll("maple", "maple")
end;
private.use_maple_beg = function()
  ObjDelete( "gfx_sewerage_maple_zone" );
end;
private.use_maple_end = function()
  if common_impl.ZzCompleteCheck("use_maple") then ObjSet( common_impl.hint["use_maple"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_sewerage_anm_maple");
  ObjDelete("spr_roadway_cover_1");
  ObjSet( "spr_roadway_cover_1a", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_maple", private.use_maple_inv );
cmn.AddSubscriber( "use_maple", private.use_maple_beg, private.room_objname );
cmn.AddSubscriber( "use_maple", private.use_maple_end, private.room_objname );
cmn.AddSubscriber( "use_maple", private.use_maple_logic );
cmn.AddSubscriber( "use_maple_inv", private.use_maple_inv, private.room_objname );
cmn.AddSubscriber( "use_maple_beg", private.use_maple_beg, private.room_objname );
cmn.AddSubscriber( "use_maple_end", private.use_maple_end, private.room_objname );
cmn.AddSubscriber( "use_maple_end", private.use_maple_logic );
--------------------------------------------------------------------------------------------
function public.use_maple( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_maple" );
    cmn.CallEventHandler( "use_maple_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_maple") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_maple_inv" );
  cmn.CallEventHandler( "use_maple_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewerage_anm_maple", "use_maple", func_end );
  SoundSfx( "aud_use_maple_roadway" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_redbutton1" ] = { type = "get", get_obj = "spr_sewerage_redbutton1", room = "rm_roadway", zz = "zz_sewerage", zz_gate = "gzz_roadway_sewerage" };

private.get_redbutton1_logic = function()
  
end;
private.get_redbutton1_inv = function()
  interface.InventoryItemAdd("inv_redbutton","spr_sewerage_redbutton1",function() level_inv.ProcessGetRedbuttonAll( "get_redbutton1" ) end);
end;
private.get_redbutton1_beg = function()
  ObjDelete("gfx_sewerage_redbutton1")
end;
private.get_redbutton1_end = function()
  if common_impl.ZzCompleteCheck("get_redbutton1") then ObjSet( common_impl.hint["get_redbutton1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewerage_sh_redbutton1");
  ObjDelete("spr_roadway_redbutton1");
end;

cmn.AddSubscriber( "get_redbutton1", private.get_redbutton1_inv );
cmn.AddSubscriber( "get_redbutton1", private.get_redbutton1_beg, private.room_objname );
cmn.AddSubscriber( "get_redbutton1", private.get_redbutton1_end, private.room_objname );
cmn.AddSubscriber( "get_redbutton1", private.get_redbutton1_logic );
--------------------------------------------------------------------
function public.get_redbutton1()
  cmn.SetEventDone( "get_redbutton1" );
  cmn.CallEventHandler( "get_redbutton1" );
  if common_impl.ZzCompleteCheck("get_redbutton1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_powder2" ] = { type = "get", get_obj = "spr_sewerage_powder2", room = "rm_roadway", zz = "zz_sewerage", zz_gate = "gzz_roadway_sewerage" };

private.get_powder2_logic = function()
  
end;
private.get_powder2_inv = function()
  interface.InventoryItemAdd("inv_powder2","spr_sewerage_powder2");
end;
private.get_powder2_beg = function()
  ObjDelete("gfx_sewerage_powder2")
end;
private.get_powder2_end = function()
  if common_impl.ZzCompleteCheck("get_powder2") then ObjSet( common_impl.hint["get_powder2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewerage_sh_powder2");
  ObjDelete("spr_roadway_powder2");
end;

cmn.AddSubscriber( "get_powder2", private.get_powder2_inv );
cmn.AddSubscriber( "get_powder2", private.get_powder2_beg, private.room_objname );
cmn.AddSubscriber( "get_powder2", private.get_powder2_end, private.room_objname );
cmn.AddSubscriber( "get_powder2", private.get_powder2_logic );
--------------------------------------------------------------------
function public.get_powder2()
  cmn.SetEventDone( "get_powder2" );
  cmn.CallEventHandler( "get_powder2" );
  if common_impl.ZzCompleteCheck("get_powder2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuletsnake_zone_clk()  --rm_roadway.use_amuletsnake_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amuletsnake' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_doors_roadway" );
  ld.AnimPlay( "anm_sewerage_anm_snake", "idle_3", func_end )  
end;  

common_impl.hint[ "use_amuletsnake" ] = { type = "use", inv_obj = "inv_amuletsnake", use_place = "gfx_sewerage_amuletsnake_zone", room = "rm_roadway", zz = "zz_sewerage", zz_gate = "gzz_roadway_sewerage" };

private.use_amuletsnake_logic = function()
  ObjSet( "spr_sewerage_bearseye1", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletsnake_inv = function()
  common_impl.ProcessMultiUseAll("amuletsnake", "amuletsnake")
end;
private.use_amuletsnake_beg = function()
  ObjDelete( "gfx_sewerage_amuletsnake_zone" );
end;
private.use_amuletsnake_end = function()
  if common_impl.ZzCompleteCheck("use_amuletsnake") then ObjSet( common_impl.hint["use_amuletsnake"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_sewerage_anm_snake");
  ObjDelete("spr_roadway_cover_2");
  ObjSet("spr_roadway_cover_2a",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletsnake", private.use_amuletsnake_inv );
cmn.AddSubscriber( "use_amuletsnake", private.use_amuletsnake_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletsnake", private.use_amuletsnake_end, private.room_objname );
cmn.AddSubscriber( "use_amuletsnake", private.use_amuletsnake_logic );
cmn.AddSubscriber( "use_amuletsnake_inv", private.use_amuletsnake_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletsnake_beg", private.use_amuletsnake_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletsnake_end", private.use_amuletsnake_end, private.room_objname );
cmn.AddSubscriber( "use_amuletsnake_end", private.use_amuletsnake_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletsnake( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletsnake" );
    cmn.CallEventHandler( "use_amuletsnake_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletsnake") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletsnake_inv" );
  cmn.CallEventHandler( "use_amuletsnake_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewerage_anm_snake", "use_snake", func_end );
  SoundSfx( "aud_use_amuletsnake_roadway" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bearseye1" ] = { type = "get", get_obj = "spr_sewerage_bearseye1", room = "rm_roadway", zz = "zz_sewerage", zz_gate = "gzz_roadway_sewerage" };

private.get_bearseye1_logic = function()
  
end;
private.get_bearseye1_inv = function()
  interface.InventoryItemAdd("inv_bearseye1","spr_sewerage_bearseye1");
end;
private.get_bearseye1_beg = function()
  ObjDelete("gfx_sewerage_bearseye1")
end;
private.get_bearseye1_end = function()
  if common_impl.ZzCompleteCheck("get_bearseye1") then ObjSet( common_impl.hint["get_bearseye1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewerage_sh_bearseye1");
  ObjDelete("spr_roadway_bearseye1");
end;

cmn.AddSubscriber( "get_bearseye1", private.get_bearseye1_inv );
cmn.AddSubscriber( "get_bearseye1", private.get_bearseye1_beg, private.room_objname );
cmn.AddSubscriber( "get_bearseye1", private.get_bearseye1_end, private.room_objname );
cmn.AddSubscriber( "get_bearseye1", private.get_bearseye1_logic );
--------------------------------------------------------------------
function public.get_bearseye1()
  cmn.SetEventDone( "get_bearseye1" );
  cmn.CallEventHandler( "get_bearseye1" );
  if common_impl.ZzCompleteCheck("get_bearseye1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_atstairs *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_medecinechest" ] = { type = "get", get_obj = "spr_atstairs_medecinechest", room = "rm_roadway", zz = "zz_atstairs", zz_gate = "gzz_roadway_atstairs" };

private.get_medecinechest_logic = function()
  ObjSet( "gfx_atstairs_code_zone", {active=1, input = 1, visible = 1} );
  ObjSet( "obj_atstairs_need_code_clk_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_medecinechest_inv = function()
  interface.InventoryItemAdd("inv_medecinechest","spr_atstairs_medecinechest");
  ObjSet( "inv_medecinechest", { drag = 0 } );
end;
private.get_medecinechest_beg = function()
  ObjDelete("gfx_atstairs_medecinechest")
end;
private.get_medecinechest_end = function()
  if common_impl.ZzCompleteCheck("get_medecinechest") then ObjSet( common_impl.hint["get_medecinechest"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_atstairs_sh_medecinechest");
  ObjDelete("spr_roadway_medecinechest");
end;

cmn.AddSubscriber( "get_medecinechest", private.get_medecinechest_inv );
cmn.AddSubscriber( "get_medecinechest", private.get_medecinechest_beg, private.room_objname );
cmn.AddSubscriber( "get_medecinechest", private.get_medecinechest_end, private.room_objname );
cmn.AddSubscriber( "get_medecinechest", private.get_medecinechest_logic );
--------------------------------------------------------------------
function public.get_medecinechest()
  cmn.SetEventDone( "get_medecinechest" );
  cmn.CallEventHandler( "get_medecinechest" );
  if common_impl.ZzCompleteCheck("get_medecinechest") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_tweezers_zone_clk()  --rm_roadway.use_tweezers_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_tweezers' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_item_roadway" );
  ld.AnimPlay( "anm_atstairs_anm_atstairs_petal", "idle_petal", func_end )
end;  


common_impl.hint[ "use_tweezers" ] = { type = "use", inv_obj = "inv_tweezers", use_place = "gfx_atstairs_tweezers_zone", room = "rm_roadway", zz = "zz_atstairs", zz_gate = "gzz_roadway_atstairs" };

private.use_tweezers_logic = function()
  ObjSet( "spr_atstairs_petal", { visible = 1, input = 1, active = 1 } )

end;
private.use_tweezers_inv = function()
  common_impl.ProcessMultiUseAll("tweezers", "tweezers")
end;
private.use_tweezers_beg = function()
  ObjDelete( "gfx_atstairs_tweezers_zone" );
end;
private.use_tweezers_end = function()
  if common_impl.ZzCompleteCheck("use_tweezers") then ObjSet( common_impl.hint["use_tweezers"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_atstairs_anm_atstairs_petal");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tweezers", private.use_tweezers_inv );
cmn.AddSubscriber( "use_tweezers", private.use_tweezers_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers", private.use_tweezers_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers", private.use_tweezers_logic );
cmn.AddSubscriber( "use_tweezers_inv", private.use_tweezers_inv, private.room_objname );
cmn.AddSubscriber( "use_tweezers_beg", private.use_tweezers_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_end", private.use_tweezers_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_end", private.use_tweezers_logic );
--------------------------------------------------------------------------------------------
function public.use_tweezers( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tweezers" );
    cmn.CallEventHandler( "use_tweezers_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tweezers") then ld.CloseSubRoom() end;
    public.get_petal();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tweezers_inv" );
  cmn.CallEventHandler( "use_tweezers_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_atstairs_anm_atstairs_petal", "use_petal", func_end );
  SoundSfx( "aud_use_tweezers_roadway" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_petal" ] = { type = "get", get_obj = "spr_atstairs_petal", room = "rm_roadway", zz = "zz_atstairs", zz_gate = "gzz_roadway_atstairs" };

private.get_petal_logic = function()
  
end;
private.get_petal_inv = function()
  interface.InventoryItemAdd("inv_petal","spr_atstairs_petal");
end;
private.get_petal_beg = function()
  ObjDelete("gfx_atstairs_petal")
end;
private.get_petal_end = function()
  if common_impl.ZzCompleteCheck("get_petal") then ObjSet( common_impl.hint["get_petal"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_roadway_petal");
end;

cmn.AddSubscriber( "get_petal", private.get_petal_inv );
cmn.AddSubscriber( "get_petal", private.get_petal_beg, private.room_objname );
cmn.AddSubscriber( "get_petal", private.get_petal_end, private.room_objname );
cmn.AddSubscriber( "get_petal", private.get_petal_logic );
--------------------------------------------------------------------
function public.get_petal()
  cmn.SetEventDone( "get_petal" );
  cmn.CallEventHandler( "get_petal" );
  if common_impl.ZzCompleteCheck("get_petal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_code_zone_clk()  --rm_roadway.use_code_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_code' )
  end;  
  
  if cmn.IsEventDone("get_medecinechest") then 
     ld.Lock(1);
     SoundSfx( "aud_touch_plate_roadway" );
     ld.AnimPlay( "anm_atstairs_anm_atstairs_door", "idle_door", func_end )
  else 
    func_end(); 
  end;   
     
end; 

common_impl.hint[ "use_code" ] = { type = "use", inv_obj = "inv_code", use_place = "gfx_atstairs_code_zone", room = "rm_roadway", zz = "zz_atstairs", zz_gate = "gzz_roadway_atstairs" };

private.use_code_logic = function()
  ObjSet( "obj_atstairs_mmg_root", { visible = 1, input = 1, active = 1 } )

end;
private.use_code_inv = function()
  common_impl.ProcessMultiUseAll("code", "code")
end;
private.use_code_beg = function()
  ObjDelete( "gfx_atstairs_code_zone" );
end;
private.use_code_end = function()
  if common_impl.ZzCompleteCheck("use_code") then ObjSet( common_impl.hint["use_code"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_atstairs_anm_atstairs_code", {animfunc = "use_cod", frame = 999 } );
  ObjDelete("obj_atstairs_need_code_clk_zone");
  ObjSet( "spr_roadway_cod", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_code", private.use_code_inv );
cmn.AddSubscriber( "use_code", private.use_code_beg, private.room_objname );
cmn.AddSubscriber( "use_code", private.use_code_end, private.room_objname );
cmn.AddSubscriber( "use_code", private.use_code_logic );
cmn.AddSubscriber( "use_code_inv", private.use_code_inv, private.room_objname );
cmn.AddSubscriber( "use_code_beg", private.use_code_beg, private.room_objname );
cmn.AddSubscriber( "use_code_end", private.use_code_end, private.room_objname );
cmn.AddSubscriber( "use_code_end", private.use_code_logic );
--------------------------------------------------------------------------------------------
function public.use_code( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_code" );
    cmn.CallEventHandler( "use_code_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_code") then ld.CloseSubRoom() end;
    
    private.init_code()
    cmn.MiniGameShow( "code" ); 
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_code_inv" );
  cmn.CallEventHandler( "use_code_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_atstairs_anm_atstairs_code", "use_cod", func_end );
  SoundSfx( "aud_use_code_roadway" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_code" ] = { type = "click", use_place = "obj_atstairs_mmg_root", room = "rm_roadway", zz = "zz_atstairs", zz_gate = "gzz_roadway_atstairs" };

private.win_code_logic = function()
  if cmn.IsEventDone("win_code") then
    ObjSet( "spr_atstairs_crystal", {active = 1, input = 1, visible = 1} );
  end;
end;
private.win_code_beg = function()
  -- ObjDelete( "gfx_roadway_win_code_zone" );
end;
private.win_code_end = function()
   if cmn.IsEventDone("win_code") then
      ObjDelete("anm_atstairs_anm_atstairs_door");
      ObjDelete("spr_roadway_door_zz");
   end;  
  --if common_impl.ZzCompleteCheck("win_code") then ObjSet( common_impl.hint["win_code"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_code", private.win_code_beg, private.room_objname );
cmn.AddSubscriber( "win_code", private.win_code_end, private.room_objname );
cmn.AddSubscriber( "win_code", private.win_code_logic );
cmn.AddSubscriber( "win_code_beg", private.win_code_beg, private.room_objname );
cmn.AddSubscriber( "win_code_end", private.win_code_end, private.room_objname );
cmn.AddSubscriber( "win_code_end", private.win_code_logic );
--------------------------------------------------------------------------------------------
function public.win_code()

  local func_end = function()
    cmn.SetEventDone( "win_code" );
    cmn.CallEventHandler( "win_code_end" );
    common_impl.Lock(0);
    --  if common_impl.ZzCompleteCheck("win_code") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    cmn.MiniGameHide( "code", true ); 
    ld.AnimPlay( "anm_atstairs_anm_atstairs_door", "open_door", func_end )
  end;  
  
  cmn.CallEventHandler( "win_code_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_mmg_colors_win" )
  --func_end()
  
 
  ObjAnimate( "obj_atstairs_mmg_root", 8, 0, 0, func_preend, {0,0,1, 0.5,0,0} );
  
  
end;

private.win_code_true_array={5,2,4,1,3}

private.win_code_first_init_flag = false;
function private.win_code_first_init()
  local parts_coord_array = {{-138,59},{-95,113},{-13,86},{33,145},{114,115}}
  
  if private.win_code_first_init_flag == false then 
    for i=1,5,1 do 
      ObjCreate("spr_atstairs_code_lig"..i,"spr");
      ObjAttach("spr_atstairs_code_lig"..i,"obj_atstairs_mmg_root");
      ObjSet( "spr_atstairs_code_lig"..i, {res="assets/levels/level/rm_roadway/zz_atstairs/lig", input=1, visible=1, alp=0, inputrect_init=1, inputrect_w=82, inputrect_h=82, inputrect_x=-41, inputrect_y=-41,
      event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", pos_x=parts_coord_array[i][1], pos_y=parts_coord_array[i][2], event_mdown = "rm_roadway.win_code_part_mdown("..i..");"} );
    end;  
  end;
 
  private.win_code_first_init_flag = true;  
end;  


------------------------------------------------------------------
function private.init_code()
  
  if not (cmn.IsEventStart("win_code")) then
    ng_global.progress["std"]["win_code"].state = 0
    
  else  
   
  end
  private.win_code_stand_pos();  
end
----------------------------------------------
function  private.win_code_stand_pos(without_win_ver)
  for i=1,5,1 do 
    if i<= ng_global.progress["std"]["win_code"].state then 
      ObjSet( "spr_atstairs_code_lig"..private.win_code_true_array[i], {alp=1, input=0, color_r=0, color_g=1, color_b=0} );
    else 
      ObjSet( "spr_atstairs_code_lig"..private.win_code_true_array[i], {alp=0, input=1, color_r=0, color_g=1, color_b=0} );
    end;  
  end;  
  
  if without_win_ver~=1 then 
    if ng_global.progress["std"]["win_code"].state == 5 then public.win_code() end;
  end;  
end;  
------------------------------------------------------
------------------------------------------------------
function public.win_code_part_mdown(num)
  if private.win_code_true_array[ng_global.progress["std"]["win_code"].state+1]==num then 
    local func_end = function()
      ld.Lock(0);
      ng_global.progress["std"]["win_code"].state=ng_global.progress["std"]["win_code"].state+1;
      private.win_code_stand_pos();
    end;  
    
    ld.Lock(1);
    SoundSfx( "aud_mmg_colors_true" );
    ObjSet( "spr_atstairs_code_lig"..num, {alp=0, color_r=0, color_g=1, color_b=0} );
    ObjAnimate( "spr_atstairs_code_lig"..num, 8, 0, 0, func_end, {0,0,0, 0.3,0,1} );
  else 
    local func_end = function()
      ld.Lock(0);
      private.win_code_reset();
    end;
    
    ld.Lock(1);
    SoundSfx( "aud_mmg_colors_wrong" );
    ObjSet( "spr_atstairs_code_lig"..num, {alp=0, color_r=1, color_g=0, color_b=0} );
    ObjAnimate( "spr_atstairs_code_lig"..num, 8, 0, 0, func_end, {0,0,0, 0.3,0,1, 0.6,0,0} );
  end;  
end;  

----------------------------------------------
function private.win_code_skip()
  local func_end = function()
    ld.Lock(0);
    ng_global.progress["std"]["win_code"].state=5;
    private.win_code_stand_pos(1)
    ObjAnimate( "obj_atstairs_mmg_root", 8, 0, 0, function() ld.Lock(0);private.win_code_stand_pos() end, {0,0,0, 0.3,0,1} );  
  end;

  ld.Lock(1);
  ObjAnimate( "obj_atstairs_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );  
end;  
----------------------------------------------
function  private.win_code_reset()
  local func_end = function()
    ld.Lock(0);
    ng_global.progress["std"]["win_code"].state=0;
    private.win_code_stand_pos()
    ObjAnimate( "obj_atstairs_mmg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );  
  end;

  ld.Lock(1);
  ObjAnimate( "obj_atstairs_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );  
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_crystal" ] = { type = "get", get_obj = "spr_atstairs_crystal", room = "rm_roadway", zz = "zz_atstairs", zz_gate = "gzz_roadway_atstairs" };

private.get_crystal_logic = function()
  
end;
private.get_crystal_inv = function()
  interface.InventoryItemAdd("inv_crystal","spr_atstairs_crystal");
end;
private.get_crystal_beg = function()
  ObjDelete("gfx_atstairs_crystal")
end;
private.get_crystal_end = function()
  if common_impl.ZzCompleteCheck("get_crystal") then ObjSet( common_impl.hint["get_crystal"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_atstairs_sh_crystal");
end;

cmn.AddSubscriber( "get_crystal", private.get_crystal_inv );
cmn.AddSubscriber( "get_crystal", private.get_crystal_beg, private.room_objname );
cmn.AddSubscriber( "get_crystal", private.get_crystal_end, private.room_objname );
cmn.AddSubscriber( "get_crystal", private.get_crystal_logic );
--------------------------------------------------------------------
function public.get_crystal()
  cmn.SetEventDone( "get_crystal" );
  cmn.CallEventHandler( "get_crystal" );
  if common_impl.ZzCompleteCheck("get_crystal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------

--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_toriver_for_roadway = function()
    if ld.CheckRequirements( {"win_toriver"} ) then
      ObjSet( "gmg_roadway_toriver", {input = 0, visible = 0} );
      ObjSet("grm_roadway_bytheriver",{ visible = 1, input = 1, active = 1 })
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_roadway_bytheriver_focus");
      end;
    end
  end;
  cmn.AddSubscriber("win_toriver", win_toriver_for_roadway, private.room_objname )

end;
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_atstairs" ) and not ld.CheckRequirements( { "win_code" } ) then  
    private.win_code_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_atstairs" ) and not ld.CheckRequirements( { "win_code" } ) then  
    private.win_code_skip()
  end;
  
end

function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_roadway();
  level.tutorial_clk.first()  
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_roadway_env" )
  if cmn.IsEventDone("clk_outro2") then 
    ObjSet( "anim_roadway_anim_warder", {animfunc = "anm_1", frame = 0, playing = 1 } );
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_palacedoor" );
  function zz_palacedoor.Open()
  end;
  function zz_palacedoor.PreOpen()
  end;
  function zz_palacedoor.PreClose()
  end;
  function zz_palacedoor.Close()
  end;

  subroom.Define( "zz_atstairs" );
  function zz_atstairs.Open()
  end;
  function zz_atstairs.PreOpen()
    if not cmn.IsEventDone("win_code") then 
      private.win_code_first_init();
    end;  
    
    if cmn.IsEventStart("win_code") and not cmn.IsEventDone("win_code") then 
      cmn.MiniGameShow( "code" ); 
      private.init_code()
    end;  
  end;
  function zz_atstairs.PreClose()
  
  end;
  function zz_atstairs.Close()
      if cmn.IsEventStart("win_code") and not cmn.IsEventDone("win_code") then 
        cmn.MiniGameHide( "code" ); 
      end;  
  end;

  subroom.Define( "zz_sewerage" );
  function zz_sewerage.Open()
  end;
  function zz_sewerage.PreOpen()
   
  end;
  function zz_sewerage.PreClose()
  end;
  function zz_sewerage.Close()
  end;

  subroom.Define( "zz_precipice" );
  function zz_precipice.Open()
  end;
  function zz_precipice.PreOpen()
  end;
  function zz_precipice.PreClose()
  end;
  function zz_precipice.Close()
  end;
  
end;
--*********************************************************************************************************************
------------------------------- other funcs ---------------------------------------------------------------------------
function public.roadway_idle_clk1()  --rm_roadway.roadway_idle_clk1()
  local func_end = function() 
     ObjSet( "obj_roadway_idle1_clk_zone", {input = 1} );
  end
  
  ObjSet( "obj_roadway_idle1_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_wheel_roadway" );
  ld.AnimPlay( "anm_roadway_anm_rodway_idle1", "idle_xl_1", func_end )
end;  

local idle2_flag = true;
function public.roadway_idle_clk2()  --rm_roadway.roadway_idle_clk2()
  local func_end = function() 
    ObjSet( "obj_roadway_idle2_clk_zone", {input = 1} );
  end
  
  SoundSfx( "aud_touch_window_roadway" );
  ObjSet( "obj_roadway_idle2_clk_zone", {input = 0} );
  if idle2_flag == true then 
    ld.AnimPlay( "anm_roadway_anm_rodway_idle2", "idle_xl_2_off", func_end )
    idle2_flag = false;
  else 
    ld.AnimPlay( "anm_roadway_anm_rodway_idle2", "idle_xl_3_on", func_end )
    idle2_flag = true;
  end;  
    
end;  
------------------------------------------------------------------------------------------------------------------------------