-- name=rm_seafront
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_seafront";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_seafront()
  if not ( cmn.IsEventDone( "opn_seafront" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_seafront" );
      cmn.CallEventHandler( "opn_seafront" )
      --ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opn_seafront");
      SoundTheme( "aud_adventure2_mus" );
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_seafront = function() end;
local opn_seafront_logic = function() end;
cmn.AddSubscriber( "opn_seafront", opn_seafront_logic )
cmn.AddSubscriber( "opn_seafront", opn_seafront, private.room_objname )
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pier *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_idle_axe_zone() 
  common_impl.ShowBbt( 'need_axe_pier' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay("anm_pier_anm_board","idle_ax1",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_axe_pier" ] = { type = "use", inv_obj = "inv_axe", use_place = "gfx_pier_axe_pier_zone", room = "rm_seafront", zz = "zz_pier", zz_gate = "gzz_seafront_pier" };

private.use_axe_pier_logic = function()
  ObjSet( "spr_pier_board1", { input = 1, active = 1 } )

end;
private.use_axe_pier_inv = function()
  common_impl.ProcessMultiUseAll("axe", "axe_pier")
end;
private.use_axe_pier_beg = function()
  ObjDelete( "gfx_pier_axe_pier_zone" );
end;
private.use_axe_pier_end = function()
  if common_impl.ZzCompleteCheck("use_axe_pier") then ObjSet( common_impl.hint["use_axe_pier"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pier_anm_board", {animfunc = "end_ax1", frame = 0 } );
  ObjSet( "gfx_pier_board1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_axe_pier", private.use_axe_pier_inv );
cmn.AddSubscriber( "use_axe_pier", private.use_axe_pier_beg, private.room_objname );
cmn.AddSubscriber( "use_axe_pier", private.use_axe_pier_end, private.room_objname );
cmn.AddSubscriber( "use_axe_pier", private.use_axe_pier_logic );
cmn.AddSubscriber( "use_axe_pier_inv", private.use_axe_pier_inv, private.room_objname );
cmn.AddSubscriber( "use_axe_pier_beg", private.use_axe_pier_beg, private.room_objname );
cmn.AddSubscriber( "use_axe_pier_end", private.use_axe_pier_end, private.room_objname );
cmn.AddSubscriber( "use_axe_pier_end", private.use_axe_pier_logic );
--------------------------------------------------------------------------------------------
function public.use_axe_pier( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_axe_pier" );
    cmn.CallEventHandler( "use_axe_pier_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_axe_pier") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_axe_pier_inv" );
  cmn.CallEventHandler( "use_axe_pier_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pier_anm_board", "use_ax", func_end );
  SoundSfx( "aud_use_axe_pier" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------

common_impl.hint[ "get_board1" ] = { type = "get", get_obj = "spr_pier_board1", room = "rm_seafront", zz = "zz_pier", zz_gate = "gzz_seafront_pier" };

private.get_board1_logic = function()
  
end;
private.get_board1_inv = function()
  interface.InventoryItemAdd("inv_board","spr_pier_board1",function() level_inv.ProcessGetBoardAll( "get_board1" ) end);
end;
private.get_board1_beg = function()
  ObjDelete("gfx_pier_board1")
end;
private.get_board1_end = function()
  if common_impl.ZzCompleteCheck("get_board1") then ObjSet( common_impl.hint["get_board1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_pier_anm_board");
end;

cmn.AddSubscriber( "get_board1", private.get_board1_inv );
cmn.AddSubscriber( "get_board1", private.get_board1_beg, private.room_objname );
cmn.AddSubscriber( "get_board1", private.get_board1_end, private.room_objname );
cmn.AddSubscriber( "get_board1", private.get_board1_logic );
--------------------------------------------------------------------
function public.get_board1()
  ObjSet( "anm_pier_anm_board", {visible = 0} );
  ObjSet( "spr_pier_board1", {visible = 1} );
  cmn.SetEventDone( "get_board1" );
  cmn.CallEventHandler( "get_board1" );
  if common_impl.ZzCompleteCheck("get_board1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_cheast_zone() 
  common_impl.ShowBbt( 'need_starfish' )
  ld.Lock(1)
  SoundSfx( "aud_touch_big_metal" );
  ld.AnimPlay("anm_pier_anm_chest","idle_chest1",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_starfish" ] = { type = "use", inv_obj = "inv_starfish", use_place = "gfx_pier_starfish_zone", room = "rm_seafront", zz = "zz_pier", zz_gate = "gzz_seafront_pier" };

private.use_starfish_logic = function()
 
  ObjSet( "spr_pier_rope", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_pier_hacksaw", { visible = 1, input = 1, active = 1 } )

end;
private.use_starfish_inv = function()
  common_impl.ProcessMultiUseAll("starfish", "starfish")
end;
private.use_starfish_beg = function()
  ObjDelete( "gfx_pier_starfish_zone" );
end;
private.use_starfish_end = function()
  if common_impl.ZzCompleteCheck("use_starfish") then ObjSet( common_impl.hint["use_starfish"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_pier_tr_chest", {visible = 1} );
  ObjSet( "spr_pier_sh_hacksaw", {visible = 1} );
  ObjSet( "anm_pier_anm_chest", {animfunc = "end1_chest2", frame = 0 } );
  ObjDelete("spr_seafront_close_chest");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_starfish", private.use_starfish_inv );
cmn.AddSubscriber( "use_starfish", private.use_starfish_beg, private.room_objname );
cmn.AddSubscriber( "use_starfish", private.use_starfish_end, private.room_objname );
cmn.AddSubscriber( "use_starfish", private.use_starfish_logic );
cmn.AddSubscriber( "use_starfish_inv", private.use_starfish_inv, private.room_objname );
cmn.AddSubscriber( "use_starfish_beg", private.use_starfish_beg, private.room_objname );
cmn.AddSubscriber( "use_starfish_end", private.use_starfish_end, private.room_objname );
cmn.AddSubscriber( "use_starfish_end", private.use_starfish_logic );
--------------------------------------------------------------------------------------------
function public.use_starfish( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_starfish" );
    cmn.CallEventHandler( "use_starfish_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_starfish") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_starfish_inv" );
  cmn.CallEventHandler( "use_starfish_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pier_anm_chest", "use_chest", func_end );
  SoundSfx( "aud_use_starfish_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_rope" ] = { type = "get", get_obj = "spr_pier_rope", room = "rm_seafront", zz = "zz_pier", zz_gate = "gzz_seafront_pier" };

private.get_rope_logic = function()
  
end;
private.get_rope_inv = function()
  interface.InventoryItemAdd("inv_rope","spr_pier_rope");
end;
private.get_rope_beg = function()
  ObjDelete("gfx_pier_rope")
end;
private.get_rope_end = function()
  if common_impl.ZzCompleteCheck("get_rope") then ObjSet( common_impl.hint["get_rope"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_rope", private.get_rope_inv );
cmn.AddSubscriber( "get_rope", private.get_rope_beg, private.room_objname );
cmn.AddSubscriber( "get_rope", private.get_rope_end, private.room_objname );
cmn.AddSubscriber( "get_rope", private.get_rope_logic );
--------------------------------------------------------------------
function public.get_rope()
  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );
  if common_impl.ZzCompleteCheck("get_rope") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hacksaw" ] = { type = "get", get_obj = "spr_pier_hacksaw", room = "rm_seafront", zz = "zz_pier", zz_gate = "gzz_seafront_pier" };

private.get_hacksaw_logic = function()
  
end;
private.get_hacksaw_inv = function()
  interface.InventoryItemAdd("inv_hacksaw","spr_pier_hacksaw");
end;
private.get_hacksaw_beg = function()
  ObjDelete("gfx_pier_hacksaw")
end;
private.get_hacksaw_end = function()
  if common_impl.ZzCompleteCheck("get_hacksaw") then ObjSet( common_impl.hint["get_hacksaw"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_pier_sh_hacksaw");
end;

cmn.AddSubscriber( "get_hacksaw", private.get_hacksaw_inv );
cmn.AddSubscriber( "get_hacksaw", private.get_hacksaw_beg, private.room_objname );
cmn.AddSubscriber( "get_hacksaw", private.get_hacksaw_end, private.room_objname );
cmn.AddSubscriber( "get_hacksaw", private.get_hacksaw_logic );
--------------------------------------------------------------------
function public.get_hacksaw()
  ObjSet( "spr_pier_sh_hacksaw", {visible = 0} );
  cmn.SetEventDone( "get_hacksaw" );
  cmn.CallEventHandler( "get_hacksaw" );
  if common_impl.ZzCompleteCheck("get_hacksaw") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------

  
common_impl.hint[ "use_fishingrod" ] = { type = "use", inv_obj = "inv_fishingrod", use_place = "gfx_pier_fishingrod_zone", room = "rm_seafront", zz = "zz_pier", zz_gate = "gzz_seafront_pier" };

private.use_fishingrod_logic = function()
  ObjSet( "gho_seafront_marine", { visible = 1, input = 1, active = 1 } )

end;
private.use_fishingrod_inv = function()
  common_impl.ProcessMultiUseAll("fishingrod", "fishingrod")
end;
private.use_fishingrod_beg = function()
  ObjDelete( "gfx_pier_fishingrod_zone" );
end;
private.use_fishingrod_end = function()
  if common_impl.ZzCompleteCheck("use_fishingrod") then ObjSet( common_impl.hint["use_fishingrod"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pier_anm_fishingrod", {animfunc = "end_fishingrod1", frame = 0 } );
  ObjSet( "anm_seafront_anm", { animfunc = "boat_static", frame = 100, playing = true, visible = true, active = true, alp = 1 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fishingrod", private.use_fishingrod_inv );
cmn.AddSubscriber( "use_fishingrod", private.use_fishingrod_beg, private.room_objname );
cmn.AddSubscriber( "use_fishingrod", private.use_fishingrod_end, private.room_objname );
cmn.AddSubscriber( "use_fishingrod", private.use_fishingrod_logic );
cmn.AddSubscriber( "use_fishingrod_inv", private.use_fishingrod_inv, private.room_objname );
cmn.AddSubscriber( "use_fishingrod_beg", private.use_fishingrod_beg, private.room_objname );
cmn.AddSubscriber( "use_fishingrod_end", private.use_fishingrod_end, private.room_objname );
cmn.AddSubscriber( "use_fishingrod_end", private.use_fishingrod_logic );
--------------------------------------------------------------------------------------------
function public.use_fishingrod( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fishingrod" );
    cmn.CallEventHandler( "use_fishingrod_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fishingrod") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fishingrod_inv" );
  cmn.CallEventHandler( "use_fishingrod_beg" );
  common_impl.Lock(1);
  
  ObjSet( "spr_pier_tr_chest", {visible = 0} );
  ld.AnimPlay( "anm_pier_anm_fishingrod", "use_fishingrod", func_end );
  SoundSfx( "aud_use_fishingrod_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_handrail *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_dolly1" ] = { type = "get", get_obj = "spr_handrail_dolly1", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };

private.get_dolly1_logic = function()
  
end;
private.get_dolly1_inv = function()
  interface.InventoryItemAdd("inv_dolly","spr_handrail_dolly1",function() level_inv.ProcessGetDollyAll( "get_dolly1" ) end);
end;
private.get_dolly1_beg = function()
  ObjDelete("gfx_handrail_dolly1")
end;
private.get_dolly1_end = function()
  if common_impl.ZzCompleteCheck("get_dolly1") then ObjSet( common_impl.hint["get_dolly1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_seafront_doll");
end;

cmn.AddSubscriber( "get_dolly1", private.get_dolly1_inv );
cmn.AddSubscriber( "get_dolly1", private.get_dolly1_beg, private.room_objname );
cmn.AddSubscriber( "get_dolly1", private.get_dolly1_end, private.room_objname );
cmn.AddSubscriber( "get_dolly1", private.get_dolly1_logic );
--------------------------------------------------------------------
function public.get_dolly1()
  cmn.SetEventDone( "get_dolly1" );
  cmn.CallEventHandler( "get_dolly1" );
  if common_impl.ZzCompleteCheck("get_dolly1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_axehandrail_zone() 
  common_impl.ShowBbt( 'need_axe_handrail' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay("anm_handrail_anm_board","idle_ax1",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_axe_handrail" ] = { type = "use", inv_obj = "inv_axe", use_place = "gfx_handrail_axe_handrail_zone", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };

private.use_axe_handrail_logic = function()
  ObjSet( "spr_handrail_board2", { visible = 1, input = 1, active = 1 } )

end;
private.use_axe_handrail_inv = function()
  common_impl.ProcessMultiUseAll("axe", "axe_handrail")
end;
private.use_axe_handrail_beg = function()
  ObjDelete( "gfx_handrail_axe_handrail_zone" );
end;
private.use_axe_handrail_end = function()
  if common_impl.ZzCompleteCheck("use_axe_handrail") then ObjSet( common_impl.hint["use_axe_handrail"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_handrail_anm_board", {animfunc = "end_ax1", frame = 0,pos_z = 4 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_axe_handrail", private.use_axe_handrail_inv );
cmn.AddSubscriber( "use_axe_handrail", private.use_axe_handrail_beg, private.room_objname );
cmn.AddSubscriber( "use_axe_handrail", private.use_axe_handrail_end, private.room_objname );
cmn.AddSubscriber( "use_axe_handrail", private.use_axe_handrail_logic );
cmn.AddSubscriber( "use_axe_handrail_inv", private.use_axe_handrail_inv, private.room_objname );
cmn.AddSubscriber( "use_axe_handrail_beg", private.use_axe_handrail_beg, private.room_objname );
cmn.AddSubscriber( "use_axe_handrail_end", private.use_axe_handrail_end, private.room_objname );
cmn.AddSubscriber( "use_axe_handrail_end", private.use_axe_handrail_logic );
--------------------------------------------------------------------------------------------
function public.use_axe_handrail( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_axe_handrail" );
    cmn.CallEventHandler( "use_axe_handrail_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_axe_handrail") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_axe_handrail_inv" );
  cmn.CallEventHandler( "use_axe_handrail_beg" );
  common_impl.Lock(1);
  
  ObjSet( "anm_handrail_anm_board", {pos_z = 10} );
  ld.AnimPlay( "anm_handrail_anm_board", "use_ax", func_end );
  SoundSfx( "aud_use_axe_handrail" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_board2" ] = { type = "get", get_obj = "spr_handrail_board2", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };

private.get_board2_logic = function()
  
end;
private.get_board2_inv = function()
  interface.InventoryItemAdd("inv_board","spr_handrail_board2",function() level_inv.ProcessGetBoardAll( "get_board2" ) end);
end;
private.get_board2_beg = function()
  ObjDelete("gfx_handrail_board2")
end;
private.get_board2_end = function()
  if common_impl.ZzCompleteCheck("get_board2") then ObjSet( common_impl.hint["get_board2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_seafront_board");
end;

cmn.AddSubscriber( "get_board2", private.get_board2_inv );
cmn.AddSubscriber( "get_board2", private.get_board2_beg, private.room_objname );
cmn.AddSubscriber( "get_board2", private.get_board2_end, private.room_objname );
cmn.AddSubscriber( "get_board2", private.get_board2_logic );
--------------------------------------------------------------------
function public.get_board2()
  cmn.SetEventDone( "get_board2" );
  cmn.CallEventHandler( "get_board2" );
  if common_impl.ZzCompleteCheck("get_board2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--function public.clk_idle_wrench_zone() 
--  common_impl.ShowBbt( 'need_wrench' )
--  ld.Lock(1)
--  --SoundSfx( "" );
--  ld.AnimPlay("anm_handrail_anm_wrench","idle_wrench1",function()ld.Lock(0)end)
--end;
--
--common_impl.hint[ "use_wrench" ] = { type = "use", inv_obj = "inv_wrench", use_place = "gfx_handrail_wrench_zone", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };
--
--private.use_wrench_logic = function()
--  ObjSet( "spr_handrail_ironarc", { input = 1, active = 1 } )
--
--end;
--private.use_wrench_inv = function()
--  common_impl.ProcessMultiUseAll("wrench", "wrench")
--end;
--private.use_wrench_beg = function()
--  ObjDelete( "gfx_handrail_wrench_zone" );
--end;
--private.use_wrench_end = function()
--  if common_impl.ZzCompleteCheck("use_wrench") then ObjSet( common_impl.hint["use_wrench"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjSet( "anm_handrail_anm_wrench", {animfunc = "end_wrench1", frame = 0, pos_z = 31 } );
--  ObjSet( "gfx_handrail_ironarc", {visible = 1} );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "use_wrench", private.use_wrench_inv );
--cmn.AddSubscriber( "use_wrench", private.use_wrench_beg, private.room_objname );
--cmn.AddSubscriber( "use_wrench", private.use_wrench_end, private.room_objname );
--cmn.AddSubscriber( "use_wrench", private.use_wrench_logic );
--cmn.AddSubscriber( "use_wrench_inv", private.use_wrench_inv, private.room_objname );
--cmn.AddSubscriber( "use_wrench_beg", private.use_wrench_beg, private.room_objname );
--cmn.AddSubscriber( "use_wrench_end", private.use_wrench_end, private.room_objname );
--cmn.AddSubscriber( "use_wrench_end", private.use_wrench_logic );
----------------------------------------------------------------------------------------------
--function public.use_wrench( obj )
--
--  local func_end = function()
--    ObjSet(obj,{visible = 1});
--    cmn.SetEventDone( "use_wrench" );
--    cmn.CallEventHandler( "use_wrench_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("use_wrench") then ld.CloseSubRoom() end;
--  end;
--
--  ObjSet(obj,{visible = 0});
--  cmn.CallEventHandler( "use_wrench_inv" );
--  cmn.CallEventHandler( "use_wrench_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_handrail_anm_wrench", "use_wrench", func_end );
--  SoundSfx( "aud_use_wrench_seafront" )
--  --func_end()
--
--end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
--common_impl.hint[ "get_ironarc" ] = { type = "get", get_obj = "spr_handrail_ironarc", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };
--
--private.get_ironarc_logic = function()
--  
--end;
--private.get_ironarc_inv = function()
--  interface.InventoryItemAdd("inv_ironarc","spr_handrail_ironarc");
--end;
--private.get_ironarc_beg = function()
--  ObjDelete("gfx_handrail_ironarc")
--end;
--private.get_ironarc_end = function()
--  if common_impl.ZzCompleteCheck("get_ironarc") then ObjSet( common_impl.hint["get_ironarc"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjDelete("anm_handrail_anm_wrench");
--end;
--
--cmn.AddSubscriber( "get_ironarc", private.get_ironarc_inv );
--cmn.AddSubscriber( "get_ironarc", private.get_ironarc_beg, private.room_objname );
--cmn.AddSubscriber( "get_ironarc", private.get_ironarc_end, private.room_objname );
--cmn.AddSubscriber( "get_ironarc", private.get_ironarc_logic );
----------------------------------------------------------------------
--function public.get_ironarc()
--  ObjSet( "anm_handrail_anm_wrench", {visible = 0} );
--  ObjSet( "spr_handrail_ironarc", {visible = 1} );
--  cmn.SetEventDone( "get_ironarc" );
--  cmn.CallEventHandler( "get_ironarc" );
--  if common_impl.ZzCompleteCheck("get_ironarc") then ld.CloseSubRoom() end;
--end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_padlock_zone() 
  
  if ld.CheckRequirements( {"use_padlock1"} ) then
    common_impl.ShowBbt( 'need_padlock2' )
  else 
    if ld.CheckRequirements( {"use_padlock2"} ) then
      common_impl.ShowBbt( 'need_padlock1' )
    else
      ld.Lock(1)
      common_impl.ShowBbt( 'need_padlock1' )
      SoundSfx( "aud_touch_big_metal" );
      ld.AnimPlay("anm_handrail_anm_door","idle_door",function()ld.Lock(0)end)
    end
  --SoundSfx( "" );
  end
end;

common_impl.hint[ "use_padlock1" ] = { type = "use", inv_obj = "inv_padlock1", use_place = "gfx_handrail_padlock1_zone", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };

private.use_padlock1_logic = function()
  if ld.CheckRequirements( {"use_padlock1","use_padlock2"} ) then
    ObjSet("gfx_handrail_win_locks_zone",{ active = 1 })
  end;

end;
private.use_padlock1_inv = function()
  common_impl.ProcessMultiUseAll("padlock1", "padlock1")
end;
private.use_padlock1_beg = function()
  ObjDelete( "gfx_handrail_padlock1_zone" );
end;
private.use_padlock1_end = function()
  if common_impl.ZzCompleteCheck("use_padlock1") then ObjSet( common_impl.hint["use_padlock1"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_padlock1","use_padlock2"} ) then
    ObjSet( "anm_handrail_anm_door", {animfunc = "end_padlock12", frame = 0 } );
    ObjDelete("anm_handrail_anm_door2");
    ObjAttach("obj_handrail_mmg_locks_root","zz_handrail")
    ObjSet( "obj_handrail_mmg_locks_root", {input = 1, alp = 1,pos_z = 50} );   
  else
    ObjSet( "anm_handrail_anm_door", {animfunc = "use_padlock1", frame = 999 } );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_padlock1", private.use_padlock1_inv );
cmn.AddSubscriber( "use_padlock1", private.use_padlock1_beg, private.room_objname );
cmn.AddSubscriber( "use_padlock1", private.use_padlock1_end, private.room_objname );
cmn.AddSubscriber( "use_padlock1", private.use_padlock1_logic );
cmn.AddSubscriber( "use_padlock1_inv", private.use_padlock1_inv, private.room_objname );
cmn.AddSubscriber( "use_padlock1_beg", private.use_padlock1_beg, private.room_objname );
cmn.AddSubscriber( "use_padlock1_end", private.use_padlock1_end, private.room_objname );
cmn.AddSubscriber( "use_padlock1_end", private.use_padlock1_logic );
--------------------------------------------------------------------------------------------
function public.use_padlock1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_padlock1" );
    cmn.CallEventHandler( "use_padlock1_end" );
    common_impl.Lock(0);
    if ld.CheckRequirements( {"use_padlock2"} ) then
      cmn.MiniGameShow( "locks" );    
      public.locks_load();
    end
    if common_impl.ZzCompleteCheck("use_padlock1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_padlock1_inv" );
  cmn.CallEventHandler( "use_padlock1_beg" );
  common_impl.Lock(1);
  
  local func_preend = function()
     if ld.CheckRequirements( {"use_padlock2"} ) then
        ObjAttach("obj_handrail_mmg_locks_root","zz_handrail")
        ObjSet("obj_handrail_mmg_locks_root",{pos_z=50})
        ObjAnimate( "obj_handrail_mmg_locks_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} ); 
     else
       func_end();
     end  
  end
  
  ld.AnimPlay( "anm_handrail_anm_door", "use_padlock1", func_preend );
  SoundSfx( "aud_use_padlock1_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------


common_impl.hint[ "use_padlock2" ] = { type = "use", inv_obj = "inv_padlock2", use_place = "gfx_handrail_padlock2_zone", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };

private.use_padlock2_logic = function()
  if ld.CheckRequirements( {"use_padlock2","use_padlock1"} ) then
    ObjSet("gfx_handrail_win_locks_zone",{ active = 1 })    
  end;

end;
private.use_padlock2_inv = function()
  common_impl.ProcessMultiUseAll("padlock2", "padlock2")
end;
private.use_padlock2_beg = function()
  ObjDelete( "gfx_handrail_padlock2_zone" );
end;
private.use_padlock2_end = function()
  if common_impl.ZzCompleteCheck("use_padlock2") then ObjSet( common_impl.hint["use_padlock2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_padlock1","use_padlock2"} ) then
    ObjSet( "anm_handrail_anm_door", {animfunc = "end_padlock12", frame = 0 } );
    ObjDelete("anm_handrail_anm_door2");
    ObjAttach("obj_handrail_mmg_locks_root","zz_handrail")
    ObjSet( "obj_handrail_mmg_locks_root", {input = 1, alp = 1,pos_z = 50} );   
  else
    ObjSet( "anm_handrail_anm_door2", {animfunc = "use_padlock2", frame = 999 } );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_padlock2", private.use_padlock2_inv );
cmn.AddSubscriber( "use_padlock2", private.use_padlock2_beg, private.room_objname );
cmn.AddSubscriber( "use_padlock2", private.use_padlock2_end, private.room_objname );
cmn.AddSubscriber( "use_padlock2", private.use_padlock2_logic );
cmn.AddSubscriber( "use_padlock2_inv", private.use_padlock2_inv, private.room_objname );
cmn.AddSubscriber( "use_padlock2_beg", private.use_padlock2_beg, private.room_objname );
cmn.AddSubscriber( "use_padlock2_end", private.use_padlock2_end, private.room_objname );
cmn.AddSubscriber( "use_padlock2_end", private.use_padlock2_logic );
--------------------------------------------------------------------------------------------
function public.use_padlock2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_padlock2" );
    cmn.CallEventHandler( "use_padlock2_end" );
    common_impl.Lock(0);
    if ld.CheckRequirements( {"use_padlock1"} ) then
      cmn.MiniGameShow( "locks" );    
      public.locks_load();
    end
    if common_impl.ZzCompleteCheck("use_padlock2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_padlock2_inv" );
  cmn.CallEventHandler( "use_padlock2_beg" );
  common_impl.Lock(1);
  
  local func_preend = function()
    if ld.CheckRequirements( {"use_padlock1"} ) then
        ObjAttach("obj_handrail_mmg_locks_root","zz_handrail")
        ObjSet("obj_handrail_mmg_locks_root",{pos_z=50})
        ObjAnimate( "obj_handrail_mmg_locks_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );  
     else
       func_end();
     end  
  end
  
  ld.AnimPlay( "anm_handrail_anm_door2", "use_padlock2", func_preend );
  SoundSfx( "aud_use_padlock2_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_locks" ] = { type = "click", use_place = "gfx_handrail_win_locks_zone", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };

private.win_locks_logic = function()
  ObjSet("spr_handrail_tube",{ visible = 1, input = 1, active = 1 })    
end;
private.win_locks_beg = function()
  ObjDelete( "gfx_handrail_win_locks_zone" );
end;
private.win_locks_end = function()
  if cmn.IsEventDone("win_locks") then 
    ObjDelete ("obj_handrail_mmg_locks_root");
    if common_impl.ZzCompleteCheck("win_locks") then ObjSet( common_impl.hint["win_locks"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjSet( "anm_handrail_anm_door", {animfunc = "end_door1", frame = 0 } );
    ObjDelete("spr_seafront_mmg");
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_locks", private.win_locks_beg, private.room_objname );
cmn.AddSubscriber( "win_locks", private.win_locks_end, private.room_objname );
cmn.AddSubscriber( "win_locks", private.win_locks_logic );
cmn.AddSubscriber( "win_locks_beg", private.win_locks_beg, private.room_objname );
cmn.AddSubscriber( "win_locks_end", private.win_locks_end, private.room_objname );
cmn.AddSubscriber( "win_locks_end", private.win_locks_logic );
--------------------------------------------------------------------------------------------
function public.win_locks()

  local func_end = function()
    cmn.SetEventDone( "win_locks" );
    cmn.CallEventHandler( "win_locks_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_locks") then ld.CloseSubRoom() end;
  end;
  
  cmn.MiniGameHide( "locks", true );
  cmn.CallEventHandler( "win_locks_beg" );
  common_impl.Lock(1);

  ObjAnimate( "obj_handrail_mmg_locks_root", 8, 0, 0,function() SoundSfx( "aud_open_handrail_cover_seafront" );  ld.AnimPlay( "anm_handrail_anm_door", "open_door", func_end ); end , {0,0,1, 0.5,0,0} );
 
   SoundSfx( "aud_mg_handrail_win" )
  --func_end()

end;

--------------------------------------------------------------------------------------------
local pos_arr = {{-116,-128},{117,-130},{125,130},{-109,124},{0,0}}
local color_arr = {{0,1,0},{1,0,0},{0,0,1},{1,1,0}}

function public.locks_load(skip)
  if not ng_global.progress["std"]["win_locks"].state then
    ng_global.progress["std"]["win_locks"].state = {4,1,2,3,0}
  end
 
  for i=1,5 do
    if (ng_global.progress["std"]["win_locks"].state[i] ~= 0) then 
      ObjSet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i],{pos_x = pos_arr[i][1], pos_y = pos_arr[i][2]})
    end
  end    
  if not skip then
    private.locks_check()
  end
end

function public.locks_button_mdown()
  local buff = ng_global.progress["std"]["win_locks"].state[5];
  for i = 5, 1, -1 do
    if (i == 1) then
      ng_global.progress["std"]["win_locks"].state[i] = ng_global.progress["std"]["win_locks"].state[5];
      
    else
      ng_global.progress["std"]["win_locks"].state[i] = ng_global.progress["std"]["win_locks"].state[i-1];
    end 
  end 
  ng_global.progress["std"]["win_locks"].state[5] = buff;
  ld.Lock(1);
  for j = 1, 4 do
    if ng_global.progress["std"]["win_locks"].state[j] ~=0 then
      ObjAnimate( "spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j], 3, 0, 0, "", {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j]).pos_x, ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j]).pos_y, 0.5,0,pos_arr[j][1], pos_y = pos_arr[j][2]} );      
  
    end
  end
  ld.StartTimer( 0.5, function() private.locks_check(); end )
  SoundSfx( "aud_mg_handrail_rotate" );
end

function public.locks_mdown(num) 
  local select_lock = num;
  
  if ( ng_global.progress["std"]["win_locks"].state[5] == 0 ) then
    ld.Lock(1);
    SoundSfx( "aud_mg_handrail_move" );
    ObjAnimate( "spr_handrail_mmg_locks_padlock"..num, 3, 0, 0, "", {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..num).pos_x, ObjGet("spr_handrail_mmg_locks_padlock"..num).pos_y, 0.5,0,pos_arr[5][1], pos_y = pos_arr[5][2]} );
    for i = 1,4 do
      if ( ng_global.progress["std"]["win_locks"].state[i] == select_lock ) then
        ng_global.progress["std"]["win_locks"].state[i] = 0;     
      end;
    end 
    ng_global.progress["std"]["win_locks"].state[5] = select_lock; 
  else
    if (num == ng_global.progress["std"]["win_locks"].state[5]) then
      for j = 1,4 do
        if ( ng_global.progress["std"]["win_locks"].state[j] == 0 ) then
          ld.Lock(1);
          ng_global.progress["std"]["win_locks"].state[j] = select_lock;
          ng_global.progress["std"]["win_locks"].state[5] = 0;
          SoundSfx( "aud_mg_handrail_move" );
          ObjAnimate( "spr_handrail_mmg_locks_padlock"..num, 3, 0, 0, "", {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..num).pos_x, ObjGet("spr_handrail_mmg_locks_padlock"..num).pos_y, 0.5,0,pos_arr[j][1], pos_y = pos_arr[j][2]} );
        end;
      end 
    end
   end
  
   ld.StartTimer( 0.5, function()  private.locks_check();  end ) 
end

function private.locks_check()
  local count = 0
  for i=1,4 do
    if (i==ng_global.progress["std"]["win_locks"].state[i]) then 
      count=count + 1 ;
      if ng_global.progress["std"]["win_locks"].state[i] ~=0 then
        ObjSet( "spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i].."_focus", {color_r = color_arr[i][1], color_g = color_arr[i][2], color_b = color_arr[i][3]} );
        if ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i].."_focus").alp==0 then SoundSfx( "aud_mg_handrail_light" ); end;
        ObjAnimate( "spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i].."_focus", 8, 0, 0, function() end, {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i].."_focus").alp, 0.3,0,1} );
      end
    else
      if ng_global.progress["std"]["win_locks"].state[i] ~=0 then
        ObjAnimate( "spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i].."_focus", 8, 0, 0, function() end, {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i].."_focus").alp, 0.3,0,0} ); 
        ObjSet( "spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[i].."_focus", {color_r = 1, color_g = 1, color_b = 1} ); 
      end
    end
  end
  ld.StartTimer( 0.3, function() ld.Lock(0); 
                                  if count == 4 then 
                                    ld.Lock(1);
                                    ld.StartTimer(1, function() ld.Lock(0); public.win_locks() end)
                                  end
                                  end );
end

function public.locks_menter(obj)
  ld.ShCur(CURSOR_HAND)
  ObjAnimate( obj.."_focus", 8, 0, 0, "", {0,0,ObjGet(obj.."_focus").alp, 0.3,0,1} );
end

function public.locks_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  if (ObjGet(obj.."_focus").color_r + ObjGet(obj.."_focus").color_g + ObjGet(obj.."_focus").color_b) == 3 then
    ObjAnimate( obj.."_focus", 8, 0, 0, "", {0,0,ObjGet(obj.."_focus").alp, 0.3,0,0} );  
  end
end

function  private.win_locks_reset()
  ng_global.progress["std"]["win_locks"].state = {4,1,2,3,0}
    local f_end = function ()
      -- ld.Lock(0)
      private.locks_check()
    end
    ld.Lock(1)
    for j = 1, 4 do
      ObjAnimate( "spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j], 3, 0, 0, "", {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j]).pos_x, ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j]).pos_y, 0.5,0,pos_arr[j][1], pos_y = pos_arr[j][2]} );
    end
    ld.StartTimer( 0.5, function() f_end() end )
end

function  private.win_locks_skip()
  ng_global.progress["std"]["win_locks"].state = {1,2,3,4,0}
    local f_end = function ()
      private.locks_check()
    end
    ld.Lock(1)
   for j = 1, 4 do
      ObjAnimate( "spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j], 3, 0, 0, "", {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j]).pos_x, ObjGet("spr_handrail_mmg_locks_padlock"..ng_global.progress["std"]["win_locks"].state[j]).pos_y, 0.5,0,pos_arr[j][1], pos_y = pos_arr[j][2]} );
    end
    ld.StartTimer( 0.5, function() f_end() end )
end

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tube" ] = { type = "get", get_obj = "spr_handrail_tube", room = "rm_seafront", zz = "zz_handrail", zz_gate = "gzz_seafront_handrail" };

private.get_tube_logic = function()
  
end;
private.get_tube_inv = function()
  interface.InventoryItemAdd("inv_tube","spr_handrail_tube");
end;
private.get_tube_beg = function()
  ObjDelete("gfx_handrail_tube")
end;
private.get_tube_end = function()
  if common_impl.ZzCompleteCheck("get_tube") then ObjSet( common_impl.hint["get_tube"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_handrail_sh_tube");
  ObjDelete("spr_seafront_tube");
end;

cmn.AddSubscriber( "get_tube", private.get_tube_inv );
cmn.AddSubscriber( "get_tube", private.get_tube_beg, private.room_objname );
cmn.AddSubscriber( "get_tube", private.get_tube_end, private.room_objname );
cmn.AddSubscriber( "get_tube", private.get_tube_logic );
--------------------------------------------------------------------
function public.get_tube()
  cmn.SetEventDone( "get_tube" );
  cmn.CallEventHandler( "get_tube" );
  if common_impl.ZzCompleteCheck("get_tube") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_onmountain *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_tile" ] = { type = "get", get_obj = "spr_onmountain_tile", room = "rm_seafront", zz = "zz_onmountain", zz_gate = "gzz_seafront_onmountain" };

private.get_tile_logic = function()
  
end;
private.get_tile_inv = function()
  interface.InventoryItemAdd("inv_tile","spr_onmountain_tile");
end;
private.get_tile_beg = function()
  ObjDelete("gfx_onmountain_tile")
end;
private.get_tile_end = function()
  if common_impl.ZzCompleteCheck("get_tile") then ObjSet( common_impl.hint["get_tile"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_tile", private.get_tile_inv );
cmn.AddSubscriber( "get_tile", private.get_tile_beg, private.room_objname );
cmn.AddSubscriber( "get_tile", private.get_tile_end, private.room_objname );
cmn.AddSubscriber( "get_tile", private.get_tile_logic );
--------------------------------------------------------------------
function public.get_tile()
  cmn.SetEventDone( "get_tile" );
  cmn.CallEventHandler( "get_tile" );
  if common_impl.ZzCompleteCheck("get_tile") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_onmountain_dolly_zone() 
  common_impl.ShowBbt( 'need_wrench' )
  
    ld.Lock(1)
    SoundSfx( "aud_touch_small_plastic" );
    ld.AnimPlay("anm_onmountain_anm_dolly","idle_ironarc1",function()ld.Lock(0)end)
  
end;

common_impl.hint[ "use_wrench" ] = { type = "use", inv_obj = "inv_wrench", use_place = "gfx_onmountain_wrench_zone", room = "rm_seafront", zz = "zz_onmountain", zz_gate = "gzz_seafront_onmountain" };

private.use_wrench_logic = function()
  ObjSet( "spr_onmountain_dolly2", { visible = 1, input = 1, active = 1 } )

end;
private.use_wrench_inv = function()
  common_impl.ProcessMultiUseAll("wrench", "wrench")
end;
private.use_wrench_beg = function()
  ObjDelete( "gfx_onmountain_wrench_zone" );
end;
private.use_wrench_end = function()
  if common_impl.ZzCompleteCheck("use_wrench") then ObjSet( common_impl.hint["use_wrench"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_onmountain_anm_dolly");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wrench", private.use_wrench_inv );
cmn.AddSubscriber( "use_wrench", private.use_wrench_beg, private.room_objname );
cmn.AddSubscriber( "use_wrench", private.use_wrench_end, private.room_objname );
cmn.AddSubscriber( "use_wrench", private.use_wrench_logic );
cmn.AddSubscriber( "use_wrench_inv", private.use_wrench_inv, private.room_objname );
cmn.AddSubscriber( "use_wrench_beg", private.use_wrench_beg, private.room_objname );
cmn.AddSubscriber( "use_wrench_end", private.use_wrench_end, private.room_objname );
cmn.AddSubscriber( "use_wrench_end", private.use_wrench_logic );
--------------------------------------------------------------------------------------------
function public.use_wrench( obj )

  local func_end = function()

    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wrench" );
    cmn.CallEventHandler( "use_wrench_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wrench") then ld.CloseSubRoom() end;
    public.get_dolly2()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wrench_inv" );
  cmn.CallEventHandler( "use_wrench_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onmountain_anm_dolly", "use_ironarc", func_end );
  SoundSfx( "aud_use_file_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dolly2" ] = { type = "get", get_obj = "spr_onmountain_dolly2", room = "rm_seafront", zz = "zz_onmountain", zz_gate = "gzz_seafront_onmountain" };

private.get_dolly2_logic = function()
  
end;
private.get_dolly2_inv = function()
  interface.InventoryItemAdd("inv_dolly","spr_onmountain_dolly2",function() level_inv.ProcessGetDollyAll( "get_dolly2" ) end);
end;
private.get_dolly2_beg = function()
  ObjDelete("gfx_onmountain_dolly2")
end;
private.get_dolly2_end = function()
  if common_impl.ZzCompleteCheck("get_dolly2") then ObjSet( common_impl.hint["get_dolly2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_dolly2", private.get_dolly2_inv );
cmn.AddSubscriber( "get_dolly2", private.get_dolly2_beg, private.room_objname );
cmn.AddSubscriber( "get_dolly2", private.get_dolly2_end, private.room_objname );
cmn.AddSubscriber( "get_dolly2", private.get_dolly2_logic );
--------------------------------------------------------------------
function public.get_dolly2()
  cmn.SetEventDone( "get_dolly2" );
  cmn.CallEventHandler( "get_dolly2" );
  if common_impl.ZzCompleteCheck("get_dolly2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_onmountain_board_zone() 
  common_impl.ShowBbt( 'need_board' )
  if (ld.CheckRequirements( {"get_tile"} ))  then
    ld.Lock(1)
    SoundSfx( "aud_touch_medium_door" );
    ld.AnimPlay("anm_onmountain_anm_board","idle_board1",function()ld.Lock(0)end)
  end
end;

common_impl.hint[ "use_board" ] = { type = "use", inv_obj = "inv_board", use_place = "gfx_onmountain_board_zone", room = "rm_seafront", zz = "zz_onmountain", zz_gate = "gzz_seafront_onmountain" };

private.use_board_logic = function()
  ObjSet( "gfx_onmountain_rope_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_board_inv = function()
  common_impl.ProcessMultiUseAll("board", "board")
end;
private.use_board_beg = function()
  ObjDelete( "gfx_onmountain_board_zone" );
end;
private.use_board_end = function()
  if common_impl.ZzCompleteCheck("use_board") then ObjSet( common_impl.hint["use_board"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_onmountain_anm_board", {animfunc = "end_board1", frame = 0 } );
  ObjSet( "spr_seafront_1", {visible = 1} );
  ObjSet( "spr_seafront_2", {visible = 1} );
  ObjSet( "spr_seafront_3", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_board", private.use_board_inv );
cmn.AddSubscriber( "use_board", private.use_board_beg, private.room_objname );
cmn.AddSubscriber( "use_board", private.use_board_end, private.room_objname );
cmn.AddSubscriber( "use_board", private.use_board_logic );
cmn.AddSubscriber( "use_board_inv", private.use_board_inv, private.room_objname );
cmn.AddSubscriber( "use_board_beg", private.use_board_beg, private.room_objname );
cmn.AddSubscriber( "use_board_end", private.use_board_end, private.room_objname );
cmn.AddSubscriber( "use_board_end", private.use_board_logic );
--------------------------------------------------------------------------------------------
function public.use_board( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_board" );
    cmn.CallEventHandler( "use_board_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_board") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_board_inv" );
  cmn.CallEventHandler( "use_board_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onmountain_anm_board", "use_board", func_end );
  SoundSfx( "aud_use_board_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_onmountain_rope_zone() 
 common_impl.ShowBbt( 'need_rope' )
  
    ld.Lock(1)
    SoundSfx( "aud_touch_small_wood" );
    ld.AnimPlay("anm_onmountain_anm_board","idle_rope1",function()ld.Lock(0)end)
  
end;

common_impl.hint[ "use_rope" ] = { type = "use", inv_obj = "inv_rope", use_place = "gfx_onmountain_rope_zone", room = "rm_seafront", zz = "zz_onmountain", zz_gate = "gzz_seafront_onmountain" };

private.use_rope_logic = function()
  ObjSet( "grm_seafront_terrace", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_seafront_terrace_focus");
  end;
end;
private.use_rope_inv = function()
  common_impl.ProcessMultiUseAll("rope", "rope")
end;
private.use_rope_beg = function()
  ObjDelete( "gfx_onmountain_rope_zone" );
end;
private.use_rope_end = function()
  if common_impl.ZzCompleteCheck("use_rope") then ObjSet( common_impl.hint["use_rope"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_onmountain_anm_board", {animfunc = "end_rope1", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rope", private.use_rope_inv );
cmn.AddSubscriber( "use_rope", private.use_rope_beg, private.room_objname );
cmn.AddSubscriber( "use_rope", private.use_rope_end, private.room_objname );
cmn.AddSubscriber( "use_rope", private.use_rope_logic );
cmn.AddSubscriber( "use_rope_inv", private.use_rope_inv, private.room_objname );
cmn.AddSubscriber( "use_rope_beg", private.use_rope_beg, private.room_objname );
cmn.AddSubscriber( "use_rope_end", private.use_rope_end, private.room_objname );
cmn.AddSubscriber( "use_rope_end", private.use_rope_logic );
--------------------------------------------------------------------------------------------
function public.use_rope( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rope" );
    cmn.CallEventHandler( "use_rope_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rope") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rope_inv" );
  cmn.CallEventHandler( "use_rope_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onmountain_anm_board", "use_rope", func_end );
  SoundSfx( "aud_use_rope_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_monument *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_idle_monument_tile_zone() 
  common_impl.ShowBbt( 'need_tile' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay("anm_monument_anm_tile","idle_tile2",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_tile" ] = { type = "use", inv_obj = "inv_tile", use_place = "gfx_monument_tile_zone", room = "rm_seafront", zz = "zz_monument", zz_gate = "gzz_seafront_monument" };

private.use_tile_logic = function()
  ObjSet( "gfx_monument_win_hidingplace_zone", { active = 1 } )

end;
private.use_tile_inv = function()
  common_impl.ProcessMultiUseAll("tile", "tile")
end;
private.use_tile_beg = function()
  ObjDelete( "gfx_monument_tile_zone" );
end;
private.use_tile_end = function()
  if common_impl.ZzCompleteCheck("use_tile") then ObjSet( common_impl.hint["use_tile"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_monument_anm_tile", {animfunc = "end_tile1", frame = 0 } );
  ObjAttach("obj_monument_mmg_hidingplace_root","zz_monument")
  ObjSet( "obj_monument_mmg_hidingplace_root", {input = 1, alp = 1,pos_z = 50} );   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tile", private.use_tile_inv );
cmn.AddSubscriber( "use_tile", private.use_tile_beg, private.room_objname );
cmn.AddSubscriber( "use_tile", private.use_tile_end, private.room_objname );
cmn.AddSubscriber( "use_tile", private.use_tile_logic );
cmn.AddSubscriber( "use_tile_inv", private.use_tile_inv, private.room_objname );
cmn.AddSubscriber( "use_tile_beg", private.use_tile_beg, private.room_objname );
cmn.AddSubscriber( "use_tile_end", private.use_tile_end, private.room_objname );
cmn.AddSubscriber( "use_tile_end", private.use_tile_logic );
--------------------------------------------------------------------------------------------
function public.use_tile( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tile" );
    cmn.CallEventHandler( "use_tile_end" );
    cmn.MiniGameShow( "hidingplace" );    
    public.hidingplace_load();
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tile") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tile_inv" );
  cmn.CallEventHandler( "use_tile_beg" );
  common_impl.Lock(1);
  
   local func_preend = function()
         ObjAttach("obj_monument_mmg_hidingplace_root","zz_monument")
        ObjSet( "obj_monument_mmg_hidingplace_root", {pos_z = 50} ); 
        ObjAnimate( "obj_monument_mmg_hidingplace_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );  
    
  end
  
  ld.AnimPlay( "anm_monument_anm_tile", "use_tile", func_preend );
  SoundSfx( "aud_use_tile_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_hidingplace" ] = { type = "click", use_place = "gfx_monument_win_hidingplace_zone", room = "rm_seafront", zz = "zz_monument", zz_gate = "gzz_seafront_monument" };

private.win_hidingplace_logic = function()
  ObjSet( "spr_monument_board3", {  input = 1, active = 1 } )
  ObjSet( "spr_monument_starfish", {  input = 1, active = 1 } )

end;
private.win_hidingplace_beg = function()
  ObjDelete( "gfx_monument_win_hidingplace_zone" );
end;
private.win_hidingplace_end = function()
  if cmn.IsEventDone("win_hidingplace") then 
    ObjDelete ("obj_monument_mmg_hidingplace_root");
    if common_impl.ZzCompleteCheck("win_hidingplace") then ObjSet( common_impl.hint["win_hidingplace"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjSet( "anm_monument_anm_tile", {animfunc = "end_tile2", frame = 0 } );
    ObjDelete("spr_seafront_cache");
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_hidingplace", private.win_hidingplace_beg, private.room_objname );
cmn.AddSubscriber( "win_hidingplace", private.win_hidingplace_end, private.room_objname );
cmn.AddSubscriber( "win_hidingplace", private.win_hidingplace_logic );
cmn.AddSubscriber( "win_hidingplace_beg", private.win_hidingplace_beg, private.room_objname );
cmn.AddSubscriber( "win_hidingplace_end", private.win_hidingplace_end, private.room_objname );
cmn.AddSubscriber( "win_hidingplace_end", private.win_hidingplace_logic );
--------------------------------------------------------------------------------------------
function public.win_hidingplace()

  local func_end = function()
    cmn.SetEventDone( "win_hidingplace" );
    cmn.CallEventHandler( "win_hidingplace_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_hidingplace") then ld.CloseSubRoom() end;
  end;
  
  cmn.MiniGameHide( "hidingplace", true );
  cmn.CallEventHandler( "win_hidingplace_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_monument_open_seafront" );
  ObjAnimate( "obj_monument_mmg_hidingplace_root", 8, 0, 0,function() ld.AnimPlay( "anm_monument_anm_tile", "open_tile1", func_end ); end , {0,0,1, 0.5,0,0} );
  --SoundSfx( 0 )
  --func_end()

end;

--------------------------------------------------------------------------------------------
local pos_arr = {{-110,-108},{0,-108},{110,-108},{-110,3},{0,3},{110,3},{-110,112},{0,112},{110,112}}
local select_tile = 0;

function public.hidingplace_load(skip)
  if not ng_global.progress["std"]["win_hidingplace"].state then
    ng_global.progress["std"]["win_hidingplace"].state = {5,7,1,9,6,3,8,2,4}
  end
 
  for i=1,9 do
    if (ng_global.progress["std"]["win_hidingplace"].state[i] ~= 0) then 
      ObjSet("spr_monument_mmg_hidingplace_tile"..ng_global.progress["std"]["win_hidingplace"].state[i],{pos_x = pos_arr[i][1], pos_y = pos_arr[i][2]})
    end
  end    
  if not skip then
    private.hidingplace_check()
  end
end


function public.hidingplace_mdown(num) 
  SoundSfx( "aud_mg_monument_click" )
 
  if (select_tile == 0) then
    select_tile = num;
    --ObjAnimate( "spr_monument_mmg_hidingplace_tile"..num.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..num.."_focus").alp, 0.3,0,1} );
  else
    ld.Lock(1);
    ObjSet( "spr_monument_mmg_hidingplace_tile"..select_tile, {pos_z = 10} );
    ObjSet( "spr_monument_mmg_hidingplace_tile"..num, {pos_z = 10} );
    for i = 1,9 do
      if ng_global.progress["std"]["win_hidingplace"].state[i] == num then
        ng_global.progress["std"]["win_hidingplace"].state[i] = select_tile; 
        SoundSfx( "aud_mg_monument_move" );
        ObjAnimate( "spr_monument_mmg_hidingplace_tile"..select_tile, 3, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..select_tile).pos_x, ObjGet("spr_monument_mmg_hidingplace_tile"..select_tile).pos_y, 0.5,0,pos_arr[i][1], pos_y = pos_arr[i][2]} );
      else
        if ng_global.progress["std"]["win_hidingplace"].state[i] == select_tile then
          SoundSfx( "aud_mg_monument_move" );
          ng_global.progress["std"]["win_hidingplace"].state[i] = num;
          ObjAnimate( "spr_monument_mmg_hidingplace_tile"..num, 3, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..num).pos_x, ObjGet("spr_monument_mmg_hidingplace_tile"..num).pos_y, 0.5,0,pos_arr[i][1], pos_y = pos_arr[i][2]} );
        end
      end
    end  
   -- if  (select_tile == num) then
      
     --ObjAnimate( "spr_monument_mmg_hidingplace_tile"..num.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..num.."_focus").alp, 0.5,0,0} );
  --  else
     --ObjAnimate( "spr_monument_mmg_hidingplace_tile"..num, 3, 0, 0, "", {0,0,ObjGet("spr_handrail_mmg_locks_padlock"..num).pos_x, ObjGet("spr_monument_mmg_hidingplace_tile"..num).pos_y, 0.5,0,pos_arr[5][1], pos_y = pos_arr[5][2]} );
     
    
    ld.StartTimer( 0.5, function() 
      ObjSet( "spr_monument_mmg_hidingplace_tile"..select_tile, {pos_z = 5} );
      ObjSet( "spr_monument_mmg_hidingplace_tile"..num, {pos_z = 5} ); 
      select_tile = 0;
      private.hidingplace_check();  
    end )
     
  end
  
end

function private.hidingplace_check()
  local count = 0
  for i=1,9 do
    if (i==ng_global.progress["std"]["win_hidingplace"].state[i]) then 
      count=count + 1 ;
    end
    ObjAnimate( "spr_monument_mmg_hidingplace_tile"..i.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..i.."_focus").alp, 0.3,0,0} );  
  end
  
 local func_f = function() 
    ld.Lock(0); 
    if count == 9 then 
      ld.Lock(1);
      for i=1,9 do
        ObjAnimate( "spr_monument_mmg_hidingplace_tile"..i.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..i.."_focus").alp, 0.3,0,0} );  
      end
      ld.StartTimer(0.5, function() ld.Lock(0); public.win_hidingplace() end)
    end  
 end
 
 ld.StartTimer( 0.3, function() func_f() end );
 if count ==  9 then SoundSfx( "aud_mg_monument_win" ); end;  
end

function public.hidingplace_menter(obj)
  ld.ShCur(CURSOR_HAND)
  ObjSet( obj, {pos_z = 10} );
  ObjAnimate( obj.."_focus", 8, 0, 0, "", {0,0,ObjGet(obj.."_focus").alp, 0.3,0,1} );
end

function public.hidingplace_mleave(num)
  ld.ShCur(CURSOR_DEFAULT)
  if (select_tile ~= num) then
    
    ObjAnimate( "spr_monument_mmg_hidingplace_tile"..num.."_focus", 8, 0, 0, function() ObjSet( "spr_monument_mmg_hidingplace_tile"..num, {pos_z = 5} ); end, {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..num.."_focus").alp, 0.3,0,0} );  
  end
end

function  private.win_hidingplace_reset()
  ng_global.progress["std"]["win_hidingplace"].state = {5,7,1,9,6,3,8,2,4}
  select_tile = 0;
    local f_end = function ()
      -- ld.Lock(0)
      private.hidingplace_check()
    end
    ld.Lock(1)
    for j = 1, 9 do
      ObjAnimate( "spr_monument_mmg_hidingplace_tile"..ng_global.progress["std"]["win_hidingplace"].state[j], 3, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..ng_global.progress["std"]["win_hidingplace"].state[j]).pos_x, ObjGet("spr_monument_mmg_hidingplace_tile"..ng_global.progress["std"]["win_hidingplace"].state[j]).pos_y, 0.5,0,pos_arr[j][1], pos_y = pos_arr[j][2]} );
    end
    ld.StartTimer( 0.5, function() f_end() end )
end

function  private.win_hidingplace_skip()
  ng_global.progress["std"]["win_hidingplace"].state = {1,2,3,4,5,6,7,8,9}
  select_tile = 0;
    local f_end = function ()
      private.hidingplace_check()
    end
    ld.Lock(1)
    for j = 1, 9 do
      ObjAnimate( "spr_monument_mmg_hidingplace_tile"..ng_global.progress["std"]["win_hidingplace"].state[j], 3, 0, 0, "", {0,0,ObjGet("spr_monument_mmg_hidingplace_tile"..ng_global.progress["std"]["win_hidingplace"].state[j]).pos_x, ObjGet("spr_monument_mmg_hidingplace_tile"..ng_global.progress["std"]["win_hidingplace"].state[j]).pos_y, 0.5,0,pos_arr[j][1], pos_y = pos_arr[j][2]} );
    end
    ld.StartTimer( 0.5, function() f_end() end )
end

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_board3" ] = { type = "get", get_obj = "spr_monument_board3", room = "rm_seafront", zz = "zz_monument", zz_gate = "gzz_seafront_monument" };

private.get_board3_logic = function()
  
end;
private.get_board3_inv = function()
  interface.InventoryItemAdd("inv_board","spr_monument_board3",function() level_inv.ProcessGetBoardAll( "get_board3" ) end);
end;
private.get_board3_beg = function()
  ObjDelete("gfx_monument_board3")
end;
private.get_board3_end = function()
  if common_impl.ZzCompleteCheck("get_board3") then ObjSet( common_impl.hint["get_board3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_monument_sh_board3");
  ObjDelete("spr_seafront_board3");
end;

cmn.AddSubscriber( "get_board3", private.get_board3_inv );
cmn.AddSubscriber( "get_board3", private.get_board3_beg, private.room_objname );
cmn.AddSubscriber( "get_board3", private.get_board3_end, private.room_objname );
cmn.AddSubscriber( "get_board3", private.get_board3_logic );
--------------------------------------------------------------------
function public.get_board3()
  cmn.SetEventDone( "get_board3" );
  cmn.CallEventHandler( "get_board3" );
  if common_impl.ZzCompleteCheck("get_board3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_starfish" ] = { type = "get", get_obj = "spr_monument_starfish", room = "rm_seafront", zz = "zz_monument", zz_gate = "gzz_seafront_monument" };

private.get_starfish_logic = function()
  
end;
private.get_starfish_inv = function()
  interface.InventoryItemAdd("inv_starfish","spr_monument_starfish");
end;
private.get_starfish_beg = function()
  ObjDelete("gfx_monument_starfish")
end;
private.get_starfish_end = function()
  if common_impl.ZzCompleteCheck("get_starfish") then ObjSet( common_impl.hint["get_starfish"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjDelete("spr_monument_sh_starfish");
   ObjDelete("spr_seafront_starfish");
end;

cmn.AddSubscriber( "get_starfish", private.get_starfish_inv );
cmn.AddSubscriber( "get_starfish", private.get_starfish_beg, private.room_objname );
cmn.AddSubscriber( "get_starfish", private.get_starfish_end, private.room_objname );
cmn.AddSubscriber( "get_starfish", private.get_starfish_logic );
--------------------------------------------------------------------
function public.get_starfish()
  cmn.SetEventDone( "get_starfish" );
  cmn.CallEventHandler( "get_starfish" );
  if common_impl.ZzCompleteCheck("get_starfish") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_glass" ] = { type = "use", inv_obj = "inv_glass", use_place = "gfx_monument_glass_zone", room = "rm_seafront", zz = "zz_monument", zz_gate = "gzz_seafront_monument" };

private.use_glass_logic = function()
  ObjSet( "spr_monument_grains", { visible = 1, input = 1, active = 1 } )
end;
private.use_glass_inv = function()
  common_impl.ProcessMultiUseAll("glass", "glass")
end;
private.use_glass_beg = function()
  ObjDelete( "gfx_monument_glass_zone" );
end;
private.use_glass_end = function()
  if common_impl.ZzCompleteCheck("use_glass") then ObjSet( common_impl.hint["use_glass"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_monument_anm_grains", {animfunc = "use_cup", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_glass", private.use_glass_inv );
cmn.AddSubscriber( "use_glass", private.use_glass_beg, private.room_objname );
cmn.AddSubscriber( "use_glass", private.use_glass_end, private.room_objname );
cmn.AddSubscriber( "use_glass", private.use_glass_logic );
cmn.AddSubscriber( "use_glass_inv", private.use_glass_inv, private.room_objname );
cmn.AddSubscriber( "use_glass_beg", private.use_glass_beg, private.room_objname );
cmn.AddSubscriber( "use_glass_end", private.use_glass_end, private.room_objname );
cmn.AddSubscriber( "use_glass_end", private.use_glass_logic );
--------------------------------------------------------------------------------------------
function public.use_glass( obj )

  local func_end = function()

    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_glass" );
    cmn.CallEventHandler( "use_glass_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_glass") then ld.CloseSubRoom() end;
    public.get_grains()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_glass_inv" );
  cmn.CallEventHandler( "use_glass_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_monument_anm_grains", "use_cup", func_end );
  SoundSfx( "aud_use_glass_seafront" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_grains" ] = { type = "get", get_obj = "spr_monument_grains", room = "rm_seafront", zz = "zz_monument", zz_gate = "gzz_seafront_monument" };

private.get_grains_logic = function()
  
end;
private.get_grains_inv = function()
  interface.InventoryItemAdd("inv_grains","spr_monument_grains");
end;
private.get_grains_beg = function()
  ObjDelete("gfx_monument_grains")
end;
private.get_grains_end = function()
  if common_impl.ZzCompleteCheck("get_grains") then ObjSet( common_impl.hint["get_grains"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_seafront_grains");
end;

cmn.AddSubscriber( "get_grains", private.get_grains_inv );
cmn.AddSubscriber( "get_grains", private.get_grains_beg, private.room_objname );
cmn.AddSubscriber( "get_grains", private.get_grains_end, private.room_objname );
cmn.AddSubscriber( "get_grains", private.get_grains_logic );
--------------------------------------------------------------------
function public.get_grains()
  cmn.SetEventDone( "get_grains" );
  cmn.CallEventHandler( "get_grains" );
  if common_impl.ZzCompleteCheck("get_grains") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_marine_for_seafront = function()
    if ld.CheckRequirements( {"win_marine"} ) then
      ObjSet( "gho_seafront_marine", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_marine", win_marine_for_seafront, private.room_objname )

end;
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_handrail" ) and not ld.CheckRequirements( { "win_locks" } ) then  
    private.win_locks_reset();
  end;
  if ( mg_name == "zz_monument" ) and not ld.CheckRequirements( { "win_hidingplace" } ) then  
    private.win_hidingplace_reset();
  end;
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_handrail" ) and not ld.CheckRequirements( { "win_locks" } ) then
    private.win_locks_skip();
  end;
  if ( mg_name == "zz_monument" ) and not ld.CheckRequirements( { "win_hidingplace" } ) then
    private.win_hidingplace_skip();
  end;
end

--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_seafront();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_seafront_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_monument" );
  function zz_monument.Open()
  end;
  function zz_monument.PreOpen()
    if cmn.IsEventStart("win_hidingplace") and not cmn.IsEventDone("win_hidingplace") then 
      cmn.MiniGameShow( "hidingplace" ); 
      public.hidingplace_load()
     end;  
  end;
  function zz_monument.PreClose()
  end;
  function zz_monument.Close()
  end;

  subroom.Define( "zz_onmountain" );
  function zz_onmountain.Open()
  end;
  function zz_onmountain.PreOpen()
  end;
  function zz_onmountain.PreClose()
  end;
  function zz_onmountain.Close()
  end;

  subroom.Define( "zz_handrail" );
  function zz_handrail.Open()
  end;
  function zz_handrail.PreOpen()
    if cmn.IsEventStart("win_locks") and not cmn.IsEventDone("win_locks") then 
      cmn.MiniGameShow( "locks" ); 
      public.locks_load()
     end;    
  end;
  function zz_handrail.PreClose()
  end;
  function zz_handrail.Close()
  end;

  subroom.Define( "zz_pier" );
  function zz_pier.Open()
  end;
  function zz_pier.PreOpen()
  end;
  function zz_pier.PreClose()
  end;
  function zz_pier.Close()
  end;
  
end;
--*********************************************************************************************************************