-- name=rm_secondfloor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secondfloor";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_secondfloor()
  if not ( cmn.IsEventDone( "opn_secondfloor" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_secondfloor" );
      cmn.CallEventHandler( "opn_secondfloor" )
      ld.ShowBbt( "opn_secondfloor" )
      SoundTheme( "aud_danger_moment1_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_secondfloor = function() end;
local opn_secondfloor_logic = function() end;
cmn.AddSubscriber( "opn_secondfloor", opn_secondfloor_logic )
cmn.AddSubscriber( "opn_secondfloor", opn_secondfloor, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wallcabinet *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_winderwallcabinet" ] = { type = "click", use_place = "gfx_wallcabinet_clk_winderwallcabinet_zone", room = "rm_secondfloor", zz = "zz_wallcabinet", zz_gate = "gzz_secondfloor_wallcabinet" };

private.clk_winderwallcabinet_logic = function()
  ObjSet( "spr_wallcabinet_winder", {active = 1, input = 1, visible = 1} );  
end;
private.clk_winderwallcabinet_beg = function()
  ObjDelete( "gfx_wallcabinet_clk_winderwallcabinet_zone" );
end;
private.clk_winderwallcabinet_end = function()
  if common_impl.ZzCompleteCheck("clk_winderwallcabinet") then ObjSet( common_impl.hint["clk_winderwallcabinet"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_wallcabinet_anm_key", {animfunc = "end_winder1", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_winderwallcabinet", private.clk_winderwallcabinet_beg, private.room_objname );
cmn.AddSubscriber( "clk_winderwallcabinet", private.clk_winderwallcabinet_end, private.room_objname );
cmn.AddSubscriber( "clk_winderwallcabinet", private.clk_winderwallcabinet_logic );
cmn.AddSubscriber( "clk_winderwallcabinet_beg", private.clk_winderwallcabinet_beg, private.room_objname );
cmn.AddSubscriber( "clk_winderwallcabinet_end", private.clk_winderwallcabinet_end, private.room_objname );
cmn.AddSubscriber( "clk_winderwallcabinet_end", private.clk_winderwallcabinet_logic );
--------------------------------------------------------------------------------------------
function public.clk_winderwallcabinet()

  local func_end = function()
    cmn.SetEventDone( "clk_winderwallcabinet" );
    cmn.CallEventHandler( "clk_winderwallcabinet_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_winderwallcabinet") then ld.CloseSubRoom() end;
    public.get_winder();
  end;

  cmn.CallEventHandler( "clk_winderwallcabinet_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wallcabinet_anm_key", "click_winder", func_end );
  SoundSfx( "aud_touch_key_secondfloor" )
  --func_end()

end;
----------------------------------------------------------------------------------------------

-------------------------
common_impl.hint[ "get_winder" ] = { type = "get", get_obj = "spr_wallcabinet_winder", room = "rm_secondfloor", zz = "zz_wallcabinet", zz_gate = "gzz_secondfloor_wallcabinet" };

private.get_winder_logic = function()
  
end;
private.get_winder_inv = function()
  interface.InventoryItemAdd("inv_winder","spr_wallcabinet_winder");
end;
private.get_winder_beg = function()
  ObjDelete("gfx_wallcabinet_winder")
end;
private.get_winder_end = function()
  if common_impl.ZzCompleteCheck("get_winder") then ObjSet( common_impl.hint["get_winder"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_secondfloor_winder");
end;

cmn.AddSubscriber( "get_winder", private.get_winder_inv );
cmn.AddSubscriber( "get_winder", private.get_winder_beg, private.room_objname );
cmn.AddSubscriber( "get_winder", private.get_winder_end, private.room_objname );
cmn.AddSubscriber( "get_winder", private.get_winder_logic );
--------------------------------------------------------------------
function public.get_winder()
  cmn.SetEventDone( "get_winder" );
  cmn.CallEventHandler( "get_winder" );
  if common_impl.ZzCompleteCheck("get_winder") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_saplingshovel_zone_clk() --rm_secondfloor.use_saplingshovel_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_saplingshovel' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_statuette" );
  ld.AnimPlay( "anm_wallcabinet_anm_shovel", "idle_shovel1", func_end )
end;  


common_impl.hint[ "use_saplingshovel" ] = { type = "use", inv_obj = "inv_saplingshovel", use_place = "gfx_wallcabinet_saplingshovel_zone", room = "rm_secondfloor", zz = "zz_wallcabinet", zz_gate = "gzz_secondfloor_wallcabinet" };

private.use_saplingshovel_logic = function()
  ObjSet( "spr_wallcabinet_shovel", { visible = 1, input = 1, active = 1 } )

end;
private.use_saplingshovel_inv = function()
  common_impl.ProcessMultiUseAll("saplingshovel", "saplingshovel")
end;
private.use_saplingshovel_beg = function()
  ObjDelete( "gfx_wallcabinet_saplingshovel_zone" );
end;
private.use_saplingshovel_end = function()
  if common_impl.ZzCompleteCheck("use_saplingshovel") then ObjSet( common_impl.hint["use_saplingshovel"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_wallcabinet_anm_shovel");
  ObjDelete("spr_secondfloor_shovel");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_saplingshovel", private.use_saplingshovel_inv );
cmn.AddSubscriber( "use_saplingshovel", private.use_saplingshovel_beg, private.room_objname );
cmn.AddSubscriber( "use_saplingshovel", private.use_saplingshovel_end, private.room_objname );
cmn.AddSubscriber( "use_saplingshovel", private.use_saplingshovel_logic );
cmn.AddSubscriber( "use_saplingshovel_inv", private.use_saplingshovel_inv, private.room_objname );
cmn.AddSubscriber( "use_saplingshovel_beg", private.use_saplingshovel_beg, private.room_objname );
cmn.AddSubscriber( "use_saplingshovel_end", private.use_saplingshovel_end, private.room_objname );
cmn.AddSubscriber( "use_saplingshovel_end", private.use_saplingshovel_logic );
--------------------------------------------------------------------------------------------
function public.use_saplingshovel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_saplingshovel" );
    cmn.CallEventHandler( "use_saplingshovel_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_saplingshovel") then ld.CloseSubRoom() end;
    public.get_shovel();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_saplingshovel_inv" );
  cmn.CallEventHandler( "use_saplingshovel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wallcabinet_anm_shovel", "use_shovel", func_end )
  SoundSfx( "aud_use_saplingshovel_secondfloor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_shovel" ] = { type = "get", get_obj = "spr_wallcabinet_shovel", room = "rm_secondfloor", zz = "zz_wallcabinet", zz_gate = "gzz_secondfloor_wallcabinet" };

private.get_shovel_logic = function()
  
end;
private.get_shovel_inv = function()
  interface.InventoryItemAdd("inv_shovel","spr_wallcabinet_shovel");
end;
private.get_shovel_beg = function()
  ObjDelete("gfx_wallcabinet_shovel")
end;
private.get_shovel_end = function()
  if common_impl.ZzCompleteCheck("get_shovel") then ObjSet( common_impl.hint["get_shovel"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_shovel", private.get_shovel_inv );
cmn.AddSubscriber( "get_shovel", private.get_shovel_beg, private.room_objname );
cmn.AddSubscriber( "get_shovel", private.get_shovel_end, private.room_objname );
cmn.AddSubscriber( "get_shovel", private.get_shovel_logic );
--------------------------------------------------------------------
function public.get_shovel()
  cmn.SetEventDone( "get_shovel" );
  cmn.CallEventHandler( "get_shovel" );
  if common_impl.ZzCompleteCheck("get_shovel") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mechanismpart1" ] = { type = "use", inv_obj = "inv_mechanismpart1", use_place = "gfx_wallcabinet_mechanismpart1_zone", room = "rm_secondfloor", zz = "zz_wallcabinet", zz_gate = "gzz_secondfloor_wallcabinet" };

private.use_mechanismpart1_logic = function()
  if ld.CheckRequirements( {"use_mechanismpart1","use_mechanismpart2"} ) then
  ObjSet( "gmg_secondfloor_incabinetmg", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_mechanismpart1_inv = function()
  common_impl.ProcessMultiUseAll("mechanismpart1", "mechanismpart1")
end;
private.use_mechanismpart1_beg = function()
  ObjDelete( "gfx_wallcabinet_mechanismpart1_zone" );
end;
private.use_mechanismpart1_end = function()
  if common_impl.ZzCompleteCheck("use_mechanismpart1") then ObjSet( common_impl.hint["use_mechanismpart1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_wallcabinet_anm_mechanismpart1", {animfunc = "use_mechanismpart1", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mechanismpart1", private.use_mechanismpart1_inv );
cmn.AddSubscriber( "use_mechanismpart1", private.use_mechanismpart1_beg, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart1", private.use_mechanismpart1_end, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart1", private.use_mechanismpart1_logic );
cmn.AddSubscriber( "use_mechanismpart1_inv", private.use_mechanismpart1_inv, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart1_beg", private.use_mechanismpart1_beg, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart1_end", private.use_mechanismpart1_end, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart1_end", private.use_mechanismpart1_logic );
--------------------------------------------------------------------------------------------
function public.use_mechanismpart1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mechanismpart1" );
    cmn.CallEventHandler( "use_mechanismpart1_end" );
    
    if ld.CheckRequirements( {"use_mechanismpart1","use_mechanismpart2"} ) then
       ld.CloseSubRoom();
       ld.StartTimer( 0.3, function() common_impl.Lock(0); cmn.GotoRoom("mg_incabinetmg");  end )
    else  
       common_impl.Lock(0);
       if common_impl.ZzCompleteCheck("use_mechanismpart1") then ld.CloseSubRoom() end;
    end;  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mechanismpart1_inv" );
  cmn.CallEventHandler( "use_mechanismpart1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wallcabinet_anm_mechanismpart1", "use_mechanismpart1", func_end );
  SoundSfx( "aud_use_mechanismpart1_secondfloor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mechanismpart2" ] = { type = "use", inv_obj = "inv_mechanismpart2", use_place = "gfx_wallcabinet_mechanismpart2_zone", room = "rm_secondfloor", zz = "zz_wallcabinet", zz_gate = "gzz_secondfloor_wallcabinet" };

private.use_mechanismpart2_logic = function()
  if ld.CheckRequirements( {"use_mechanismpart2","use_mechanismpart1"} ) then
  ObjSet( "gmg_secondfloor_incabinetmg", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_mechanismpart2_inv = function()
  common_impl.ProcessMultiUseAll("mechanismpart2", "mechanismpart2")
end;
private.use_mechanismpart2_beg = function()
  ObjDelete( "gfx_wallcabinet_mechanismpart2_zone" );
end;
private.use_mechanismpart2_end = function()
  if common_impl.ZzCompleteCheck("use_mechanismpart2") then ObjSet( common_impl.hint["use_mechanismpart2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_wallcabinet_anm_mechanismpart2", {animfunc = "use_mechanismpart2", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mechanismpart2", private.use_mechanismpart2_inv );
cmn.AddSubscriber( "use_mechanismpart2", private.use_mechanismpart2_beg, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart2", private.use_mechanismpart2_end, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart2", private.use_mechanismpart2_logic );
cmn.AddSubscriber( "use_mechanismpart2_inv", private.use_mechanismpart2_inv, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart2_beg", private.use_mechanismpart2_beg, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart2_end", private.use_mechanismpart2_end, private.room_objname );
cmn.AddSubscriber( "use_mechanismpart2_end", private.use_mechanismpart2_logic );
--------------------------------------------------------------------------------------------
function public.use_mechanismpart2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mechanismpart2" );
    cmn.CallEventHandler( "use_mechanismpart2_end" );
    common_impl.Lock(0);
     
    if ld.CheckRequirements( {"use_mechanismpart1","use_mechanismpart2"} ) then
       ld.CloseSubRoom();
       ld.StartTimer( 0.3, function() common_impl.Lock(0); cmn.GotoRoom("mg_incabinetmg");  end )
    else  
       common_impl.Lock(0);
       if common_impl.ZzCompleteCheck("use_mechanismpart2") then ld.CloseSubRoom() end;
    end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mechanismpart2_inv" );
  cmn.CallEventHandler( "use_mechanismpart2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wallcabinet_anm_mechanismpart2", "use_mechanismpart2", func_end );
  SoundSfx( "aud_use_mechanismpart2_secondfloor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_kidscorner *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_winder_zone_clk()  --rm_secondfloor.use_winder_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_winder' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_very_small_metal" );
  ld.AnimPlay( "anm_kidscorner_anm_box", "idle_winder1", func_end )
end;  


common_impl.hint[ "use_winder" ] = { type = "use", inv_obj = "inv_winder", use_place = "gfx_kidscorner_winder_zone", room = "rm_secondfloor", zz = "zz_kidscorner", zz_gate = "gzz_secondfloor_kidscorner" };

private.use_winder_logic = function()
  --  ObjSet( "spr_kidscorner_cuckoo", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gfx_kidscorner_clk_winder_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_winder_inv = function()
  common_impl.ProcessMultiUseAll("winder", "winder")
end;
private.use_winder_beg = function()
  ObjDelete( "gfx_kidscorner_winder_zone" );
end;
private.use_winder_end = function()
  if common_impl.ZzCompleteCheck("use_winder") then ObjSet( common_impl.hint["use_winder"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_kidscorner_anm_box", {animfunc = "click_winder", frame = 0 } );
  ObjSet( "spr_secondfloor_key", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_winder", private.use_winder_inv );
cmn.AddSubscriber( "use_winder", private.use_winder_beg, private.room_objname );
cmn.AddSubscriber( "use_winder", private.use_winder_end, private.room_objname );
cmn.AddSubscriber( "use_winder", private.use_winder_logic );
cmn.AddSubscriber( "use_winder_inv", private.use_winder_inv, private.room_objname );
cmn.AddSubscriber( "use_winder_beg", private.use_winder_beg, private.room_objname );
cmn.AddSubscriber( "use_winder_end", private.use_winder_end, private.room_objname );
cmn.AddSubscriber( "use_winder_end", private.use_winder_logic );
--------------------------------------------------------------------------------------------
function public.use_winder( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_winder" );
    cmn.CallEventHandler( "use_winder_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_winder") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_winder_inv" );
  cmn.CallEventHandler( "use_winder_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_kidscorner_anm_box", "use_winder", func_end )
  SoundSfx( "aud_use_winder_secondfloor" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_winder" ] = { type = "click", use_place = "gfx_kidscorner_clk_winder_zone", room = "rm_secondfloor", zz = "zz_kidscorner", zz_gate = "gzz_secondfloor_kidscorner" };

private.clk_winder_logic = function()
  ObjSet( "spr_kidscorner_cuckoo", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_kidscorner_cuckoo", { active = 1, visible = 1} );
end;
private.clk_winder_beg = function()
  ObjDelete( "gfx_kidscorner_clk_winder_zone" );
end;
private.clk_winder_end = function()
  if common_impl.ZzCompleteCheck("clk_winder") then ObjSet( common_impl.hint["clk_winder"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_kidscorner_anm_box", {animfunc = "click_winder", frame = 999 } );
  ObjSet( "spr_secondfloor_open_cap", {visible = 1} );
  ObjSet( "spr_secondfloor_cuckoo", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_winder", private.clk_winder_beg, private.room_objname );
cmn.AddSubscriber( "clk_winder", private.clk_winder_end, private.room_objname );
cmn.AddSubscriber( "clk_winder", private.clk_winder_logic );
cmn.AddSubscriber( "clk_winder_beg", private.clk_winder_beg, private.room_objname );
cmn.AddSubscriber( "clk_winder_end", private.clk_winder_end, private.room_objname );
cmn.AddSubscriber( "clk_winder_end", private.clk_winder_logic );
--------------------------------------------------------------------------------------------
function public.clk_winder()

  local func_end = function()
    cmn.SetEventDone( "clk_winder" );
    cmn.CallEventHandler( "clk_winder_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_winder") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_winder_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_kidscorner_anm_box", "click_winder", func_end );
  SoundSfx( "aud_get_key_secondfloor" )
  --func_end()

end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cuckoo" ] = { type = "get", get_obj = "spr_kidscorner_cuckoo", room = "rm_secondfloor", zz = "zz_kidscorner", zz_gate = "gzz_secondfloor_kidscorner" };

private.get_cuckoo_logic = function()
  
end;
private.get_cuckoo_inv = function()
  interface.InventoryItemAdd("inv_cuckoo","spr_kidscorner_cuckoo");
  ObjSet( "inv_cuckoo", { drag = 0 } );
end;
private.get_cuckoo_beg = function()
  ObjDelete("gfx_kidscorner_cuckoo")
end;
private.get_cuckoo_end = function()
  if common_impl.ZzCompleteCheck("get_cuckoo") then ObjSet( common_impl.hint["get_cuckoo"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_kidscorner_anm_box", {animfunc = "end_winder1", frame = 0 } );
  ObjDelete("spr_secondfloor_cuckoo");
end;

cmn.AddSubscriber( "get_cuckoo", private.get_cuckoo_inv );
cmn.AddSubscriber( "get_cuckoo", private.get_cuckoo_beg, private.room_objname );
cmn.AddSubscriber( "get_cuckoo", private.get_cuckoo_end, private.room_objname );
cmn.AddSubscriber( "get_cuckoo", private.get_cuckoo_logic );
--------------------------------------------------------------------
function public.get_cuckoo()
  ObjSet( "spr_kidscorner_cuckoo", {visible = 1} );
  cmn.SetEventDone( "get_cuckoo" );
  cmn.CallEventHandler( "get_cuckoo" );
  if common_impl.ZzCompleteCheck("get_cuckoo") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_secateurs_zone_clk()  --rm_secondfloor.use_secateurs_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_secateurs' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_clothes" )
  ld.AnimPlay( "anm_kidscorner_anm_toy", "idle_scissors1", func_end )
end;  


common_impl.hint[ "use_secateurs" ] = { type = "use", inv_obj = "inv_secateurs", use_place = "gfx_kidscorner_secateurs_zone", room = "rm_secondfloor", zz = "zz_kidscorner", zz_gate = "gzz_secondfloor_kidscorner" };

private.use_secateurs_logic = function()
  ObjSet( "spr_kidscorner_moon", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_kidscorner_moon", {active = 1, visible = 1} );
end;
private.use_secateurs_inv = function()
  common_impl.ProcessMultiUseAll("secateurs", "secateurs")
end;
private.use_secateurs_beg = function()
  ObjDelete( "gfx_kidscorner_secateurs_zone" );
end;
private.use_secateurs_end = function()
  if common_impl.ZzCompleteCheck("use_secateurs") then ObjSet( common_impl.hint["use_secateurs"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_kidscorner_anm_toy", {animfunc = "use_scissors", frame = 999 } );
  ObjSet( "spr_secondfloor_tr_rabbit", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_secateurs", private.use_secateurs_inv );
cmn.AddSubscriber( "use_secateurs", private.use_secateurs_beg, private.room_objname );
cmn.AddSubscriber( "use_secateurs", private.use_secateurs_end, private.room_objname );
cmn.AddSubscriber( "use_secateurs", private.use_secateurs_logic );
cmn.AddSubscriber( "use_secateurs_inv", private.use_secateurs_inv, private.room_objname );
cmn.AddSubscriber( "use_secateurs_beg", private.use_secateurs_beg, private.room_objname );
cmn.AddSubscriber( "use_secateurs_end", private.use_secateurs_end, private.room_objname );
cmn.AddSubscriber( "use_secateurs_end", private.use_secateurs_logic );
--------------------------------------------------------------------------------------------
function public.use_secateurs( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_secateurs" );
    cmn.CallEventHandler( "use_secateurs_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_secateurs") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_secateurs_inv" );
  cmn.CallEventHandler( "use_secateurs_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_kidscorner_anm_toy", "use_scissors", func_end )
  SoundSfx( "aud_use_secateurs_secondfloor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_moon" ] = { type = "get", get_obj = "spr_kidscorner_moon", room = "rm_secondfloor", zz = "zz_kidscorner", zz_gate = "gzz_secondfloor_kidscorner" };

private.get_moon_logic = function()
  
end;
private.get_moon_inv = function()
  interface.InventoryItemAdd("inv_moon","spr_kidscorner_moon");
end;
private.get_moon_beg = function()
  ObjDelete("gfx_kidscorner_moon")
end;
private.get_moon_end = function()
  if common_impl.ZzCompleteCheck("get_moon") then ObjSet( common_impl.hint["get_moon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_kidscorner_anm_toy", {animfunc = "end_scissors1", frame = 0 } );
end;

cmn.AddSubscriber( "get_moon", private.get_moon_inv );
cmn.AddSubscriber( "get_moon", private.get_moon_beg, private.room_objname );
cmn.AddSubscriber( "get_moon", private.get_moon_end, private.room_objname );
cmn.AddSubscriber( "get_moon", private.get_moon_logic );
--------------------------------------------------------------------
function public.get_moon()
  ObjSet( "spr_kidscorner_moon", {visible = 1} );
  cmn.SetEventDone( "get_moon" );
  cmn.CallEventHandler( "get_moon" );
  if common_impl.ZzCompleteCheck("get_moon") then ld.CloseSubRoom() end;
  if port.isPortable()==1 then
    iOS_RateMe();
  end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_suitcase *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_pawcuckoo_zone_clk()  --rm_secondfloor.use_pawcuckoo_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_pawcuckoo' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_clothes" );
  ld.AnimPlay( "anm_suitcase_anm_pawcucko", "idle_pawcuckoo2", func_end )
end;  


common_impl.hint[ "use_pawcuckoo" ] = { type = "use", inv_obj = "inv_pawcuckoo", use_place = "gfx_suitcase_pawcuckoo_zone", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };

private.use_pawcuckoo_logic = function()
  ObjSet( "spr_suitcase_spanner", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_suitcase_ingredientr", { visible = 1, input = 1, active = 1 } )

end;
private.use_pawcuckoo_inv = function()
  common_impl.ProcessMultiUseAll("pawcuckoo", "pawcuckoo")
end;
private.use_pawcuckoo_beg = function()
  ObjDelete( "gfx_suitcase_pawcuckoo_zone" );
end;
private.use_pawcuckoo_end = function()
  if common_impl.ZzCompleteCheck("use_pawcuckoo") then ObjSet( common_impl.hint["use_pawcuckoo"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_suitcase_tr_suitcasecover", {visible = 1} );
  ObjSet( "spr_suitcase_sh_ingredientr", {visible = 1} );
  ObjSet( "anm_suitcase_anm_pawcucko", {animfunc = "end_pawcuckoo1", frame = 0 } );
  ObjSet( "spr_suitcase_sh_spanner", {visible = 1} );
  ObjSet( "spr_secondfloor_suitcasecover_open", {visible = 1} );
  ObjSet( "spr_secondfloor_spanner", {visible = 1} );
  ObjSet( "spr_secondfloor_ingredientr", {visible = 1} );
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pawcuckoo", private.use_pawcuckoo_inv );
cmn.AddSubscriber( "use_pawcuckoo", private.use_pawcuckoo_beg, private.room_objname );
cmn.AddSubscriber( "use_pawcuckoo", private.use_pawcuckoo_end, private.room_objname );
cmn.AddSubscriber( "use_pawcuckoo", private.use_pawcuckoo_logic );
cmn.AddSubscriber( "use_pawcuckoo_inv", private.use_pawcuckoo_inv, private.room_objname );
cmn.AddSubscriber( "use_pawcuckoo_beg", private.use_pawcuckoo_beg, private.room_objname );
cmn.AddSubscriber( "use_pawcuckoo_end", private.use_pawcuckoo_end, private.room_objname );
cmn.AddSubscriber( "use_pawcuckoo_end", private.use_pawcuckoo_logic );
--------------------------------------------------------------------------------------------
function public.use_pawcuckoo( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pawcuckoo" );
    cmn.CallEventHandler( "use_pawcuckoo_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pawcuckoo") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pawcuckoo_inv" );
  cmn.CallEventHandler( "use_pawcuckoo_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_suitcase_anm_pawcucko", "use_pawcuckoo", func_end );
  SoundSfx( "aud_use_pawcuckoo_secondfloor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_spanner" ] = { type = "get", get_obj = "spr_suitcase_spanner", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };

private.get_spanner_logic = function()
  
end;
private.get_spanner_inv = function()
  interface.InventoryItemAdd("inv_spanner","spr_suitcase_spanner");
end;
private.get_spanner_beg = function()
  ObjDelete("gfx_suitcase_spanner")
end;
private.get_spanner_end = function()
  if common_impl.ZzCompleteCheck("get_spanner") then ObjSet( common_impl.hint["get_spanner"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"get_ingredientr","get_spanner"} ) then
    ObjDelete("spr_suitcase_tr_suitcasecover");
    ObjDelete("anm_suitcase_anm_pawcucko");
    ObjSet( "anm_suitcase_anm_moon", {animfunc = "idle_moon1", frame = 0 } );
  end;  
  ObjDelete("spr_suitcase_sh_spanner");
  ObjDelete("spr_secondfloor_spanner");
end;

cmn.AddSubscriber( "get_spanner", private.get_spanner_inv );
cmn.AddSubscriber( "get_spanner", private.get_spanner_beg, private.room_objname );
cmn.AddSubscriber( "get_spanner", private.get_spanner_end, private.room_objname );
cmn.AddSubscriber( "get_spanner", private.get_spanner_logic );
--------------------------------------------------------------------
function public.get_spanner()
  cmn.SetEventDone( "get_spanner" );
  cmn.CallEventHandler( "get_spanner" );
  if common_impl.ZzCompleteCheck("get_spanner") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ingredientr" ] = { type = "get", get_obj = "spr_suitcase_ingredientr", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };

private.get_ingredientr_logic = function()
  
end;
private.get_ingredientr_inv = function()
  interface.InventoryItemAdd("inv_ingredientr","spr_suitcase_ingredientr");
end;
private.get_ingredientr_beg = function()
  ObjDelete("gfx_suitcase_ingredientr")
end;
private.get_ingredientr_end = function()
  if common_impl.ZzCompleteCheck("get_ingredientr") then ObjSet( common_impl.hint["get_ingredientr"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_suitcase_sh_ingredientr");
  if ld.CheckRequirements( {"get_ingredientr","get_spanner"} ) then
    ObjDelete("spr_suitcase_tr_suitcasecover");
    ObjDelete("anm_suitcase_anm_pawcucko");
    ObjSet( "anm_suitcase_anm_moon", {animfunc = "idle_moon1", frame = 0 } );
  end;  
  ObjDelete("spr_secondfloor_ingredientr")
end;

cmn.AddSubscriber( "get_ingredientr", private.get_ingredientr_inv );
cmn.AddSubscriber( "get_ingredientr", private.get_ingredientr_beg, private.room_objname );
cmn.AddSubscriber( "get_ingredientr", private.get_ingredientr_end, private.room_objname );
cmn.AddSubscriber( "get_ingredientr", private.get_ingredientr_logic );
--------------------------------------------------------------------
function public.get_ingredientr()
  cmn.SetEventDone( "get_ingredientr" );
  cmn.CallEventHandler( "get_ingredientr" );
  if common_impl.ZzCompleteCheck("get_ingredientr") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_moon_zone_clk() --rm_secondfloor.use_moon_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_moon' );
  end
  
  if ld.CheckRequirements( {"get_ingredientr","get_spanner"} ) then 
    ld.AnimPlay( "anm_suitcase_anm_moon", "idle_moon1", func_end )
  else 
    func_end();
  end;  
end;  


common_impl.hint[ "use_moon" ] = { type = "use", inv_obj = "inv_moon", use_place = "gfx_suitcase_moon_zone", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };

private.use_moon_logic = function()
  -- ObjSet( "spr_suitcase_mechanismpart2", { visible = 1, input = 1, active = 1 } )
  -- ObjSet( "gfx_suitcase_clk_suitcase1_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "gfx_suitcase_clk_suitcase2_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "spr_suitcase_mechanismpart2", {active=1, input=0, visible = 1} );
end;
private.use_moon_inv = function()
  common_impl.ProcessMultiUseAll("moon", "moon")
end;
private.use_moon_beg = function()
  ObjDelete( "gfx_suitcase_moon_zone" );
end;
private.use_moon_end = function()
  if common_impl.ZzCompleteCheck("use_moon") then ObjSet( common_impl.hint["use_moon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_suitcase_anm_moon", {animfunc = "use_moon", frame = 0 } );
  for i=1,3,1 do 
    ObjSet( "anm_suitcase_anm_click"..i, {active = 1, visible = 1} );
  end;  
  ObjDelete("anm_suitcase_anm_moon");
  ObjSet( "spr_suitcase_sh_mechanismpart2", {visible = 1} );
  ObjSet( "spr_secondfloor_moon", {visible = 1} );
  ObjDelete("spr_secondfloor_suitcasecover_open");
  ObjSet( "spr_secondfloor_open_suitcase", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_moon", private.use_moon_inv );
cmn.AddSubscriber( "use_moon", private.use_moon_beg, private.room_objname );
cmn.AddSubscriber( "use_moon", private.use_moon_end, private.room_objname );
cmn.AddSubscriber( "use_moon", private.use_moon_logic );
cmn.AddSubscriber( "use_moon_inv", private.use_moon_inv, private.room_objname );
cmn.AddSubscriber( "use_moon_beg", private.use_moon_beg, private.room_objname );
cmn.AddSubscriber( "use_moon_end", private.use_moon_end, private.room_objname );
cmn.AddSubscriber( "use_moon_end", private.use_moon_logic );
--------------------------------------------------------------------------------------------
function public.use_moon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_moon" );
    cmn.CallEventHandler( "use_moon_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_moon") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_moon_inv" );
  cmn.CallEventHandler( "use_moon_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_suitcase_anm_moon", "use_moon", func_end );
  SoundSfx( "aud_use_moon_secondfloor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_suitcase1" ] = { type = "click", use_place = "gfx_suitcase_clk_suitcase1_zone", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };
--
--private.clk_suitcase1_logic = function()
--  if ld.CheckRequirements( {"clk_suitcase1","clk_suitcase3"} ) then
--    ObjSet( "spr_suitcase_mechanismpart2", { visible = 1, input = 1, active = 1 } )
--    ObjSet( "gfx_suitcase_mechanismpart2", { active = 1, visible = 1} );
--  end;  
--  --ObjSet( "gfx_suitcase_clk_suitcase2_zone", {active = 1, input = 1, visible = 1} );  
--end;
--private.clk_suitcase1_beg = function()
--  ObjDelete( "gfx_suitcase_clk_suitcase1_zone" );
--end;
--private.clk_suitcase1_end = function()
--  if common_impl.ZzCompleteCheck("clk_suitcase1") then ObjSet( common_impl.hint["clk_suitcase1"].zz_gate, { visible = 0, input = 0 } ); end;
--  ObjSet( "anm_suitcase_anm_click1", {animfunc = "click_moon1", frame = 999 } );
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_suitcase1", private.clk_suitcase1_beg, private.room_objname );
--cmn.AddSubscriber( "clk_suitcase1", private.clk_suitcase1_end, private.room_objname );
--cmn.AddSubscriber( "clk_suitcase1", private.clk_suitcase1_logic );
--cmn.AddSubscriber( "clk_suitcase1_beg", private.clk_suitcase1_beg, private.room_objname );
--cmn.AddSubscriber( "clk_suitcase1_end", private.clk_suitcase1_end, private.room_objname );
--cmn.AddSubscriber( "clk_suitcase1_end", private.clk_suitcase1_logic );
----------------------------------------------------------------------------------------------
--function public.clk_suitcase1()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_suitcase1" );
--    cmn.CallEventHandler( "clk_suitcase1_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_suitcase1") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_suitcase1_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_suitcase_anm_click1", "click_moon1", func_end );
--  SoundSfx( "aud_clk_suitcase1" )
--  --func_end()
--
--end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_suitcase2" ] = { type = "click", use_place = "gfx_suitcase_clk_suitcase2_zone", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };

private.clk_suitcase2_logic = function()
  ObjSet( "gfx_suitcase_clk_suitcase3_zone", {active = 1, input = 1, visible = 1} );  
  ObjSet( "anm_suitcase_anm_click2", {animfunc = "click_moon2", frame = 999 } );
end;
private.clk_suitcase2_beg = function()
  ObjDelete( "gfx_suitcase_clk_suitcase2_zone" );
end;
private.clk_suitcase2_end = function()
  if common_impl.ZzCompleteCheck("clk_suitcase2") then ObjSet( common_impl.hint["clk_suitcase2"].zz_gate, { visible = 0, input = 0 } ); end;
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_suitcase2", private.clk_suitcase2_beg, private.room_objname );
cmn.AddSubscriber( "clk_suitcase2", private.clk_suitcase2_end, private.room_objname );
cmn.AddSubscriber( "clk_suitcase2", private.clk_suitcase2_logic );
cmn.AddSubscriber( "clk_suitcase2_beg", private.clk_suitcase2_beg, private.room_objname );
cmn.AddSubscriber( "clk_suitcase2_end", private.clk_suitcase2_end, private.room_objname );
cmn.AddSubscriber( "clk_suitcase2_end", private.clk_suitcase2_logic );
--------------------------------------------------------------------------------------------
function public.clk_suitcase2()

  local func_end = function()
    cmn.SetEventDone( "clk_suitcase2" );
    cmn.CallEventHandler( "clk_suitcase2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_suitcase2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_suitcase2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_suitcase_anm_click2", "click_moon2", func_end );
  SoundSfx( "aud_touch_clothes_secondfloor" )
  --func_end()

end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_suitcase3" ] = { type = "click", use_place = "gfx_suitcase_clk_suitcase3_zone", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };

private.clk_suitcase3_logic = function()
  if ld.CheckRequirements( {"clk_suitcase2","clk_suitcase3"} ) then
    ObjSet( "spr_suitcase_mechanismpart2", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gfx_suitcase_mechanismpart2", { active = 1, visible = 1} );
  end; 
end;
private.clk_suitcase3_beg = function()
  ObjDelete( "gfx_suitcase_clk_suitcase3_zone" );
end;
private.clk_suitcase3_end = function()
  if common_impl.ZzCompleteCheck("clk_suitcase3") then ObjSet( common_impl.hint["clk_suitcase3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_suitcase_anm_click3", {animfunc = "click_moon3", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_suitcase3", private.clk_suitcase3_beg, private.room_objname );
cmn.AddSubscriber( "clk_suitcase3", private.clk_suitcase3_end, private.room_objname );
cmn.AddSubscriber( "clk_suitcase3", private.clk_suitcase3_logic );
cmn.AddSubscriber( "clk_suitcase3_beg", private.clk_suitcase3_beg, private.room_objname );
cmn.AddSubscriber( "clk_suitcase3_end", private.clk_suitcase3_end, private.room_objname );
cmn.AddSubscriber( "clk_suitcase3_end", private.clk_suitcase3_logic );
--------------------------------------------------------------------------------------------
function public.clk_suitcase3()

  local func_end = function()
    cmn.SetEventDone( "clk_suitcase3" );
    cmn.CallEventHandler( "clk_suitcase3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_suitcase3") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_suitcase3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_suitcase_anm_click3", "click_moon3", func_end );
  SoundSfx( "aud_touch_clothes_secondfloor" )
  --func_end()

end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mechanismpart2" ] = { type = "get", get_obj = "spr_suitcase_mechanismpart2", room = "rm_secondfloor", zz = "zz_suitcase", zz_gate = "gzz_secondfloor_suitcase" };

private.get_mechanismpart2_logic = function()
  
end;
private.get_mechanismpart2_inv = function()
  interface.InventoryItemAdd("inv_mechanismpart2","spr_suitcase_mechanismpart2");
end;
private.get_mechanismpart2_beg = function()
  ObjDelete("gfx_suitcase_mechanismpart2")
end;
private.get_mechanismpart2_end = function()
  if common_impl.ZzCompleteCheck("get_mechanismpart2") then ObjSet( common_impl.hint["get_mechanismpart2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_suitcase_sh_mechanismpart2");
end;

cmn.AddSubscriber( "get_mechanismpart2", private.get_mechanismpart2_inv );
cmn.AddSubscriber( "get_mechanismpart2", private.get_mechanismpart2_beg, private.room_objname );
cmn.AddSubscriber( "get_mechanismpart2", private.get_mechanismpart2_end, private.room_objname );
cmn.AddSubscriber( "get_mechanismpart2", private.get_mechanismpart2_logic );
--------------------------------------------------------------------
function public.get_mechanismpart2()
  cmn.SetEventDone( "get_mechanismpart2" );
  cmn.CallEventHandler( "get_mechanismpart2" );
  if common_impl.ZzCompleteCheck("get_mechanismpart2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_incabinetmg_forsecondfloor = function()
    if ld.CheckRequirements( {"win_incabinetmg"} ) then
      ObjSet( "spr_secondfloor_open_box", {visible = 1} );
      ObjSet( "spr_secondfloor_ingredientt", {visible = 1} );
    end
  end;
  
  cmn.AddSubscriber("win_incabinetmg", win_incabinetmg_forsecondfloor )


  local get_ingredientt_for_secondfloor = function()
    if ld.CheckRequirements( {"get_ingredientt"} ) then
      ObjSet( "gmg_secondfloor_incabinetmg", {input = 0, visible = 0} );
      ObjDelete("spr_secondfloor_ingredientt");
    end
  end;
  cmn.AddSubscriber("get_ingredientt", get_ingredientt_for_secondfloor, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_secondfloor();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_secondfloor_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_suitcase" );
  function zz_suitcase.Open()
  end;
  function zz_suitcase.PreOpen()
  end;
  function zz_suitcase.PreClose()
  end;
  function zz_suitcase.Close()
  end;

  subroom.Define( "zz_kidscorner" );
  function zz_kidscorner.Open()
  end;
  function zz_kidscorner.PreOpen()
  end;
  function zz_kidscorner.PreClose()
  end;
  function zz_kidscorner.Close()
  end;

  subroom.Define( "zz_wallcabinet" );
  function zz_wallcabinet.Open()
  end;
  function zz_wallcabinet.PreOpen()
  end;
  function zz_wallcabinet.PreClose()
  end;
  function zz_wallcabinet.Close()
  end;
  
end;
--*********************************************************************************************************************
------------------------- other funcs()

function public.kidscorner_leg_zone_clk() --rm_secondfloor.kidscorner_leg_zone_clk()
  local func_end = function()
     ObjSet( "obj_kidscorner_leg_clk_zone", {input = 1} );
  end
  
  ObjSet( "obj_kidscorner_leg_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_kidscorner_anm_leg", "click_leg_rabbit", func_end )
  SoundSfx( "aud_touch_clothes" );
end;  