-- name=rm_square
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_square";
  --------------------------------------------------------------------------------------------
  private.InitZz()
  ld.NoteInit("spr_tradeshop_newspaper1", "spr_tradeshop_newspaper","tradeshop_newspaper")
  ld.NoteInit("spr_tohome_paper", "spr_tohome_paper_big")
  ld.NoteInit("obj_understage_little_text_root", "spr_understage_text","understage_text")
  --ld.NoteInit("spr_mailbox_note_small", "spr_mailbox_note_big", "txt_mailbox_note")

  
--------------------------------------------------------------------------------------------
function private.opn_square()

  if not ( cmn.IsEventDone( "opn_square" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_square" );
      cmn.CallEventHandler( "opn_square" )
      ld.ShowBbtOpn( private.room_objname )
  end;
    func_end();
  end;

  if not cmn.IsEventDone("clk_anmfly") then 
     public.clk_anmfly();
  end;  

end;


local opn_square = function()
   
end;
local opn_square_logic = function() 
  --interface.SetTask("leveltask_1")
end;
cmn.AddSubscriber( "opn_square", opn_square_logic )
cmn.AddSubscriber( "opn_square", opn_square, private.room_objname )

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmfly" ] = { type = "click", use_place = "gfx_square_clk_anmfly_zone", room = "rm_square" };

private.clk_anmfly_logic = function()
  ObjSet( "gzz_square_horse", {visible = 1, input = 1, active = 1} );
  ObjSet( "gzz_square_understage", {visible = 1, input = 1, active = 1} );
  ObjSet( "gzz_square_tradeshop", {visible = 1, input = 1, active = 1} );
  ObjSet( "gzz_square_tohome", {visible = 1, input = 1, active = 1} );  
end;
private.clk_anmfly_beg = function()
  ObjDelete( "gfx_square_clk_anmfly_zone" );
end;
private.clk_anmfly_end = function()
  ObjDelete("vid_square_vid_anmfly");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmfly", private.clk_anmfly_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmfly", private.clk_anmfly_end, private.room_objname );
cmn.AddSubscriber( "clk_anmfly", private.clk_anmfly_logic );
cmn.AddSubscriber( "clk_anmfly_beg", private.clk_anmfly_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmfly_end", private.clk_anmfly_end, private.room_objname );
cmn.AddSubscriber( "clk_anmfly_end", private.clk_anmfly_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmfly()
  
  local widget_settings = 
  {
    InterfaceWidget_Inventory,
    InterfaceWidget_BtnHint,
    InterfaceWidget_BtnGuide,
    InterfaceWidget_BtnMenu,
    InterfaceWidget_BtnMap,
  }

  local func_end = function()
    SoundEnv("aud_square_env");
    SoundEnv("aud_torch_square_loc_env",1)
    ld.ShowBbt("after_anmfly");
    ObjAnimate( "vid_square_vid_anmfly", 8, 0, 0, function()
    
      cmn.SetEventDone( "clk_anmfly" );
      cmn.CallEventHandler( "clk_anmfly_end" );
      common_impl.Lock(0);
      --  ld.ShowBbt("after_anmfly");
      level.tutorial_deploy.first()  
      SoundTheme( "aud_danger1_mus" );
      
      end, {0,0,1, 0.5,0,0} );
    
  end;

  cmn.CallEventHandler( "clk_anmfly_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  -- SoundSfx( "aud_clk_anmfly" )
  -- func_end()

  
  ------------------------------------------------
  
  local func_preend = function()
    ld.Lock(1)
    --  SoundVid( 0 );
    VidPause("vid_square_vid_anmfly",1)
    int.DialogVideoHide();
    for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 1, true );
    end; 
    --ObjAnimate( "vid_square_vid_anmfly", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
    
      --ld.StartTimer( 0.5, func_end )
    func_end();  
  end;  
  
  
  for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 0, false );
  end;
  
  --ObjAttach("vid_square_vid_anmfly","rm_square");
  
  SoundTheme( 0 )
  SoundEnv(0);
  SndPlay( "assets/levels/common/audio/aud_clk_anmfly_square", "sfx", 0, 0.5 );
  --SoundSfx( "aud_clk_anmfly_square" )
  VidPlay( "vid_square_vid_anmfly",function() func_preend(); ld.StartTimer( 3, function() SndStop( "assets/levels/common/audio/aud_clk_anmfly_square", 0.5 ) end ); end)
  int.DialogVideoShow( "", 1,function()  SndStop( "assets/levels/common/audio/aud_clk_anmfly_square", 0.5 ) func_preend(); end, 1 );
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outro2" ] = { type = "click", use_place = "gfx_square_clk_outro2_zone", room = "rm_square" };

private.clk_outro2_logic = function()
  ObjSet( "gfx_roadway_poisonspice_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_square_dlg_square_lady4_zone", { visible = 1, input = 1, active = 1 } )
  ObjDelete("obj_roadway_sleepwarder_clk_zone");
end;
private.clk_outro2_beg = function()
  ObjDelete( "gfx_square_clk_outro2_zone" );
end;
private.clk_outro2_end = function()
  ObjDelete("vid_square_vid_outro2")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outro2", private.clk_outro2_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro2", private.clk_outro2_end, private.room_objname );
cmn.AddSubscriber( "clk_outro2", private.clk_outro2_logic );
cmn.AddSubscriber( "clk_outro2_beg", private.clk_outro2_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro2_end", private.clk_outro2_end, private.room_objname );
cmn.AddSubscriber( "clk_outro2_end", private.clk_outro2_logic );
--------------------------------------------------------------------------------------------
function public.clk_outro2()
  
  local widget_settings = 
  {
    InterfaceWidget_Inventory,
    InterfaceWidget_BtnHint,
    InterfaceWidget_BtnGuide,
    InterfaceWidget_BtnMenu,
    InterfaceWidget_BtnMap,
  }

  local func_end = function()
    SoundEnv("aud_square_env");
    --ld.ShowBbt("after_outro2");
    -- cmn.GotoRoom("rm_outro");

    ObjAnimate( "vid_square_vid_outro2", 8, 0, 0, function()
    
      cmn.SetEventDone( "clk_outro2" );
      cmn.CallEventHandler( "clk_outro2_end" );
      common_impl.Lock(0);
         ld.ShowBbt("after_outro2");
      SoundTheme( "aud_danger_moment3_mus" );   
      
      end, {0,0,1, 0.5,0,0} );
    
  end;

  cmn.CallEventHandler( "clk_outro2_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  -- SoundSfx( "aud_clk_outro2_squeare" )
  -- func_end()

  
  ------------------------------------------------
  
  local func_preend = function()
    SoundVoice(0);
    ld.Lock(1)
    --  SoundVid( 0 );
    VidPause("vid_square_vid_outro2",1)
    int.DialogVideoHide();
    for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 1, true );
    end; 
    --ObjAnimate( "vid_square_vid_outro2", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
    
      --ld.StartTimer( 0.5, func_end )
    func_end();  
  end;  
  
  
  for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 0, false );
  end;
  
  --ObjAttach("vid_square_vid_outro2","rm_square");
  
  SoundTheme( 0 )
  SoundEnv(0);
  --SndPlay( "assets/levels/common/audio/aud_clk_outro2_square", "sfx", 0, 0.5 );
  SoundVid("aud_clk_outro2_square");
  SoundVoice("aud_clk_outro2_square_voc");
  VidPlay( "vid_square_vid_outro2",function() func_preend(); end)
  int.DialogVideoShow( "", 1,function() func_preend(); end, 1 );
  
end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "lady4" then
    if count_txt == 1 then
      ld.Lock(1);
      ld.StartTimer( 1, function() AnimPlay( "anm_square_lady4", "giv1", function() ld.Lock(0);  end);
         SoundSfx( "aud_get_to_us" );  end )  
    elseif count_txt == 2 then    
         ObjSet( "spr_square_lordkey", {active=1, visible = 1} );
       cmn.CallEventHandler( "get_lordkey" );
      --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" )  
      AnimPlay( "anm_square_lady4", "hand", function()   end);
    end; 
  end;
end;

--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_square_lady4" ] = { type = "click", use_place = "gfx_square_dlg_square_lady4_zone", room = "rm_square" };

private.dlg_square_lady4_logic = function()
  ObjSet( "spr_square_lordkey", { visible = 1, input = 1, active = 1 } )
  ObjSet("gzz_livingroom_cabinetlord",{ visible = 1, input = 1, active = 1 })
  ObjSet( "gfx_bedroomboy_poisonformula_zone", { visible = 1, input = 1, active = 1 } )   
  ObjDelete("obj_livingroom_cabinet_clk_zone")
end;
private.dlg_square_lady4_beg = function()
  ObjDelete( "gfx_square_dlg_square_lady4_zone" );
end;
private.dlg_square_lady4_end = function()
  ObjSet("anm_square_anm_lady_anm",{visible=0})
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_square_lady4", private.dlg_square_lady4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_square_lady4", private.dlg_square_lady4_end, private.room_objname );
cmn.AddSubscriber( "dlg_square_lady4", private.dlg_square_lady4_logic );
cmn.AddSubscriber( "dlg_square_lady4_beg", private.dlg_square_lady4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_square_lady4_end", private.dlg_square_lady4_end, private.room_objname );
cmn.AddSubscriber( "dlg_square_lady4_end", private.dlg_square_lady4_logic );
--------------------------------------------------------------------------------------------
function public.dlg_square_lady4( obj )

-- local func_end = function()
 --   cmn.SetEventDone( "dlg_square_lady5" );
 --   cmn.CallEventHandler( "dlg_square_lady5_end" );
 --   common_impl.Lock(0);
 -- end;

 -- cmn.CallEventHandler( "dlg_square_lady5_beg" );
 -- common_impl.Lock(1);

 -- --ld.AnimPlay( "", "", func_end );
 -- --SoundSfx( 0 )
 -- func_end()

  local func_end = function()
    cmn.SetEventDone( "dlg_square_lady4" );
    cmn.CallEventHandler( "dlg_square_lady4_end" );
    cmn.CallEventHandler( "dlg_square_lady4" );    
    cmn.SetEventDone( "get_lordkey" );
    if ObjGetRelations( "inv_lordkey" ).parent == "level_inv_hub" then
      ObjSet( "spr_square_lordkey", {visible = 1} );
      cmn.CallEventHandler( "get_lordkey" );
    end
    common_impl.Lock(0);
    
    ld.ShowBbt("after_dlg_lady4");
  end;
  
  function public.dlg_square_lady4_end()
    ObjSet( "dlg_square_lady4", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_square_lady4_beg" );
 
  -- ObjAnimate( "anim_square_anim_lady", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  common_impl.dialog_character_loc = "anm_square_anm_lady_anm"
  common_impl.continue_visible = false;
  common_impl.Start( "lady4", 2, nil, nil, true, "dlg_square_lady4_end",{"aud_lady_lankerman_6_voc"} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lordkey" ] = { type = "get", get_obj = "spr_square_lordkey", room = "rm_square" };

private.get_lordkey_logic = function()
  
end;
private.get_lordkey_inv = function()
  interface.InventoryItemAdd("inv_lordkey","spr_square_lordkey");
end;
private.get_lordkey_beg = function()
  ObjDelete("gfx_square_lordkey")
end;
private.get_lordkey_end = function()
  
end;

cmn.AddSubscriber( "get_lordkey", private.get_lordkey_inv );
cmn.AddSubscriber( "get_lordkey", private.get_lordkey_beg, private.room_objname );
cmn.AddSubscriber( "get_lordkey", private.get_lordkey_end, private.room_objname );
cmn.AddSubscriber( "get_lordkey", private.get_lordkey_logic );
--------------------------------------------------------------------
function public.get_lordkey()
  cmn.SetEventDone( "get_lordkey" );
  cmn.CallEventHandler( "get_lordkey" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_horse *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_carvedhandle" ] = { type = "get", get_obj = "spr_horse_carvedhandle", room = "rm_square", zz = "zz_horse", zz_gate = "gzz_square_horse" };

private.get_carvedhandle_logic = function()
  
end;
private.get_carvedhandle_inv = function()
  interface.InventoryItemAdd("inv_carvedhandle","spr_horse_carvedhandle");
end;
private.get_carvedhandle_beg = function()
  ObjDelete("gfx_horse_carvedhandle")
end;
private.get_carvedhandle_end = function()
  ObjDelete("spr_horse_sh_carvedhandle")
  if common_impl.ZzCompleteCheck("get_carvedhandle") then ObjSet( common_impl.hint["get_carvedhandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_carvedhandle", private.get_carvedhandle_inv );
cmn.AddSubscriber( "get_carvedhandle", private.get_carvedhandle_beg, private.room_objname );
cmn.AddSubscriber( "get_carvedhandle", private.get_carvedhandle_end, private.room_objname );
cmn.AddSubscriber( "get_carvedhandle", private.get_carvedhandle_logic );
--------------------------------------------------------------------
function public.get_carvedhandle()
  cmn.SetEventDone( "get_carvedhandle" );
  cmn.CallEventHandler( "get_carvedhandle" );
  if common_impl.ZzCompleteCheck("get_carvedhandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--common_impl.hint[ "use_goldhorseshoe1" ] = { type = "use", inv_obj = "inv_goldhorseshoe1", use_place = "gfx_horse_goldhorseshoe1_zone", room = "rm_square", zz = "zz_horse", zz_gate = "gzz_square_horse" };
--
--private.use_goldhorseshoe1_logic = function()
--  if ld.CheckRequirements( {"use_goldhorseshoe1","use_goldhorseshoe2"} ) then
--    ObjSet( "spr_horse_beetle", { visible = 1, input = 1, active = 1 } )
--  end;
--
--end;
--private.use_goldhorseshoe1_inv = function()
--  common_impl.ProcessMultiUseAll("goldhorseshoe1", "goldhorseshoe1")
--end;
--private.use_goldhorseshoe1_beg = function()
--  ObjDelete( "gfx_horse_goldhorseshoe1_zone" );
--end;
--private.use_goldhorseshoe1_end = function()
--  if ld.CheckRequirements( {"use_goldhorseshoe1","use_goldhorseshoe2"} ) then
--    ObjDelete("anm_horse_anm_horse_1")
--    ObjDelete("anm_horse_anm_horse_2")
--    ObjSet("anm_horse_anm_cover",{animfunc="end_cover",frame=0})
--    ObjSet( "spr_horse_sh_beetle", {alp = 1} );    
--    ObjSet( "spr_square_open_horse", {alp = 1} );
--    ObjSet( "spr_square_beetle", {visible = 1} ); 
--  else 
--    ObjSet("anm_horse_anm_horse_1",{animfunc="use_horse_1",frame=999})    
--  end  
--  if common_impl.ZzCompleteCheck("use_goldhorseshoe1") then ObjSet( common_impl.hint["use_goldhorseshoe1"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "use_goldhorseshoe1", private.use_goldhorseshoe1_inv );
--cmn.AddSubscriber( "use_goldhorseshoe1", private.use_goldhorseshoe1_beg, private.room_objname );
--cmn.AddSubscriber( "use_goldhorseshoe1", private.use_goldhorseshoe1_end, private.room_objname );
--cmn.AddSubscriber( "use_goldhorseshoe1", private.use_goldhorseshoe1_logic );
--cmn.AddSubscriber( "use_goldhorseshoe1_inv", private.use_goldhorseshoe1_inv, private.room_objname );
--cmn.AddSubscriber( "use_goldhorseshoe1_beg", private.use_goldhorseshoe1_beg, private.room_objname );
--cmn.AddSubscriber( "use_goldhorseshoe1_end", private.use_goldhorseshoe1_end, private.room_objname );
--cmn.AddSubscriber( "use_goldhorseshoe1_end", private.use_goldhorseshoe1_logic );
----------------------------------------------------------------------------------------------
--function public.use_goldhorseshoe1( obj )
--
--  local func_end = function()
--    ObjSet(obj,{visible = 1});
--    cmn.SetEventDone( "use_goldhorseshoe1" );
--    cmn.CallEventHandler( "use_goldhorseshoe1_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("use_goldhorseshoe1") then ld.CloseSubRoom() end;
--  end;
--  local f_step = function ()
--    if  cmn.IsEventDone("use_goldhorseshoe2") then
--      ObjDelete("anm_horse_anm_horse_1")
--      ObjDelete("anm_horse_anm_horse_2")      
--      ld.AnimPlay( "anm_horse_anm_cover", "open_cover", func_end );
--    else 
--      func_end()
--    end
--  end
--  ObjSet(obj,{visible = 0});
--  cmn.CallEventHandler( "use_goldhorseshoe1_inv" );
--  cmn.CallEventHandler( "use_goldhorseshoe1_beg" );
--  common_impl.Lock(1);
--
--  ld.AnimPlay( "anm_horse_anm_horse_1", "use_horse_1", f_step );
--  SoundSfx( "aud_use_goldhorseshoe1_square" )
--  --func_end()
--
--end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goldhorseshoe2" ] = { type = "use", inv_obj = "inv_goldhorseshoe2", use_place = "gfx_horse_goldhorseshoe2_zone", room = "rm_square", zz = "zz_horse", zz_gate = "gzz_square_horse" };

private.use_goldhorseshoe2_logic = function()
  if ld.CheckRequirements( {"use_goldhorseshoe2"} ) then
    ObjSet( "spr_horse_beetle", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_goldhorseshoe2_inv = function()
  common_impl.ProcessMultiUseAll("goldhorseshoe2", "goldhorseshoe2")
end;
private.use_goldhorseshoe2_beg = function()
  ObjDelete( "gfx_horse_goldhorseshoe2_zone" );
end;
private.use_goldhorseshoe2_end = function()
  if ld.CheckRequirements( {"use_goldhorseshoe2"} ) then
    ObjDelete("anm_horse_anm_horse_1")
    ObjDelete("anm_horse_anm_horse_2")
    ObjSet("anm_horse_anm_cover",{animfunc="end_cover",frame=0})
    ObjSet( "spr_horse_sh_beetle", {alp = 1} );
    ObjSet( "spr_square_open_horse", {alp = 1} );   
    ObjSet( "spr_square_beetle", {visible = 1} ); 
  else 
    ObjSet("anm_horse_anm_horse_1",{animfunc="use_horse_2",frame=999})
  end  
  if common_impl.ZzCompleteCheck("use_goldhorseshoe2") then ObjSet( common_impl.hint["use_goldhorseshoe2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldhorseshoe2", private.use_goldhorseshoe2_inv );
cmn.AddSubscriber( "use_goldhorseshoe2", private.use_goldhorseshoe2_beg, private.room_objname );
cmn.AddSubscriber( "use_goldhorseshoe2", private.use_goldhorseshoe2_end, private.room_objname );
cmn.AddSubscriber( "use_goldhorseshoe2", private.use_goldhorseshoe2_logic );
cmn.AddSubscriber( "use_goldhorseshoe2_inv", private.use_goldhorseshoe2_inv, private.room_objname );
cmn.AddSubscriber( "use_goldhorseshoe2_beg", private.use_goldhorseshoe2_beg, private.room_objname );
cmn.AddSubscriber( "use_goldhorseshoe2_end", private.use_goldhorseshoe2_end, private.room_objname );
cmn.AddSubscriber( "use_goldhorseshoe2_end", private.use_goldhorseshoe2_logic );
--------------------------------------------------------------------------------------------
function public.use_goldhorseshoe2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goldhorseshoe2" );
    cmn.CallEventHandler( "use_goldhorseshoe2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_goldhorseshoe2") then ld.CloseSubRoom() end;
  end;

  local f_step = function ()
      ObjDelete("anm_horse_anm_horse_1")
      ObjDelete("anm_horse_anm_horse_2")     
      ld.AnimPlay( "anm_horse_anm_cover", "open_cover", func_end );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldhorseshoe2_inv" );
  cmn.CallEventHandler( "use_goldhorseshoe2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_horse_anm_horse_2", "use_horse_2", f_step );
  SoundSfx( "aud_use_goldhorseshoe_square" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_beetle" ] = { type = "get", get_obj = "spr_horse_beetle", room = "rm_square", zz = "zz_horse", zz_gate = "gzz_square_horse" };

private.get_beetle_logic = function()
  
end;
private.get_beetle_inv = function()
  interface.InventoryItemAdd("inv_beetle","spr_horse_beetle");
end;
private.get_beetle_beg = function()
  ObjDelete("gfx_horse_beetle")
end;
private.get_beetle_end = function()
  ObjDelete("spr_horse_sh_beetle")
  if common_impl.ZzCompleteCheck("get_beetle") then ObjSet( common_impl.hint["get_beetle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_square_beetle");
end;

cmn.AddSubscriber( "get_beetle", private.get_beetle_inv );
cmn.AddSubscriber( "get_beetle", private.get_beetle_beg, private.room_objname );
cmn.AddSubscriber( "get_beetle", private.get_beetle_end, private.room_objname );
cmn.AddSubscriber( "get_beetle", private.get_beetle_logic );
--------------------------------------------------------------------
function public.get_beetle()
  cmn.SetEventDone( "get_beetle" );
  cmn.CallEventHandler( "get_beetle" );
  if common_impl.ZzCompleteCheck("get_beetle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bridle" ] = { type = "use", inv_obj = "inv_bridle", use_place = "gfx_horse_bridle_zone", room = "rm_square", zz = "zz_horse", zz_gate = "gzz_square_horse" };

private.use_bridle_logic = function()
  ObjSet( "spr_horse_coin", { visible = 1, input = 1, active = 1 } )

end;
private.use_bridle_inv = function()
  common_impl.ProcessMultiUseAll("bridle", "bridle")
end;
private.use_bridle_beg = function()
  ObjDelete( "gfx_horse_bridle_zone" );
end;
private.use_bridle_end = function()
  ObjSet("anm_horse_anm_bridle",{animfunc="end_bridle",frame=0})
  ObjSet( "spr_horse_sh_coin", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_bridle") then ObjSet( common_impl.hint["use_bridle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bridle", private.use_bridle_inv );
cmn.AddSubscriber( "use_bridle", private.use_bridle_beg, private.room_objname );
cmn.AddSubscriber( "use_bridle", private.use_bridle_end, private.room_objname );
cmn.AddSubscriber( "use_bridle", private.use_bridle_logic );
cmn.AddSubscriber( "use_bridle_inv", private.use_bridle_inv, private.room_objname );
cmn.AddSubscriber( "use_bridle_beg", private.use_bridle_beg, private.room_objname );
cmn.AddSubscriber( "use_bridle_end", private.use_bridle_end, private.room_objname );
cmn.AddSubscriber( "use_bridle_end", private.use_bridle_logic );
--------------------------------------------------------------------------------------------
function public.use_bridle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bridle" );
    cmn.CallEventHandler( "use_bridle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bridle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bridle_inv" );
  cmn.CallEventHandler( "use_bridle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_horse_anm_bridle", "use_bridle", func_end );
  SoundSfx( "aud_use_bridle_square" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coin" ] = { type = "get", get_obj = "spr_horse_coin", room = "rm_square", zz = "zz_horse", zz_gate = "gzz_square_horse" };

private.get_coin_logic = function()
  
end;
private.get_coin_inv = function()
  interface.InventoryItemAdd("inv_coin","spr_horse_coin");
end;
private.get_coin_beg = function()
  ObjDelete("gfx_horse_coin")
end;
private.get_coin_end = function()
  ObjDelete("spr_horse_sh_coin")
  if common_impl.ZzCompleteCheck("get_coin") then ObjSet( common_impl.hint["get_coin"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coin", private.get_coin_inv );
cmn.AddSubscriber( "get_coin", private.get_coin_beg, private.room_objname );
cmn.AddSubscriber( "get_coin", private.get_coin_end, private.room_objname );
cmn.AddSubscriber( "get_coin", private.get_coin_logic );
--------------------------------------------------------------------
function public.get_coin()
  cmn.SetEventDone( "get_coin" );
  cmn.CallEventHandler( "get_coin" );
  if common_impl.ZzCompleteCheck("get_coin") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tohome *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
--common_impl.hint[ "get_goldhorseshoe1" ] = { type = "get", get_obj = "spr_tohome_goldhorseshoe1", room = "rm_square", zz = "zz_tohome", zz_gate = "gzz_square_tohome" };
--
--private.get_goldhorseshoe1_logic = function()
--  
--end;
--private.get_goldhorseshoe1_inv = function()
--  interface.InventoryItemAdd("inv_goldhorseshoe1","spr_tohome_goldhorseshoe1");
--end;
--private.get_goldhorseshoe1_beg = function()
--  ObjDelete("gfx_tohome_goldhorseshoe1")
--end;
--private.get_goldhorseshoe1_end = function()
--  ObjDelete("spr_tohome_nail")
--  ObjDelete("spr_tohome_sh_goldhorseshoe1")
--  ObjDelete("spr_square_goldhorseshoe1")
--  if common_impl.ZzCompleteCheck("get_goldhorseshoe1") then ObjSet( common_impl.hint["get_goldhorseshoe1"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
--
--cmn.AddSubscriber( "get_goldhorseshoe1", private.get_goldhorseshoe1_inv );
--cmn.AddSubscriber( "get_goldhorseshoe1", private.get_goldhorseshoe1_beg, private.room_objname );
--cmn.AddSubscriber( "get_goldhorseshoe1", private.get_goldhorseshoe1_end, private.room_objname );
--cmn.AddSubscriber( "get_goldhorseshoe1", private.get_goldhorseshoe1_logic );
----------------------------------------------------------------------
--function public.get_goldhorseshoe1()
--  cmn.SetEventDone( "get_goldhorseshoe1" );
--  cmn.CallEventHandler( "get_goldhorseshoe1" );
--  if common_impl.ZzCompleteCheck("get_goldhorseshoe1") then ld.CloseSubRoom() end;
--end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_torch" ] = { type = "use", inv_obj = "inv_torch", use_place = "gfx_tohome_torch_zone", room = "rm_square", zz = "zz_tohome", zz_gate = "gzz_square_tohome" };

private.use_torch_logic = function()
  ObjSet( "gfx_tohome_fulladress_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_torch_inv = function()
  common_impl.ProcessMultiUseAll("torch", "torch")
end;
private.use_torch_beg = function()
  ObjDelete( "gfx_tohome_torch_zone" );
end;
private.use_torch_end = function()
  ObjSet("anm_tohome_anm",{animfunc="end_torch",frame=0})
  ObjSet( "spr_tohome_paper", {active=1, input = 1, visible = 1} );
  for i=1,4 do
    ObjDelete("spr_square_sh"..i)
  end
  ObjSet( "spr_square_lidht", {visible=1, alp = 1} );
  if common_impl.ZzCompleteCheck("use_torch") then ObjSet( common_impl.hint["use_torch"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_square_paper2", {visible = 1} );
  ObjSet( "fx_square_pm_lamp", {active=1, visible=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_torch", private.use_torch_inv );
cmn.AddSubscriber( "use_torch", private.use_torch_beg, private.room_objname );
cmn.AddSubscriber( "use_torch", private.use_torch_end, private.room_objname );
cmn.AddSubscriber( "use_torch", private.use_torch_logic );
cmn.AddSubscriber( "use_torch_inv", private.use_torch_inv, private.room_objname );
cmn.AddSubscriber( "use_torch_beg", private.use_torch_beg, private.room_objname );
cmn.AddSubscriber( "use_torch_end", private.use_torch_end, private.room_objname );
cmn.AddSubscriber( "use_torch_end", private.use_torch_logic );
--------------------------------------------------------------------------------------------
function public.use_torch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_torch" );
    cmn.CallEventHandler( "use_torch_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_torch") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_torch_inv" );
  cmn.CallEventHandler( "use_torch_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tohome_anm", "use_torch", func_end );
  SoundSfx( "aud_use_torch_square" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fulladress" ] = { type = "use", inv_obj = "inv_fulladress", use_place = "gfx_tohome_fulladress_zone", room = "rm_square", zz = "zz_tohome", zz_gate = "gzz_square_tohome" };

private.use_fulladress_logic = function()
  ObjSet( "grm_square_nearhouse", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_square_nearhouse_focus");
  end;
end;
private.use_fulladress_inv = function()
  common_impl.ProcessMultiUseAll("fulladress", "fulladress")
end;
private.use_fulladress_beg = function()
  ObjDelete( "gfx_tohome_fulladress_zone" );
end;
private.use_fulladress_end = function()
  ObjSet("anm_tohome_anm",{animfunc="end_address",frame=0})  
  ObjSet( "spr_square_address", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_fulladress") then ObjSet( common_impl.hint["use_fulladress"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjSet( "spr_tohome_paper", {input = 0} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fulladress", private.use_fulladress_inv );
cmn.AddSubscriber( "use_fulladress", private.use_fulladress_beg, private.room_objname );
cmn.AddSubscriber( "use_fulladress", private.use_fulladress_end, private.room_objname );
cmn.AddSubscriber( "use_fulladress", private.use_fulladress_logic );
cmn.AddSubscriber( "use_fulladress_inv", private.use_fulladress_inv, private.room_objname );
cmn.AddSubscriber( "use_fulladress_beg", private.use_fulladress_beg, private.room_objname );
cmn.AddSubscriber( "use_fulladress_end", private.use_fulladress_end, private.room_objname );
cmn.AddSubscriber( "use_fulladress_end", private.use_fulladress_logic );
--------------------------------------------------------------------------------------------
function public.use_fulladress( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fulladress" );
    cmn.CallEventHandler( "use_fulladress_end" );
    common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_fulladress") then ld.CloseSubRoom() end;
    ObjSet( "spr_tohome_paper", {visible = 1} );
  end;

  local func_preend = function()
    ObjSet( "spr_square_address", {alp = 1} );
    ld.CloseSubRoom()
    ld.StartTimer( 0.3, function()
      ld.ShowBbt("after_fulladdress");
      ObjSet( "grm_square_nearhouse", {active=1, visible=1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_nearhouse_focus");
      end;
      ObjAnimate( "grm_square_nearhouse_focus", 8, 0, 0, func_end, {0,0,0, 0.5,0,1, 1,0,1, 1.5,0,0} );
    end )
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fulladress_inv" );
  cmn.CallEventHandler( "use_fulladress_beg" );
  common_impl.Lock(1);

  ObjSet( "spr_tohome_paper", {visible = 0} );
  ld.AnimPlay( "anm_tohome_anm", "use_address", func_preend );
  SoundSfx( "aud_use_address_square" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_traderaddress" ] = { type = "use", inv_obj = "inv_traderaddress", use_place = "gfx_tohome_traderaddress", room = "rm_square",  zz = "zz_tohome", zz_gate = "gzz_square_tohome" };

private.use_traderaddress_logic = function()
  ObjSet( "grm_square_seafront", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_square_seafront_focus");
  end;
end;
private.use_traderaddress_inv = function()
  common_impl.ProcessMultiUseAll("traderaddress", "traderaddress")
end;
private.use_traderaddress_beg = function()
  ObjDelete( "gfx_tohome_traderaddress" );
end;
private.use_traderaddress_end = function()
  ObjSet( "anm_tohome_anm_road", {animfunc = "end_road", frame = 0, visible = 1 } );
  ObjSet( "spr_square_open_door", {visible = 1} );
  ObjDelete("obj_square_ladder_clk_zone");
  ObjSet( "spr_square_riverroad", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_traderaddress", private.use_traderaddress_inv );
cmn.AddSubscriber( "use_traderaddress", private.use_traderaddress_beg, private.room_objname );
cmn.AddSubscriber( "use_traderaddress", private.use_traderaddress_end, private.room_objname );
cmn.AddSubscriber( "use_traderaddress", private.use_traderaddress_logic );
cmn.AddSubscriber( "use_traderaddress_inv", private.use_traderaddress_inv, private.room_objname );
cmn.AddSubscriber( "use_traderaddress_beg", private.use_traderaddress_beg, private.room_objname );
cmn.AddSubscriber( "use_traderaddress_end", private.use_traderaddress_end, private.room_objname );
cmn.AddSubscriber( "use_traderaddress_end", private.use_traderaddress_logic );
--------------------------------------------------------------------------------------------
function public.use_traderaddress( obj )


 local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_traderaddress" );
    cmn.CallEventHandler( "use_traderaddress_end" );
    common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_fulladress") then ld.CloseSubRoom() end;
    -- ObjSet( "spr_tohome_paper", {visible = 1} );
    ld.ShowBbt("after_traderaddress");
  end;

  local func_preend = function()
    -- ObjSet( "spr_square_address", {alp = 1} );
    ObjSet( "spr_square_open_door", {visible = 1} );
    ld.CloseSubRoom()
    ld.StartTimer( 0.3, function()
    --  ld.ShowBbt("after_traderaddress");
      ObjSet( "grm_square_seafront", {active=1, visible=1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_seafront_focus");
      end;
      ObjAnimate( "grm_square_seafront_focus", 8, 0, 0, func_end, {0,0,0, 0.5,0,1, 1,0,1, 1.5,0,0} );
    end )
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_traderaddress_inv" );
  cmn.CallEventHandler( "use_traderaddress_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_tohome_anm_road", {visible = 1} );
  ld.AnimPlay( "anm_tohome_anm_road", "use_road", func_preend );
  SoundSfx( "aud_use_traderaddress_square" )
  --func_preend()

end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tradeshop *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_carvedhandle" ] = { type = "use", inv_obj = "inv_carvedhandle", use_place = "gfx_tradeshop_carvedhandle_zone", room = "rm_square", zz = "zz_tradeshop", zz_gate = "gzz_square_tradeshop" };

private.use_carvedhandle_logic = function()
  ObjSet( "spr_tradeshop_necklace", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_tradeshop_goldhorseshoe2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_tradeshop_button_zone", { visible = 1, input = 1, active = 1 } )
  

end;
private.use_carvedhandle_inv = function()
  common_impl.ProcessMultiUseAll("carvedhandle", "carvedhandle")
end;
private.use_carvedhandle_beg = function()
  ObjDelete( "gfx_tradeshop_carvedhandle_zone" );
end;
private.use_carvedhandle_end = function()
  -- ObjSet("anm_tradeshop_use_pen",{animfunc="use_button",frame=0,pos_z=3})
  ObjDelete("anm_tradeshop_use_pen");
  ObjSet( "spr_square_tr", {alp = 1} );
  ObjSet( "spr_square_flask", {alp = 1} );
  -- ObjSet( "spr_square_camomile1", {alp = 1} );
  ObjSet( "spr_tradeshop_sh_ring", {visible = 1} );
  ObjSet( "spr_square_goldhorseshoe2", {alp = 1} );
  ObjSet( "spr_square_necklace", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_carvedhandle") then ObjSet( common_impl.hint["use_carvedhandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_carvedhandle", private.use_carvedhandle_inv );
cmn.AddSubscriber( "use_carvedhandle", private.use_carvedhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_carvedhandle", private.use_carvedhandle_end, private.room_objname );
cmn.AddSubscriber( "use_carvedhandle", private.use_carvedhandle_logic );
cmn.AddSubscriber( "use_carvedhandle_inv", private.use_carvedhandle_inv, private.room_objname );
cmn.AddSubscriber( "use_carvedhandle_beg", private.use_carvedhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_carvedhandle_end", private.use_carvedhandle_end, private.room_objname );
cmn.AddSubscriber( "use_carvedhandle_end", private.use_carvedhandle_logic );
--------------------------------------------------------------------------------------------
function public.use_carvedhandle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_carvedhandle" );
    cmn.CallEventHandler( "use_carvedhandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_carvedhandle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_carvedhandle_inv" );
  cmn.CallEventHandler( "use_carvedhandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tradeshop_use_pen", "use_pen", func_end );
  SoundSfx( "aud_use_carvedhandle_square" )
  

end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_necklace" ] = { type = "get", get_obj = "spr_tradeshop_necklace", room = "rm_square", zz = "zz_tradeshop", zz_gate = "gzz_square_tradeshop" };

private.get_necklace_logic = function()
  
end;
private.get_necklace_inv = function()
  interface.InventoryItemAdd("inv_necklace","spr_tradeshop_necklace");
end;
private.get_necklace_beg = function()
  ObjDelete("gfx_tradeshop_necklace")
end;
private.get_necklace_end = function()
  ObjDelete("spr_tradeshop_sh_ring")
  ObjDelete("spr_square_ring");
  if common_impl.ZzCompleteCheck("get_necklace") then ObjSet( common_impl.hint["get_necklace"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_necklace", private.get_necklace_inv );
cmn.AddSubscriber( "get_necklace", private.get_necklace_beg, private.room_objname );
cmn.AddSubscriber( "get_necklace", private.get_necklace_end, private.room_objname );
cmn.AddSubscriber( "get_necklace", private.get_necklace_logic );
--------------------------------------------------------------------
function public.get_necklace()
  cmn.SetEventDone( "get_necklace" );
  cmn.CallEventHandler( "get_necklace" );
  if common_impl.ZzCompleteCheck("get_necklace") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_goldhorseshoe2" ] = { type = "get", get_obj = "spr_tradeshop_goldhorseshoe2", room = "rm_square", zz = "zz_tradeshop", zz_gate = "gzz_square_tradeshop" };

private.get_goldhorseshoe2_logic = function()
  
end;
private.get_goldhorseshoe2_inv = function()
  interface.InventoryItemAdd("inv_goldhorseshoe2","spr_tradeshop_goldhorseshoe2");
end;
private.get_goldhorseshoe2_beg = function()
  ObjDelete("gfx_tradeshop_goldhorseshoe2")
end;
private.get_goldhorseshoe2_end = function()
  ObjDelete("spr_tradeshop_sh_goldhorseshoe2")  
  ObjDelete("spr_square_goldhorseshoe2")
  if common_impl.ZzCompleteCheck("get_goldhorseshoe2") then ObjSet( common_impl.hint["get_goldhorseshoe2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_goldhorseshoe2", private.get_goldhorseshoe2_inv );
cmn.AddSubscriber( "get_goldhorseshoe2", private.get_goldhorseshoe2_beg, private.room_objname );
cmn.AddSubscriber( "get_goldhorseshoe2", private.get_goldhorseshoe2_end, private.room_objname );
cmn.AddSubscriber( "get_goldhorseshoe2", private.get_goldhorseshoe2_logic );
--------------------------------------------------------------------
function public.get_goldhorseshoe2()
  cmn.SetEventDone( "get_goldhorseshoe2" );
  cmn.CallEventHandler( "get_goldhorseshoe2" );
  if common_impl.ZzCompleteCheck("get_goldhorseshoe2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_button" ] = { type = "use", inv_obj = "inv_button", use_place = "gfx_tradeshop_button_zone", room = "rm_square", zz = "zz_tradeshop", zz_gate = "gzz_square_tradeshop" };

private.use_button_logic = function()
  ObjSet( "gmg_square_behindglass", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_square_tradeshop", {active=0, visible=0, input = 0} );
end;
private.use_button_inv = function()
  common_impl.ProcessMultiUseAll("button", "button")
end;
private.use_button_beg = function()
  ObjDelete( "gfx_tradeshop_button_zone" );
end;
private.use_button_end = function()
  ObjSet( "spr_square_button", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_button") then ObjSet( common_impl.hint["use_button"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_tradeshop_newspaper", {active=0, input=0} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_button", private.use_button_inv );
cmn.AddSubscriber( "use_button", private.use_button_beg, private.room_objname );
cmn.AddSubscriber( "use_button", private.use_button_end, private.room_objname );
cmn.AddSubscriber( "use_button", private.use_button_logic );
cmn.AddSubscriber( "use_button_inv", private.use_button_inv, private.room_objname );
cmn.AddSubscriber( "use_button_beg", private.use_button_beg, private.room_objname );
cmn.AddSubscriber( "use_button_end", private.use_button_end, private.room_objname );
cmn.AddSubscriber( "use_button_end", private.use_button_logic );
--------------------------------------------------------------------------------------------
function public.use_button( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_button" );
    cmn.CallEventHandler( "use_button_end" );
    common_impl.Lock(0);
    ld.CloseSubRoom() 
    cmn.GotoRoom("mg_behindglass")
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_button_inv" );
  cmn.CallEventHandler( "use_button_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tradeshop_statik", "use_button", func_end );
  SoundSfx( "aud_use_button_square" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_understage *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_beetle_zone_clk()  -- rm_square.use_beetle_zone_clk()
  common_impl.ShowBbt( 'need_beetle' );
  ld.Lock(1)
  --ld.AnimPlay("anm_understage_anm_torch","idle_torch",function()ld.Lock(0)end)
  SoundSfx( "aud_touch_torch_square" );  
  ObjAnimate( "anm_understage_anm_torch_torch", 1, 0, 0, function() ld.Lock(0); end, {0,0,-110, 0.25,0,-120, 0.5,0,-110} );  
end;  



common_impl.hint[ "use_beetle" ] = { type = "use", inv_obj = "inv_beetle", use_place = "gfx_understage_beetle_zone", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.use_beetle_logic = function()
  ObjSet( "gfx_understage_win_clamp_zone", { input = 1, active = 1 } )
end;
private.use_beetle_inv = function()
  common_impl.ProcessMultiUseAll("beetle", "beetle")
end;
private.use_beetle_beg = function()
  ObjDelete( "gfx_understage_beetle_zone" );
end;
private.use_beetle_end = function()
  ObjSet("anm_understage_anm_torch",{animfunc="end_beetle",frame=0})
    ObjAttach("spr_understage_mmg_root","zz_understage")  
  ObjSet( "spr_understage_mmg_root", {input = 1, alp = 1} );  
  if common_impl.ZzCompleteCheck("use_beetle") then ObjSet( common_impl.hint["use_beetle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_beetle", private.use_beetle_inv );
cmn.AddSubscriber( "use_beetle", private.use_beetle_beg, private.room_objname );
cmn.AddSubscriber( "use_beetle", private.use_beetle_end, private.room_objname );
cmn.AddSubscriber( "use_beetle", private.use_beetle_logic );
cmn.AddSubscriber( "use_beetle_inv", private.use_beetle_inv, private.room_objname );
cmn.AddSubscriber( "use_beetle_beg", private.use_beetle_beg, private.room_objname );
cmn.AddSubscriber( "use_beetle_end", private.use_beetle_end, private.room_objname );
cmn.AddSubscriber( "use_beetle_end", private.use_beetle_logic );
--------------------------------------------------------------------------------------------
function public.use_beetle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_beetle" );
    cmn.CallEventHandler( "use_beetle_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "clamp" );
    level.tutorial_mg.first()
    if common_impl.ZzCompleteCheck("use_beetle") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
    ObjAttach("spr_understage_mmg_root","zz_understage")
    ObjAnimate( "spr_understage_mmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );    
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_beetle_inv" );
  cmn.CallEventHandler( "use_beetle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_understage_anm_torch", "use_beetle", f_step );
  SoundSfx( "aud_use_beetle_square" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_clamp" ] = { type = "click", use_place = "gfx_understage_win_clamp_zone", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.win_clamp_logic = function()
  if cmn.IsEventDone("win_clamp") then  
    -- ObjSet( "spr_understage_torch", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_clamp_beg = function()
  if cmn.IsEventDone("win_clamp") then    
    ObjDelete( "gfx_understage_win_clamp_zone" );
  end
end;
private.win_clamp_end = function()
  if cmn.IsEventDone("win_clamp") then    
    ObjSet("anm_understage_anm_torch",{animfunc="end_open_torch",frame=0, pos_z=1})
    ObjDelete("spr_understage_mmg_root")
    if common_impl.ZzCompleteCheck("win_clamp") then ObjSet( common_impl.hint["win_clamp"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjDelete("anm_understage_anm_torch_2")
    ObjDelete("pfx_understage_pm_light");
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_clamp", private.win_clamp_beg, private.room_objname );
cmn.AddSubscriber( "win_clamp", private.win_clamp_end, private.room_objname );
cmn.AddSubscriber( "win_clamp", private.win_clamp_logic );
cmn.AddSubscriber( "win_clamp_beg", private.win_clamp_beg, private.room_objname );
cmn.AddSubscriber( "win_clamp_end", private.win_clamp_end, private.room_objname );
cmn.AddSubscriber( "win_clamp_end", private.win_clamp_logic );
--------------------------------------------------------------------------------------------
function public.win_clamp()

  local func_end = function()
    ld.Lock(0);
    cmn.SetEventDone( "win_clamp" );
    cmn.CallEventHandler( "win_clamp_end" );
    public.get_torch()
    if common_impl.ZzCompleteCheck("win_clamp") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    ld.AnimPlay( "anm_understage_anm_torch", "open_torch", func_end );
    ld.AnimPlay( "anm_understage_anm_torch_2", "open_torch1", function() end )
    ObjAnimate( "pfx_understage_pm_light", 8, 0, 0, function() common_impl.Lock(0); end, {0,0,1, 0.4,0,1, 0.6,0,0} );  
  end
  cmn.MiniGameHide( "clamp", true );   
  cmn.CallEventHandler( "win_clamp_beg" );
  common_impl.Lock(1);
  SoundSfx( "aud_mmg_clamp_win" );
  ObjAnimate( "spr_understage_mmg_root", 8, 0, 0, f_step, {0,0,1, 0.5,0,0} );
  
  --SoundSfx( 0 )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--mmg_clamp
private.win_clamp_connection = {3,4,2,1}
private.win_clamp_state = {1,1,1,1}
function public.understage_mdown(obj)
  SoundSfx( "aud_mmg_clamp_move" );
  local num1 = tonumber(ld.StringDivide(obj)[4])
  local num2 = private.win_clamp_connection[num1]
  local obj2 = "spr_understage_beetle_"..num2
  
  local dir1 = 1
  local dir2 = 1 
  if private.win_clamp_state[num1]==1 then dir1 = -1 end
  if private.win_clamp_state[num2]==1 then dir2 = -1 end 
  ld.Lock(1)   
  ObjAnimate( obj, 0, 0, 0, "", {0,0,ObjGet(obj).pos_x, 0.5,0,ObjGet(obj).pos_x+50*dir1} );
  ObjAnimate( obj2, 0, 0, 0, private.understage_check, {0,0,ObjGet(obj2).pos_x, 0.5,0,ObjGet(obj2).pos_x+50*dir2} );
  private.win_clamp_state[num1] = dir1
  private.win_clamp_state[num2] = dir2  
end
function private.understage_check()
    ld.Lock(0)
  local sum = 0 
  for i=1,4 do
    sum = sum + private.win_clamp_state[i]
  end
  if sum == -4 then
    public.win_clamp()
  end
end
function public.understage_menter(obj)
  ld.ShCur(CURSOR_HAND)
  ObjAnimate( obj.."_light", 8, 0, 0, "", {0,0,ObjGet(obj.."_light").alp, 0.2,0,1} );
end
function public.understage_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  ObjAnimate( obj.."_light", 8, 0, 0, "", {0,0,ObjGet(obj.."_light").alp, 0.2,0,0} );  
end

function private.win_clamp_skip()
  private.win_clamp_state = {-1,-1,-1,-1}
  ld.Lock(1)  
  for i=1,4 do 
    local obj = "spr_understage_beetle_"..i
    ObjAnimate( obj, 0, 0, 0, "", {0,0,ObjGet(obj).pos_x, 0.5,0,-49} );
  end  
  ld.StartTimer( 0.5, public.win_clamp )
end

function private.win_clamp_reset()
  private.win_clamp_state = {1,1,1,1}
  ld.Lock(1)
  for i=1,4 do 
    local obj = "spr_understage_beetle_"..i
    ObjAnimate( obj, 0, 0, 0, "", {0,0,ObjGet(obj).pos_x, 0.5,0,1} );
  end
    ld.StartTimer( 0.5, function()ld.Lock(0)end )
end
--------------------------------------------------------------------
--common_impl.hint[ "get_torch" ] = { type = "get", get_obj = "spr_understage_torch", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

common_impl.hint[ "get_torch" ] = { type = "get", get_obj = "anm_understage_anm_torch_torch", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.get_torch_logic = function()
  
end;
private.get_torch_inv = function()
  interface.InventoryItemAdd("inv_torch","anm_understage_anm_torch_torch");
end;
private.get_torch_beg = function()
  ObjDelete("gfx_understage_torch")
end;
private.get_torch_end = function()
  ObjDelete("spr_square_torch")
  if common_impl.ZzCompleteCheck("get_torch") then ObjSet( common_impl.hint["get_torch"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("fx_square_pm_torch");
  ObjDelete( "spr_understage_text_l");
  ObjSet( "spr_understage_text_d", {visible = 1} );
  ObjDelete("spr_square_text_l1");
  ObjSet( "spr_square_text_d1", {visible = 1} );
end;

cmn.AddSubscriber( "get_torch", private.get_torch_inv );
cmn.AddSubscriber( "get_torch", private.get_torch_beg, private.room_objname );
cmn.AddSubscriber( "get_torch", private.get_torch_end, private.room_objname );
cmn.AddSubscriber( "get_torch", private.get_torch_logic );
--------------------------------------------------------------------
function public.get_torch()
  SoundEnv("aud_torch_square_loc_env",0);
  SoundEnv("aud_torch_square_zz_env",0);
  cmn.SetEventDone( "get_torch" );
  cmn.CallEventHandler( "get_torch" );
  if common_impl.ZzCompleteCheck("get_torch") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_tubule" ] = { type = "use", inv_obj = "inv_tubule", use_place = "gfx_understage_tubule_zone", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.use_tubule_logic = function()
  ObjSet( "spr_understage_emblem", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_understage_camomile1", { visible = 1, input = 1, active = 1 } )
  
end;
private.use_tubule_inv = function()
  common_impl.ProcessMultiUseAll("tubule", "tubule")
end;
private.use_tubule_beg = function()
  ObjDelete( "gfx_understage_tubule_zone" );
end;
private.use_tubule_end = function()
  ObjSet( "spr_understage_sh_emblem", {visible = 1} ); 
  ObjSet( "spr_understage_sh_ring", {visible = 1} );   
  ObjSet("anm_understage_anm_right",{animfunc="end_1",frame=0})
  ObjSet( "spr_square_door2_open", {alp = 1} );
  ObjSet( "spr_square_emblem", {visible = 1} );
  ObjDelete("spr_square_door2")  
  if common_impl.ZzCompleteCheck("use_tubule") then ObjSet( common_impl.hint["use_tubule"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_square_camomile1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tubule", private.use_tubule_inv );
cmn.AddSubscriber( "use_tubule", private.use_tubule_beg, private.room_objname );
cmn.AddSubscriber( "use_tubule", private.use_tubule_end, private.room_objname );
cmn.AddSubscriber( "use_tubule", private.use_tubule_logic );
cmn.AddSubscriber( "use_tubule_inv", private.use_tubule_inv, private.room_objname );
cmn.AddSubscriber( "use_tubule_beg", private.use_tubule_beg, private.room_objname );
cmn.AddSubscriber( "use_tubule_end", private.use_tubule_end, private.room_objname );
cmn.AddSubscriber( "use_tubule_end", private.use_tubule_logic );
--------------------------------------------------------------------------------------------
function public.use_tubule( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tubule" );
    cmn.CallEventHandler( "use_tubule_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tubule") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tubule_inv" );
  cmn.CallEventHandler( "use_tubule_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_understage_anm_right", "use_tubule", func_end );
  SoundSfx( "aud_use_tubule_square" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_emblem" ] = { type = "get", get_obj = "spr_understage_emblem", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.get_emblem_logic = function()
  
end;
private.get_emblem_inv = function()
  interface.InventoryItemAdd("inv_emblem","spr_understage_emblem");
end;
private.get_emblem_beg = function()
  ObjDelete("gfx_understage_emblem")
end;
private.get_emblem_end = function()
  ObjDelete("spr_understage_sh_emblem")
  if common_impl.ZzCompleteCheck("get_emblem") then ObjSet( common_impl.hint["get_emblem"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_square_emblem");
end;

cmn.AddSubscriber( "get_emblem", private.get_emblem_inv );
cmn.AddSubscriber( "get_emblem", private.get_emblem_beg, private.room_objname );
cmn.AddSubscriber( "get_emblem", private.get_emblem_end, private.room_objname );
cmn.AddSubscriber( "get_emblem", private.get_emblem_logic );
--------------------------------------------------------------------
function public.get_emblem()
  cmn.SetEventDone( "get_emblem" );
  cmn.CallEventHandler( "get_emblem" );
  if common_impl.ZzCompleteCheck("get_emblem") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_camomile1" ] = { type = "get", get_obj = "spr_understage_camomile1", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.get_camomile1_logic = function()
  
end;
private.get_camomile1_inv = function()
  interface.InventoryItemAdd("inv_camomile","spr_understage_camomile1",function() level_inv.ProcessGetCamomileAll( "get_camomile1" ) end);
end;
private.get_camomile1_beg = function()
  ObjDelete("gfx_understage_camomile1")
end;
private.get_camomile1_end = function()
  ObjDelete("spr_understage_sh_camomile1")
  -- ObjDelete("spr_square_camomile1")
  if common_impl.ZzCompleteCheck("get_camomile1") then ObjSet( common_impl.hint["get_camomile1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_square_camomile1")
end;

cmn.AddSubscriber( "get_camomile1", private.get_camomile1_inv );
cmn.AddSubscriber( "get_camomile1", private.get_camomile1_beg, private.room_objname );
cmn.AddSubscriber( "get_camomile1", private.get_camomile1_end, private.room_objname );
cmn.AddSubscriber( "get_camomile1", private.get_camomile1_logic );
--------------------------------------------------------------------
function public.get_camomile1()
  cmn.SetEventDone( "get_camomile1" );
  cmn.CallEventHandler( "get_camomile1" );
  if common_impl.ZzCompleteCheck("get_camomile1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bird" ] = { type = "use", inv_obj = "inv_bird", use_place = "gfx_understage_bird_zone", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.use_bird_logic = function()
  ObjSet( "spr_understage_acid", { visible = 1, input = 1, active = 1 } )

end;
private.use_bird_inv = function()
  common_impl.ProcessMultiUseAll("bird", "bird")
end;
private.use_bird_beg = function()
  ObjDelete( "gfx_understage_bird_zone" );
end;
private.use_bird_end = function()
  ObjSet("anm_understage_anm_left",{animfunc="end_2",frame=0}) 
  ObjSet( "spr_understage_sh_acid", {visible = 1} ); 
  ObjSet( "spr_square_door1_open", {alp = 1} );
  ObjDelete("spr_square_door1")
  ObjSet( "spr_square_acid", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_bird") then ObjSet( common_impl.hint["use_bird"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bird", private.use_bird_inv );
cmn.AddSubscriber( "use_bird", private.use_bird_beg, private.room_objname );
cmn.AddSubscriber( "use_bird", private.use_bird_end, private.room_objname );
cmn.AddSubscriber( "use_bird", private.use_bird_logic );
cmn.AddSubscriber( "use_bird_inv", private.use_bird_inv, private.room_objname );
cmn.AddSubscriber( "use_bird_beg", private.use_bird_beg, private.room_objname );
cmn.AddSubscriber( "use_bird_end", private.use_bird_end, private.room_objname );
cmn.AddSubscriber( "use_bird_end", private.use_bird_logic );
--------------------------------------------------------------------------------------------
function public.use_bird( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bird" );
    cmn.CallEventHandler( "use_bird_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bird") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bird_inv" );
  cmn.CallEventHandler( "use_bird_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_understage_anm_left", "use_birdie", func_end );
  SoundSfx( "aud_use_bird_square" )
 

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_acid" ] = { type = "get", get_obj = "spr_understage_acid", room = "rm_square", zz = "zz_understage", zz_gate = "gzz_square_understage" };

private.get_acid_logic = function()
  
end;
private.get_acid_inv = function()
  interface.InventoryItemAdd("inv_acid","spr_understage_acid");
end;
private.get_acid_beg = function()
  ObjDelete("gfx_understage_acid")
end;
private.get_acid_end = function()
  ObjDelete("spr_understage_sh_acid")  
  if common_impl.ZzCompleteCheck("get_acid") then ObjSet( common_impl.hint["get_acid"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_square_acid");
end;

cmn.AddSubscriber( "get_acid", private.get_acid_inv );
cmn.AddSubscriber( "get_acid", private.get_acid_beg, private.room_objname );
cmn.AddSubscriber( "get_acid", private.get_acid_end, private.room_objname );
cmn.AddSubscriber( "get_acid", private.get_acid_logic );
--------------------------------------------------------------------
function public.get_acid()
  cmn.SetEventDone( "get_acid" );
  cmn.CallEventHandler( "get_acid" );
  if common_impl.ZzCompleteCheck("get_acid") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_behindglass_for_square = function()
    if ld.CheckRequirements( {"win_behindglass","get_package","get_tubule"} ) then
      ObjSet( "gmg_square_behindglass", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_behindglass", win_behindglass_for_square, private.room_objname )
  cmn.AddSubscriber("get_package", win_behindglass_for_square, private.room_objname )
  cmn.AddSubscriber("get_tubule", win_behindglass_for_square, private.room_objname ) 
  
  local win_injail_for_square = function()
    if ld.CheckRequirements( {"win_injail"} ) then
      ObjSet( "gho_square_injail", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_injail", win_injail_for_square, private.room_objname )

end

---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_understage" ) and not ld.CheckRequirements( { "win_clamp" } ) then  
    private.win_clamp_reset();
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_understage" ) and not ld.CheckRequirements( { "win_clamp" } ) then
    private.win_clamp_skip();
  end;
  
end
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  private.opn_square();

  level.tutorial_deploy.first()
  level.tutorial_zz.first()
  
    if not cmn.IsEventDone("clk_outro2") and cmn.IsEventDone("dlg_bedroomboy_lady3") then 
     public.clk_outro2()
  end;  
end;
--*********************************************************************************************************************
function public.PreOpen()
  --if not ( cmn.IsEventDone( "opn_square" ) ) then
  --  private.SeeIntro()
  --end;

  if not cmn.IsEventDone("clk_anmfly") then 
   -- public.clk_anmfly()
    ObjAttach("vid_square_vid_anmfly","rm_square");
   --  local widget_settings = 
   --    {
   --      InterfaceWidget_Inventory,
   --      InterfaceWidget_BtnHint,
   --      InterfaceWidget_BtnGuide,
   --      InterfaceWidget_BtnMenu,
   --      InterfaceWidget_BtnMap,
   --    }
  
   --  for i = 1, #widget_settings do
   --      interface.WidgetSetVisible( widget_settings[i], 0, false );
   --  end;  
  else
    SoundEnv("aud_square_env");
    if not cmn.IsEventDone("get_torch") then SoundEnv("aud_torch_square_loc_env",1) end;
  end;  
  
  if not cmn.IsEventDone("clk_outro2")  and cmn.IsEventDone("dlg_bedroomboy_lady3") then 
    ObjAttach("vid_square_vid_outro2","rm_square");
  end; 
  
  if cmn.IsEventDone("get_tubule") and cmn.IsEventDone("get_package") then 
    ObjSet( "spr_square_tr_package", {visible = 1} );
  end;  
  
  
  if cmn.IsEventDone("dlg_bedroomboy_lady3") and not cmn.IsEventDone("dlg_square_lady4") then 
    ObjSet( "anm_square_anm_lady_anm", {active = 1, visible = 1, playing = 1} );
  end;  
end;
--*********************************************************************************************************************
function public.Close()

end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_understage" );
  function zz_understage.Open()
  end;
  function zz_understage.PreOpen()
     if cmn.IsEventStart("win_clamp") and not cmn.IsEventDone("win_clamp") then 
       cmn.MiniGameShow( "clamp" ); 
       level.tutorial_mg.first()
       private.understage_check()
     end;    
     if not cmn.IsEventDone("get_torch") then 
       SoundEnv("aud_torch_square_loc_env",0);
       SoundEnv("aud_torch_square_zz_env",1);
     end;  
  end;
  function zz_understage.PreClose()
  end;
  function zz_understage.Close()
     if not cmn.IsEventDone("get_torch") then 
       SoundEnv("aud_torch_square_loc_env",1);
       SoundEnv("aud_torch_square_zz_env",0);
     end;  
  end;

  subroom.Define( "zz_tradeshop" );
  function zz_tradeshop.Open()
    level.tutorial_use.first()      
  end;
  function zz_tradeshop.PreOpen()
  end;
  function zz_tradeshop.PreClose()
  end;
  function zz_tradeshop.Close()
  end;

  subroom.Define( "zz_tohome" );
  function zz_tohome.Open()
  end;
  function zz_tohome.PreOpen()
  end;
  function zz_tohome.PreClose()
  end;
  function zz_tohome.Close()
  end;

  subroom.Define( "zz_horse" );
  function zz_horse.Open()
    level.tutorial_get.first()
  end;
  function zz_horse.PreOpen()
  end;
  function zz_horse.PreClose()
  end;
  function zz_horse.Close()
  end;



end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************