-- name=ho_nightmareshoext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "nightmareshoext" );
  game.relations[ "ho_nightmareshoext" ].exitroom = "rm_abyssext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_nightmareshoext" ] = { type = "win", room = "rm_abyssext", zz = "ho_nightmareshoext", zz_gate = "gho_abyssext_nightmareshoext" };
 
  local win_nightmareshoext_func = function ()

    if ( cmn.IsEventDone( "win_nightmareshoext" ) ) then
      interface.InventoryItemAdd( "inv_featherext2", "spr_nightmareshoext_win" );
      ObjDelete( "gho_abyssext_nightmareshoext" );
    end;

  end;
  cmn.AddSubscriber( "win_nightmareshoext", win_nightmareshoext_func );

  local unmark_morph= function () 
    ObjSet("spr_nightmareshoext_ggg",{input=1})
    --ObjSet("spr_nightmareshoext_hhh",{input=1})
    ObjSet("spr_nightmareshoext_hhh_part_1",{input=1})
    ObjSet("gfx_nightmareshoext_hhh_part_2",{input=1})    
    --ObjSet("spr_nightmareshoext_iii",{input=1})
    ObjSet( "gfx_nightmareshoext_unmark_iii_zone", {active=1,input = 1, visible = 1} );
    ObjSet("spr_nightmareshoext_jjj",{input=1})
    --ObjSet("spr_nightmareshoext_kkk",{input=1})
    ObjSet("spr_nightmareshoext_kkk_part_1",{active=1,input=1, visible = 1})
    ObjSet("gfx_nightmareshoext_kkk_part_2",{active=1,input=1, visible = 1})
    
    ObjSet("spr_nightmareshoext_lll",{input=1})
  end;
  cmn.AddSubscriber( "nightmareshoext_unmark_morph", unmark_morph, "ho_nightmareshoext" ); 
  
  local unmark_kkk = function () 
    ObjSet( "spr_nightmareshoext_kkk", {input = 1,alp=1} );
    ObjDelete("spr_nightmareshoext_kkk_part_1")    
    ObjDelete("gfx_nightmareshoext_kkk_part_2")
    ObjSet("anm_nightmareshoext_unmark_kkk",{animfunc="end_amulet",frame=0})
    ObjSet( "spr_nightmareshoext_back_3tr", {visible=1} );
  end;
  cmn.AddSubscriber( "nightmareshoext_unmark_kkk", unmark_kkk, "ho_nightmareshoext" ); 
 
  local unmark_iii = function () 
    ObjSet( "spr_nightmareshoext_iii", {input = 1,alp=1} );
    ObjDelete("gfx_nightmareshoext_unmark_iii_zone")
    ObjSet("anm_nightmareshoext_unmark_iii",{animfunc="click_sheet",frame=999})
  end;
  cmn.AddSubscriber( "nightmareshoext_unmark_iii", unmark_iii, "ho_nightmareshoext" ); 
 
  local unmark_hhh = function () 
    ObjSet( "spr_nightmareshoext_hhh", {input = 1,alp=1} );
    ObjDelete("spr_nightmareshoext_hhh_part_1")    
    ObjDelete("gfx_nightmareshoext_hhh_part_2")
    ObjDelete("anm_nightmareshoext_unmark_hhh")
    ObjSet( "spr_nightmareshoext_bottle_2tr", {visible=1} );    
    ObjSet( "spr_nightmareshoext_bottle_3tr", {visible=1} );    
  end;
  cmn.AddSubscriber( "nightmareshoext_unmark_hhh", unmark_hhh, "ho_nightmareshoext" ); 
   
  
  local start_nightmareshoext_func = function ()
      common_impl.ProcessHoStart( "nightmareshoext" );  
  if not cmn.IsEventDone("win_nightmareshoext") then
    if ng_global.progress["ext"]["win_nightmareshoext"].state then
      unmark_morph()
    end
    if cmn.IsUnmarkedTask("nightmareshoext","kkk") then 
      unmark_kkk()
    end  
    if cmn.IsUnmarkedTask("nightmareshoext","iii") then 
      unmark_iii()
    end 
    if cmn.IsUnmarkedTask("nightmareshoext","hhh") then 
      unmark_hhh()
    end     
  end
  end;
  cmn.AddSubscriber( "win_nightmareshoext", start_nightmareshoext_func, "ho_nightmareshoext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_ho_nightmareshoext_env" )

  if ( not cmn.IsEventDone( "opn_nightmareshoext" ) ) then

    cmn.InitHo( "nightmareshoext" );

    cmn.SetEventDone( "opn_nightmareshoext" );
    ng_global.progress["ext"]["win_nightmareshoext"].state = false
    cmn.SetMarkedTask( "nightmareshoext", "kkk" );
    cmn.SetMarkedTask( "nightmareshoext", "iii" );    
    cmn.SetMarkedTask( "nightmareshoext", "hhh" );       
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_nightmareshoext_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_nightmareshoext_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_nightmareshoext_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_nightmareshoext_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_nightmareshoext_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_nightmareshoext_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_nightmareshoext_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_nightmareshoext_hhh","spr_nightmareshoext_hhh_part_1","gfx_nightmareshoext_hhh_part_2"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_nightmareshoext_iii","gfx_nightmareshoext_unmark_iii_zone"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_nightmareshoext_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_nightmareshoext_kkk","spr_nightmareshoext_kkk_part_1","gfx_nightmareshoext_kkk_part_2"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_nightmareshoext_lll"}); 
  ObjAttach("spr_nightmareshoext_panel","int_itempanel_impl")
  ObjSet("spr_nightmareshoext_panel",{pos_x=0,pos_y=0})  
  
  SoundHoTheme( true );
  interface.ItemPanelShow( ho_items );
  if ng_global.progress["ext"]["win_nightmareshoext"].found then
    ObjSet("txt_nightmareshoext_panel",{param0=6-#ng_global.progress["ext"]["win_nightmareshoext"].found})
    if #ng_global.progress["ext"]["win_nightmareshoext"].found>=6 then
      ObjDetach("spr_nightmareshoext_panel")
    end
  end
  for j = 1, #ng_global.progress["ext"]["win_nightmareshoext"].found do

    local task =  ld.StringDivide(ng_global.progress["ext"]["win_nightmareshoext"].found[j]["item"])[3]
   
    ObjDelete( "anm_nightmareshoext_morph_"..task );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.ItemPanelHide();

end;

function public.Close()
  ObjDetach("spr_nightmareshoext_panel")
end

--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show()
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
  ObjDelete("grm_nightmareshoext_abyssext")
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  --  ld.LogTrace( item_name );
  
  local task =  ld.StringDivide(item_name)[3]
  ObjAnimate( "anm_nightmareshoext_morph_"..task, 8, 0, 0, "", {0,0,1, 0.1,0,0} );
  
  local sum = 6 - #ng_global.progress["ext"]["win_nightmareshoext"].found
   
  ObjSet("txt_nightmareshoext_panel",{param0=sum})
  if sum == 0 then
    ld.Lock(1)
    
    ng_global.progress["ext"]["win_nightmareshoext"].state = true
    ObjAnimate( "spr_nightmareshoext_panel", 1, 0, 0, function()ld.Lock(0);cmn.CallEventHandler("nightmareshoext_unmark_morph");end, {0,0,0, 0.5,0,133} );
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_nightmareshoext_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_nightmareshoext_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.clk_monkey()
  local f_end = function()
    ld.Lock(0)
    ObjSet("anm_nightmareshoext_monkey",{playing=1,animfunc="static_monkey"})
  end
  SoundSfx( "aud_ho_nightmareshoext_monkey" )
  ld.Lock(1)
  ld.AnimPlay("anm_nightmareshoext_monkey","idle_click_monkey",f_end)
end
----------------------------------------------------------------------------

function public.unmark_kkk()
  if ApplyObj("spr_nightmareshoext_kkk_part_1","gfx_nightmareshoext_kkk_part_2") then   
    local func_end = function()
      ld.Lock(0)
      ng_global.progress["ext"]["win_nightmareshoext"].start = 1;
      ng_global.progress["ext"]["win_nightmareshoext"].unmark["kkk"].done = 1;
      cmn.CallEventHandler("nightmareshoext_unmark_kkk");
    end  
    ld.Lock(1)
    ObjDelete("spr_nightmareshoext_kkk_part_1")
    ObjDelete("gfx_nightmareshoext_kkk_part_2")
    SoundSfx( "aud_ho_nightmareshoext_coffee" )    
    ld.AnimPlay("anm_nightmareshoext_unmark_kkk","use_amulet",func_end)
  else 
    ObjSet("spr_nightmareshoext_kkk_part_1",{pos_z = 0})
    ObjSet( "spr_nightmareshoext_amulet_tr", {alp = 1} );
  end
end

----------------------------------------------------------------------------

function public.unmark_hhh()
  if ApplyObj("spr_nightmareshoext_hhh_part_1","gfx_nightmareshoext_hhh_part_2") then   
    local func_end = function()
      ld.Lock(0)
      ng_global.progress["ext"]["win_nightmareshoext"].start = 1;
      ng_global.progress["ext"]["win_nightmareshoext"].unmark["hhh"].done = 1;
      cmn.CallEventHandler("nightmareshoext_unmark_hhh");
    end  
    ld.Lock(1)
    ObjDelete("spr_nightmareshoext_hhh_part_1")
    ObjDelete("gfx_nightmareshoext_hhh_part_2")
    SoundSfx( "aud_ho_nightmareshoext_stone" )       
    ld.AnimPlay("anm_nightmareshoext_unmark_hhh","use_stone",func_end)
  else 
    ObjSet("spr_nightmareshoext_hhh_part_1",{pos_z = 0})
  end
end


function public.unmark_iii() 
   local func_end = function()
    ld.Lock(0)
    ng_global.progress["ext"]["win_nightmareshoext"].unmark["iii"].done = 1;
    cmn.CallEventHandler( "nightmareshoext_unmark_iii" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_nightmareshoext_unmark_iii_zone")
  SoundSfx( "aud_ho_nightmareshoext_leaf" )    
  ld.AnimPlay("anm_nightmareshoext_unmark_iii","click_sheet",func_end) 
end