-- name=levelext

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 13 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 11 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 9 );

  interface.WidgetAdd( InterfaceWidget_Effects );



  interface.WidgetAdd( InterfaceWidget_DialogHo,30 );

  interface.ButtonLockAdd();
  interface.LockAdd();



  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel,9 );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,30 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo,30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory,30 );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 30 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial,32 );

  interface.WidgetAdd( InterfaceWidget_Map, 16  );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 15 );

  interface.PanelNotificationAdd(10);

  if IsCollectorsEdition() then
    if true then -- temp for version
      interface.WidgetAdd( InterfaceWidget_StrategyGuide,45 );
      interface.WidgetAdd( InterfaceWidget_BtnGuide, 12 );
    end
  end
  
  --interface.DeployInvAdd(7);
  interface.ComplexInvAdd( 9 )
  interface.DialogHintAdd(20);
  --interface.Btn_DiaryAdd(12)
  --interface.InvestigationButtonAdd( 17 );
  --interface.DiaryAdd( 18 );
  --interface.DiaryDcnAdd( 31 );

  interface.PanelhopairAdd(9)

  interface.ButtonTaskAdd(20)
  interface.DialogTaskAdd(19)

  private.Init();


  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init()

  private.TutorInit()--тутор
  --
  interface.ArrCards()
  interface.ArrPuzzles()

  common.LevelLoad( "levelext", "ext", "rm_housedoctorext", param );
  --ModLoad( "assets/interface/map/mod_map" );



  interface.ArrInvPlus()  -- проверка состояния плюсика для деплойных инв предметов

  interface.KeyUpdate();

  --временно залочена кнопка SG
  interface.WidgetSetInput(InterfaceWidget_BtnGuide, 1)

  ObjSet( "txt_int_dialog_character", {param0 = GetCurrentProfile()} );
  --автоподствновка имени игрока в диалоги

  interface.CheckPuzzles()
  interface.CheckMorphing()
  interface.CheckCards()


end;

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_squareext"
--[[AUTO]]  ,"rm_nearhouseext"
--[[AUTO]]  ,"rm_housedoctorext"

--[[AUTO]]  ,"rm_groveext"
--[[AUTO]]  ,"ho_theatreext"
--[[AUTO]]  ,"rm_laboratoryext"
--[[AUTO]]  ,"rm_cryptext"
--[[AUTO]]  ,"rm_susieroomext"
--[[AUTO]]  ,"ho_gothicext"
--[[AUTO]]  ,"rm_toyworldext"
--[[AUTO]]  ,"mg_demonriddleext"
--[[AUTO]]  ,"rm_abyssext"
--[[AUTO]]  ,"ho_nightmareshoext"
--[[AUTO]]  ,"rm_blackcastleext"
--[[AUTO]]  ,"mg_againstdemonext"
--[[AUTO]]  ,"mg_cryptdoorext"
--[[AUTO]]  ,"mg_heartsext"
  };

  game.progress_names =
  {

--[[AUTO]]  "opn_housedoctorext"
--[[AUTO]]  ,"dlg_housedoctorext_lekarext4"
--[[AUTO]]  ,"get_moonext"
            ,"opn_squareext"  
--[[AUTO]]  ,"opn_nearhouseext"
--[[AUTO]]  ,"get_dictionarydreamsext"
--[[AUTO]]  ,"use_moonext"
--[[AUTO]]  ,"opn_dictionarydreamsext"
--[[AUTO]]  ,"win_dictionarydreamsext"
--[[AUTO]]  ,"get_candleext1"
--[[AUTO]]  ,"get_invitationext"
            ,"clk_dogfigureext"
            ,"clk_dogfigureext2"
--[[AUTO]]  ,"get_dogfigureext"
--[[AUTO]]  ,"get_scarfext"
--[[AUTO]]  ,"use_dogfigureext"
--[[AUTO]]  ,"win_figuresext"
--[[AUTO]]  ,"get_clownkeyext"
--[[AUTO]]  ,"use_scarfext"
--[[AUTO]]  ,"get_pieceglassext"
--[[AUTO]]  ,"use_clownkeyext"
--[[AUTO]]  ,"get_candleext2"
--[[AUTO]]  ,"get_hacksawext"
--[[AUTO]]  ,"use_hacksawext"
            ,"clk_cartexhacksawext"
--[[AUTO]]  ,"get_susiebarretteext"
--[[AUTO]]  ,"get_heartext1"
--[[AUTO]]  ,"use_susiebarretteext"
--[[AUTO]]  ,"get_catpawext"
--[[AUTO]]  ,"use_pieceglassext"
--[[AUTO]]  ,"get_tapeext"
--[[AUTO]]  ,"get_susiebagext"
--[[AUTO]]  ,"use_catpawext"
--[[AUTO]]  ,"get_heartext2"
--[[AUTO]]  ,"get_hookext"
--[[AUTO]]  ,"use_heartext1"
--[[AUTO]]  ,"use_heartext2"
--[[AUTO]]  ,"win_heartsext"
--[[AUTO]]  ,"opn_groveext"
--[[AUTO]]  ,"clk_animspiritext1"
--[[AUTO]]  ,"get_candleext3"
--[[AUTO]]  ,"use_hookext"
--[[AUTO]]  ,"get_combext"
--[[AUTO]]  ,"get_appleext"
--[[AUTO]]  ,"use_combext"
--[[AUTO]]  ,"get_childrencoinext"
--[[AUTO]]  ,"get_colorpyramidext"
--[[AUTO]]  ,"use_appleext"
--[[AUTO]]  ,"get_scoopnetext"
--[[AUTO]]  ,"use_scoopnetext"
--[[AUTO]]  ,"get_candleext4"
--[[AUTO]]  ,"use_childrencoinext"
--[[AUTO]]  ,"get_hamsaext"
--[[AUTO]]  ,"get_springext"
--[[AUTO]]  ,"use_hamsaext"
--[[AUTO]]  ,"opn_theatreext"
--[[AUTO]]  ,"win_theatreext"
--[[AUTO]]  ,"use_colorpyramidext"
--[[AUTO]]  ,"get_barnkeyext"
--[[AUTO]]  ,"use_barnkeyext"
            ,"clk_barnkeyext1"
            ,"clk_barnkeyext2"
            ,"clk_barnkeyext3"
--[[AUTO]]  ,"get_widebulbext"
--[[AUTO]]  ,"get_medicalcrossext"
--[[AUTO]]  ,"use_widebulbext"
--[[AUTO]]  ,"win_laboratoryext"
--[[AUTO]]  ,"opn_laboratoryext"
--[[AUTO]]  ,"get_ritualbookext"
--[[AUTO]]  ,"use_medicalcrossext"
--[[AUTO]]  ,"get_medicalclampext"
--[[AUTO]]  ,"use_medicalclampext_potsext"
--[[AUTO]]  ,"get_bowext1"
--[[AUTO]]  ,"get_screwdriverext"
--[[AUTO]]  ,"use_tapeext"
--[[AUTO]]  ,"get_bouquetext"
--[[AUTO]]  ,"clk_brokenbouquetext"
--[[AUTO]]  ,"use_bouquetext"
--[[AUTO]]  ,"get_clockext"
--[[AUTO]]  ,"use_medicalclampext_armchairext"
--[[AUTO]]  ,"get_clockbuttonext"
--[[AUTO]]  ,"clk_oldspringext"
--[[AUTO]]  ,"use_springext"
--[[AUTO]]  ,"use_clockbuttonext"
            ,"clk_oldspringext2"
--[[AUTO]]  ,"get_amuletletterext"
--[[AUTO]]  ,"use_screwdriverext"
--[[AUTO]]  ,"get_iconext"
--[[AUTO]]  ,"use_iconext"
--[[AUTO]]  ,"get_puppetext"
--[[AUTO]]  ,"use_puppetext"
--[[AUTO]]  ,"win_puppetsext"
--[[AUTO]]  ,"get_skullext1"
--[[AUTO]]  ,"use_amuletletterext"
--[[AUTO]]  ,"get_skullext2"
--[[AUTO]]  ,"use_skullext1"
--[[AUTO]]  ,"use_skullext2"
--[[AUTO]]  ,"win_cryptdoorext"
--[[AUTO]]  ,"opn_cryptext"
--[[AUTO]]  ,"clk_animspiritext2"
--[[AUTO]]  ,"clk_animlivesusieext"
--[[AUTO]]  ,"get_bowext2"
--[[AUTO]]  ,"get_partpuzzleext"
--[[AUTO]]  ,"get_boneext"
--[[AUTO]]  ,"use_partpuzzleext"
--[[AUTO]]  ,"get_sunamuletext"
--[[AUTO]]  ,"use_sunamuletext"
--[[AUTO]]  ,"get_silverspoonext"
--[[AUTO]]  ,"use_silverspoonext"
--[[AUTO]]  ,"get_candleext5"
--[[AUTO]]  ,"get_limestoneext"
--[[AUTO]]  ,"use_boneext"
--[[AUTO]]  ,"get_sprayext"
--[[AUTO]]  ,"use_sprayext"
--[[AUTO]]  ,"get_pickext"
--[[AUTO]]  ,"use_pickext"
--[[AUTO]]  ,"get_diamondext"
--[[AUTO]]  ,"use_diamondext"
--[[AUTO]]  ,"get_candleext6"
--[[AUTO]]  ,"use_candleext"
--[[AUTO]]  ,"get_lightedcandlesext"
--[[AUTO]]  ,"use_ritualrecipeext"
--[[AUTO]]  ,"use_limestoneext"
--[[AUTO]]  ,"use_lightedcandlesext"
--[[AUTO]]  ,"use_ritualbookext"
--[[AUTO]]  ,"use_magicdustext"
--[[AUTO]]  ,"win_mysterycircleext"
--[[AUTO]]  ,"clk_animritualext"
            ,"clk_demoncardext"
--[[AUTO]]  ,"get_demoncardext"
--[[AUTO]]  ,"use_demoncardext"
--[[AUTO]]  ,"dlg_cryptext_lekarext5"
--[[AUTO]]  ,"get_susiekeyext"
--[[AUTO]]  ,"use_susiekeyext"
--[[AUTO]]  ,"opn_susieroomext"
--[[AUTO]]  ,"clk_animspiritext3"
--[[AUTO]]  ,"get_bowext3"
--[[AUTO]]  ,"get_foxfigureext"
--[[AUTO]]  ,"use_bowext"
            ,"clk_susiebagextbowext1"
            ,"clk_susiebagextbowext2"
--[[AUTO]]  ,"get_harpext"
--[[AUTO]]  ,"use_harpext"
--[[AUTO]]  ,"opn_gothicext"
--[[AUTO]]  ,"win_gothicext"
--[[AUTO]]  ,"get_commodehandleext"
--[[AUTO]]  ,"use_commodehandleext"
--[[AUTO]]  ,"get_lotusext1"
--[[AUTO]]  ,"get_spannerext"
--[[AUTO]]  ,"use_foxfigureext"
--[[AUTO]]  ,"get_starext"
--[[AUTO]]  ,"get_childrenrivetext"
--[[AUTO]]  ,"use_spannerext_tableext"
--[[AUTO]]  ,"get_wandext"
--[[AUTO]]  ,"use_childrenrivetext"
--[[AUTO]]  ,"get_amuletflameext"
--[[AUTO]]  ,"use_amuletflameext"
--[[AUTO]]  ,"get_lotusext2"
--[[AUTO]]  ,"use_spannerext_armchairext"
--[[AUTO]]  ,"get_littlestarext"
--[[AUTO]]  ,"use_wandext"
--[[AUTO]]  ,"use_littlestarext"
--[[AUTO]]  ,"get_magicwandext"
--[[AUTO]]  ,"use_magicwandext"
--[[AUTO]]  ,"get_maskext"
--[[AUTO]]  ,"use_maskext"
--[[AUTO]]  ,"get_scissorsext"
--[[AUTO]]  ,"use_scissorsext"
--[[AUTO]]  ,"get_lotusext3"
            ,"clk_lotusext"
--[[AUTO]]  ,"use_lotusext"
--[[AUTO]]  ,"get_wreathext"
--[[AUTO]]  ,"use_wreathext"
--[[AUTO]] -- ,"win_susiedreamsext"
--[[AUTO]]  --,"opn_toyworldext"
--[[AUTO]]  ,"clk_demonattackext"
--[[AUTO]]  ,"dlg_cryptext_lekarext6"
--[[AUTO]]  ,"win_demonriddleext"
--[[AUTO]]  ,"get_demonsignext"
--[[AUTO]]  ,"opn_toyworldext"
--[[AUTO]]  ,"get_lassoext"
--[[AUTO]]  ,"use_lassoext"
--[[AUTO]]  ,"get_hugekeyext"
--[[AUTO]]  ,"use_hugekeyext"
--[[AUTO]]  ,"get_coverext"
--[[AUTO]]  ,"get_nibblerext"
--[[AUTO]]  ,"use_coverext"
--[[AUTO]]  ,"opn_abyssext"
--[[AUTO]]  ,"dlg_abyssext_benedictusext"
--[[AUTO]]  ,"get_blueghostext"
--[[AUTO]]  ,"use_lassoext_hollowex"
--[[AUTO]]  ,"get_catinhatext"
            ,"clk_featherext1"
--[[AUTO]]  ,"get_featherext1"
            ,"clk_hatext"
--[[AUTO]]  ,"get_hatext"
            ,"clk_medallionbearsext"
--[[AUTO]]  ,"get_medallionbearsext"
--[[AUTO]]  ,"use_hatext"
--[[AUTO]]  ,"get_whiteghostext"
--[[AUTO]]  ,"use_medallionbearsext"
--[[AUTO]]  ,"get_pepperext"
--[[AUTO]]  ,"use_pepperext"
--[[AUTO]]  ,"get_purpleghostext"
--[[AUTO]]  ,"use_blueghostext"
--[[AUTO]]  ,"use_whiteghostext"
--[[AUTO]]  ,"use_purpleghostext"
--[[AUTO]]  ,"win_nightmaresext"
--[[AUTO]]  ,"opn_nightmareshoext"
--[[AUTO]]  ,"win_nightmareshoext"
--[[AUTO]]  ,"use_featherext1"
--[[AUTO]]  ,"use_featherext2"
            ,"win_feathersext"
--[[AUTO]]  ,"clk_animpathext"
--[[AUTO]]  ,"get_blackpowderext"
--[[AUTO]]  ,"get_stoneext"
--[[AUTO]]  ,"use_blackpowderext"
--[[AUTO]]  ,"get_magicalfruitext"
--[[AUTO]]  ,"get_bigleafext"
--[[AUTO]]  ,"use_magicalfruitext"
--[[AUTO]]  ,"get_toothext1"
--[[AUTO]]  ,"use_stoneext"
--[[AUTO]]  ,"get_wolfeyesext"
--[[AUTO]]  ,"use_wolfeyesext"
--[[AUTO]]  ,"get_shovelext"
--[[AUTO]]  ,"use_shovelext_fenechext"
--[[AUTO]]  ,"get_forcepsext"
--[[AUTO]]  ,"use_forcepsext"
--[[AUTO]]  ,"get_toothext2"
--[[AUTO]]  ,"use_toothext1"
--[[AUTO]]  ,"use_toothext2"
--[[AUTO]]  ,"use_demonsignext_castleentranceext"

--[[AUTO]]  ,"opn_blackcastleext"
--[[AUTO]]  ,"get_greenbeansext"
--[[AUTO]]  ,"use_bigleafext"
--[[AUTO]]  ,"get_waterleafext"
--[[AUTO]]  ,"get_leverext"
--[[AUTO]]  ,"use_shovelext_tothroneext"
--[[AUTO]]  ,"use_greenbeansext"
--[[AUTO]]  ,"use_waterleafext"
--[[AUTO]]  ,"get_cellkeyext"
--[[AUTO]]  ,"use_leverext"
--[[AUTO]]  ,"get_mittenext"
--[[AUTO]]  ,"get_soldieremblemext"
--[[AUTO]]  ,"use_soldieremblemext"
--[[AUTO]]  ,"get_toyswordext"
--[[AUTO]]  ,"use_mittenext"
--[[AUTO]]  ,"get_icetridentext"
--[[AUTO]]  ,"use_icetridentext"
--[[AUTO]]  ,"use_toyswordext"
--[[AUTO]]  ,"use_cellkeyext"
--[[AUTO]]  ,"dlg_blackcastleext_susieext1"
--[[AUTO]]  ,"get_pipeext"
--[[AUTO]]  ,"use_pipeext"
--[[AUTO]]  ,"get_demoncasketext"
--[[AUTO]]  ,"use_demonsignext_demoncasketext"
--[[AUTO]]  ,"get_pendantsusieext"
            ,"clk_animappearanceext"
--[[AUTO]]  ,"use_pendantsusieext"

--[[AUTO]]  ,"win_againstdemonext"
--[[AUTO]]  ,"dlg_blackcastleext_susieext2"
--[[AUTO]]  ,"clk_outroext"


  };


  game.relations = {};

  game.level_tasks_ext = {  
  --[[1]] "dlg_housedoctorext_lekarext4",
  --[[2]] "win_dictionarydreamsext",
  --[[2]] "clk_animritualext",  
  --[[4]] "dlg_cryptext_lekarext5",  
  --[[5]] "dlg_cryptext_lekarext6",    
  --[[6]] "opn_blackcastleext",   
  --[[7]] "dlg_blackcastleext_susieext1",    
  --[[8]] "clk_animappearanceext",      
};


end;

function private.TutorInit()
end;  
  
  
  
  
  
  