-- name=levelext_inv
function public.ProcessGetLotusextAll( prg )
  local inv = "inv_lotusext"
  local prg_all = {"get_lotusext1","get_lotusext2","get_lotusext3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
  interface.CheckInvPlus()   
end
function public.ProcessGetBowextAll( prg )
  local inv = "inv_bowext"
  local prg_all = {"get_bowext1","get_bowext2","get_bowext3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
  interface.CheckInvPlus()   
end
function public.ProcessGetCandleextAll( prg )
  local inv = "inv_candleext"
  local prg_all = {"get_candleext1","get_candleext2","get_candleext3","get_candleext4","get_candleext5","get_candleext6"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
  else
    ObjSet( inv, { drag = 0 } );
  end  
  interface.CheckInvPlus()   
end
-- name=levelext_inv

function public.ProcessGetBallAll( prg )
  local inv = "inv_ball"
  local prg_all = {"get_ball1","get_ball2","get_ball3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  
  if public.ProcessDragChecker( inv, prg, prg_all ) then 
    ObjSet( inv, { drag = 1, event_mdown = "" } );
   
  else
    ObjSet( inv, { drag = 0 } );
  end  
  interface.CheckInvPlus() 
end


-->>constant Объекты не удаляемые из инвентаря

--common_impl.hint[ "use_wanderersign_constant" ] = { type = "use", inv_obj = "inv_wanderersign" };

--<<constant


public.use_add = {
  ["obj_simon_cursor_drag"]  = {     --Саймон
    { "gfx_tree_elfclimber_zone", private.elf_tree_elfclimber};
  },
  ["inv_cellkeyext"]  = {     
    { "gfx_cellext_icetridentext_zone", "cellextkey_before_ice"};};
 -- ["inv_cellkeyext"]  = {     
   --  { "gfx_cellext_toyswordext_zone","cellextkey_before_ice"};};


}
ld.InvSetDropable         = int_inventory.InvSetDropable;   --ObjDoNotDrop для инв. предметов

function public.ProcessDragChecker( inv, prg, prg_all )
  if ( int_inventory.InventoryItemAddFly[inv] and int_inventory.InventoryItemAddFly[inv] == 0 and ( ld.CheckRequirements( prg_all, 1 ) == ( #prg_all - ( ld.CheckRequirements( { prg } ) and 0 or 1 ) ) ) )
  or ( not int_inventory.InventoryItemAddFly[inv] and ld.CheckRequirements( prg_all ) ) then 
    return true
  else
    return false
  end 
end;

function public.ProcessUseChecker( inv, prg, prg_all )
  if ( ld.CheckRequirements( prg_all, 1 ) == ( #prg_all - ( ld.CheckRequirements( { prg } ) and 0 or 1 ) ) )
  then 
    return true
  else
    return false
  end 
end;


--*********************************************************************************************************************
--public.chainedgolem_onmouse_enter = function()
--  if ObjGet( "int_popup" ).visible==false then
--    interface.PopupShow("pop_inv_chainedgolem");
--  end
--  if not ObjGet("tmr_inv_chainedgolem_vid") then  
--    VidPlay("inv_chainedgolem","")
--    ld.StartTimer("tmr_inv_chainedgolem_vid", math.random(2,4),  public.chainedgolem_onmouse_enter );
--  end
--end
--
--
--public.chainedgolem_mouse_leave = function()
--  if ObjGet("tmr_inv_chainedgolem_vid") then  
--    ObjDelete("tmr_inv_chainedgolem_vid")
--  end
--
--  VidStop("inv_chainedgolem")
--  interface.PopupHide()
--end
--
--public.chainedgolem_startdrag = function()
--  if ObjGet("tmr_inv_chainedgolem_vid") then  
--    ObjDelete("tmr_inv_chainedgolem_vid")
--  end
--  
--  if not ObjGet("tmr_inv_chainedgolem_vid") then
--    VidPlay("inv_chainedgolem","")
--    ld.StartTimer("tmr_inv_chainedgolem_vid", math.random(2,4),  public.chainedgolem_startdrag );
--  end
--end
----**************


function public.Init()
  
  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
  
--ld.NoteInit("spr_medecinechest_text", "spr_medecinechest_text_big","medecinechest_text")

--*********************************************************************************************************************
--*********************************************************************************************************************
--ПЕРЕОПРЕДЕЛЕНИЕ ССЫЛКИ НА ИНВЕНТАРЬ
  level_inv = levelext_inv
--*********************************************************************************************************************
--*********************************************************************************************************************


--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_dictionarydreamsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_moonext" ] = { type = "use", inv_obj = "inv_moonext", use_place = "gfx_dictionarydreamsext_moonext_zone", room = "inv_complex_inv", zz = "inv_complex_dictionarydreamsext", zz_gate = "inv_dictionarydreamsext" };

private.use_moonext_logic = function()

end;
private.use_moonext_inv = function()
  common_impl.ProcessMultiUseAll("moonext", "moonext")
end;
private.use_moonext_beg = function()
  ObjDelete( "gfx_dictionarydreamsext_moonext_zone" );
end;
private.use_moonext_end = function()
  ObjAttach("obj_dictionarydreamsextho_root","inv_complex_dictionarydreamsext")
  ObjSet( "obj_dictionarydreamsextho_root", {input = 1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_moonext", private.use_moonext_inv );
cmn.AddSubscriber( "use_moonext", private.use_moonext_beg );
cmn.AddSubscriber( "use_moonext", private.use_moonext_end );
cmn.AddSubscriber( "use_moonext", private.use_moonext_logic );
cmn.AddSubscriber( "use_moonext_inv", private.use_moonext_inv );
cmn.AddSubscriber( "use_moonext_beg", private.use_moonext_beg );
cmn.AddSubscriber( "use_moonext_end", private.use_moonext_end );
cmn.AddSubscriber( "use_moonext_end", private.use_moonext_logic );
--------------------------------------------------------------------------------------------
function public.use_moonext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_moonext" );
    cmn.CallEventHandler( "use_moonext_end" );
private.start_dictionarydreamsext()    
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_moonext_inv" );
  cmn.CallEventHandler( "use_moonext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_moonext_dictionarydreamsext" )
  
  ld.AnimPlay( "anm_dictionarydreamsext_moon", "use_moon", func_end );


end;
--------------------------------------------------------------------------------------------
function private.start_dictionarydreamsext()
if ( not cmn.IsEventDone( "opn_dictionarydreamsext" ) ) then

    cmn.InitHo( "dictionarydreamsext" );

    cmn.SetEventDone( "opn_dictionarydreamsext" );
    ng_global.progress[ "ext" ][ "win_dictionarydreamsext" ].state = {}
    ng_global.progress[ "ext" ][ "win_dictionarydreamsext" ].state.page=1
    ObjDelete("anm_dictionarydreamsext_moon")
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "bbb",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "ccc",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "ddd",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "eee",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "fff",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "ggg",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "hhh",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "iii",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "jjj",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "kkk",false,"dictionarydreamsext" );
  interface.ItemPanelItemAdd( ho_items, "lll",false,"dictionarydreamsext" );

  interface.ItemPanelShow( ho_items,"dictionarydreamsext" );
  
  
  public.dictionarydreamsext_LoadPage()
--  SoundHoTheme( true );
--  interface.TaskPanelShow( ho_items,"dictionarydreamsext" );
--
  local ho_found = ng_global.progress[ "ext" ][ "win_dictionarydreamsext" ].found;

  for i = 1, #ho_found, 1 do
    local obj_name = tostring( ng_global.progress["ext"]["win_dictionarydreamsext"].found[i]["object"] )
    ObjDelete(obj_name)
    task=ld.StringDivide(obj_name)[3]
    ObjSet("anm_dictionarydreamsext_use_"..task,{frame=999})
  end;    
end
------------------------------------------------------------------------------------------------
common_impl.hint[ "win_dictionarydreamsext" ] = { type = "click", room = "inv_complex_inv", zz = "inv_complex_dictionarydreamsext", zz_gate = "inv_dictionarydreamsext", use_place = "obj_dictionarydreamsextho_root" };

local win_dictionarydreamsext_func = function ()

  if ( cmn.IsEventDone( "win_dictionarydreamsext" ) ) then
    interface.InventoryItemAdd( "inv_ritualrecipeext", "spr_dictionarydreamsext_win" );
    if common_impl.ZzCompleteCheck("win_dictionarydreamsext") then interface.InventoryItemRemove("inv_dictionarydreamsext") end;
  end;

end;
cmn.AddSubscriber( "win_dictionarydreamsext", win_dictionarydreamsext_func );

local start_dictionarydreamsext_func = function ()
  ObjDelete("anm_dictionarydreamsext_moon")
  if not cmn.IsEventDone("win_dictionarydreamsext") then
    common_impl.ProcessHoStart( "dictionarydreamsext" );
  end
end;
cmn.AddSubscriber( "win_dictionarydreamsext", start_dictionarydreamsext_func );  


function public.dictionarydreamsext_preopen()
  --SoundEnv( "aud_housedoctorext_env" )
  if cmn.IsEventDone("use_moonext") then
    private.start_dictionarydreamsext()
  end
  
end
function public.dictionarydreamsext_open()
  
end
function public.dictionarydreamsext_preclose()
  if cmn.IsEventDone("use_moonext") then  
    interface.ItemPanelHide();
  end
end
function public.dictionarydreamsext_close()
  if cmn.IsEventDone( "win_dictionarydreamsext" ) then
    int_button_task.Update_FromSetEventDone ( "win_dictionarydreamsext" )
    SoundTheme( "aud_adventure1_mus" ); 
  end
end

function public.dictionarydreamsext_ItemFound( item_name,item_object_name )
  
    local sfx_arr = {
      aaa = "aud_dictionarydreamsext_tree"     ,
      bbb = "aud_dictionarydreamsext_stars"    ,
      ccc = "aud_dictionarydreamsext_cloud"    ,
      ddd = "aud_dictionarydreamsext_house"    ,
      eee = "aud_dictionarydreamsext_column"   ,
      fff = "aud_dictionarydreamsext_basrelief",
      ggg = "aud_dictionarydreamsext_wing"     ,
      hhh = "aud_dictionarydreamsext_vase"     ,
      iii = "aud_dictionarydreamsext_griffin"  ,
      jjj = "aud_dictionarydreamsext_bat"      ,
      kkk = "aud_dictionarydreamsext_arms"     ,
      lll = "aud_dictionarydreamsext_cloak"    ,
    }
    local item_object_name = "obj_"..common.GetObjectName( item_name );
    local task = ld.StringDivide(common.GetObjectName( item_name ))[2]
    local parent = ObjGetRelations( item_object_name ).parent
    if common_impl.ObjIntersectCheck(item_name, item_object_name) and  ObjGet(parent).input then
    local f_end = function()
      ld.Lock(0);
      interface.ItemPanelTryToComplete();
    end    
    
    ng_global.progress[ "ext" ][ "win_dictionarydreamsext"].start = 1;  
    local item_found = { item = item_name, object = item_object_name };
    table.insert( ng_global.progress[ "ext" ][ "win_dictionarydreamsext" ].found, item_found );
    
    ObjDelete( item_object_name );
    interface.ItemPanelItemRemove( item_name,"dictionarydreamsext" );
    interface_impl.CountTaskHoAchievement();
    ld.Lock(1);
    SoundSfx( sfx_arr[task] )
    ld.AnimPlay("anm_dictionarydreamsext_use_"..task,"use_"..task,f_end)
  end
end;
function public.dictionarydreamsext_HoComplete(  )
  
  
end


function public.dictionarydreamsext_NextPage( inc )
  SoundSfx( "aud_dictionarydreamsext_page" )
  local max_count = 3
  local new_num;
  local cur_page = ng_global.progress[ "ext" ][ "win_dictionarydreamsext" ].state.page
  if cur_page == max_count and inc == 1 then
    new_num = 1;
  elseif cur_page == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = cur_page + inc;
  end;

  local name     = "spr_dictionarydreamsextho_back_";
  local tme      = 0.3;

  ld.Lock(1)
  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjAnimate( name..cur_page, "alp", 0, 0, function()ld.Lock(0);public.dictionarydreamsext_LoadPage()end, { 0,0,1, tme,0,0 } );
    
  ng_global.progress[ "ext" ][ "win_dictionarydreamsext" ].state.page = new_num;
  
end

function public.dictionarydreamsext_LoadPage()
  local cur_page = ng_global.progress[ "ext" ][ "win_dictionarydreamsext" ].state.page
  for i=1,3 do 
    ObjSet( "spr_dictionarydreamsextho_back_"..i, {alp = 0,input=0} );
    for j=1,#ObjGetRelations( "spr_dictionarydreamsextho_back_"..i ).childs do
      if ld.StringDivide( ObjGetRelations( "spr_dictionarydreamsextho_back_"..i ).childs[j])[1] == "obj" then
        ObjSet(ObjGetRelations( "spr_dictionarydreamsextho_back_"..i ).childs[j],{input=0})
      end
    end
  end
  ObjSet( "spr_dictionarydreamsextho_back_"..cur_page, {alp = 1,input=1} );
  for a=1,#ObjGetRelations( "spr_dictionarydreamsextho_back_"..cur_page ).childs do
    if ld.StringDivide( ObjGetRelations( "spr_dictionarydreamsextho_back_"..cur_page ).childs[a])[1] == "obj" then
      ObjSet(ObjGetRelations( "spr_dictionarydreamsextho_back_"..cur_page ).childs[a],{input=1})
    end
  end  
  
end

function public.dictionarydreamsext_ShowHint()
  local hints = {"spr_dictionarydreamsextho_arrow_left","spr_dictionarydreamsextho_arrow_right"}
    local hints_table = { hint = {} };

  for i=1,#hints do 
     local sceneobj = hints[i];
     local sceneobj_pos = GetObjPosByObj( sceneobj );
     if ObjGet(sceneobj) and ObjGet(sceneobj).input then
         table.insert( hints_table.hint,{ pos_x = sceneobj_pos[ 1 ], pos_y = sceneobj_pos[ 2 ], obj_name = sceneobj } );
     end
  end
  MsgSend( Command_Effect_ShowHoHint, hints_table );
end

function public.dictionarydreamsext_Skip()
  
  cmn.SetEventDone( "win_dictionarydreamsext" )
  cmn.CallEventHandler( "win_dictionarydreamsext" );   
  common_impl.HideComplexItem()    
end
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_invitationext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "clk_dogfigureext" ] = { type = "click", use_place = "gfx_invitationext_clk_dogfigureext", room = "inv_complex_inv", zz = "inv_complex_invitationext", zz_gate = "inv_invitationext"  };

private.clk_dogfigureext_logic = function()
  ObjSet("gfx_invitationext_clk_dogfigureext2",{active=1, input=1, visible=1});
end;
private.clk_dogfigureext_beg = function()
  ObjDelete( "gfx_invitationext_clk_dogfigureext" );
end;
private.clk_dogfigureext_end = function()
  ObjSet( "anm_invitationext_anm", {animfunc = "cleek", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_dogfigureext", private.clk_dogfigureext_beg );
cmn.AddSubscriber( "clk_dogfigureext", private.clk_dogfigureext_end );
cmn.AddSubscriber( "clk_dogfigureext", private.clk_dogfigureext_logic );
cmn.AddSubscriber( "clk_dogfigureext_beg", private.clk_dogfigureext_beg );
cmn.AddSubscriber( "clk_dogfigureext_end", private.clk_dogfigureext_end );
cmn.AddSubscriber( "clk_dogfigureext_end", private.clk_dogfigureext_logic );
--------------------------------------------------------------------------------------------
function public.clk_dogfigureext()  -- level_inv.clk_dogfigureext()

  local func_end = function()
    cmn.SetEventDone( "clk_dogfigureext" );
    cmn.CallEventHandler( "clk_dogfigureext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_dogfigureext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_invitationext_anm", "cleek", func_end );
  SoundSfx( "aud_touch_invitationext_1" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_dogfigureext2" ] = { type = "click", use_place = "gfx_invitationext_clk_dogfigureext2", room = "inv_complex_inv", zz = "inv_complex_invitationext", zz_gate = "inv_invitationext"  };

private.clk_dogfigureext2_logic = function()
  ObjSet("spr_invitationext_dogfigureext",{active=1, input=1, visible=1});
end;
private.clk_dogfigureext2_beg = function()
  ObjDelete( "gfx_invitationext_clk_dogfigureext2" );
end;
private.clk_dogfigureext2_end = function()
  ObjSet( "anm_invitationext_anm", {animfunc = "end", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_dogfigureext2", private.clk_dogfigureext2_beg );
cmn.AddSubscriber( "clk_dogfigureext2", private.clk_dogfigureext2_end );
cmn.AddSubscriber( "clk_dogfigureext2", private.clk_dogfigureext2_logic );
cmn.AddSubscriber( "clk_dogfigureext2_beg", private.clk_dogfigureext2_beg );
cmn.AddSubscriber( "clk_dogfigureext2_end", private.clk_dogfigureext2_end );
cmn.AddSubscriber( "clk_dogfigureext2_end", private.clk_dogfigureext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_dogfigureext2() ---- level_inv.clk_dogfigureext2()

  local func_end = function()
    cmn.SetEventDone( "clk_dogfigureext2" );
    cmn.CallEventHandler( "clk_dogfigureext2_end" );
    common_impl.Lock(0);
    public.get_dogfigureext();
  end;

  cmn.CallEventHandler( "clk_dogfigureext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_invitationext_anm", "cleek1", func_end );
  SoundSfx( "aud_touch_invitationext_2" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "get_dogfigureext" ] = { type = "get", get_obj = "spr_invitationext_dogfigureext", room = "inv_complex_inv", zz = "inv_complex_invitationext", zz_gate = "inv_invitationext" };

private.get_dogfigureext_logic = function()
 
end;
private.get_dogfigureext_inv = function()
  interface.InventoryItemAdd("inv_dogfigureext","spr_invitationext_dogfigureext");
  if common_impl.ZzCompleteCheck("get_dogfigureext") then interface.InventoryItemRemove("inv_invitationext") end;
end;
private.get_dogfigureext_beg = function()
  ObjDelete("gfx_invitationext_dogfigureext");
end;
private.get_dogfigureext_end = function()
  
end;

cmn.AddSubscriber( "get_dogfigureext", private.get_dogfigureext_inv );
cmn.AddSubscriber( "get_dogfigureext", private.get_dogfigureext_beg );
cmn.AddSubscriber( "get_dogfigureext", private.get_dogfigureext_end );
cmn.AddSubscriber( "get_dogfigureext", private.get_dogfigureext_logic );
--------------------------------------------------------------------
function public.get_dogfigureext()
  cmn.SetEventDone( "get_dogfigureext" );
  cmn.CallEventHandler( "get_dogfigureext" );
  if common_impl.ZzCompleteCheck("get_dogfigureext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_clockext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_oldspringext" ] = { type = "click", use_place = "gfx_clockext_clk_oldspringext_zone", room = "inv_complex_inv", zz = "inv_complex_clockext", zz_gate = "inv_clockext" };

private.clk_oldspringext_logic = function()
  ObjSet( "gfx_clockext_springext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_oldspringext_beg = function()
  ObjDelete( "gfx_clockext_clk_oldspringext_zone" );
end;
private.clk_oldspringext_end = function()
  ObjSet( "anm_clockext_anm", {animfunc = "use_button", frame = 999 } );
  ObjDelete("inv_clockext_back");
  ObjSet( "inv_clockext_state_4", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_oldspringext", private.clk_oldspringext_beg );
cmn.AddSubscriber( "clk_oldspringext", private.clk_oldspringext_end );
cmn.AddSubscriber( "clk_oldspringext", private.clk_oldspringext_logic );
cmn.AddSubscriber( "clk_oldspringext_beg", private.clk_oldspringext_beg );
cmn.AddSubscriber( "clk_oldspringext_end", private.clk_oldspringext_end );
cmn.AddSubscriber( "clk_oldspringext_end", private.clk_oldspringext_logic );
--------------------------------------------------------------------------------------------
function public.clk_oldspringext()

  local func_end = function()
    cmn.SetEventDone( "clk_oldspringext" );
    cmn.CallEventHandler( "clk_oldspringext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_oldspringext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_clockext_anm", "use_button", func_end );
  SoundSfx( "aud_clk_oldspringext_clockext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_springext_zone_clk()  --levelext_inv.use_springext_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_springext' );
  end
  SoundSfx( "aud_touch_very_small_metal" )
  ld.Lock(1);
  ld.AnimPlay( "anm_clockext_anm", "idle", func_end ); 
end;  


common_impl.hint[ "use_springext" ] = { type = "use", inv_obj = "inv_springext", use_place = "gfx_clockext_springext_zone", room = "inv_complex_inv", zz = "inv_complex_clockext", zz_gate = "inv_clockext" };

private.use_springext_logic = function()
  ObjSet( "gfx_clockext_clockbuttonext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_springext_inv = function()
  common_impl.ProcessMultiUseAll("springext", "springext")
end;
private.use_springext_beg = function()
  ObjDelete( "gfx_clockext_springext_zone" );
end;
private.use_springext_end = function()
  ObjSet( "anm_clockext_anm", {animfunc = "use_spring", frame = 999 } );
  ObjDelete("inv_clockext_state_4");
  ObjSet( "inv_clockext_state_2", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_springext", private.use_springext_inv );
cmn.AddSubscriber( "use_springext", private.use_springext_beg );
cmn.AddSubscriber( "use_springext", private.use_springext_end );
cmn.AddSubscriber( "use_springext", private.use_springext_logic );
cmn.AddSubscriber( "use_springext_inv", private.use_springext_inv );
cmn.AddSubscriber( "use_springext_beg", private.use_springext_beg );
cmn.AddSubscriber( "use_springext_end", private.use_springext_end );
cmn.AddSubscriber( "use_springext_end", private.use_springext_logic );
--------------------------------------------------------------------------------------------
function public.use_springext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_springext" );
    cmn.CallEventHandler( "use_springext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_springext_inv" );
  cmn.CallEventHandler( "use_springext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_springext_clockext" )
  
  ld.AnimPlay( "anm_clockext_anm", "use_spring", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_clockbuttonext" ] = { type = "use", inv_obj = "inv_clockbuttonext", use_place = "gfx_clockext_clockbuttonext_zone", room = "inv_complex_inv", zz = "inv_complex_clockext", zz_gate = "inv_clockext" };

private.use_clockbuttonext_logic = function()
  ObjSet( "gfx_clockext_clk_oldspringext2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_clockbuttonext_inv = function()
  common_impl.ProcessMultiUseAll("clockbuttonext", "clockbuttonext")
end;
private.use_clockbuttonext_beg = function()
  ObjDelete( "gfx_clockext_clockbuttonext_zone" );
end;
private.use_clockbuttonext_end = function()
  ObjSet( "anm_clockext_anm", {animfunc = "use_spring1", frame = 999 } );
  ObjDelete("inv_clockext_state_2");
  ObjSet( "inv_clockext_state_1", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_clockbuttonext", private.use_clockbuttonext_inv );
cmn.AddSubscriber( "use_clockbuttonext", private.use_clockbuttonext_beg );
cmn.AddSubscriber( "use_clockbuttonext", private.use_clockbuttonext_end );
cmn.AddSubscriber( "use_clockbuttonext", private.use_clockbuttonext_logic );
cmn.AddSubscriber( "use_clockbuttonext_inv", private.use_clockbuttonext_inv );
cmn.AddSubscriber( "use_clockbuttonext_beg", private.use_clockbuttonext_beg );
cmn.AddSubscriber( "use_clockbuttonext_end", private.use_clockbuttonext_end );
cmn.AddSubscriber( "use_clockbuttonext_end", private.use_clockbuttonext_logic );
--------------------------------------------------------------------------------------------
function public.use_clockbuttonext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_clockbuttonext" );
    cmn.CallEventHandler( "use_clockbuttonext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_clockbuttonext_inv" );
  cmn.CallEventHandler( "use_clockbuttonext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_clockbuttonext_clockext" )
  
  ld.AnimPlay( "anm_clockext_anm", "use_spring1", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_oldspringext2" ] = { type = "click", use_place = "gfx_clockext_clk_oldspringext2_zone", room = "inv_complex_inv", zz = "inv_complex_clockext", zz_gate = "inv_clockext" };

private.clk_oldspringext2_logic = function()
   ObjSet( "spr_clockext_amuletletterext", { visible = 1, input = 1, active = 1 } )

end;
private.clk_oldspringext2_beg = function()
  ObjDelete( "gfx_clockext_clk_oldspringext2_zone" );
end;
private.clk_oldspringext2_end = function()
  ObjSet( "anm_clockext_anm", {animfunc = "end_open", frame = 0 } );
  ObjDelete("inv_clockext_state_1");
  ObjSet( "inv_clockext_state_3", {alp=1} );
  ObjSet( "spr_clockext_sh_amuletletterext", {visible = 1} );
  ObjSet( "inv_clockext_state_5", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_oldspringext2", private.clk_oldspringext2_beg );
cmn.AddSubscriber( "clk_oldspringext2", private.clk_oldspringext2_end );
cmn.AddSubscriber( "clk_oldspringext2", private.clk_oldspringext2_logic );
cmn.AddSubscriber( "clk_oldspringext2_beg", private.clk_oldspringext2_beg );
cmn.AddSubscriber( "clk_oldspringext2_end", private.clk_oldspringext2_end );
cmn.AddSubscriber( "clk_oldspringext2_end", private.clk_oldspringext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_oldspringext2()

  local func_end = function()
    cmn.SetEventDone( "clk_oldspringext2" );
    cmn.CallEventHandler( "clk_oldspringext2_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_oldspringext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_clockext_anm", "open", func_end );
  SoundSfx( "aud_touch_clockbuttonext_clockext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletletterext" ] = { type = "get", get_obj = "spr_clockext_amuletletterext", room = "inv_complex_inv", zz = "inv_complex_clockext", zz_gate = "inv_clockext" };

private.get_amuletletterext_logic = function()
 
end;
private.get_amuletletterext_inv = function()
  interface.InventoryItemAdd("inv_amuletletterext","spr_clockext_amuletletterext");
  if common_impl.ZzCompleteCheck("get_amuletletterext") then interface.InventoryItemRemove("inv_clockext") end;
end;
private.get_amuletletterext_beg = function()
  ObjDelete("gfx_clockext_amuletletterext");
end;
private.get_amuletletterext_end = function()
  ObjDelete("spr_clockext_sh_amuletletterext");
  ObjDelete("inv_clockext_state_5");
end;

cmn.AddSubscriber( "get_amuletletterext", private.get_amuletletterext_inv );
cmn.AddSubscriber( "get_amuletletterext", private.get_amuletletterext_beg );
cmn.AddSubscriber( "get_amuletletterext", private.get_amuletletterext_end );
cmn.AddSubscriber( "get_amuletletterext", private.get_amuletletterext_logic );
--------------------------------------------------------------------
function public.get_amuletletterext()
  cmn.SetEventDone( "get_amuletletterext" );
  cmn.CallEventHandler( "get_amuletletterext" );
  if common_impl.ZzCompleteCheck("get_amuletletterext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_susiebagext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bowext_zone_clk()  --level_inv.use_bowext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_bowext' );
  end;
  SoundSfx( "aud_touch_clothes" )
  ld.Lock(1);
  ld.AnimPlay( "anm_susiebagext_anm", "bag_click", func_end )  
end;  


common_impl.hint[ "use_bowext" ] = { type = "use", inv_obj = "inv_bowext", use_place = "gfx_susiebagext_bowext_zone", room = "inv_complex_inv", zz = "inv_complex_susiebagext", zz_gate = "inv_susiebagext" };

private.use_bowext_logic = function()
   ObjSet( "gfx_susiebagext_clk_susiebagextbowext1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_bowext_inv = function()
  common_impl.ProcessMultiUseAll("bowext", "bowext")
end;
private.use_bowext_beg = function()
  ObjDelete( "gfx_susiebagext_bowext_zone" );
end;
private.use_bowext_end = function()
  ObjSet( "anm_susiebagext_anm", {animfunc = "use_items1", frame = 0 } );
  ObjDelete("inv_susiebagext_back");
  ObjSet( "inv_susiebagext_susiebagext_state_st_2", {alp = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bowext", private.use_bowext_inv );
cmn.AddSubscriber( "use_bowext", private.use_bowext_beg );
cmn.AddSubscriber( "use_bowext", private.use_bowext_end );
cmn.AddSubscriber( "use_bowext", private.use_bowext_logic );
cmn.AddSubscriber( "use_bowext_inv", private.use_bowext_inv );
cmn.AddSubscriber( "use_bowext_beg", private.use_bowext_beg );
cmn.AddSubscriber( "use_bowext_end", private.use_bowext_end );
cmn.AddSubscriber( "use_bowext_end", private.use_bowext_logic );
--------------------------------------------------------------------------------------------
function public.use_bowext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bowext" );
    cmn.CallEventHandler( "use_bowext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bowext_inv" );
  cmn.CallEventHandler( "use_bowext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_bowext_susiebagext" )
  
  ld.AnimPlay( "anm_susiebagext_anm", "bag_open", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_susiebagextbowext1" ] = { type = "click", use_place = "gfx_susiebagext_clk_susiebagextbowext1_zone", room = "inv_complex_inv", zz = "inv_complex_susiebagext", zz_gate = "inv_susiebagext" };

private.clk_susiebagextbowext1_logic = function()
  ObjSet( "gfx_susiebagext_clk_susiebagextbowext2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_susiebagextbowext1_beg = function()
  ObjDelete( "gfx_susiebagext_clk_susiebagextbowext1_zone" );
end;
private.clk_susiebagextbowext1_end = function()
  ObjSet( "anm_susiebagext_anm", {animfunc = "use_items1", frame = 999 } );
  ObjDelete("inv_susiebagext_susiebagext_state_st_2");
  ObjSet( "inv_susiebagext_susiebagext_state_st_3", {alp = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_susiebagextbowext1", private.clk_susiebagextbowext1_beg );
cmn.AddSubscriber( "clk_susiebagextbowext1", private.clk_susiebagextbowext1_end );
cmn.AddSubscriber( "clk_susiebagextbowext1", private.clk_susiebagextbowext1_logic );
cmn.AddSubscriber( "clk_susiebagextbowext1_beg", private.clk_susiebagextbowext1_beg );
cmn.AddSubscriber( "clk_susiebagextbowext1_end", private.clk_susiebagextbowext1_end );
cmn.AddSubscriber( "clk_susiebagextbowext1_end", private.clk_susiebagextbowext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_susiebagextbowext1()

  local func_end = function()
    cmn.SetEventDone( "clk_susiebagextbowext1" );
    cmn.CallEventHandler( "clk_susiebagextbowext1_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_susiebagextbowext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_susiebagext_anm", "use_items1", func_end );
  SoundSfx( "aud_touch_clothes_susiebagext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_susiebagextbowext2" ] = { type = "click", use_place = "gfx_susiebagext_clk_susiebagextbowext2_zone", room = "inv_complex_inv", zz = "inv_complex_susiebagext", zz_gate = "inv_susiebagext" };

private.clk_susiebagextbowext2_logic = function()
  ObjSet( "spr_susiebagext_harpext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_susiebagext_harpext", {active=1, visible=1} );
end;
private.clk_susiebagextbowext2_beg = function()
  ObjDelete( "gfx_susiebagext_clk_susiebagextbowext2_zone" );
end;
private.clk_susiebagextbowext2_end = function()
  ObjSet( "anm_susiebagext_anm", {animfunc = "use_items2", frame = 999 } );
  ObjDelete("inv_susiebagext_susiebagext_state_st_3");
  ObjSet( "inv_susiebagext_susiebagext_state_st_4", {alp = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_susiebagextbowext2", private.clk_susiebagextbowext2_beg );
cmn.AddSubscriber( "clk_susiebagextbowext2", private.clk_susiebagextbowext2_end );
cmn.AddSubscriber( "clk_susiebagextbowext2", private.clk_susiebagextbowext2_logic );
cmn.AddSubscriber( "clk_susiebagextbowext2_beg", private.clk_susiebagextbowext2_beg );
cmn.AddSubscriber( "clk_susiebagextbowext2_end", private.clk_susiebagextbowext2_end );
cmn.AddSubscriber( "clk_susiebagextbowext2_end", private.clk_susiebagextbowext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_susiebagextbowext2()

  local func_end = function()
    cmn.SetEventDone( "clk_susiebagextbowext2" );
    cmn.CallEventHandler( "clk_susiebagextbowext2_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_susiebagextbowext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_susiebagext_anm", "use_items2", func_end );
  SoundSfx( "aud_touch_clothes_susiebagext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_harpext" ] = { type = "get", get_obj = "spr_susiebagext_harpext", room = "inv_complex_inv", zz = "inv_complex_susiebagext", zz_gate = "inv_susiebagext" };

private.get_harpext_logic = function()
 
end;
private.get_harpext_inv = function()
  interface.InventoryItemAdd("inv_harpext","spr_susiebagext_harpext");
  if common_impl.ZzCompleteCheck("get_harpext") then interface.InventoryItemRemove("inv_susiebagext") end;
end;
private.get_harpext_beg = function()
  ObjDelete("gfx_susiebagext_harpext");
end;
private.get_harpext_end = function()
   ObjSet( "anm_susiebagext_anm", {animfunc = "bag_open_end", frame = 999 } );
end;

cmn.AddSubscriber( "get_harpext", private.get_harpext_inv );
cmn.AddSubscriber( "get_harpext", private.get_harpext_beg );
cmn.AddSubscriber( "get_harpext", private.get_harpext_end );
cmn.AddSubscriber( "get_harpext", private.get_harpext_logic );
--------------------------------------------------------------------
function public.get_harpext()
  ObjSet( "spr_susiebagext_harpext", {visible = 1} );
  cmn.SetEventDone( "get_harpext" );
  cmn.CallEventHandler( "get_harpext" );
  if common_impl.ZzCompleteCheck("get_harpext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_starext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wandext" ] = { type = "use", inv_obj = "inv_wandext", use_place = "gfx_starext_wandext_zone", room = "inv_complex_inv", zz = "inv_complex_starext", zz_gate = "inv_starext" };

private.use_wandext_logic = function()
  if ld.CheckRequirements( {"use_wandext","use_littlestarext"} ) then
      ObjSet( "spr_starext_magicwandext", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_wandext_inv = function()
  common_impl.ProcessMultiUseAll("wandext", "wandext")
end;
private.use_wandext_beg = function()
  ObjDelete( "gfx_starext_wandext_zone" );
end;
private.use_wandext_end = function()
  if ld.CheckRequirements( {"use_wandext","use_littlestarext"} ) then
     ObjDelete("anm_starext_anm_wand");
     ObjDelete("anm_starext_anm_star")
     ObjDelete("anm_starext_anm_stand");
  else
     ObjSet( "anm_starext_anm_wand", {animfunc = "use_wand", frame = 999 } );
  end;  
  ObjSet( "inv_starext_state_st_3", {alp=1} );   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wandext", private.use_wandext_inv );
cmn.AddSubscriber( "use_wandext", private.use_wandext_beg );
cmn.AddSubscriber( "use_wandext", private.use_wandext_end );
cmn.AddSubscriber( "use_wandext", private.use_wandext_logic );
cmn.AddSubscriber( "use_wandext_inv", private.use_wandext_inv );
cmn.AddSubscriber( "use_wandext_beg", private.use_wandext_beg );
cmn.AddSubscriber( "use_wandext_end", private.use_wandext_end );
cmn.AddSubscriber( "use_wandext_end", private.use_wandext_logic );
--------------------------------------------------------------------------------------------
function public.use_wandext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wandext" );
    cmn.CallEventHandler( "use_wandext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wandext_inv" );
  cmn.CallEventHandler( "use_wandext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_wandext_starext" )
  
  ld.AnimPlay( "anm_starext_anm_wand", "use_wand", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_littlestarext" ] = { type = "use", inv_obj = "inv_littlestarext", use_place = "gfx_starext_littlestarext_zone", room = "inv_complex_inv", zz = "inv_complex_starext", zz_gate = "inv_starext" };

private.use_littlestarext_logic = function()
  if ld.CheckRequirements( {"use_wandext","use_littlestarext"} ) then
       ObjSet( "spr_starext_magicwandext", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_littlestarext_inv = function()
  common_impl.ProcessMultiUseAll("littlestarext", "littlestarext")
end;
private.use_littlestarext_beg = function()
  ObjDelete( "gfx_starext_littlestarext_zone" );
end;
private.use_littlestarext_end = function()
  if ld.CheckRequirements( {"use_wandext","use_littlestarext"} ) then
     ObjDelete("anm_starext_anm_wand");
     ObjDelete("anm_starext_anm_star");
     ObjDelete("anm_starext_anm_stand");
  else
     ObjSet( "anm_starext_anm_star", {animfunc = "use_start", frame = 999 } );
  end; 
  ObjSet( "inv_starext_state_st_1", {alp=1} );  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_littlestarext", private.use_littlestarext_inv );
cmn.AddSubscriber( "use_littlestarext", private.use_littlestarext_beg );
cmn.AddSubscriber( "use_littlestarext", private.use_littlestarext_end );
cmn.AddSubscriber( "use_littlestarext", private.use_littlestarext_logic );
cmn.AddSubscriber( "use_littlestarext_inv", private.use_littlestarext_inv );
cmn.AddSubscriber( "use_littlestarext_beg", private.use_littlestarext_beg );
cmn.AddSubscriber( "use_littlestarext_end", private.use_littlestarext_end );
cmn.AddSubscriber( "use_littlestarext_end", private.use_littlestarext_logic );
--------------------------------------------------------------------------------------------
function public.use_littlestarext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_littlestarext" );
    cmn.CallEventHandler( "use_littlestarext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_littlestarext_inv" );
  cmn.CallEventHandler( "use_littlestarext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_littlestarext_starext" )
  
  ld.AnimPlay( "anm_starext_anm_star", "use_start", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_magicwandext" ] = { type = "get", get_obj = "spr_starext_magicwandext", room = "inv_complex_inv", zz = "inv_complex_starext", zz_gate = "inv_starext" };

private.get_magicwandext_logic = function()
 
end;
private.get_magicwandext_inv = function()
  interface.InventoryItemAdd("inv_magicwandext","spr_starext_magicwandext");
  if common_impl.ZzCompleteCheck("get_magicwandext") then interface.InventoryItemRemove("inv_starext") end;
end;
private.get_magicwandext_beg = function()
  ObjDelete("gfx_starext_magicwandext");
end;
private.get_magicwandext_end = function()
  
end;

cmn.AddSubscriber( "get_magicwandext", private.get_magicwandext_inv );
cmn.AddSubscriber( "get_magicwandext", private.get_magicwandext_beg );
cmn.AddSubscriber( "get_magicwandext", private.get_magicwandext_end );
cmn.AddSubscriber( "get_magicwandext", private.get_magicwandext_logic );
--------------------------------------------------------------------
function public.get_magicwandext()
  cmn.SetEventDone( "get_magicwandext" );
  cmn.CallEventHandler( "get_magicwandext" );
  if common_impl.ZzCompleteCheck("get_magicwandext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_magicbranchesext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_lotusext" ] = { type = "click", use_place = "gfx_magicbranchesext_clk_lotusext", room = "inv_complex_inv", zz = "inv_complex_magicbranchesext", zz_gate = "inv_magicbranchesext"  };

private.clk_lotusext_logic = function()
  ObjSet("gfx_magicbranchesext_lotusext_zone",{active=1, input=1, visible=1});
end;
private.clk_lotusext_beg = function()
  ObjDelete( "gfx_magicbranchesext_clk_lotusext" );
end;
private.clk_lotusext_end = function()
  ObjSet( "anm_magicbranchesext_anm", {animfunc = "branches_use1", frame = 999 } );
  ObjDelete("inv_magicbranchesext_back");
  ObjSet( "inv_magicbranchesext_back_st_2", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_lotusext", private.clk_lotusext_beg );
cmn.AddSubscriber( "clk_lotusext", private.clk_lotusext_end );
cmn.AddSubscriber( "clk_lotusext", private.clk_lotusext_logic );
cmn.AddSubscriber( "clk_lotusext_beg", private.clk_lotusext_beg );
cmn.AddSubscriber( "clk_lotusext_end", private.clk_lotusext_end );
cmn.AddSubscriber( "clk_lotusext_end", private.clk_lotusext_logic );
--------------------------------------------------------------------------------------------
function public.clk_lotusext()  -- level_inv.clk_lotusext()

  local func_end = function()
    cmn.SetEventDone( "clk_lotusext" );
    cmn.CallEventHandler( "clk_lotusext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_lotusext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_magicbranchesext_anm", "branches_use", func_end );
  SoundSfx( "aud_magicbranch_click" )
  --func_end()

end;
--------------------------------------------------------------------------------------------

common_impl.hint[ "use_lotusext" ] = { type = "use", inv_obj = "inv_lotusext", use_place = "gfx_magicbranchesext_lotusext_zone", room = "inv_complex_inv", zz = "inv_complex_magicbranchesext", zz_gate = "inv_magicbranchesext" };

private.use_lotusext_logic = function()
  ObjSet( "spr_magicbranchesext_wreathext", { visible = 1, input = 1, active = 1 } )

end;
private.use_lotusext_inv = function()
  common_impl.ProcessMultiUseAll("lotusext", "lotusext")
end;
private.use_lotusext_beg = function()
  ObjDelete( "gfx_magicbranchesext_lotusext_zone" );
end;
private.use_lotusext_end = function()
  ObjDelete("anm_magicbranchesext_anm");
  ObjDelete("inv_magicbranchesext_back_st_2");
  ObjSet( "inv_magicbranchesext_back_st_3", {alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lotusext", private.use_lotusext_inv );
cmn.AddSubscriber( "use_lotusext", private.use_lotusext_beg );
cmn.AddSubscriber( "use_lotusext", private.use_lotusext_end );
cmn.AddSubscriber( "use_lotusext", private.use_lotusext_logic );
cmn.AddSubscriber( "use_lotusext_inv", private.use_lotusext_inv );
cmn.AddSubscriber( "use_lotusext_beg", private.use_lotusext_beg );
cmn.AddSubscriber( "use_lotusext_end", private.use_lotusext_end );
cmn.AddSubscriber( "use_lotusext_end", private.use_lotusext_logic );
--------------------------------------------------------------------------------------------
function public.use_lotusext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lotusext" );
    cmn.CallEventHandler( "use_lotusext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lotusext_inv" );
  cmn.CallEventHandler( "use_lotusext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_lotusext_magicbranchesext" )
  
  ld.AnimPlay( "anm_magicbranchesext_anm", "branches_lotus", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wreathext" ] = { type = "get", get_obj = "spr_magicbranchesext_wreathext", room = "inv_complex_inv", zz = "inv_complex_magicbranchesext", zz_gate = "inv_magicbranchesext" };

private.get_wreathext_logic = function()
 
end;
private.get_wreathext_inv = function()
  interface.InventoryItemAdd("inv_wreathext","spr_magicbranchesext_wreathext");
  if common_impl.ZzCompleteCheck("get_wreathext") then interface.InventoryItemRemove("inv_magicbranchesext") end;
end;
private.get_wreathext_beg = function()
  ObjDelete("gfx_magicbranchesext_wreathext");
end;
private.get_wreathext_end = function()
  
end;

cmn.AddSubscriber( "get_wreathext", private.get_wreathext_inv );
cmn.AddSubscriber( "get_wreathext", private.get_wreathext_beg );
cmn.AddSubscriber( "get_wreathext", private.get_wreathext_end );
cmn.AddSubscriber( "get_wreathext", private.get_wreathext_logic );
--------------------------------------------------------------------
function public.get_wreathext()
  cmn.SetEventDone( "get_wreathext" );
  cmn.CallEventHandler( "get_wreathext" );
  if common_impl.ZzCompleteCheck("get_wreathext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_catinhatext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_hatext" ] = { type = "click", use_place = "gfx_catinhatext_clk_hatext", room = "inv_complex_inv", zz = "inv_complex_catinhatext", zz_gate = "inv_catinhatext" };

private.clk_hatext_logic = function()
   ObjSet( "spr_catinhatext_hatext", { visible = 1, input = 1, active = 1 } )

end;
private.clk_hatext_beg = function()
  ObjDelete( "gfx_catinhatext_clk_hatext" );
end;
private.clk_hatext_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_hatext", private.clk_hatext_beg );
cmn.AddSubscriber( "clk_hatext", private.clk_hatext_end );
cmn.AddSubscriber( "clk_hatext", private.clk_hatext_logic );
cmn.AddSubscriber( "clk_hatext_beg", private.clk_hatext_beg );
cmn.AddSubscriber( "clk_hatext_end", private.clk_hatext_end );
cmn.AddSubscriber( "clk_hatext_end", private.clk_hatext_logic );
--------------------------------------------------------------------------------------------
function public.clk_hatext()

  local func_end = function()
    cmn.SetEventDone( "clk_hatext" );
    cmn.CallEventHandler( "clk_hatext_end" );
    common_impl.Lock(0);
    public.get_hatext();
  end;

  cmn.CallEventHandler( "clk_hatext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_catinhatext_anm_stand_hat", "use_hat", func_end )
  SoundSfx( "aud_hat_toyworldext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------

common_impl.hint[ "get_hatext" ] = { type = "get", get_obj = "spr_catinhatext_hatext", room = "inv_complex_inv", zz = "inv_complex_catinhatext", zz_gate = "inv_catinhatext" };

private.get_hatext_logic = function()
 
end;
private.get_hatext_inv = function()
  interface.InventoryItemAdd("inv_hatext","spr_catinhatext_hatext");
  if common_impl.ZzCompleteCheck("get_hatext") then interface.InventoryItemRemove("inv_catinhatext") end;
end;
private.get_hatext_beg = function()
  ObjDelete("gfx_catinhatext_hatext");
end;
private.get_hatext_end = function()
  ObjDelete("anm_catinhatext_anm_stand_hat");
  ObjDelete("inv_catinhatext_state_st_3");
end;

cmn.AddSubscriber( "get_hatext_end", private.get_hatext_inv );
cmn.AddSubscriber( "get_hatext_beg", private.get_hatext_beg );
cmn.AddSubscriber( "get_hatext_end", private.get_hatext_end );
cmn.AddSubscriber( "get_hatext_end", private.get_hatext_logic );
cmn.AddSubscriber( "get_hatext", private.get_hatext_inv );
cmn.AddSubscriber( "get_hatext", private.get_hatext_beg );
cmn.AddSubscriber( "get_hatext", private.get_hatext_end );
cmn.AddSubscriber( "get_hatext", private.get_hatext_logic );
--------------------------------------------------------------------
function public.get_hatext()
 -- local func_end = function()
      ld.Lock(0);
      ObjSet( "spr_catinhatext_hatext", {visible = 1} );
      cmn.SetEventDone( "get_hatext" );
      cmn.CallEventHandler( "get_hatext" );
      if common_impl.ZzCompleteCheck("get_hatext") then common_impl.HideComplexItem() end;
--  end;  
--  
--  
--  cmn.CallEventHandler( "get_hatext_beg" );
--  
--  ld.Lock(1);
--  ld.AnimPlay( "anm_catinhatext_anm_stand_hat", "use_hat", func_end )
end
--------------------------------------------------------------------
common_impl.hint[ "clk_featherext1" ] = { type = "click", use_place = "gfx_catinhatext_clk_featherext1", room = "inv_complex_inv", zz = "inv_complex_catinhatext", zz_gate = "inv_catinhatext" };

private.clk_featherext1_logic = function()
   ObjSet( "spr_catinhatext_featherext1", { visible = 1, input = 1, active = 1 } )

end;
private.clk_featherext1_beg = function()
  ObjDelete( "gfx_catinhatext_clk_featherext1" );
end;
private.clk_featherext1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_featherext1", private.clk_featherext1_beg );
cmn.AddSubscriber( "clk_featherext1", private.clk_featherext1_end );
cmn.AddSubscriber( "clk_featherext1", private.clk_featherext1_logic );
cmn.AddSubscriber( "clk_featherext1_beg", private.clk_featherext1_beg );
cmn.AddSubscriber( "clk_featherext1_end", private.clk_featherext1_end );
cmn.AddSubscriber( "clk_featherext1_end", private.clk_featherext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_featherext1()

  local func_end = function()
    cmn.SetEventDone( "clk_featherext1" );
    cmn.CallEventHandler( "clk_featherext1_end" );
    common_impl.Lock(0);
    public.get_featherext1();
  end;

  cmn.CallEventHandler( "clk_featherext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_catinhatext_anm_feather", "use_feather", func_end );
  SoundSfx( "aud_feather_toyworldext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "get_featherext1" ] = { type = "get", get_obj = "spr_catinhatext_featherext1", room = "inv_complex_inv", zz = "inv_complex_catinhatext", zz_gate = "inv_catinhatext" };

private.get_featherext1_logic = function()
   ObjSet( "gfx_catinhatext_clk_hatext", {active = 1 ,input = 1, visible = 1} );
end;
private.get_featherext1_inv = function()
  interface.InventoryItemAdd("inv_featherext1","spr_catinhatext_featherext1");
  if common_impl.ZzCompleteCheck("get_featherext1") then interface.InventoryItemRemove("inv_catinhatext") end;
end;
private.get_featherext1_beg = function()
  ObjDelete("gfx_catinhatext_featherext1");
end;
private.get_featherext1_end = function()
  ObjDelete("anm_catinhatext_anm_feather");
  ObjDelete("inv_catinhatext_state_st_4");
end;

cmn.AddSubscriber( "get_featherext1_end", private.get_featherext1_inv );
cmn.AddSubscriber( "get_featherext1_beg", private.get_featherext1_beg );
cmn.AddSubscriber( "get_featherext1_end", private.get_featherext1_end );
cmn.AddSubscriber( "get_featherext1_end", private.get_featherext1_logic );
cmn.AddSubscriber( "get_featherext1", private.get_featherext1_inv );
cmn.AddSubscriber( "get_featherext1", private.get_featherext1_beg );
cmn.AddSubscriber( "get_featherext1", private.get_featherext1_end );
cmn.AddSubscriber( "get_featherext1", private.get_featherext1_logic );
--------------------------------------------------------------------
function public.get_featherext1()
  --local func_end = function()
  --  ld.Lock(0);
    ObjSet( "spr_catinhatext_featherext1", {visible = 1} );
    cmn.SetEventDone( "get_featherext1" );
    cmn.CallEventHandler( "get_featherext1" );
    if common_impl.ZzCompleteCheck("get_featherext1") then common_impl.HideComplexItem() end;
 --end;
 --
 --ld.Lock(1);
 --cmn.CallEventHandler( "get_featherext1_beg" );
 --ld.AnimPlay( "anm_catinhatext_anm_feather", "use_feather", func_end );
end
--------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_medallionbearsext" ] = { type = "click", use_place = "gfx_catinhatext_clk_medallionbearsext", room = "inv_complex_inv", zz = "inv_complex_catinhatext", zz_gate = "inv_catinhatext" };

private.clk_medallionbearsext_logic = function()
   ObjSet( "spr_catinhatext_medallionbearsext", { visible = 1, input = 1, active = 1 } )

end;
private.clk_medallionbearsext_beg = function()
  ObjDelete( "gfx_catinhatext_clk_medallionbearsext" );
end;
private.clk_medallionbearsext_end = function()
 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_medallionbearsext", private.clk_medallionbearsext_beg );
cmn.AddSubscriber( "clk_medallionbearsext", private.clk_medallionbearsext_end );
cmn.AddSubscriber( "clk_medallionbearsext", private.clk_medallionbearsext_logic );
cmn.AddSubscriber( "clk_medallionbearsext_beg", private.clk_medallionbearsext_beg );
cmn.AddSubscriber( "clk_medallionbearsext_end", private.clk_medallionbearsext_end );
cmn.AddSubscriber( "clk_medallionbearsext_end", private.clk_medallionbearsext_logic );
--------------------------------------------------------------------------------------------
function public.clk_medallionbearsext()

  local func_end = function()
    cmn.SetEventDone( "clk_medallionbearsext" );
    cmn.CallEventHandler( "clk_medallionbearsext_end" );
    common_impl.Lock(0);
    public.get_medallionbearsext();
  end;

  cmn.CallEventHandler( "clk_medallionbearsext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_catinhatext_anm_medal", "use_medal", func_end )
  SoundSfx( "aud_collar_toyworldext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------


common_impl.hint[ "get_medallionbearsext" ] = { type = "get", get_obj = "spr_catinhatext_medallionbearsext", room = "inv_complex_inv", zz = "inv_complex_catinhatext", zz_gate = "inv_catinhatext" };

private.get_medallionbearsext_logic = function()
 
end;
private.get_medallionbearsext_inv = function()
  interface.InventoryItemAdd("inv_medallionbearsext","spr_catinhatext_medallionbearsext");
  if common_impl.ZzCompleteCheck("get_medallionbearsext") then interface.InventoryItemRemove("inv_catinhatext") end;
end;
private.get_medallionbearsext_beg = function()
  ObjDelete("gfx_catinhatext_medallionbearsext");
end;
private.get_medallionbearsext_end = function()
  ObjDelete("anm_catinhatext_anm_medal");
  ObjDelete("inv_catinhatext_state_st_2");
end;

cmn.AddSubscriber( "get_medallionbearsext_end", private.get_medallionbearsext_inv );
cmn.AddSubscriber( "get_medallionbearsext_beg", private.get_medallionbearsext_beg );
cmn.AddSubscriber( "get_medallionbearsext_end", private.get_medallionbearsext_end );
cmn.AddSubscriber( "get_medallionbearsext_end", private.get_medallionbearsext_logic );
cmn.AddSubscriber( "get_medallionbearsext", private.get_medallionbearsext_inv );
cmn.AddSubscriber( "get_medallionbearsext", private.get_medallionbearsext_beg );
cmn.AddSubscriber( "get_medallionbearsext", private.get_medallionbearsext_end );
cmn.AddSubscriber( "get_medallionbearsext", private.get_medallionbearsext_logic );
--------------------------------------------------------------------
function public.get_medallionbearsext()
 -- local func_end = function()
    ObjSet( "spr_catinhatext_medallionbearsext", {visible = 1} );
    ld.Lock(0);
    cmn.SetEventDone( "get_medallionbearsext" );
    cmn.CallEventHandler( "get_medallionbearsext" );
    if common_impl.ZzCompleteCheck("get_medallionbearsext") then common_impl.HideComplexItem() end;
--  end;
--  
--  cmn.CallEventHandler( "get_medallionbearsext_beg" );
--  ld.Lock(1);
--  ld.AnimPlay( "anm_catinhatext_anm_medal", "use_medal", func_end )
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_nibblerext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_pepperext_zone_clk() --levelext_inv.use_pepperext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_pepperext' );
    ObjSet( "anm_nibblerext_anm", {animfunc = "stand", frame = 0, playing=1 } );
  end;  
  SoundSfx( "aud_touch_nibbleext" )
  ld.Lock(1);
  ld.AnimPlay( "anm_nibblerext_anm", "stand_click", func_end )
end;  


common_impl.hint[ "use_pepperext" ] = { type = "use", inv_obj = "inv_pepperext", use_place = "gfx_nibblerext_pepperext_zone", room = "inv_complex_inv", zz = "inv_complex_nibblerext", zz_gate = "inv_nibblerext" };

private.use_pepperext_logic = function()
  ObjSet( "spr_nibblerext_purpleghostext", { visible = 1, input = 1, active = 1 } )

end;
private.use_pepperext_inv = function()
  common_impl.ProcessMultiUseAll("pepperext", "pepperext")
end;
private.use_pepperext_beg = function()
  ObjDelete( "gfx_nibblerext_pepperext_zone" );
end;
private.use_pepperext_end = function()
  ObjSet( "anm_nibblerext_anm", {animfunc = "end", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pepperext", private.use_pepperext_inv );
cmn.AddSubscriber( "use_pepperext", private.use_pepperext_beg );
cmn.AddSubscriber( "use_pepperext", private.use_pepperext_end );
cmn.AddSubscriber( "use_pepperext", private.use_pepperext_logic );
cmn.AddSubscriber( "use_pepperext_inv", private.use_pepperext_inv );
cmn.AddSubscriber( "use_pepperext_beg", private.use_pepperext_beg );
cmn.AddSubscriber( "use_pepperext_end", private.use_pepperext_end );
cmn.AddSubscriber( "use_pepperext_end", private.use_pepperext_logic );
--------------------------------------------------------------------------------------------
function public.use_pepperext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pepperext" );
    cmn.CallEventHandler( "use_pepperext_end" );
    common_impl.Lock(0);
    public.get_purpleghostext();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pepperext_inv" );
  cmn.CallEventHandler( "use_pepperext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_pepperext_nibblerext" )
  
  ld.AnimPlay( "anm_nibblerext_anm", "stand_use_pepper", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_purpleghostext" ] = { type = "get", get_obj = "spr_nibblerext_purpleghostext", room = "inv_complex_inv", zz = "inv_complex_nibblerext", zz_gate = "inv_nibblerext" };

private.get_purpleghostext_logic = function()
 
end;
private.get_purpleghostext_inv = function()
  interface.InventoryItemAdd("inv_purpleghostext","spr_nibblerext_purpleghostext");
  if common_impl.ZzCompleteCheck("get_purpleghostext") then interface.InventoryItemRemove("inv_nibblerext") end;
end;
private.get_purpleghostext_beg = function()
  ObjDelete("gfx_nibblerext_purpleghostext");
end;
private.get_purpleghostext_end = function()
  
end;

cmn.AddSubscriber( "get_purpleghostext", private.get_purpleghostext_inv );
cmn.AddSubscriber( "get_purpleghostext", private.get_purpleghostext_beg );
cmn.AddSubscriber( "get_purpleghostext", private.get_purpleghostext_end );
cmn.AddSubscriber( "get_purpleghostext", private.get_purpleghostext_logic );
--------------------------------------------------------------------
function public.get_purpleghostext()
  cmn.SetEventDone( "get_purpleghostext" );
  cmn.CallEventHandler( "get_purpleghostext" );
  if common_impl.ZzCompleteCheck("get_purpleghostext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_demoncasketext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_demonsignext_demoncasketext_zone_clk()  --levelext_inv.use_demonsignext_demoncasketext_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_demonsignext_demoncasketext' );
  end;  
  SoundSfx( "aud_touch_small_wood" )
  ld.Lock(1);
  ld.AnimPlay( "anm_demoncasketext_anm", "click", func_end )
end;  


common_impl.hint[ "use_demonsignext_demoncasketext" ] = { type = "use", inv_obj = "inv_demonsignext", use_place = "gfx_demoncasketext_demonsignext_demoncasketext_zone", room = "inv_complex_inv", zz = "inv_complex_demoncasketext", zz_gate = "inv_demoncasketext" };

private.use_demonsignext_demoncasketext_logic = function()
  ObjSet( "spr_demoncasketext_pendantsusieext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_demoncasketext_pendantsusieext", { active = 1, visible = 1} );
end;
private.use_demonsignext_demoncasketext_inv = function()
  common_impl.ProcessMultiUseAll("demonsignext", "demonsignext_demoncasketext")
end;
private.use_demonsignext_demoncasketext_beg = function()
  ObjDelete( "gfx_demoncasketext_demonsignext_demoncasketext_zone" );
end;
private.use_demonsignext_demoncasketext_end = function()
  ObjSet( "anm_demoncasketext_anm", {animfunc = "stand_open", frame = 0 } );
  ObjDelete("inv_demoncasketext_back")
  ObjSet( "inv_demoncasketext_state_st_2", { alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_demonsignext_demoncasketext", private.use_demonsignext_demoncasketext_inv );
cmn.AddSubscriber( "use_demonsignext_demoncasketext", private.use_demonsignext_demoncasketext_beg );
cmn.AddSubscriber( "use_demonsignext_demoncasketext", private.use_demonsignext_demoncasketext_end );
cmn.AddSubscriber( "use_demonsignext_demoncasketext", private.use_demonsignext_demoncasketext_logic );
cmn.AddSubscriber( "use_demonsignext_demoncasketext_inv", private.use_demonsignext_demoncasketext_inv );
cmn.AddSubscriber( "use_demonsignext_demoncasketext_beg", private.use_demonsignext_demoncasketext_beg );
cmn.AddSubscriber( "use_demonsignext_demoncasketext_end", private.use_demonsignext_demoncasketext_end );
cmn.AddSubscriber( "use_demonsignext_demoncasketext_end", private.use_demonsignext_demoncasketext_logic );
--------------------------------------------------------------------------------------------
function public.use_demonsignext_demoncasketext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_demonsignext_demoncasketext" );
    cmn.CallEventHandler( "use_demonsignext_demoncasketext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_demonsignext_demoncasketext_inv" );
  cmn.CallEventHandler( "use_demonsignext_demoncasketext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_demonsignext_demoncasketext" )
  
  ld.AnimPlay( "anm_demoncasketext_anm", "default2", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pendantsusieext" ] = { type = "get", get_obj = "spr_demoncasketext_pendantsusieext", room = "inv_complex_inv", zz = "inv_complex_demoncasketext", zz_gate = "inv_demoncasketext" };

private.get_pendantsusieext_logic = function()
  ObjSet( "gfx_blackcastleext_clk_animappearanceext_zone", { visible = 1, input = 1, active = 1 } );
end;
private.get_pendantsusieext_inv = function()
  interface.InventoryItemAdd("inv_pendantsusieext","spr_demoncasketext_pendantsusieext");
  if common_impl.ZzCompleteCheck("get_pendantsusieext") then interface.InventoryItemRemove("inv_demoncasketext") end;
end;
private.get_pendantsusieext_beg = function()
  ObjDelete("gfx_demoncasketext_pendantsusieext");
end;
private.get_pendantsusieext_end = function()
  ObjSet( "anm_demoncasketext_anm", {animfunc = "stand_end", frame = 0 } );
end;

cmn.AddSubscriber( "get_pendantsusieext", private.get_pendantsusieext_inv );
cmn.AddSubscriber( "get_pendantsusieext", private.get_pendantsusieext_beg );
cmn.AddSubscriber( "get_pendantsusieext", private.get_pendantsusieext_end );
cmn.AddSubscriber( "get_pendantsusieext", private.get_pendantsusieext_logic );
--------------------------------------------------------------------
function public.get_pendantsusieext()
  ObjSet( "spr_demoncasketext_pendantsusieext", {visible = 1} );
  cmn.SetEventDone( "get_pendantsusieext" );
  cmn.CallEventHandler( "get_pendantsusieext" );
  if common_impl.ZzCompleteCheck("get_pendantsusieext") then common_impl.HideComplexItem() end;
end

function public.demoncasketext_close()
  local cur_room = common.GetCurrentRoom();
  if cur_room == "rm_blackcastleext" and not cmn.IsEventDone("clk_animappearanceext") and cmn.IsEventDone("get_pendantsusieext") then 
    rm_blackcastleext.clk_animappearanceext();
  end;  
end;  
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end

function public.Reset()
  mg_name = interface.GetCurrentComplexInv()
  --ld.LogTrace( mg_name )
  --if ( mg_name == "inv_complex_garland" ) and not ld.CheckRequirements( { "win_garland" } ) then
  --  private.win_garland_gm.reset()
  --end

end
function public.Skip()
  mg_name = interface.GetCurrentComplexInv()
  --if ( mg_name == "inv_complex_garland" ) and not ld.CheckRequirements( { "win_garland" } ) then
  --private.win_garland_gm.skip()
  --end;

end