-- name=rm_cryptext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cryptext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  
  ld.NoteInit("anm_ritualcircleext_anm_paper","spr_ritualcircleext_paper_big");
  ld.NoteRelaseLock( "anm_ritualcircleext_anm_paper" );
  --------------------------------------------------------------------------------------------
function private.opn_cryptext()
  if not ( cmn.IsEventDone( "opn_cryptext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_cryptext" );
      cmn.CallEventHandler( "opn_cryptext" )
      ld.ShowBbtOpn( private.room_objname )
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_cryptext = function() end;
local opn_cryptext_logic = function() end;
cmn.AddSubscriber( "opn_cryptext", opn_cryptext_logic )
cmn.AddSubscriber( "opn_cryptext", opn_cryptext, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animspiritext2" ] = { type = "click", use_place = "gfx_cryptext_clk_animspiritext2_zone", room = "rm_cryptext" };

private.clk_animspiritext2_logic = function()

end;
private.clk_animspiritext2_beg = function()
  ObjDelete( "gfx_cryptext_clk_animspiritext2_zone" );
end;
private.clk_animspiritext2_end = function()
  ObjDelete("anm_cryptext_anm_suzi");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animspiritext2", private.clk_animspiritext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext2", private.clk_animspiritext2_end, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext2", private.clk_animspiritext2_logic );
cmn.AddSubscriber( "clk_animspiritext2_beg", private.clk_animspiritext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext2_end", private.clk_animspiritext2_end, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext2_end", private.clk_animspiritext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_animspiritext2()

  local func_end = function()
    cmn.SetEventDone( "clk_animspiritext2" );
    cmn.CallEventHandler( "clk_animspiritext2_end" );
    common_impl.Lock(0);
    ld.ShowBbt("animspiritext2");
    SoundTheme( "aud_danger_moment2_mus" )
  end;

  cmn.CallEventHandler( "clk_animspiritext2_beg" );
  common_impl.Lock(1);
  
  ld.AnimPlay( "anm_cryptext_anm_suzi", "anim_suzi", func_end );
  SoundSfx( "aud_clk_animspiritext2_cryptext" )
  SoundVoice("aud_clk_animspiritext2_cryptext_voc");
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animritualext" ] = { type = "click", use_place = "gfx_cryptext_clk_animritualext_zone", room = "rm_cryptext" };

private.clk_animritualext_logic = function()
  -- ObjSet( "spr_tombext_demoncardext", {active=1, input = 1, visible = 1} );
  ObjSet( "gfx_tombext_clk_demoncardext_zone", {active = 1, input = 1, visible = 1} );
end;
private.clk_animritualext_beg = function()
  ObjDelete( "gfx_cryptext_clk_animritualext_zone" );
end;
private.clk_animritualext_end = function()
  ObjSet( "anm_tombext_anm_hand", {animfunc = "use_demoncardext", frame = 0, playing = 0 } );
  ObjDelete("vid_cryptext_vid_animritual");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animritualext", private.clk_animritualext_beg, private.room_objname );
cmn.AddSubscriber( "clk_animritualext", private.clk_animritualext_end, private.room_objname );
cmn.AddSubscriber( "clk_animritualext", private.clk_animritualext_logic );
cmn.AddSubscriber( "clk_animritualext_beg", private.clk_animritualext_beg, private.room_objname );
cmn.AddSubscriber( "clk_animritualext_end", private.clk_animritualext_end, private.room_objname );
cmn.AddSubscriber( "clk_animritualext_end", private.clk_animritualext_logic );
--------------------------------------------------------------------------------------------
function public.clk_animritualext()

  local func_end = function()
    cmn.SetEventDone( "clk_animritualext" );
    cmn.CallEventHandler( "clk_animritualext_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_animritualext");
        SoundTheme( "aud_danger1_mus" )
  end;

  local func_preend = function()
     ld.Lock(1);
     SoundVoice(0);
   
     VidPause("vid_cryptext_vid_animritual",1)
     -- ObjAnimate( "vid_blackcastleext_outroext", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
     int.DialogVideoHide();
     SoundEnvHide(0);
     ld.StartTimer( 0.5, function() func_end(); end )
  end
  
  
  cmn.CallEventHandler( "clk_animritualext_beg" );
  common_impl.Lock(0);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_animritualext_cryptext" )
  --func_end()
  --VidPlay("vid_cryptext_vid_animritual", func_end);

  -- ObjAttach("vid_cryptext_vid_animritual","rm_cryptext");

  SoundEnvHide(1);
  
  VidPlay("vid_cryptext_vid_animritual",func_preend);
  int.DialogVideoShow( "vid_cryptext_vid_animritual", 1, func_preend, 1 );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_demoncardext_zone_clk()  --rm_cryptext.use_demoncardext_zone_clk()
  if cmn.IsEventDone("clk_animritualext") then 
     common_impl.ShowBbt( 'need_demoncardext' );
  else 
     ld.ShowBbt("cryptext_lekar_before_ritual");
  end;  
end;  

function public.use_demoncardext_menter()  --rm_cryptext.use_demoncardext_menter();
   if cmn.IsEventDone("clk_animritualext") then 
     ld.SetCursor( CURSOR_USE );
   else 
     
   end;  
end; 

common_impl.hint[ "use_demoncardext" ] = { type = "use", inv_obj = "inv_demoncardext", use_place = "gfx_cryptext_demoncardext_zone", room = "rm_cryptext" };

private.use_demoncardext_logic = function()
  ObjSet( "gfx_cryptext_dlg_cryptext_lekarext5_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_demoncardext_inv = function()
  common_impl.ProcessMultiUseAll("demoncardext", "demoncardext")
end;
private.use_demoncardext_beg = function()
  ObjDelete( "gfx_cryptext_demoncardext_zone" );
end;
private.use_demoncardext_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_demoncardext", private.use_demoncardext_inv );
cmn.AddSubscriber( "use_demoncardext", private.use_demoncardext_beg, private.room_objname );
cmn.AddSubscriber( "use_demoncardext", private.use_demoncardext_end, private.room_objname );
cmn.AddSubscriber( "use_demoncardext", private.use_demoncardext_logic );
cmn.AddSubscriber( "use_demoncardext_inv", private.use_demoncardext_inv, private.room_objname );
cmn.AddSubscriber( "use_demoncardext_beg", private.use_demoncardext_beg, private.room_objname );
cmn.AddSubscriber( "use_demoncardext_end", private.use_demoncardext_end, private.room_objname );
cmn.AddSubscriber( "use_demoncardext_end", private.use_demoncardext_logic );
--------------------------------------------------------------------------------------------
function public.use_demoncardext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_demoncardext" );
    cmn.CallEventHandler( "use_demoncardext_end" );
    common_impl.Lock(0);
    public.dlg_cryptext_lekarext5();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_demoncardext_inv" );
  cmn.CallEventHandler( "use_demoncardext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_demoncardext_cryptext" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "lekarext5" then
      if count_txt == 1 then
        
      elseif count_txt == 2 then    
        ld.Lock(1);
        AnimPlay( "anm_cryptext_lekarext5", "giv_susikey", function() ld.Lock(0);  end);
        SoundSfx( "aud_get_to_us" )  
      elseif  count_txt == 3 then
        cmn.CallEventHandler( "get_susiekeyext" );
        ObjSet( "spr_cryptext_susiekeyext", {visible = 1, active = 1 } );
        ld.Lock(1);
        -- SoundSfx( "aud_touch_paper_barnes" );
        AnimPlay( "anm_cryptext_lekarext5", "giv1", function() ld.Lock(0);   end);  
      elseif count_txt == 4 then 
        --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" )  
        
      end;  
  end;
    
  if dlg_name == "lekarext6" then
  
  end;    
end;




common_impl.hint[ "dlg_cryptext_lekarext5" ] = { type = "click", use_place = "gfx_cryptext_dlg_cryptext_lekarext5_zone", room = "rm_cryptext" };

private.dlg_cryptext_lekarext5_logic = function()
  ObjSet( "spr_cryptext_susiekeyext", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_cryptext_lekarext5_beg = function()
  ObjDelete( "gfx_cryptext_dlg_cryptext_lekarext5_zone" );
end;
private.dlg_cryptext_lekarext5_end = function()
  ObjSet( "anm_cryptext_anm_back", {animfunc = "man2", frame = 0, playing = 1 } );
  ObjSet( "obj_cryptext_lekar_clk_zone", {active = 1, input = 1, visible = 1} );

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_cryptext_lekarext5", private.dlg_cryptext_lekarext5_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext5", private.dlg_cryptext_lekarext5_end, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext5", private.dlg_cryptext_lekarext5_logic );
cmn.AddSubscriber( "dlg_cryptext_lekarext5_beg", private.dlg_cryptext_lekarext5_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext5_end", private.dlg_cryptext_lekarext5_end, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext5_end", private.dlg_cryptext_lekarext5_logic );
--------------------------------------------------------------------------------------------
function public.dlg_cryptext_lekarext5( obj )
--
--  local func_end = function()
--    cmn.SetEventDone( "dlg_cryptext_lekarext5" );
--    cmn.CallEventHandler( "dlg_cryptext_lekarext5_end" );
--    common_impl.Lock(0);
--    ld.ShowBbt("after_dlg_lekarext5");
--  end;
--
--  cmn.CallEventHandler( "dlg_cryptext_lekarext5_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  --SoundSfx( 0 )
--  func_end()

  
  local func_end = function()
    cmn.SetEventDone( "dlg_cryptext_lekarext5" );
    cmn.CallEventHandler( "dlg_cryptext_lekarext5_end" );
    cmn.SetEventDone( "get_susiekeyext" );
    if ObjGetRelations( "inv_susiekeyext" ).parent == "levelext_inv_hub" then
        ObjSet( "spr_cryptext_susiekeyext", {visible = 1} );
        cmn.CallEventHandler( "get_susiekeyext" );
      end
    common_impl.Lock(0);
   ld.ShowBbt("after_dlg_lekarext5");
  end;

 function public.dlg_cryptext_lekarext5_end()
    ObjSet( "dlg_cryptext_lekarext5", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_cryptext_lekarext5_beg" );
  

  common_impl.dialog_character_loc = "anm_cryptext_anm_back"
  common_impl.continue_visible = false;
  common_impl.Start( "lekarext5", 3, nil, nil, true, "dlg_cryptext_lekarext5_end",{"aud_barnes_11_voc","aud_barnes_12_voc"} );
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_susiekeyext" ] = { type = "get", get_obj = "spr_cryptext_susiekeyext", room = "rm_cryptext" };

private.get_susiekeyext_logic = function()
  
end;
private.get_susiekeyext_inv = function()
  interface.InventoryItemAdd("inv_susiekeyext","spr_cryptext_susiekeyext");
end;
private.get_susiekeyext_beg = function()
  ObjDelete("gfx_cryptext_susiekeyext")
end;
private.get_susiekeyext_end = function()
  
end;

cmn.AddSubscriber( "get_susiekeyext", private.get_susiekeyext_inv );
cmn.AddSubscriber( "get_susiekeyext", private.get_susiekeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_susiekeyext", private.get_susiekeyext_end, private.room_objname );
cmn.AddSubscriber( "get_susiekeyext", private.get_susiekeyext_logic );
--------------------------------------------------------------------
function public.get_susiekeyext()
  cmn.SetEventDone( "get_susiekeyext" );
  cmn.CallEventHandler( "get_susiekeyext" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_demonattackext" ] = { type = "click", use_place = "gfx_cryptext_clk_demonattackext_zone", room = "rm_cryptext" };

private.clk_demonattackext_logic = function()
  --ObjSet( "gzz_toyworldext_toabyssext", {visible = 1, input = 1, activ = 1} );
  -- ObjSet( "gzz_toyworldext_bigbearext", {visible = 1, input = 1, activ = 1} );
  --ObjSet( "gzz_toyworldext_chestext", {visible = 1, input = 1, activ = 1} );
  --ObjSet( "gzz_toyworldext_soldiersext", {visible = 1, input = 1, activ = 1} );
  ObjSet( "gfx_cryptext_dlg_cryptext_lekarext6_zone", {active = 1, input = 1, visible = 1} );
end;
private.clk_demonattackext_beg = function()
  ObjDelete( "gfx_cryptext_clk_demonattackext_zone" );
end;
private.clk_demonattackext_end = function()
  --ObjSet( "obj_toyworldext_idle1_clk_zone", {visible = 1, input = 1, activ = 1} );  
  --ObjSet( "obj_toyworldext_idle2_clk_zone", {visible = 1, input = 1, activ = 1} );  
  ObjDelete("vid_cryptext_vid_demonattack");
  ObjDelete("obj_cryptext_lekar_clk_zone");
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_demonattackext", private.clk_demonattackext_beg, private.room_objname );
cmn.AddSubscriber( "clk_demonattackext", private.clk_demonattackext_end, private.room_objname );
cmn.AddSubscriber( "clk_demonattackext", private.clk_demonattackext_logic );
cmn.AddSubscriber( "clk_demonattackext_beg", private.clk_demonattackext_beg, private.room_objname );
cmn.AddSubscriber( "clk_demonattackext_end", private.clk_demonattackext_end, private.room_objname );
cmn.AddSubscriber( "clk_demonattackext_end", private.clk_demonattackext_logic );
--------------------------------------------------------------------------------------------
function public.clk_demonattackext()

 -- local func_end = function()
 --   cmn.SetEventDone( "clk_demonattackext" );
 --   cmn.CallEventHandler( "clk_demonattackext_end" );
 --   common_impl.Lock(0);
 --   
 --   ld.ShowBbt("after_demonattackext");
 --   -- cmn.GotoRoom( "rm_cryptext" )
 --   public.dlg_cryptext_lekarext6();
 -- end;

 -- cmn.CallEventHandler( "clk_demonattackext_beg" );
 -- common_impl.Lock(1);
 -- 
 -- 
 -- SoundSfx( "aud_clk_demonattackext_toyworldext" )
 -- func_end()

  local func_end = function()
    cmn.SetEventDone( "clk_demonattackext" );
    cmn.CallEventHandler( "clk_demonattackext_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_demonattackext");
    SoundTheme( "aud_danger1_mus" )
    public.dlg_cryptext_lekarext6();
  end;

  local func_preend = function()
     ld.Lock(1);
     SoundVoice(0);
   
     VidPause("vid_cryptext_vid_demonattack",1)
     int.DialogVideoHide();
     SoundEnvHide(0);
     ld.StartTimer( 0.3, function() func_end(); end )
  end
  
  
  cmn.CallEventHandler( "clk_demonattackext_beg" );
  common_impl.Lock(0);

 
  
  SoundEnvHide(1);
  ObjAnimate( "vid_cryptext_vid_demonattack", 8, 0, 0, function ()SoundSfx( "aud_clk_demonattackext_toyworldext" );SoundVoice("aud_clk_demonattackext_toyworldext_voc") end, {0,0,1, 0,0,1} );
  VidPlay("vid_cryptext_vid_demonattack",func_preend);
  int.DialogVideoShow( "vid_cryptext_vid_demonattack", 1, func_preend, 1 );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_cryptext_lekarext6" ] = { type = "click", use_place = "gfx_cryptext_dlg_cryptext_lekarext6_zone", room = "rm_cryptext" };

private.dlg_cryptext_lekarext6_logic = function()
  ObjSet( "gmg_cryptext_demonriddleext", { visible = 1, input = 1, active = 1 } )
  
end;
private.dlg_cryptext_lekarext6_beg = function()
  ObjDelete( "gfx_cryptext_dlg_cryptext_lekarext6_zone" );
end;
private.dlg_cryptext_lekarext6_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_cryptext_lekarext6", private.dlg_cryptext_lekarext6_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext6", private.dlg_cryptext_lekarext6_end, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext6", private.dlg_cryptext_lekarext6_logic );
cmn.AddSubscriber( "dlg_cryptext_lekarext6_beg", private.dlg_cryptext_lekarext6_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext6_end", private.dlg_cryptext_lekarext6_end, private.room_objname );
cmn.AddSubscriber( "dlg_cryptext_lekarext6_end", private.dlg_cryptext_lekarext6_logic );
--------------------------------------------------------------------------------------------
function public.dlg_cryptext_lekarext6( obj )

 -- local func_end = function()
 --   cmn.SetEventDone( "dlg_cryptext_lekarext6" );
 --   cmn.CallEventHandler( "dlg_cryptext_lekarext6_end" );
 --   common_impl.Lock(0);
 --   ld.ShowBbt("after_dlg_lekarext6");
 -- end;

 -- cmn.CallEventHandler( "dlg_cryptext_lekarext6_beg" );
 -- common_impl.Lock(1);

 -- --ld.AnimPlay( "", "", func_end );
 -- --SoundSfx( 0 )
 -- func_end()

  local func_end = function()
    cmn.SetEventDone( "dlg_cryptext_lekarext6" );
    cmn.CallEventHandler( "dlg_cryptext_lekarext6_end" );
   -- cmn.SetEventDone( "get_susiekeyext" );
   -- if ObjGetRelations( "inv_susiekeyext" ).parent == "levelext_inv_hub" then
   --     ObjSet( "spr_cryptext_susiekeyext", {visible = 1} );
   --     cmn.CallEventHandler( "get_susiekeyext" );
   --   end
   --common_impl.Lock(0);
    ld.ShowBbt("after_dlg_lekarext6");
    
    ld.StartTimer( 0.3, function() ld.Lock(0); cmn.GotoRoom("mg_demonriddleext"); end ) 
  end;

  function public.dlg_cryptext_lekarext6_end()
    ObjSet( "dlg_cryptext_lekarext6", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_cryptext_lekarext6_beg" );
  

 common_impl.dialog_character_loc = "anm_cryptext_anm_back"
  common_impl.continue_visible = false;
  common_impl.Start( "lekarext6", 2, nil, nil, true, "dlg_cryptext_lekarext6_end",{"aud_barnes_13_voc"} );
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tombext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animlivesusieext" ] = { type = "click", use_place = "gfx_tombext_clk_animlivesusieext_zone", room = "rm_cryptext", zz = "zz_tombext", zz_gate = "gzz_cryptext_tombext" };

private.clk_animlivesusieext_logic = function()
  ObjSet( "spr_tombext_bowext2", { visible = 1, input = 1, active = 1 } )

end;
private.clk_animlivesusieext_beg = function()
  ObjDelete( "gfx_tombext_clk_animlivesusieext_zone" );
end;
private.clk_animlivesusieext_end = function()
  if common_impl.ZzCompleteCheck("clk_animlivesusieext") then ObjSet( common_impl.hint["clk_animlivesusieext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_tombext_sh_bowext2", {visible = 1} );
  ObjSet( "anm_tombext_anm", {animfunc = "static", frame = 0, playing=1 } );
  ObjSet( "anm_tombext_anm_wreath", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animlivesusieext", private.clk_animlivesusieext_beg, private.room_objname );
cmn.AddSubscriber( "clk_animlivesusieext", private.clk_animlivesusieext_end, private.room_objname );
cmn.AddSubscriber( "clk_animlivesusieext", private.clk_animlivesusieext_logic );
cmn.AddSubscriber( "clk_animlivesusieext_beg", private.clk_animlivesusieext_beg, private.room_objname );
cmn.AddSubscriber( "clk_animlivesusieext_end", private.clk_animlivesusieext_end, private.room_objname );
cmn.AddSubscriber( "clk_animlivesusieext_end", private.clk_animlivesusieext_logic );
--------------------------------------------------------------------------------------------
function public.clk_animlivesusieext()

  local func_end = function()
    cmn.SetEventDone( "clk_animlivesusieext" );
    cmn.CallEventHandler( "clk_animlivesusieext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_animlivesusieext") then ld.CloseSubRoom() end;
    ld.ShowBbt("after_animlivesusieext");
  end;

  cmn.CallEventHandler( "clk_animlivesusieext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tombext_anm", "awakening", func_end );
  SoundSfx( "aud_clk_animlivesusieext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bowext2" ] = { type = "get", get_obj = "spr_tombext_bowext2", room = "rm_cryptext", zz = "zz_tombext", zz_gate = "gzz_cryptext_tombext" };

private.get_bowext2_logic = function()
  
end;
private.get_bowext2_inv = function()
  interface.InventoryItemAdd("inv_bowext","spr_tombext_bowext2",function() level_inv.ProcessGetBowextAll( "get_bowext2" ) end);
end;
private.get_bowext2_beg = function()
  ObjDelete("gfx_tombext_bowext2")
end;
private.get_bowext2_end = function()
  if common_impl.ZzCompleteCheck("get_bowext2") then ObjSet( common_impl.hint["get_bowext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tombext_sh_bowext2");
end;

cmn.AddSubscriber( "get_bowext2", private.get_bowext2_inv );
cmn.AddSubscriber( "get_bowext2", private.get_bowext2_beg, private.room_objname );
cmn.AddSubscriber( "get_bowext2", private.get_bowext2_end, private.room_objname );
cmn.AddSubscriber( "get_bowext2", private.get_bowext2_logic );
--------------------------------------------------------------------
function public.get_bowext2()
  cmn.SetEventDone( "get_bowext2" );
  cmn.CallEventHandler( "get_bowext2" );
  if common_impl.ZzCompleteCheck("get_bowext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_demoncardext" ] = { type = "click", use_place = "gfx_tombext_clk_demoncardext_zone", room = "rm_cryptext", zz = "zz_tombext", zz_gate = "gzz_cryptext_tombext" };

private.clk_demoncardext_logic = function()
  ObjSet( "spr_tombext_demoncardext", {active = 1, input = 1, visible = 1} );
end;
private.clk_demoncardext_beg = function()
  ObjDelete( "gfx_tombext_clk_demoncardext_zone" );
end;
private.clk_demoncardext_end = function()
  if common_impl.ZzCompleteCheck("clk_demoncardext") then ObjSet( common_impl.hint["clk_demoncardext"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjSet( "anm_tombext_anm_hand", {animfunc = "use_demoncardext", frame = 999 } );
  ObjSet( "anm_tombext_anm_hand", {animfunc = "static_hand", frame = 0, playing = 1 } );  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_demoncardext", private.clk_demoncardext_beg, private.room_objname );
cmn.AddSubscriber( "clk_demoncardext", private.clk_demoncardext_end, private.room_objname );
cmn.AddSubscriber( "clk_demoncardext", private.clk_demoncardext_logic );
cmn.AddSubscriber( "clk_demoncardext_beg", private.clk_demoncardext_beg, private.room_objname );
cmn.AddSubscriber( "clk_demoncardext_end", private.clk_demoncardext_end, private.room_objname );
cmn.AddSubscriber( "clk_demoncardext_end", private.clk_demoncardext_logic );
--------------------------------------------------------------------------------------------
function public.clk_demoncardext()

  local func_end = function()
    --cmn.SetEventDone( "get_demoncardext" );
    --cmn.SetEventDone( "clk_demoncardext" );
    cmn.CallEventHandler( "clk_demoncardext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_demoncardext") then ld.CloseSubRoom() end;
    ld.ShowBbt("cryptext_big_demoncard_clk");
  end;

  cmn.CallEventHandler( "clk_demoncardext_beg" );
  common_impl.Lock(1);
  SoundSfx( "aud_touch_demon_card_cryptext" )
  ld.AnimPlay( "anm_tombext_anm_hand", "use_demoncardext", func_end );
 
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_demoncardext" ] = { type = "get", get_obj = "spr_tombext_demoncardext", room = "rm_cryptext", zz = "zz_tombext", zz_gate = "gzz_cryptext_tombext" };

private.get_demoncardext_logic = function()
  
end;
private.get_demoncardext_inv = function()
  interface.InventoryItemAdd("inv_demoncardext","spr_tombext_demoncardext");
end;
private.get_demoncardext_beg = function()
  ObjDelete("gfx_tombext_demoncardext")
end;
private.get_demoncardext_end = function()
  if common_impl.ZzCompleteCheck("get_demoncardext") then ObjSet( common_impl.hint["get_demoncardext"].zz_gate, { visible = 0, input = 0 } ); end;
 
end;

cmn.AddSubscriber( "get_demoncardext", private.get_demoncardext_inv );
cmn.AddSubscriber( "get_demoncardext", private.get_demoncardext_beg, private.room_objname );
cmn.AddSubscriber( "get_demoncardext", private.get_demoncardext_end, private.room_objname );
cmn.AddSubscriber( "get_demoncardext", private.get_demoncardext_logic );
--------------------------------------------------------------------
function public.get_demoncardext()
    cmn.SetEventDone( "get_demoncardext" );
    cmn.SetEventDone( "clk_demoncardext" );
  cmn.CallEventHandler( "get_demoncardext" );
  if common_impl.ZzCompleteCheck("get_demoncardext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_wreathext_zone_clk()  --rm_cryptext.use_wreathext_zone_clk()
  if cmn.IsEventDone("dlg_cryptext_lekarext5") then 
    common_impl.ShowBbt( 'need_wreathext' )
  else 
    ld.ShowBbt("after_animlivesusieext");
  end;  
end;  



common_impl.hint[ "use_wreathext" ] = { type = "use", inv_obj = "inv_wreathext", use_place = "gfx_tombext_wreathext_zone", room = "rm_cryptext", zz = "zz_tombext", zz_gate = "gzz_cryptext_tombext" };

private.use_wreathext_logic = function()
  --ObjSet( "grm_cryptext_toyworldext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_cryptext_clk_demonattackext_zone", {active = 1, input = 1, visible = 1 } );
end;
private.use_wreathext_inv = function()
  common_impl.ProcessMultiUseAll("wreathext", "wreathext")
end;
private.use_wreathext_beg = function()
  ObjDelete( "gfx_tombext_wreathext_zone" );
end;
private.use_wreathext_end = function()
  if common_impl.ZzCompleteCheck("use_wreathext") then ObjSet( common_impl.hint["use_wreathext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_tombext_anm_wreath", {animfunc = "use_wreath", frame = 999 } );
  ObjSet( "spr_cryptext_wreath", {visible = 1} );
  ObjSet( "fx_cryptext_pm_back2", {active = 1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wreathext", private.use_wreathext_inv );
cmn.AddSubscriber( "use_wreathext", private.use_wreathext_beg, private.room_objname );
cmn.AddSubscriber( "use_wreathext", private.use_wreathext_end, private.room_objname );
cmn.AddSubscriber( "use_wreathext", private.use_wreathext_logic );
cmn.AddSubscriber( "use_wreathext_inv", private.use_wreathext_inv, private.room_objname );
cmn.AddSubscriber( "use_wreathext_beg", private.use_wreathext_beg, private.room_objname );
cmn.AddSubscriber( "use_wreathext_end", private.use_wreathext_end, private.room_objname );
cmn.AddSubscriber( "use_wreathext_end", private.use_wreathext_logic );
--------------------------------------------------------------------------------------------
function public.use_wreathext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wreathext" );
    cmn.CallEventHandler( "use_wreathext_end" );
    --common_impl.Lock(0);
    -- if common_impl.ZzCompleteCheck("use_wreathext") then 
    ld.CloseSubRoom();-- end;
    ld.StartTimer( 0.3, function() ld.Lock(0); public.clk_demonattackext(); end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wreathext_inv" );
  cmn.CallEventHandler( "use_wreathext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tombext_anm_wreath", "use_wreath", func_end );
  SoundSfx( "aud_use_wreathext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "win_susiedreamsext" ] = { type = "click", use_place = "gfx_tombext_win_susiedreamsext_zone", room = "rm_cryptext", zz = "zz_tombext", zz_gate = "gzz_cryptext_tombext" };
--
--private.win_susiedreamsext_logic = function()
--  ObjSet( "grm_cryptext_toyworldext", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.win_susiedreamsext_beg = function()
--  ObjDelete( "gfx_tombext_win_susiedreamsext_zone" );
--end;
--private.win_susiedreamsext_end = function()
--  if common_impl.ZzCompleteCheck("win_susiedreamsext") then ObjSet( common_impl.hint["win_susiedreamsext"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "win_susiedreamsext", private.win_susiedreamsext_beg, private.room_objname );
--cmn.AddSubscriber( "win_susiedreamsext", private.win_susiedreamsext_end, private.room_objname );
--cmn.AddSubscriber( "win_susiedreamsext", private.win_susiedreamsext_logic );
--cmn.AddSubscriber( "win_susiedreamsext_beg", private.win_susiedreamsext_beg, private.room_objname );
--cmn.AddSubscriber( "win_susiedreamsext_end", private.win_susiedreamsext_end, private.room_objname );
--cmn.AddSubscriber( "win_susiedreamsext_end", private.win_susiedreamsext_logic );
----------------------------------------------------------------------------------------------
--function public.win_susiedreamsext()
--
--  local func_end = function()
--    cmn.SetEventDone( "win_susiedreamsext" );
--    cmn.CallEventHandler( "win_susiedreamsext_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("win_susiedreamsext") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "win_susiedreamsext_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  --SoundSfx( 0 )
--  func_end()
--
--end;
----------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ritualcircleext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_partpuzzleext" ] = { type = "get", get_obj = "spr_ritualcircleext_partpuzzleext", room = "rm_cryptext", zz = "zz_ritualcircleext", zz_gate = "gzz_cryptext_ritualcircleext" };

private.get_partpuzzleext_logic = function()
  
end;
private.get_partpuzzleext_inv = function()
  interface.InventoryItemAdd("inv_partpuzzleext","spr_ritualcircleext_partpuzzleext");
end;
private.get_partpuzzleext_beg = function()
  ObjDelete("gfx_ritualcircleext_partpuzzleext")
end;
private.get_partpuzzleext_end = function()
  if common_impl.ZzCompleteCheck("get_partpuzzleext") then ObjSet( common_impl.hint["get_partpuzzleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_ritualcircleext_sh_partpuzzleext");
  ObjDelete("spr_cryptext_sh_partpuzzleext");
  ObjDelete("spr_cryptext_partpuzzleext");
end;

cmn.AddSubscriber( "get_partpuzzleext", private.get_partpuzzleext_inv );
cmn.AddSubscriber( "get_partpuzzleext", private.get_partpuzzleext_beg, private.room_objname );
cmn.AddSubscriber( "get_partpuzzleext", private.get_partpuzzleext_end, private.room_objname );
cmn.AddSubscriber( "get_partpuzzleext", private.get_partpuzzleext_logic );
--------------------------------------------------------------------
function public.get_partpuzzleext()
  cmn.SetEventDone( "get_partpuzzleext" );
  cmn.CallEventHandler( "get_partpuzzleext" );
  if common_impl.ZzCompleteCheck("get_partpuzzleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ritualrecipeext" ] = { type = "use", inv_obj = "inv_ritualrecipeext", use_place = "gfx_ritualcircleext_ritualrecipeext_zone", room = "rm_cryptext", zz = "zz_ritualcircleext", zz_gate = "gzz_cryptext_ritualcircleext" };

private.use_ritualrecipeext_logic = function()
  ObjSet( "gfx_ritualcircleext_limestoneext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_ritualcircleext_lightedcandlesext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_ritualcircleext_ritualbookext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_ritualcircleext_magicdustext_zone", { visible = 1, input = 1, active = 1 } )
  
  ObjSet( "anm_ritualcircleext_anm_paper", {input = 1} );
end;
private.use_ritualrecipeext_inv = function()
  common_impl.ProcessMultiUseAll("ritualrecipeext", "ritualrecipeext")
end;
private.use_ritualrecipeext_beg = function()
  ObjDelete( "gfx_ritualcircleext_ritualrecipeext_zone" );
end;
private.use_ritualrecipeext_end = function()
  if common_impl.ZzCompleteCheck("use_ritualrecipeext") then ObjSet( common_impl.hint["use_ritualrecipeext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ritualcircleext_anm_paper", {animfunc = "use_paper", frame = 999 } );
  ObjSet("spr_cryptext_paper",{visible=1});
  ObjSet("spr_cryptext_sh_paper",{visible=1});
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ritualrecipeext", private.use_ritualrecipeext_inv );
cmn.AddSubscriber( "use_ritualrecipeext", private.use_ritualrecipeext_beg, private.room_objname );
cmn.AddSubscriber( "use_ritualrecipeext", private.use_ritualrecipeext_end, private.room_objname );
cmn.AddSubscriber( "use_ritualrecipeext", private.use_ritualrecipeext_logic );
cmn.AddSubscriber( "use_ritualrecipeext_inv", private.use_ritualrecipeext_inv, private.room_objname );
cmn.AddSubscriber( "use_ritualrecipeext_beg", private.use_ritualrecipeext_beg, private.room_objname );
cmn.AddSubscriber( "use_ritualrecipeext_end", private.use_ritualrecipeext_end, private.room_objname );
cmn.AddSubscriber( "use_ritualrecipeext_end", private.use_ritualrecipeext_logic );
--------------------------------------------------------------------------------------------
function public.use_ritualrecipeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ritualrecipeext" );
    cmn.CallEventHandler( "use_ritualrecipeext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ritualrecipeext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ritualrecipeext_inv" );
  cmn.CallEventHandler( "use_ritualrecipeext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ritualcircleext_anm_paper", "use_paper", func_end );
  SoundSfx( "aud_use_ritualrecipeext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_limestoneext" ] = { type = "use", inv_obj = "inv_limestoneext", use_place = "gfx_ritualcircleext_limestoneext_zone", room = "rm_cryptext", zz = "zz_ritualcircleext", zz_gate = "gzz_cryptext_ritualcircleext" };

private.use_limestoneext_logic = function()
  if ld.CheckRequirements( {"use_limestoneext","use_lightedcandlesext","use_ritualbookext","use_magicdustext"} ) then
    ObjSet( "spr_ritualcircleext_back_mmg", {active=1, alp=1, input=1, visible = 1} );
  end;

end;
private.use_limestoneext_inv = function()
  common_impl.ProcessMultiUseAll("limestoneext", "limestoneext")
end;
private.use_limestoneext_beg = function()
  ObjDelete( "gfx_ritualcircleext_limestoneext_zone" );
end;
private.use_limestoneext_end = function()
  if common_impl.ZzCompleteCheck("use_limestoneext") then ObjSet( common_impl.hint["use_limestoneext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ritualcircleext_anm_limestone", {animfunc = "use_limestone", frame = 999 } );
  if ld.CheckRequirements( {"use_limestoneext","use_lightedcandlesext","use_ritualbookext","use_magicdustext"} ) then
    -- ObjDelete("anm_ritualcircleext_anm_light");
     ObjSet( "spr_ritualcircleext_back_mmg", {alp=1, input=1, visible = 1} );
  end;   
  ObjSet( "spr_cryptext_limestoneext", {visible = 1} );
  ObjSet( "spr_cryptext_sh_limestoneext", {visible = 1} ); 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_limestoneext", private.use_limestoneext_inv );
cmn.AddSubscriber( "use_limestoneext", private.use_limestoneext_beg, private.room_objname );
cmn.AddSubscriber( "use_limestoneext", private.use_limestoneext_end, private.room_objname );
cmn.AddSubscriber( "use_limestoneext", private.use_limestoneext_logic );
cmn.AddSubscriber( "use_limestoneext_inv", private.use_limestoneext_inv, private.room_objname );
cmn.AddSubscriber( "use_limestoneext_beg", private.use_limestoneext_beg, private.room_objname );
cmn.AddSubscriber( "use_limestoneext_end", private.use_limestoneext_end, private.room_objname );
cmn.AddSubscriber( "use_limestoneext_end", private.use_limestoneext_logic );
--------------------------------------------------------------------------------------------
function public.use_limestoneext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_limestoneext" );
    cmn.CallEventHandler( "use_limestoneext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_limestoneext") then ld.CloseSubRoom() end;
  end;

  local func_preend2 = function()
    ObjSet( "spr_ritualcircleext_back_mmg", {visible = 1} );
    ObjAnimate( "spr_ritualcircleext_back_mmg", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
    private.init_mysterycircleext();
    cmn.MiniGameShow( "mysterycircleext" ); 
    --private.init_mysterycircleext()
  end;  
  
  
  local func_preend = function()
    if ld.CheckRequirements( {"use_lightedcandlesext","use_ritualbookext","use_magicdustext"} ) then
      --ld.AnimPlay( "anm_ritualcircleext_anm_light", "light", func_preend2 ); 
      func_preend2(); 
    else 
       func_end();
    end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_limestoneext_inv" );
  cmn.CallEventHandler( "use_limestoneext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ritualcircleext_anm_limestone", "use_limestone", func_preend );
  SoundSfx( "aud_use_limestoneext_cryptext" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lightedcandlesext" ] = { type = "use", inv_obj = "inv_lightedcandlesext", use_place = "gfx_ritualcircleext_lightedcandlesext_zone", room = "rm_cryptext", zz = "zz_ritualcircleext", zz_gate = "gzz_cryptext_ritualcircleext" };

private.use_lightedcandlesext_logic = function()
  if ld.CheckRequirements( {"use_lightedcandlesext","use_limestoneext","use_ritualbookext","use_magicdustext"} ) then
    ObjSet( "spr_ritualcircleext_back_mmg", {active=1, alp=1, input=1, visible = 1} );
  end;

end;
private.use_lightedcandlesext_inv = function()
  common_impl.ProcessMultiUseAll("lightedcandlesext", "lightedcandlesext")
end;
private.use_lightedcandlesext_beg = function()
  ObjDelete( "gfx_ritualcircleext_lightedcandlesext_zone" );
end;
private.use_lightedcandlesext_end = function()
  if common_impl.ZzCompleteCheck("use_lightedcandlesext") then ObjSet( common_impl.hint["use_lightedcandlesext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ritualcircleext_anm_candles", {animfunc = "fire", playing = 1} );
  if ld.CheckRequirements( {"use_lightedcandlesext","use_limestoneext","use_ritualbookext","use_magicdustext"} ) then
    -- ObjDelete("anm_ritualcircleext_anm_light");
     ObjSet( "spr_ritualcircleext_back_mmg", {alp=1, input=1, visible = 1} );
  end;   
  ObjSet( "spr_cryptext_candles", {visible = 1} ); 
  ObjSet( "fx_cryptext_pm_fire", {active = 1, visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lightedcandlesext", private.use_lightedcandlesext_inv );
cmn.AddSubscriber( "use_lightedcandlesext", private.use_lightedcandlesext_beg, private.room_objname );
cmn.AddSubscriber( "use_lightedcandlesext", private.use_lightedcandlesext_end, private.room_objname );
cmn.AddSubscriber( "use_lightedcandlesext", private.use_lightedcandlesext_logic );
cmn.AddSubscriber( "use_lightedcandlesext_inv", private.use_lightedcandlesext_inv, private.room_objname );
cmn.AddSubscriber( "use_lightedcandlesext_beg", private.use_lightedcandlesext_beg, private.room_objname );
cmn.AddSubscriber( "use_lightedcandlesext_end", private.use_lightedcandlesext_end, private.room_objname );
cmn.AddSubscriber( "use_lightedcandlesext_end", private.use_lightedcandlesext_logic );
--------------------------------------------------------------------------------------------
function public.use_lightedcandlesext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lightedcandlesext" );
    cmn.CallEventHandler( "use_lightedcandlesext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lightedcandlesext") then ld.CloseSubRoom() end;
  end;

  local func_preend2 = function()
    ObjSet( "spr_ritualcircleext_back_mmg", {visible = 1} );
    ObjAnimate( "spr_ritualcircleext_back_mmg", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
    private.init_mysterycircleext();
    cmn.MiniGameShow( "mysterycircleext" ); 
    -- private.init_mysterycircleext()
  end;  
  
  local func_preend = function()
    if ld.CheckRequirements( {"use_limestoneext","use_ritualbookext","use_magicdustext"} ) then
      --  ld.AnimPlay( "anm_ritualcircleext_anm_light", "light", func_preend2 );  
      func_preend2();
    else 
       func_end();
    end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lightedcandlesext_inv" );
  cmn.CallEventHandler( "use_lightedcandlesext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ritualcircleext_anm_candles", "use_candles", func_preend );
  SoundSfx( "aud_use_lightedcandlesext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ritualbookext" ] = { type = "use", inv_obj = "inv_ritualbookext", use_place = "gfx_ritualcircleext_ritualbookext_zone", room = "rm_cryptext", zz = "zz_ritualcircleext", zz_gate = "gzz_cryptext_ritualcircleext" };

private.use_ritualbookext_logic = function()
  if ld.CheckRequirements( {"use_ritualbookext","use_limestoneext","use_lightedcandlesext","use_magicdustext"} ) then
    ObjSet( "spr_ritualcircleext_back_mmg", {active=1, alp=1, input=1, visible = 1} );
  end;

end;
private.use_ritualbookext_inv = function()
  common_impl.ProcessMultiUseAll("ritualbookext", "ritualbookext")
end;
private.use_ritualbookext_beg = function()
  ObjDelete( "gfx_ritualcircleext_ritualbookext_zone" );
end;
private.use_ritualbookext_end = function()
  if common_impl.ZzCompleteCheck("use_ritualbookext") then ObjSet( common_impl.hint["use_ritualbookext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ritualcircleext_anm_book", {animfunc = "use_book", frame = 999 } );
  if ld.CheckRequirements( {"use_ritualbookext","use_limestoneext","use_lightedcandlesext","use_magicdustext"} ) then
    -- ObjDelete("anm_ritualcircleext_anm_light");
     ObjSet( "spr_ritualcircleext_back_mmg", {alp=1, input=1, visible = 1} );
  end;  
  ObjSet( "spr_cryptext_book", {visible = 1} ); 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ritualbookext", private.use_ritualbookext_inv );
cmn.AddSubscriber( "use_ritualbookext", private.use_ritualbookext_beg, private.room_objname );
cmn.AddSubscriber( "use_ritualbookext", private.use_ritualbookext_end, private.room_objname );
cmn.AddSubscriber( "use_ritualbookext", private.use_ritualbookext_logic );
cmn.AddSubscriber( "use_ritualbookext_inv", private.use_ritualbookext_inv, private.room_objname );
cmn.AddSubscriber( "use_ritualbookext_beg", private.use_ritualbookext_beg, private.room_objname );
cmn.AddSubscriber( "use_ritualbookext_end", private.use_ritualbookext_end, private.room_objname );
cmn.AddSubscriber( "use_ritualbookext_end", private.use_ritualbookext_logic );
--------------------------------------------------------------------------------------------
function public.use_ritualbookext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ritualbookext" );
    cmn.CallEventHandler( "use_ritualbookext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ritualbookext") then ld.CloseSubRoom() end;
  end;

  local func_preend2 = function()
    ObjSet( "spr_ritualcircleext_back_mmg", {visible = 1} );
    ObjAnimate( "spr_ritualcircleext_back_mmg", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
    private.init_mysterycircleext();
    cmn.MiniGameShow( "mysterycircleext" ); 
    --private.init_mysterycircleext()
  end;  
  
  local func_preend = function()
    if ld.CheckRequirements(  {"use_limestoneext","use_lightedcandlesext","use_magicdustext"}  ) then
      -- ld.AnimPlay( "anm_ritualcircleext_anm_light", "light", func_preend2 );  
      func_preend2();
    else 
       func_end();
    end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ritualbookext_inv" );
  cmn.CallEventHandler( "use_ritualbookext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ritualcircleext_anm_book", "use_book", func_preend );
  SoundSfx( "aud_use_ritualbookext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_magicdustext" ] = { type = "use", inv_obj = "inv_magicdustext", use_place = "gfx_ritualcircleext_magicdustext_zone", room = "rm_cryptext", zz = "zz_ritualcircleext", zz_gate = "gzz_cryptext_ritualcircleext" };

private.use_magicdustext_logic = function()
  if ld.CheckRequirements( {"use_magicdustext","use_limestoneext","use_lightedcandlesext","use_ritualbookext"} ) then
     ObjSet( "spr_ritualcircleext_back_mmg", {active=1, alp=1, input=1, visible = 1} );
  end;

end;
private.use_magicdustext_inv = function()
  common_impl.ProcessMultiUseAll("magicdustext", "magicdustext")
end;
private.use_magicdustext_beg = function()
  ObjDelete( "gfx_ritualcircleext_magicdustext_zone" );
end;
private.use_magicdustext_end = function()
  if common_impl.ZzCompleteCheck("use_magicdustext") then ObjSet( common_impl.hint["use_magicdustext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ritualcircleext_anm_magic", {animfunc = "use_magic", frame = 999 } );
  if ld.CheckRequirements( {"use_ritualbookext","use_limestoneext","use_lightedcandlesext","use_magicdustext"} ) then
    -- ObjDelete("anm_ritualcircleext_anm_light");
     ObjSet( "spr_ritualcircleext_back_mmg", {alp=1, input=1, visible = 1} );
  end; 
  ObjSet( "spr_cryptext_magic_pollen", {visible = 1} );
  ObjSet( "spr_cryptext_sh_magic_pollen", {visible = 1} ); 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_magicdustext", private.use_magicdustext_inv );
cmn.AddSubscriber( "use_magicdustext", private.use_magicdustext_beg, private.room_objname );
cmn.AddSubscriber( "use_magicdustext", private.use_magicdustext_end, private.room_objname );
cmn.AddSubscriber( "use_magicdustext", private.use_magicdustext_logic );
cmn.AddSubscriber( "use_magicdustext_inv", private.use_magicdustext_inv, private.room_objname );
cmn.AddSubscriber( "use_magicdustext_beg", private.use_magicdustext_beg, private.room_objname );
cmn.AddSubscriber( "use_magicdustext_end", private.use_magicdustext_end, private.room_objname );
cmn.AddSubscriber( "use_magicdustext_end", private.use_magicdustext_logic );
--------------------------------------------------------------------------------------------
function public.use_magicdustext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_magicdustext" );
    cmn.CallEventHandler( "use_magicdustext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_magicdustext") then ld.CloseSubRoom() end;
  end;

  local func_preend2 = function()
    ObjSet( "spr_ritualcircleext_back_mmg", {visible = 1} );
    ObjAnimate( "spr_ritualcircleext_back_mmg", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
    private.init_mysterycircleext();
    cmn.MiniGameShow( "mysterycircleext" ); 
    --   private.init_mysterycircleext()
  end;  
  
  local func_preend = function()
    if ld.CheckRequirements(  {"use_limestoneext","use_lightedcandlesext","use_ritualbookext"} ) then
      -- ld.AnimPlay( "anm_ritualcircleext_anm_light", "light", func_preend2 );  
      func_preend2();
    else 
       func_end();
    end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_magicdustext_inv" );
  cmn.CallEventHandler( "use_magicdustext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ritualcircleext_anm_magic", "use_magic", func_preend );
  SoundSfx( "aud_use_magicdustext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_mysterycircleext" ] = { type = "click", use_place = "spr_ritualcircleext_back_mmg", room = "rm_cryptext", zz = "zz_ritualcircleext", zz_gate = "gzz_cryptext_ritualcircleext" };

private.win_mysterycircleext_logic = function()
  if cmn.IsEventDone("win_mysterycircleext") then
    ObjSet( "gfx_cryptext_clk_animritualext_zone", {active=1, input = 1, visible = 1} );
    ObjDelete("spr_ritualcircleext_back_mmg");
  end;

end;
private.win_mysterycircleext_beg = function()
  
end;
private.win_mysterycircleext_end = function()
  if common_impl.ZzCompleteCheck("win_mysterycircleext") then ObjSet( common_impl.hint["win_mysterycircleext"].zz_gate, { visible = 0, input = 0 } ); end;
 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_mysterycircleext", private.win_mysterycircleext_beg, private.room_objname );
cmn.AddSubscriber( "win_mysterycircleext", private.win_mysterycircleext_end, private.room_objname );
cmn.AddSubscriber( "win_mysterycircleext", private.win_mysterycircleext_logic );
cmn.AddSubscriber( "win_mysterycircleext_beg", private.win_mysterycircleext_beg, private.room_objname );
cmn.AddSubscriber( "win_mysterycircleext_end", private.win_mysterycircleext_end, private.room_objname );
cmn.AddSubscriber( "win_mysterycircleext_end", private.win_mysterycircleext_logic );
--------------------------------------------------------------------------------------------
function public.win_mysterycircleext()

  local func_end = function()
    cmn.SetEventDone( "win_mysterycircleext" );
    cmn.CallEventHandler( "win_mysterycircleext_end" );
    --common_impl.Lock(0);
    ld.CloseSubRoom();
    ld.StartTimer( 0.4, function() public.clk_animritualext(); end )
  end;

  cmn.CallEventHandler( "win_mysterycircleext_beg" );
  common_impl.Lock(1);

  
  cmn.MiniGameHide( "mysterycircleext", true ); 
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  SoundSfx( "aud_mg_ritual_win" )
  ObjAnimate( "spr_ritualcircleext_back_mmg", 8, 0, 0, function()
     ld.AnimPlay( "anm_ritualcircleext_anm_light", "light", func_end );  
     end, {0,0,1, 0.5,0,1, 0.8,0,0} );
end;


private.mysterycircleext_fp_array = 2;

function private.init_mysterycircleext()
  
  if not cmn.IsEventStart("win_mysterycircleext") then
    ng_global.progress["ext"]["win_mysterycircleext"].state = private.mysterycircleext_fp_array;
    
  else  
   
  end
  private.win_mysterycircleext_stand_on_pos()
  ObjSet( "spr_ritualcircleext_limestoneext", {event_startdrag = "rm_cryptext.ritualcircleext_stone_startdrag();", event_drag = "rm_cryptext.ritualcircleext_stone_drag();", event_dragdrop="rm_cryptext.ritualcircleext_stone_dragdrop();", 
         input=1, event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", drag=1} );
  
end;
----------------------------
function public.ritualcircleext_stone_startdrag()
  SoundSfx( "aud_mg_ritual_get" )
  ld.StartTimer( 0.1, function() ld.SetCursor(CURSOR_NULL); end )
    
end;
----------------------------

function public.ritualcircleext_stone_drag()
  if not ApplyObj("spr_ritualcircleext_limestoneext","spr_ritualcircleext_back_mmg") then 
    SoundSfx( "aud_mg_ritual_put" )
    ObjStopDrag("spr_ritualcircleext_limestoneext");
  end;  
  
  
  local zones_apply_flag = false;
  local true_zone_apply_flag = false;
  
  for i=1,25,1 do 
    if  ApplyObj("obj_ritualcircleext_stone_apply_zone","obj_ritalcircleext_zone_"..i) then 
      zones_apply_flag = true;
      if i==ng_global.progress["ext"]["win_mysterycircleext"].state then 
        true_zone_apply_flag=true;
        ng_global.progress["ext"]["win_mysterycircleext"].state = i+1;
        SoundSfx( "aud_mg_ritual_line" )
        ObjSet( "spr_ritualcircleext_"..i-1, {alp=1} );
        if i==25 then ObjStopDrag("spr_ritualcircleext_limestoneext"); end;
      end;
    end;  
  end; 
 
  
end;  
-------------------------------- 
function public.ritualcircleext_stone_dragdrop()
  ld.SetCursor(CURSOR_DEFAULT);
  SoundSfx( "aud_mg_ritual_put" )
  private.win_mysterycircleext_stand_on_pos(); 
end;  
---------------------------------

function  private.win_mysterycircleext_stand_on_pos(without_win_ver)
  local count=0;
  for i=1,24,1 do 
    if i<=ng_global.progress["ext"]["win_mysterycircleext"].state-1 then 
      ObjSet( "spr_ritualcircleext_"..i, {alp=1} );
    else  
      ObjSet( "spr_ritualcircleext_"..i, {alp=0} );
    end;  
  end;  
  
  if without_win_ver~=1 and ng_global.progress["ext"]["win_mysterycircleext"].state==26 then  public.win_mysterycircleext(); end;
end;  
------------------------------------------
function private.win_mysterycircleext_reset()
  local func_end = function()
     private.win_mysterycircleext_stand_on_pos();
     ObjAnimate( "obj_ritualcircleext_parts_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  end;  
  
  ld.Lock(1);
  ng_global.progress["ext"]["win_mysterycircleext"].state = 2;
  ObjAnimate( "obj_ritualcircleext_parts_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  
  
function private.win_mysterycircleext_skip()
  local func_end = function()
     private.win_mysterycircleext_stand_on_pos(1);
     ObjAnimate( "obj_ritualcircleext_parts_root", 8, 0, 0, function()  private.win_mysterycircleext_stand_on_pos(); end, {0,0,0, 0.3,0,1} );
  end;  
  
  ld.Lock(1);
  ng_global.progress["ext"]["win_mysterycircleext"].state = 26;
  ObjAnimate( "obj_ritualcircleext_parts_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_angelsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_boneext" ] = { type = "get", get_obj = "spr_angelsext_boneext", room = "rm_cryptext", zz = "zz_angelsext", zz_gate = "gzz_cryptext_angelsext" };

private.get_boneext_logic = function()
ObjSet( "gfx_angelsext_harpext_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_boneext_inv = function()
  interface.InventoryItemAdd("inv_boneext","spr_angelsext_boneext");
end;
private.get_boneext_beg = function()
  ObjDelete("gfx_angelsext_boneext")
end;
private.get_boneext_end = function()
  if common_impl.ZzCompleteCheck("get_boneext") then ObjSet( common_impl.hint["get_boneext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_angelsext_tr_angel");
  ObjDelete("spr_angelsext_sh_boneext");
  ObjDelete("spr_cryptext_boneext");
end;

cmn.AddSubscriber( "get_boneext", private.get_boneext_inv );
cmn.AddSubscriber( "get_boneext", private.get_boneext_beg, private.room_objname );
cmn.AddSubscriber( "get_boneext", private.get_boneext_end, private.room_objname );
cmn.AddSubscriber( "get_boneext", private.get_boneext_logic );
--------------------------------------------------------------------
function public.get_boneext()
  cmn.SetEventDone( "get_boneext" );
  cmn.CallEventHandler( "get_boneext" );
  if common_impl.ZzCompleteCheck("get_boneext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_partpuzzleext_zone_clk()  --rm_cryptext.use_partpuzzleext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_partpuzzleext' );
  end;
  SoundSfx( "aud_touch_statuette" )
  ld.Lock(1);
  ld.AnimPlay( "anm_angelsext_anm_puzle", "idle", func_end )  
end;  


common_impl.hint[ "use_partpuzzleext" ] = { type = "use", inv_obj = "inv_partpuzzleext", use_place = "gfx_angelsext_partpuzzleext_zone", room = "rm_cryptext", zz = "zz_angelsext", zz_gate = "gzz_cryptext_angelsext" };

private.use_partpuzzleext_logic = function()
  ObjSet( "spr_angelsext_sunamuletext", { visible = 1, input = 1, active = 1 } )

end;
private.use_partpuzzleext_inv = function()
  common_impl.ProcessMultiUseAll("partpuzzleext", "partpuzzleext")
end;
private.use_partpuzzleext_beg = function()
  ObjDelete( "gfx_angelsext_partpuzzleext_zone" );
end;
private.use_partpuzzleext_end = function()
  if common_impl.ZzCompleteCheck("use_partpuzzleext") then ObjSet( common_impl.hint["use_partpuzzleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_angelsext_anm_puzle")
  ObjSet( "spr_cryptext_puzzle_sun", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_partpuzzleext", private.use_partpuzzleext_inv );
cmn.AddSubscriber( "use_partpuzzleext", private.use_partpuzzleext_beg, private.room_objname );
cmn.AddSubscriber( "use_partpuzzleext", private.use_partpuzzleext_end, private.room_objname );
cmn.AddSubscriber( "use_partpuzzleext", private.use_partpuzzleext_logic );
cmn.AddSubscriber( "use_partpuzzleext_inv", private.use_partpuzzleext_inv, private.room_objname );
cmn.AddSubscriber( "use_partpuzzleext_beg", private.use_partpuzzleext_beg, private.room_objname );
cmn.AddSubscriber( "use_partpuzzleext_end", private.use_partpuzzleext_end, private.room_objname );
cmn.AddSubscriber( "use_partpuzzleext_end", private.use_partpuzzleext_logic );
--------------------------------------------------------------------------------------------
function public.use_partpuzzleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_partpuzzleext" );
    cmn.CallEventHandler( "use_partpuzzleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_partpuzzleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_partpuzzleext_inv" );
  cmn.CallEventHandler( "use_partpuzzleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angelsext_anm_puzle", "use_puzzle", func_end )  
  SoundSfx( "aud_use_partpuzzleext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sunamuletext" ] = { type = "get", get_obj = "spr_angelsext_sunamuletext", room = "rm_cryptext", zz = "zz_angelsext", zz_gate = "gzz_cryptext_angelsext" };

private.get_sunamuletext_logic = function()
  
end;
private.get_sunamuletext_inv = function()
  interface.InventoryItemAdd("inv_sunamuletext","spr_angelsext_sunamuletext");
end;
private.get_sunamuletext_beg = function()
  ObjDelete("gfx_angelsext_sunamuletext")
end;
private.get_sunamuletext_end = function()
  if common_impl.ZzCompleteCheck("get_sunamuletext") then ObjSet( common_impl.hint["get_sunamuletext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cryptext_puzzle_sun");
  ObjDelete("spr_cryptext_sun");
end;

cmn.AddSubscriber( "get_sunamuletext", private.get_sunamuletext_inv );
cmn.AddSubscriber( "get_sunamuletext", private.get_sunamuletext_beg, private.room_objname );
cmn.AddSubscriber( "get_sunamuletext", private.get_sunamuletext_end, private.room_objname );
cmn.AddSubscriber( "get_sunamuletext", private.get_sunamuletext_logic );
--------------------------------------------------------------------
function public.get_sunamuletext()
  cmn.SetEventDone( "get_sunamuletext" );
  cmn.CallEventHandler( "get_sunamuletext" );
  if common_impl.ZzCompleteCheck("get_sunamuletext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_harpext_zone_clk() --rm_cryptext.use_harpext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_harpext' );
  end;

  ld.Lock(1);
  if ld.CheckRequirements( {"get_sunamuletext","get_boneext"} ) then
      SoundSfx( "aud_touch_big_stone" )
     ld.AnimPlay( "anm_angelsext_anm_harp", "idle1", func_end )  
  else  
    func_end();
  end;  
end;  

common_impl.hint[ "use_harpext" ] = { type = "use", inv_obj = "inv_harpext", use_place = "gfx_angelsext_harpext_zone", room = "rm_cryptext", zz = "zz_angelsext", zz_gate = "gzz_cryptext_angelsext" };

private.use_harpext_logic = function()
  ObjSet( "gho_cryptext_gothicext", { visible = 1, input = 1, active = 1 } )

end;
private.use_harpext_inv = function()
  common_impl.ProcessMultiUseAll("harpext", "harpext")
end;
private.use_harpext_beg = function()
  ObjDelete( "gfx_angelsext_harpext_zone" );
end;
private.use_harpext_end = function()
  if common_impl.ZzCompleteCheck("use_harpext") then ObjSet( common_impl.hint["use_harpext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_angelsext_anm_harp", {animfunc = "use_harp", frame = 999 } );
  ObjSet( "spr_cryptext_harp", {visible = 1} );
  ObjSet( "anm_cryptext_anm_ho", {animfunc = "open_door", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_harpext", private.use_harpext_inv );
cmn.AddSubscriber( "use_harpext", private.use_harpext_beg, private.room_objname );
cmn.AddSubscriber( "use_harpext", private.use_harpext_end, private.room_objname );
cmn.AddSubscriber( "use_harpext", private.use_harpext_logic );
cmn.AddSubscriber( "use_harpext_inv", private.use_harpext_inv, private.room_objname );
cmn.AddSubscriber( "use_harpext_beg", private.use_harpext_beg, private.room_objname );
cmn.AddSubscriber( "use_harpext_end", private.use_harpext_end, private.room_objname );
cmn.AddSubscriber( "use_harpext_end", private.use_harpext_logic );
--------------------------------------------------------------------------------------------
function public.use_harpext( obj )

  local func_end = function()
   
    --common_impl.Lock(0);
    ld.CloseSubRoom();
    ld.StartTimer( 0.3, function()SoundSfx( "aud_touch_harpext_cryptext" ); ld.AnimPlay( "anm_cryptext_anm_ho", "open_door",function()
          ObjSet(obj,{visible = 1});
          cmn.SetEventDone( "use_harpext" );
          cmn.CallEventHandler( "use_harpext_end" );
          ld.Lock(0);
    end  ); end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_harpext_inv" );
  cmn.CallEventHandler( "use_harpext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angelsext_anm_harp", "use_harp", func_end )  
  SoundSfx( "aud_use_harpext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_skullsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_limestoneext" ] = { type = "get", get_obj = "spr_skullsext_limestoneext", room = "rm_cryptext", zz = "zz_skullsext", zz_gate = "gzz_cryptext_skullsext" };

private.get_limestoneext_logic = function()
  
end;
private.get_limestoneext_inv = function()
  interface.InventoryItemAdd("inv_limestoneext","spr_skullsext_limestoneext");
end;
private.get_limestoneext_beg = function()
  ObjDelete("gfx_skullsext_limestoneext")
end;
private.get_limestoneext_end = function()
  if common_impl.ZzCompleteCheck("get_limestoneext") then ObjSet( common_impl.hint["get_limestoneext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_skullsext_sh_limestoneext");
  ObjDelete("spr_cryptext_limestoneext1");
end;

cmn.AddSubscriber( "get_limestoneext", private.get_limestoneext_inv );
cmn.AddSubscriber( "get_limestoneext", private.get_limestoneext_beg, private.room_objname );
cmn.AddSubscriber( "get_limestoneext", private.get_limestoneext_end, private.room_objname );
cmn.AddSubscriber( "get_limestoneext", private.get_limestoneext_logic );
--------------------------------------------------------------------
function public.get_limestoneext()
  cmn.SetEventDone( "get_limestoneext" );
  cmn.CallEventHandler( "get_limestoneext" );
  if common_impl.ZzCompleteCheck("get_limestoneext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_boneext_zone_clk()  --rm_cryptext.use_boneext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_boneext' );
  end;
  SoundSfx( "aud_touch_small_wood" )
  ld.Lock(1);
  ld.AnimPlay( "anm_skullsext_anm_bone", "idle", func_end );  
end;  

common_impl.hint[ "use_boneext" ] = { type = "use", inv_obj = "inv_boneext", use_place = "gfx_skullsext_boneext_zone", room = "rm_cryptext", zz = "zz_skullsext", zz_gate = "gzz_cryptext_skullsext" };

private.use_boneext_logic = function()
  ObjSet( "spr_skullsext_sprayext", { visible = 1, input = 1, active = 1 } )

end;
private.use_boneext_inv = function()
  common_impl.ProcessMultiUseAll("boneext", "boneext")
end;
private.use_boneext_beg = function()
  ObjDelete( "gfx_skullsext_boneext_zone" );
end;
private.use_boneext_end = function()
  if common_impl.ZzCompleteCheck("use_boneext") then ObjSet( common_impl.hint["use_boneext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_skullsext_anm_bone", {animfunc = "end_bone", frame = 0 } );
  ObjSet( "spr_skullsext_sh_sprayext", {visible = 1} );
  ObjSet( "spr_cryptext_bone", {visible = 1} );
  ObjDelete("spr_cryptext_dor_closed1");
  ObjSet( "spr_cryptext_dor_open1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_boneext", private.use_boneext_inv );
cmn.AddSubscriber( "use_boneext", private.use_boneext_beg, private.room_objname );
cmn.AddSubscriber( "use_boneext", private.use_boneext_end, private.room_objname );
cmn.AddSubscriber( "use_boneext", private.use_boneext_logic );
cmn.AddSubscriber( "use_boneext_inv", private.use_boneext_inv, private.room_objname );
cmn.AddSubscriber( "use_boneext_beg", private.use_boneext_beg, private.room_objname );
cmn.AddSubscriber( "use_boneext_end", private.use_boneext_end, private.room_objname );
cmn.AddSubscriber( "use_boneext_end", private.use_boneext_logic );
--------------------------------------------------------------------------------------------
function public.use_boneext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_boneext" );
    cmn.CallEventHandler( "use_boneext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_boneext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_boneext_inv" );
  cmn.CallEventHandler( "use_boneext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_skullsext_anm_bone", "use_bone", func_end );
  SoundSfx( "aud_use_boneext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sprayext" ] = { type = "get", get_obj = "spr_skullsext_sprayext", room = "rm_cryptext", zz = "zz_skullsext", zz_gate = "gzz_cryptext_skullsext" };

private.get_sprayext_logic = function()
  
end;
private.get_sprayext_inv = function()
  interface.InventoryItemAdd("inv_sprayext","spr_skullsext_sprayext");
end;
private.get_sprayext_beg = function()
  ObjDelete("gfx_skullsext_sprayext")
end;
private.get_sprayext_end = function()
  if common_impl.ZzCompleteCheck("get_sprayext") then ObjSet( common_impl.hint["get_sprayext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_skullsext_sh_sprayext");
  ObjDelete("spr_cryptext_sprayext");
end;

cmn.AddSubscriber( "get_sprayext", private.get_sprayext_inv );
cmn.AddSubscriber( "get_sprayext", private.get_sprayext_beg, private.room_objname );
cmn.AddSubscriber( "get_sprayext", private.get_sprayext_end, private.room_objname );
cmn.AddSubscriber( "get_sprayext", private.get_sprayext_logic );
--------------------------------------------------------------------
function public.get_sprayext()
  cmn.SetEventDone( "get_sprayext" );
  cmn.CallEventHandler( "get_sprayext" );
  if common_impl.ZzCompleteCheck("get_sprayext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_diamondext_zone_clk()  --rm_cryptext.use_diamondext_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_diamondext' );
  end;
  SoundSfx( "aud_touch_small_wood" )
  ld.Lock(1);
  ld.AnimPlay( "anm_skullsext_anm_diamond", "idle1", func_end )  
end;  


common_impl.hint[ "use_diamondext" ] = { type = "use", inv_obj = "inv_diamondext", use_place = "gfx_skullsext_diamondext_zone", room = "rm_cryptext", zz = "zz_skullsext", zz_gate = "gzz_cryptext_skullsext" };

private.use_diamondext_logic = function()
  ObjSet( "spr_skullsext_candleext6", { visible = 1, input = 1, active = 1 } )

end;
private.use_diamondext_inv = function()
  common_impl.ProcessMultiUseAll("diamondext", "diamondext")
end;
private.use_diamondext_beg = function()
  ObjDelete( "gfx_skullsext_diamondext_zone" );
end;
private.use_diamondext_end = function()
  if common_impl.ZzCompleteCheck("use_diamondext") then ObjSet( common_impl.hint["use_diamondext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_skullsext_anm_diamond", {animfunc = "end_diamond", frame = 0 } );
  ObjSet( "spr_skullsext_sh_candleext6", {visible = 1} );
  ObjSet( "spr_cryptext_diamond", {visible = 1} );
  ObjDelete("spr_cryptext_dor_closed2");
  ObjSet( "spr_cryptext_dor_open2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_diamondext", private.use_diamondext_inv );
cmn.AddSubscriber( "use_diamondext", private.use_diamondext_beg, private.room_objname );
cmn.AddSubscriber( "use_diamondext", private.use_diamondext_end, private.room_objname );
cmn.AddSubscriber( "use_diamondext", private.use_diamondext_logic );
cmn.AddSubscriber( "use_diamondext_inv", private.use_diamondext_inv, private.room_objname );
cmn.AddSubscriber( "use_diamondext_beg", private.use_diamondext_beg, private.room_objname );
cmn.AddSubscriber( "use_diamondext_end", private.use_diamondext_end, private.room_objname );
cmn.AddSubscriber( "use_diamondext_end", private.use_diamondext_logic );
--------------------------------------------------------------------------------------------
function public.use_diamondext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_diamondext" );
    cmn.CallEventHandler( "use_diamondext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_diamondext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_diamondext_inv" );
  cmn.CallEventHandler( "use_diamondext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_skullsext_anm_diamond", "use_diamond", func_end )  
  SoundSfx( "aud_use_diamondext_cryptext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_candleext6" ] = { type = "get", get_obj = "spr_skullsext_candleext6", room = "rm_cryptext", zz = "zz_skullsext", zz_gate = "gzz_cryptext_skullsext" };

private.get_candleext6_logic = function()
  
end;
private.get_candleext6_inv = function()
  interface.InventoryItemAdd("inv_candleext","spr_skullsext_candleext6",function() level_inv.ProcessGetCandleextAll( "get_candleext6" ) end);
end;
private.get_candleext6_beg = function()
  ObjDelete("gfx_skullsext_candleext6")
end;
private.get_candleext6_end = function()
  if common_impl.ZzCompleteCheck("get_candleext6") then ObjSet( common_impl.hint["get_candleext6"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_skullsext_sh_candleext6");
  ObjDelete("spr_cryptext_candleext6");
end;

cmn.AddSubscriber( "get_candleext6", private.get_candleext6_inv );
cmn.AddSubscriber( "get_candleext6", private.get_candleext6_beg, private.room_objname );
cmn.AddSubscriber( "get_candleext6", private.get_candleext6_end, private.room_objname );
cmn.AddSubscriber( "get_candleext6", private.get_candleext6_logic );
--------------------------------------------------------------------
function public.get_candleext6()
  cmn.SetEventDone( "get_candleext6" );
  cmn.CallEventHandler( "get_candleext6" );
  if common_impl.ZzCompleteCheck("get_candleext6") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

   if ( mg_name == "zz_ritualcircleext" ) and not ld.CheckRequirements( { "win_mysterycircleext" } ) then  
     -- private.win_totemgame_reset()
      private.win_mysterycircleext_reset();
  end; 
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_ritualcircleext" ) and not ld.CheckRequirements( { "win_mysterycircleext" } ) then  
    -- private.win_totemgame_skip()
     private.win_mysterycircleext_skip();
  end;

end

--*********************************************************************************************************************
  local win_demonriddleext_for_cryptext = function()
    if ld.CheckRequirements( {"win_demonriddleext"} ) then
      --ObjSet( "gmg_cryptext_demonriddleext", {input = 0, visible = 0} );
      --ObjSet( "anm_cryptext_anm_back", {animfunc = "man", frame = 0, playing = 1 } );
      -- ObjSet( "obj_cryptext_lekar_clk2_zone", {active = 1, input = 1, visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_demonriddleext", win_demonriddleext_for_cryptext, private.room_objname )
  
  local get_demonsignext_on_crypt_logic = function()
     ObjSet( "anm_cryptext_anm_back", {animfunc = "man", frame = 0, playing = 1 } );
  end;  
  cmn.AddSubscriber( "get_demonsignext", get_demonsignext_on_crypt_logic );
  
  local win_gothicext_for_cryptext = function()
    if ld.CheckRequirements( {"win_gothicext"} ) then
      ObjSet( "gho_cryptext_gothicext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_gothicext", win_gothicext_for_cryptext, private.room_objname )

  
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_cryptext();
  
  if not cmn.IsEventDone("clk_animspiritext2") then
     public.clk_animspiritext2();
  end;
 --if cmn.IsEventDone("clk_demonattackext") and not cmn.IsEventDone("dlg_cryptext_lekarext6") then 
 --   ObjSet( "gfx_cryptext_dlg_cryptext_lekarext6_zone", {active=1, input = 1, visible = 1} );
 --   public.dlg_cryptext_lekarext6();
 --end;  
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_cryptext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_skullsext" );
  function zz_skullsext.Open()
  end;
  function zz_skullsext.PreOpen()
  end;
  function zz_skullsext.PreClose()
  end;
  function zz_skullsext.Close()
  end;

  subroom.Define( "zz_angelsext" );
  function zz_angelsext.Open()
  end;
  function zz_angelsext.PreOpen()
  end;
  function zz_angelsext.PreClose()
  end;
  function zz_angelsext.Close()
  end;

  subroom.Define( "zz_ritualcircleext" );
  function zz_ritualcircleext.Open()
  end;
  function zz_ritualcircleext.PreOpen()
    if cmn.IsEventStart("win_mysterycircleext") and not cmn.IsEventDone("win_mysterycircleext") then 
      cmn.MiniGameShow( "mysterycircleext" ); 
      private.init_mysterycircleext()
    end; 
  end;
  function zz_ritualcircleext.PreClose()
  end;
  function zz_ritualcircleext.Close()
    if cmn.IsEventStart("win_mysterycircleext") and not cmn.IsEventDone("win_mysterycircleext") then 
      cmn.MiniGameHide( "mysterycircleext" ); 
    end; 
  end;

  subroom.Define( "zz_tombext" );
  function zz_tombext.Open()
    if not cmn.IsEventDone("clk_animlivesusieext") then
      public.clk_animlivesusieext(); 
    end
    
  end;
  function zz_tombext.PreOpen()
    SoundEnv("aud_susie_breath_zz_env",1);  
  end;
  function zz_tombext.PreClose()
    SoundEnv("aud_susie_breath_zz_env",1);  
  end;
  function zz_tombext.Close()
  end;
  
end;
--*********************************************************************************************************************