-- name=rm_laboratoryext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_laboratoryext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_laboratoryext()
  if not ( cmn.IsEventDone( "opn_laboratoryext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_laboratoryext" );
      cmn.CallEventHandler( "opn_laboratoryext" )
      SoundTheme( "aud_danger_moment1_mus" )
      ld.ShowBbt( "opn_laboratoryext" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_laboratoryext = function() end;
local opn_laboratoryext_logic = function() end;
cmn.AddSubscriber( "opn_laboratoryext", opn_laboratoryext_logic )
cmn.AddSubscriber( "opn_laboratoryext", opn_laboratoryext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bookcaseext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_ritualbookext" ] = { type = "get", get_obj = "spr_bookcaseext_ritualbookext", room = "rm_laboratoryext", zz = "zz_bookcaseext", zz_gate = "gzz_laboratoryext_bookcaseext" };

private.get_ritualbookext_logic = function()
  
end;
private.get_ritualbookext_inv = function()
  interface.InventoryItemAdd("inv_ritualbookext","spr_bookcaseext_ritualbookext");
end;
private.get_ritualbookext_beg = function()
  ObjDelete("gfx_bookcaseext_ritualbookext")
end;
private.get_ritualbookext_end = function()
  if common_impl.ZzCompleteCheck("get_ritualbookext") then ObjSet( common_impl.hint["get_ritualbookext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_bookcaseext_sh_ritualbookext");
  ObjDelete("spr_bookcaseext_sh_ritualbookext1");
  ObjDelete("spr_bookcaseext_ritualbookext_sh_down");
  ObjDelete( "spr_bookcaseext_ritualbookext_sh_top" );
  ObjDelete("spr_laboratoryext_ritualbook");
end;

cmn.AddSubscriber( "get_ritualbookext", private.get_ritualbookext_inv );
cmn.AddSubscriber( "get_ritualbookext", private.get_ritualbookext_beg, private.room_objname );
cmn.AddSubscriber( "get_ritualbookext", private.get_ritualbookext_end, private.room_objname );
cmn.AddSubscriber( "get_ritualbookext", private.get_ritualbookext_logic );
--------------------------------------------------------------------
function public.get_ritualbookext()
  cmn.SetEventDone( "get_ritualbookext" );
  cmn.CallEventHandler( "get_ritualbookext" );
  if common_impl.ZzCompleteCheck("get_ritualbookext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_medicalcrossext_zone_clk()  --rm_laboratoryext.use_medicalcrossext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_medicalcrossext' )
  end;  
  SoundSfx("aud_touch_small_wood")
  ld.Lock(1);
  ld.AnimPlay( "anm_bookcaseext_anm_medicalcross", "idle_medicalcross1", func_end )
end;  

common_impl.hint[ "use_medicalcrossext" ] = { type = "use", inv_obj = "inv_medicalcrossext", use_place = "gfx_bookcaseext_medicalcrossext_zone", room = "rm_laboratoryext", zz = "zz_bookcaseext", zz_gate = "gzz_laboratoryext_bookcaseext" };

private.use_medicalcrossext_logic = function()
  ObjSet( "spr_bookcaseext_medicalclampext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_bookcaseext_medicalclampext", { active  = 1, visible = 1} );
end;
private.use_medicalcrossext_inv = function()
  common_impl.ProcessMultiUseAll("medicalcrossext", "medicalcrossext")
end;
private.use_medicalcrossext_beg = function()
  ObjDelete( "gfx_bookcaseext_medicalcrossext_zone" );
end;
private.use_medicalcrossext_end = function()
  if common_impl.ZzCompleteCheck("use_medicalcrossext") then ObjSet( common_impl.hint["use_medicalcrossext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_bookcaseext_anm_medicalcross", {animfunc = "use_medicalcross", frame = 999 } );
  ObjDelete("spr_laboratoryext_cover2");
  ObjSet( "spr_laboratoryext_cover1", {visible = 1} );
  ObjSet( "spr_laboratoryext_medicalclamp", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_medicalcrossext", private.use_medicalcrossext_inv );
cmn.AddSubscriber( "use_medicalcrossext", private.use_medicalcrossext_beg, private.room_objname );
cmn.AddSubscriber( "use_medicalcrossext", private.use_medicalcrossext_end, private.room_objname );
cmn.AddSubscriber( "use_medicalcrossext", private.use_medicalcrossext_logic );
cmn.AddSubscriber( "use_medicalcrossext_inv", private.use_medicalcrossext_inv, private.room_objname );
cmn.AddSubscriber( "use_medicalcrossext_beg", private.use_medicalcrossext_beg, private.room_objname );
cmn.AddSubscriber( "use_medicalcrossext_end", private.use_medicalcrossext_end, private.room_objname );
cmn.AddSubscriber( "use_medicalcrossext_end", private.use_medicalcrossext_logic );
--------------------------------------------------------------------------------------------
function public.use_medicalcrossext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_medicalcrossext" );
    cmn.CallEventHandler( "use_medicalcrossext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_medicalcrossext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_medicalcrossext_inv" );
  cmn.CallEventHandler( "use_medicalcrossext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bookcaseext_anm_medicalcross", "use_medicalcross", func_end );
  SoundSfx( "aud_use_medicalcrossext_laboratoryext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_medicalclampext" ] = { type = "get", get_obj = "spr_bookcaseext_medicalclampext", room = "rm_laboratoryext", zz = "zz_bookcaseext", zz_gate = "gzz_laboratoryext_bookcaseext" };

private.get_medicalclampext_logic = function()
  
end;
private.get_medicalclampext_inv = function()
  interface.InventoryItemAdd("inv_medicalclampext","spr_bookcaseext_medicalclampext");
end;
private.get_medicalclampext_beg = function()
  ObjDelete("gfx_bookcaseext_medicalclampext")
end;
private.get_medicalclampext_end = function()
  if common_impl.ZzCompleteCheck("get_medicalclampext") then ObjSet( common_impl.hint["get_medicalclampext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_bookcaseext_anm_medicalcross", {animfunc = "end_medicalcross1", frame = 0 } );
  ObjDelete("spr_laboratoryext_medicalclamp");
end;

cmn.AddSubscriber( "get_medicalclampext", private.get_medicalclampext_inv );
cmn.AddSubscriber( "get_medicalclampext", private.get_medicalclampext_beg, private.room_objname );
cmn.AddSubscriber( "get_medicalclampext", private.get_medicalclampext_end, private.room_objname );
cmn.AddSubscriber( "get_medicalclampext", private.get_medicalclampext_logic );
--------------------------------------------------------------------
function public.get_medicalclampext()
  ObjSet( "spr_bookcaseext_medicalclampext", {visible = 1} );
  cmn.SetEventDone( "get_medicalclampext" );
  cmn.CallEventHandler( "get_medicalclampext" );
  if common_impl.ZzCompleteCheck("get_medicalclampext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_potsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_medicalclampext_potsext_zone_clk()  --rm_laboratoryext.use_medicalclampext_potsext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_medicalclampext_potsext' );
  end;  
  SoundSfx( "aud_touch_weed" )    
  ld.Lock(1);
  ld.AnimPlay( "anm_potsext_anm_bowext", "idle_bantik1", func_end )
end;  



common_impl.hint[ "use_medicalclampext_potsext" ] = { type = "use", inv_obj = "inv_medicalclampext", use_place = "gfx_potsext_medicalclampext_potsext_zone", room = "rm_laboratoryext", zz = "zz_potsext", zz_gate = "gzz_laboratoryext_potsext" };

private.use_medicalclampext_potsext_logic = function()
  ObjSet( "spr_potsext_bowext1", { visible = 1, input = 1, active = 1 } )

end;
private.use_medicalclampext_potsext_inv = function()
  common_impl.ProcessMultiUseAll("medicalclampext", "medicalclampext_potsext")
end;
private.use_medicalclampext_potsext_beg = function()
  ObjDelete( "gfx_potsext_medicalclampext_potsext_zone" );
end;
private.use_medicalclampext_potsext_end = function()
  if common_impl.ZzCompleteCheck("use_medicalclampext_potsext") then ObjSet( common_impl.hint["use_medicalclampext_potsext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_potsext_anm_bowext", {animfunc = "ehd_bantik1", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_medicalclampext_potsext", private.use_medicalclampext_potsext_inv );
cmn.AddSubscriber( "use_medicalclampext_potsext", private.use_medicalclampext_potsext_beg, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_potsext", private.use_medicalclampext_potsext_end, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_potsext", private.use_medicalclampext_potsext_logic );
cmn.AddSubscriber( "use_medicalclampext_potsext_inv", private.use_medicalclampext_potsext_inv, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_potsext_beg", private.use_medicalclampext_potsext_beg, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_potsext_end", private.use_medicalclampext_potsext_end, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_potsext_end", private.use_medicalclampext_potsext_logic );
--------------------------------------------------------------------------------------------
function public.use_medicalclampext_potsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_medicalclampext_potsext" );
    cmn.CallEventHandler( "use_medicalclampext_potsext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_medicalclampext_potsext") then ld.CloseSubRoom() end;
    public.get_bowext1();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_medicalclampext_potsext_inv" );
  cmn.CallEventHandler( "use_medicalclampext_potsext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_potsext_anm_bowext", "use_bantik", func_end );
  SoundSfx( "aud_use_medicalclampext_potsext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bowext1" ] = { type = "get", get_obj = "spr_potsext_bowext1", room = "rm_laboratoryext", zz = "zz_potsext", zz_gate = "gzz_laboratoryext_potsext" };

private.get_bowext1_logic = function()
  
end;
private.get_bowext1_inv = function()
  interface.InventoryItemAdd("inv_bowext","spr_potsext_bowext1",function() level_inv.ProcessGetBowextAll( "get_bowext1" ) end);
end;
private.get_bowext1_beg = function()
  ObjDelete("gfx_potsext_bowext1")
end;
private.get_bowext1_end = function()
  if common_impl.ZzCompleteCheck("get_bowext1") then ObjSet( common_impl.hint["get_bowext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_laboratoryext_bantik");
end;

cmn.AddSubscriber( "get_bowext1", private.get_bowext1_inv );
cmn.AddSubscriber( "get_bowext1", private.get_bowext1_beg, private.room_objname );
cmn.AddSubscriber( "get_bowext1", private.get_bowext1_end, private.room_objname );
cmn.AddSubscriber( "get_bowext1", private.get_bowext1_logic );
--------------------------------------------------------------------
function public.get_bowext1()
  cmn.SetEventDone( "get_bowext1" );
  cmn.CallEventHandler( "get_bowext1" );
  if common_impl.ZzCompleteCheck("get_bowext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_candleext" ] = { type = "use", inv_obj = "inv_candleext", use_place = "gfx_potsext_candleext_zone", room = "rm_laboratoryext", zz = "zz_potsext", zz_gate = "gzz_laboratoryext_potsext" };

private.use_candleext_logic = function()
  --ObjSet( "spr_potsext_lightedcandlesext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "anm_potsext_anm_candle", {active=1, input = 1, visible = 1} );
end;
private.use_candleext_inv = function()
  common_impl.ProcessMultiUseAll("candleext", "candleext")
end;
private.use_candleext_beg = function()
  ObjDelete( "gfx_potsext_candleext_zone" );
end;
private.use_candleext_end = function()
  if common_impl.ZzCompleteCheck("use_candleext") then ObjSet( common_impl.hint["use_candleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_potsext_anm_candles");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_candleext", private.use_candleext_inv );
cmn.AddSubscriber( "use_candleext", private.use_candleext_beg, private.room_objname );
cmn.AddSubscriber( "use_candleext", private.use_candleext_end, private.room_objname );
cmn.AddSubscriber( "use_candleext", private.use_candleext_logic );
cmn.AddSubscriber( "use_candleext_inv", private.use_candleext_inv, private.room_objname );
cmn.AddSubscriber( "use_candleext_beg", private.use_candleext_beg, private.room_objname );
cmn.AddSubscriber( "use_candleext_end", private.use_candleext_end, private.room_objname );
cmn.AddSubscriber( "use_candleext_end", private.use_candleext_logic );
--------------------------------------------------------------------------------------------
function public.use_candleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_candleext" );
    cmn.CallEventHandler( "use_candleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_candleext") then ld.CloseSubRoom() end;
    ObjSet( "anm_potsext_anm_candle", {active=1, input = 1, visible = 1} );
    public.get_lightedcandlesext();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_candleext_inv" );
  cmn.CallEventHandler( "use_candleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_potsext_anm_candles", "use_bowext2", func_end );
  SoundSfx( "aud_use_candleext_laboratoryext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lightedcandlesext" ] = { type = "get", get_obj = "anm_potsext_anm_candle", room = "rm_laboratoryext", zz = "zz_potsext", zz_gate = "gzz_laboratoryext_potsext" };

private.get_lightedcandlesext_logic = function()
  ObjSet( "gfx_cryptext_demoncardext_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "anm_cryptext_anm_back", {active = 1, visible = 1, playing = 1} );
end;
private.get_lightedcandlesext_inv = function()
  interface.InventoryItemAdd("inv_lightedcandlesext","anm_potsext_anm_candle");
end;
private.get_lightedcandlesext_beg = function()
  ObjDelete("gfx_potsext_lightedcandlesext")
end;
private.get_lightedcandlesext_end = function()
  if common_impl.ZzCompleteCheck("get_lightedcandlesext") then ObjSet( common_impl.hint["get_lightedcandlesext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lightedcandlesext", private.get_lightedcandlesext_inv );
cmn.AddSubscriber( "get_lightedcandlesext", private.get_lightedcandlesext_beg, private.room_objname );
cmn.AddSubscriber( "get_lightedcandlesext", private.get_lightedcandlesext_end, private.room_objname );
cmn.AddSubscriber( "get_lightedcandlesext", private.get_lightedcandlesext_logic );
--------------------------------------------------------------------
function public.get_lightedcandlesext()
  cmn.SetEventDone( "get_lightedcandlesext" );
  cmn.CallEventHandler( "get_lightedcandlesext" );
  if common_impl.ZzCompleteCheck("get_lightedcandlesext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_basketsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_screwdriverext" ] = { type = "get", get_obj = "spr_basketsext_screwdriverext", room = "rm_laboratoryext", zz = "zz_basketsext", zz_gate = "gzz_laboratoryext_basketsext" };

private.get_screwdriverext_logic = function()
  
end;
private.get_screwdriverext_inv = function()
  interface.InventoryItemAdd("inv_screwdriverext","spr_basketsext_screwdriverext");
end;
private.get_screwdriverext_beg = function()
  ObjDelete("gfx_basketsext_screwdriverext")
end;
private.get_screwdriverext_end = function()
  if common_impl.ZzCompleteCheck("get_screwdriverext") then ObjSet( common_impl.hint["get_screwdriverext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_basketsext_screw_sh");
  ObjDelete("spr_laboratoryext_screwdriverext");
end;

cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_inv );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_beg, private.room_objname );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_end, private.room_objname );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_logic );
--------------------------------------------------------------------
function public.get_screwdriverext()
  cmn.SetEventDone( "get_screwdriverext" );
  cmn.CallEventHandler( "get_screwdriverext" );
  if common_impl.ZzCompleteCheck("get_screwdriverext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_tapeext_zone_clk()  --rm_laboratoryext.use_tapeext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_tapeext' );
  end;
  SoundSfx( "aud_touch_weed" )    
  ld.Lock(1);
  ld.AnimPlay( "anm_basketsext_anm_flowers", "idle_flouers", func_end )  
  
end;  

common_impl.hint[ "use_tapeext" ] = { type = "use", inv_obj = "inv_tapeext", use_place = "gfx_basketsext_tapeext_zone", room = "rm_laboratoryext", zz = "zz_basketsext", zz_gate = "gzz_laboratoryext_basketsext" };

private.use_tapeext_logic = function()
  ObjSet( "spr_basketsext_bouquetext", { visible = 1, input = 1, active = 1 } )

end;
private.use_tapeext_inv = function()
  common_impl.ProcessMultiUseAll("tapeext", "tapeext")
end;
private.use_tapeext_beg = function()
  ObjDelete( "gfx_basketsext_tapeext_zone" );
end;
private.use_tapeext_end = function()
  if common_impl.ZzCompleteCheck("use_tapeext") then ObjSet( common_impl.hint["use_tapeext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_basketsext_anm_flowers");
  ObjDelete("spr_laboratoryext_flowers");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tapeext", private.use_tapeext_inv );
cmn.AddSubscriber( "use_tapeext", private.use_tapeext_beg, private.room_objname );
cmn.AddSubscriber( "use_tapeext", private.use_tapeext_end, private.room_objname );
cmn.AddSubscriber( "use_tapeext", private.use_tapeext_logic );
cmn.AddSubscriber( "use_tapeext_inv", private.use_tapeext_inv, private.room_objname );
cmn.AddSubscriber( "use_tapeext_beg", private.use_tapeext_beg, private.room_objname );
cmn.AddSubscriber( "use_tapeext_end", private.use_tapeext_end, private.room_objname );
cmn.AddSubscriber( "use_tapeext_end", private.use_tapeext_logic );
--------------------------------------------------------------------------------------------
function public.use_tapeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tapeext" );
    cmn.CallEventHandler( "use_tapeext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tapeext") then ld.CloseSubRoom() end;
    public.get_bouquetext();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tapeext_inv" );
  cmn.CallEventHandler( "use_tapeext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_basketsext_anm_flowers", "use_tape", func_end );
  SoundSfx( "aud_use_tapeext_laboratoryext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bouquetext" ] = { type = "get", get_obj = "spr_basketsext_bouquetext", room = "rm_laboratoryext", zz = "zz_basketsext", zz_gate = "gzz_laboratoryext_basketsext" };

private.get_bouquetext_logic = function()
  
end;
private.get_bouquetext_inv = function()
  interface.InventoryItemAdd("inv_bouquetext","spr_basketsext_bouquetext");
end;
private.get_bouquetext_beg = function()
  ObjDelete("gfx_basketsext_bouquetext")
end;
private.get_bouquetext_end = function()
  if common_impl.ZzCompleteCheck("get_bouquetext") then ObjSet( common_impl.hint["get_bouquetext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bouquetext", private.get_bouquetext_inv );
cmn.AddSubscriber( "get_bouquetext", private.get_bouquetext_beg, private.room_objname );
cmn.AddSubscriber( "get_bouquetext", private.get_bouquetext_end, private.room_objname );
cmn.AddSubscriber( "get_bouquetext", private.get_bouquetext_logic );
--------------------------------------------------------------------
function public.get_bouquetext()
  cmn.SetEventDone( "get_bouquetext" );
  cmn.CallEventHandler( "get_bouquetext" );
  if common_impl.ZzCompleteCheck("get_bouquetext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuletflameext_zone_clk()  --rm_laboratoryext.use_amuletflameext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amuletflameext' );
  end
  SoundSfx( "aud_touch_clothes" )      
  ld.Lock(1);
  ld.AnimPlay( "anm_basketsext_anm_amulet", "idle_backet", func_end )
end;  

common_impl.hint[ "use_amuletflameext" ] = { type = "use", inv_obj = "inv_amuletflameext", use_place = "gfx_basketsext_amuletflameext_zone", room = "rm_laboratoryext", zz = "zz_basketsext", zz_gate = "gzz_laboratoryext_basketsext" };

private.use_amuletflameext_logic = function()
  ObjSet( "spr_basketsext_lotusext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletflameext_inv = function()
  common_impl.ProcessMultiUseAll("amuletflameext", "amuletflameext")
end;
private.use_amuletflameext_beg = function()
  ObjDelete( "gfx_basketsext_amuletflameext_zone" );
end;
private.use_amuletflameext_end = function()
  if common_impl.ZzCompleteCheck("use_amuletflameext") then ObjSet( common_impl.hint["use_amuletflameext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_basketsext_anm_amulet", {animfunc = "end_onion", frame = 0 } );
  ObjSet( "spr_basketsext_lot_sh", {visible = 1} );
  ObjSet( "spr_laboratoryext_cover_22", {visible = 1} );
  ObjDelete("spr_laboratoryext_cover_11");
  ObjSet( "spr_laboratoryext_lotusext2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletflameext", private.use_amuletflameext_inv );
cmn.AddSubscriber( "use_amuletflameext", private.use_amuletflameext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletflameext", private.use_amuletflameext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletflameext", private.use_amuletflameext_logic );
cmn.AddSubscriber( "use_amuletflameext_inv", private.use_amuletflameext_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletflameext_beg", private.use_amuletflameext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletflameext_end", private.use_amuletflameext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletflameext_end", private.use_amuletflameext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletflameext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletflameext" );
    cmn.CallEventHandler( "use_amuletflameext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletflameext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletflameext_inv" );
  cmn.CallEventHandler( "use_amuletflameext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_basketsext_anm_amulet", "use_onion", func_end );
  SoundSfx( "aud_use_amuletflameext_laboratoryext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lotusext2" ] = { type = "get", get_obj = "spr_basketsext_lotusext2", room = "rm_laboratoryext", zz = "zz_basketsext", zz_gate = "gzz_laboratoryext_basketsext" };

private.get_lotusext2_logic = function()
  
end;
private.get_lotusext2_inv = function()
  interface.InventoryItemAdd("inv_lotusext","spr_basketsext_lotusext2",function() level_inv.ProcessGetLotusextAll( "get_lotusext2" ) end);
end;
private.get_lotusext2_beg = function()
  ObjDelete("gfx_basketsext_lotusext2")
end;
private.get_lotusext2_end = function()
  if common_impl.ZzCompleteCheck("get_lotusext2") then ObjSet( common_impl.hint["get_lotusext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_basketsext_lot_sh");
  ObjDelete("spr_laboratoryext_lotusext2");
end;

cmn.AddSubscriber( "get_lotusext2", private.get_lotusext2_inv );
cmn.AddSubscriber( "get_lotusext2", private.get_lotusext2_beg, private.room_objname );
cmn.AddSubscriber( "get_lotusext2", private.get_lotusext2_end, private.room_objname );
cmn.AddSubscriber( "get_lotusext2", private.get_lotusext2_logic );
--------------------------------------------------------------------
function public.get_lotusext2()
  cmn.SetEventDone( "get_lotusext2" );
  cmn.CallEventHandler( "get_lotusext2" );
  if common_impl.ZzCompleteCheck("get_lotusext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_armchairext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_medicalclampext_armchairext_zone_clk()  --rm_laboratoryext.use_medicalclampext_armchairext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_medicalclampext_armchairext' );
  end;  
  SoundSfx( "aud_touch_weed" )      
  ld.Lock(1);
  ld.AnimPlay( "anm_armchairext_anm", "idle_tweezers1", func_end );
end;  


common_impl.hint[ "use_medicalclampext_armchairext" ] = { type = "use", inv_obj = "inv_medicalclampext", use_place = "gfx_armchairext_medicalclampext_armchairext_zone", room = "rm_laboratoryext", zz = "zz_armchairext", zz_gate = "gzz_laboratoryext_armchairext" };

private.use_medicalclampext_armchairext_logic = function()
  ObjSet( "spr_armchairext_clockbuttonext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_armchairext_clockbuttonext", { active = 1, visible = 1 } );
end;
private.use_medicalclampext_armchairext_inv = function()
  common_impl.ProcessMultiUseAll("medicalclampext", "medicalclampext_armchairext")
end;
private.use_medicalclampext_armchairext_beg = function()
  ObjDelete( "gfx_armchairext_medicalclampext_armchairext_zone" );
end;
private.use_medicalclampext_armchairext_end = function()
  if common_impl.ZzCompleteCheck("use_medicalclampext_armchairext") then ObjSet( common_impl.hint["use_medicalclampext_armchairext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_armchairext_anm", {animfunc = "use_tweezers", frame = 999 } );
  ObjDelete("spr_laboratoryext_clockbutton");
  ObjSet( "spr_laboratoryext_clockbutton_2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_medicalclampext_armchairext", private.use_medicalclampext_armchairext_inv );
cmn.AddSubscriber( "use_medicalclampext_armchairext", private.use_medicalclampext_armchairext_beg, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_armchairext", private.use_medicalclampext_armchairext_end, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_armchairext", private.use_medicalclampext_armchairext_logic );
cmn.AddSubscriber( "use_medicalclampext_armchairext_inv", private.use_medicalclampext_armchairext_inv, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_armchairext_beg", private.use_medicalclampext_armchairext_beg, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_armchairext_end", private.use_medicalclampext_armchairext_end, private.room_objname );
cmn.AddSubscriber( "use_medicalclampext_armchairext_end", private.use_medicalclampext_armchairext_logic );
--------------------------------------------------------------------------------------------
function public.use_medicalclampext_armchairext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_medicalclampext_armchairext" );
    cmn.CallEventHandler( "use_medicalclampext_armchairext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_medicalclampext_armchairext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_medicalclampext_armchairext_inv" );
  cmn.CallEventHandler( "use_medicalclampext_armchairext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_armchairext_anm", "use_tweezers", func_end );
  SoundSfx( "aud_use_medicalclampext_armchairext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_clockbuttonext" ] = { type = "get", get_obj = "spr_armchairext_clockbuttonext", room = "rm_laboratoryext", zz = "zz_armchairext", zz_gate = "gzz_laboratoryext_armchairext" };

private.get_clockbuttonext_logic = function()
  
end;
private.get_clockbuttonext_inv = function()
  interface.InventoryItemAdd("inv_clockbuttonext","spr_armchairext_clockbuttonext");
end;
private.get_clockbuttonext_beg = function()
  ObjDelete("gfx_armchairext_clockbuttonext")
end;
private.get_clockbuttonext_end = function()
  if common_impl.ZzCompleteCheck("get_clockbuttonext") then ObjSet( common_impl.hint["get_clockbuttonext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_armchairext_anm");
  ObjDelete("spr_laboratoryext_clockbutton_2");
end;

cmn.AddSubscriber( "get_clockbuttonext", private.get_clockbuttonext_inv );
cmn.AddSubscriber( "get_clockbuttonext", private.get_clockbuttonext_beg, private.room_objname );
cmn.AddSubscriber( "get_clockbuttonext", private.get_clockbuttonext_end, private.room_objname );
cmn.AddSubscriber( "get_clockbuttonext", private.get_clockbuttonext_logic );
--------------------------------------------------------------------
function public.get_clockbuttonext()
  ObjSet( "spr_armchairext_clockbuttonext", {visible = 1} );
  cmn.SetEventDone( "get_clockbuttonext" );
  cmn.CallEventHandler( "get_clockbuttonext" );
  if common_impl.ZzCompleteCheck("get_clockbuttonext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_spannerext_armchairext_zone_clk()  --rm_laboratoryext.use_spannerext_armchairext_zone_clk()
  local func_end = function()
    common_impl.ShowBbt( 'need_spannerext_armchairext' );
    ld.Lock(0);
  end;  
  SoundSfx( "aud_touch_very_small_metal" )      
  ld.Lock(1);
  ld.AnimPlay( "anm_armchairext_anm_2", "idle_wrench1", func_end )
end;  

common_impl.hint[ "use_spannerext_armchairext" ] = { type = "use", inv_obj = "inv_spannerext", use_place = "gfx_armchairext_spannerext_armchairext_zone", room = "rm_laboratoryext", zz = "zz_armchairext", zz_gate = "gzz_laboratoryext_armchairext" };

private.use_spannerext_armchairext_logic = function()
  ObjSet( "spr_armchairext_littlestarext", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_armchairext_littlestarext", {active = 1, visible = 1} );
end;
private.use_spannerext_armchairext_inv = function()
  common_impl.ProcessMultiUseAll("spannerext", "spannerext_armchairext")
end;
private.use_spannerext_armchairext_beg = function()
  ObjDelete( "gfx_armchairext_spannerext_armchairext_zone" );
end;
private.use_spannerext_armchairext_end = function()
  if common_impl.ZzCompleteCheck("use_spannerext_armchairext") then ObjSet( common_impl.hint["use_spannerext_armchairext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_armchairext_anm_2", {animfunc = "use_wrench", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_spannerext_armchairext", private.use_spannerext_armchairext_inv );
cmn.AddSubscriber( "use_spannerext_armchairext", private.use_spannerext_armchairext_beg, private.room_objname );
cmn.AddSubscriber( "use_spannerext_armchairext", private.use_spannerext_armchairext_end, private.room_objname );
cmn.AddSubscriber( "use_spannerext_armchairext", private.use_spannerext_armchairext_logic );
cmn.AddSubscriber( "use_spannerext_armchairext_inv", private.use_spannerext_armchairext_inv, private.room_objname );
cmn.AddSubscriber( "use_spannerext_armchairext_beg", private.use_spannerext_armchairext_beg, private.room_objname );
cmn.AddSubscriber( "use_spannerext_armchairext_end", private.use_spannerext_armchairext_end, private.room_objname );
cmn.AddSubscriber( "use_spannerext_armchairext_end", private.use_spannerext_armchairext_logic );
--------------------------------------------------------------------------------------------
function public.use_spannerext_armchairext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_spannerext_armchairext" );
    cmn.CallEventHandler( "use_spannerext_armchairext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_spannerext_armchairext") then ld.CloseSubRoom() end;
  --  public.get_littlestarext();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_spannerext_armchairext_inv" );
  cmn.CallEventHandler( "use_spannerext_armchairext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_armchairext_anm_2", "use_wrench", func_end );
  SoundSfx( "aud_use_spannerext_armchairext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_littlestarext" ] = { type = "get", get_obj = "spr_armchairext_littlestarext", room = "rm_laboratoryext", zz = "zz_armchairext", zz_gate = "gzz_laboratoryext_armchairext" };

private.get_littlestarext_logic = function()
  
end;
private.get_littlestarext_inv = function()
  interface.InventoryItemAdd("inv_littlestarext","spr_armchairext_littlestarext");
end;
private.get_littlestarext_beg = function()
  ObjDelete("gfx_armchairext_littlestarext")
end;
private.get_littlestarext_end = function()
  if common_impl.ZzCompleteCheck("get_littlestarext") then ObjSet( common_impl.hint["get_littlestarext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_armchairext_anm_2");
  ObjDelete("spr_laboratoryext_star");
end;

cmn.AddSubscriber( "get_littlestarext", private.get_littlestarext_inv );
cmn.AddSubscriber( "get_littlestarext", private.get_littlestarext_beg, private.room_objname );
cmn.AddSubscriber( "get_littlestarext", private.get_littlestarext_end, private.room_objname );
cmn.AddSubscriber( "get_littlestarext", private.get_littlestarext_logic );
--------------------------------------------------------------------
function public.get_littlestarext()
  ObjSet( "spr_armchairext_littlestarext", {visible = 1} );
  cmn.SetEventDone( "get_littlestarext" );
  cmn.CallEventHandler( "get_littlestarext" );
  if common_impl.ZzCompleteCheck("get_littlestarext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_laboratoryext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_laboratoryext_env" )
  SoundEnv("aud_fireplace_loc_laboratoryext_env",1);  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_armchairext" );
  function zz_armchairext.Open()
  end;
  function zz_armchairext.PreOpen()
  end;
  function zz_armchairext.PreClose()
  end;
  function zz_armchairext.Close()
  end;

  subroom.Define( "zz_basketsext" );
  function zz_basketsext.Open()
  end;
  function zz_basketsext.PreOpen()
  end;
  function zz_basketsext.PreClose()
  end;
  function zz_basketsext.Close()
  end;

  subroom.Define( "zz_potsext" );
  function zz_potsext.Open()
  end;
  function zz_potsext.PreOpen()
    SoundEnv("aud_fireplace_loc_laboratoryext_env",0);  
    SoundEnv("aud_fireplace_zz_laboratoryext_env",1);        
  end;
  function zz_potsext.PreClose()
    SoundEnv("aud_fireplace_loc_laboratoryext_env",1);  
    SoundEnv("aud_fireplace_zz_laboratoryext_env",0);    
  end;
  function zz_potsext.Close()
  end;

  subroom.Define( "zz_bookcaseext" );
  function zz_bookcaseext.Open()
  end;
  function zz_bookcaseext.PreOpen()
  end;
  function zz_bookcaseext.PreClose()
  end;
  function zz_bookcaseext.Close()
  end;
  
end;
--*********************************************************************************************************************
--------------- OTHER FUNCS 

function public.bookcaseext_doctor_zone_clk()  --rm_laboratoryext.bookcaseext_doctor_zone_clk();
  local func_end = function()
      ObjSet( "obj_bookcaseext_idle_doctor_clk_zone", {input = 1} );
  end
  SoundSfx( "aud_doctor_laboratoryext" )
  ObjSet( "obj_bookcaseext_idle_doctor_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_bookcaseext_anm_click_doctor", "click_doctor", func_end )
end;  



function public.bookcaseext_web_zone_clk()  --rm_laboratoryext.bookcaseext_web_zone_clk();
  local func_end = function()
      ObjSet( "obj_bookcaseext_idle_web_clk_zone", {input = 1} );
  end
  SoundSfx( "aud_touch_weed" )
  ObjSet( "obj_bookcaseext_idle_web_clk_zone", {input = 0} );
  ld.AnimPlay( "anm_bookcaseext_anm_click_web", "click_web", func_end )
end;  

function public.armchair_idle_1() --rm_laboratoryext.armchair_idle_1()
  local func_end = function()
    ObjSet( "obj_armchair_idle_1_zone", {input = 1} );
    ObjSet( "obj_armchair_idle_2_zone", {input = 1} );
  end;
  SoundSfx( "aud_touch_clothes" )  
   ObjSet( "obj_armchair_idle_1_zone", {input = 0} );
   ObjSet( "obj_armchair_idle_2_zone", {input = 0} );
   ld.AnimPlay( "anm_armchairext_anm_idle1", "click", func_end )  
end;  

function public.armchair_idle_2() --rm_laboratoryext.armchair_idle_1()
  local func_end = function()
    ObjSet( "obj_armchair_idle_1_zone", {input = 1} );
    ObjSet( "obj_armchair_idle_2_zone", {input = 1} );
  end;
  SoundSfx( "aud_touch_clothes" )  
   ObjSet( "obj_armchair_idle_1_zone", {input = 0} );
   ObjSet( "obj_armchair_idle_2_zone", {input = 0} );
   ld.AnimPlay( "anm_armchairext_anm_idle1", "click1_pillow", func_end )  
end;  