-- name=rm_nearhouseext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearhouseext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_nearhouseext()
  if not ( cmn.IsEventDone( "opn_nearhouseext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_nearhouseext" );
      cmn.CallEventHandler( "opn_nearhouseext" )
      ld.ShowBbt( "opn_nearhouseext" )
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_nearhouseext = function() end;
local opn_nearhouseext_logic = function() end;
cmn.AddSubscriber( "opn_nearhouseext", opn_nearhouseext_logic )
cmn.AddSubscriber( "opn_nearhouseext", opn_nearhouseext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cartext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hacksawext_zone_clk()  --rm_nearhouseext.use_hacksawext_zone_clk();
  local func_end = function()  
    ld.Lock(0);
    common_impl.ShowBbt( 'need_hacksawext' );
  end;
  SoundSfx( "aud_touch_small_door" )
  ld.Lock(1);
  ld.AnimPlay( "anm_cartext_anm_cartext_hacksaw", "idle_casket", func_end )
end;  


common_impl.hint[ "use_hacksawext" ] = { type = "use", inv_obj = "inv_hacksawext", use_place = "gfx_cartext_hacksawext_zone", room = "rm_nearhouseext", zz = "zz_cartext", zz_gate = "gzz_nearhouseext_cartext" };

private.use_hacksawext_logic = function()
  -- ObjSet( "spr_cartext_susiebarretteext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_cartext_clk_cartexhacksawext_zone", {input = 1, visible = 1, active = 1} );
end;
private.use_hacksawext_inv = function()
  common_impl.ProcessMultiUseAll("hacksawext", "hacksawext")
end;
private.use_hacksawext_beg = function()
  ObjDelete( "gfx_cartext_hacksawext_zone" );
end;
private.use_hacksawext_end = function()
  if common_impl.ZzCompleteCheck("use_hacksawext") then ObjSet( common_impl.hint["use_hacksawext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cartext_anm_cartext_hacksaw", {animfunc = "use_hacksaw", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_inv );
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_beg, private.room_objname );
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_end, private.room_objname );
cmn.AddSubscriber( "use_hacksawext", private.use_hacksawext_logic );
cmn.AddSubscriber( "use_hacksawext_inv", private.use_hacksawext_inv, private.room_objname );
cmn.AddSubscriber( "use_hacksawext_beg", private.use_hacksawext_beg, private.room_objname );
cmn.AddSubscriber( "use_hacksawext_end", private.use_hacksawext_end, private.room_objname );
cmn.AddSubscriber( "use_hacksawext_end", private.use_hacksawext_logic );
--------------------------------------------------------------------------------------------
function public.use_hacksawext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hacksawext" );
    cmn.CallEventHandler( "use_hacksawext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hacksawext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hacksawext_inv" );
  cmn.CallEventHandler( "use_hacksawext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cartext_anm_cartext_hacksaw", "click_hacksaw", func_end );
  SoundSfx( "aud_use_hacksawext_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cartexhacksawext" ] = { type = "click", use_place = "gfx_cartext_clk_cartexhacksawext_zone", room = "rm_nearhouseext", zz = "zz_cartext", zz_gate = "gzz_nearhouseext_cartext" };

private.clk_cartexhacksawext_logic = function()
   ObjSet( "spr_cartext_susiebarretteext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_cartexhacksawext_beg = function()
  ObjDelete( "gfx_cartext_clk_cartexhacksawext_zone" );
end;
private.clk_cartexhacksawext_end = function()
  if common_impl.ZzCompleteCheck("clk_cartexhacksawext") then ObjSet( common_impl.hint["clk_cartexhacksawext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_cartext_anm_cartext_hacksaw", {animfunc = "use_hacksaw", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cartexhacksawext", private.clk_cartexhacksawext_beg, private.room_objname );
cmn.AddSubscriber( "clk_cartexhacksawext", private.clk_cartexhacksawext_end, private.room_objname );
cmn.AddSubscriber( "clk_cartexhacksawext", private.clk_cartexhacksawext_logic );
cmn.AddSubscriber( "clk_cartexhacksawext_beg", private.clk_cartexhacksawext_beg, private.room_objname );
cmn.AddSubscriber( "clk_cartexhacksawext_end", private.clk_cartexhacksawext_end, private.room_objname );
cmn.AddSubscriber( "clk_cartexhacksawext_end", private.clk_cartexhacksawext_logic );
--------------------------------------------------------------------------------------------
function public.clk_cartexhacksawext()

  local func_end = function()
    cmn.SetEventDone( "clk_cartexhacksawext" );
    cmn.CallEventHandler( "clk_cartexhacksawext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_cartexhacksawext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_cartexhacksawext_beg" );
  common_impl.Lock(1);

  ObjSet( "spr_cartext_widebulbext", { visible = 1, active = 1 } )
  ObjSet( "spr_cartext_medicalcrossext", { visible = 1, active = 1 } )
  ld.AnimPlay( "anm_cartext_anm_cartext_hacksaw", "use_hacksaw", func_end );
  SoundSfx( "aud_touch_casket_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_susiebarretteext" ] = { type = "get", get_obj = "spr_cartext_susiebarretteext", room = "rm_nearhouseext", zz = "zz_cartext", zz_gate = "gzz_nearhouseext_cartext" };

private.get_susiebarretteext_logic = function()
  
end;
private.get_susiebarretteext_inv = function()
  interface.InventoryItemAdd("inv_susiebarretteext","spr_cartext_susiebarretteext");
end;
private.get_susiebarretteext_beg = function()
  ObjDelete("gfx_cartext_susiebarretteext")
end;
private.get_susiebarretteext_end = function()
  if common_impl.ZzCompleteCheck("get_susiebarretteext") then ObjSet( common_impl.hint["get_susiebarretteext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cartext_sh_susiebarretteext");
end;

cmn.AddSubscriber( "get_susiebarretteext", private.get_susiebarretteext_inv );
cmn.AddSubscriber( "get_susiebarretteext", private.get_susiebarretteext_beg, private.room_objname );
cmn.AddSubscriber( "get_susiebarretteext", private.get_susiebarretteext_end, private.room_objname );
cmn.AddSubscriber( "get_susiebarretteext", private.get_susiebarretteext_logic );
--------------------------------------------------------------------
function public.get_susiebarretteext()
  cmn.SetEventDone( "get_susiebarretteext" );
  cmn.CallEventHandler( "get_susiebarretteext" );
  if common_impl.ZzCompleteCheck("get_susiebarretteext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_screwdriverext_zone_clk() --rm_nearhouseext.use_screwdriverext_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_screwdriverext' );
  end;
  SoundSfx( "aud_touch_small_plastic" )    
  ld.Lock(1);
  ld.AnimPlay( "anm_cartext_anm_cartext_screwdriver", "idle_medallion", func_end )
end;  


common_impl.hint[ "use_screwdriverext" ] = { type = "use", inv_obj = "inv_screwdriverext", use_place = "gfx_cartext_screwdriverext_zone", room = "rm_nearhouseext", zz = "zz_cartext", zz_gate = "gzz_nearhouseext_cartext" };

private.use_screwdriverext_logic = function()
  ObjSet( "spr_cartext_iconext", { visible = 1, input = 1, active = 1 } )

end;
private.use_screwdriverext_inv = function()
  common_impl.ProcessMultiUseAll("screwdriverext", "screwdriverext")
end;
private.use_screwdriverext_beg = function()
  ObjDelete( "gfx_cartext_screwdriverext_zone" );
end;
private.use_screwdriverext_end = function()
  if common_impl.ZzCompleteCheck("use_screwdriverext") then ObjSet( common_impl.hint["use_screwdriverext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_cartext_anm_cartext_screwdriver");
  ObjSet( "spr_cartext_sh_iconext", {visible = 1} );
  ObjDelete("spr_nearhouseext_screw");
  ObjDelete("spr_nearhouseext_iconext");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_inv );
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext", private.use_screwdriverext_logic );
cmn.AddSubscriber( "use_screwdriverext_inv", private.use_screwdriverext_inv, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_beg", private.use_screwdriverext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_end", private.use_screwdriverext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_end", private.use_screwdriverext_logic );
--------------------------------------------------------------------------------------------
function public.use_screwdriverext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwdriverext" );
    cmn.CallEventHandler( "use_screwdriverext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screwdriverext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwdriverext_inv" );
  cmn.CallEventHandler( "use_screwdriverext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cartext_anm_cartext_screwdriver", "use_screwdriver", func_end );
  SoundSfx( "aud_use_screwdriverext_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_iconext" ] = { type = "get", get_obj = "spr_cartext_iconext", room = "rm_nearhouseext", zz = "zz_cartext", zz_gate = "gzz_nearhouseext_cartext" };

private.get_iconext_logic = function()
  
end;
private.get_iconext_inv = function()
  interface.InventoryItemAdd("inv_iconext","spr_cartext_iconext");
end;
private.get_iconext_beg = function()
  ObjDelete("gfx_cartext_iconext")
end;
private.get_iconext_end = function()
  if common_impl.ZzCompleteCheck("get_iconext") then ObjSet( common_impl.hint["get_iconext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cartext_sh_iconext");
end;

cmn.AddSubscriber( "get_iconext", private.get_iconext_inv );
cmn.AddSubscriber( "get_iconext", private.get_iconext_beg, private.room_objname );
cmn.AddSubscriber( "get_iconext", private.get_iconext_end, private.room_objname );
cmn.AddSubscriber( "get_iconext", private.get_iconext_logic );
--------------------------------------------------------------------
function public.get_iconext()
  cmn.SetEventDone( "get_iconext" );
  cmn.CallEventHandler( "get_iconext" );
  if common_impl.ZzCompleteCheck("get_iconext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_benchext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_heartext1" ] = { type = "get", get_obj = "spr_benchext_heartext1", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.get_heartext1_logic = function()
  
end;
private.get_heartext1_inv = function()
  interface.InventoryItemAdd("inv_heartext1","spr_benchext_heartext1");
end;
private.get_heartext1_beg = function()
  ObjDelete("gfx_benchext_heartext1")
end;
private.get_heartext1_end = function()
  if common_impl.ZzCompleteCheck("get_heartext1") then ObjSet( common_impl.hint["get_heartext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_benchext_sh_heartext1");
  ObjDelete("spr_nearhouseext_heartext1");
end;

cmn.AddSubscriber( "get_heartext1", private.get_heartext1_inv );
cmn.AddSubscriber( "get_heartext1", private.get_heartext1_beg, private.room_objname );
cmn.AddSubscriber( "get_heartext1", private.get_heartext1_end, private.room_objname );
cmn.AddSubscriber( "get_heartext1", private.get_heartext1_logic );
--------------------------------------------------------------------
function public.get_heartext1()
  cmn.SetEventDone( "get_heartext1" );
  cmn.CallEventHandler( "get_heartext1" );
  if common_impl.ZzCompleteCheck("get_heartext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_susiebarretteext_zone_clk()  --rm_nearhouseext.use_susiebarretteext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_susiebarretteext' );
  end;  
  SoundSfx( "aud_touch_weed" )
  ld.Lock(1);
  ld.AnimPlay( "anm_benchext_anm_bench_casket", "idle_casket", func_end );
end;  

common_impl.hint[ "use_susiebarretteext" ] = { type = "use", inv_obj = "inv_susiebarretteext", use_place = "gfx_benchext_susiebarretteext_zone", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.use_susiebarretteext_logic = function()
  ObjSet( "spr_benchext_catpawext", { visible = 1, input = 1, active = 1, pos_z=31 } )

end;
private.use_susiebarretteext_inv = function()
  common_impl.ProcessMultiUseAll("susiebarretteext", "susiebarretteext")
end;
private.use_susiebarretteext_beg = function()
  ObjDelete( "gfx_benchext_susiebarretteext_zone" );
end;
private.use_susiebarretteext_end = function()
  if common_impl.ZzCompleteCheck("use_susiebarretteext") then ObjSet( common_impl.hint["use_susiebarretteext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_benchext_anm_bench_casket", {animfunc = "end_casket", frame = 0 } );
  ObjSet( "spr_benchext_sh_catpawext", {visible = 1, pos_z=29} );
  ObjDelete("spr_nearhouseext_close1");
  ObjSet( "spr_nearhouseext_catpawext", {visible = 1} );
  ObjSet( "spr_nearhouseext_open1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_susiebarretteext", private.use_susiebarretteext_inv );
cmn.AddSubscriber( "use_susiebarretteext", private.use_susiebarretteext_beg, private.room_objname );
cmn.AddSubscriber( "use_susiebarretteext", private.use_susiebarretteext_end, private.room_objname );
cmn.AddSubscriber( "use_susiebarretteext", private.use_susiebarretteext_logic );
cmn.AddSubscriber( "use_susiebarretteext_inv", private.use_susiebarretteext_inv, private.room_objname );
cmn.AddSubscriber( "use_susiebarretteext_beg", private.use_susiebarretteext_beg, private.room_objname );
cmn.AddSubscriber( "use_susiebarretteext_end", private.use_susiebarretteext_end, private.room_objname );
cmn.AddSubscriber( "use_susiebarretteext_end", private.use_susiebarretteext_logic );
--------------------------------------------------------------------------------------------
function public.use_susiebarretteext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_susiebarretteext" );
    cmn.CallEventHandler( "use_susiebarretteext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_susiebarretteext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_susiebarretteext_inv" );
  cmn.CallEventHandler( "use_susiebarretteext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_benchext_anm_bench_casket", "use_casket", func_end );
  SoundSfx( "aud_use_susiebarretteext_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_catpawext" ] = { type = "get", get_obj = "spr_benchext_catpawext", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.get_catpawext_logic = function()
  
end;
private.get_catpawext_inv = function()
  interface.InventoryItemAdd("inv_catpawext","spr_benchext_catpawext");
end;
private.get_catpawext_beg = function()
  ObjDelete("gfx_benchext_catpawext")
end;
private.get_catpawext_end = function()
  if common_impl.ZzCompleteCheck("get_catpawext") then ObjSet( common_impl.hint["get_catpawext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_benchext_sh_catpawext");
  ObjDelete("spr_nearhouseext_catpawext");
end;

cmn.AddSubscriber( "get_catpawext", private.get_catpawext_inv );
cmn.AddSubscriber( "get_catpawext", private.get_catpawext_beg, private.room_objname );
cmn.AddSubscriber( "get_catpawext", private.get_catpawext_end, private.room_objname );
cmn.AddSubscriber( "get_catpawext", private.get_catpawext_logic );
--------------------------------------------------------------------
function public.get_catpawext()
  cmn.SetEventDone( "get_catpawext" );
  cmn.CallEventHandler( "get_catpawext" );
  if common_impl.ZzCompleteCheck("get_catpawext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_barnkeyext_zone_clk()  --rm_nearhouseext.use_barnkeyext_zone_clk()
  local  func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_barnkeyext' )
  end;  
  SoundSfx( "aud_touch_small_door" )
  ld.Lock(1);
  ld.AnimPlay( "anm_benchext_anm_bench_barnkeyext", "idle_chest", func_end )
  
end;  

common_impl.hint[ "use_barnkeyext" ] = { type = "use", inv_obj = "inv_barnkeyext", use_place = "gfx_benchext_barnkeyext_zone", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.use_barnkeyext_logic = function()
  -- ObjSet( "spr_benchext_widebulbext", { visible = 1, input = 1, active = 1 } )
  -- ObjSet( "spr_benchext_medicalcrossext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_benchext_clk_barnkeyext1_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_barnkeyext_inv = function()
  common_impl.ProcessMultiUseAll("barnkeyext", "barnkeyext")
end;
private.use_barnkeyext_beg = function()
  ObjDelete( "gfx_benchext_barnkeyext_zone" );
end;
private.use_barnkeyext_end = function()
  if common_impl.ZzCompleteCheck("use_barnkeyext") then ObjSet( common_impl.hint["use_barnkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_benchext_anm_bench_barnkeyext",{animfunc = "use_chest", frame = 999})
  ObjDelete("spr_nearhouseext_lock");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_barnkeyext", private.use_barnkeyext_inv );
cmn.AddSubscriber( "use_barnkeyext", private.use_barnkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_barnkeyext", private.use_barnkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_barnkeyext", private.use_barnkeyext_logic );
cmn.AddSubscriber( "use_barnkeyext_inv", private.use_barnkeyext_inv, private.room_objname );
cmn.AddSubscriber( "use_barnkeyext_beg", private.use_barnkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_barnkeyext_end", private.use_barnkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_barnkeyext_end", private.use_barnkeyext_logic );
--------------------------------------------------------------------------------------------
function public.use_barnkeyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_barnkeyext" );
    cmn.CallEventHandler( "use_barnkeyext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_barnkeyext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_barnkeyext_inv" );
  cmn.CallEventHandler( "use_barnkeyext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_benchext_anm_bench_barnkeyext", "use_chest", func_end );
  SoundSfx( "aud_use_barnkeyext_nearhouseext" )
  --func_end()

end;

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_barnkeyext1" ] = { type = "click", use_place = "gfx_benchext_clk_barnkeyext1_zone", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.clk_barnkeyext1_logic = function()
  ObjSet( "gfx_benchext_clk_barnkeyext2_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_benchext_widebulbext", { visible = 1, active = 1, input=0 } )
  ObjSet( "spr_benchext_medicalcrossext", { visible = 1, active = 1, input=0 } )
end;
private.clk_barnkeyext1_beg = function()
  ObjDelete( "gfx_benchext_clk_barnkeyext1_zone" );
end;
private.clk_barnkeyext1_end = function()
  if common_impl.ZzCompleteCheck("clk_barnkeyext1") then ObjSet( common_impl.hint["clk_barnkeyext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_benchext_anm_bench_barnkeyext", {animfunc = "click_chest", frame = 999 } );
  ObjSet( "spr_benchext_sh_medicalcrossext", {visible = 1} );
  ObjSet( "spr_benchext_sh_widebulbext", {visible = 1} );
  ObjDelete("spr_nearhouseext_close_s");
  ObjSet( "spr_nearhouseext_open_s", {visible = 1} );
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_barnkeyext1", private.clk_barnkeyext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext1", private.clk_barnkeyext1_end, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext1", private.clk_barnkeyext1_logic );
cmn.AddSubscriber( "clk_barnkeyext1_beg", private.clk_barnkeyext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext1_end", private.clk_barnkeyext1_end, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext1_end", private.clk_barnkeyext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_barnkeyext1()

  local func_end = function()
    cmn.SetEventDone( "clk_barnkeyext1" );
    cmn.CallEventHandler( "clk_barnkeyext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_barnkeyext1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_barnkeyext1_beg" );
  common_impl.Lock(1);

  ObjSet( "spr_benchext_widebulbext", { visible = 1, active = 1 } )
  ObjSet( "spr_benchext_medicalcrossext", { visible = 1, active = 1 } )
  ld.AnimPlay( "anm_benchext_anm_bench_barnkeyext", "click_chest", func_end );
  SoundSfx( "aud_touch_chest_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_barnkeyext2" ] = { type = "click", use_place = "gfx_benchext_clk_barnkeyext2_zone", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.clk_barnkeyext2_logic = function()
  ObjSet( "gfx_benchext_clk_barnkeyext3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_barnkeyext2_beg = function()
  ObjDelete( "gfx_benchext_clk_barnkeyext2_zone" );
end;
private.clk_barnkeyext2_end = function()
  if common_impl.ZzCompleteCheck("clk_barnkeyext2") then ObjSet( common_impl.hint["clk_barnkeyext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_benchext_anm_bench_barnkeyext", {animfunc = "click_things1", frame = 999 } );
  ObjDelete("spr_nearhouseext_things");
  ObjSet( "spr_nearhouseext_tr_things1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_barnkeyext2", private.clk_barnkeyext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext2", private.clk_barnkeyext2_end, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext2", private.clk_barnkeyext2_logic );
cmn.AddSubscriber( "clk_barnkeyext2_beg", private.clk_barnkeyext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext2_end", private.clk_barnkeyext2_end, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext2_end", private.clk_barnkeyext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_barnkeyext2()

  local func_end = function()
    cmn.SetEventDone( "clk_barnkeyext2" );
    cmn.CallEventHandler( "clk_barnkeyext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_barnkeyext2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_barnkeyext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_benchext_anm_bench_barnkeyext", "click_things1", func_end );
  SoundSfx( "aud_touch_clothes_nearhouseext" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_barnkeyext3" ] = { type = "click", use_place = "gfx_benchext_clk_barnkeyext3_zone", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.clk_barnkeyext3_logic = function()
   ObjSet( "spr_benchext_widebulbext", { visible = 1, input = 1, active = 1 } )
   ObjSet( "spr_benchext_medicalcrossext", { visible = 1, input = 1, active = 1 } )

end;
private.clk_barnkeyext3_beg = function()
  ObjDelete( "gfx_benchext_clk_barnkeyext3_zone" );
end;
private.clk_barnkeyext3_end = function()
  if common_impl.ZzCompleteCheck("clk_barnkeyext3") then ObjSet( common_impl.hint["clk_barnkeyext3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_benchext_anm_bench_barnkeyext", {animfunc = "click_things2", frame = 999 } );
  ObjDelete("spr_nearhouseext_things1");
  ObjSet( "spr_nearhouseext_tr_hings1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_barnkeyext3", private.clk_barnkeyext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext3", private.clk_barnkeyext3_end, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext3", private.clk_barnkeyext3_logic );
cmn.AddSubscriber( "clk_barnkeyext3_beg", private.clk_barnkeyext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext3_end", private.clk_barnkeyext3_end, private.room_objname );
cmn.AddSubscriber( "clk_barnkeyext3_end", private.clk_barnkeyext3_logic );
--------------------------------------------------------------------------------------------
function public.clk_barnkeyext3()

  local func_end = function()
    cmn.SetEventDone( "clk_barnkeyext3" );
    cmn.CallEventHandler( "clk_barnkeyext3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_barnkeyext3") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_barnkeyext3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_benchext_anm_bench_barnkeyext", "click_things2", func_end );
  SoundSfx( "aud_touch_clothes_nearhouseext" )
  -- func_end()

end;
--------------------------------------------------------------------
common_impl.hint[ "get_widebulbext" ] = { type = "get", get_obj = "spr_benchext_widebulbext", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.get_widebulbext_logic = function()
  
end;
private.get_widebulbext_inv = function()
  interface.InventoryItemAdd("inv_widebulbext","spr_benchext_widebulbext");
end;
private.get_widebulbext_beg = function()
  ObjDelete("gfx_benchext_widebulbext")
end;
private.get_widebulbext_end = function()
  if common_impl.ZzCompleteCheck("get_widebulbext") then ObjSet( common_impl.hint["get_widebulbext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_benchext_sh_widebulbext");
  ObjDelete("spr_nearhouseext_widebulbext");
end;

cmn.AddSubscriber( "get_widebulbext", private.get_widebulbext_inv );
cmn.AddSubscriber( "get_widebulbext", private.get_widebulbext_beg, private.room_objname );
cmn.AddSubscriber( "get_widebulbext", private.get_widebulbext_end, private.room_objname );
cmn.AddSubscriber( "get_widebulbext", private.get_widebulbext_logic );
--------------------------------------------------------------------
function public.get_widebulbext()
  cmn.SetEventDone( "get_widebulbext" );
  cmn.CallEventHandler( "get_widebulbext" );
  if common_impl.ZzCompleteCheck("get_widebulbext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_medicalcrossext" ] = { type = "get", get_obj = "spr_benchext_medicalcrossext", room = "rm_nearhouseext", zz = "zz_benchext", zz_gate = "gzz_nearhouseext_benchext" };

private.get_medicalcrossext_logic = function()
  
end;
private.get_medicalcrossext_inv = function()
  interface.InventoryItemAdd("inv_medicalcrossext","spr_benchext_medicalcrossext");
end;
private.get_medicalcrossext_beg = function()
  ObjDelete("gfx_benchext_medicalcrossext")
end;
private.get_medicalcrossext_end = function()
  if common_impl.ZzCompleteCheck("get_medicalcrossext") then ObjSet( common_impl.hint["get_medicalcrossext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_benchext_sh_medicalcrossext");
  ObjDelete("spr_nearhouseext_medicalcrossext");
end;

cmn.AddSubscriber( "get_medicalcrossext", private.get_medicalcrossext_inv );
cmn.AddSubscriber( "get_medicalcrossext", private.get_medicalcrossext_beg, private.room_objname );
cmn.AddSubscriber( "get_medicalcrossext", private.get_medicalcrossext_end, private.room_objname );
cmn.AddSubscriber( "get_medicalcrossext", private.get_medicalcrossext_logic );
--------------------------------------------------------------------
function public.get_medicalcrossext()
  cmn.SetEventDone( "get_medicalcrossext" );
  cmn.CallEventHandler( "get_medicalcrossext" );
  if common_impl.ZzCompleteCheck("get_medicalcrossext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_inthegroveext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_hookext" ] = { type = "get", get_obj = "spr_inthegroveext_hookext", room = "rm_nearhouseext", zz = "zz_inthegroveext", zz_gate = "gzz_nearhouseext_inthegroveext" };

private.get_hookext_logic = function()
  ObjSet( "gfx_inthegroveext_heartext1_zone", { active = 1, input = 1, visible = 1} );
  ObjSet( "gfx_inthegroveext_heartext2_zone", { active = 1, input = 1, visible = 1} );
end;
private.get_hookext_inv = function()
  interface.InventoryItemAdd("inv_hookext","spr_inthegroveext_hookext");
end;
private.get_hookext_beg = function()
  ObjDelete("gfx_inthegroveext_hookext")
end;
private.get_hookext_end = function()
  if common_impl.ZzCompleteCheck("get_hookext") then ObjSet( common_impl.hint["get_hookext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_inthegroveext_anm_door", {animfunc = "idle_door1", frame = 0 } );
  ObjDelete("spr_nearhouseext_hookext");
end;

cmn.AddSubscriber( "get_hookext", private.get_hookext_inv );
cmn.AddSubscriber( "get_hookext", private.get_hookext_beg, private.room_objname );
cmn.AddSubscriber( "get_hookext", private.get_hookext_end, private.room_objname );
cmn.AddSubscriber( "get_hookext", private.get_hookext_logic );
--------------------------------------------------------------------
function public.get_hookext()
  ObjSet( "spr_inthegroveext_hookext", {visible = 1} );
  cmn.SetEventDone( "get_hookext" );
  cmn.CallEventHandler( "get_hookext" );
  if common_impl.ZzCompleteCheck("get_hookext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_heartext_zone_clk(num)  --rm_nearhouseext.use_heartext_zone_clk(num)
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_heartext'..num )
  end;  
  
  ld.Lock(1);
  if cmn.IsEventDone("get_hookext") and not cmn.IsEventDone("use_heartext1") and not cmn.IsEventDone("use_heartext2")  then 
     ld.AnimPlay( "anm_inthegroveext_anm_door", "idle_door1", func_end )
     SoundSfx( "aud_touch_big_wood" )
   elseif not cmn.IsEventDone("use_heartext1") and not cmn.IsEventDone("use_heartext2") then 
     ld.AnimPlay( "anm_inthegroveext_anm_door", "idle_door", func_end )  
     SoundSfx( "aud_touch_big_wood" )     
  else  
     func_end();
  end;  
  
end;  



common_impl.hint[ "use_heartext1" ] = { type = "use", inv_obj = "inv_heartext1", use_place = "gfx_inthegroveext_heartext1_zone", room = "rm_nearhouseext", zz = "zz_inthegroveext", zz_gate = "gzz_nearhouseext_inthegroveext" };

private.use_heartext1_logic = function()
  if ld.CheckRequirements( {"use_heartext1","use_heartext2"} ) then
    ObjSet("gmg_nearhouseext_heartsext",{ visible = 1, input = 1, active = 1 })
  end;

end;
private.use_heartext1_inv = function()
  common_impl.ProcessMultiUseAll("heartext1", "heartext1")
end;
private.use_heartext1_beg = function()
  ObjDelete( "gfx_inthegroveext_heartext1_zone" );
end;
private.use_heartext1_end = function()
  if common_impl.ZzCompleteCheck("use_heartext1") then ObjSet( common_impl.hint["use_heartext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_inthegroveext_anm_heart1", {animfunc = "use_a1", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_heartext1", private.use_heartext1_inv );
cmn.AddSubscriber( "use_heartext1", private.use_heartext1_beg, private.room_objname );
cmn.AddSubscriber( "use_heartext1", private.use_heartext1_end, private.room_objname );
cmn.AddSubscriber( "use_heartext1", private.use_heartext1_logic );
cmn.AddSubscriber( "use_heartext1_inv", private.use_heartext1_inv, private.room_objname );
cmn.AddSubscriber( "use_heartext1_beg", private.use_heartext1_beg, private.room_objname );
cmn.AddSubscriber( "use_heartext1_end", private.use_heartext1_end, private.room_objname );
cmn.AddSubscriber( "use_heartext1_end", private.use_heartext1_logic );
--------------------------------------------------------------------------------------------
function public.use_heartext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_heartext1" );
    cmn.CallEventHandler( "use_heartext1_end" );
    if ld.CheckRequirements( {"use_heartext1","use_heartext2"} ) then
       ld.CloseSubRoom()
       ld.StartTimer( 0.3, function() ld.Lock(0); cmn.GotoRoom("mg_heartsext"); end )
    else  
       common_impl.Lock(0);
       if common_impl.ZzCompleteCheck("use_heartext1") then ld.CloseSubRoom() end;
    end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_heartext1_inv" );
  cmn.CallEventHandler( "use_heartext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_inthegroveext_anm_heart1", "use_a1", func_end );
  SoundSfx( "aud_use_heartext1_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_heartext2" ] = { type = "use", inv_obj = "inv_heartext2", use_place = "gfx_inthegroveext_heartext2_zone", room = "rm_nearhouseext", zz = "zz_inthegroveext", zz_gate = "gzz_nearhouseext_inthegroveext" };

private.use_heartext2_logic = function()
  if ld.CheckRequirements( {"use_heartext2","use_heartext1"} ) then
    ObjSet("gmg_nearhouseext_heartsext",{ visible = 1, input = 1, active = 1 })    
  end;

end;
private.use_heartext2_inv = function()
  common_impl.ProcessMultiUseAll("heartext2", "heartext2")
end;
private.use_heartext2_beg = function()
  ObjDelete( "gfx_inthegroveext_heartext2_zone" );
end;
private.use_heartext2_end = function()
  if common_impl.ZzCompleteCheck("use_heartext2") then ObjSet( common_impl.hint["use_heartext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_inthegroveext_anm_heart2", {animfunc = "use_a2", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_heartext2", private.use_heartext2_inv );
cmn.AddSubscriber( "use_heartext2", private.use_heartext2_beg, private.room_objname );
cmn.AddSubscriber( "use_heartext2", private.use_heartext2_end, private.room_objname );
cmn.AddSubscriber( "use_heartext2", private.use_heartext2_logic );
cmn.AddSubscriber( "use_heartext2_inv", private.use_heartext2_inv, private.room_objname );
cmn.AddSubscriber( "use_heartext2_beg", private.use_heartext2_beg, private.room_objname );
cmn.AddSubscriber( "use_heartext2_end", private.use_heartext2_end, private.room_objname );
cmn.AddSubscriber( "use_heartext2_end", private.use_heartext2_logic );
--------------------------------------------------------------------------------------------
function public.use_heartext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_heartext2" );
    cmn.CallEventHandler( "use_heartext2_end" );
    if ld.CheckRequirements( {"use_heartext1","use_heartext2"} ) then
       ld.CloseSubRoom()
       ld.StartTimer( 0.3, function() ld.Lock(0); cmn.GotoRoom("mg_heartsext"); end )
    else  
       common_impl.Lock(0);
       if common_impl.ZzCompleteCheck("use_heartext2") then ld.CloseSubRoom() end;
    end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_heartext2_inv" );
  cmn.CallEventHandler( "use_heartext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_inthegroveext_anm_heart2", "use_a2", func_end );
  SoundSfx( "aud_use_heartext2_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_flowersext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletletterext" ] = { type = "use", inv_obj = "inv_amuletletterext", use_place = "gfx_flowersext_amuletletterext_zone", room = "rm_nearhouseext", zz = "zz_flowersext", zz_gate = "gzz_nearhouseext_flowersext" };

private.use_amuletletterext_logic = function()
  ObjSet( "spr_flowersext_skullext2", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_flowersext_skullext2", { active = 1, visible = 1} );
end;
private.use_amuletletterext_inv = function()
  common_impl.ProcessMultiUseAll("amuletletterext", "amuletletterext")
end;
private.use_amuletletterext_beg = function()
  ObjDelete( "gfx_flowersext_amuletletterext_zone" );
end;
private.use_amuletletterext_end = function()
  if common_impl.ZzCompleteCheck("use_amuletletterext") then ObjSet( common_impl.hint["use_amuletletterext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_flowersext_anm_back_scull", {animfunc = "tabl", frame = 999 } );
  ObjSet( "spr_nearhouseext_tabl", {pos_y=470} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletletterext", private.use_amuletletterext_inv );
cmn.AddSubscriber( "use_amuletletterext", private.use_amuletletterext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletletterext", private.use_amuletletterext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletletterext", private.use_amuletletterext_logic );
cmn.AddSubscriber( "use_amuletletterext_inv", private.use_amuletletterext_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletletterext_beg", private.use_amuletletterext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletletterext_end", private.use_amuletletterext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletletterext_end", private.use_amuletletterext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletletterext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletletterext" );
    cmn.CallEventHandler( "use_amuletletterext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletletterext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletletterext_inv" );
  cmn.CallEventHandler( "use_amuletletterext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowersext_anm_back_scull", "tabl", func_end );
  SoundSfx( "aud_use_amuletletterext_nearhouseext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_skullext2" ] = { type = "get", get_obj = "spr_flowersext_skullext2", room = "rm_nearhouseext", zz = "zz_flowersext", zz_gate = "gzz_nearhouseext_flowersext" };

private.get_skullext2_logic = function()
  
end;
private.get_skullext2_inv = function()
  interface.InventoryItemAdd("inv_skullext2","spr_flowersext_skullext2");
end;
private.get_skullext2_beg = function()
  ObjDelete("gfx_flowersext_skullext2")
end;
private.get_skullext2_end = function()
  if common_impl.ZzCompleteCheck("get_skullext2") then ObjSet( common_impl.hint["get_skullext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_flowersext_anm_back_scull", {animfunc = "tabl_end", frame = 0 } );
  ObjDelete("spr_nearhouseext_skullext2");
end;

cmn.AddSubscriber( "get_skullext2", private.get_skullext2_inv );
cmn.AddSubscriber( "get_skullext2", private.get_skullext2_beg, private.room_objname );
cmn.AddSubscriber( "get_skullext2", private.get_skullext2_end, private.room_objname );
cmn.AddSubscriber( "get_skullext2", private.get_skullext2_logic );
--------------------------------------------------------------------
function public.get_skullext2()
  ObjSet( "spr_flowersext_skullext2", {visible = 1} );
  cmn.SetEventDone( "get_skullext2" );
  cmn.CallEventHandler( "get_skullext2" );
  if common_impl.ZzCompleteCheck("get_skullext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_sprayext_zone_clk()  --rm_nearhouseext.use_sprayext_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_sprayext' );
    ObjSet("anm_flowersext_anm_back",{animfunc="static", playing=1})
  end;
  SoundSfx( "aud_touch_bugs_nearhouseext" )
  ld.Lock(1);
  ld.AnimPlay( "anm_flowersext_anm_back", "attack", func_end );  
end;  

common_impl.hint[ "use_sprayext" ] = { type = "use", inv_obj = "inv_sprayext", use_place = "gfx_flowersext_sprayext_zone", room = "rm_nearhouseext", zz = "zz_flowersext", zz_gate = "gzz_nearhouseext_flowersext" };

private.use_sprayext_logic = function()
  ObjSet( "spr_flowersext_pickext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_flowersext_pickext", {active = 1, visible = 1} );
end;
private.use_sprayext_inv = function()
  common_impl.ProcessMultiUseAll("sprayext", "sprayext")
end;
private.use_sprayext_beg = function()
  ObjDelete( "gfx_flowersext_sprayext_zone" );
end;
private.use_sprayext_end = function()
  if common_impl.ZzCompleteCheck("use_sprayext") then ObjSet( common_impl.hint["use_sprayext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_flowersext_anm_back");
  ObjDelete("spr_nearhouseext_wing5");
  --ObjDelete("pfx_flowersext_pm_smoke");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sprayext", private.use_sprayext_inv );
cmn.AddSubscriber( "use_sprayext", private.use_sprayext_beg, private.room_objname );
cmn.AddSubscriber( "use_sprayext", private.use_sprayext_end, private.room_objname );
cmn.AddSubscriber( "use_sprayext", private.use_sprayext_logic );
cmn.AddSubscriber( "use_sprayext_inv", private.use_sprayext_inv, private.room_objname );
cmn.AddSubscriber( "use_sprayext_beg", private.use_sprayext_beg, private.room_objname );
cmn.AddSubscriber( "use_sprayext_end", private.use_sprayext_end, private.room_objname );
cmn.AddSubscriber( "use_sprayext_end", private.use_sprayext_logic );
--------------------------------------------------------------------------------------------
function public.use_sprayext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sprayext" );
    cmn.CallEventHandler( "use_sprayext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sprayext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sprayext_inv" );
  cmn.CallEventHandler( "use_sprayext_beg" );
  common_impl.Lock(1);

  ld.StartTimer( 0.8, function() ObjSet( "pfx_flowersext_pm_smoke", {active = 1, visible = 1} ); end ) 
  ld.AnimPlay( "anm_flowersext_anm_back", "bottle", func_end );
  SoundSfx( "aud_use_sprayext_nearhouseext" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pickext" ] = { type = "get", get_obj = "spr_flowersext_pickext", room = "rm_nearhouseext", zz = "zz_flowersext", zz_gate = "gzz_nearhouseext_flowersext" };

private.get_pickext_logic = function()
  
end;
private.get_pickext_inv = function()
  interface.InventoryItemAdd("inv_pickext","spr_flowersext_pickext");
end;
private.get_pickext_beg = function()
  ObjDelete("gfx_flowersext_pickext")
end;
private.get_pickext_end = function()
  if common_impl.ZzCompleteCheck("get_pickext") then ObjSet( common_impl.hint["get_pickext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_flowersext_sh_pickext");
  ObjDelete("spr_nearhouseext_pickext");
end;

cmn.AddSubscriber( "get_pickext", private.get_pickext_inv );
cmn.AddSubscriber( "get_pickext", private.get_pickext_beg, private.room_objname );
cmn.AddSubscriber( "get_pickext", private.get_pickext_end, private.room_objname );
cmn.AddSubscriber( "get_pickext", private.get_pickext_logic );
--------------------------------------------------------------------
function public.get_pickext()
  cmn.SetEventDone( "get_pickext" );
  cmn.CallEventHandler( "get_pickext" );
  if common_impl.ZzCompleteCheck("get_pickext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_heartsext_for_nearhouseext = function()
    if ld.CheckRequirements( {"win_heartsext"} ) then
      ObjSet( "gmg_nearhouseext_heartsext", {input = 0, visible = 0} );
      ObjSet( "anm_nearhouseext_anm_nearhouseext_open_doorgroov", {animfunc = "open_doorgroov", frame = 999 } );
      ObjSet( "grm_nearhouseext_groveext", {active = 1, input = 1, visible = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearhouseext_groveext_focus");
      end;
    end
  end;
  cmn.AddSubscriber("win_heartsext", win_heartsext_for_nearhouseext, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_nearhouseext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearhouseext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_flowersext" );
  function zz_flowersext.Open()
  end;
  function zz_flowersext.PreOpen()
  end;
  function zz_flowersext.PreClose()
  end;
  function zz_flowersext.Close()
  end;

  subroom.Define( "zz_inthegroveext" );
  function zz_inthegroveext.Open()
  end;
  function zz_inthegroveext.PreOpen()
  end;
  function zz_inthegroveext.PreClose()
  end;
  function zz_inthegroveext.Close()
  end;

  subroom.Define( "zz_benchext" );
  function zz_benchext.Open()
  end;
  function zz_benchext.PreOpen()
  end;
  function zz_benchext.PreClose()
  end;
  function zz_benchext.Close()
  end;

  subroom.Define( "zz_cartext" );
  function zz_cartext.Open()
  end;
  function zz_cartext.PreOpen()
  end;
  function zz_cartext.PreClose()
  end;
  function zz_cartext.Close()
  end;
  
end;
--*********************************************************************************************************************
--------------------- other funcs
function public.nearhouse_idle_clk_zone()  --rm_nearhouseext.nearhouse_idle_clk_zone()
  local func_end = function()
     ObjSet( "obj_nearhouseext_idle_x1_zone", {input = 1} );
  end;  
   SoundSfx( "aud_touch_aid_nearhouse" )
  ObjSet( "obj_nearhouseext_idle_x1_zone", {input = 0} );
  ld.AnimPlay( "anm_nearhouseext_anm_nearhouseext_idle", "idle_xl1", func_end )
end;  
  
function public.nearhouse_idle_nesting_zone()  --rm_nearhouseext.nearhouse_idle_nesting_zone()
  local func_end = function()
     ObjSet( "obj_nearhouseext_idle_nesting_zone", {input = 1} );
  end;  
   SoundSfx( "aud_touch_nesting_box_nearhouseext" )  
  ObjSet( "obj_nearhouseext_idle_nesting_zone", {input = 0} );
  ld.AnimPlay( "anm_nearhouseext_anm_nearhouseext_idle_nesting", "idle_nesting", func_end )
end;  
  