-- name=rm_squareext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_squareext";
  --------------------------------------------------------------------------------------------
  private.InitZz()
 
--------------------------------------------------------------------------------------------
function private.opn_squareext()

  if not ( cmn.IsEventDone( "opn_squareext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_squareext" );
      cmn.CallEventHandler( "opn_squareext" )
      ld.ShowBbt("opn_squareext");
  end;
  func_end()
  end;
end;


local opn_squareext = function()
   
end;
local opn_squareext_logic = function() 

end;
cmn.AddSubscriber( "opn_squareext", opn_squareext_logic )
cmn.AddSubscriber( "opn_squareext", opn_squareext, private.room_objname )

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------

--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sceneext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_scarfext" ] = { type = "get", get_obj = "spr_sceneext_scarfext", room = "rm_squareext", zz = "zz_sceneext", zz_gate = "gzz_squareext_sceneext" };

private.get_scarfext_logic = function()
  
end;
private.get_scarfext_inv = function()
  interface.InventoryItemAdd("inv_scarfext","spr_sceneext_scarfext");
end;
private.get_scarfext_beg = function()
  ObjDelete("gfx_sceneext_scarfext")
end;
private.get_scarfext_end = function()
  ObjDelete("spr_sceneext_scarfext_shadow")
  ObjDelete("spr_squareext_scarfext")
  if common_impl.ZzCompleteCheck("get_scarfext") then ObjSet( common_impl.hint["get_scarfext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_scarfext", private.get_scarfext_inv );
cmn.AddSubscriber( "get_scarfext", private.get_scarfext_beg, private.room_objname );
cmn.AddSubscriber( "get_scarfext", private.get_scarfext_end, private.room_objname );
cmn.AddSubscriber( "get_scarfext", private.get_scarfext_logic );
--------------------------------------------------------------------
function public.get_scarfext()
  cmn.SetEventDone( "get_scarfext" );
  cmn.CallEventHandler( "get_scarfext" );
  if common_impl.ZzCompleteCheck("get_scarfext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dogfigureext" ] = { type = "use", inv_obj = "inv_dogfigureext", use_place = "gfx_sceneext_dogfigureext_zone", room = "rm_squareext", zz = "zz_sceneext", zz_gate = "gzz_squareext_sceneext" };

private.use_dogfigureext_logic = function()
  ObjSet( "gfx_sceneext_win_figuresext_zone", { input = 1, active = 1 } )

end;
private.use_dogfigureext_inv = function()
  common_impl.ProcessMultiUseAll("dogfigureext", "dogfigureext")
end;
private.use_dogfigureext_beg = function()
  ObjDelete( "gfx_sceneext_dogfigureext_zone" );
end;
private.use_dogfigureext_end = function()
    ObjAttach("spr_sceneext_mmg_root","zz_sceneext")  
  ObjSet( "spr_sceneext_mmg_root", {input = 1, alp = 1} );    
  if common_impl.ZzCompleteCheck("use_dogfigureext") then ObjSet( common_impl.hint["use_dogfigureext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dogfigureext", private.use_dogfigureext_inv );
cmn.AddSubscriber( "use_dogfigureext", private.use_dogfigureext_beg, private.room_objname );
cmn.AddSubscriber( "use_dogfigureext", private.use_dogfigureext_end, private.room_objname );
cmn.AddSubscriber( "use_dogfigureext", private.use_dogfigureext_logic );
cmn.AddSubscriber( "use_dogfigureext_inv", private.use_dogfigureext_inv, private.room_objname );
cmn.AddSubscriber( "use_dogfigureext_beg", private.use_dogfigureext_beg, private.room_objname );
cmn.AddSubscriber( "use_dogfigureext_end", private.use_dogfigureext_end, private.room_objname );
cmn.AddSubscriber( "use_dogfigureext_end", private.use_dogfigureext_logic );
--------------------------------------------------------------------------------------------
function public.use_dogfigureext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dogfigureext" );
    cmn.CallEventHandler( "use_dogfigureext_end" );
    common_impl.Lock(0);
    private.figuresext_loadstate()
    cmn.MiniGameShow( "figuresext" );    
    if common_impl.ZzCompleteCheck("use_dogfigureext") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
    ObjAttach("spr_sceneext_mmg_root","zz_sceneext")
    ObjAnimate( "spr_sceneext_mmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );    
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dogfigureext_inv" );
  cmn.CallEventHandler( "use_dogfigureext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sceneext_anm_dog", "clownkeyext", f_step );
  SoundSfx( "aud_use_dogfigureext_squareext" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_figuresext" ] = { type = "click", use_place = "gfx_sceneext_win_figuresext_zone", room = "rm_squareext", zz = "zz_sceneext", zz_gate = "gzz_squareext_sceneext" };

private.win_figuresext_logic = function()
  if cmn.IsEventDone("win_figuresext") then
    ObjSet( "spr_sceneext_clownkeyext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_figuresext_beg = function()
  if cmn.IsEventDone("win_figuresext") then 
    ObjDelete( "gfx_sceneext_win_figuresext_zone" );
  end
end;
private.win_figuresext_end = function()
  if cmn.IsEventDone("win_figuresext") then
    for i=1,4 do 
      ObjSet( "spr_sceneext_arrow_"..i, {input = 0,alp=0} );
    end
    ObjSet("spr_sceneext_dog",{pos_x=-208,pos_y=-208})
    ObjSet("spr_sceneext_clownkeyext",{pos_x=0,pos_y=0,scale_x=0.9,scale_y=0.9})
    ObjAttach("spr_sceneext_clownkeyext","spr_sceneext_dog")    
    if common_impl.ZzCompleteCheck("win_figuresext") then ObjSet( common_impl.hint["win_figuresext"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_figuresext", private.win_figuresext_beg, private.room_objname );
cmn.AddSubscriber( "win_figuresext", private.win_figuresext_end, private.room_objname );
cmn.AddSubscriber( "win_figuresext", private.win_figuresext_logic );
cmn.AddSubscriber( "win_figuresext_beg", private.win_figuresext_beg, private.room_objname );
cmn.AddSubscriber( "win_figuresext_end", private.win_figuresext_end, private.room_objname );
cmn.AddSubscriber( "win_figuresext_end", private.win_figuresext_logic );
--------------------------------------------------------------------------------------------
function public.win_figuresext()

  local func_end = function()
    
    cmn.SetEventDone( "win_figuresext" );
    cmn.CallEventHandler( "win_figuresext_end" );
    -- public.get_clownkeyext()
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_figuresext") then ld.CloseSubRoom() end;
  end;
  cmn.MiniGameHide( "figuresext", true );   
  cmn.CallEventHandler( "win_figuresext_beg" );
  common_impl.Lock(1);


  ObjAnimate( "spr_sceneext_clownkeyext", 6, 0, 0, func_end, {0,0,0.5,0.5, 0.5,0,0.9,0.9} );

  --SoundSfx( 0 )


end;
--------------------------------------------------------------------------------------------
function private.figuresext_loadstate(skip)
  if not ng_global.progress["ext"]["win_figuresext"].state then
    ng_global.progress["ext"]["win_figuresext"].state  = {9,9,0,52}
  end
  if ng_global.progress["ext"]["win_figuresext"].state[3]==1 then
    ObjSet("spr_sceneext_clownkeyext",{pos_x=0,pos_y=0})
    ObjAttach("spr_sceneext_clownkeyext","spr_sceneext_dog")
  end
  local step = private.figuresext_step  
  ObjSet("spr_sceneext_dog",{pos_x=-260+ng_global.progress["ext"]["win_figuresext"].state[2]*step,
                             pos_y=-260+ng_global.progress["ext"]["win_figuresext"].state[1]*step})
  --ld.LogTrace( ng_global.progress["ext"]["win_figuresext"].state );
  ObjSet("txt_sceneext_mmg_count",{text = ng_global.progress["ext"]["win_figuresext"].state[4]})
  if not skip then
    private.figuresext_check()
  end
end

private.figuresext_maze = {
  --  1         2         3         4         5         6         7         8         9
  {  {1,1,0,1},{1,0,0,1},{1,0,1,0},{1,0,1,0},{1,0,1,0},{1,0,1,0},{1,1,0,0},{1,0,0,1},{1,1,0,0} },--1
  {  {0,1,0,1},{0,0,1,1},{1,1,0,0},{1,0,0,1},{1,0,1,0},{1,1,0,0},{0,1,0,1},{0,1,0,1},{0,1,0,1} },--2
  {  {0,0,1,1},{1,1,0,0},{0,0,1,1},{0,1,1,0},{1,0,0,1},{0,1,0,0},{0,1,0,1},{0,1,0,1},{0,1,0,1} },--3
  {  {1,1,0,1},{0,0,1,1},{1,1,0,0},{1,1,1,1},{0,1,0,1},{0,0,0,1},{0,1,1,0},{0,1,1,1},{0,1,0,1} },--4
  {  {0,1,0,1},{1,0,0,1},{0,1,1,0},{1,0,0,1},{0,1,1,0},{0,1,0,1},{1,0,0,1},{1,0,1,0},{0,1,1,0} },--5
  {  {0,0,1,1},{0,0,1,0},{1,0,1,0},{0,1,1,0},{1,0,0,1},{0,1,1,0},{0,1,0,1},{1,0,1,1},{1,1,0,0} },--6
  {  {1,0,0,1},{1,0,0,0},{1,0,1,0},{1,1,0,0},{0,0,1,1},{1,0,1,0},{0,1,0,0},{1,0,0,1},{0,1,0,0} },--7
  {  {0,1,1,1},{0,0,0,1},{1,1,0,0},{0,0,1,1},{1,0,1,0},{1,0,1,0},{0,1,1,0},{0,1,0,1},{0,1,0,1} },--8
  {  {1,0,1,1},{0,1,1,0},{0,0,1,1},{1,0,1,0},{1,0,1,0},{1,0,1,0},{1,0,1,0},{0,1,1,0},{0,1,1,1} },--9

}
private.figuresext_step = 52

function public.figuresext_mdown(obj)
    local step = private.figuresext_step
    local way_arr = {{0,-1},{1,0},{0,1},{-1,0}}
    
    local way = tonumber(ld.StringDivide(obj)[4])
    ng_global.progress["ext"]["win_figuresext"].state [1]=ng_global.progress["ext"]["win_figuresext"].state [1]+way_arr[way][2]
    ng_global.progress["ext"]["win_figuresext"].state [2]=ng_global.progress["ext"]["win_figuresext"].state [2]+way_arr[way][1]    
    local param = ObjGet("spr_sceneext_dog")
    ld.Lock(1)
    SoundSfx( "aud_mg_labirint_move" )
    ObjAnimate(param.name , 3, 0, 0, function()ld.Lock(0);private.figuresext_check()end, {0,0,param.pos_x,param.pos_y, 0.2,0,param.pos_x+way_arr[way][1]*step,param.pos_y+way_arr[way][2]*step} );
      
    ng_global.progress["ext"]["win_figuresext"].state[4] = ng_global.progress["ext"]["win_figuresext"].state[4] - 1
end

function private.figuresext_check()
  local s = ng_global.progress["ext"]["win_figuresext"].state 
  for i=1,4 do 
    if private.figuresext_maze[s[1] ][s[2] ][i] == 1 then
      ObjSet("spr_sceneext_arrow_"..i,{alp=0,input=0})
    elseif private.figuresext_maze[s[1] ][s[2] ][i] == 0 then
      ObjSet("spr_sceneext_arrow_"..i,{alp=1,input=1})
    end
  end
  if ng_global.progress["ext"]["win_figuresext"].state[3]==0 and ng_global.progress["ext"]["win_figuresext"].state [1]==3 
    and ng_global.progress["ext"]["win_figuresext"].state[2]==3 then
    ng_global.progress["ext"]["win_figuresext"].state[3]=1
    ObjSet("spr_sceneext_clownkeyext",{pos_x=0,pos_y=0})
    SoundSfx( "aud_mg_labirint_get" )
    ObjAttach("spr_sceneext_clownkeyext","spr_sceneext_dog")
  end
  ObjSet("txt_sceneext_mmg_count",{text = ng_global.progress["ext"]["win_figuresext"].state[4]})
  if ng_global.progress["ext"]["win_figuresext"].state[3]==1 and ng_global.progress["ext"]["win_figuresext"].state [1]==1 
    and ng_global.progress["ext"]["win_figuresext"].state[2]==1 and ng_global.progress["ext"]["win_figuresext"].state[4] >=0 then
      SoundSfx( "aud_mg_labirint_win" )
      public.win_figuresext()
  elseif ng_global.progress["ext"]["win_figuresext"].state[4] == 0 then
      SoundSfx( "aud_mg_labirint_wrong" )
      private.win_figuresext_reset()
  end

end

function public.figuresext_menter(obj)
  ld.ShCur(CURSOR_HAND)
  local obj_focus = obj.."_focus" 
  ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,1} );
end
function public.figuresext_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  local obj_focus = obj.."_focus" 
  ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,0} );  
end

function private.win_figuresext_skip()
  ng_global.progress["ext"]["win_figuresext"].state  = {1,1,1,0}
  
  local f_end = function ()
    ObjAnimate( "spr_sceneext_dog", 8, 0, 0, "", {0,0,0, 0.5,0,1} );
    ObjAnimate( "spr_sceneext_clownkeyext", 8, 0, 0,function()ld.Lock(0) private.figuresext_check() end, {0,0,0, 0.5,0,1} );  
    private.figuresext_loadstate(true)    
  end
    ld.Lock(1)  
    ObjAnimate( "spr_sceneext_clownkeyext", 8, 0, 0, "", {0,0,1, 0.5,0,0} );       
    ObjAnimate( "spr_sceneext_dog", 8, 0, 0, f_end, {0,0,1, 0.5,0,0} );
end

function private.win_figuresext_reset()
  local f_end = function ()
    ObjSet("spr_sceneext_clownkeyext",{pos_x=-104,pos_y=-104})
    ObjAttach("spr_sceneext_clownkeyext","spr_sceneext_mmg_root")    
    ObjAnimate( "spr_sceneext_dog", 8, 0, 0, "", {0,0,0, 0.5,0,1} );
    ObjAnimate( "spr_sceneext_clownkeyext", 8, 0, 0, function()ld.Lock(0) end, {0,0,0, 0.5,0,1} );  
    private.figuresext_loadstate()    
  end
    ld.Lock(1)  
    ng_global.progress["ext"]["win_figuresext"].state  = {9,9,0,52}
    ObjAnimate( "spr_sceneext_clownkeyext", 8, 0, 0, "", {0,0,1, 0.5,0,0} );       
    ObjAnimate( "spr_sceneext_dog", 8, 0, 0, f_end, {0,0,1, 0.5,0,0} );
end
--------------------------------------------------------------------
common_impl.hint[ "get_clownkeyext" ] = { type = "get", get_obj = "spr_sceneext_clownkeyext", room = "rm_squareext", zz = "zz_sceneext", zz_gate = "gzz_squareext_sceneext" };

private.get_clownkeyext_logic = function()
  
end;
private.get_clownkeyext_inv = function()
  interface.InventoryItemAdd("inv_clownkeyext","spr_sceneext_clownkeyext");
end;
private.get_clownkeyext_beg = function()
  ObjDelete("gfx_sceneext_clownkeyext")
end;
private.get_clownkeyext_end = function()
  ObjDelete("spr_sceneext_mmg_root")
  if common_impl.ZzCompleteCheck("get_clownkeyext") then ObjSet( common_impl.hint["get_clownkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_clownkeyext", private.get_clownkeyext_inv );
cmn.AddSubscriber( "get_clownkeyext_inv", private.get_clownkeyext_inv, private.room_objname );
cmn.AddSubscriber( "get_clownkeyext", private.get_clownkeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_clownkeyext_beg", private.get_clownkeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_clownkeyext", private.get_clownkeyext_end, private.room_objname );
cmn.AddSubscriber( "get_clownkeyext_end", private.get_clownkeyext_end, private.room_objname );
cmn.AddSubscriber( "get_clownkeyext", private.get_clownkeyext_logic );
--------------------------------------------------------------------
function public.get_clownkeyext()
  local func_end = function()  
  ld.Lock(0)    
  cmn.SetEventDone( "get_clownkeyext" );
  cmn.CallEventHandler( "get_clownkeyext_end" );
  if common_impl.ZzCompleteCheck("get_clownkeyext") then ld.CloseSubRoom() end;
  end
  cmn.CallEventHandler( "get_clownkeyext_inv" );  
  cmn.CallEventHandler( "get_clownkeyext_beg" );  
  --ld.Lock(1)
  ObjAnimate( "spr_sceneext_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_colorpyramidext" ] = { type = "use", inv_obj = "inv_colorpyramidext", use_place = "gfx_sceneext_colorpyramidext_zone", room = "rm_squareext", zz = "zz_sceneext", zz_gate = "gzz_squareext_sceneext" };

private.use_colorpyramidext_logic = function()
  ObjSet( "spr_sceneext_barnkeyext", { input = 1, active = 1 } )

end;
private.use_colorpyramidext_inv = function()
  common_impl.ProcessMultiUseAll("colorpyramidext", "colorpyramidext")
end;
private.use_colorpyramidext_beg = function()
  ObjDelete( "gfx_sceneext_colorpyramidext_zone" );
end;
private.use_colorpyramidext_end = function()
  ObjSet( "gfx_sceneext_barnkeyext", {visible = 1} );
  ObjSet("anm_sceneext_anm_pyramid",{animfunc="pyramid_end_key",frame=0})
  ObjSet( "spr_squareext_pyramid", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_colorpyramidext") then ObjSet( common_impl.hint["use_colorpyramidext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_colorpyramidext", private.use_colorpyramidext_inv );
cmn.AddSubscriber( "use_colorpyramidext", private.use_colorpyramidext_beg, private.room_objname );
cmn.AddSubscriber( "use_colorpyramidext", private.use_colorpyramidext_end, private.room_objname );
cmn.AddSubscriber( "use_colorpyramidext", private.use_colorpyramidext_logic );
cmn.AddSubscriber( "use_colorpyramidext_inv", private.use_colorpyramidext_inv, private.room_objname );
cmn.AddSubscriber( "use_colorpyramidext_beg", private.use_colorpyramidext_beg, private.room_objname );
cmn.AddSubscriber( "use_colorpyramidext_end", private.use_colorpyramidext_end, private.room_objname );
cmn.AddSubscriber( "use_colorpyramidext_end", private.use_colorpyramidext_logic );
--------------------------------------------------------------------------------------------
function public.use_colorpyramidext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_colorpyramidext" );
    cmn.CallEventHandler( "use_colorpyramidext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_colorpyramidext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_colorpyramidext_inv" );
  cmn.CallEventHandler( "use_colorpyramidext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sceneext_anm_pyramid", "pyramid_use", func_end );
  SoundSfx( "aud_use_colorpyramidext_squareext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_barnkeyext" ] = { type = "get", get_obj = "spr_sceneext_barnkeyext", room = "rm_squareext", zz = "zz_sceneext", zz_gate = "gzz_squareext_sceneext" };

private.get_barnkeyext_logic = function()

end;
private.get_barnkeyext_inv = function()
  interface.InventoryItemAdd("inv_barnkeyext","spr_sceneext_barnkeyext");
end;
private.get_barnkeyext_beg = function()
  ObjSet( "spr_sceneext_barnkeyext", {visible = 1} );  
  ObjDelete("gfx_sceneext_barnkeyext")
end;
private.get_barnkeyext_end = function()
  ObjSet("anm_sceneext_anm_pyramid",{animfunc="key_use",frame=0})  
  if common_impl.ZzCompleteCheck("get_barnkeyext") then ObjSet( common_impl.hint["get_barnkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_barnkeyext", private.get_barnkeyext_inv );
cmn.AddSubscriber( "get_barnkeyext", private.get_barnkeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_barnkeyext", private.get_barnkeyext_end, private.room_objname );
cmn.AddSubscriber( "get_barnkeyext", private.get_barnkeyext_logic );
--------------------------------------------------------------------
function public.get_barnkeyext()
  cmn.SetEventDone( "get_barnkeyext" );
  cmn.CallEventHandler( "get_barnkeyext" );
  if common_impl.ZzCompleteCheck("get_barnkeyext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_spottingplacesext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scarfext" ] = { type = "use", inv_obj = "inv_scarfext", use_place = "gfx_spottingplacesext_scarfext_zone", room = "rm_squareext", zz = "zz_spottingplacesext", zz_gate = "gzz_squareext_spottingplacesext" };

private.use_scarfext_logic = function()
  ObjSet( "spr_spottingplacesext_pieceglassext", { visible = 1, input = 1, active = 1 } )

end;
private.use_scarfext_inv = function()
  common_impl.ProcessMultiUseAll("scarfext", "scarfext")
end;
private.use_scarfext_beg = function()
  ObjDelete( "gfx_spottingplacesext_scarfext_zone" );
end;
private.use_scarfext_end = function()
  ObjDelete("anm_spottingplacesext_use_scarf")
  if common_impl.ZzCompleteCheck("use_scarfext") then ObjSet( common_impl.hint["use_scarfext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scarfext", private.use_scarfext_inv );
cmn.AddSubscriber( "use_scarfext", private.use_scarfext_beg, private.room_objname );
cmn.AddSubscriber( "use_scarfext", private.use_scarfext_end, private.room_objname );
cmn.AddSubscriber( "use_scarfext", private.use_scarfext_logic );
cmn.AddSubscriber( "use_scarfext_inv", private.use_scarfext_inv, private.room_objname );
cmn.AddSubscriber( "use_scarfext_beg", private.use_scarfext_beg, private.room_objname );
cmn.AddSubscriber( "use_scarfext_end", private.use_scarfext_end, private.room_objname );
cmn.AddSubscriber( "use_scarfext_end", private.use_scarfext_logic );
--------------------------------------------------------------------------------------------
function public.use_scarfext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scarfext" );
    cmn.CallEventHandler( "use_scarfext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scarfext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scarfext_inv" );
  cmn.CallEventHandler( "use_scarfext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_spottingplacesext_use_scarf", "use_scarf", func_end );
  SoundSfx( "aud_use_scarfext_squareext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pieceglassext" ] = { type = "get", get_obj = "spr_spottingplacesext_pieceglassext", room = "rm_squareext", zz = "zz_spottingplacesext", zz_gate = "gzz_squareext_spottingplacesext" };

private.get_pieceglassext_logic = function()
  
end;
private.get_pieceglassext_inv = function()
  interface.InventoryItemAdd("inv_pieceglassext","spr_spottingplacesext_pieceglassext");
end;
private.get_pieceglassext_beg = function()
  ObjDelete("gfx_spottingplacesext_pieceglassext")
end;
private.get_pieceglassext_end = function()
  ObjDelete("spr_squareext_pieceglassext_idle")
  if common_impl.ZzCompleteCheck("get_pieceglassext") then ObjSet( common_impl.hint["get_pieceglassext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pieceglassext", private.get_pieceglassext_inv );
cmn.AddSubscriber( "get_pieceglassext", private.get_pieceglassext_beg, private.room_objname );
cmn.AddSubscriber( "get_pieceglassext", private.get_pieceglassext_end, private.room_objname );
cmn.AddSubscriber( "get_pieceglassext", private.get_pieceglassext_logic );
--------------------------------------------------------------------
function public.get_pieceglassext()
  cmn.SetEventDone( "get_pieceglassext" );
  cmn.CallEventHandler( "get_pieceglassext" );
  if common_impl.ZzCompleteCheck("get_pieceglassext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_clownkeyext" ] = { type = "use", inv_obj = "inv_clownkeyext", use_place = "gfx_spottingplacesext_clownkeyext_zone", room = "rm_squareext", zz = "zz_spottingplacesext", zz_gate = "gzz_squareext_spottingplacesext" };

private.use_clownkeyext_logic = function()
  ObjSet( "spr_spottingplacesext_candleext2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_spottingplacesext_hacksawext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_spottingplacesext_iconext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_clownkeyext_inv = function()
  common_impl.ProcessMultiUseAll("clownkeyext", "clownkeyext")
end;
private.use_clownkeyext_beg = function()
  ObjDelete( "gfx_spottingplacesext_clownkeyext_zone" );
end;
private.use_clownkeyext_end = function()
  ObjSet("anm_spottingplacesext_door",{animfunc="cap_close_idle",frame=0})
  ObjSet( "spr_spottingplacesext_candleext2_shad", {alp = 1} );
  ObjSet( "spr_spottingplacesext_hacksawext_shad", {alp = 1} );
  ObjSet( "spr_squareext_zz_open", {alp = 1} );
  ObjDelete("spr_squareext_zz_close")
  
  if common_impl.ZzCompleteCheck("use_clownkeyext") then ObjSet( common_impl.hint["use_clownkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_clownkeyext", private.use_clownkeyext_inv );
cmn.AddSubscriber( "use_clownkeyext", private.use_clownkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_clownkeyext", private.use_clownkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_clownkeyext", private.use_clownkeyext_logic );
cmn.AddSubscriber( "use_clownkeyext_inv", private.use_clownkeyext_inv, private.room_objname );
cmn.AddSubscriber( "use_clownkeyext_beg", private.use_clownkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_clownkeyext_end", private.use_clownkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_clownkeyext_end", private.use_clownkeyext_logic );
--------------------------------------------------------------------------------------------
function public.use_clownkeyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_clownkeyext" );
    cmn.CallEventHandler( "use_clownkeyext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_clownkeyext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_clownkeyext_inv" );
  cmn.CallEventHandler( "use_clownkeyext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_spottingplacesext_door", "use_key", func_end );
  SoundSfx( "aud_use_clownkeyext_squareext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_candleext2" ] = { type = "get", get_obj = "spr_spottingplacesext_candleext2", room = "rm_squareext", zz = "zz_spottingplacesext", zz_gate = "gzz_squareext_spottingplacesext" };

private.get_candleext2_logic = function()
  
end;
private.get_candleext2_inv = function()
  interface.InventoryItemAdd("inv_candleext","spr_spottingplacesext_candleext2",function() level_inv.ProcessGetCandleextAll( "get_candleext2" ) end);
end;
private.get_candleext2_beg = function()
  ObjDelete("gfx_spottingplacesext_candleext2")
end;
private.get_candleext2_end = function()
  ObjDelete("spr_spottingplacesext_candleext2_shad")
  ObjDelete("spr_squareext_candleext2")
  if common_impl.ZzCompleteCheck("get_candleext2") then ObjSet( common_impl.hint["get_candleext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_candleext2", private.get_candleext2_inv );
cmn.AddSubscriber( "get_candleext2", private.get_candleext2_beg, private.room_objname );
cmn.AddSubscriber( "get_candleext2", private.get_candleext2_end, private.room_objname );
cmn.AddSubscriber( "get_candleext2", private.get_candleext2_logic );
--------------------------------------------------------------------
function public.get_candleext2()
  cmn.SetEventDone( "get_candleext2" );
  cmn.CallEventHandler( "get_candleext2" );
  
  if common_impl.ZzCompleteCheck("get_candleext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hacksawext" ] = { type = "get", get_obj = "spr_spottingplacesext_hacksawext", room = "rm_squareext", zz = "zz_spottingplacesext", zz_gate = "gzz_squareext_spottingplacesext" };

private.get_hacksawext_logic = function()
  
end;
private.get_hacksawext_inv = function()
  interface.InventoryItemAdd("inv_hacksawext","spr_spottingplacesext_hacksawext");
end;
private.get_hacksawext_beg = function()
  ObjDelete("gfx_spottingplacesext_hacksawext")
end;
private.get_hacksawext_end = function()
  ObjDelete("spr_spottingplacesext_hacksawext_shad")
  ObjDelete("spr_squareext_hacksawext")
  if common_impl.ZzCompleteCheck("get_hacksawext") then ObjSet( common_impl.hint["get_hacksawext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_inv );
cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_beg, private.room_objname );
cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_end, private.room_objname );
cmn.AddSubscriber( "get_hacksawext", private.get_hacksawext_logic );
--------------------------------------------------------------------
function public.get_hacksawext()
  cmn.SetEventDone( "get_hacksawext" );
  cmn.CallEventHandler( "get_hacksawext" );
  if common_impl.ZzCompleteCheck("get_hacksawext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_iconext" ] = { type = "use", inv_obj = "inv_iconext", use_place = "gfx_spottingplacesext_iconext_zone", room = "rm_squareext", zz = "zz_spottingplacesext", zz_gate = "gzz_squareext_spottingplacesext" };

private.use_iconext_logic = function()
  ObjSet( "spr_spottingplacesext_puppetext", {  input = 1, active = 1 } )

end;
private.use_iconext_inv = function()
  common_impl.ProcessMultiUseAll("iconext", "iconext")
end;
private.use_iconext_beg = function()
  ObjDelete( "gfx_spottingplacesext_iconext_zone" );
end;
private.use_iconext_end = function()
  ObjSet( "gfx_spottingplacesext_puppetext", {visible = 1} );
  ObjSet("anm_spottingplacesext_door",{animfunc="use_mask",frame=999})
  ObjSet( "spr_squareext_tabl", {alp = 1} );
  ObjSet( "spr_squareext_cap_open", {alp = 1} );
  ObjDelete("spr_squareext_cap_close")
  ObjSet( "spr_squareext_puppetext", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_iconext") then ObjSet( common_impl.hint["use_iconext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_iconext", private.use_iconext_inv );
cmn.AddSubscriber( "use_iconext", private.use_iconext_beg, private.room_objname );
cmn.AddSubscriber( "use_iconext", private.use_iconext_end, private.room_objname );
cmn.AddSubscriber( "use_iconext", private.use_iconext_logic );
cmn.AddSubscriber( "use_iconext_inv", private.use_iconext_inv, private.room_objname );
cmn.AddSubscriber( "use_iconext_beg", private.use_iconext_beg, private.room_objname );
cmn.AddSubscriber( "use_iconext_end", private.use_iconext_end, private.room_objname );
cmn.AddSubscriber( "use_iconext_end", private.use_iconext_logic );
--------------------------------------------------------------------------------------------
function public.use_iconext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_iconext" );
    cmn.CallEventHandler( "use_iconext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_iconext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_iconext_inv" );
  cmn.CallEventHandler( "use_iconext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_spottingplacesext_door", "use_mask", func_end );
  SoundSfx( "aud_use_iconext_squareext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_puppetext" ] = { type = "get", get_obj = "spr_spottingplacesext_puppetext", room = "rm_squareext", zz = "zz_spottingplacesext", zz_gate = "gzz_squareext_spottingplacesext" };

private.get_puppetext_logic = function()

end;
private.get_puppetext_inv = function()
  interface.InventoryItemAdd("inv_puppetext","spr_spottingplacesext_puppetext");
end;
private.get_puppetext_beg = function()
  ObjDelete("gfx_spottingplacesext_puppetext")
end;
private.get_puppetext_end = function()
  ObjSet( "spr_spottingplacesext_puppetext", {visible = 1} );  
  ObjSet("anm_spottingplacesext_door",{animfunc="use_mask_end",frame=0})  
  ObjDelete("spr_squareext_puppetext")
  if common_impl.ZzCompleteCheck("get_puppetext") then ObjSet( common_impl.hint["get_puppetext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_puppetext", private.get_puppetext_inv );
cmn.AddSubscriber( "get_puppetext", private.get_puppetext_beg, private.room_objname );
cmn.AddSubscriber( "get_puppetext", private.get_puppetext_end, private.room_objname );
cmn.AddSubscriber( "get_puppetext", private.get_puppetext_logic );
--------------------------------------------------------------------
function public.get_puppetext()
  cmn.SetEventDone( "get_puppetext" );
  cmn.CallEventHandler( "get_puppetext" );
  if common_impl.ZzCompleteCheck("get_puppetext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_puppettheatreext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_childrencoinext" ] = { type = "use", inv_obj = "inv_childrencoinext", use_place = "gfx_puppettheatreext_childrencoinext_zone", room = "rm_squareext", zz = "zz_puppettheatreext", zz_gate = "gzz_squareext_puppettheatreext" };

private.use_childrencoinext_logic = function()
  ObjSet( "spr_puppettheatreext_hamsaext", { visible = 1, input = 1, active = 1 } )


end;
private.use_childrencoinext_inv = function()
  common_impl.ProcessMultiUseAll("childrencoinext", "childrencoinext")
end;
private.use_childrencoinext_beg = function()
  ObjDelete( "gfx_puppettheatreext_childrencoinext_zone" );
end;
private.use_childrencoinext_end = function()
  ObjSet( "anm_puppettheatreext_back", {animfunc="open_door_end",frame=0} );
  ObjSet( "spr_puppettheatreext_sh_hamsaext", {visible = 1} );
  ObjSet( "spr_squareext_open_zz_puppettheatre", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_childrencoinext") then ObjSet( common_impl.hint["use_childrencoinext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_childrencoinext", private.use_childrencoinext_inv );
cmn.AddSubscriber( "use_childrencoinext", private.use_childrencoinext_beg, private.room_objname );
cmn.AddSubscriber( "use_childrencoinext", private.use_childrencoinext_end, private.room_objname );
cmn.AddSubscriber( "use_childrencoinext", private.use_childrencoinext_logic );
cmn.AddSubscriber( "use_childrencoinext_inv", private.use_childrencoinext_inv, private.room_objname );
cmn.AddSubscriber( "use_childrencoinext_beg", private.use_childrencoinext_beg, private.room_objname );
cmn.AddSubscriber( "use_childrencoinext_end", private.use_childrencoinext_end, private.room_objname );
cmn.AddSubscriber( "use_childrencoinext_end", private.use_childrencoinext_logic );
--------------------------------------------------------------------------------------------
function public.use_childrencoinext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_childrencoinext" );
    cmn.CallEventHandler( "use_childrencoinext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_childrencoinext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_childrencoinext_inv" );
  cmn.CallEventHandler( "use_childrencoinext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_puppettheatreext_back", "open_door", func_end );
  SoundSfx( "aud_use_childrencoinext_squareext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hamsaext" ] = { type = "get", get_obj = "spr_puppettheatreext_hamsaext", room = "rm_squareext", zz = "zz_puppettheatreext", zz_gate = "gzz_squareext_puppettheatreext" };

private.get_hamsaext_logic = function()
    ObjSet( "gfx_puppettheatreext_puppetext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_hamsaext_inv = function()
  interface.InventoryItemAdd("inv_hamsaext","spr_puppettheatreext_hamsaext");
end;
private.get_hamsaext_beg = function()
  ObjDelete("gfx_puppettheatreext_hamsaext")
end;
private.get_hamsaext_end = function()
  ObjDelete("spr_puppettheatreext_sh_hamsaext")
  if common_impl.ZzCompleteCheck("get_hamsaext") then ObjSet( common_impl.hint["get_hamsaext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_hamsaext", private.get_hamsaext_inv );
cmn.AddSubscriber( "get_hamsaext", private.get_hamsaext_beg, private.room_objname );
cmn.AddSubscriber( "get_hamsaext", private.get_hamsaext_end, private.room_objname );
cmn.AddSubscriber( "get_hamsaext", private.get_hamsaext_logic );
--------------------------------------------------------------------
function public.get_hamsaext()
  cmn.SetEventDone( "get_hamsaext" );
  cmn.CallEventHandler( "get_hamsaext" );
  if common_impl.ZzCompleteCheck("get_hamsaext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_puppetext" ] = { type = "use", inv_obj = "inv_puppetext", use_place = "gfx_puppettheatreext_puppetext_zone", room = "rm_squareext", zz = "zz_puppettheatreext", zz_gate = "gzz_squareext_puppettheatreext" };

private.use_puppetext_logic = function()
  ObjSet( "gfx_puppettheatreext_win_puppetsext_zone", {  input = 1 } )

end;
private.use_puppetext_inv = function()
  common_impl.ProcessMultiUseAll("puppetext", "puppetext")
end;
private.use_puppetext_beg = function()
  ObjDelete( "gfx_puppettheatreext_puppetext_zone" );
end;
private.use_puppetext_end = function()
  ObjAttach("spr_puppettheatreext_mmg_root","zz_puppettheatreext")
  ObjSet( "spr_puppettheatreext_mmg_root", {input = 1} );
  ObjSet( "anm_puppettheatreext_back", {animfunc="skull",frame=0} );
  ObjSet( "spr_puppettheatreext_arrow_root", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_puppetext") then ObjSet( common_impl.hint["use_puppetext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_puppetext", private.use_puppetext_inv );
cmn.AddSubscriber( "use_puppetext", private.use_puppetext_beg, private.room_objname );
cmn.AddSubscriber( "use_puppetext", private.use_puppetext_end, private.room_objname );
cmn.AddSubscriber( "use_puppetext", private.use_puppetext_logic );
cmn.AddSubscriber( "use_puppetext_inv", private.use_puppetext_inv, private.room_objname );
cmn.AddSubscriber( "use_puppetext_beg", private.use_puppetext_beg, private.room_objname );
cmn.AddSubscriber( "use_puppetext_end", private.use_puppetext_end, private.room_objname );
cmn.AddSubscriber( "use_puppetext_end", private.use_puppetext_logic );
--------------------------------------------------------------------------------------------
function public.use_puppetext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_puppetext" );
    cmn.CallEventHandler( "use_puppetext_end" );
    common_impl.Lock(0);
    private.puppetsext_loadstate()
    cmn.MiniGameShow( "puppetsext" );     
    if common_impl.ZzCompleteCheck("use_puppetext") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    ObjAttach("spr_puppettheatreext_mmg_root","zz_puppettheatreext")
    ObjSet( "anm_puppettheatreext_back", {animfunc="skull",frame=0} );    
    ObjAnimate( "spr_puppettheatreext_arrow_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_puppetext_inv" );
  cmn.CallEventHandler( "use_puppetext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_puppettheatreext_back", "doll", f_step );
  SoundSfx( "aud_use_puppetext_squareext" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_puppetsext" ] = { type = "click", use_place = "gfx_puppettheatreext_win_puppetsext_zone", room = "rm_squareext", zz = "zz_puppettheatreext", zz_gate = "gzz_squareext_puppettheatreext" };

private.win_puppetsext_logic = function()
  if cmn.IsEventDone("win_puppetsext") then  
    ObjSet( "spr_puppettheatreext_skullext1", {  input = 1, active = 1 } )
  end

end;
private.win_puppetsext_beg = function()
  if cmn.IsEventDone("win_puppetsext") then  
    ObjDelete( "gfx_puppettheatreext_win_puppetsext_zone" );
  end
end;
private.win_puppetsext_end = function()
  if cmn.IsEventDone("win_puppetsext") then
    ObjSet( "gfx_puppettheatreext_skullext1", {visible = 1} );
    ObjSet("anm_puppettheatreext_back",{animfunc="skull",frame=999})
    ObjDelete("spr_puppettheatreext_mmg_root")
    ObjSet( "spr_squareext_open_zz_puppettheatre2", {alp = 1} );
    if common_impl.ZzCompleteCheck("win_puppetsext") then ObjSet( common_impl.hint["win_puppetsext"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_puppetsext", private.win_puppetsext_beg, private.room_objname );
cmn.AddSubscriber( "win_puppetsext", private.win_puppetsext_end, private.room_objname );
cmn.AddSubscriber( "win_puppetsext", private.win_puppetsext_logic );
cmn.AddSubscriber( "win_puppetsext_beg", private.win_puppetsext_beg, private.room_objname );
cmn.AddSubscriber( "win_puppetsext_end", private.win_puppetsext_end, private.room_objname );
cmn.AddSubscriber( "win_puppetsext_end", private.win_puppetsext_logic );
--------------------------------------------------------------------------------------------
function public.win_puppetsext()

  local func_end = function()
    cmn.SetEventDone( "win_puppetsext" );
    cmn.CallEventHandler( "win_puppetsext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_puppetsext") then ld.CloseSubRoom() end;
  end;
  
  local f_step = function ()
    ld.AnimPlay("anm_puppettheatreext_back","skull",func_end)  
  end
  cmn.MiniGameHide( "puppetsext", true );  
  cmn.CallEventHandler( "win_puppetsext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_mg_puppetsext_win" )
  ObjAnimate( "spr_puppettheatreext_mmg_root", 8, 0, 0, f_step, {0,0,1, 0.5,0,0} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.puppetsext_loadstate(skip)
  if not ng_global.progress["ext"]["win_puppetsext"].state then
    ng_global.progress["ext"]["win_puppetsext"].state  = {3,3,3}
  end
  for i=1,3 do
    ObjSet("spr_puppettheatreext_doll_"..i,{pos_y=-240+80*ng_global.progress["ext"]["win_puppetsext"].state[i]})
  end
  if not skip then
    private.puppetsext_check()
  end
end

--private.puppetsext_state_doll = {3,3,3}
private.puppetsext_doll_link = {2,3,1}
function public.puppetsext_mdown(doll,dir)
  SoundSfx( "aud_mg_puppetsext_move" )
 public.puppetsext_animdoll(doll,dir,true)
end

function public.puppetsext_animdoll(doll,dir,mdown)
  ld.Lock(1)
  local s = ng_global.progress["ext"]["win_puppetsext"].state
  local max_count = 3
  local new_pos;
  local cur_pos = s[doll]
  if cur_pos == max_count and dir == 1 then
    new_pos = cur_pos;
  elseif cur_pos == 1 and dir == -1 then
    new_pos = cur_pos
  else
    new_pos = cur_pos + dir;
  end;
  local obj = "spr_puppettheatreext_doll_"..doll
  local s_pos = -240
  local new_pos_y = s_pos+80*new_pos
  ng_global.progress["ext"]["win_puppetsext"].state[doll] = new_pos
  if ObjGet(obj).pos_y ~= new_pos_y then SoundSfx( "aud_mg_puppetsext_move" ) end 
  ObjAnimate( obj, 1, 0, 0, "", {0,0,ObjGet(obj).pos_y, 0.5,0,new_pos_y} );
  if mdown then
    local d =-1*dir
    public.puppetsext_animdoll(private.puppetsext_doll_link[doll],d,false)
  end
  if mdown then
    ld.StartTimer( 0.55,function()ld.Lock(0);private.puppetsext_check() end )
  end
end


function private.puppetsext_check()
  ld.Lock(1)
  local s = ng_global.progress["ext"]["win_puppetsext"].state
  local obj = "spr_puppettheatreext_light_"
  local count = 0 
  if s[1]==3 then
    if ObjGet(obj.."1").alp ~= 1 then SoundSfx( "aud_mg_puppetsext_light" ) end
    ObjAnimate( obj.."1", 8, 0, 0, "", {0,0,ObjGet(obj.."1").alp, 0.2,0,1} );
    count = count +1
  else 
    ObjAnimate( obj.."1", 8, 0, 0, "", {0,0,ObjGet(obj.."1").alp, 0.2,0,0} );
  end
  if s[2]==2 then
    if ObjGet(obj.."2").alp ~= 1 then SoundSfx( "aud_mg_puppetsext_light" ) end
    ObjAnimate( obj.."2", 8, 0, 0, "", {0,0,ObjGet(obj.."2").alp, 0.2,0,1} );    
    count = count +1
  else 
    ObjAnimate( obj.."2", 8, 0, 0, "", {0,0,ObjGet(obj.."2").alp, 0.2,0,0} );    
  end
  if  s[3]==1 then
    if ObjGet(obj.."3").alp ~= 1 then SoundSfx( "aud_mg_puppetsext_light" ) end    
    ObjAnimate( obj.."3", 8, 0, 0, "", {0,0,ObjGet(obj.."3").alp, 0.2,0,1} );    
    count = count +1
  else 
    ObjAnimate( obj.."3", 8, 0, 0, "", {0,0,ObjGet(obj.."3").alp, 0.2,0,0} );    
  end
  if count == 3 then 
    ld.StartTimer( 0.3,function()ld.Lock(0);public.win_puppetsext() end )
  else
    ld.StartTimer( 0.3, function()ld.Lock(0);end )  
  end
end

function public.puppetsext_menter(obj)
  ld.ShCur(CURSOR_HAND)
  --local obj_focus = obj.."_focus" 
  --ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,1} );
end
function public.puppetsext_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  --local obj_focus = obj.."_focus" 
  --ObjAnimate( obj_focus, 8, 0, 0, "", {0,0,ObjGet(obj_focus).alp, 0.2,0,0} );  
end

function private.win_puppetsext_skip()
  ng_global.progress["ext"]["win_puppetsext"].state  = {3,2,1}
  ld.Lock(1)
  for i=1,3 do 
    local obj = "spr_puppettheatreext_doll_"..i
    local new_pos_y = -240+80*ng_global.progress["ext"]["win_puppetsext"].state[i]
    ObjAnimate( obj, 1, 0, 0, "", {0,0,ObjGet(obj).pos_y, 0.5,0,new_pos_y} ); 
  end
  ld.StartTimer( 0.6, function()ld.Lock(0);private.puppetsext_check()end )
end
function private.win_puppetsext_reset()
  ng_global.progress["ext"]["win_puppetsext"].state  = {3,3,3}
  ld.Lock(1)
  for i=1,3 do 
    local obj = "spr_puppettheatreext_doll_"..i
    local new_pos_y = -240+80*ng_global.progress["ext"]["win_puppetsext"].state[i]
    ObjAnimate( obj, 1, 0, 0, "", {0,0,ObjGet(obj).pos_y, 0.5,0,new_pos_y} ); 
  end
  ld.StartTimer( 0.6, function()ld.Lock(0);private.puppetsext_check()end )  
end
--------------------------------------------------------------------
common_impl.hint[ "get_skullext1" ] = { type = "get", get_obj = "spr_puppettheatreext_skullext1", room = "rm_squareext", zz = "zz_puppettheatreext", zz_gate = "gzz_squareext_puppettheatreext" };

private.get_skullext1_logic = function()
  
end;
private.get_skullext1_inv = function()
  interface.InventoryItemAdd("inv_skullext1","spr_puppettheatreext_skullext1");
end;
private.get_skullext1_beg = function()
  ObjDelete("gfx_puppettheatreext_skullext1")
end;
private.get_skullext1_end = function()
  ObjSet( "spr_puppettheatreext_skullext1", {visible = 1} );
  ObjSet("anm_puppettheatreext_back",{animfunc="skull_end",frame=0})  
  if common_impl.ZzCompleteCheck("get_skullext1") then ObjSet( common_impl.hint["get_skullext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_skullext1", private.get_skullext1_inv );
cmn.AddSubscriber( "get_skullext1", private.get_skullext1_beg, private.room_objname );
cmn.AddSubscriber( "get_skullext1", private.get_skullext1_end, private.room_objname );
cmn.AddSubscriber( "get_skullext1", private.get_skullext1_logic );
--------------------------------------------------------------------
function public.get_skullext1()
  cmn.SetEventDone( "get_skullext1" );
  cmn.CallEventHandler( "get_skullext1" );
  if common_impl.ZzCompleteCheck("get_skullext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_backstageext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_springext" ] = { type = "get", get_obj = "spr_backstageext_springext", room = "rm_squareext", zz = "zz_backstageext", zz_gate = "gzz_squareext_backstageext" };

private.get_springext_logic = function()
 ObjSet("gfx_backstageext_hamsaext_zone", { visible = 1, input = 1, active = 1 } )  
end;
private.get_springext_inv = function()
  interface.InventoryItemAdd("inv_springext","spr_backstageext_springext");
end;
private.get_springext_beg = function()
  ObjDelete("gfx_backstageext_springext")
end;
private.get_springext_end = function()
  ObjDelete("spr_backstageext_springext_shadow")
  if common_impl.ZzCompleteCheck("get_springext") then ObjSet( common_impl.hint["get_springext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_springext", private.get_springext_inv );
cmn.AddSubscriber( "get_springext", private.get_springext_beg, private.room_objname );
cmn.AddSubscriber( "get_springext", private.get_springext_end, private.room_objname );
cmn.AddSubscriber( "get_springext", private.get_springext_logic );
--------------------------------------------------------------------
function public.get_springext()
  cmn.SetEventDone( "get_springext" );
  cmn.CallEventHandler( "get_springext" );
  if common_impl.ZzCompleteCheck("get_springext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hamsaext" ] = { type = "use", inv_obj = "inv_hamsaext", use_place = "gfx_backstageext_hamsaext_zone", room = "rm_squareext", zz = "zz_backstageext", zz_gate = "gzz_squareext_backstageext" };

private.use_hamsaext_logic = function()
  ObjSet("gho_squareext_theatreext", { visible = 1, input = 1, active = 1 } )
end;
private.use_hamsaext_inv = function()
  common_impl.ProcessMultiUseAll("hamsaext", "hamsaext")
end;
private.use_hamsaext_beg = function()
  ObjDelete( "gfx_backstageext_hamsaext_zone" );
end;
private.use_hamsaext_end = function()
  ObjSet( "spr_squareext_open_ho", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_hamsaext") then ObjSet( common_impl.hint["use_hamsaext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hamsaext", private.use_hamsaext_inv );
cmn.AddSubscriber( "use_hamsaext", private.use_hamsaext_beg, private.room_objname );
cmn.AddSubscriber( "use_hamsaext", private.use_hamsaext_end, private.room_objname );
cmn.AddSubscriber( "use_hamsaext", private.use_hamsaext_logic );
cmn.AddSubscriber( "use_hamsaext_inv", private.use_hamsaext_inv, private.room_objname );
cmn.AddSubscriber( "use_hamsaext_beg", private.use_hamsaext_beg, private.room_objname );
cmn.AddSubscriber( "use_hamsaext_end", private.use_hamsaext_end, private.room_objname );
cmn.AddSubscriber( "use_hamsaext_end", private.use_hamsaext_logic );
--------------------------------------------------------------------------------------------
function public.use_hamsaext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hamsaext" );
    cmn.CallEventHandler( "use_hamsaext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hamsaext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hamsaext_inv" );
  cmn.CallEventHandler( "use_hamsaext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_backstageext_anm", "door_use_hamsa", func_end );
  SoundSfx( "aud_use_hamsaext_squareext" )


end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_theatreext_for_squareext = function()
    if ld.CheckRequirements( {"win_theatreext"} ) then
      ObjSet( "gho_squareext_theatreext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_theatreext", win_theatreext_for_squareext, private.room_objname )

end

---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_sceneext" ) and not ld.CheckRequirements( { "win_figuresext" } ) then    
    private.win_figuresext_reset();
  elseif ( mg_name == "zz_puppettheatreext" ) and not ld.CheckRequirements( { "win_puppetsext" } ) then    
    private.win_puppetsext_reset();    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_sceneext" ) and not ld.CheckRequirements( { "win_figuresext" } ) then    
    private.win_figuresext_skip()
  elseif ( mg_name == "zz_puppettheatreext" ) and not ld.CheckRequirements( { "win_puppetsext" } ) then    
    private.win_puppetsext_skip()  
  end;
  
end
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  private.opn_squareext();

end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_squareext_env" )
end;
--*********************************************************************************************************************
function public.Close()

end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_backstageext" );
  function zz_backstageext.Open()
  end;
  function zz_backstageext.PreOpen()
  end;
  function zz_backstageext.PreClose()
  end;
  function zz_backstageext.Close()
  end;

  subroom.Define( "zz_puppettheatreext" );
  function zz_puppettheatreext.Open()
     if cmn.IsEventStart("win_puppetsext") and not cmn.IsEventDone("win_puppetsext") then 
       cmn.MiniGameShow( "puppetsext" ); 
     end;    
  end;
  function zz_puppettheatreext.PreOpen()
     if cmn.IsEventStart("win_puppetsext") and not cmn.IsEventDone("win_puppetsext") then 
       private.puppetsext_loadstate()
     end;     
  end;
  function zz_puppettheatreext.PreClose()
  end;
  function zz_puppettheatreext.Close()
  end;

  subroom.Define( "zz_spottingplacesext" );
  function zz_spottingplacesext.Open()
  end;
  function zz_spottingplacesext.PreOpen()
  end;
  function zz_spottingplacesext.PreClose()
  end;
  function zz_spottingplacesext.Close()
  end;

  subroom.Define( "zz_sceneext" );
  function zz_sceneext.Open()
     if cmn.IsEventStart("win_figuresext") and not cmn.IsEventDone("win_figuresext") then 
       cmn.MiniGameShow( "figuresext" ); 
     end;     
  end;
  function zz_sceneext.PreOpen()
     if cmn.IsEventStart("win_figuresext") and not cmn.IsEventDone("win_figuresext") then 
       private.figuresext_loadstate()
     end;       
  end;
  function zz_sceneext.PreClose()
  end;
  function zz_sceneext.Close()
  end;

end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************