-- name=rm_susieroomext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_susieroomext";
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_bedext_text", "spr_bedext_text_big","susieroomext_bed_page_clk")
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_susieroomext()
  if not ( cmn.IsEventDone( "opn_susieroomext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_susieroomext" );
      cmn.CallEventHandler( "opn_susieroomext" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_susieroomext = function() end;
local opn_susieroomext_logic = function() end;
cmn.AddSubscriber( "opn_susieroomext", opn_susieroomext_logic )
cmn.AddSubscriber( "opn_susieroomext", opn_susieroomext, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animspiritext3" ] = { type = "click", use_place = "gfx_susieroomext_clk_animspiritext3_zone", room = "rm_susieroomext" };

private.clk_animspiritext3_logic = function()
  ObjSet( "gzz_susieroomext_bedext", { visible = 1, input = 1, active = 1 } );
  ObjSet( "gzz_susieroomext_dollext", { visible = 1, input = 1, active = 1 } );
  ObjSet( "gzz_susieroomext_commodeext", { visible = 1, input = 1, active = 1 } );  
end;
private.clk_animspiritext3_beg = function()
  ObjDelete( "gfx_susieroomext_clk_animspiritext3_zone" );
end;
private.clk_animspiritext3_end = function()
  ObjDelete("anm_susieroomext_suzi")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animspiritext3", private.clk_animspiritext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext3", private.clk_animspiritext3_end, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext3", private.clk_animspiritext3_logic );
cmn.AddSubscriber( "clk_animspiritext3_beg", private.clk_animspiritext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext3_end", private.clk_animspiritext3_end, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext3_end", private.clk_animspiritext3_logic );
--------------------------------------------------------------------------------------------
function public.clk_animspiritext3()

  local func_end = function()
    cmn.SetEventDone( "clk_animspiritext3" );
    cmn.CallEventHandler( "clk_animspiritext3_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_animspiritext3");
    SoundTheme( "aud_danger_moment1_mus" )
  end;

  cmn.CallEventHandler( "clk_animspiritext3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_susieroomext_suzi", "anim_suzi", func_end );
  SoundSfx( "aud_clk_animspiritext3_susieroomext" )
  SoundVoice("aud_clk_animspiritext3_susieroomext_voc");
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_commodeext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_bowext3" ] = { type = "get", get_obj = "spr_commodeext_bowext3", room = "rm_susieroomext", zz = "zz_commodeext", zz_gate = "gzz_susieroomext_commodeext" };

private.get_bowext3_logic = function()
  
end;
private.get_bowext3_inv = function()
  interface.InventoryItemAdd("inv_bowext","spr_commodeext_bowext3",function() level_inv.ProcessGetBowextAll( "get_bowext3" ) end);
end;
private.get_bowext3_beg = function()
  ObjDelete("gfx_commodeext_bowext3")
end;
private.get_bowext3_end = function()
  ObjDelete("spr_commodeext_bow_sh")
  ObjDelete("spr_susieroomext_bowext3")
  if common_impl.ZzCompleteCheck("get_bowext3") then ObjSet( common_impl.hint["get_bowext3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bowext3", private.get_bowext3_inv );
cmn.AddSubscriber( "get_bowext3", private.get_bowext3_beg, private.room_objname );
cmn.AddSubscriber( "get_bowext3", private.get_bowext3_end, private.room_objname );
cmn.AddSubscriber( "get_bowext3", private.get_bowext3_logic );
--------------------------------------------------------------------
function public.get_bowext3()
  cmn.SetEventDone( "get_bowext3" );
  cmn.CallEventHandler( "get_bowext3" );
  if common_impl.ZzCompleteCheck("get_bowext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_foxfigureext" ] = { type = "get", get_obj = "spr_commodeext_foxfigureext", room = "rm_susieroomext", zz = "zz_commodeext", zz_gate = "gzz_susieroomext_commodeext" };

private.get_foxfigureext_logic = function()
  
end;
private.get_foxfigureext_inv = function()
  interface.InventoryItemAdd("inv_foxfigureext","spr_commodeext_foxfigureext");
end;
private.get_foxfigureext_beg = function()
  ObjDelete("gfx_commodeext_foxfigureext")
end;
private.get_foxfigureext_end = function()
  ObjDelete("spr_commodeext_fox_sh")  
  ObjDelete("spr_susieroomext_foxfigureext")
  if common_impl.ZzCompleteCheck("get_foxfigureext") then ObjSet( common_impl.hint["get_foxfigureext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_foxfigureext", private.get_foxfigureext_inv );
cmn.AddSubscriber( "get_foxfigureext", private.get_foxfigureext_beg, private.room_objname );
cmn.AddSubscriber( "get_foxfigureext", private.get_foxfigureext_end, private.room_objname );
cmn.AddSubscriber( "get_foxfigureext", private.get_foxfigureext_logic );
--------------------------------------------------------------------
function public.get_foxfigureext()
  cmn.SetEventDone( "get_foxfigureext" );
  cmn.CallEventHandler( "get_foxfigureext" );
  if common_impl.ZzCompleteCheck("get_foxfigureext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_commodehandleext" ] = { type = "use", inv_obj = "inv_commodehandleext", use_place = "gfx_commodeext_commodehandleext_zone", room = "rm_susieroomext", zz = "zz_commodeext", zz_gate = "gzz_susieroomext_commodeext" };

private.use_commodehandleext_logic = function()
  ObjSet( "spr_commodeext_lotusext1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_commodeext_spannerext", { visible = 1, input = 1, active = 1 } )
  
end;
private.use_commodehandleext_inv = function()
  common_impl.ProcessMultiUseAll("commodehandleext", "commodehandleext")
end;
private.use_commodehandleext_beg = function()
  ObjDelete( "gfx_commodeext_commodehandleext_zone" );
end;
private.use_commodehandleext_end = function()
  ObjSet("anm_commodeext_use_handle",{animfunc="end_handle",frame=0})
  ObjSet( "spr_commodeext_lotus_sh", {visible = 1} );
  ObjSet( "spr_commodeext_span_sh", {visible = 1} );
  ObjSet( "spr_commodeext_span_sh2", {visible = 1} );
  ObjSet( "spr_susieroomext_cover1", {alp = 1} );
  ObjSet( "gfx_commodeext_spannerext", {active = 1, visible = 1} );
  if common_impl.ZzCompleteCheck("use_commodehandleext") then ObjSet( common_impl.hint["use_commodehandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_commodehandleext", private.use_commodehandleext_inv );
cmn.AddSubscriber( "use_commodehandleext", private.use_commodehandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_commodehandleext", private.use_commodehandleext_end, private.room_objname );
cmn.AddSubscriber( "use_commodehandleext", private.use_commodehandleext_logic );
cmn.AddSubscriber( "use_commodehandleext_inv", private.use_commodehandleext_inv, private.room_objname );
cmn.AddSubscriber( "use_commodehandleext_beg", private.use_commodehandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_commodehandleext_end", private.use_commodehandleext_end, private.room_objname );
cmn.AddSubscriber( "use_commodehandleext_end", private.use_commodehandleext_logic );
--------------------------------------------------------------------------------------------
function public.use_commodehandleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_commodehandleext" );
    cmn.CallEventHandler( "use_commodehandleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_commodehandleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_commodehandleext_inv" );
  cmn.CallEventHandler( "use_commodehandleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_commodeext_use_handle", "use_handle", func_end );
  SoundSfx( "aud_use_commodehandleext_susieroomext" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lotusext1" ] = { type = "get", get_obj = "spr_commodeext_lotusext1", room = "rm_susieroomext", zz = "zz_commodeext", zz_gate = "gzz_susieroomext_commodeext" };

private.get_lotusext1_logic = function()
  
end;
private.get_lotusext1_inv = function()
  interface.InventoryItemAdd("inv_lotusext","spr_commodeext_lotusext1",function() level_inv.ProcessGetLotusextAll( "get_lotusext1" ) end);
end;
private.get_lotusext1_beg = function()
  ObjDelete("gfx_commodeext_lotusext1")
end;
private.get_lotusext1_end = function()
  ObjDelete("spr_commodeext_lotus_sh")
  if common_impl.ZzCompleteCheck("get_lotusext1") then ObjSet( common_impl.hint["get_lotusext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lotusext1", private.get_lotusext1_inv );
cmn.AddSubscriber( "get_lotusext1", private.get_lotusext1_beg, private.room_objname );
cmn.AddSubscriber( "get_lotusext1", private.get_lotusext1_end, private.room_objname );
cmn.AddSubscriber( "get_lotusext1", private.get_lotusext1_logic );
--------------------------------------------------------------------
function public.get_lotusext1()
  cmn.SetEventDone( "get_lotusext1" );
  cmn.CallEventHandler( "get_lotusext1" );
  if common_impl.ZzCompleteCheck("get_lotusext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_spannerext" ] = { type = "get", get_obj = "spr_commodeext_spannerext", room = "rm_susieroomext", zz = "zz_commodeext", zz_gate = "gzz_susieroomext_commodeext" };

private.get_spannerext_logic = function()
  
end;
private.get_spannerext_inv = function()
  interface.InventoryItemAdd("inv_spannerext","spr_commodeext_spannerext");
end;
private.get_spannerext_beg = function()
  ObjDelete("gfx_commodeext_spannerext")
end;
private.get_spannerext_end = function()
  ObjDelete("spr_commodeext_span_sh");
  ObjDelete("spr_commodeext_span_sh2");
  if common_impl.ZzCompleteCheck("get_spannerext") then ObjSet( common_impl.hint["get_spannerext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_spannerext", private.get_spannerext_inv );
cmn.AddSubscriber( "get_spannerext", private.get_spannerext_beg, private.room_objname );
cmn.AddSubscriber( "get_spannerext", private.get_spannerext_end, private.room_objname );
cmn.AddSubscriber( "get_spannerext", private.get_spannerext_logic );
--------------------------------------------------------------------
function public.get_spannerext()
  cmn.SetEventDone( "get_spannerext" );
  cmn.CallEventHandler( "get_spannerext" );
  if common_impl.ZzCompleteCheck("get_spannerext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_maskext" ] = { type = "use", inv_obj = "inv_maskext", use_place = "gfx_commodeext_maskext_zone", room = "rm_susieroomext", zz = "zz_commodeext", zz_gate = "gzz_susieroomext_commodeext" };

private.use_maskext_logic = function()
  ObjSet( "spr_commodeext_scissorsext", { input = 1, active = 1 } )

end;
private.use_maskext_inv = function()
  common_impl.ProcessMultiUseAll("maskext", "maskext")
end;
private.use_maskext_beg = function()
  ObjDelete( "gfx_commodeext_maskext_zone" );
end;
private.use_maskext_end = function()
  ObjSet("anm_commodeext_mask",{animfunc="use_mask",frame=999})
  ObjSet( "gfx_commodeext_scissorsext", {visible = 1} );
  ObjDelete("spr_susieroomext_tr")
  ObjSet( "spr_susieroomext_cover4", {alp = 1} );
  ObjSet( "spr_susieroomext_scissorsext", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_maskext") then ObjSet( common_impl.hint["use_maskext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_maskext", private.use_maskext_inv );
cmn.AddSubscriber( "use_maskext", private.use_maskext_beg, private.room_objname );
cmn.AddSubscriber( "use_maskext", private.use_maskext_end, private.room_objname );
cmn.AddSubscriber( "use_maskext", private.use_maskext_logic );
cmn.AddSubscriber( "use_maskext_inv", private.use_maskext_inv, private.room_objname );
cmn.AddSubscriber( "use_maskext_beg", private.use_maskext_beg, private.room_objname );
cmn.AddSubscriber( "use_maskext_end", private.use_maskext_end, private.room_objname );
cmn.AddSubscriber( "use_maskext_end", private.use_maskext_logic );
--------------------------------------------------------------------------------------------
function public.use_maskext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_maskext" );
    cmn.CallEventHandler( "use_maskext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_maskext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_maskext_inv" );
  cmn.CallEventHandler( "use_maskext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_commodeext_mask", "use_mask", func_end );
  SoundSfx( "aud_use_maskext_susieroomext" )
 

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scissorsext" ] = { type = "get", get_obj = "spr_commodeext_scissorsext", room = "rm_susieroomext", zz = "zz_commodeext", zz_gate = "gzz_susieroomext_commodeext" };

private.get_scissorsext_logic = function()
  
end;
private.get_scissorsext_inv = function()
  interface.InventoryItemAdd("inv_scissorsext","spr_commodeext_scissorsext");
end;
private.get_scissorsext_beg = function()
  ObjDelete("gfx_commodeext_scissorsext")
end;
private.get_scissorsext_end = function()
  ObjSet( "spr_commodeext_scissorsext", {visible = 1} );
  ObjSet("anm_commodeext_mask",{animfunc="end_mask",frame=0})
  ObjDelete("spr_susieroomext_scissorsext")
  if common_impl.ZzCompleteCheck("get_scissorsext") then ObjSet( common_impl.hint["get_scissorsext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_scissorsext", private.get_scissorsext_inv );
cmn.AddSubscriber( "get_scissorsext", private.get_scissorsext_beg, private.room_objname );
cmn.AddSubscriber( "get_scissorsext", private.get_scissorsext_end, private.room_objname );
cmn.AddSubscriber( "get_scissorsext", private.get_scissorsext_logic );
--------------------------------------------------------------------
function public.get_scissorsext()
  cmn.SetEventDone( "get_scissorsext" );
  cmn.CallEventHandler( "get_scissorsext" );
  if common_impl.ZzCompleteCheck("get_scissorsext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_dollext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_commodehandleext" ] = { type = "get", get_obj = "spr_dollext_commodehandleext", room = "rm_susieroomext", zz = "zz_dollext", zz_gate = "gzz_susieroomext_dollext" };

private.get_commodehandleext_logic = function()
  
end;
private.get_commodehandleext_inv = function()
  interface.InventoryItemAdd("inv_commodehandleext","spr_dollext_commodehandleext");
end;
private.get_commodehandleext_beg = function()
  ObjDelete("gfx_dollext_commodehandleext")
end;
private.get_commodehandleext_end = function()
  ObjDelete("spr_dollext_sh_commodehandleext")
  if common_impl.ZzCompleteCheck("get_commodehandleext") then ObjSet( common_impl.hint["get_commodehandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_commodehandleext", private.get_commodehandleext_inv );
cmn.AddSubscriber( "get_commodehandleext", private.get_commodehandleext_beg, private.room_objname );
cmn.AddSubscriber( "get_commodehandleext", private.get_commodehandleext_end, private.room_objname );
cmn.AddSubscriber( "get_commodehandleext", private.get_commodehandleext_logic );
--------------------------------------------------------------------
function public.get_commodehandleext()
  cmn.SetEventDone( "get_commodehandleext" );
  cmn.CallEventHandler( "get_commodehandleext" );
  if common_impl.ZzCompleteCheck("get_commodehandleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_magicwandext" ] = { type = "use", inv_obj = "inv_magicwandext", use_place = "gfx_dollext_magicwandext_zone", room = "rm_susieroomext", zz = "zz_dollext", zz_gate = "gzz_susieroomext_dollext" };

private.use_magicwandext_logic = function()
  ObjSet( "spr_dollext_maskext", {  input = 1, active = 1 } )

end;
private.use_magicwandext_inv = function()
  common_impl.ProcessMultiUseAll("magicwandext", "magicwandext")
end;
private.use_magicwandext_beg = function()
  ObjDelete( "gfx_dollext_magicwandext_zone" );
end;
private.use_magicwandext_end = function()
  ObjSet("anm_dollext_anm_magicwand",{animfunc="use_magicwand",frame=999})
  ObjSet( "gfx_dollext_maskext", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_magicwandext") then ObjSet( common_impl.hint["use_magicwandext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("obj_dollext_page_clk_zone");
  ObjSet( "spr_susieroomext_magicwand", {alp = 1} );
  ObjSet("spr_susieroomext_maskext",{pos_x=864,pos_y=470})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_magicwandext", private.use_magicwandext_inv );
cmn.AddSubscriber( "use_magicwandext", private.use_magicwandext_beg, private.room_objname );
cmn.AddSubscriber( "use_magicwandext", private.use_magicwandext_end, private.room_objname );
cmn.AddSubscriber( "use_magicwandext", private.use_magicwandext_logic );
cmn.AddSubscriber( "use_magicwandext_inv", private.use_magicwandext_inv, private.room_objname );
cmn.AddSubscriber( "use_magicwandext_beg", private.use_magicwandext_beg, private.room_objname );
cmn.AddSubscriber( "use_magicwandext_end", private.use_magicwandext_end, private.room_objname );
cmn.AddSubscriber( "use_magicwandext_end", private.use_magicwandext_logic );
--------------------------------------------------------------------------------------------
function public.use_magicwandext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_magicwandext" );
    cmn.CallEventHandler( "use_magicwandext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_magicwandext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_magicwandext_inv" );
  cmn.CallEventHandler( "use_magicwandext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_dollext_anm_magicwand", "use_magicwand", func_end );
  SoundSfx( "aud_use_magicwandext_susieroomext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_maskext" ] = { type = "get", get_obj = "spr_dollext_maskext", room = "rm_susieroomext", zz = "zz_dollext", zz_gate = "gzz_susieroomext_dollext" };

private.get_maskext_logic = function()
  
end;
private.get_maskext_inv = function()
  interface.InventoryItemAdd("inv_maskext","spr_dollext_maskext");
end;
private.get_maskext_beg = function()
  ObjDelete("gfx_dollext_maskext")
end;
private.get_maskext_end = function()
  ObjSet( "spr_dollext_maskext", {visible = 1} );
  ObjDelete("spr_susieroomext_maskext")
  ObjSet("anm_dollext_anm_magicwand",{animfunc="end_magicwand1",frame=0})  
  if common_impl.ZzCompleteCheck("get_maskext") then ObjSet( common_impl.hint["get_maskext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_maskext", private.get_maskext_inv );
cmn.AddSubscriber( "get_maskext", private.get_maskext_beg, private.room_objname );
cmn.AddSubscriber( "get_maskext", private.get_maskext_end, private.room_objname );
cmn.AddSubscriber( "get_maskext", private.get_maskext_logic );
--------------------------------------------------------------------
function public.get_maskext()
  cmn.SetEventDone( "get_maskext" );
  cmn.CallEventHandler( "get_maskext" );
  if common_impl.ZzCompleteCheck("get_maskext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bedext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_childrenrivetext" ] = { type = "use", inv_obj = "inv_childrenrivetext", use_place = "gfx_bedext_childrenrivetext_zone", room = "rm_susieroomext", zz = "zz_bedext", zz_gate = "gzz_susieroomext_bedext" };

private.use_childrenrivetext_logic = function()
  ObjSet( "spr_bedext_amuletflameext", {  input = 1, active = 1 } )

end;
private.use_childrenrivetext_inv = function()
  common_impl.ProcessMultiUseAll("childrenrivetext", "childrenrivetext")
end;
private.use_childrenrivetext_beg = function()
  ObjDelete( "gfx_bedext_childrenrivetext_zone" );
end;
private.use_childrenrivetext_end = function()
  ObjSet( "gfx_bedext_amuletflameext", {visible = 1} );
  ObjSet("anm_bedext_childrenrivetext",{animfunc="use_onion",frame=999})
  ObjSet( "spr_susieroomext_pocket_open", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_childrenrivetext") then ObjSet( common_impl.hint["use_childrenrivetext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_childrenrivetext", private.use_childrenrivetext_inv );
cmn.AddSubscriber( "use_childrenrivetext", private.use_childrenrivetext_beg, private.room_objname );
cmn.AddSubscriber( "use_childrenrivetext", private.use_childrenrivetext_end, private.room_objname );
cmn.AddSubscriber( "use_childrenrivetext", private.use_childrenrivetext_logic );
cmn.AddSubscriber( "use_childrenrivetext_inv", private.use_childrenrivetext_inv, private.room_objname );
cmn.AddSubscriber( "use_childrenrivetext_beg", private.use_childrenrivetext_beg, private.room_objname );
cmn.AddSubscriber( "use_childrenrivetext_end", private.use_childrenrivetext_end, private.room_objname );
cmn.AddSubscriber( "use_childrenrivetext_end", private.use_childrenrivetext_logic );
--------------------------------------------------------------------------------------------
function public.use_childrenrivetext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_childrenrivetext" );
    cmn.CallEventHandler( "use_childrenrivetext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_childrenrivetext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_childrenrivetext_inv" );
  cmn.CallEventHandler( "use_childrenrivetext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bedext_childrenrivetext", "use_onion", func_end );
  SoundSfx( "aud_use_childrenrivetext_susieroomext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletflameext" ] = { type = "get", get_obj = "spr_bedext_amuletflameext", room = "rm_susieroomext", zz = "zz_bedext", zz_gate = "gzz_susieroomext_bedext" };

private.get_amuletflameext_logic = function()
  
end;
private.get_amuletflameext_inv = function()
  interface.InventoryItemAdd("inv_amuletflameext","spr_bedext_amuletflameext");
end;
private.get_amuletflameext_beg = function()
  ObjSet( "spr_bedext_amuletflameext", {visible = 1} );
  ObjDelete("gfx_bedext_amuletflameext")
end;
private.get_amuletflameext_end = function()
  ObjSet("anm_bedext_childrenrivetext",{animfunc="end_onion",frame=0})  
  if common_impl.ZzCompleteCheck("get_amuletflameext") then ObjSet( common_impl.hint["get_amuletflameext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletflameext", private.get_amuletflameext_inv );
cmn.AddSubscriber( "get_amuletflameext", private.get_amuletflameext_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletflameext", private.get_amuletflameext_end, private.room_objname );
cmn.AddSubscriber( "get_amuletflameext", private.get_amuletflameext_logic );
--------------------------------------------------------------------
function public.get_amuletflameext()
  cmn.SetEventDone( "get_amuletflameext" );
  cmn.CallEventHandler( "get_amuletflameext" );
  if common_impl.ZzCompleteCheck("get_amuletflameext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scissorsext" ] = { type = "use", inv_obj = "inv_scissorsext", use_place = "gfx_bedext_scissorsext_zone", room = "rm_susieroomext", zz = "zz_bedext", zz_gate = "gzz_susieroomext_bedext" };

private.use_scissorsext_logic = function()
  ObjSet( "spr_bedext_lotusext3", { visible = 1, input = 1, active = 1 } )

end;
private.use_scissorsext_inv = function()
  common_impl.ProcessMultiUseAll("scissorsext", "scissorsext")
end;
private.use_scissorsext_beg = function()
  ObjDelete( "gfx_bedext_scissorsext_zone" );
end;
private.use_scissorsext_end = function()
  
  ObjSet( "anm_bedext_scissorsext", {animfunc="end_scissors",frame=0} );
  if common_impl.ZzCompleteCheck("use_scissorsext") then ObjSet( common_impl.hint["use_scissorsext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissorsext", private.use_scissorsext_inv );
cmn.AddSubscriber( "use_scissorsext", private.use_scissorsext_beg, private.room_objname );
cmn.AddSubscriber( "use_scissorsext", private.use_scissorsext_end, private.room_objname );
cmn.AddSubscriber( "use_scissorsext", private.use_scissorsext_logic );
cmn.AddSubscriber( "use_scissorsext_inv", private.use_scissorsext_inv, private.room_objname );
cmn.AddSubscriber( "use_scissorsext_beg", private.use_scissorsext_beg, private.room_objname );
cmn.AddSubscriber( "use_scissorsext_end", private.use_scissorsext_end, private.room_objname );
cmn.AddSubscriber( "use_scissorsext_end", private.use_scissorsext_logic );
--------------------------------------------------------------------------------------------
function public.use_scissorsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scissorsext" );
    cmn.CallEventHandler( "use_scissorsext_end" );
    common_impl.Lock(0);
    public.get_lotusext3()
    if common_impl.ZzCompleteCheck("use_scissorsext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissorsext_inv" );
  cmn.CallEventHandler( "use_scissorsext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bedext_scissorsext", "use_scissors", func_end );
  SoundSfx( "aud_use_scissorsext_susieroomext" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lotusext3" ] = { type = "get", get_obj = "spr_bedext_lotusext3", room = "rm_susieroomext", zz = "zz_bedext", zz_gate = "gzz_susieroomext_bedext" };

private.get_lotusext3_logic = function()
  
end;
private.get_lotusext3_inv = function()
  interface.InventoryItemAdd("inv_lotusext","spr_bedext_lotusext3",function() level_inv.ProcessGetLotusextAll( "get_lotusext3" ) end);
end;
private.get_lotusext3_beg = function()
  ObjDelete("gfx_bedext_lotusext3")
end;
private.get_lotusext3_end = function()
  ObjDelete("spr_susieroomext_lotusext3")
  if common_impl.ZzCompleteCheck("get_lotusext3") then ObjSet( common_impl.hint["get_lotusext3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lotusext3", private.get_lotusext3_inv );
cmn.AddSubscriber( "get_lotusext3", private.get_lotusext3_beg, private.room_objname );
cmn.AddSubscriber( "get_lotusext3", private.get_lotusext3_end, private.room_objname );
cmn.AddSubscriber( "get_lotusext3", private.get_lotusext3_logic );
--------------------------------------------------------------------
function public.get_lotusext3()
  cmn.SetEventDone( "get_lotusext3" );
  cmn.CallEventHandler( "get_lotusext3" );
  if common_impl.ZzCompleteCheck("get_lotusext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_susieroomext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_susieroomext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_bedext" );
  function zz_bedext.Open()
  end;
  function zz_bedext.PreOpen()
  end;
  function zz_bedext.PreClose()
  end;
  function zz_bedext.Close()
  end;

  subroom.Define( "zz_dollext" );
  function zz_dollext.Open()
  end;
  function zz_dollext.PreOpen()
  end;
  function zz_dollext.PreClose()
  end;
  function zz_dollext.Close()
  end;

  subroom.Define( "zz_commodeext" );
  function zz_commodeext.Open()
  end;
  function zz_commodeext.PreOpen()
  end;
  function zz_commodeext.PreClose()
  end;
  function zz_commodeext.Close()
  end;
  
end;
--*********************************************************************************************************************