-- name=ho_nightmareshoextscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "nightmareshoextscr" );
  game.relations[ "ho_nightmareshoextscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_nightmareshoextscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_nightmareshoextscr", zz_gate = "gho_abyssext_nightmareshoextscr" };
 
  local win_nightmareshoextscr_func = function ()

    if ( cmn.IsEventDone( "win_nightmareshoextscr" ) ) then
      ObjDetach( "spr_nightmareshoextscr_win" );

    end;

  end;
  cmn.AddSubscriber( "win_nightmareshoextscr", win_nightmareshoextscr_func );

  local unmark_morph= function () 
    ObjSet("spr_nightmareshoextscr_ggg",{input=1})
    --ObjSet("spr_nightmareshoextscr_hhh",{input=1})
    ObjSet("spr_nightmareshoextscr_hhh_part_1",{input=1})
    ObjSet("gfx_nightmareshoextscr_hhh_part_2",{input=1})    
    --ObjSet("spr_nightmareshoextscr_iii",{input=1})
    ObjSet( "gfx_nightmareshoextscr_unmark_iii_zone", {active=1,input = 1, visible = 1} );
    ObjSet("spr_nightmareshoextscr_jjj",{input=1})
    --ObjSet("spr_nightmareshoextscr_kkk",{input=1})
    ObjSet("spr_nightmareshoextscr_kkk_part_1",{active=1,input=1, visible = 1})
    ObjSet("gfx_nightmareshoextscr_kkk_part_2",{active=1,input=1, visible = 1})
    
    ObjSet("spr_nightmareshoextscr_lll",{input=1})
  end;
  cmn.AddSubscriber( "nightmareshoextscr_unmark_morph", unmark_morph, "ho_nightmareshoextscr" ); 
  
  local unmark_kkk = function () 
    ObjSet( "spr_nightmareshoextscr_kkk", {input = 1,alp=1} );
    ObjDelete("spr_nightmareshoextscr_kkk_part_1")    
    ObjDelete("gfx_nightmareshoextscr_kkk_part_2")
    ObjSet("anm_nightmareshoextscr_unmark_kkk",{animfunc="end_amulet",frame=0})
    ObjSet( "spr_nightmareshoextscr_back_3tr", {visible=1} );
  end;
  cmn.AddSubscriber( "nightmareshoextscr_unmark_kkk", unmark_kkk, "ho_nightmareshoextscr" ); 
 
  local unmark_iii = function () 
    ObjSet( "spr_nightmareshoextscr_iii", {input = 1,alp=1} );
    ObjDelete("gfx_nightmareshoextscr_unmark_iii_zone")
    ObjSet("anm_nightmareshoextscr_unmark_iii",{animfunc="click_sheet",frame=999})
  end;
  cmn.AddSubscriber( "nightmareshoextscr_unmark_iii", unmark_iii, "ho_nightmareshoextscr" ); 
 
  local unmark_hhh = function () 
    ObjSet( "spr_nightmareshoextscr_hhh", {input = 1,alp=1} );
    ObjDelete("spr_nightmareshoextscr_hhh_part_1")    
    ObjDelete("gfx_nightmareshoextscr_hhh_part_2")
    ObjDelete("anm_nightmareshoextscr_unmark_hhh")
    ObjSet( "spr_nightmareshoextscr_bottle_2tr", {visible=1} );    
    ObjSet( "spr_nightmareshoextscr_bottle_3tr", {visible=1} );    
  end;
  cmn.AddSubscriber( "nightmareshoextscr_unmark_hhh", unmark_hhh, "ho_nightmareshoextscr" ); 
   
  
  local start_nightmareshoextscr_func = function ()
      common_impl.ProcessHoStart( "nightmareshoextscr" );  
  if not cmn.IsEventDone("win_nightmareshoextscr") then
    if ng_global.progress["scr"]["win_nightmareshoextscr"].state then
      unmark_morph()
    end
    if cmn.IsUnmarkedTask("nightmareshoextscr","kkk") then 
      unmark_kkk()
    end  
    if cmn.IsUnmarkedTask("nightmareshoextscr","iii") then 
      unmark_iii()
    end 
    if cmn.IsUnmarkedTask("nightmareshoextscr","hhh") then 
      unmark_hhh()
    end     
  end
  end;
  cmn.AddSubscriber( "win_nightmareshoextscr", start_nightmareshoextscr_func, "ho_nightmareshoextscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_ho_nightmareshoext_env" )

  if ( not cmn.IsEventDone( "opn_nightmareshoextscr" ) ) then

    cmn.InitHo( "nightmareshoextscr" );

    cmn.SetEventDone( "opn_nightmareshoextscr" );
    ng_global.progress["scr"]["win_nightmareshoextscr"].state = false
    cmn.SetMarkedTask( "nightmareshoextscr", "kkk" );
    cmn.SetMarkedTask( "nightmareshoextscr", "iii" );    
    cmn.SetMarkedTask( "nightmareshoextscr", "hhh" );       
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_nightmareshoextscr_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_nightmareshoextscr_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_nightmareshoextscr_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_nightmareshoextscr_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_nightmareshoextscr_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_nightmareshoextscr_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_nightmareshoextscr_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_nightmareshoextscr_hhh","spr_nightmareshoextscr_hhh_part_1","gfx_nightmareshoextscr_hhh_part_2"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_nightmareshoextscr_iii","gfx_nightmareshoextscr_unmark_iii_zone"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_nightmareshoextscr_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_nightmareshoextscr_kkk","spr_nightmareshoextscr_kkk_part_1","gfx_nightmareshoextscr_kkk_part_2"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_nightmareshoextscr_lll"}); 
  ObjAttach("spr_nightmareshoextscr_panel","int_itempanel_impl")
  ObjSet("spr_nightmareshoextscr_panel",{pos_x=0,pos_y=0})  
  
  SoundHoTheme( true );
  interface.ItemPanelShow( ho_items );
  if ng_global.progress["scr"]["win_nightmareshoextscr"].found then
    ObjSet("txt_nightmareshoextscr_panel",{param0=6-#ng_global.progress["scr"]["win_nightmareshoextscr"].found})
    if #ng_global.progress["scr"]["win_nightmareshoextscr"].found>=6 then
      ObjDetach("spr_nightmareshoextscr_panel")
    end
  end
  for j = 1, #ng_global.progress["scr"]["win_nightmareshoextscr"].found do

    local task =  ld.StringDivide(ng_global.progress["scr"]["win_nightmareshoextscr"].found[j]["item"])[3]
   
    ObjDelete( "anm_nightmareshoextscr_morph_"..task );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.ItemPanelHide();
  ObjDetach( "spr_nightmareshoextscr_win" );
  
end;

function public.Close()

end

--*********************************************************************************************************************
function public.HoComplete()
  
  common_impl.DialogHo_Show();
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  -- ld.LogTrace( item_name );
  
  local task =  ld.StringDivide(item_name)[3]
  ObjAnimate( "anm_nightmareshoextscr_morph_"..task, 8, 0, 0, "", {0,0,1, 0.1,0,0} );
  
  local sum = 6 - #ng_global.progress["scr"]["win_nightmareshoextscr"].found
   
  ObjSet("txt_nightmareshoextscr_panel",{param0=sum})
  if sum == 0 then
    ld.Lock(1)
    ng_global.progress["scr"]["win_nightmareshoextscr"].state = true
    ObjAnimate( "spr_nightmareshoextscr_panel", 1, 0, 0, function()ld.Lock(0);cmn.CallEventHandler("nightmareshoextscr_unmark_morph");end, {0,0,0, 0.5,0,133} );
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_nightmareshoextscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_nightmareshoextscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.clk_monkey()
  local f_end = function()
    ld.Lock(0)
    ObjSet("anm_nightmareshoextscr_monkey",{playing=1,animfunc="static_monkey"})
  end
  ld.Lock(1)
  SoundSfx( "aud_ho_nightmareshoext_monkey" )
  ld.AnimPlay("anm_nightmareshoextscr_monkey","idle_click_monkey",f_end)
end
----------------------------------------------------------------------------

function public.unmark_kkk()
  if ApplyObj("spr_nightmareshoextscr_kkk_part_1","gfx_nightmareshoextscr_kkk_part_2") then   
    local func_end = function()
      ld.Lock(0)
      ng_global.progress["scr"]["win_nightmareshoextscr"].start = 1;
      ng_global.progress["scr"]["win_nightmareshoextscr"].unmark["kkk"].done = 1;
      cmn.CallEventHandler("nightmareshoextscr_unmark_kkk");
    end  
    ld.Lock(1)
    ObjDelete("spr_nightmareshoextscr_kkk_part_1")
    ObjDelete("gfx_nightmareshoextscr_kkk_part_2")
    SoundSfx( "aud_ho_nightmareshoext_coffee" )       
    ld.AnimPlay("anm_nightmareshoextscr_unmark_kkk","use_amulet",func_end)
  else 
    ObjSet("spr_nightmareshoextscr_kkk_part_1",{pos_z = 0})
    ObjSet( "spr_nightmareshoextscr_amulet_tr", {alp = 1} );
  end
end

----------------------------------------------------------------------------

function public.unmark_hhh()
  if ApplyObj("spr_nightmareshoextscr_hhh_part_1","gfx_nightmareshoextscr_hhh_part_2") then   
    local func_end = function()
      ld.Lock(0)
      ng_global.progress["scr"]["win_nightmareshoextscr"].start = 1;
      ng_global.progress["scr"]["win_nightmareshoextscr"].unmark["hhh"].done = 1;
      cmn.CallEventHandler("nightmareshoextscr_unmark_hhh");
    end  
    ld.Lock(1)
    ObjDelete("spr_nightmareshoextscr_hhh_part_1")
    ObjDelete("gfx_nightmareshoextscr_hhh_part_2")
    SoundSfx( "aud_ho_nightmareshoext_stone" )          
    ld.AnimPlay("anm_nightmareshoextscr_unmark_hhh","use_stone",func_end)
  else 
    ObjSet("spr_nightmareshoextscr_hhh_part_1",{pos_z = 0})
  end
end


function public.unmark_iii() 
   local func_end = function()
    ld.Lock(0)
    ng_global.progress["scr"]["win_nightmareshoextscr"].unmark["iii"].done = 1;
    cmn.CallEventHandler( "nightmareshoextscr_unmark_iii" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_nightmareshoextscr_unmark_iii_zone")
  SoundSfx( "aud_ho_nightmareshoext_leaf" ) 
  ld.AnimPlay("anm_nightmareshoextscr_unmark_iii","click_sheet",func_end) 
end