-- name=ho_winestorescr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "winestorescr" );
  game.relations[ "ho_winestorescr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_winestorescr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_winestorescr", zz_gate = "gho_cellar_winestorescr" };
 
  local win_winestorescr_func = function ()

    if ( cmn.IsEventDone( "win_winestorescr" ) ) then
      ObjDetach( "spr_winestorescr_win" );
    end;

  end;
  cmn.AddSubscriber( "win_winestorescr", win_winestorescr_func );
  
  local start_winestorescr_func = function ()
  if not cmn.IsEventDone("win_winestorescr") then
  common_impl.ProcessHoStart( "winestorescr" );

      local ho_found = ng_global.progress[ "scr" ][ "win_winestorescr" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;  
  end
  end;
  cmn.AddSubscriber( "win_winestorescr", start_winestorescr_func, "ho_winestorescr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_cellar_env" )

  if ( not cmn.IsEventDone( "opn_winestorescr" ) ) then

    cmn.InitHo( "winestorescr" );

    cmn.SetEventDone( "opn_winestorescr" );
   
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_winestorescr_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_winestorescr_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_winestorescr_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_winestorescr_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_winestorescr_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_winestorescr_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_winestorescr_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_winestorescr_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_winestorescr_iii"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_winestorescr_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_winestorescr_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_winestorescr_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.PreClose()
  
  SoundHoTheme( false );
  interface.ItemPanelHide();

end;
function public.Close()
  ObjDetach( "spr_winestorescr_win" );
end
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
  common_impl.DialogHo_Show();
  ObjDelete("grm_winestorescr_cellar");  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_winestorescr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_winestorescr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------