-- name=mg_heartsextscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_heartsextscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_heartsextscr" ] = {type = "win", use_place = "mg_heartsextscr", room = "rm_secretroomscr", zz = "mg_heartsextscr", zz_gate = "gmg_secretroomscr_heartsextscr" };

  local win_heartsextscr_logic = function()
    if ld.CheckRequirements( {"win_heartsextscr"} ) then
      
    end
  end;
  local win_heartsextscr = function()
    if ld.CheckRequirements( {"win_heartsextscr"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_heartsextscr", win_heartsextscr, private.room_objname )
  cmn.AddSubscriber("win_heartsextscr", win_heartsextscr_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
 local first_heart_pos = {327,189};
 local hearts_step={124,162};

 private.mg_heartsextscr_first_init_flag = false;
 function private.mg_heartsextscr_first_init()
   if private.mg_heartsextscr_first_init_flag == false then 
     -- create hor parts 
     for i=1,4,1 do 
       ObjCreate("spr_heartsextscr_hor_"..i,"spr")
       ObjSet( "spr_heartsextscr_hor_"..i, {res = "assets/levels/levelext/mg_heartsext/a1", input=1, drag=1, event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_startdrag = "mg_heartsextscr.heartsextscr_part_start_drag(1,"..i..");", event_dragdrop="mg_heartsextscr.heartsextscr_part_drop(1,"..i..");", 
       inputrect_init=1, inputrect_w = 120, inputrect_h = 26, inputrect_x = -60, inputrect_y=-13} );
       ObjAttach("spr_heartsextscr_hor_"..i, "obj_heartsextscr_mg_root");
       
       -- drag zone 
       ObjCreate("obj_heartsextscr_hor_drag_zone_"..i,"obj");
       ObjSet( "obj_heartsextscr_hor_drag_zone_"..i, {input=0, inputrect_init=1, inputrect_w=30, inputrect_h=30, inputrect_x=-15, inputrect_y=-15} );
       ObjAttach("obj_heartsextscr_hor_drag_zone_"..i, "spr_heartsextscr_hor_"..i);
     end;  
     -- create ver parts 
     for i=1,6,1 do 
       ObjCreate("spr_heartsextscr_ver_"..i,"spr")
       ObjSet( "spr_heartsextscr_ver_"..i, {res = "assets/levels/levelext/mg_heartsext/a2", input=1, drag=1, event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_startdrag = "mg_heartsextscr.heartsextscr_part_start_drag(2,"..i..")", event_dragdrop="mg_heartsextscr.heartsextscr_part_drop(2,"..i..");", 
       inputrect_init=1, inputrect_w = 26, inputrect_h = 160, inputrect_x = -13, inputrect_y=-80} );
       ObjAttach("spr_heartsextscr_ver_"..i, "obj_heartsextscr_mg_root");
       
        -- drag zone 
       ObjCreate("obj_heartsextscr_ver_drag_zone_"..i,"obj");
       ObjSet( "obj_heartsextscr_ver_drag_zone_"..i, {input=0, inputrect_init=1, inputrect_w=30, inputrect_h=30, inputrect_x=-15, inputrect_y=-15} );
       ObjAttach("obj_heartsextscr_ver_drag_zone_"..i, "spr_heartsextscr_ver_"..i);
     end; 
     
     -- create hearts field 
     for i=1,3,1 do 
       for j=1,4,1 do 
         ObjCreate("obj_heartsextscr_heart_"..i.."_"..j,"obj");
         ObjAttach("obj_heartsextscr_heart_"..i.."_"..j,"obj_heartsextscr_heart_root");
         ObjSet( "obj_heartsextscr_heart_"..i.."_"..j, {pos_x = first_heart_pos[1]+hearts_step[1]*(j-1), pos_y = first_heart_pos[2]+hearts_step[2]*(i-1), input=0, inputrect_init=1, inputrect_w=124, inputrect_h=160, inputrect_x=-62, inputrect_y=-80} );
         -- create hearts lights
         ObjCreate("spr_hearts_heart_"..i.."_"..j.."_light","spr");
         ObjAttach("spr_hearts_heart_"..i.."_"..j.."_light","obj_heartsextscr_heart_"..i.."_"..j);
         ObjSet( "spr_hearts_heart_"..i.."_"..j.."_light", {res="assets/levels/levelext/mg_heartsext/lig"..private.heartsextscr_field_count_array[i][j], alp=0, input=0} );
       end;  
     end; 
    
    -- for i=1,12,1 do 
    --   ObjSet( "obj_heartsextscr_hor_"..i, {input = 0} );
    -- end;  
    -- 
    -- for i=1,15,1 do 
    --   ObjSet( "obj_heartsextscr_ver_"..i, {input = 0} );
    -- end;  
   end;  
   
    private.mg_heartsextscr_first_init_flag = true;
 end;  

end;
--------------------- group search ----------------------------------
private.heartsextscr_group={{{},{},{},{}},{{},{},{},{}},{{},{},{},{}}};
private.heartsextscr_select_group_array={};
private.heartsextscr_group_count = {};
----------------------------------------------------------
function private.heartsextscr_show_hearts_light()
  local win_flag=1;
  private.heartsextscr_sound_light = false
  for i=1,#private.heartsextscr_select_group_array,1 do 
    if private.heartsextscr_group_count[i]==3 then 
      for ii=1,#private.heartsextscr_select_group_array[i],1 do 
        if not private.heartsextscr_sound_light then
          private.heartsextscr_sound_light = true
          SoundSfx( "aud_mg_heartsext_light_part" );
          --ld.LogTrace( "light" );  
        end  
        
        ObjSet( "spr_hearts_heart_"..private.heartsextscr_select_group_array[i][ii][1].."_"..private.heartsextscr_select_group_array[i][ii][2].."_light", {alp=1} );
      end; 
    else
      win_flag=0;
      for ii=1,#private.heartsextscr_select_group_array[i],1 do 
        ObjSet( "spr_hearts_heart_"..private.heartsextscr_select_group_array[i][ii][1].."_"..private.heartsextscr_select_group_array[i][ii][2].."_light", {alp=0} );
      end; 
    end;  
  end; 
  
  if win_flag==1 then private.Win(); else  ld.Lock(0);  end;
  
 --local mytext="";
 --for i=1,#ng_global.progress["scr"]["win_heartsextscr"].state,1 do 
 --  mytext=mytext.."{"
 --  for j=1,#ng_global.progress["scr"]["win_heartsextscr"].state[i],1 do 
 --    mytext=mytext..ng_global.progress["scr"]["win_heartsextscr"].state[i][j]..","
 --  end; 
 --  mytext=mytext.."}," 
 --end;  
 --ld.LogTrace( mytext );
end;  


function private.heartsextscr_get_group_count()
  private.heartsextscr_group_count = {};
  local count=0;
  for i=1,#private.heartsextscr_select_group_array,1 do 
    count=0;
    for n=1,#private.heartsextscr_select_group_array[i],1 do 
      count=count+private.heartsextscr_field_count_array[private.heartsextscr_select_group_array[i][n][1] ][private.heartsextscr_select_group_array[i][n][2] ];
    end;  
    private.heartsextscr_group_count[#private.heartsextscr_group_count+1]=count;
  end;  
  
  private.heartsextscr_show_hearts_light();
  
 -- ld.LogTrace( "COUNTS" );
 -- for i=1,#private.heartsextscr_group_count,1 do 
 --   ld.LogTrace( "group ["..i.."] count = "..private.heartsextscr_group_count[i] );
 -- end;  
end;
----------------------------------------------------------
function private.heartsextscr_select_array()
  private.heartsextscr_select_group_array={};
--  private.heartsextscr_select_group_array[1]=ld.TableCopy(private.heartsextscr_group[1][1]);
  local flag=0;
  for i=1,3,1 do 
    for j=1,4,1 do
      flag=0;
     -- if not(i==1 and j==1) then
         for n=1,#private.heartsextscr_group[i][j],1 do 
           --- search on select array 
             for nn=1,#private.heartsextscr_select_group_array,1 do 
               for nnn=1,#private.heartsextscr_select_group_array[nn],1 do 
                 if private.heartsextscr_group[i][j][n][1]==private.heartsextscr_select_group_array[nn][nnn][1] and private.heartsextscr_group[i][j][n][2]==private.heartsextscr_select_group_array[nn][nnn][2] then 
                   flag=1; -- izvrasheniya =)
                 end;  
               end;  
             end;  
           ----------------------------
         end;  
         -- end
      
      if flag==0 then private.heartsextscr_select_group_array[#private.heartsextscr_select_group_array+1] = ld.TableCopy(private.heartsextscr_group[i][j]); end;
    end;  
  end; 
 
  -- private.heartsextscr_show_select_group(); 
  private.heartsextscr_get_group_count();
end;  
--------------------------------------------------------------------------
function private.heartsextscr_show_select_group()
  -- ld.LogTrace( "SELECT GROUP" );
  
  local mytext = "";
  for i=1,#private.heartsextscr_select_group_array,1 do 
     mytext = "select group ["..i.."]= ";
      for ii=1,#private.heartsextscr_select_group_array[i],1 do 
        mytext = mytext.."{"..private.heartsextscr_select_group_array[i][ii][1]..","..private.heartsextscr_select_group_array[i][ii][2].."},"
      end;  
      --  ld.LogTrace( mytext );
  end;  
end;  
--------------------------------------------------------------------------------
private.heartsextscr_seaching_flag = false;
private.heartsextscr_all_searching_flag = false;

function private.heartsextscr_group_search()
  private.heartsextscr_group={{{},{},{},{}},{{},{},{},{}},{{},{},{},{}}};
  private.heartsextscr_seaching_flag = true;
  private.heartsextscr_all_searching_flag = false;

  for i=1,3,1 do 
    for j=1,4,1 do 
      if i==3 and j==4 then private.heartsextscr_all_searching_flag  = true; end;
      private.heartsextscr_group[i][j][1]={i,j};
      private.heartsextscr_seach_blyat(i,j,i,j);
    end;  
  end;  
  private.heartsextscr_all_searching_flag  = true;
 -- ld.StartTimer( 0.1, function()
 --  -- private.heartsextscr_show_group(); 
 --   private.heartsextscr_select_array(); end )
end;  

function private.heartsextscr_search_heart_on_group_array(i,j,fi,fj)
  for i1=1,#private.heartsextscr_group[fi][fj],1 do 
    if private.heartsextscr_group[fi][fj][i1][1]==i and private.heartsextscr_group[fi][fj][i1][2]==j then return true; end;
  end;  
  return false;
end;  


private.heartsextscr_seach_blyat_count=0;
function private.heartsextscr_seach_blyat(i,j,fi,fj) -- fi,fj start pos
  private.heartsextscr_seach_blyat_count=private.heartsextscr_seach_blyat_count+1;
  -- ld.LogTrace( "{"..i..","..j.."}" );
   -- search up
   if i>1 then 
     if private.heartsextscr_search_apply_part(i,j,i-1,j,1)==false then 
       if private.heartsextscr_search_heart_on_group_array(i-1,j,fi,fj)==false then 
          private.heartsextscr_group[fi][fj][# private.heartsextscr_group[fi][fj]+1 ] = {i-1,j};
          private.heartsextscr_seach_blyat(i-1,j,fi,fj);
       end;  
      end;  
   end; 
   -- search down 
   if i<3 then 
     if private.heartsextscr_search_apply_part(i,j,i+1,j,1)==false then 
       if private.heartsextscr_search_heart_on_group_array(i+1,j,fi,fj)==false then 
         private.heartsextscr_group[fi][fj][# private.heartsextscr_group[fi][fj]+1 ] = {i+1,j};
         private.heartsextscr_seach_blyat(i+1,j,fi,fj);
       end;  
     end;  
   end; 
   --serach left 
   if j>1 then 
     if private.heartsextscr_search_apply_part(i,j,i,j-1,2)==false then 
       if private.heartsextscr_search_heart_on_group_array(i,j-1,fi,fj)==false then 
         private.heartsextscr_group[fi][fj][# private.heartsextscr_group[fi][fj]+1 ] = {i,j-1};
         private.heartsextscr_seach_blyat(i,j-1,fi,fj);
       end;  
     end;  
   end; 
   --search right 
   if j<4 then 
     if private.heartsextscr_search_apply_part(i,j,i,j+1,2)==false then 
       if private.heartsextscr_search_heart_on_group_array(i,j+1,fi,fj)==false then 
         private.heartsextscr_group[fi][fj][# private.heartsextscr_group[fi][fj]+1 ] = {i,j+1};
         private.heartsextscr_seach_blyat(i,j+1,fi,fj);
       end;  
     end;  
   end; 
   
   private.heartsextscr_seach_blyat_count=private.heartsextscr_seach_blyat_count-1;
   private.heartsextscr_seach_blyat_after();
end;  
 
function private.heartsextscr_seach_blyat_after()
 -- ld.LogTrace( "private.heartsextscr_seach_blyat_count = "..private.heartsextscr_seach_blyat_count );
 -- if private.heartsextscr_seaching_flag then ld.LogTrace( "private.heartsextscr_seaching_flag = true" ); else ld.LogTrace( "private.heartsextscr_seaching_flag = false" ); end;
 -- if private.heartsextscr_all_searching_flag then ld.LogTrace( "private.heartsextscr_all_searching_flag = true" ); else ld.LogTrace( "private.heartsextscr_all_searching_flag = false" ); end;
  if private.heartsextscr_seach_blyat_count==0 and private.heartsextscr_seaching_flag and  private.heartsextscr_all_searching_flag then private.heartsextscr_seaching_flag=false; private.heartsextscr_select_array(); end;
end;  
 
function private.heartsextscr_search_apply_part(i1,j1,i2,j2,ptype)
   local type_ar = {"hor","ver"};
   local type_count_ar = {4,6};
   for i=1,type_count_ar[ptype],1 do 
     if ApplyObj("obj_heartsextscr_"..type_ar[ptype].."_drag_zone_"..i,"obj_heartsextscr_heart_"..i1.."_"..j1) and ApplyObj("obj_heartsextscr_"..type_ar[ptype].."_drag_zone_"..i,"obj_heartsextscr_heart_"..i2.."_"..j2) then 
     --  ld.LogTrace( "stop in spr_heartsextscr_"..type_ar[ptype].."_"..i );
       return true;
     end;  
   end;  
   return false;
end;  
 
------------------------------------------------------------------------ 
function private.heartsextscr_show_group()
  local mytext = "";
  for i=1,3,1 do 
    for j=1,4,1 do 
      mytext = "group ["..i.."]["..j.."] = ";
      for ii=1,#private.heartsextscr_group[i][j],1 do 
        mytext = mytext.."{"..private.heartsextscr_group[i][j][ii][1]..","..private.heartsextscr_group[i][j][ii][2].."},"
      end;  
      --  ld.LogTrace( mytext );
    end;  
  end;  
end;  
-------------------------------------------------------------------------
private.heartsextscr_field_count_array = {{1,1,1,1},
                                       {1,3,2,1},
                                       {1,1,1,1}}


private.heartsextscr_parts_fp = {{1,2,3,4},{1,2,3,4,5,6}}; --hor, ver

function private.heartsextscr_stand_on_pos(without_win_ver)
  -- hor 
  for i=1,4,1 do 
    pos = ng_global.progress["scr"]["win_heartsextscr"].state[1][i];
    ObjAttach("spr_heartsextscr_hor_"..i,"obj_heartsextscr_hor_"..pos);
  end;  
  
  -- ver
  for i=1,6,1 do 
    pos = ng_global.progress["scr"]["win_heartsextscr"].state[2][i];
    ObjAttach("spr_heartsextscr_ver_"..i,"obj_heartsextscr_ver_"..pos);
  end;  
  
  if without_win_ver~=1 then  ld.StartTimer( 0.1, function() private.heartsextscr_group_search(); end ) end;
end;  
--------------------------------------------------------------------------
function public.heartsextscr_part_start_drag(ptype, num)
  ld.SetCursor(CURSOR_HAND);
  local type_ar = {"hor","ver"};
  SoundSfx( "aud_mg_heartsext_get_part" );
  ObjSet( "spr_heartsextscr_"..type_ar[ptype].."_"..num, {pos_z=40} );
  -- ld.LogTrace( "spr_heartsextscr_"..type_ar[ptype].."_"..num );
  ObjSet( "obj_heartsextscr_"..type_ar[ptype].."_"..ng_global.progress["scr"]["win_heartsextscr"].state[ptype][num], {pos_z=40} );
end;  

function public.heartsextscr_part_drop(ptype, num) --ptype 1-hor, 2-ver
   local type_ar = {"hor","ver"};
   local type_count_ar = {12,15}; 
   SoundSfx( "aud_mg_heartsext_drop_part" );
   local attach_num=0;
   for i=1,type_count_ar[ptype],1 do 
     local rel = ObjGetRelations( "obj_heartsextscr_"..type_ar[ptype].."_"..i );
     if ApplyObj("obj_heartsextscr_"..type_ar[ptype].."_drag_zone_"..num,"obj_heartsextscr_"..type_ar[ptype].."_"..i) and #rel.childs==0 then 
       attach_num = i;
     end;  
   end;  
   
   if attach_num~=0 then 
     ObjAttach("spr_heartsextscr_"..type_ar[ptype].."_"..num,"obj_heartsextscr_"..type_ar[ptype].."_drag_zone_"..attach_num);
      ng_global.progress["scr"]["win_heartsextscr"].state[ptype][num] = attach_num;
   end;
   
   ld.SetCursor(CURSOR_DEFAULT); 
   ObjSet( "spr_heartsextscr_"..type_ar[ptype].."_"..num, {pos_z=0} );
   ObjSet( "obj_heartsextscr_"..type_ar[ptype].."_"..ng_global.progress["scr"]["win_heartsextscr"].state[ptype][num], {pos_z=0} );
  -- ld.StartTimer( 0.1, function() ld.Lock(0); private.heartsextscr_stand_on_pos(); end ) 
   ld.Lock(1);
   private.heartsextscr_stand_on_pos();
end;  
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_heartsextscr"} ) then
  SoundMgTheme( true )
    cmn.MiniGameShow( "heartsextscr" );
  end
  private.heartsextscr_stand_on_pos();
end;
--*********************************************************************************************************************
function public.PreOpen()
  private.mg_heartsextscr_first_init();
  SoundEnv( "aud_nearhouseext_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_heartsextscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "heartsextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
     ng_global.progress["scr"]["win_heartsextscr"].state = ld.TableCopy(private.heartsextscr_parts_fp);
     private.heartsextscr_stand_on_pos();
     ObjAnimate( "obj_heartsextscr_mg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.2,0,0, 0.5,0,1} );  
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_heartsextscr_mg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} ); 
end;
--*********************************************************************************************************************
function public.Skip()
  local win_array = {{10,9,11,6},{14,10,11,13,8,15}};
  
  --private.Win();
  local func_end = function()
     ng_global.progress["scr"]["win_heartsextscr"].state = ld.TableCopy(win_array);
     private.heartsextscr_stand_on_pos(1);
     ObjAnimate( "obj_heartsextscr_mg_root", 8, 0, 0, function()  private.heartsextscr_stand_on_pos(); end, {0,0,0, 0.2,0,0, 0.5,0,1} );  
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_heartsextscr_mg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} ); 
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_heartsextscr" );
  cmn.CallEventHandler( "win_heartsextscr" );
  if common_impl.ZzCompleteCheck( "win_heartsextscr" ) then rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ); end;

end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  SoundSfx( "aud_mg_heartsext_win" );
  ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_heartsextscr"].state then
      gm.state = ld.TableCopy( ng_global.progress["scr"]["win_heartsextscr"].state )
    else  
      ng_global.progress["scr"]["win_heartsextscr"].state = ld.TableCopy(private.heartsextscr_parts_fp);
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.heartsextscr_stand_on_pos(1);
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_heartsextscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;