-- name=mg_hutdoorscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_hutdoorscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_hutdoorscr" ] = {type = "win", use_place = "mg_hutdoorscr", room = "rm_secretroomscr", zz = "mg_hutdoorscr", zz_gate = "gmg_secretroomscr_hutdoorscr" };

  local win_hutdoorscr_logic = function()
    if ld.CheckRequirements( {"win_hutdoorscr"} ) then

    end
  end;
  local win_hutdoorscr = function()
    if ld.CheckRequirements( {"win_hutdoorscr"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_hutdoorscr", win_hutdoorscr, private.room_objname )
  cmn.AddSubscriber("win_hutdoorscr", win_hutdoorscr_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;


private.parts_fp_array = {{0,0,0,0},{-30,-30,-30,30,-30,-30,30,30,-30}};

private.mg_hutdoorscr_first_init_flag = false;
function private.mg_hutdoorscr_first_init()
  if private.mg_hutdoorscr_first_init_flag == false then 
    for i=1,9,1 do 
      ObjCreate("spr_hutdoorscr_am"..i,"spr");
      ObjAttach("spr_hutdoorscr_am"..i,"obj_hutdoorscr_lp_center"..i);
      --local part_pos = {ObjGet("obj_hutdoorscr_lp_center"..i).pos_x,ObjGet("obj_hutdoorscr_lp_center"..i).pos_y};
      ObjSet( "spr_hutdoorscr_am"..i, {res="assets/levels/level/mg_hutdoor/am", input=1, visible=1, pos_z=10, event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);",
            event_mdown = "mg_hutdoorscr.mg_hutdoorscr_circle_mdown("..i..");"} );
      
      ObjCreate("spr_hutdoorscr_lig_am"..i,"spr");
      ObjAttach("spr_hutdoorscr_lig_am"..i,"spr_hutdoorscr_am"..i);
      ObjSet( "spr_hutdoorscr_lig_am"..i, {res="assets/levels/level/mg_hutdoor/lig_am", input=0, visible=1, alp=0, pos_y=-3} );
      
      ObjCreate("obj_hutdoorscr_am_apply_zone"..i,"obj");
      ObjAttach("obj_hutdoorscr_am_apply_zone"..i,"spr_hutdoorscr_am"..i);
      ObjSet( "obj_hutdoorscr_am_apply_zone"..i, {input=0, inputrect_init=1, inputrect_w=44, inputrect_h=44, inputrect_y=-22, inputrect_x=-22} );
      
      ObjCreate("obj_hutdoorscr_am_drag_root_"..i,"obj");
      ObjAttach("obj_hutdoorscr_am_drag_root_"..i,"obj_hutdoorscr_am_apply_zone"..i);
      ObjSet( "obj_hutdoorscr_am_drag_root_"..i, {drag=0, event_drag = "mg_hutdoorscr.hutdoorscr_circledragroot_drag("..i..");", event_dragdrop = "mg_hutdoorscr.mg_hutdoorscr_circle_root_stopdrag("..i..");"}  );

    end; 
   
    for i=1,4,1 do 
       private.parts_fp_array[1][i] = ObjGet("obj_hutdoorscr_mp_part"..i).pos_x; 
       ObjSet( "obj_hutdoorscr_mp_part"..i, {event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="mg_hutdoorscr.mg_hutdoorscr_am_mdown("..i..");"} );
       -- ObjSet( "spr_hutdoorscr_a"..i, {event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="mg_hutdoorscr.mg_hutdoorscr_am_mdown("..i..");"} );
       ObjSet( "spr_hutdoorscr_a"..i, {input=0});
       ObjCreate("obj_hutdoorscr_a_drag_root_"..i,"obj");
       ObjAttach("obj_hutdoorscr_a_drag_root_"..i,"obj_hutdoorscr_mp_part"..i);
       ObjSet( "obj_hutdoorscr_a_drag_root_"..i, {drag=0, event_drag = "mg_hutdoorscr.mg_hutdoorscr_am_root_drag("..i..");", event_dragdrop = "mg_hutdoorscr.mg_hutdoorscr_am_root_stopdrag("..i..");"}  );
    end;  
  end;  
  private.mg_hutdoorscr_first_init_flag = true;
end;  

local mg_hutdoorscr_last_pos=0;
local mg_hutdoorscr_bigpart_last_pos=0;
function public.mg_hutdoorscr_am_mdown(num)
 -- ld.LogTrace( "mg_hutdoorscr_am_mdown" );
  local cursor = GetZoomCursorPos(); 
  ObjSet( "obj_hutdoorscr_a_drag_root_"..num, {pos_x = cursor[1], pos_y = cursor[2]} );
  ObjStartDrag("obj_hutdoorscr_a_drag_root_"..num);
  mg_hutdoorscr_last_pos = cursor[1];
  mg_hutdoorscr_bigpart_last_pos = ObjGet("obj_hutdoorscr_mp_part"..num).pos_x;
--  ld.SetCursor(CURSOR_DEFAULT);
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet( "obj_hutdoorscr_mp_part"..num, {input=0} );
  SoundSfx( "aud_mg_hutdoor_lock_get" );
end;  

private.hutdoorscr_move_sound2_flag = false;
function private.hutdoorscr_move_sound2()
  if private.hutdoorscr_move_sound2_flag==false then 
    SoundSfx( "aud_mg_hutdoor_lock_move" );
    private.hutdoorscr_move_sound2_flag = true;
    ld.StartTimer( 0.2, function() private.hutdoorscr_move_sound2_flag =false;  end )
  end;  
end

function public.mg_hutdoorscr_am_root_drag(num)
  local pos_prdl={80,960}
  -- ld.LogTrace( "mg_hutdoorscr_am_root_drag");
  if ApplyObj("obj_hutdoorscr_mp_part"..num,"obj_hutdoorscr_a_drag_root_"..num) then
      
      local cursor = GetZoomCursorPos(); 
      local step=0;
      if mg_hutdoorscr_last_pos~=cursor[1] then step=cursor[1]-mg_hutdoorscr_last_pos; mg_hutdoorscr_last_pos=cursor[1]; end;
      --ld.SetCursor(CURSOR_HAND);
      local pos = ObjGet("obj_hutdoorscr_mp_part"..num).pos_x 
      
      local littlepart_apply_flag=0;
      local little_parts_search_final_flag = 0;
      local rel = ObjGetRelations( "spr_hutdoorscr_a"..num );
      for i=1,9,1 do 
        for j=1,#rel.childs,1 do 
          if ApplyObj("obj_hutdoorscr_am_apply_zone"..i,"obj_hutdoorscr_a"..num.."_"..j) then
             local apply_delta = GetObjPosByObj("obj_hutdoorscr_am_apply_zone"..i,"obj_hutdoorscr_mg_root")[1] - GetObjPosByObj("obj_hutdoorscr_a"..num.."_"..j,"obj_hutdoorscr_mg_root")[1];
             if apply_delta*step >= 0 then
                 littlepart_apply_flag=littlepart_apply_flag+1;
               end;
             end;
        end;  
        if i==9 then little_parts_search_final_flag = 1; end;
      end;  
      
      if math.abs(step)>1 then private.hutdoorscr_move_sound2(); end;
      
      if (num==1 or num==3) then 
          if not (pos+step>pos_prdl[1] and pos+step<private.parts_fp_array[1][num]) then step=0; end; 
      elseif num==2 or num==4 then 
          if not (pos+step<pos_prdl[2] and pos+step>private.parts_fp_array[1][num]) then step=0; end; 
      end;  
      
      if little_parts_search_final_flag==1 then   
        if littlepart_apply_flag>0 then  step=0; ObjSet( "obj_hutdoorscr_mp_part"..num, {pos_x=mg_hutdoorscr_bigpart_last_pos} ); elseif step>=-30 and step<=30 then  ObjSet( "obj_hutdoorscr_mp_part"..num, {pos_x=pos+step} ); mg_hutdoorscr_bigpart_last_pos = ObjGet("obj_hutdoorscr_mp_part"..num).pos_x; end;
        ng_global.progress["scr"]["win_hutdoorscr"].state[1][num] = ObjGet("obj_hutdoorscr_mp_part"..num).pos_x
        if (num==1 or num==3) and  ng_global.progress["scr"]["win_hutdoorscr"].state[1][num]-50<=pos_prdl[1] then
             ng_global.progress["scr"]["win_hutdoorscr"].state[1][num] = pos_prdl[1];
             mg_hutdoorscr_bigpart_last_pos = pos_prdl[1]; 
             ObjSet( "obj_hutdoorscr_mp_part"..num, {pos_x=ng_global.progress["scr"]["win_hutdoorscr"].state[1][num]} );
             ObjStopDrag("obj_hutdoorscr_a_drag_root_"..num); return;
           elseif   (num==2 or num==4) and  ng_global.progress["scr"]["win_hutdoorscr"].state[1][num]+50>=pos_prdl[2] then
             ng_global.progress["scr"]["win_hutdoorscr"].state[1][num] = pos_prdl[2];
             mg_hutdoorscr_bigpart_last_pos = pos_prdl[2];
             ObjSet( "obj_hutdoorscr_mp_part"..num, {pos_x=ng_global.progress["scr"]["win_hutdoorscr"].state[1][num]} );
             ObjStopDrag("obj_hutdoorscr_a_drag_root_"..num); return;
        end; 
      end;    
  else 
      ObjStopDrag("obj_hutdoorscr_a_drag_root_"..num);
  end;
end;  

private.hutdoorscr_stop_drag_sound_flag = false;  
function private.hutdoorscr_stop_drag_sound()
  if private.hutdoorscr_stop_drag_sound_flag==false then 
    private.hutdoorscr_stop_drag_sound_flag = true;
    SoundSfx( "aud_mg_hutdoor_lock_set" );
    ld.StartTimer( 0.5, function() private.hutdoorscr_stop_drag_sound_flag=false;  end )
  end;  
end;  

local aud_mg_hutdoorscr_lock_win_flag = false;  
function public.mg_hutdoorscr_am_root_stopdrag(num)
  ld.SetCursor(CURSOR_DEFAULT);
  --SoundSfx( "aud_mg_hutdoor_lock_set" );
  private.hutdoorscr_stop_drag_sound();
  local pos_prdl={80,960}
  
 
  if (num==1 or num==3) and  ng_global.progress["scr"]["win_hutdoorscr"].state[1][num]-50<=pos_prdl[1] then
          ld.Lock(1);
           if aud_mg_hutdoorscr_lock_win_flag==false then 
             aud_mg_hutdoorscr_lock_win_flag = true;
             SoundSfx( "aud_mg_hutdoor_lock_win" )
             ld.StartTimer( 0.3, function() aud_mg_hutdoorscr_lock_win_flag = false; end )
           end;
           ld.AnimPlay( "anm_hutdoorscr_amn_mg", "idle_st", function() ld.Lock(0);  private.mg_hutdoorscr_stand_on_pos(); end)
  elseif (num==2 or num==4) and  ng_global.progress["scr"]["win_hutdoorscr"].state[1][num]+50>=pos_prdl[2] then
           ld.Lock(1);
           if aud_mg_hutdoorscr_lock_win_flag==false then 
               aud_mg_hutdoorscr_lock_win_flag = true;
               SoundSfx( "aud_mg_hutdoor_lock_win"); 
               ld.StartTimer( 0.3, function() aud_mg_hutdoorscr_lock_win_flag = false; end )
           end;
           ld.AnimPlay( "anm_hutdoorscr_amn_mg", "idle_st", function() ld.Lock(0);  private.mg_hutdoorscr_stand_on_pos(); end)
  else
     ObjSet( "obj_hutdoorscr_mp_part"..num, {input=1} );
     private.mg_hutdoorscr_stand_on_pos();        
  end;
end;  

------------------------------------------------
local mg_hutdoorscr_circledragroot_last_pos=0;
local mg_hutdoorscr_circle_last_pos = 0;

function public.mg_hutdoorscr_circle_mdown(num)
--  ld.LogTrace( "mg_hutdoorscr_circle_mdown" );
  local cursor = GetZoomCursorPos(); 
  ObjSet( "obj_hutdoorscr_am_drag_root_"..num, {pos_x = cursor[1], pos_y = cursor[2]} );
  ObjStartDrag("obj_hutdoorscr_am_drag_root_"..num);
  mg_hutdoorscr_circledragroot_last_pos = cursor[2];
  mg_hutdoorscr_circle_last_pos = ObjGet("spr_hutdoorscr_am"..num).pos_y;
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet( "spr_hutdoorscr_am"..num, {input = 0} );
  ObjSet( "spr_hutdoorscr_lig_am"..num, {visible = 1, alp=1} );
  
  SoundSfx( "aud_mg_hutdoor_circle_get" );
end;  

private.hutdoorscr_move_sound_flag = false;
function private.hutdoorscr_move_sound()
  if private.hutdoorscr_move_sound_flag==false then 
    SoundSfx( "aud_mg_hutdoor_circle_move" );
    private.hutdoorscr_move_sound_flag = true;
    ld.StartTimer( 0.1, function() private.hutdoorscr_move_sound_flag =false;  end )
  end;  
end


function public.hutdoorscr_circledragroot_drag(num)
  -- ld.SetCursor(CURSOR_DEFAULT);
 --  ld.LogTrace( "hutdoorscr_circledragroot_drag" );
   local move_prdl={-30,30};
  
   if ApplyObj("spr_hutdoorscr_am"..num,"obj_hutdoorscr_am_drag_root_"..num) then
      
      local cursor = GetZoomCursorPos(); 
      local step=0;
      if mg_hutdoorscr_circledragroot_last_pos~=cursor[2] then step=cursor[2]-mg_hutdoorscr_circledragroot_last_pos; mg_hutdoorscr_circledragroot_last_pos=cursor[2]; end;
      -- ld.SetCursor(CURSOR_HAND);
      local pos = ObjGet("spr_hutdoorscr_am"..num).pos_y 
      
      local littlepart_apply_flag=0;
      for i=1,4,1 do 
        local rel = ObjGetRelations( "spr_hutdoorscr_a"..i );
        for j=1,#rel.childs,1 do 
          if ApplyObj("obj_hutdoorscr_am_apply_zone"..num,"obj_hutdoorscr_a"..i.."_"..j) then 
            local apply_delta = GetObjPosByObj("obj_hutdoorscr_a"..i.."_"..j,"obj_hutdoorscr_mg_root")[2] - GetObjPosByObj("obj_hutdoorscr_am_apply_zone"..num,"obj_hutdoorscr_mg_root")[2] ;
            if apply_delta*step > 1 then
                littlepart_apply_flag=littlepart_apply_flag+1;
              end;
          end;
        end;  
      end;  
      
        if math.abs(step)>1 then private.hutdoorscr_move_sound(); end;
        
      if  pos+step<=move_prdl[1] or pos+step>=move_prdl[2] then step=0; end;  
      if littlepart_apply_flag>0 then  step=0; ObjSet( "spr_hutdoorscr_am"..num, {pos_y=mg_hutdoorscr_circle_last_pos} ); else mg_hutdoorscr_circle_last_pos = ObjGet("spr_hutdoorscr_am"..num).pos_y;  ObjSet( "spr_hutdoorscr_am"..num, {pos_y=pos+step} ); end;
      ng_global.progress["scr"]["win_hutdoorscr"].state[2][num] = ObjGet("spr_hutdoorscr_am"..num).pos_y;
  else 
      ObjStopDrag("obj_hutdoorscr_am_drag_root_"..num);
  end;
end;  
  
private.hutdoorscr_stop_drag_sound2_flag = false;  
function private.hutdoorscr_stop_drag_sound2()
  if private.hutdoorscr_stop_drag_sound2_flag==false then 
    private.hutdoorscr_stop_drag_sound2_flag = true;
    SoundSfx( "aud_mg_hutdoor_circle_set" );
    ld.StartTimer( 0.5, function() private.hutdoorscr_stop_drag_sound2_flag=false;  end )
  end;  
end;    
  
function public.mg_hutdoorscr_circle_root_stopdrag(num)
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet(  "spr_hutdoorscr_am"..num, {input = 1} );
  ObjSet( "spr_hutdoorscr_lig_am"..num, {visible = 1, alp=0} );
--  SoundSfx( "aud_mg_hutdoor_circle_set" );
  private.hutdoorscr_stop_drag_sound2();
end;    
------------------------------------------------------------------------------------  
function private.mg_hutdoorscr_stand_on_pos(without_win_ver)
  local pos_prdl={80,960}
  for i=1,4,1 do 
    if ((i==1 or i==3) and ng_global.progress["scr"]["win_hutdoorscr"].state[1][i]==pos_prdl[1]) or ((i==2 or i==4) and ng_global.progress["scr"]["win_hutdoorscr"].state[1][i]==pos_prdl[2]) then 
      ObjSet( "obj_hutdoorscr_mp_part"..i, {input = 0} );
      if i==1 or i ==3 then  ng_global.progress["scr"]["win_hutdoorscr"].state[1][i] =  pos_prdl[1]; end;
      if i==2 or i ==4 then  ng_global.progress["scr"]["win_hutdoorscr"].state[1][i] =  pos_prdl[2]; end;
    else
      ObjSet( "obj_hutdoorscr_mp_part"..i, {input = 1} );
    end;  
    ObjSet( "obj_hutdoorscr_mp_part"..i, {pos_x = ng_global.progress["scr"]["win_hutdoorscr"].state[1][i]} );
  end;  
  for i=1,9,1 do 
    ObjSet( "spr_hutdoorscr_am"..i, {pos_y =  ng_global.progress["scr"]["win_hutdoorscr"].state[2][i]} );
  end; 
  if  without_win_ver~=1 then private.mg_hutdoorscr_win_ver() end;
end;  

function private.mg_hutdoorscr_win_ver()
  local pos_prdl={80,960}
  local count = 0;
  for i=1,4,1 do 
    if ((i==1 or i==3) and ng_global.progress["scr"]["win_hutdoorscr"].state[1][i]==pos_prdl[1]) or ((i==2 or i==4) and ng_global.progress["scr"]["win_hutdoorscr"].state[1][i]==pos_prdl[2]) then 
      count = count+1;
    end;  
  end;  
 if count ==4 then private.Win(); end;
 
end;  


--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_hutdoorscr"} ) then
  SoundMgTheme( true )
    cmn.MiniGameShow( "hutdoorscr" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  iOS_NeedDrag(0);
  private.mg_hutdoorscr_first_init()
  SoundEnv( "aud_grove_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_hutdoorscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "hutdoorscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  iOS_NeedDrag(1);
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
    ng_global.progress["scr"]["win_hutdoorscr"].state = ld.TableCopy(private.parts_fp_array);
    private.mg_hutdoorscr_stand_on_pos();
    ObjAnimate( "obj_hutdoorscr_mg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_hutdoorscr_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function public.Skip()
  -- private.Win();
  local func_end = function()
    ng_global.progress["scr"]["win_hutdoorscr"].state = {{80,960,80,960},{0,0,0,0,0,0,0,0,0}};
    private.mg_hutdoorscr_stand_on_pos(1);
    ObjAnimate( "obj_hutdoorscr_mg_root", 8, 0, 0, function()  private.mg_hutdoorscr_stand_on_pos(); end, {0,0,0, 0.25,0,1} );  
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_hutdoorscr_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  -- ld.Lock(0);
  cmn.SetEventDone( "win_hutdoorscr" );
  iOS_NeedDrag(1);
  cmn.CallEventHandler( "win_hutdoorscr" );
  ld.StartTimer( 0.5, function() ld.Lock(0); rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ) end ); 
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, private.WinEnd  );
  SoundSfx( "aud_mg_hutdoor_win" );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_hutdoorscr"].state then
      --gm.state = ld.TableCopy( ng_global.progress["scr"]["win_hutdoorscr"].state )
    else  
      ng_global.progress["scr"]["win_hutdoorscr"].state = ld.TableCopy(private.parts_fp_array);
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.mg_hutdoorscr_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_hutdoorscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;