-- name=ho_utilityroomho
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "utilityroomho" );
  game.relations[ "ho_utilityroomho" ].exitroom = "rm_hut";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_utilityroomho" ] = { type = "win", room = "rm_hut", zz = "ho_utilityroomho", zz_gate = "gho_hut_utilityroomho" };
 
  local win_utilityroomho_func = function ()

    if ( cmn.IsEventDone( "win_utilityroomho" ) ) then
      interface.InventoryItemAdd( "inv_quatrefoil", "spr_utilityroomho_win" );
      ObjDelete( "gho_hut_utilityroomho" );
    end;

  end;
  cmn.AddSubscriber( "win_utilityroomho", win_utilityroomho_func );
  
  local start_utilityroomho_func = function ()
  if not cmn.IsEventDone("win_utilityroomho") then
  
  end
  end;
  cmn.AddSubscriber( "win_utilityroomho", start_utilityroomho_func, "ho_utilityroomho" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_hut_env" )

  if ( not cmn.IsEventDone( "opn_utilityroomho" ) ) then

    cmn.InitHo( "utilityroomho" );

    cmn.SetEventDone( "opn_utilityroomho" );
 
  end;

  local ho_items = {};

  --[[1]] interface.TaskPanelTaskAdd( ho_items, "aaa",          5, 0, { { "spr_utilityroomho_aaa_mul_1" },{ "spr_utilityroomho_aaa_mul_2" },{ "spr_utilityroomho_aaa_mul_3" },{ "spr_utilityroomho_aaa_mul_4" },{ "spr_utilityroomho_aaa_mul_5" } }); --siluet
    --[[2]] interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_utilityroomho_bbb" } } );
    --[[3]] interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_utilityroomho_ccc" } } );
  --[[4]] interface.TaskPanelTaskAdd( ho_items, "ddd",          0, 0, { { "spr_utilityroomho_ddd" } } );--0
  --[[5]] interface.TaskPanelTaskAdd( ho_items, "eee",          0, 0, { { "spr_utilityroomho_eee" } } );--0
    --[[6]] interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_utilityroomho_fff" } } );
    --[[7]] interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_utilityroomho_ggg" } } );
  --[[8]] interface.TaskPanelTaskAdd( ho_items, "hhh",          0, 0, { { "spr_utilityroomho_hhh" } } );--0
  --[[9]] interface.TaskPanelTaskAdd( ho_items, "iii",          0, 0, { { "spr_utilityroomho_iii" } } );--0
    --[[10]] interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_utilityroomho_jjj" } } );
    --[[11]] interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_utilityroomho_kkk" } } );
  --[[12]] interface.TaskPanelTaskAdd( ho_items, "lll",          5, 0, { { "spr_utilityroomho_lll_mul_1" },{ "spr_utilityroomho_lll_mul_2" },{ "spr_utilityroomho_lll_mul_3" },{ "spr_utilityroomho_lll_mul_4" },{ "spr_utilityroomho_lll_mul_5" } } ); --siluet
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  --ObjAttach("spr_utilityroomho_panel","int_taskpanel_impl")
  --ObjSet("spr_utilityroomho_panel",{pos_x=0,pos_y=0})
  
  ObjAttach("spr_utilityroomho_panel_aaa_siluet","spr_int_taskpanel")
  ObjAttach("spr_utilityroomho_panel_lll_siluet","spr_int_taskpanel")
  
  ObjSet( "obj_int_taskpanel_task_1", {visible = 0} );
  ObjSet( "obj_int_taskpanel_task_4", {visible = 0} );
  ObjSet( "obj_int_taskpanel_task_5", {visible = 0} );
  ObjSet( "obj_int_taskpanel_task_8", {visible = 0} );
  ObjSet( "obj_int_taskpanel_task_9", {visible = 0} );
  ObjSet( "obj_int_taskpanel_task_12", {visible = 0} );  
  
   for j = 1, #ng_global.progress["std"]["win_utilityroomho"].found do

    local name = tostring( ng_global.progress["std"]["win_utilityroomho"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  private.LoadState()
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;

function public.Close()
  ObjAttach("spr_utilityroomho_panel_aaa_siluet","obj_utilityroomho_siluet_root")
  ObjAttach("spr_utilityroomho_panel_lll_siluet","obj_utilityroomho_siluet_root")
  
  ObjSet( "obj_int_taskpanel_task_1", {visible = 1} );
  ObjSet( "obj_int_taskpanel_task_4", {visible = 1} );
  ObjSet( "obj_int_taskpanel_task_5", {visible = 1} );
  ObjSet( "obj_int_taskpanel_task_8", {visible = 1} );
  ObjSet( "obj_int_taskpanel_task_9", {visible = 1} );
  ObjSet( "obj_int_taskpanel_task_12", {visible = 1} ); 
end
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
    private.LoadState()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  ObjSet( "spr_utilityroomho_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_utilityroomho_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------

function private.LoadState()
  public.state = {}
  for j = 1, #ng_global.progress["std"]["win_utilityroomho"].found do
    
    local task = tostring( ng_global.progress["std"]["win_utilityroomho"].found[j]["task"] );
      if public.state[task] then
        public.state[task] = public.state[task] + 1
      else 
        public.state[task] = 1
      end
  end;
  for k,v in pairs(public.state) do
    if public.state[k] then

      ObjSet("txt_utilityroomho_panel_"..k.."_text",{text="x"..(5-tonumber(v))})
    end
  end 
end
----------------------------------------------------------------------------