-- name=mg_prison
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_prison";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_prison" ] = {type = "win", use_place = "mg_prison", room = "rm_cellar", zz = "mg_prison", zz_gate = "gmg_cellar_prison" };

  local win_prison_logic = function()
    if ld.CheckRequirements( {"win_prison"} ) then
        ObjSet("gfx_cellar_portrait_zone",{visible = 1, input = 1, active = 1})
    end
  end;
  local win_prison = function()
    if ld.CheckRequirements( {"win_prison"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_prison", win_prison, private.room_objname )
  cmn.AddSubscriber("win_prison", win_prison_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

private.prison_place_coord={{{235,214},{365,214},{495,214}},
                            {{235,344},{365,344},{495,344}},
                            {{235,474},{365,474},{495,474}}}

private.prison_parts_fp = {{4,1,7},{8,5,2},{3,9,6}};
private.prison_win_pos = {{1,2,3},{4,5,6},{7,8,9}};
                        
function private.prison_stand_on_pos(without_win_ver)
  for i=1,3,1 do 
    for j=1,3,1 do 
      ObjSet( "spr_prison_a"..ng_global.progress["std"]["win_prison"].state[i][j], {pos_x = private.prison_place_coord[i][j][1], pos_y =  private.prison_place_coord[i][j][2]} );
    end;  
  end;  
  -- private.prison_show_state();
  
  if without_win_ver~=1 then 
      private.prison_win_ver();
  end;    
end;  

function private.prison_win_ver()
  local count=0;
  for i=1,3,1 do 
    for j=1,3,1 do
      if ng_global.progress["std"]["win_prison"].state[i][j] == private.prison_win_pos[i][j] then count=count+1; end;
    end;  
  end;  
  if count ==9 then private.Win() end;
end;  



function private.prison_show_state()
  --  ld.LogTrace( "-----------------------------------------" );
  local buf="";
  for i=1,3,1 do 
    for j=1,3,1 do 
      buf = buf.." "..ng_global.progress["std"]["win_prison"].state[i][j];
    end;  
    --ld.LogTrace( buf );
    buf = "";
  end;  
end;  


function public.prison_mothion(num,napr)  --mg_prison.prison_mothion(1,1)
 -- ld.LogTrace( ng_global.progress["std"]["win_prison"].state );
  ld.AnimPlay( "anm_prison_anm_jail_castle", "idle_castle", "" ); 
  SoundSfx( "aud_mg_prison_move" );
  
  local ver_step = 130;
  local hor_step = 130;
  ---------------- vertical ------------
  if num == 1 or num ==2 then
    local jnum = 1;
    if num ==2 then jnum=3 end;
    
    if napr == 1 then  
        local up_num = ng_global.progress["std"]["win_prison"].state[1][jnum];
        ObjCreate("spr_prison_down_1","spr");
        ObjSet( "spr_prison_down_1", {res="assets/levels/level/mg_prison/a"..up_num, input=0, pos_x=private.prison_place_coord[1][jnum][1], pos_y=604, visible=1} );
        ObjAttach("spr_prison_down_1","obj_prison_root")
        for i=1,3,1 do 
          local cur_pos = {ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[i][jnum]).pos_x,ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[i][jnum]).pos_y};
          ObjAnimate( "spr_prison_a"..ng_global.progress["std"]["win_prison"].state[i][jnum], 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,cur_pos[1],(cur_pos[2]-ver_step)} );
        end;  
          
        cur_pos = {ObjGet("spr_prison_down_1").pos_x,ObjGet("spr_prison_down_1").pos_y};
        ObjAnimate( "spr_prison_down_1", 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,cur_pos[1],(cur_pos[2]-ver_step)} );  
        ld.Lock(1)  
        ld.StartTimer( 0.6, function() 
          ld.Lock(0);
          local buf = ng_global.progress["std"]["win_prison"].state[1][jnum];
          ng_global.progress["std"]["win_prison"].state[1][jnum] = ng_global.progress["std"]["win_prison"].state[2][jnum]; 
          ng_global.progress["std"]["win_prison"].state[2][jnum] = ng_global.progress["std"]["win_prison"].state[3][jnum];
          ng_global.progress["std"]["win_prison"].state[3][jnum] = buf;
          private.prison_stand_on_pos();
          ObjDelete("spr_prison_down_1");
          end )  
   elseif napr == 2 then 
        local down_num = ng_global.progress["std"]["win_prison"].state[3][jnum];
        ObjCreate("spr_prison_down_1","spr");
        ObjSet( "spr_prison_down_1", {res="assets/levels/level/mg_prison/a"..down_num, input=0,pos_x=private.prison_place_coord[1][jnum][1], pos_y=84, visible=1} );
        ObjAttach("spr_prison_down_1","obj_prison_root")
        for i=1,3,1 do 
          local cur_pos = {ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[i][jnum]).pos_x,ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[i][jnum]).pos_y};
          ObjAnimate( "spr_prison_a"..ng_global.progress["std"]["win_prison"].state[i][jnum], 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,cur_pos[1],(cur_pos[2]+ver_step)} );
        end;  
          
        cur_pos = {ObjGet("spr_prison_down_1").pos_x,ObjGet("spr_prison_down_1").pos_y};
        ObjAnimate( "spr_prison_down_1", 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,cur_pos[1],(cur_pos[2]+ver_step)} );  
        ld.Lock(1)  
        ld.StartTimer( 0.6, function() 
          ld.Lock(0);
          local buf = ng_global.progress["std"]["win_prison"].state[2][jnum];
          ng_global.progress["std"]["win_prison"].state[2][jnum] = ng_global.progress["std"]["win_prison"].state[1][jnum];
          ng_global.progress["std"]["win_prison"].state[1][jnum] = ng_global.progress["std"]["win_prison"].state[3][jnum];
          ng_global.progress["std"]["win_prison"].state[3][jnum] = buf;
          private.prison_stand_on_pos();
          ObjDelete("spr_prison_down_1");
          end )  
   end;     
  --------------------- horizontal -----------------
  elseif num ==3 or num==4 then 
    local inum = 1;
    if num == 4 then inum=3 end;
    
    if napr == 1 then  
      local left_num = ng_global.progress["std"]["win_prison"].state[inum][1];
      ObjCreate("spr_prison_left_1","spr");
      ObjSet( "spr_prison_left_1", {res="assets/levels/level/mg_prison/a"..left_num, input=0, pos_x = 625, pos_y=private.prison_place_coord[inum][1][2], visible=1} );
      ObjAttach("spr_prison_left_1","obj_prison_root")
        for i=1,3,1 do 
          local cur_pos = {ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[inum][i]).pos_x,ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[inum][i]).pos_y};
          ObjAnimate( "spr_prison_a"..ng_global.progress["std"]["win_prison"].state[inum][i], 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,(cur_pos[1]-hor_step),cur_pos[2]} );
        end;  
          
        cur_pos = {ObjGet("spr_prison_left_1").pos_x,ObjGet("spr_prison_left_1").pos_y};
        ObjAnimate( "spr_prison_left_1", 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,(cur_pos[1]-hor_step),cur_pos[2]} );  
        ld.Lock(1)  
        ld.StartTimer( 0.6, function() 
          ld.Lock(0);
          local buf = ng_global.progress["std"]["win_prison"].state[inum][1];
          ng_global.progress["std"]["win_prison"].state[inum][1] = ng_global.progress["std"]["win_prison"].state[inum][2];
          ng_global.progress["std"]["win_prison"].state[inum][2] = ng_global.progress["std"]["win_prison"].state[inum][3];
          ng_global.progress["std"]["win_prison"].state[inum][3] = buf;
          private.prison_stand_on_pos();
          ObjDelete("spr_prison_left_1");
          end )  
   elseif napr == 2 then 
        local right_num = ng_global.progress["std"]["win_prison"].state[inum][3];
        ObjCreate("spr_prison_right_1","spr");
        ObjSet( "spr_prison_right_1", {res="assets/levels/level/mg_prison/a"..right_num, input=0,pos_x=105, pos_y=private.prison_place_coord[inum][1][2], visible=1} );
        ObjAttach("spr_prison_right_1","obj_prison_root")
        for i=1,3,1 do 
          local cur_pos = {ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[inum][i]).pos_x,ObjGet("spr_prison_a"..ng_global.progress["std"]["win_prison"].state[inum][i]).pos_y};
          ObjAnimate( "spr_prison_a"..ng_global.progress["std"]["win_prison"].state[inum][i], 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,cur_pos[1]+hor_step,cur_pos[2]} );
        end;  
          
        cur_pos = {ObjGet("spr_prison_right_1").pos_x,ObjGet("spr_prison_right_1").pos_y};
        ObjAnimate( "spr_prison_right_1", 3, 0, 0, function() end, {0,0,cur_pos[1],cur_pos[2], 0.5,0,cur_pos[1]+hor_step,cur_pos[2]} );  
        ld.Lock(1)  
        ld.StartTimer( 0.6, function() 
          ld.Lock(0);
          local buf = ng_global.progress["std"]["win_prison"].state[inum][2];
          ng_global.progress["std"]["win_prison"].state[inum][2] = ng_global.progress["std"]["win_prison"].state[inum][1];
          ng_global.progress["std"]["win_prison"].state[inum][1] = ng_global.progress["std"]["win_prison"].state[inum][3];
          ng_global.progress["std"]["win_prison"].state[inum][3] = buf;
          private.prison_stand_on_pos();
          ObjDelete("spr_prison_right_1");
          end )  
    end; 
  end;
    
end;  
        

function public.prisont_st_menter(num,napr)
  ld.SetCursor(CURSOR_HAND);
  ObjSet( "spr_prison_st_lig"..num.."_"..napr, {alp=1} );
end;  
    
function public.prison_st_mleave(num,napr)
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet( "spr_prison_st_lig"..num.."_"..napr, {alp=0} );
end;  

public.prison_first_init_flag = false;
function public.prison_first_init()
  if public.prison_first_init_flag  == false then 
    for i=1,4,1 do 
      for j=1,2,1 do 
        ObjSet( "spr_prison_st"..i.."_"..j, {pos_z=20, event_menter = "mg_prison.prisont_st_menter("..i..","..j..");", event_mleave="mg_prison.prison_st_mleave("..i..","..j..");"} );
      end;  
    end;  
  end;  
  public.prison_first_init_flag = true;
end;  
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_prison"} ) then
    SoundMgTheme( true )
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( {"win_prison"} ) then
      cmn.MiniGameShow( "prison" );
  end;  
  public.prison_first_init()
  SoundEnv( "aud_cellar_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_prison"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "prison" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function() 
     ng_global.progress["std"]["win_prison"].state = ld.TableCopy(private.prison_parts_fp);
     private.prison_stand_on_pos();
     ObjAnimate( "obj_prison_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end
  --private.Win();
  
  
  ld.Lock(1);
  ObjAnimate( "obj_prison_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function public.Skip()
  local func_end = function() 
     ng_global.progress["std"]["win_prison"].state = ld.TableCopy(private.prison_win_pos);
     private.prison_stand_on_pos(1);
     ObjAnimate( "obj_prison_root", 8, 0, 0,  private.prison_stand_on_pos, {0,0,0, 0.25,0,1} );
  end
  --private.Win();
  
  
  ld.Lock(1);
  ObjAnimate( "obj_prison_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_prison" );
  cmn.CallEventHandler( "win_prison" );
  if common_impl.ZzCompleteCheck( "win_prison" ) then cmn.GotoRoom( "rm_cellar" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, function() SoundSfx( "aud_mg_prison_win" ); ld.AnimPlay( "anm_prison_anm_jail_castle", "open_castle", function() private.WinEnd() end ) end  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_prison"].state then
      --  gm.state = ld.TableCopy( ng_global.progress["std"]["win_prison"].state )
    else  
      ng_global.progress["std"]["win_prison"].state = ld.TableCopy(private.prison_parts_fp);
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.prison_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_prison"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;