-- name=mg_toriver
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_toriver";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_toriver" ] = {type = "win", use_place = "mg_toriver", room = "rm_roadway", zz = "mg_toriver", zz_gate = "gmg_roadway_toriver" };

  local win_toriver_logic = function()
    if ld.CheckRequirements( {"win_toriver"} ) then
      
    end
  end;
  local win_toriver = function()
    if ld.CheckRequirements( {"win_toriver"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_toriver", win_toriver, private.room_objname )
  cmn.AddSubscriber("win_toriver", win_toriver_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

private.toriver_fp_array = {
  {0,11,0,10,0,0,0},
  {0,0,0,0,0,22,0},
  {0,0,0,0,0,9,0},
  {0,0,9,3,0,0,0},
  {0,0,0,0,9,0,0},
  {0,21,0,0,0,0,0},
  {0,0,0,1,0,0,12},
  {1,-1,1,-1} --napr array
}

-- 11,12 -bats
-- 21,22 -clouds
-- 3 - moon

private.toriver_nil_pos = {-50,371};
private.toriver_step = {70.5,32.5};

private.toriver_first_init_flag = false;
function private.toriver_first_init()
  if private.toriver_first_init_flag == false then 
    -- create girl 
    ObjCreate("obj_toriver_girl_root","obj");
    ObjAttach("obj_toriver_girl_root","obj_toriver_mg_root");
    ObjSet( "obj_toriver_girl_root", {input=1} );
    -- attach dead anim
    ObjAttach("anm_toriver_anm_toriver_dead","obj_toriver_girl_root");
    
    -- create girl imgs
    local girl_names_array = {"straight", "ago", "left", "right"};
    for i=1,4,1 do 
      ObjCreate("spr_toriver_girl"..i,"spr");
      ObjAttach("spr_toriver_girl"..i,"obj_toriver_girl_root");
      ObjSet( "spr_toriver_girl"..i, {res="assets/levels/level/mg_toriver/girl_"..girl_names_array[i], visible=0, input=0, pos_y=-30, pos_z = 50} );
    end;  
    
    ObjSet( "spr_toriver_girl1",{visible = 1});
    
    -- create mdown zones
    
    ObjCreate("obj_toriver_napr_root","obj");
    ObjAttach("obj_toriver_napr_root","obj_toriver_girl_root");
    
    local mdown_sprites_pos_array = {{-1,-1},{1,1},{-1,1},{1,-1}} 
    for i=1,4,1 do 
      ObjCreate("spr_toriver_napr"..i,"spr");
      ObjAttach("spr_toriver_napr"..i,"obj_toriver_napr_root");
      ObjSet( "spr_toriver_napr"..i, {res = "assets/levels/level/mg_toriver/light", visible=1, input=1, alp=1, inputrect_init = 1, inputrect_w=138, inputrect_h=68, inputrect_x=-69, inputrect_y=-34, pos_x = mdown_sprites_pos_array[i][1]*private.toriver_step[1], pos_y = mdown_sprites_pos_array[i][2]*private.toriver_step[2], 
      event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="mg_toriver.toriver_girl_mdown("..i..");"} );
    end;  
    
    
    ----------- for experiment 
  --  for i=1,7,1 do 
  --      for j=1,7,1 do 
  --          local cur_pos = private.toriver_get_coord(i,j);  
  --        
  --          ObjCreate("spr_toriver_field"..i.."_"..j,"spr");
  --          ObjAttach("spr_toriver_field"..i.."_"..j,"obj_toriver_mg_root");
  --          ObjSet( "spr_toriver_field"..i.."_"..j, {res = "assets/levels/level/mg_toriver/light", visible=1, input=1, alp=1, inputrect_init = 1, inputrect_w=138, inputrect_h=68, inputrect_x=-69, inputrect_y=-34, pos_x = cur_pos[1], pos_y = cur_pos[2]} );

  --      end;  
  --  end;  

    
    -- create bats
     for i=1,2,1 do 
       ObjCreate("obj_toriver_bat"..i,"obj");
       ObjAttach("obj_toriver_bat"..i,"obj_toriver_mg_root");
       ObjCreate("anm_toriver_bat"..i,"anim");
       ObjSet( "anm_toriver_bat"..i, {res = "assets/levels/level/mg_toriver/anm_toriver", animfunc = "static_bat"..i, frame = 0, pos_y=-20 } );
       ObjAttach( "anm_toriver_bat"..i,"obj_toriver_bat"..i);
     end; 
    -- create cloud
     for i=1,2,1 do 
       ObjCreate("obj_toriver_cloud"..i,"obj");
       ObjAttach("obj_toriver_cloud"..i,"obj_toriver_mg_root");
       ObjCreate("anm_toriver_cloud"..i,"anim");
       ObjSet( "anm_toriver_cloud"..i, {res = "assets/levels/level/mg_toriver/anm_toriver", animfunc = "static_cloud", frame = 0, pos_y=-40 } );
       ObjAttach("anm_toriver_cloud"..i,"obj_toriver_cloud"..i);
     end;  
     -- attach moon
     ObjCreate("obj_toriver_moon","obj");
     ObjAttach("obj_toriver_moon","obj_toriver_mg_root");
     ObjAttach("anm_toriver_anm_toriver_moon","obj_toriver_moon");
     ObjSet( "obj_toriver_moon", {pos_z=10} );
     
     ObjSet( "anm_toriver_anm_toriver_moon", {pos_y = -40} );
  end;
 
  private.toriver_first_init_flag = true; 
end;  
------------------------------------
function private.toriver_get_coord(ipos,jpos)
  local pos={0,0};
  pos[1]=private.toriver_nil_pos[1]+private.toriver_step[1]*jpos+private.toriver_step[1]*ipos;
  pos[2]=private.toriver_nil_pos[2]+private.toriver_step[2]*ipos - private.toriver_step[2]*jpos;
  
  return pos;
end;
----------------------
function private.toriver_get_obj_pos_on_field(objtype) --1, girl
 
      for i=1,7,1 do 
        for j=1,7,1 do 
          if  ng_global.progress["std"]["win_toriver"].state[i][j] == objtype then return {i,j}; end;
        end;  
      end;  
  
  return {0,0};    
end;  
---------------------------------------
private.toriver_clouds_env_playing_flag=false;
function private.toriver_clouds_env_playing(play) --1-start? 0- stop
  if play==1 then 
    if private.toriver_clouds_env_playing_flag==false then 
      private.toriver_clouds_env_playing_flag = true; 
      SoundEnv( "aud_mg_toriver_clouds_env",1 )
    end;  
  elseif play==0 then 
    if private.toriver_clouds_env_playing_flag==true then
      private.toriver_clouds_env_playing_flag = false; 
      SoundEnv( "aud_mg_toriver_clouds_env",0 )
    end;  
  end;  
end;  



private.toriver_girl_napr = 1; --default
private.toriver_bat_napr = {1,1} -- default
function private.toriver_stand_on_pos(without_win_ver)
  local obj_flags={{0,0},{0,0},0} --bats,clouds,moon
  
  for i=1,7,1 do 
    for j=1,7,1 do 
      local cur_pos = private.toriver_get_coord(i,j);
      -- girl
      if ng_global.progress["std"]["win_toriver"].state[i][j]==1 then
        ObjSet( "obj_toriver_girl_root", {pos_x = cur_pos[1], pos_y = cur_pos[2], alp=1} );
         for ii=1,4,1 do 
           if private.toriver_girl_napr==ii then 
             ObjSet( "spr_toriver_girl"..ii, {visible = 1} );
           else 
             ObjSet( "spr_toriver_girl"..ii, {visible = 0} );
           end;  
         end;  
      end;
      -- bats  
      if ng_global.progress["std"]["win_toriver"].state[i][j]==11 or ng_global.progress["std"]["win_toriver"].state[i][j]==12 then 
        local num = 1;
       
        if ng_global.progress["std"]["win_toriver"].state[i][j]==12 then num = 2; end;
        ObjSet( "obj_toriver_bat"..num, {pos_x = cur_pos[1], pos_y = cur_pos[2], visible=1} );
        local obj = ObjGet("anm_toriver_bat"..num);
        local buf=1;
        if ng_global.progress["std"]["win_toriver"].state[8][num]==-1 then buf=2 end;
        
       -- ld.LogTrace( "bat "..num.." napr = "..ng_global.progress["std"]["win_toriver"].state[8][num].." buf = "..buf );
        ObjSet( "anm_toriver_bat"..num, {animfunc = "static_bat"..buf, playing=1 } );
           
        obj_flags[1][num]=1;
      end; 
      
      --clouds
      if ng_global.progress["std"]["win_toriver"].state[i][j]==21 or ng_global.progress["std"]["win_toriver"].state[i][j]==22 then 
        local num = 1;
        if ng_global.progress["std"]["win_toriver"].state[i][j]==22 then num = 2; end;
        ObjSet( "obj_toriver_cloud"..num, {pos_x = cur_pos[1], pos_y = cur_pos[2], visible = 1, alp=1} );
        local obj = ObjGet("anm_toriver_cloud"..num);
        if not obj.playing then 
           ObjSet( "anm_toriver_cloud"..num, {animfunc = "static_cloud",  playing = 1 } );
        end;   
        obj_flags[2][num]=1;
      end;
      
      --moon 
      if ng_global.progress["std"]["win_toriver"].state[i][j]==3 then 
        
        ObjSet( "obj_toriver_moon", {pos_x = cur_pos[1], pos_y = cur_pos[2], visible = 1, alp=1} );
        local obj = ObjGet("anm_toriver_anm_toriver_moon");
        if not obj.playing then 
          ObjSet( "anm_toriver_anm_toriver_moon", {animfunc = "static_moon",  playing = 1, visible=1 } );
        end;   
        obj_flags[3]=1;
      end;
    
    end;  
  end;  
   
  -------- not enabled objs ---
 --if obj_flags[1][1]==0 then ObjSet( "obj_toriver_bat1",{visible=0}); end;
 --if obj_flags[1][2]==0 then ObjSet( "obj_toriver_bat2",{visible=0}); end; 
  if obj_flags[2][1]==0 then ObjSet( "obj_toriver_cloud1",{visible=0}); private.toriver_active_clouds[1]=0; end;
  if obj_flags[2][2]==0 then ObjSet( "obj_toriver_cloud2",{visible=0}); private.toriver_active_clouds[2]=0; end; 
  if obj_flags[3]==0 then ObjSet( "obj_toriver_cloud2",{visible=0}); end; 
  -----------------------------
  
   private.toriver_show_napr(); 
   
   if without_win_ver~=1 then 
     local flag = private.toriver_win_ver();
     if flag==0 then 
        private.toriver_parts_startmove();
     end;   
   end; 
   
   -------------------- for clouds env
   if ng_global.progress["std"]["win_toriver"].state[4][4]==3 then 
      private.toriver_clouds_env_playing(1);
   else   
      private.toriver_clouds_env_playing(0);   
   end;  
end;  
----------------------------------------
function private.toriver_win_ver()
  if ng_global.progress["std"]["win_toriver"].state[1][4] == 1 then 
    private.Win();
    return 1;
  else  
    return 0;
  end;  
end;  

---------------------------------------------------
function private.toriver_show_napr()
    local mdown_sprites_pos_array = {{-1,0},{1,0},{0,-1},{0,1}} 
    local cur_fpos = private.toriver_get_obj_pos_on_field(1); --1-girl   
    
    for i=1,4,1 do 
      if  (cur_fpos[1] + mdown_sprites_pos_array[i][1]<=0) or (cur_fpos[1] + mdown_sprites_pos_array[i][1]>7) or (cur_fpos[2] + mdown_sprites_pos_array[i][2]<=0) or (cur_fpos[2] + mdown_sprites_pos_array[i][2]>7) then      
        ObjSet( "spr_toriver_napr"..i, {visible = 0, input = 0} );
      else  
       if ng_global.progress["std"]["win_toriver"].state[cur_fpos[1] + mdown_sprites_pos_array[i][1] ][cur_fpos[2] + mdown_sprites_pos_array[i][2] ]==9 then 
          ObjSet( "spr_toriver_napr"..i, {visible = 0, input = 0} );
       else   
           ObjSet( "spr_toriver_napr"..i, {visible = 1, input = 1, color_r=0, color_g=1, color_b=0} );
       end;   
      end;  
    end;  
end;  
----------------------------------------
function public.toriver_girl_mdown(napr)
  
  local mdown_sprites_pos_array = {{-1,0},{1,0},{0,-1},{0,1}} 
  
  ld.Lock(1);
  private.toriver_girl_napr = napr;
  for i=1,4,1 do 
    if private.toriver_girl_napr==i then 
      ObjSet( "spr_toriver_girl"..i, {visible = 1} );
    else 
      ObjSet( "spr_toriver_girl"..i, {visible = 0} );
    end;  
  end; 
 
  local cur_fpos = private.toriver_get_obj_pos_on_field(1); --1-girl
  local next_fpos = {cur_fpos[1]+ mdown_sprites_pos_array[napr][1],cur_fpos[2]+ mdown_sprites_pos_array[napr][2]}
  
  local cur_pos = private.toriver_get_coord(cur_fpos[1],cur_fpos[2]);
  local next_pos =  private.toriver_get_coord(next_fpos[1],next_fpos[2]);
  
  local func_end = function()
    ng_global.progress["std"]["win_toriver"].state[cur_fpos[1] ][cur_fpos[2] ]=0;
    ng_global.progress["std"]["win_toriver"].state[next_fpos[1] ][next_fpos[2] ]=1;
    ld.Lock(0); 
    private.toriver_stand_on_pos();
    ObjSet( "obj_toriver_napr_root", {alp=1} ); 
  end;  
  
  local func_preend = function()
   if ng_global.progress["std"]["win_toriver"].state[next_fpos[1] ][next_fpos[2] ] >10 then 
        private.toriver_attack(ng_global.progress["std"]["win_toriver"].state[next_fpos[1] ][next_fpos[2] ]);
        --ld.StartTimer( 1, func_end )
   elseif ng_global.progress["std"]["win_toriver"].state[next_fpos[1] ][next_fpos[2] ]==3 then 
        SoundSfx( "aud_mg_toriver_moon" );
        ObjAnimate( "obj_toriver_moon", 8, 0, 0, func_end, {0,0,1, 0.6,0,0} );
        ObjSet( "anm_toriver_anm_toriver_moon", { playing = 0 } );
        private.toriver_off_clouds(); 
   else 
      func_end();
   end;   
  end;  
  
   SoundSfx( "aud_mg_toriver_move" );
   -- ObjAnimate( "obj_toriver_napr_root", 8, 0, 0, function() end, {0,0,1, 0.1,0,0, 0.4,0,1} );
   ObjSet( "obj_toriver_napr_root", {alp=0} ); 
   ObjAnimate( "obj_toriver_girl_root", 3, 0, 0, func_preend, {0,0,cur_pos[1],cur_pos[2], 0.3,0,next_pos[1],next_pos[2]} );
end; 
 
private.toriver_active_clouds = {1,1}; 
function private.toriver_off_clouds() 
  ld.Lock(1);
  for i=1,2,1 do 
    local cur_ij = private.toriver_get_obj_pos_on_field(20+i);
    ng_global.progress["std"]["win_toriver"].state[cur_ij[1] ][cur_ij[2] ] = 0;
    ObjAnimate( "obj_toriver_cloud"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
    ObjSet( "anm_toriver_cloud"..i, {playing = 0} );
  end;  
 -- ld.StartTimer( 0.4, function() ld.Lock(0);private.toriver_stand_on_pos(); end )
end;  
 
 
function private.toriver_attack(num)
  local func_end = function()
    public.Reset();
    ld.LockCustom("toriver_attack",0);    
  end;  
  ld.LockCustom("toriver_attack",1);
  if num == 11 or num == 12 then
    ld.AnimPlay( "anm_toriver_anm_toriver_dead", "dead",function() end )
    ObjAnimate( "obj_toriver_girl_root", 8, 0, 0, function() end, {0,0,1, 0.6,0,1, 0.7,0,0} );
    local buf=1;
    if ng_global.progress["std"]["win_toriver"].state[8][num-10]==-1 then buf = 2; end;
    ObjSet( "anm_toriver_bat"..(num-10), {animfunc = "atack_bat"..buf, frame = 0, playing=0 } );
    ld.AnimPlay( "anm_toriver_bat"..(num-10), "atack_bat"..buf, function() end )
    ld.StartTimer( 1, func_end ) 
    SoundSfx( "aud_mg_toriver_bats_kill" );
  elseif num==21 or num ==22 then 
    ld.AnimPlay( "anm_toriver_anm_toriver_dead", "dead", function() end )
    ObjAnimate( "obj_toriver_girl_root", 8, 0, 0, function() end, {0,0,1, 0.6,0,1, 0.7,0,0} );
    ObjSet( "anm_toriver_cloud"..(num-20), {animfunc = "atack_cloud", frame = 0, playing=0} );
    ld.AnimPlay( "anm_toriver_cloud"..(num-20), "atack_cloud", function() end )
    ld.StartTimer( 1, func_end )  
    SoundSfx( "aud_mg_toriver_clouds_kill" )
  end;  
end;  


private.toriver_parts_move_step={0,0,0,0}
function private.toriver_parts_move(num)

  local pars_num_array = {11,12,21,22};
  local parts_names_array = {"obj_toriver_bat1","obj_toriver_bat2","obj_toriver_cloud1","obj_toriver_cloud2"};
  local move_ar={1,1};
  if num<3 then 
    move_ar={1,0};
  else 
    move_ar={0,1};
  end; 
 
  --ld.LogTrace( "move_ar = "..move_ar[1].." "..move_ar[2] );
  
  local cur_pos=private.toriver_get_obj_pos_on_field(pars_num_array[num]);
  local napr = ng_global.progress["std"]["win_toriver"].state[8][num] 
 
  move_ar = {move_ar[1]*napr,move_ar[2]*napr};
  
  local func_end = function()
     private.toriver_parts_move_step[num]=private.toriver_parts_move_step[num]-1;
     if  private.toriver_parts_move_step[num]<=0 then 
       ld.Lock(0);
     else
       private.toriver_parts_move(num);
     end; 
  end;  
  
  if (cur_pos[1]+move_ar[1])<1 or (cur_pos[1]+move_ar[1])>7 or  (cur_pos[2]+move_ar[2])<1 or (cur_pos[2]+move_ar[2])>7 then --smena napr
       ng_global.progress["std"]["win_toriver"].state[8][num] = napr*(-1);
     --  ld.LogTrace( "smena napr "..parts_names_array[num] );
       if num<3 then 
        --local bat_ar = {2,1}
        local buf=1;
        if ng_global.progress["std"]["win_toriver"].state[8][num]==-1 then buf=2 end;
        ObjSet( "anm_toriver_bat"..num,{animfunc = "static_bat"..buf, playing=1})
      end;  
      
       private.toriver_parts_move(num);
  else 
       local loc_func_end = function()
           if ng_global.progress["std"]["win_toriver"].state[cur_pos[1]+move_ar[1] ][cur_pos[2]+move_ar[2] ]==1 then 
              private.toriver_attack(pars_num_array[num]);
           else 
             ng_global.progress["std"]["win_toriver"].state[cur_pos[1] ][cur_pos[2] ] = 0;
             ng_global.progress["std"]["win_toriver"].state[cur_pos[1]+move_ar[1] ][cur_pos[2]+move_ar[2] ] = pars_num_array[num] ;
             func_end();
           end;  
       end;
       
       ld.Lock(1);
       local st_p= private.toriver_get_coord(cur_pos[1],cur_pos[2]);
       local next_p = private.toriver_get_coord(cur_pos[1]+move_ar[1],cur_pos[2]+move_ar[2]);
       
       --SoundSfx( parts_names_array_sounds[num] );
       ObjAnimate( parts_names_array[num], 3, 0, 0, loc_func_end, {0,0,st_p[1],st_p[2], 0.5,0,next_p[1],next_p[2]} );
  end;  
end;  


function private.toriver_parts_startmove()
  local pars_num_array = {11,12,21,22};
  private.toriver_parts_move_step={3,3,4,4}
   local parts_names_array_sounds = {"aud_mg_toriver_bats_move","aud_mg_toriver_bats_move","aud_mg_toriver_clouds_move","aud_mg_toriver_clouds_move"};

  for i=1,4,1 do 
  -- if i<3 then 
  --    --local bat_ar = {2,1}
  --    local buf=2;
  --    if ng_global.progress["std"]["win_toriver"].state[8][i] ==-1 then buf=1 end;
  --    ObjSet( "anm_toriver_bat"..i,{animfunc = "static_bat"..buf, playing=1})
  --  end;
    
    local cur_pos=private.toriver_get_obj_pos_on_field(pars_num_array[i]);
    if cur_pos[1]~=0 then 
    private.toriver_parts_move(i);
      if i==1 or i==3 then
      SoundSfx( parts_names_array_sounds[i] ); 
      end
    end;
  end;  
  
end;  

--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_toriver"} ) then
    SoundMgTheme( true )
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( {"win_toriver"} ) then
    cmn.MiniGameShow( "toriver" );
  end
  private.toriver_first_init();
  SoundEnv( "aud_bytheriver_env" )
  SoundEnv("aud_mg_toriver_bats_env",1);
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_toriver"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "toriver" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
     local parts_names_array = {"obj_toriver_bat1","obj_toriver_bat2","obj_toriver_cloud1","obj_toriver_cloud2"};
     for i=1,4,1 do 
       ObjStopAnimate(parts_names_array[i],3);  
     end;  
     ng_global.progress["std"]["win_toriver"].state = ld.TableCopy(private.toriver_fp_array);
   --  ObjSet( "anm_toriver_bat1", {playing=0} );
   --  ObjSet( "anm_toriver_bat2", {playing=0} );
     
     private.toriver_stand_on_pos();
     ObjAnimate( "obj_toriver_mg_root", 8, 0, 0, function() ld.LockCustom("toriver_reset",0);  end, {0,0,0, 0.3,0,1} );
  end;  
  
  ld.LockCustom("toriver_reset",1);  
  ObjAnimate( "obj_toriver_mg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
  
end;
--*********************************************************************************************************************
function public.Skip()

 local func_end = function()
    ng_global.progress["std"]["win_toriver"].state = {
    {0,11,0,1,0,0,0},
    {0,0,0,0,0,22,0},
    {0,0,0,0,0,9,0},
    {0,0,9,3,0,0,0},
    {0,0,0,0,9,0,0},
    {0,21,0,0,0,0,0},
    {0,0,0,0,0,0,12},
    {1,-1,1,-1} --napr array
}
    private.toriver_stand_on_pos(1);
    ObjAnimate( "obj_toriver_mg_root", 8, 0, 0, function() private.Win(); end, {0,0,0, 0.3,0,1} );
 end;  
 
 ld.Lock(1);
 ObjAnimate( "obj_toriver_mg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  -- ld.Lock(0);
  cmn.SetEventDone( "win_toriver" );
  cmn.CallEventHandler( "win_toriver" );
  -- if common_impl.ZzCompleteCheck( "win_toriver" ) then 
  ld.StartTimer( 0.5, function() ld.Lock(0); cmn.GotoRoom( "rm_bytheriver" ); end );  
  --cmn.GotoRoom( "rm_bytheriver" );-- end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_toriver"].state then
      --gm.state = ld.TableCopy( ng_global.progress["std"]["win_toriver"].state )
    else  
      ng_global.progress["std"]["win_toriver"].state = ld.TableCopy(private.toriver_fp_array);
    end
  
    gm.loaded  = true;
  else
  
  end;
  
  private.toriver_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_toriver"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;