-- name=rm_balcony
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_balcony";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_balcony()
  if not ( cmn.IsEventDone( "opn_balcony" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_balcony" );
      cmn.CallEventHandler( "opn_balcony" )
      ld.ShowBbtOpn( private.room_objname )
      public.clk_outro1()
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_balcony = function() end;
local opn_balcony_logic = function() end;
cmn.AddSubscriber( "opn_balcony", opn_balcony_logic )
cmn.AddSubscriber( "opn_balcony", opn_balcony, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outro1" ] = { type = "click", use_place = "gfx_balcony_clk_outro1_zone", room = "rm_balcony" };

private.clk_outro1_logic = function()
    ObjSet( "gfx_balcony_dlg_balcony_lord1_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_outro1_beg = function()
  ObjDelete( "gfx_balcony_clk_outro1_zone" );
end;
private.clk_outro1_end = function()
  ObjDelete("vid_balcony_vid_outro");
  ObjSet("spr_balcony_lord",{alp=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outro1", private.clk_outro1_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro1", private.clk_outro1_end, private.room_objname );
cmn.AddSubscriber( "clk_outro1", private.clk_outro1_logic );
cmn.AddSubscriber( "clk_outro1_beg", private.clk_outro1_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro1_end", private.clk_outro1_end, private.room_objname );
cmn.AddSubscriber( "clk_outro1_end", private.clk_outro1_logic );
--------------------------------------------------------------------------------------------
function public.clk_outro1()


  local func_end = function()
     ld.ShowBbt("after_outro_lvl1");
     cmn.SetEventDone( "clk_outro1" );
     cmn.CallEventHandler( "clk_outro1_end" );
     SoundTheme( "aud_adventure2_mus" );
     public.dlg_balcony_lord1( obj );
  end;  



  local func_preend = function()
    SoundVoice(0);
   
      VidPause("vid_balcony_vid_outro",1)
      ObjSet("spr_balcony_lord",{alp=1})
      ObjAnimate( "vid_balcony_vid_outro", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
      int.DialogVideoHide();
      --if  IsSurveyEdition() or IsDemoEdition()  then --IsSurveyEdition() or
      -- 
      --  cmn.GotoRoom("rm_outro");
      --  
      --else
      
      if (iOS_IsBought() == 0) then
        
        cmn.SetEventDone( "clk_outro1" );
        iOS_LogEvents(1);
        common.LevelSwitch("menu","unlock");
        
      else
     
        local widget_settings = 
           {
             InterfaceWidget_Inventory,
             InterfaceWidget_BtnHint,
             InterfaceWidget_BtnGuide,
             InterfaceWidget_BtnMenu,
             InterfaceWidget_BtnMap,
           }

        for i = 1, #widget_settings do
          interface.WidgetSetVisible( widget_settings[i], 1, true );
        end;  
        ld.StartTimer( 0.5, func_end )
        SoundEnv( "aud_balcony_env" );
        
      end;  
        --cmn.GotoRoom("rm_ruralroad");
     --end
  end;

  cmn.CallEventHandler( "clk_outro1_beg" );
 
  
  SoundTheme( 0 )
  SoundEnv(0);
  
  ld.Lock(1);
  ObjSet( "vid_balcony_vid_outro", {alp=0} );
  ObjAttach("vid_balcony_vid_outro","rm_balcony");
  ObjAnimate( "vid_balcony_vid_outro", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  SoundVid("aud_clk_outro1_balcony");
  VidPlay("vid_balcony_vid_outro",func_preend);
  SoundVoice("aud_clk_outro1_balcony_voc");
  
       local widget_settings = 
          {
            InterfaceWidget_Inventory,
            InterfaceWidget_BtnHint,
            InterfaceWidget_BtnGuide,
            InterfaceWidget_BtnMenu,
            InterfaceWidget_BtnMap,
          }

       for i = 1, #widget_settings do
         interface.WidgetSetVisible( widget_settings[i], 0, false );
       end;  
  
    int.DialogVideoShow( "", 1, func_preend, 1 ); 
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "lord1" then
    if count_txt == 1 then
      
    elseif count_txt == 2 then    
      
    elseif count_txt == 3 then 
      
    end;  
  end
end;


common_impl.hint[ "dlg_balcony_lord1" ] = { type = "click", use_place = "gfx_balcony_dlg_balcony_lord1_zone", room = "rm_balcony" };

private.dlg_balcony_lord1_logic = function()
    ObjSet( "gzz_balcony_oldchest", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gzz_balcony_gryphon", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gzz_balcony_leaves", { visible = 1, input = 1, active = 1 } )   
   ObjSet("gfx_livingroom_clk_incellaranm_zone", { visible = 1, input = 1, active = 1 }) 
   --2lvl
   ObjSet("gfx_tohome_traderaddress", { visible = 1, input = 1, active = 1 }) 
   ObjSet("gfx_bedroomboy_notebook_zone", { visible = 1, input = 1, active = 1 }) 
   ObjSet("gzz_housedoctor_nursery", { visible = 1, input = 1, active = 1 })
   ObjDelete("obj_nearhouse_childroom_clk_zone")
   ObjDelete("obj_livingroom_cellar_clk_zone")
end;
private.dlg_balcony_lord1_beg = function()
  ObjDelete( "gfx_balcony_dlg_balcony_lord1_zone" );
end;
private.dlg_balcony_lord1_end = function()
  ObjDelete("spr_balcony_lord")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_balcony_lord1", private.dlg_balcony_lord1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_balcony_lord1", private.dlg_balcony_lord1_end, private.room_objname );
cmn.AddSubscriber( "dlg_balcony_lord1", private.dlg_balcony_lord1_logic );
cmn.AddSubscriber( "dlg_balcony_lord1_beg", private.dlg_balcony_lord1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_balcony_lord1_end", private.dlg_balcony_lord1_end, private.room_objname );
cmn.AddSubscriber( "dlg_balcony_lord1_end", private.dlg_balcony_lord1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_balcony_lord1( obj )

  local func_end = function()
    cmn.SetEventDone( "clk_outro1" );
    cmn.SetEventDone( "dlg_balcony_lord1" );
    cmn.CallEventHandler( "dlg_balcony_lord1_end" );
    
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_lord1");
  end;

  function public.dlg_balcony_lord1_end()
    ObjSet( "dlg_balcony_lord1", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
  
  cmn.CallEventHandler( "dlg_balcony_lord1_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

  common_impl.dialog_character_loc = "spr_balcony_lord"
  common_impl.continue_visible = false;
  common_impl.Start( "lord1", 3, nil, nil, true, "dlg_balcony_lord1_end",{"aud_lord_lankerman_1_voc","aud_lord_lankerman_2_voc"} );
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_leaves *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_eliminating" ] = { type = "click", use_place = "gfx_leaves_clk_eliminating_zone", room = "rm_balcony", zz = "zz_leaves", zz_gate = "gzz_balcony_leaves" };

private.clk_eliminating_logic = function()
  if cmn.IsEventDone( "clk_eliminating" ) then   
    ObjSet( "gfx_leaves_clk_portrait_zone", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_leaves_fork1", { visible = 1, input = 1, active = 1 } )
  end
end;
private.clk_eliminating_beg = function()
  if cmn.IsEventDone( "clk_eliminating" ) then 
    ObjDelete( "gfx_leaves_clk_eliminating_zone" );
  end
end;
private.clk_eliminating_end = function()
  if cmn.IsEventDone( "clk_eliminating" ) then  
    ObjDelete( "gfx_leaves_clk_eliminating_zone" ); 
    ObjSet( "gfx_leaves_fork1", {visible = 1} );
    ObjSet( "gfx_leaves_portrait", {visible = 1} );    
    ObjDelete("spr_balcony_leaves1")
    for i=1,3 do
      ObjDelete("anm_leaves_anm_click_leaves"..i)
    end      
    if common_impl.ZzCompleteCheck("clk_eliminating") then ObjSet( common_impl.hint["clk_eliminating"].zz_gate, { visible = 0, input = 0 } ); end;
  elseif ng_global.progress["std"]["clk_eliminating"].state then
    for i=1,ng_global.progress["std"]["clk_eliminating"].state do
      ObjDelete("anm_leaves_anm_click_leaves"..i)
    end  
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_eliminating", private.clk_eliminating_beg, private.room_objname );
cmn.AddSubscriber( "clk_eliminating", private.clk_eliminating_end, private.room_objname );
cmn.AddSubscriber( "clk_eliminating", private.clk_eliminating_logic );
cmn.AddSubscriber( "clk_eliminating_beg", private.clk_eliminating_beg, private.room_objname );
cmn.AddSubscriber( "clk_eliminating_end", private.clk_eliminating_end, private.room_objname );
cmn.AddSubscriber( "clk_eliminating_end", private.clk_eliminating_logic );
--------------------------------------------------------------------------------------------
function public.clk_eliminating()

  local func_end = function()
    ng_global.progress["std"]["clk_eliminating"].state = ng_global.progress["std"]["clk_eliminating"].state + 1    
    if ng_global.progress["std"]["clk_eliminating"].state == 3 then
      cmn.SetEventDone( "clk_eliminating" );
    end
    cmn.CallEventHandler( "clk_eliminating_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_eliminating") then ld.CloseSubRoom() end;
  end;
  if not ng_global.progress["std"]["clk_eliminating"].state then 
    ng_global.progress["std"]["clk_eliminating"].state = 0
    cmn.SetEventStart("clk_eliminating")
  end
  local num = ng_global.progress["std"]["clk_eliminating"].state + 1
  cmn.CallEventHandler( "clk_eliminating_beg" );
  common_impl.Lock(1);
  ld.AnimPlay( "anm_leaves_anm_click_leaves"..num, "click_leaves"..num, func_end );

  SoundSfx( "aud_clk_eliminating_balcony" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_portrait" ] = { type = "click", use_place = "gfx_leaves_clk_portrait_zone", room = "rm_balcony", zz = "zz_leaves", zz_gate = "gzz_balcony_leaves" };

private.clk_portrait_logic = function()
  if cmn.IsEventDone( "clk_portrait" ) then   
    ObjSet( "spr_leaves_portrait_big", { visible = 1, input = 1, active = 1 } )
    if not cmn.IsEventDone("use_fang") then 
      ObjSet( "gfx_leaves_fang_zone", {active= 0, input=0, visible=0 } );
    end;  
  end
end;
private.clk_portrait_beg = function()
  ObjDelete("gfx_leaves_clk_portrait_zone");
end;
private.clk_portrait_end = function()
  ObjDelete("anm_leaves_anm_portrait");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_portrait", private.clk_portrait_beg, private.room_objname );
cmn.AddSubscriber( "clk_portrait", private.clk_portrait_end, private.room_objname );
cmn.AddSubscriber( "clk_portrait", private.clk_portrait_logic );
cmn.AddSubscriber( "clk_portrait_beg", private.clk_portrait_beg, private.room_objname );
cmn.AddSubscriber( "clk_portrait_end", private.clk_portrait_end, private.room_objname );
cmn.AddSubscriber( "clk_portrait_end", private.clk_portrait_logic );
--------------------------------------------------------------------------------------------
function public.clk_portrait()

  local func_end = function()
    cmn.SetEventDone( "clk_portrait" );
    cmn.CallEventHandler( "clk_portrait_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_portrait") then ld.CloseSubRoom() end;
    ld.ShowBbt("portait_clk");
  end;
 
  cmn.CallEventHandler( "clk_portrait_beg" );
  common_impl.Lock(1);
  --func_end();
  ObjSet( "anm_leaves_anm_portrait", {pos_z = 40} );
  ld.AnimPlay( "anm_leaves_anm_portrait", "portrait_big", func_end )
  SoundSfx( "aud_get_portrait_balcony" );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_portrait" ] = { type = "get", get_obj = "spr_leaves_portrait_big", room = "rm_balcony", zz = "zz_leaves", zz_gate = "gzz_balcony_leaves" };

private.get_portrait_logic = function()
  if not cmn.IsEventDone("use_fang") then 
    ObjSet( "gfx_leaves_fang_zone", {active= 1, input=1, visible=1 } );
  end;  
end;
private.get_portrait_inv = function()
  interface.InventoryItemAdd("inv_portrait","spr_leaves_portrait_big");
end;
private.get_portrait_beg = function()
  ObjDelete("gfx_leaves_portrait")
end;
private.get_portrait_end = function()
  ObjDelete("spr_balcony_portrait")
  if common_impl.ZzCompleteCheck("get_portrait") then ObjSet( common_impl.hint["get_portrait"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_portrait", private.get_portrait_inv );
cmn.AddSubscriber( "get_portrait", private.get_portrait_beg, private.room_objname );
cmn.AddSubscriber( "get_portrait", private.get_portrait_end, private.room_objname );
cmn.AddSubscriber( "get_portrait", private.get_portrait_logic );
--------------------------------------------------------------------
function public.get_portrait()
  
  cmn.SetEventDone( "get_portrait" );
  cmn.CallEventHandler( "get_portrait" );
  if common_impl.ZzCompleteCheck("get_portrait") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fork1" ] = { type = "get", get_obj = "spr_leaves_fork1", room = "rm_balcony", zz = "zz_leaves", zz_gate = "gzz_balcony_leaves" };

private.get_fork1_logic = function()
  
end;
private.get_fork1_inv = function()
  interface.InventoryItemAdd("inv_fork","spr_leaves_fork1",function() level_inv.ProcessGetForkAll( "get_fork1" ) end);
end;
private.get_fork1_beg = function()
  ObjDelete("gfx_leaves_fork1")
end;
private.get_fork1_end = function()
  ObjDelete("spr_leaves_sh_fork1")  
  ObjDelete("spr_balcony_fork1")
  if common_impl.ZzCompleteCheck("get_fork1") then ObjSet( common_impl.hint["get_fork1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fork1", private.get_fork1_inv );
cmn.AddSubscriber( "get_fork1", private.get_fork1_beg, private.room_objname );
cmn.AddSubscriber( "get_fork1", private.get_fork1_end, private.room_objname );
cmn.AddSubscriber( "get_fork1", private.get_fork1_logic );
--------------------------------------------------------------------
function public.get_fork1()
  cmn.SetEventDone( "get_fork1" );
  cmn.CallEventHandler( "get_fork1" );
  if common_impl.ZzCompleteCheck("get_fork1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fang" ] = { type = "use", inv_obj = "inv_fang", use_place = "gfx_leaves_fang_zone", room = "rm_balcony", zz = "zz_leaves", zz_gate = "gzz_balcony_leaves" };

private.use_fang_logic = function()
  ObjSet( "spr_leaves_raggedshawl", { visible = 1, input = 1, active = 1 } )
end;
private.use_fang_inv = function()
  common_impl.ProcessMultiUseAll("fang", "fang")
end;
private.use_fang_beg = function()
  ObjDelete( "gfx_leaves_fang_zone" );
end;
private.use_fang_end = function()
  ObjSet("anm_leaves_anm_use_fang",{animfunc="end_fang1",frame=0})
  ObjSet( "gfx_leaves_raggedshawl", {visible = 1} );
  ObjDelete("spr_balcony_stone")
  if common_impl.ZzCompleteCheck("use_fang") then ObjSet( common_impl.hint["use_fang"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fang", private.use_fang_inv );
cmn.AddSubscriber( "use_fang", private.use_fang_beg, private.room_objname );
cmn.AddSubscriber( "use_fang", private.use_fang_end, private.room_objname );
cmn.AddSubscriber( "use_fang", private.use_fang_logic );
cmn.AddSubscriber( "use_fang_inv", private.use_fang_inv, private.room_objname );
cmn.AddSubscriber( "use_fang_beg", private.use_fang_beg, private.room_objname );
cmn.AddSubscriber( "use_fang_end", private.use_fang_end, private.room_objname );
cmn.AddSubscriber( "use_fang_end", private.use_fang_logic );
--------------------------------------------------------------------------------------------
function public.use_fang( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fang" );
    cmn.CallEventHandler( "use_fang_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fang") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fang_inv" );
  cmn.CallEventHandler( "use_fang_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_leaves_anm_use_fang", "use_fang", func_end );
  SoundSfx( "aud_use_fang_balcony" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_raggedshawl" ] = { type = "get", get_obj = "spr_leaves_raggedshawl", room = "rm_balcony", zz = "zz_leaves", zz_gate = "gzz_balcony_leaves" };

private.get_raggedshawl_logic = function()
  
end;
private.get_raggedshawl_inv = function()
  interface.InventoryItemAdd("inv_raggedshawl","spr_leaves_raggedshawl");
end;
private.get_raggedshawl_beg = function()
  ObjDelete("gfx_leaves_raggedshawl")
end;
private.get_raggedshawl_end = function()
   ObjDelete("spr_leaves_sh_raggedshawl")    
   ObjDelete("spr_balcony_raggedshawl")
  if common_impl.ZzCompleteCheck("get_raggedshawl") then ObjSet( common_impl.hint["get_raggedshawl"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_raggedshawl", private.get_raggedshawl_inv );
cmn.AddSubscriber( "get_raggedshawl", private.get_raggedshawl_beg, private.room_objname );
cmn.AddSubscriber( "get_raggedshawl", private.get_raggedshawl_end, private.room_objname );
cmn.AddSubscriber( "get_raggedshawl", private.get_raggedshawl_logic );
--------------------------------------------------------------------
function public.get_raggedshawl()
  cmn.SetEventDone( "get_raggedshawl" );
  cmn.CallEventHandler( "get_raggedshawl" );
  if common_impl.ZzCompleteCheck("get_raggedshawl") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_gryphon *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_royallily" ] = { type = "get", get_obj = "spr_gryphon_royallily", room = "rm_balcony", zz = "zz_gryphon", zz_gate = "gzz_balcony_gryphon" };

private.get_royallily_logic = function()
  
end;
private.get_royallily_inv = function()
  interface.InventoryItemAdd("inv_royallily","spr_gryphon_royallily");
end;
private.get_royallily_beg = function()
  ObjDelete("gfx_gryphon_royallily")
end;
private.get_royallily_end = function()
  ObjDelete("spr_gryphon_sh_royallily")
  ObjDelete("spr_balcony_royallily_leo")
  if common_impl.ZzCompleteCheck("get_royallily") then ObjSet( common_impl.hint["get_royallily"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_royallily", private.get_royallily_inv );
cmn.AddSubscriber( "get_royallily", private.get_royallily_beg, private.room_objname );
cmn.AddSubscriber( "get_royallily", private.get_royallily_end, private.room_objname );
cmn.AddSubscriber( "get_royallily", private.get_royallily_logic );
--------------------------------------------------------------------
function public.get_royallily()
  cmn.SetEventDone( "get_royallily" );
  cmn.CallEventHandler( "get_royallily" );
  if common_impl.ZzCompleteCheck("get_royallily") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_necklace" ] = { type = "use", inv_obj = "inv_necklace", use_place = "gfx_gryphon_necklace_zone", room = "rm_balcony", zz = "zz_gryphon", zz_gate = "gzz_balcony_gryphon" };

private.use_necklace_logic = function()
  ObjSet( "spr_gryphon_fang", { visible = 1, input = 1, active = 1 } )

end;
private.use_necklace_inv = function()
  common_impl.ProcessMultiUseAll("necklace", "necklace")
end;
private.use_necklace_beg = function()
  ObjDelete( "gfx_gryphon_necklace_zone" );
end;
private.use_necklace_end = function()
  ObjSet("anm_gryphon_anm_necklace",{animfunc="end_ring1",frame=0})
  ObjSet( "spr_balcony_ring", {alp = 1} );
  ObjSet("spr_balcony_open_leo",{alp=1})
  ObjSet("spr_balcony_fang",{alp=1})
  ObjDelete("spr_balcony_door_leo")
  if common_impl.ZzCompleteCheck("use_necklace") then ObjSet( common_impl.hint["use_necklace"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_necklace", private.use_necklace_inv );
cmn.AddSubscriber( "use_necklace", private.use_necklace_beg, private.room_objname );
cmn.AddSubscriber( "use_necklace", private.use_necklace_end, private.room_objname );
cmn.AddSubscriber( "use_necklace", private.use_necklace_logic );
cmn.AddSubscriber( "use_necklace_inv", private.use_necklace_inv, private.room_objname );
cmn.AddSubscriber( "use_necklace_beg", private.use_necklace_beg, private.room_objname );
cmn.AddSubscriber( "use_necklace_end", private.use_necklace_end, private.room_objname );
cmn.AddSubscriber( "use_necklace_end", private.use_necklace_logic );
--------------------------------------------------------------------------------------------
function public.use_necklace( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_necklace" );
    cmn.CallEventHandler( "use_necklace_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_necklace") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_necklace_inv" );
  cmn.CallEventHandler( "use_necklace_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_gryphon_anm_necklace", "use_ring", func_end );
  SoundSfx( "aud_use_necklace_balcony" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fang" ] = { type = "get", get_obj = "spr_gryphon_fang", room = "rm_balcony", zz = "zz_gryphon", zz_gate = "gzz_balcony_gryphon" };

private.get_fang_logic = function()
  
end;
private.get_fang_inv = function()
  interface.InventoryItemAdd("inv_fang","spr_gryphon_fang");
end;
private.get_fang_beg = function()
  ObjDelete("gfx_gryphon_fang")
end;
private.get_fang_end = function()
  if common_impl.ZzCompleteCheck("get_fang") then ObjSet( common_impl.hint["get_fang"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_gryphon_sh_fang");
  ObjDelete("spr_balcony_fang")
end;

cmn.AddSubscriber( "get_fang", private.get_fang_inv );
cmn.AddSubscriber( "get_fang", private.get_fang_beg, private.room_objname );
cmn.AddSubscriber( "get_fang", private.get_fang_end, private.room_objname );
cmn.AddSubscriber( "get_fang", private.get_fang_logic );
--------------------------------------------------------------------
function public.get_fang()
  cmn.SetEventDone( "get_fang" );
  cmn.CallEventHandler( "get_fang" );
  if common_impl.ZzCompleteCheck("get_fang") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_gryphoneye" ] = { type = "use", inv_obj = "inv_gryphoneye", use_place = "gfx_gryphon_gryphoneye_zone", room = "rm_balcony", zz = "zz_gryphon", zz_gate = "gzz_balcony_gryphon" };

private.use_gryphoneye_logic = function()
  ObjSet( "spr_gryphon_lever", { visible = 1, input = 1, active = 1 } )

end;
private.use_gryphoneye_inv = function()
  common_impl.ProcessMultiUseAll("gryphoneye", "gryphoneye")
end;
private.use_gryphoneye_beg = function()
  ObjDelete( "gfx_gryphon_gryphoneye_zone" );
end;
private.use_gryphoneye_end = function()
  ObjSet("anm_gryphon_anm_eye",{animfunc="end_eye1",frame=0})
  ObjSet("spr_balcony_eye",{alp=1})
  ObjSet("spr_balcony_lever",{alp=1})
  ObjSet( "spr_balcony_tr_mouth", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_gryphoneye") then ObjSet( common_impl.hint["use_gryphoneye"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_gryphoneye", private.use_gryphoneye_inv );
cmn.AddSubscriber( "use_gryphoneye", private.use_gryphoneye_beg, private.room_objname );
cmn.AddSubscriber( "use_gryphoneye", private.use_gryphoneye_end, private.room_objname );
cmn.AddSubscriber( "use_gryphoneye", private.use_gryphoneye_logic );
cmn.AddSubscriber( "use_gryphoneye_inv", private.use_gryphoneye_inv, private.room_objname );
cmn.AddSubscriber( "use_gryphoneye_beg", private.use_gryphoneye_beg, private.room_objname );
cmn.AddSubscriber( "use_gryphoneye_end", private.use_gryphoneye_end, private.room_objname );
cmn.AddSubscriber( "use_gryphoneye_end", private.use_gryphoneye_logic );
--------------------------------------------------------------------------------------------
function public.use_gryphoneye( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_gryphoneye" );
    cmn.CallEventHandler( "use_gryphoneye_end" );
    public.get_lever()    
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_gryphoneye") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_gryphoneye_inv" );
  cmn.CallEventHandler( "use_gryphoneye_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_gryphon_anm_eye", "use_eye", func_end );
  SoundSfx( "aud_use_gryphoneye_balcony" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lever" ] = { type = "get", get_obj = "spr_gryphon_lever", room = "rm_balcony", zz = "zz_gryphon", zz_gate = "gzz_balcony_gryphon" };

private.get_lever_logic = function()
  
end;
private.get_lever_inv = function()
  interface.InventoryItemAdd("inv_lever","spr_gryphon_lever");
end;
private.get_lever_beg = function()
  ObjDelete("gfx_gryphon_lever")
end;
private.get_lever_end = function()
  ObjDelete("spr_balcony_lever")
  if common_impl.ZzCompleteCheck("get_lever") then ObjSet( common_impl.hint["get_lever"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lever", private.get_lever_inv );
cmn.AddSubscriber( "get_lever", private.get_lever_beg, private.room_objname );
cmn.AddSubscriber( "get_lever", private.get_lever_end, private.room_objname );
cmn.AddSubscriber( "get_lever", private.get_lever_logic );
--------------------------------------------------------------------
function public.get_lever()
  cmn.SetEventDone( "get_lever" );
  cmn.CallEventHandler( "get_lever" );
  if common_impl.ZzCompleteCheck("get_lever") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_oldchest *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_fork2" ] = { type = "get", get_obj = "spr_oldchest_fork2", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.get_fork2_logic = function()
  
end;
private.get_fork2_inv = function()
  interface.InventoryItemAdd("inv_fork","spr_oldchest_fork2",function() level_inv.ProcessGetForkAll( "get_fork2" ) end);
end;
private.get_fork2_beg = function()
  ObjDelete("gfx_oldchest_fork2")
end;
private.get_fork2_end = function()
  ObjDelete("spr_balcony_fork2")
  if common_impl.ZzCompleteCheck("get_fork2") then ObjSet( common_impl.hint["get_fork2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fork2", private.get_fork2_inv );
cmn.AddSubscriber( "get_fork2", private.get_fork2_beg, private.room_objname );
cmn.AddSubscriber( "get_fork2", private.get_fork2_end, private.room_objname );
cmn.AddSubscriber( "get_fork2", private.get_fork2_logic );
--------------------------------------------------------------------
function public.get_fork2()
  cmn.SetEventDone( "get_fork2" );
  cmn.CallEventHandler( "get_fork2" );
  if common_impl.ZzCompleteCheck("get_fork2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_royallily_zone_clk()  --rm_balcony.use_royallily_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_royallily' )  
  end;

   ld.Lock(1);  
   ld.AnimPlay( "anm_oldchest_anm_royal", "idle_cover2", func_end )
   SoundSfx( "aud_touch_very_small_metal" );
end;  


common_impl.hint[ "use_royallily" ] = { type = "use", inv_obj = "inv_royallily", use_place = "gfx_oldchest_royallily_zone", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.use_royallily_logic = function()
  -- ObjSet( "gfx_oldchest_win_flowers_zone", { visible = 1, input = 1, active = 1 } )
   ObjSet( "spr_oldchest_wire", { visible = 0, input = 1, active = 1 } )
   ObjSet( "gfx_oldchest_wire", { visible = 1, active = 1 } );
end;
private.use_royallily_inv = function()
  common_impl.ProcessMultiUseAll("royallily", "royallily")
end;
private.use_royallily_beg = function()
  ObjDelete( "gfx_oldchest_royallily_zone" );
end;
private.use_royallily_end = function()
  ObjDelete("spr_balcony_cov2")
  ObjSet("spr_balcony_royallily",{alp=1})
  ObjSet("spr_balcony_cov2open",{alp=1})  
  if common_impl.ZzCompleteCheck("use_royallily") then ObjSet( common_impl.hint["use_royallily"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_oldchest_anm_royal", {animfunc = "use_royallili", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_royallily", private.use_royallily_inv );
cmn.AddSubscriber( "use_royallily", private.use_royallily_beg, private.room_objname );
cmn.AddSubscriber( "use_royallily", private.use_royallily_end, private.room_objname );
cmn.AddSubscriber( "use_royallily", private.use_royallily_logic );
cmn.AddSubscriber( "use_royallily_inv", private.use_royallily_inv, private.room_objname );
cmn.AddSubscriber( "use_royallily_beg", private.use_royallily_beg, private.room_objname );
cmn.AddSubscriber( "use_royallily_end", private.use_royallily_end, private.room_objname );
cmn.AddSubscriber( "use_royallily_end", private.use_royallily_logic );
--------------------------------------------------------------------------------------------
function public.use_royallily( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_royallily" );
    cmn.CallEventHandler( "use_royallily_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_royallily") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_royallily_inv" );
  cmn.CallEventHandler( "use_royallily_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_oldchest_anm_royal", "use_royallili", func_end );
  SoundSfx( "aud_use_royallily_balcony" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "win_flowers" ] = { type = "click", use_place = "gfx_oldchest_win_flowers_zone", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };
--
--private.win_flowers_logic = function()
--  ObjSet( "spr_oldchest_wire", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.win_flowers_beg = function()
--  ObjDelete( "gfx_oldchest_win_flowers_zone" );
--end;
--private.win_flowers_end = function()
--  if common_impl.ZzCompleteCheck("win_flowers") then ObjSet( common_impl.hint["win_flowers"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "win_flowers", private.win_flowers_beg, private.room_objname );
--cmn.AddSubscriber( "win_flowers", private.win_flowers_end, private.room_objname );
--cmn.AddSubscriber( "win_flowers", private.win_flowers_logic );
--cmn.AddSubscriber( "win_flowers_beg", private.win_flowers_beg, private.room_objname );
--cmn.AddSubscriber( "win_flowers_end", private.win_flowers_end, private.room_objname );
--cmn.AddSubscriber( "win_flowers_end", private.win_flowers_logic );
----------------------------------------------------------------------------------------------
--function public.win_flowers()
--
--  local func_end = function()
--    cmn.SetEventDone( "win_flowers" );
--    cmn.CallEventHandler( "win_flowers_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("win_flowers") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "win_flowers_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  --SoundSfx( 0 )
--  func_end()
--
--end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wire" ] = { type = "get", get_obj = "spr_oldchest_wire", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.get_wire_logic = function()
  
end;
private.get_wire_inv = function()
  interface.InventoryItemAdd("inv_wire","spr_oldchest_wire");
end;
private.get_wire_beg = function()
  ObjDelete("gfx_oldchest_wire")
end;
private.get_wire_end = function()
  if common_impl.ZzCompleteCheck("get_wire") then ObjSet( common_impl.hint["get_wire"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_balcony_wire")
  ObjSet( "anm_oldchest_anm_royal", {animfunc = "end_royallili1", frame = 0 } );
end;

cmn.AddSubscriber( "get_wire", private.get_wire_inv );
cmn.AddSubscriber( "get_wire", private.get_wire_beg, private.room_objname );
cmn.AddSubscriber( "get_wire", private.get_wire_end, private.room_objname );
cmn.AddSubscriber( "get_wire", private.get_wire_logic );
--------------------------------------------------------------------
function public.get_wire()
  ObjSet( "spr_oldchest_wire", {visible = 1} );
  cmn.SetEventDone( "get_wire" );
  cmn.CallEventHandler( "get_wire" );
  if common_impl.ZzCompleteCheck("get_wire") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_lever_zone_clk()  -- rm_balcony.use_lever_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_lever' );
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_oldchest_anm_lever", "idle_cover1", func_end )
  SoundSfx( "aud_touch_very_small_metal" );
end;  




common_impl.hint[ "use_lever" ] = { type = "use", inv_obj = "inv_lever", use_place = "gfx_oldchest_lever_zone", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.use_lever_logic = function()
  ObjSet( "spr_oldchest_fork3", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_oldchest_fork3", {active = 1, visible = 1} );

end;
private.use_lever_inv = function()
  common_impl.ProcessMultiUseAll("lever", "lever")
end;
private.use_lever_beg = function()
  ObjDelete( "gfx_oldchest_lever_zone" );
end;
private.use_lever_end = function()
  ObjDelete("spr_balcony_cov1")
  ObjSet("spr_balcony_lever_chest",{alp=1})
  ObjSet("spr_balcony_cov1open",{alp=1}) 
  if common_impl.ZzCompleteCheck("use_lever") then ObjSet( common_impl.hint["use_lever"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_oldchest_anm_lever", {animfunc = "use_lever", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lever", private.use_lever_inv );
cmn.AddSubscriber( "use_lever", private.use_lever_beg, private.room_objname );
cmn.AddSubscriber( "use_lever", private.use_lever_end, private.room_objname );
cmn.AddSubscriber( "use_lever", private.use_lever_logic );
cmn.AddSubscriber( "use_lever_inv", private.use_lever_inv, private.room_objname );
cmn.AddSubscriber( "use_lever_beg", private.use_lever_beg, private.room_objname );
cmn.AddSubscriber( "use_lever_end", private.use_lever_end, private.room_objname );
cmn.AddSubscriber( "use_lever_end", private.use_lever_logic );
--------------------------------------------------------------------------------------------
function public.use_lever( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lever" );
    cmn.CallEventHandler( "use_lever_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lever") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lever_inv" );
  cmn.CallEventHandler( "use_lever_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_oldchest_anm_lever", "use_lever", func_end );
  SoundSfx( "aud_use_lever_balcony" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fork3" ] = { type = "get", get_obj = "spr_oldchest_fork3", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.get_fork3_logic = function()
  
end;
private.get_fork3_inv = function()
  interface.InventoryItemAdd("inv_fork","spr_oldchest_fork3",function() level_inv.ProcessGetForkAll( "get_fork3" ) end);
end;
private.get_fork3_beg = function()
  ObjDelete("gfx_oldchest_fork3")
end;
private.get_fork3_end = function()
  ObjDelete("spr_balcony_fork3")
  if common_impl.ZzCompleteCheck("get_fork3") then ObjSet( common_impl.hint["get_fork3"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_oldchest_anm_lever", {animfunc = "end_cover", frame = 0 } );
end;

cmn.AddSubscriber( "get_fork3", private.get_fork3_inv );
cmn.AddSubscriber( "get_fork3", private.get_fork3_beg, private.room_objname );
cmn.AddSubscriber( "get_fork3", private.get_fork3_end, private.room_objname );
cmn.AddSubscriber( "get_fork3", private.get_fork3_logic );
--------------------------------------------------------------------
function public.get_fork3()
  ObjSet( "spr_oldchest_fork3", {visible = 1 } );
  cmn.SetEventDone( "get_fork3" );
  cmn.CallEventHandler( "get_fork3" );
  if common_impl.ZzCompleteCheck("get_fork3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_bat_zone_clk()  --rm_balcony.use_bat_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_bat' )
  end;  
  
  ld.Lock(1);
  
  if cmn.IsEventDone("get_fork2") then 
     ld.AnimPlay( "anm_oldchest_anm_bat", "idle_cover", func_end )
     SoundSfx( "aud_touch_big_wood" );
  else   
     func_end();   
  end;   
end;  


common_impl.hint[ "use_bat" ] = { type = "use", inv_obj = "inv_bat", use_place = "gfx_oldchest_bat_zone", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.use_bat_logic = function()
  ObjSet( "spr_oldchest_spatula", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_oldchest_axe", { visible = 1, input = 1, active = 1 } )

end;
private.use_bat_inv = function()
  common_impl.ProcessMultiUseAll("bat", "bat")
end;
private.use_bat_beg = function()
  ObjDelete( "gfx_oldchest_bat_zone" );
end;
private.use_bat_end = function()
  if common_impl.ZzCompleteCheck("use_bat") then ObjSet( common_impl.hint["use_bat"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_oldchest_anm_bat", {animfunc = "end_bat", frame = 0 } );
  ObjSet( "spr_oldchest_spatula_sh", {visible = 1} );
  ObjSet( "spr_oldchest_axe_sh", {visible = 1} );
  ObjSet( "anm_oldchest_anm_trash", {visible = 1} );
  
  ObjSet("spr_balcony_open_chest",{alp=1})
  ObjSet("spr_balcony_axe",{alp=1})
  ObjSet("spr_balcony_spatula",{alp=1})   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bat", private.use_bat_inv );
cmn.AddSubscriber( "use_bat", private.use_bat_beg, private.room_objname );
cmn.AddSubscriber( "use_bat", private.use_bat_end, private.room_objname );
cmn.AddSubscriber( "use_bat", private.use_bat_logic );
cmn.AddSubscriber( "use_bat_inv", private.use_bat_inv, private.room_objname );
cmn.AddSubscriber( "use_bat_beg", private.use_bat_beg, private.room_objname );
cmn.AddSubscriber( "use_bat_end", private.use_bat_end, private.room_objname );
cmn.AddSubscriber( "use_bat_end", private.use_bat_logic );
--------------------------------------------------------------------------------------------
function public.use_bat( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bat" );
    cmn.CallEventHandler( "use_bat_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bat") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bat_inv" );
  cmn.CallEventHandler( "use_bat_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_oldchest_anm_bat", "use_bat", func_end );
  SoundSfx( "aud_use_bat_balcony" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_spatula" ] = { type = "get", get_obj = "spr_oldchest_spatula", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.get_spatula_logic = function()
  
end;
private.get_spatula_inv = function()
  interface.InventoryItemAdd("inv_spatula","spr_oldchest_spatula");
end;
private.get_spatula_beg = function()
  ObjDelete("gfx_oldchest_spatula")
end;
private.get_spatula_end = function()
  if common_impl.ZzCompleteCheck("get_spatula") then ObjSet( common_impl.hint["get_spatula"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_oldchest_spatula_sh")
  ObjDelete("spr_balcony_spatula")  
end;

cmn.AddSubscriber( "get_spatula", private.get_spatula_inv );
cmn.AddSubscriber( "get_spatula", private.get_spatula_beg, private.room_objname );
cmn.AddSubscriber( "get_spatula", private.get_spatula_end, private.room_objname );
cmn.AddSubscriber( "get_spatula", private.get_spatula_logic );
--------------------------------------------------------------------
function public.get_spatula()
  cmn.SetEventDone( "get_spatula" );
  cmn.CallEventHandler( "get_spatula" );
  if common_impl.ZzCompleteCheck("get_spatula") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_axe" ] = { type = "get", get_obj = "spr_oldchest_axe", room = "rm_balcony", zz = "zz_oldchest", zz_gate = "gzz_balcony_oldchest" };

private.get_axe_logic = function()
  
end;
private.get_axe_inv = function()
  interface.InventoryItemAdd("inv_axe","spr_oldchest_axe");
end;
private.get_axe_beg = function()
  ObjDelete("gfx_oldchest_axe")
end;
private.get_axe_end = function()
  if common_impl.ZzCompleteCheck("get_axe") then ObjSet( common_impl.hint["get_axe"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_oldchest_axe_sh");
  ObjDelete("spr_balcony_axe")
end;

cmn.AddSubscriber( "get_axe", private.get_axe_inv );
cmn.AddSubscriber( "get_axe", private.get_axe_beg, private.room_objname );
cmn.AddSubscriber( "get_axe", private.get_axe_end, private.room_objname );
cmn.AddSubscriber( "get_axe", private.get_axe_logic );
--------------------------------------------------------------------
function public.get_axe()
  cmn.SetEventDone( "get_axe" );
  cmn.CallEventHandler( "get_axe" );
  if common_impl.ZzCompleteCheck("get_axe") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_balcony();
  if cmn.IsEventDone("clk_outro1") and not cmn.IsEventDone("dlg_balcony_lord1") then
    ld.ShowBbt("after_outro_lvl1");
    SoundTheme( "aud_adventure2_mus" );
    public.dlg_balcony_lord1( obj );
  end;
end;
--*********************************************************************************************************************
function public.PreOpen()
  if cmn.IsEventDone("clk_outro1") then 
    SoundEnv( "aud_balcony_env" );
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_oldchest" );
  function zz_oldchest.Open()
  end;
  function zz_oldchest.PreOpen()
  end;
  function zz_oldchest.PreClose()
  end;
  function zz_oldchest.Close()
  end;

  subroom.Define( "zz_gryphon" );
  function zz_gryphon.Open()
  end;
  function zz_gryphon.PreOpen()
  end;
  function zz_gryphon.PreClose()
  end;
  function zz_gryphon.Close()
  end;

  subroom.Define( "zz_leaves" );
  function zz_leaves.Open()
  end;
  function zz_leaves.PreOpen()
  end;
  function zz_leaves.PreClose()
  end;
  function zz_leaves.Close()
  end;
  
end;
--*********************************************************************************************************************