-- name=rm_bytheriver
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_bytheriver";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("obj_yacht_text_mini","spr_yacht_text","yacht_page_clk");
  ld.NoteInit("spr_lordstatue_text_min","spr_lordstatue_text_big","lordstatue_page_clk");
  --------------------------------------------------------------------------------------------
function private.opn_bytheriver()
  if not ( cmn.IsEventDone( "opn_bytheriver" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_bytheriver" );
      cmn.CallEventHandler( "opn_bytheriver" )
      ld.ShowBbt( "opn_bytheriver" );
      SoundTheme( "aud_adventure2_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_bytheriver = function() end;
local opn_bytheriver_logic = function() end;
cmn.AddSubscriber( "opn_bytheriver", opn_bytheriver_logic )
cmn.AddSubscriber( "opn_bytheriver", opn_bytheriver, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_lordstatue *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_flag" ] = { type = "get", get_obj = "spr_lordstatue_flag", room = "rm_bytheriver", zz = "zz_lordstatue", zz_gate = "gzz_bytheriver_lordstatue" };

private.get_flag_logic = function()
  
end;
private.get_flag_inv = function()
  interface.InventoryItemAdd("inv_flag","spr_lordstatue_flag");
end;
private.get_flag_beg = function()
  ObjDelete("gfx_lordstatue_flag")
end;
private.get_flag_end = function()
  if common_impl.ZzCompleteCheck("get_flag") then ObjSet( common_impl.hint["get_flag"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_lordstatue_flag_sh");
end;

cmn.AddSubscriber( "get_flag", private.get_flag_inv );
cmn.AddSubscriber( "get_flag", private.get_flag_beg, private.room_objname );
cmn.AddSubscriber( "get_flag", private.get_flag_end, private.room_objname );
cmn.AddSubscriber( "get_flag", private.get_flag_logic );
--------------------------------------------------------------------
function public.get_flag()
  cmn.SetEventDone( "get_flag" );
  cmn.CallEventHandler( "get_flag" );
  if common_impl.ZzCompleteCheck("get_flag") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_stonebracelet_zone_clk()  -- rm_bytheriver.use_stonebracelet_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_stonebracelet' );
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay( "anm_lordstatue_anm_epaulet", "idle_epaulet", func_end )  
end;  

common_impl.hint[ "use_stonebracelet" ] = { type = "use", inv_obj = "inv_stonebracelet", use_place = "gfx_lordstatue_stonebracelet_zone", room = "rm_bytheriver", zz = "zz_lordstatue", zz_gate = "gzz_bytheriver_lordstatue" };

private.use_stonebracelet_logic = function()
  ObjSet( "spr_lordstatue_sail", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_lordstatue_sail", { active = 1, visible = 1} );
end;
private.use_stonebracelet_inv = function()
  common_impl.ProcessMultiUseAll("stonebracelet", "stonebracelet")
end;
private.use_stonebracelet_beg = function()
  ObjDelete( "gfx_lordstatue_stonebracelet_zone" );
end;
private.use_stonebracelet_end = function()
  if common_impl.ZzCompleteCheck("use_stonebracelet") then ObjSet( common_impl.hint["use_stonebracelet"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_lordstatue_anm_epaulet", {animfunc = "use_epaulet", frame = 999 } );
  ObjSet( "spr_bytheriver_epolet_m", {visible = 1} );
  ObjDelete("spr_bytheriver_hand_m");
  ObjSet( "spr_bytheriver_hand1_m", {visible = 1} );
  ObjSet( "spr_bytheriver_sail_m", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stonebracelet", private.use_stonebracelet_inv );
cmn.AddSubscriber( "use_stonebracelet", private.use_stonebracelet_beg, private.room_objname );
cmn.AddSubscriber( "use_stonebracelet", private.use_stonebracelet_end, private.room_objname );
cmn.AddSubscriber( "use_stonebracelet", private.use_stonebracelet_logic );
cmn.AddSubscriber( "use_stonebracelet_inv", private.use_stonebracelet_inv, private.room_objname );
cmn.AddSubscriber( "use_stonebracelet_beg", private.use_stonebracelet_beg, private.room_objname );
cmn.AddSubscriber( "use_stonebracelet_end", private.use_stonebracelet_end, private.room_objname );
cmn.AddSubscriber( "use_stonebracelet_end", private.use_stonebracelet_logic );
--------------------------------------------------------------------------------------------
function public.use_stonebracelet( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stonebracelet" );
    cmn.CallEventHandler( "use_stonebracelet_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stonebracelet") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stonebracelet_inv" );
  cmn.CallEventHandler( "use_stonebracelet_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lordstatue_anm_epaulet", "use_epaulet", func_end );
  SoundSfx( "aud_use_stonebracelet_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sail" ] = { type = "get", get_obj = "spr_lordstatue_sail", room = "rm_bytheriver", zz = "zz_lordstatue", zz_gate = "gzz_bytheriver_lordstatue" };

private.get_sail_logic = function()
  
end;
private.get_sail_inv = function()
  interface.InventoryItemAdd("inv_sail","spr_lordstatue_sail");
end;
private.get_sail_beg = function()
  ObjDelete("gfx_lordstatue_sail")
end;
private.get_sail_end = function()
  if common_impl.ZzCompleteCheck("get_sail") then ObjSet( common_impl.hint["get_sail"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_lordstatue_anm_epaulet", {animfunc = "end_epaulet", frame = 0 } );
  ObjDelete("spr_bytheriver_sail_m");
end;

cmn.AddSubscriber( "get_sail", private.get_sail_inv );
cmn.AddSubscriber( "get_sail", private.get_sail_beg, private.room_objname );
cmn.AddSubscriber( "get_sail", private.get_sail_end, private.room_objname );
cmn.AddSubscriber( "get_sail", private.get_sail_logic );
--------------------------------------------------------------------
function public.get_sail()
  ObjSet( "spr_lordstatue_sail", {visible = 1} );
  cmn.SetEventDone( "get_sail" );
  cmn.CallEventHandler( "get_sail" );
  if common_impl.ZzCompleteCheck("get_sail") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_twoswords_zone_clk()  -- rm_bytheriver.use_twoswords_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_twoswords' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_stone" );
  ld.AnimPlay( "anm_lordstatue_anm_twoswords", "idle_cover", func_end )  
end;  

common_impl.hint[ "use_twoswords" ] = { type = "use", inv_obj = "inv_twoswords", use_place = "gfx_lordstatue_twoswords_zone", room = "rm_bytheriver", zz = "zz_lordstatue", zz_gate = "gzz_bytheriver_lordstatue" };

private.use_twoswords_logic = function()
  ObjSet( "spr_lordstatue_goldcrow4", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_lordstatue_residencekey", { visible = 1, input = 1, active = 1 } )

end;
private.use_twoswords_inv = function()
  common_impl.ProcessMultiUseAll("twoswords", "twoswords")
end;
private.use_twoswords_beg = function()
  ObjDelete( "gfx_lordstatue_twoswords_zone" );
end;
private.use_twoswords_end = function()
  if common_impl.ZzCompleteCheck("use_twoswords") then ObjSet( common_impl.hint["use_twoswords"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_lordstatue_anm_twoswords");
  ObjSet( "spr_lordstatue_goldcrow4_sh", {visible = 1} );
  ObjSet( "spr_lordstatue_residencekey_sh", {visible = 1} );
  ObjDelete("spr_bytheriver_am_swords_m");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_twoswords", private.use_twoswords_inv );
cmn.AddSubscriber( "use_twoswords", private.use_twoswords_beg, private.room_objname );
cmn.AddSubscriber( "use_twoswords", private.use_twoswords_end, private.room_objname );
cmn.AddSubscriber( "use_twoswords", private.use_twoswords_logic );
cmn.AddSubscriber( "use_twoswords_inv", private.use_twoswords_inv, private.room_objname );
cmn.AddSubscriber( "use_twoswords_beg", private.use_twoswords_beg, private.room_objname );
cmn.AddSubscriber( "use_twoswords_end", private.use_twoswords_end, private.room_objname );
cmn.AddSubscriber( "use_twoswords_end", private.use_twoswords_logic );
--------------------------------------------------------------------------------------------
function public.use_twoswords( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_twoswords" );
    cmn.CallEventHandler( "use_twoswords_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_twoswords") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_twoswords_inv" );
  cmn.CallEventHandler( "use_twoswords_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lordstatue_anm_twoswords", "use_sward", func_end );
  SoundSfx( "aud_use_twoswords_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goldcrow4" ] = { type = "get", get_obj = "spr_lordstatue_goldcrow4", room = "rm_bytheriver", zz = "zz_lordstatue", zz_gate = "gzz_bytheriver_lordstatue" };

private.get_goldcrow4_logic = function()
  
end;
private.get_goldcrow4_inv = function()
  interface.InventoryItemAdd("inv_goldcrow","spr_lordstatue_goldcrow4",function() level_inv.ProcessGetGoldcrowAll( "get_goldcrow4" ) end);
end;
private.get_goldcrow4_beg = function()
  ObjDelete("gfx_lordstatue_goldcrow4")
end;
private.get_goldcrow4_end = function()
  if common_impl.ZzCompleteCheck("get_goldcrow4") then ObjSet( common_impl.hint["get_goldcrow4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_lordstatue_goldcrow4_sh");
  ObjDelete("spr_bytheriver_goldcrow4_m");
end;

cmn.AddSubscriber( "get_goldcrow4", private.get_goldcrow4_inv );
cmn.AddSubscriber( "get_goldcrow4", private.get_goldcrow4_beg, private.room_objname );
cmn.AddSubscriber( "get_goldcrow4", private.get_goldcrow4_end, private.room_objname );
cmn.AddSubscriber( "get_goldcrow4", private.get_goldcrow4_logic );
--------------------------------------------------------------------
function public.get_goldcrow4()
  cmn.SetEventDone( "get_goldcrow4" );
  cmn.CallEventHandler( "get_goldcrow4" );
  if common_impl.ZzCompleteCheck("get_goldcrow4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_residencekey" ] = { type = "get", get_obj = "spr_lordstatue_residencekey", room = "rm_bytheriver", zz = "zz_lordstatue", zz_gate = "gzz_bytheriver_lordstatue" };

private.get_residencekey_logic = function()
  
end;
private.get_residencekey_inv = function()
  interface.InventoryItemAdd("inv_residencekey","spr_lordstatue_residencekey");
end;
private.get_residencekey_beg = function()
  ObjDelete("gfx_lordstatue_residencekey")
end;
private.get_residencekey_end = function()
  if common_impl.ZzCompleteCheck("get_residencekey") then ObjSet( common_impl.hint["get_residencekey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_lordstatue_residencekey_sh")
  ObjDelete("spr_bytheriver_residencekey_m");
end;

cmn.AddSubscriber( "get_residencekey", private.get_residencekey_inv );
cmn.AddSubscriber( "get_residencekey", private.get_residencekey_beg, private.room_objname );
cmn.AddSubscriber( "get_residencekey", private.get_residencekey_end, private.room_objname );
cmn.AddSubscriber( "get_residencekey", private.get_residencekey_logic );
--------------------------------------------------------------------
function public.get_residencekey()
  cmn.SetEventDone( "get_residencekey" );
  cmn.CallEventHandler( "get_residencekey" );
  if common_impl.ZzCompleteCheck("get_residencekey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_residencedoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_flag_zone_clk()  --rm_bytheriver.use_flag_zone_clk()
    local func_end = function()
      common_impl.ShowBbt( 'need_flag' )
      ld.Lock(0);
    end;
  
    ld.Lock(1);
    SoundSfx( "aud_touch_small_metal" );
    ld.AnimPlay( "anm_residencedoor_anm_box", "idle_box", func_end )  
end


common_impl.hint[ "use_flag" ] = { type = "use", inv_obj = "inv_flag", use_place = "gfx_residencedoor_flag_zone", room = "rm_bytheriver", zz = "zz_residencedoor", zz_gate = "gzz_bytheriver_residencedoor" };

private.use_flag_logic = function()
  ObjSet( "spr_residencedoor_dancinggirl", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_residencedoor_dancinggirl", { active = 1, visible = 1} );
end;
private.use_flag_inv = function()
  common_impl.ProcessMultiUseAll("flag", "flag")
end;
private.use_flag_beg = function()
  ObjDelete( "gfx_residencedoor_flag_zone" );
end;
private.use_flag_end = function()
  if common_impl.ZzCompleteCheck("use_flag") then ObjSet( common_impl.hint["use_flag"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_residencedoor_anm_box", {animfunc = "use_flag", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_flag", private.use_flag_inv );
cmn.AddSubscriber( "use_flag", private.use_flag_beg, private.room_objname );
cmn.AddSubscriber( "use_flag", private.use_flag_end, private.room_objname );
cmn.AddSubscriber( "use_flag", private.use_flag_logic );
cmn.AddSubscriber( "use_flag_inv", private.use_flag_inv, private.room_objname );
cmn.AddSubscriber( "use_flag_beg", private.use_flag_beg, private.room_objname );
cmn.AddSubscriber( "use_flag_end", private.use_flag_end, private.room_objname );
cmn.AddSubscriber( "use_flag_end", private.use_flag_logic );
--------------------------------------------------------------------------------------------
function public.use_flag( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_flag" );
    cmn.CallEventHandler( "use_flag_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_flag") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_flag_inv" );
  cmn.CallEventHandler( "use_flag_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_residencedoor_anm_box", "use_flag", func_end );
  SoundSfx( "aud_use_flag_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dancinggirl" ] = { type = "get", get_obj = "spr_residencedoor_dancinggirl", room = "rm_bytheriver", zz = "zz_residencedoor", zz_gate = "gzz_bytheriver_residencedoor" };

private.get_dancinggirl_logic = function()
  
end;
private.get_dancinggirl_inv = function()
  interface.InventoryItemAdd("inv_dancinggirl","spr_residencedoor_dancinggirl");
end;
private.get_dancinggirl_beg = function()
  ObjDelete("gfx_residencedoor_dancinggirl")
end;
private.get_dancinggirl_end = function()
  if common_impl.ZzCompleteCheck("get_dancinggirl") then ObjSet( common_impl.hint["get_dancinggirl"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_residencedoor_anm_box", {animfunc = "end_flag", frame = 0 } );
end;

cmn.AddSubscriber( "get_dancinggirl", private.get_dancinggirl_inv );
cmn.AddSubscriber( "get_dancinggirl", private.get_dancinggirl_beg, private.room_objname );
cmn.AddSubscriber( "get_dancinggirl", private.get_dancinggirl_end, private.room_objname );
cmn.AddSubscriber( "get_dancinggirl", private.get_dancinggirl_logic );
--------------------------------------------------------------------
function public.get_dancinggirl()
  ObjSet( "spr_residencedoor_dancinggirl", {visible = 1} );
  cmn.SetEventDone( "get_dancinggirl" );
  cmn.CallEventHandler( "get_dancinggirl" );
  if common_impl.ZzCompleteCheck("get_dancinggirl") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_residencekey_zone_clk()  --rm_bytheriver.use_residencekey_zone_clk()
    local func_end = function()
      common_impl.ShowBbt( 'need_residencekey' )
      ld.Lock(0);
    end;
  
    ld.Lock(1);
    SoundSfx( "aud_touch_medium_door" );
    ld.AnimPlay( "anm_residencedoor_anm_door", "idle_door", func_end )  
end


common_impl.hint[ "use_residencekey" ] = { type = "use", inv_obj = "inv_residencekey", use_place = "gfx_residencedoor_residencekey_zone", room = "rm_bytheriver", zz = "zz_residencedoor", zz_gate = "gzz_bytheriver_residencedoor" };

private.use_residencekey_logic = function()
  ObjSet( "grm_bytheriver_residence", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_bytheriver_residence_focus");
  end;
end;
private.use_residencekey_inv = function()
  common_impl.ProcessMultiUseAll("residencekey", "residencekey")
end;
private.use_residencekey_beg = function()
  ObjDelete( "gfx_residencedoor_residencekey_zone" );
end;
private.use_residencekey_end = function()
  if common_impl.ZzCompleteCheck("use_residencekey") then ObjSet( common_impl.hint["use_residencekey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_residencedoor_anm_door", {animfunc = "use_key", frame = 999 } );
  ObjSet( "spr_bytheriver_door_tr", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_residencekey", private.use_residencekey_inv );
cmn.AddSubscriber( "use_residencekey", private.use_residencekey_beg, private.room_objname );
cmn.AddSubscriber( "use_residencekey", private.use_residencekey_end, private.room_objname );
cmn.AddSubscriber( "use_residencekey", private.use_residencekey_logic );
cmn.AddSubscriber( "use_residencekey_inv", private.use_residencekey_inv, private.room_objname );
cmn.AddSubscriber( "use_residencekey_beg", private.use_residencekey_beg, private.room_objname );
cmn.AddSubscriber( "use_residencekey_end", private.use_residencekey_end, private.room_objname );
cmn.AddSubscriber( "use_residencekey_end", private.use_residencekey_logic );
--------------------------------------------------------------------------------------------
function public.use_residencekey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_residencekey" );
    cmn.CallEventHandler( "use_residencekey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_residencekey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_residencekey_inv" );
  cmn.CallEventHandler( "use_residencekey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_residencedoor_anm_door", "use_key", func_end );
  SoundSfx( "aud_use_residencekey_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_summergarden *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_goldcrow3" ] = { type = "get", get_obj = "spr_summergarden_goldcrow3", room = "rm_bytheriver", zz = "zz_summergarden", zz_gate = "gzz_bytheriver_summergarden" };

private.get_goldcrow3_logic = function()
  
end;
private.get_goldcrow3_inv = function()
  interface.InventoryItemAdd("inv_goldcrow","spr_summergarden_goldcrow3",function() level_inv.ProcessGetGoldcrowAll( "get_goldcrow3" ) end);
end;
private.get_goldcrow3_beg = function()
  ObjDelete("gfx_summergarden_goldcrow3")
end;
private.get_goldcrow3_end = function()
  if common_impl.ZzCompleteCheck("get_goldcrow3") then ObjSet( common_impl.hint["get_goldcrow3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_summergarden_goldcrow3_sh");
  ObjDelete("spr_bytheriver_goldcrow3");
end;

cmn.AddSubscriber( "get_goldcrow3", private.get_goldcrow3_inv );
cmn.AddSubscriber( "get_goldcrow3", private.get_goldcrow3_beg, private.room_objname );
cmn.AddSubscriber( "get_goldcrow3", private.get_goldcrow3_end, private.room_objname );
cmn.AddSubscriber( "get_goldcrow3", private.get_goldcrow3_logic );
--------------------------------------------------------------------
function public.get_goldcrow3()
  cmn.SetEventDone( "get_goldcrow3" );
  cmn.CallEventHandler( "get_goldcrow3" );
  if common_impl.ZzCompleteCheck("get_goldcrow3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_dancinggirl_zone_clk()  --rm_bytheriver.use_dancinggirl_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_dancinggirl' );
  end;
    
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_summergarden_anm_doll", "idle_cover", func_end )
end


common_impl.hint[ "use_dancinggirl" ] = { type = "use", inv_obj = "inv_dancinggirl", use_place = "gfx_summergarden_dancinggirl_zone", room = "rm_bytheriver", zz = "zz_summergarden", zz_gate = "gzz_bytheriver_summergarden" };

private.use_dancinggirl_logic = function()
  ObjSet( "spr_summergarden_stonebracelet", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_summergarden_stonebracelet", { active = 1, visible = 1} );
end;
private.use_dancinggirl_inv = function()
  common_impl.ProcessMultiUseAll("dancinggirl", "dancinggirl")
end;
private.use_dancinggirl_beg = function()
  ObjDelete( "gfx_summergarden_dancinggirl_zone" );
end;
private.use_dancinggirl_end = function()
  if common_impl.ZzCompleteCheck("use_dancinggirl") then ObjSet( common_impl.hint["use_dancinggirl"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_summergarden_anm_doll", {animfunc = "use_doll", frame = 999 } );
  ObjSet( "spr_bytheriver_doll_tr", {visible = 1} );
  ObjDelete("spr_bytheriver_cover_m1");
  ObjSet( "spr_bytheriver_cover_m2", {visible = 1} );
  ObjSet( "spr_bytheriver_stonebracelet_m", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dancinggirl", private.use_dancinggirl_inv );
cmn.AddSubscriber( "use_dancinggirl", private.use_dancinggirl_beg, private.room_objname );
cmn.AddSubscriber( "use_dancinggirl", private.use_dancinggirl_end, private.room_objname );
cmn.AddSubscriber( "use_dancinggirl", private.use_dancinggirl_logic );
cmn.AddSubscriber( "use_dancinggirl_inv", private.use_dancinggirl_inv, private.room_objname );
cmn.AddSubscriber( "use_dancinggirl_beg", private.use_dancinggirl_beg, private.room_objname );
cmn.AddSubscriber( "use_dancinggirl_end", private.use_dancinggirl_end, private.room_objname );
cmn.AddSubscriber( "use_dancinggirl_end", private.use_dancinggirl_logic );
--------------------------------------------------------------------------------------------
function public.use_dancinggirl( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dancinggirl" );
    cmn.CallEventHandler( "use_dancinggirl_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dancinggirl") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dancinggirl_inv" );
  cmn.CallEventHandler( "use_dancinggirl_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_summergarden_anm_doll", "use_doll", func_end );
  SoundSfx( "aud_use_dancinggirl_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stonebracelet" ] = { type = "get", get_obj = "spr_summergarden_stonebracelet", room = "rm_bytheriver", zz = "zz_summergarden", zz_gate = "gzz_bytheriver_summergarden" };

private.get_stonebracelet_logic = function()
  
end;
private.get_stonebracelet_inv = function()
  interface.InventoryItemAdd("inv_stonebracelet","spr_summergarden_stonebracelet");
end;
private.get_stonebracelet_beg = function()
  ObjDelete("gfx_summergarden_stonebracelet")
end;
private.get_stonebracelet_end = function()
  if common_impl.ZzCompleteCheck("get_stonebracelet") then ObjSet( common_impl.hint["get_stonebracelet"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_summergarden_anm_doll", {animfunc = "end_doll1", frame = 0 } );
  ObjDelete("spr_bytheriver_stonebracelet_m")
end;

cmn.AddSubscriber( "get_stonebracelet", private.get_stonebracelet_inv );
cmn.AddSubscriber( "get_stonebracelet", private.get_stonebracelet_beg, private.room_objname );
cmn.AddSubscriber( "get_stonebracelet", private.get_stonebracelet_end, private.room_objname );
cmn.AddSubscriber( "get_stonebracelet", private.get_stonebracelet_logic );
--------------------------------------------------------------------
function public.get_stonebracelet()
  ObjSet( "spr_summergarden_stonebracelet", {visible = 1} );
  cmn.SetEventDone( "get_stonebracelet" );
  cmn.CallEventHandler( "get_stonebracelet" );
  if common_impl.ZzCompleteCheck("get_stonebracelet") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_shovel_zone_clk() --rm_bytheriver.use_shovel_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_shovel' );
  end
  
  ld.Lock(1);
  ld.AnimPlay( "anm_summergarden_anm_shovel", "idle_terra", func_end )
end;  


common_impl.hint[ "use_shovel" ] = { type = "use", inv_obj = "inv_shovel", use_place = "gfx_summergarden_shovel_zone", room = "rm_bytheriver", zz = "zz_summergarden", zz_gate = "gzz_bytheriver_summergarden" };

private.use_shovel_logic = function()
  ObjSet( "spr_summergarden_secateurs", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_summergarden_ingredients", { visible = 1, input = 1, active = 1 } )

end;
private.use_shovel_inv = function()
  common_impl.ProcessMultiUseAll("shovel", "shovel")
end;
private.use_shovel_beg = function()
  ObjDelete( "gfx_summergarden_shovel_zone" );
end;
private.use_shovel_end = function()
  if common_impl.ZzCompleteCheck("use_shovel") then ObjSet( common_impl.hint["use_shovel"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_summergarden_anm_shovel", {animfunc = "use_shove1", frame = 0 } );
  ObjSet( "spr_summergarden_secateurs_sh", {visible = 1} );
  ObjSet( "spr_summergarden_ingredients_sh", {visible = 1} );
  ObjSet( "anm_summergarden_anm_trash", {visible = 1} );
  ObjSet( "spr_bytheriver_terra_tr", {visible = 1} );
  ObjSet( "spr_bytheriver_terra_m2", {visible = 1} );
  ObjSet( "spr_bytheriver_secateurs", {visible = 1} );
  ObjSet( "spr_bytheriver_ingredients", {visible = 1} );
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_shovel", private.use_shovel_inv );
cmn.AddSubscriber( "use_shovel", private.use_shovel_beg, private.room_objname );
cmn.AddSubscriber( "use_shovel", private.use_shovel_end, private.room_objname );
cmn.AddSubscriber( "use_shovel", private.use_shovel_logic );
cmn.AddSubscriber( "use_shovel_inv", private.use_shovel_inv, private.room_objname );
cmn.AddSubscriber( "use_shovel_beg", private.use_shovel_beg, private.room_objname );
cmn.AddSubscriber( "use_shovel_end", private.use_shovel_end, private.room_objname );
cmn.AddSubscriber( "use_shovel_end", private.use_shovel_logic );
--------------------------------------------------------------------------------------------
function public.use_shovel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_shovel" );
    cmn.CallEventHandler( "use_shovel_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_shovel") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_shovel_inv" );
  cmn.CallEventHandler( "use_shovel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_summergarden_anm_shovel", "use_shove", func_end );
  SoundSfx( "aud_use_shovel_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_secateurs" ] = { type = "get", get_obj = "spr_summergarden_secateurs", room = "rm_bytheriver", zz = "zz_summergarden", zz_gate = "gzz_bytheriver_summergarden" };

private.get_secateurs_logic = function()
  
end;
private.get_secateurs_inv = function()
  interface.InventoryItemAdd("inv_secateurs","spr_summergarden_secateurs");
end;
private.get_secateurs_beg = function()
  ObjDelete("gfx_summergarden_secateurs")
end;
private.get_secateurs_end = function()
  if common_impl.ZzCompleteCheck("get_secateurs") then ObjSet( common_impl.hint["get_secateurs"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_summergarden_secateurs_sh")
  ObjDelete("spr_bytheriver_secateurs");
end;

cmn.AddSubscriber( "get_secateurs", private.get_secateurs_inv );
cmn.AddSubscriber( "get_secateurs", private.get_secateurs_beg, private.room_objname );
cmn.AddSubscriber( "get_secateurs", private.get_secateurs_end, private.room_objname );
cmn.AddSubscriber( "get_secateurs", private.get_secateurs_logic );
--------------------------------------------------------------------
function public.get_secateurs()
  cmn.SetEventDone( "get_secateurs" );
  cmn.CallEventHandler( "get_secateurs" );
  if common_impl.ZzCompleteCheck("get_secateurs") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ingredients" ] = { type = "get", get_obj = "spr_summergarden_ingredients", room = "rm_bytheriver", zz = "zz_summergarden", zz_gate = "gzz_bytheriver_summergarden" };

private.get_ingredients_logic = function()
  
end;
private.get_ingredients_inv = function()
  interface.InventoryItemAdd("inv_ingredients","spr_summergarden_ingredients");
end;
private.get_ingredients_beg = function()
  ObjDelete("gfx_summergarden_ingredients")
end;
private.get_ingredients_end = function()
  if common_impl.ZzCompleteCheck("get_ingredients") then ObjSet( common_impl.hint["get_ingredients"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_summergarden_ingredients_sh")
  ObjDelete("spr_bytheriver_ingredients")
end;

cmn.AddSubscriber( "get_ingredients", private.get_ingredients_inv );
cmn.AddSubscriber( "get_ingredients", private.get_ingredients_beg, private.room_objname );
cmn.AddSubscriber( "get_ingredients", private.get_ingredients_end, private.room_objname );
cmn.AddSubscriber( "get_ingredients", private.get_ingredients_logic );
--------------------------------------------------------------------
function public.get_ingredients()
  cmn.SetEventDone( "get_ingredients" );
  cmn.CallEventHandler( "get_ingredients" );
  if common_impl.ZzCompleteCheck("get_ingredients") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_yacht *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_sail_zone_clk()  --rm_bytheriver.use_sail_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_sail' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_medium_door" )
  ld.AnimPlay( "anm_yacht_anm_sail", "use_cinqu2", func_end )  
end;  

common_impl.hint[ "use_sail" ] = { type = "use", inv_obj = "inv_sail", use_place = "gfx_yacht_sail_zone", room = "rm_bytheriver", zz = "zz_yacht", zz_gate = "gzz_bytheriver_yacht" };

private.use_sail_logic = function()
  ObjSet( "spr_yacht_cinquefoil", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_yacht_cathead", { visible = 1, input = 1, active = 1 } )

end;
private.use_sail_inv = function()
  common_impl.ProcessMultiUseAll("sail", "sail")
end;
private.use_sail_beg = function()
  ObjDelete( "gfx_yacht_sail_zone" );
end;
private.use_sail_end = function()
  if common_impl.ZzCompleteCheck("use_sail") then ObjSet( common_impl.hint["use_sail"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_yacht_anm_sail", {animfunc = "end_cinqu2", frame = 0 } );
  ObjSet( "spr_yacht_cathead_sh", {visible = 1} );
  ObjSet( "spr_yacht_cinquefoil_sh", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sail", private.use_sail_inv );
cmn.AddSubscriber( "use_sail", private.use_sail_beg, private.room_objname );
cmn.AddSubscriber( "use_sail", private.use_sail_end, private.room_objname );
cmn.AddSubscriber( "use_sail", private.use_sail_logic );
cmn.AddSubscriber( "use_sail_inv", private.use_sail_inv, private.room_objname );
cmn.AddSubscriber( "use_sail_beg", private.use_sail_beg, private.room_objname );
cmn.AddSubscriber( "use_sail_end", private.use_sail_end, private.room_objname );
cmn.AddSubscriber( "use_sail_end", private.use_sail_logic );
--------------------------------------------------------------------------------------------
function public.use_sail( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sail" );
    cmn.CallEventHandler( "use_sail_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sail") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sail_inv" );
  cmn.CallEventHandler( "use_sail_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_yacht_anm_sail", "use_cinqu", func_end );
  SoundSfx( "aud_use_sail_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cinquefoil" ] = { type = "get", get_obj = "spr_yacht_cinquefoil", room = "rm_bytheriver", zz = "zz_yacht", zz_gate = "gzz_bytheriver_yacht" };

private.get_cinquefoil_logic = function()
  
end;
private.get_cinquefoil_inv = function()
  interface.InventoryItemAdd("inv_cinquefoil","spr_yacht_cinquefoil");
end;
private.get_cinquefoil_beg = function()
  ObjDelete("gfx_yacht_cinquefoil")
end;
private.get_cinquefoil_end = function()
  if common_impl.ZzCompleteCheck("get_cinquefoil") then ObjSet( common_impl.hint["get_cinquefoil"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_yacht_cinquefoil_sh")
end;

cmn.AddSubscriber( "get_cinquefoil", private.get_cinquefoil_inv );
cmn.AddSubscriber( "get_cinquefoil", private.get_cinquefoil_beg, private.room_objname );
cmn.AddSubscriber( "get_cinquefoil", private.get_cinquefoil_end, private.room_objname );
cmn.AddSubscriber( "get_cinquefoil", private.get_cinquefoil_logic );
--------------------------------------------------------------------
function public.get_cinquefoil()
  cmn.SetEventDone( "get_cinquefoil" );
  cmn.CallEventHandler( "get_cinquefoil" );
  if common_impl.ZzCompleteCheck("get_cinquefoil") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cathead" ] = { type = "get", get_obj = "spr_yacht_cathead", room = "rm_bytheriver", zz = "zz_yacht", zz_gate = "gzz_bytheriver_yacht" };

private.get_cathead_logic = function()
  
end;
private.get_cathead_inv = function()
  interface.InventoryItemAdd("inv_cathead","spr_yacht_cathead");
end;
private.get_cathead_beg = function()
  ObjDelete("gfx_yacht_cathead")
end;
private.get_cathead_end = function()
  if common_impl.ZzCompleteCheck("get_cathead") then ObjSet( common_impl.hint["get_cathead"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_yacht_cathead_sh")
end;

cmn.AddSubscriber( "get_cathead", private.get_cathead_inv );
cmn.AddSubscriber( "get_cathead", private.get_cathead_beg, private.room_objname );
cmn.AddSubscriber( "get_cathead", private.get_cathead_end, private.room_objname );
cmn.AddSubscriber( "get_cathead", private.get_cathead_logic );
--------------------------------------------------------------------
function public.get_cathead()
  cmn.SetEventDone( "get_cathead" );
  cmn.CallEventHandler( "get_cathead" );
  if common_impl.ZzCompleteCheck("get_cathead") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_greenbutton_zone_clk()  --rm_bytheriver.use_greenbutton_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_greenbutton' );
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_small_door" );
  ld.AnimPlay( "anm_yacht_anm_btn", "cover_idle", func_end )  
end;  


common_impl.hint[ "use_greenbutton" ] = { type = "use", inv_obj = "inv_greenbutton", use_place = "gfx_yacht_greenbutton_zone", room = "rm_bytheriver", zz = "zz_yacht", zz_gate = "gzz_bytheriver_yacht" };

private.use_greenbutton_logic = function()
  ObjSet( "spr_yacht_goldcrow5", { visible = 1, input = 1, active = 1 } )
  ObjSet( "obj_yacht_text_mini", {input = 1} );
end;
private.use_greenbutton_inv = function()
  common_impl.ProcessMultiUseAll("greenbutton", "greenbutton")
end;
private.use_greenbutton_beg = function()
  ObjDelete( "gfx_yacht_greenbutton_zone" );
end;
private.use_greenbutton_end = function()
  if common_impl.ZzCompleteCheck("use_greenbutton") then ObjSet( common_impl.hint["use_greenbutton"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_yacht_anm_btn", {animfunc = "end_btn", frame = 0 } );
  ObjSet( "spr_yacht_goldcrow5_sh", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_greenbutton", private.use_greenbutton_inv );
cmn.AddSubscriber( "use_greenbutton", private.use_greenbutton_beg, private.room_objname );
cmn.AddSubscriber( "use_greenbutton", private.use_greenbutton_end, private.room_objname );
cmn.AddSubscriber( "use_greenbutton", private.use_greenbutton_logic );
cmn.AddSubscriber( "use_greenbutton_inv", private.use_greenbutton_inv, private.room_objname );
cmn.AddSubscriber( "use_greenbutton_beg", private.use_greenbutton_beg, private.room_objname );
cmn.AddSubscriber( "use_greenbutton_end", private.use_greenbutton_end, private.room_objname );
cmn.AddSubscriber( "use_greenbutton_end", private.use_greenbutton_logic );
--------------------------------------------------------------------------------------------
function public.use_greenbutton( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_greenbutton" );
    cmn.CallEventHandler( "use_greenbutton_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_greenbutton") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_greenbutton_inv" );
  cmn.CallEventHandler( "use_greenbutton_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_yacht_anm_btn", "use_btn", func_end );
  SoundSfx( "aud_use_greenbutton_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goldcrow5" ] = { type = "get", get_obj = "spr_yacht_goldcrow5", room = "rm_bytheriver", zz = "zz_yacht", zz_gate = "gzz_bytheriver_yacht" };

private.get_goldcrow5_logic = function()
  
end;
private.get_goldcrow5_inv = function()
  interface.InventoryItemAdd("inv_goldcrow","spr_yacht_goldcrow5",function() level_inv.ProcessGetGoldcrowAll( "get_goldcrow5" ) end);
end;
private.get_goldcrow5_beg = function()
  ObjDelete("gfx_yacht_goldcrow5")
end;
private.get_goldcrow5_end = function()
  if common_impl.ZzCompleteCheck("get_goldcrow5") then ObjSet( common_impl.hint["get_goldcrow5"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_yacht_goldcrow5_sh");
end;

cmn.AddSubscriber( "get_goldcrow5", private.get_goldcrow5_inv );
cmn.AddSubscriber( "get_goldcrow5", private.get_goldcrow5_beg, private.room_objname );
cmn.AddSubscriber( "get_goldcrow5", private.get_goldcrow5_end, private.room_objname );
cmn.AddSubscriber( "get_goldcrow5", private.get_goldcrow5_logic );
--------------------------------------------------------------------
function public.get_goldcrow5()
  cmn.SetEventDone( "get_goldcrow5" );
  cmn.CallEventHandler( "get_goldcrow5" );
  if common_impl.ZzCompleteCheck("get_goldcrow5") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_screwdriver_zone_clk()  --rm_bytheriver.use_screwdriver_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_screwdriver' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_very_small_metal" );
  ld.AnimPlay( "anm_yacht_anm_screw", "idle_screw1", func_end )  
end;  

common_impl.hint[ "use_screwdriver" ] = { type = "use", inv_obj = "inv_screwdriver", use_place = "gfx_yacht_screwdriver_zone", room = "rm_bytheriver", zz = "zz_yacht", zz_gate = "gzz_bytheriver_yacht" };

private.use_screwdriver_logic = function()
  ObjSet( "spr_yacht_numeral", { visible = 1, input = 1, active = 1 } )

end;
private.use_screwdriver_inv = function()
  common_impl.ProcessMultiUseAll("screwdriver", "screwdriver")
end;
private.use_screwdriver_beg = function()
  ObjDelete( "gfx_yacht_screwdriver_zone" );
end;
private.use_screwdriver_end = function()
  if common_impl.ZzCompleteCheck("use_screwdriver") then ObjSet( common_impl.hint["use_screwdriver"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_yacht_anm_screw");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_inv );
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriver", private.use_screwdriver_logic );
cmn.AddSubscriber( "use_screwdriver_inv", private.use_screwdriver_inv, private.room_objname );
cmn.AddSubscriber( "use_screwdriver_beg", private.use_screwdriver_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriver_end", private.use_screwdriver_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriver_end", private.use_screwdriver_logic );
--------------------------------------------------------------------------------------------
function public.use_screwdriver( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwdriver" );
    cmn.CallEventHandler( "use_screwdriver_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screwdriver") then ld.CloseSubRoom() end;
    public.get_numeral();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwdriver_inv" );
  cmn.CallEventHandler( "use_screwdriver_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_yacht_anm_screw", "use_screw", func_end );
  SoundSfx( "aud_use_screwdriver_bytheriver" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_numeral" ] = { type = "get", get_obj = "spr_yacht_numeral", room = "rm_bytheriver", zz = "zz_yacht", zz_gate = "gzz_bytheriver_yacht" };

private.get_numeral_logic = function()
  
end;
private.get_numeral_inv = function()
  interface.InventoryItemAdd("inv_numeral","spr_yacht_numeral");
end;
private.get_numeral_beg = function()
  ObjDelete("gfx_yacht_numeral")
end;
private.get_numeral_end = function()
  if common_impl.ZzCompleteCheck("get_numeral") then ObjSet( common_impl.hint["get_numeral"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_numeral", private.get_numeral_inv );
cmn.AddSubscriber( "get_numeral", private.get_numeral_beg, private.room_objname );
cmn.AddSubscriber( "get_numeral", private.get_numeral_end, private.room_objname );
cmn.AddSubscriber( "get_numeral", private.get_numeral_logic );
--------------------------------------------------------------------
function public.get_numeral()
  cmn.SetEventDone( "get_numeral" );
  cmn.CallEventHandler( "get_numeral" );
  if common_impl.ZzCompleteCheck("get_numeral") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_bytheriver();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_bytheriver_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_yacht" );
  function zz_yacht.Open()
  end;
  function zz_yacht.PreOpen()
  end;
  function zz_yacht.PreClose()
  end;
  function zz_yacht.Close()
  end;

  subroom.Define( "zz_summergarden" );
  function zz_summergarden.Open()
  end;
  function zz_summergarden.PreOpen()
  end;
  function zz_summergarden.PreClose()
  end;
  function zz_summergarden.Close()
  end;

  subroom.Define( "zz_residencedoor" );
  function zz_residencedoor.Open()
  end;
  function zz_residencedoor.PreOpen()
  end;
  function zz_residencedoor.PreClose()
  end;
  function zz_residencedoor.Close()
  end;

  subroom.Define( "zz_lordstatue" );
  function zz_lordstatue.Open()
  end;
  function zz_lordstatue.PreOpen()
  end;
  function zz_lordstatue.PreClose()
  end;
  function zz_lordstatue.Close()
  end;
  
end;
--*********************************************************************************************************************
-------------- other funcs ------
function public.bytherither_snails_clk()
  local func_end = function()
     ObjSet( "obj_yacht_snails_clk_zone", {input = 1} );  
     ObjSet( "anm_yacht_anm_snails", {animfunc = "snails_statik", frame = 0, playing = 1 } );
  end;

  ObjSet( "obj_yacht_snails_clk_zone", {input = 0} );  
  SoundSfx( "aud_touch_snail_bytheriver" );
  ld.AnimPlay( "anm_yacht_anm_snails", "snails_statik1", func_end )
end;  