-- name=rm_laboratory
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_laboratory";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("obj_wardrobe_text", "spr_wardrobe_text")
  --------------------------------------------------------------------------------------------
function private.opn_laboratory()
  if not ( cmn.IsEventDone( "opn_laboratory" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_laboratory" );
      cmn.CallEventHandler( "opn_laboratory" )
      --ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opn_laboratory");
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_laboratory = function() end;
local opn_laboratory_logic = function() end;
cmn.AddSubscriber( "opn_laboratory", opn_laboratory_logic )
cmn.AddSubscriber( "opn_laboratory", opn_laboratory, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animshadows" ] = { type = "click", use_place = "gfx_laboratory_clk_animshadows_zone", room = "rm_laboratory" };

private.clk_animshadows_logic = function()
   ObjSet( "gzz_laboratory_doorinflor", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_laboratory_wardrobe", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_laboratory_boiler", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_laboratory_worktable", {active=1, input = 1, visible = 1} );
end;
private.clk_animshadows_beg = function()
  ObjDelete( "gfx_laboratory_clk_animshadows_zone" );
end;
private.clk_animshadows_end = function()
  ObjDelete("anm_laboratory_anm_shadow"); 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animshadows", private.clk_animshadows_beg, private.room_objname );
cmn.AddSubscriber( "clk_animshadows", private.clk_animshadows_end, private.room_objname );
cmn.AddSubscriber( "clk_animshadows", private.clk_animshadows_logic );
cmn.AddSubscriber( "clk_animshadows_beg", private.clk_animshadows_beg, private.room_objname );
cmn.AddSubscriber( "clk_animshadows_end", private.clk_animshadows_end, private.room_objname );
cmn.AddSubscriber( "clk_animshadows_end", private.clk_animshadows_logic );
--------------------------------------------------------------------------------------------
function public.clk_animshadows()

  local func_end = function()
    cmn.SetEventDone( "clk_animshadows" );
    cmn.CallEventHandler( "clk_animshadows_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_animshadows");
    SoundTheme( "aud_danger_moment3_mus" );
  end;

 
  cmn.CallEventHandler( "clk_animshadows_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_laboratory_anm_shadow", "shadow", function() end )
  SoundSfx( "aud_shadow_laboratory" )
  --func_end()
  
--  ObjAnimate( "rm_laboratory", 3, 0, 0, function() end, {0,0,0,0, 1,0,-200,0, 2,0,0,0} );
  ObjAnimate( "rm_laboratory", 6, 0, 0, func_end, {0,0,1,1, 0.8,0,1,1, 1.8,0,1.3,1.3, 3,0,1.3,1.3, 4,0,1,1} );
 
end;

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_worktable *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_camomile7" ] = { type = "get", get_obj = "spr_worktable_camomile7", room = "rm_laboratory", zz = "zz_worktable", zz_gate = "gzz_laboratory_worktable" };

private.get_camomile7_logic = function()
  
end;
private.get_camomile7_inv = function()
  interface.InventoryItemAdd("inv_camomile","spr_worktable_camomile7",function() level_inv.ProcessGetCamomileAll( "get_camomile7" ) end);
end;
private.get_camomile7_beg = function()
  ObjDelete("gfx_worktable_camomile7")
end;
private.get_camomile7_end = function()
  if common_impl.ZzCompleteCheck("get_camomile7") then ObjSet( common_impl.hint["get_camomile7"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_worktable_sh_camomile7");
  ObjDelete("spr_laboratory_cam");
end;

cmn.AddSubscriber( "get_camomile7", private.get_camomile7_inv );
cmn.AddSubscriber( "get_camomile7", private.get_camomile7_beg, private.room_objname );
cmn.AddSubscriber( "get_camomile7", private.get_camomile7_end, private.room_objname );
cmn.AddSubscriber( "get_camomile7", private.get_camomile7_logic );
--------------------------------------------------------------------
function public.get_camomile7()
  cmn.SetEventDone( "get_camomile7" );
  cmn.CallEventHandler( "get_camomile7" );
  if common_impl.ZzCompleteCheck("get_camomile7") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_handledragon_zone_clk()  --rm_laboratory.use_handledragon_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_handledragon' )
  end;

  ld.Lock(1);  
  SoundSfx( "aud_touch_medium_wood" );
  ld.AnimPlay( "anm_worktable_anm_up", "idle_1", func_end )
end;  



common_impl.hint[ "use_handledragon" ] = { type = "use", inv_obj = "inv_handledragon", use_place = "gfx_worktable_handledragon_zone", room = "rm_laboratory", zz = "zz_worktable", zz_gate = "gzz_laboratory_worktable" };

private.use_handledragon_logic = function()
  ObjSet( "spr_worktable_ruler", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_worktable_ruler", {active = 1, visible = 1} );
end;
private.use_handledragon_inv = function()
  common_impl.ProcessMultiUseAll("handledragon", "handledragon")
end;
private.use_handledragon_beg = function()
  ObjDelete( "gfx_worktable_handledragon_zone" );
end;
private.use_handledragon_end = function()
  if common_impl.ZzCompleteCheck("use_handledragon") then ObjSet( common_impl.hint["use_handledragon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_worktable_anm_up", {animfunc = "end_doorhandle_1", frame = 0 } );
  ObjSet( "spr_laboratory_drawer", {visible = 1} );
  ObjSet( "spr_laboratory_rul", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_handledragon", private.use_handledragon_inv );
cmn.AddSubscriber( "use_handledragon", private.use_handledragon_beg, private.room_objname );
cmn.AddSubscriber( "use_handledragon", private.use_handledragon_end, private.room_objname );
cmn.AddSubscriber( "use_handledragon", private.use_handledragon_logic );
cmn.AddSubscriber( "use_handledragon_inv", private.use_handledragon_inv, private.room_objname );
cmn.AddSubscriber( "use_handledragon_beg", private.use_handledragon_beg, private.room_objname );
cmn.AddSubscriber( "use_handledragon_end", private.use_handledragon_end, private.room_objname );
cmn.AddSubscriber( "use_handledragon_end", private.use_handledragon_logic );
--------------------------------------------------------------------------------------------
function public.use_handledragon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_handledragon" );
    cmn.CallEventHandler( "use_handledragon_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_handledragon") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_handledragon_inv" );
  cmn.CallEventHandler( "use_handledragon_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_worktable_anm_up", "use_doorhandle_1", func_end );
  SoundSfx( "aud_use_handledragon_laboratory" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ruler" ] = { type = "get", get_obj = "spr_worktable_ruler", room = "rm_laboratory", zz = "zz_worktable", zz_gate = "gzz_laboratory_worktable" };

private.get_ruler_logic = function()
  
end;
private.get_ruler_inv = function()
  interface.InventoryItemAdd("inv_ruler","spr_worktable_ruler");
end;
private.get_ruler_beg = function()
  ObjDelete("gfx_worktable_ruler")
end;
private.get_ruler_end = function()
  if common_impl.ZzCompleteCheck("get_ruler") then ObjSet( common_impl.hint["get_ruler"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_worktable_anm_up", {animfunc = "end_closed", frame = 0 } );
  ObjDelete("spr_laboratory_drawer");
  ObjDelete("spr_laboratory_rul");
  ObjSet( "spr_laboratory_tr_h", {visible = 1} );
end;

cmn.AddSubscriber( "get_ruler", private.get_ruler_inv );
cmn.AddSubscriber( "get_ruler", private.get_ruler_beg, private.room_objname );
cmn.AddSubscriber( "get_ruler", private.get_ruler_end, private.room_objname );
cmn.AddSubscriber( "get_ruler", private.get_ruler_logic );
cmn.AddSubscriber( "get_ruler_inv", private.get_ruler_inv );
cmn.AddSubscriber( "get_ruler_beg", private.get_ruler_beg, private.room_objname );
cmn.AddSubscriber( "get_ruler_end", private.get_ruler_end, private.room_objname );
cmn.AddSubscriber( "get_ruler_end", private.get_ruler_logic );
--------------------------------------------------------------------
function public.get_ruler()
  local func_end = function()
     ld.Lock(0);
     cmn.SetEventDone( "get_ruler" );
     cmn.CallEventHandler( "get_ruler_end" );
     if common_impl.ZzCompleteCheck("get_ruler") then ld.CloseSubRoom() end;
  end;  
  
  ld.Lock(1); 
  ObjSet( "spr_worktable_ruler", {visible = 1} );
  cmn.CallEventHandler( "get_ruler_inv" );
  cmn.CallEventHandler( "get_ruler_beg" );
  
  SoundSfx( "aud_touch_handledragon_laboratory" );
  ld.AnimPlay( "anm_worktable_anm_up", "closed", func_end )
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_brokenhadle" ] = { type = "click", use_place = "gfx_worktable_clk_brokenhadle_zone", room = "rm_laboratory", zz = "zz_worktable", zz_gate = "gzz_laboratory_worktable" };

private.clk_brokenhadle_logic = function()
  ObjSet( "gfx_worktable_handlepart_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_brokenhadle_beg = function()
  ObjDelete( "gfx_worktable_clk_brokenhadle_zone" );
end;
private.clk_brokenhadle_end = function()
  if common_impl.ZzCompleteCheck("clk_brokenhadle") then ObjSet( common_impl.hint["clk_brokenhadle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_worktable_anm_down", {animfunc = "close", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_brokenhadle", private.clk_brokenhadle_beg, private.room_objname );
cmn.AddSubscriber( "clk_brokenhadle", private.clk_brokenhadle_end, private.room_objname );
cmn.AddSubscriber( "clk_brokenhadle", private.clk_brokenhadle_logic );
cmn.AddSubscriber( "clk_brokenhadle_beg", private.clk_brokenhadle_beg, private.room_objname );
cmn.AddSubscriber( "clk_brokenhadle_end", private.clk_brokenhadle_end, private.room_objname );
cmn.AddSubscriber( "clk_brokenhadle_end", private.clk_brokenhadle_logic );
--------------------------------------------------------------------------------------------
function public.clk_brokenhadle()

  local func_end = function()
    cmn.SetEventDone( "clk_brokenhadle" );
    cmn.CallEventHandler( "clk_brokenhadle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_brokenhadle") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_brokenhadle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_worktable_anm_down", "close", func_end );
  SoundSfx( "aud_clk_brokenhadle_laboratory" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_handlepart_zone_clk()  --rm_laboratory.use_handlepart_zone_clk();
  local func_end = function()
     ld.Lock(0);
     common_impl.ShowBbt( 'need_handlepart' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_medium_wood" );
  ld.AnimPlay( "anm_worktable_anm_down", "idle_2", func_end )
end;  


common_impl.hint[ "use_handlepart" ] = { type = "use", inv_obj = "inv_handlepart", use_place = "gfx_worktable_handlepart_zone", room = "rm_laboratory", zz = "zz_worktable", zz_gate = "gzz_laboratory_worktable" };

private.use_handlepart_logic = function()
  ObjSet( "spr_worktable_needlecotton", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_worktable_mainland2", { visible = 1, input = 1, active = 1 } )

end;
private.use_handlepart_inv = function()
  common_impl.ProcessMultiUseAll("handlepart", "handlepart")
end;
private.use_handlepart_beg = function()
  ObjDelete( "gfx_worktable_handlepart_zone" );
end;
private.use_handlepart_end = function()
  if common_impl.ZzCompleteCheck("use_handlepart") then ObjSet( common_impl.hint["use_handlepart"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_worktable_tr_box_2", {visible = 1} );
  ObjSet( "anm_worktable_anm_down", {animfunc = "end_2", frame = 0 } );
  ObjSet( "spr_laboratory_drawer1", {visible = 1} );
  ObjSet( "spr_laboratory_need", {visible = 1} );
  ObjSet( "spr_laboratory_main2", {visible = 1} );
  ObjSet("spr_worktable_sh_needlecotton",{visible=1})
  ObjSet("spr_worktable_sh_mainland2",{visible=1})  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_handlepart", private.use_handlepart_inv );
cmn.AddSubscriber( "use_handlepart", private.use_handlepart_beg, private.room_objname );
cmn.AddSubscriber( "use_handlepart", private.use_handlepart_end, private.room_objname );
cmn.AddSubscriber( "use_handlepart", private.use_handlepart_logic );
cmn.AddSubscriber( "use_handlepart_inv", private.use_handlepart_inv, private.room_objname );
cmn.AddSubscriber( "use_handlepart_beg", private.use_handlepart_beg, private.room_objname );
cmn.AddSubscriber( "use_handlepart_end", private.use_handlepart_end, private.room_objname );
cmn.AddSubscriber( "use_handlepart_end", private.use_handlepart_logic );
--------------------------------------------------------------------------------------------
function public.use_handlepart( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_handlepart" );
    cmn.CallEventHandler( "use_handlepart_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_handlepart") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_handlepart_inv" );
  cmn.CallEventHandler( "use_handlepart_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_worktable_anm_down", "use_doorhandle_2", func_end );
  SoundSfx( "aud_use_handlepart_laboratory" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_needlecotton" ] = { type = "get", get_obj = "spr_worktable_needlecotton", room = "rm_laboratory", zz = "zz_worktable", zz_gate = "gzz_laboratory_worktable" };

private.get_needlecotton_logic = function()
  
end;
private.get_needlecotton_inv = function()
  interface.InventoryItemAdd("inv_needlecotton","spr_worktable_needlecotton");
end;
private.get_needlecotton_beg = function()
  ObjDelete("gfx_worktable_needlecotton")
end;
private.get_needlecotton_end = function()
  if common_impl.ZzCompleteCheck("get_needlecotton") then ObjSet( common_impl.hint["get_needlecotton"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_laboratory_need");
  ObjDelete("spr_worktable_sh_needlecotton")
end;

cmn.AddSubscriber( "get_needlecotton", private.get_needlecotton_inv );
cmn.AddSubscriber( "get_needlecotton", private.get_needlecotton_beg, private.room_objname );
cmn.AddSubscriber( "get_needlecotton", private.get_needlecotton_end, private.room_objname );
cmn.AddSubscriber( "get_needlecotton", private.get_needlecotton_logic );
--------------------------------------------------------------------
function public.get_needlecotton()
  cmn.SetEventDone( "get_needlecotton" );
  cmn.CallEventHandler( "get_needlecotton" );
  if common_impl.ZzCompleteCheck("get_needlecotton") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mainland2" ] = { type = "get", get_obj = "spr_worktable_mainland2", room = "rm_laboratory", zz = "zz_worktable", zz_gate = "gzz_laboratory_worktable" };

private.get_mainland2_logic = function()
  
end;
private.get_mainland2_inv = function()
  interface.InventoryItemAdd("inv_mainland2","spr_worktable_mainland2");
end;
private.get_mainland2_beg = function()
  ObjDelete("gfx_worktable_mainland2")
end;
private.get_mainland2_end = function()
  if common_impl.ZzCompleteCheck("get_mainland2") then ObjSet( common_impl.hint["get_mainland2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_laboratory_main2");
  ObjDelete("spr_worktable_sh_mainland2")  
end;

cmn.AddSubscriber( "get_mainland2", private.get_mainland2_inv );
cmn.AddSubscriber( "get_mainland2", private.get_mainland2_beg, private.room_objname );
cmn.AddSubscriber( "get_mainland2", private.get_mainland2_end, private.room_objname );
cmn.AddSubscriber( "get_mainland2", private.get_mainland2_logic );
--------------------------------------------------------------------
function public.get_mainland2()
  cmn.SetEventDone( "get_mainland2" );
  cmn.CallEventHandler( "get_mainland2" );
  if common_impl.ZzCompleteCheck("get_mainland2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_boiler *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_bantik" ] = { type = "get", get_obj = "spr_boiler_bantik", room = "rm_laboratory", zz = "zz_boiler", zz_gate = "gzz_laboratory_boiler" };

private.get_bantik_logic = function()
  
end;
private.get_bantik_inv = function()
  interface.InventoryItemAdd("inv_bantik","spr_boiler_bantik");
end;
private.get_bantik_beg = function()
  ObjDelete("gfx_boiler_bantik")
end;
private.get_bantik_end = function()
  if common_impl.ZzCompleteCheck("get_bantik") then ObjSet( common_impl.hint["get_bantik"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boiler_sh_bantik");
  ObjDelete("spr_laboratory_bantik");
end;

cmn.AddSubscriber( "get_bantik", private.get_bantik_inv );
cmn.AddSubscriber( "get_bantik", private.get_bantik_beg, private.room_objname );
cmn.AddSubscriber( "get_bantik", private.get_bantik_end, private.room_objname );
cmn.AddSubscriber( "get_bantik", private.get_bantik_logic );
--------------------------------------------------------------------
function public.get_bantik()
  cmn.SetEventDone( "get_bantik" );
  cmn.CallEventHandler( "get_bantik" );
  if common_impl.ZzCompleteCheck("get_bantik") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_tongs_zone_clk()  --rm_laboratory.use_tongs_zone_clk()
  local func_end = function() 
    ld.Lock(0);
    common_impl.ShowBbt( 'need_tongs' );
  end
  
  ld.Lock(1);
  ld.AnimPlay( "anm_boiler_anm_eye", "idle_eye", func_end )
  SoundSfx( "aud_touch_eye_laboratory" );
end;  

common_impl.hint[ "use_tongs" ] = { type = "use", inv_obj = "inv_tongs", use_place = "gfx_boiler_tongs_zone", room = "rm_laboratory", zz = "zz_boiler", zz_gate = "gzz_laboratory_boiler" };

private.use_tongs_logic = function()
  ObjSet( "spr_boiler_eye", { visible = 1, input = 1, active = 1 } )

end;
private.use_tongs_inv = function()
  common_impl.ProcessMultiUseAll("tongs", "tongs")
end;
private.use_tongs_beg = function()
  ObjDelete( "gfx_boiler_tongs_zone" );
end;
private.use_tongs_end = function()
  if common_impl.ZzCompleteCheck("use_tongs") then ObjSet( common_impl.hint["use_tongs"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boiler_anm_eye", {animfunc = "use_forceps", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tongs", private.use_tongs_inv );
cmn.AddSubscriber( "use_tongs", private.use_tongs_beg, private.room_objname );
cmn.AddSubscriber( "use_tongs", private.use_tongs_end, private.room_objname );
cmn.AddSubscriber( "use_tongs", private.use_tongs_logic );
cmn.AddSubscriber( "use_tongs_inv", private.use_tongs_inv, private.room_objname );
cmn.AddSubscriber( "use_tongs_beg", private.use_tongs_beg, private.room_objname );
cmn.AddSubscriber( "use_tongs_end", private.use_tongs_end, private.room_objname );
cmn.AddSubscriber( "use_tongs_end", private.use_tongs_logic );
--------------------------------------------------------------------------------------------
function public.use_tongs( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tongs" );
    cmn.CallEventHandler( "use_tongs_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tongs") then ld.CloseSubRoom() end;
    public.get_eye();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tongs_inv" );
  cmn.CallEventHandler( "use_tongs_beg" );
  common_impl.Lock(1);

 -- ObjSet( "anm_boiler_anm_eye", {pos_z=33} );
  ld.AnimPlay( "anm_boiler_anm_eye", "use_forceps", func_end );
  SoundSfx( "aud_use_tongs_laboratory" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_eye" ] = { type = "get", get_obj = "spr_boiler_eye", room = "rm_laboratory", zz = "zz_boiler", zz_gate = "gzz_laboratory_boiler" };

private.get_eye_logic = function()
  
end;
private.get_eye_inv = function()
  interface.InventoryItemAdd("inv_eye","spr_boiler_eye");
end;
private.get_eye_beg = function()
  ObjDelete("gfx_boiler_eye")
end;
private.get_eye_end = function()
  if common_impl.ZzCompleteCheck("get_eye") then ObjSet( common_impl.hint["get_eye"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_eye", private.get_eye_inv );
cmn.AddSubscriber( "get_eye", private.get_eye_beg, private.room_objname );
cmn.AddSubscriber( "get_eye", private.get_eye_end, private.room_objname );
cmn.AddSubscriber( "get_eye", private.get_eye_logic );
--------------------------------------------------------------------
function public.get_eye()
  ObjSet( "spr_boiler_eye", {active=1, input=1, visible = 1} );
  cmn.SetEventDone( "get_eye" );
  cmn.CallEventHandler( "get_eye" );
  if common_impl.ZzCompleteCheck("get_eye") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_petal_zone_clk()  --rm_laboratory.use_petal_zone_clk()
  local func_end = function() 
   ld.Lock(0);
   common_impl.ShowBbt( 'need_petal' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_medium_wood" );
  ld.AnimPlay( "anm_boiler_anm_cover", "idle_cover", func_end )
end;  


common_impl.hint[ "use_petal" ] = { type = "use", inv_obj = "inv_petal", use_place = "gfx_boiler_petal_zone", room = "rm_laboratory", zz = "zz_boiler", zz_gate = "gzz_laboratory_boiler" };

private.use_petal_logic = function()
  ObjSet( "spr_boiler_ruby1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_boiler_gaff", { visible = 1, input = 1, active = 1 } )

end;
private.use_petal_inv = function()
  common_impl.ProcessMultiUseAll("petal", "petal")
end;
private.use_petal_beg = function()
  ObjDelete( "gfx_boiler_petal_zone" );
end;
private.use_petal_end = function()
  ObjSet("anm_boiler_anm_cover",{animfunc="use_petal",frame=999})
  if common_impl.ZzCompleteCheck("use_petal") then ObjSet( common_impl.hint["use_petal"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_petal", private.use_petal_inv );
cmn.AddSubscriber( "use_petal", private.use_petal_beg, private.room_objname );
cmn.AddSubscriber( "use_petal", private.use_petal_end, private.room_objname );
cmn.AddSubscriber( "use_petal", private.use_petal_logic );
cmn.AddSubscriber( "use_petal_inv", private.use_petal_inv, private.room_objname );
cmn.AddSubscriber( "use_petal_beg", private.use_petal_beg, private.room_objname );
cmn.AddSubscriber( "use_petal_end", private.use_petal_end, private.room_objname );
cmn.AddSubscriber( "use_petal_end", private.use_petal_logic );
--------------------------------------------------------------------------------------------
function public.use_petal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_petal" );
    cmn.CallEventHandler( "use_petal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_petal") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_petal_inv" );
  cmn.CallEventHandler( "use_petal_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boiler_anm_cover", "use_petal", func_end );
  SoundSfx( "aud_use_petal_laboratory" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ruby1" ] = { type = "get", get_obj = "spr_boiler_ruby1", room = "rm_laboratory", zz = "zz_boiler", zz_gate = "gzz_laboratory_boiler" };

private.get_ruby1_logic = function()
  
end;
private.get_ruby1_inv = function()
  interface.InventoryItemAdd("inv_ruby1","spr_boiler_ruby1");
end;
private.get_ruby1_beg = function()
  ObjDelete("gfx_boiler_ruby1")
end;
private.get_ruby1_end = function()
  if common_impl.ZzCompleteCheck("get_ruby1") then ObjSet( common_impl.hint["get_ruby1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boiler_sh_ruby1");
end;

cmn.AddSubscriber( "get_ruby1", private.get_ruby1_inv );
cmn.AddSubscriber( "get_ruby1", private.get_ruby1_beg, private.room_objname );
cmn.AddSubscriber( "get_ruby1", private.get_ruby1_end, private.room_objname );
cmn.AddSubscriber( "get_ruby1", private.get_ruby1_logic );
--------------------------------------------------------------------
function public.get_ruby1()
  cmn.SetEventDone( "get_ruby1" );
  cmn.CallEventHandler( "get_ruby1" );
  if common_impl.ZzCompleteCheck("get_ruby1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_gaff" ] = { type = "get", get_obj = "spr_boiler_gaff", room = "rm_laboratory", zz = "zz_boiler", zz_gate = "gzz_laboratory_boiler" };

private.get_gaff_logic = function()
  
end;
private.get_gaff_inv = function()
  interface.InventoryItemAdd("inv_gaff","spr_boiler_gaff");
end;
private.get_gaff_beg = function()
  ObjDelete("gfx_boiler_gaff")
end;
private.get_gaff_end = function()
  if common_impl.ZzCompleteCheck("get_gaff") then ObjSet( common_impl.hint["get_gaff"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boiler_sh_gaff");
end;

cmn.AddSubscriber( "get_gaff", private.get_gaff_inv );
cmn.AddSubscriber( "get_gaff", private.get_gaff_beg, private.room_objname );
cmn.AddSubscriber( "get_gaff", private.get_gaff_end, private.room_objname );
cmn.AddSubscriber( "get_gaff", private.get_gaff_logic );
--------------------------------------------------------------------
function public.get_gaff()
  cmn.SetEventDone( "get_gaff" );
  cmn.CallEventHandler( "get_gaff" );
  if common_impl.ZzCompleteCheck("get_gaff") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wardrobe *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fish_zone_clk()  --rm_laboratory.use_fish_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_fish' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_medium_wood" );
  ld.AnimPlay( "anm_wardrobe_anm_right", "idle_door_2", func_end )
  
end;  


common_impl.hint[ "use_fish" ] = { type = "use", inv_obj = "inv_fish", use_place = "gfx_wardrobe_fish_zone", room = "rm_laboratory", zz = "zz_wardrobe", zz_gate = "gzz_laboratory_wardrobe" };

private.use_fish_logic = function()
  ObjSet( "spr_wardrobe_tweezers", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_wardrobe_container", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_wardrobe_tweezers", {active = 1, visible = 1} );
  ObjSet( "gfx_wardrobe_container", {active = 1, visible = 1} );
end;
private.use_fish_inv = function()
  common_impl.ProcessMultiUseAll("fish", "fish")
end;
private.use_fish_beg = function()
  ObjDelete( "gfx_wardrobe_fish_zone" );
end;
private.use_fish_end = function()
  if common_impl.ZzCompleteCheck("use_fish") then ObjSet( common_impl.hint["use_fish"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_wardrobe_anm_right");
  ObjDelete("spr_laboratory_tr_s3");
  ObjSet( "spr_laboratory_tr_s8", {visible = 1} );
  ObjSet( "obj_wardrobe_text", {input = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fish", private.use_fish_inv );
cmn.AddSubscriber( "use_fish", private.use_fish_beg, private.room_objname );
cmn.AddSubscriber( "use_fish", private.use_fish_end, private.room_objname );
cmn.AddSubscriber( "use_fish", private.use_fish_logic );
cmn.AddSubscriber( "use_fish_inv", private.use_fish_inv, private.room_objname );
cmn.AddSubscriber( "use_fish_beg", private.use_fish_beg, private.room_objname );
cmn.AddSubscriber( "use_fish_end", private.use_fish_end, private.room_objname );
cmn.AddSubscriber( "use_fish_end", private.use_fish_logic );
--------------------------------------------------------------------------------------------
function public.use_fish( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fish" );
    cmn.CallEventHandler( "use_fish_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fish") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fish_inv" );
  cmn.CallEventHandler( "use_fish_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wardrobe_anm_right", "use_fish", func_end );
  SoundSfx( "aud_use_fish_laboratory" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tweezers" ] = { type = "get", get_obj = "spr_wardrobe_tweezers", room = "rm_laboratory", zz = "zz_wardrobe", zz_gate = "gzz_laboratory_wardrobe" };

private.get_tweezers_logic = function()
  
end;
private.get_tweezers_inv = function()
  interface.InventoryItemAdd("inv_tweezers","spr_wardrobe_tweezers");
end;
private.get_tweezers_beg = function()
  ObjDelete("gfx_wardrobe_tweezers")
end;
private.get_tweezers_end = function()
  if common_impl.ZzCompleteCheck("get_tweezers") then ObjSet( common_impl.hint["get_tweezers"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_wardrobe_sh_tweezers");
  ObjDelete("spr_laboratory_tr_s6");
end;

cmn.AddSubscriber( "get_tweezers", private.get_tweezers_inv );
cmn.AddSubscriber( "get_tweezers", private.get_tweezers_beg, private.room_objname );
cmn.AddSubscriber( "get_tweezers", private.get_tweezers_end, private.room_objname );
cmn.AddSubscriber( "get_tweezers", private.get_tweezers_logic );
--------------------------------------------------------------------
function public.get_tweezers()
  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );
  if common_impl.ZzCompleteCheck("get_tweezers") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_container" ] = { type = "get", get_obj = "spr_wardrobe_container", room = "rm_laboratory", zz = "zz_wardrobe", zz_gate = "gzz_laboratory_wardrobe" };

private.get_container_logic = function()
  
end;
private.get_container_inv = function()
  interface.InventoryItemAdd("inv_container","spr_wardrobe_container");
  ObjSet( "inv_container", { drag = 0 } );
end;
private.get_container_beg = function()
  ObjDelete("gfx_wardrobe_container")
end;
private.get_container_end = function()
  if common_impl.ZzCompleteCheck("get_container") then ObjSet( common_impl.hint["get_container"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_wardrobe_sh_container");
  ObjDelete("spr_laboratory_soporif");
end;

cmn.AddSubscriber( "get_container", private.get_container_inv );
cmn.AddSubscriber( "get_container", private.get_container_beg, private.room_objname );
cmn.AddSubscriber( "get_container", private.get_container_end, private.room_objname );
cmn.AddSubscriber( "get_container", private.get_container_logic );
--------------------------------------------------------------------
function public.get_container()
  cmn.SetEventDone( "get_container" );
  cmn.CallEventHandler( "get_container" );
  if common_impl.ZzCompleteCheck("get_container") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuletinfinity_zone_clk()  --rm_laboratory.use_amuletinfinity_zone_clk()
  local func_end = function() 
    ld.Lock(0); 
    common_impl.ShowBbt( 'need_amuletinfinity' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_medium_wood" );
  ld.AnimPlay( "anm_wardrobe_anm_left", "idle_door_1", func_end )
end;  

common_impl.hint[ "use_amuletinfinity" ] = { type = "use", inv_obj = "inv_amuletinfinity", use_place = "gfx_wardrobe_amuletinfinity_zone", room = "rm_laboratory", zz = "zz_wardrobe", zz_gate = "gzz_laboratory_wardrobe" };

private.use_amuletinfinity_logic = function()
  ObjSet( "spr_wardrobe_maple", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletinfinity_inv = function()
  common_impl.ProcessMultiUseAll("amuletinfinity", "amuletinfinity")
end;
private.use_amuletinfinity_beg = function()
  ObjDelete( "gfx_wardrobe_amuletinfinity_zone" );
end;
private.use_amuletinfinity_end = function()
  if common_impl.ZzCompleteCheck("use_amuletinfinity") then ObjSet( common_impl.hint["use_amuletinfinity"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_wardrobe_anm_left", {animfunc = "use_amulet", frame = 999 } );
  ObjSet( "gfx_wardrobe_maple", {active = 1, visible = 1} );
  ObjDelete("spr_laboratory_tr_4");
  ObjSet( "spr_laboratory_tr_s7", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletinfinity", private.use_amuletinfinity_inv );
cmn.AddSubscriber( "use_amuletinfinity", private.use_amuletinfinity_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletinfinity", private.use_amuletinfinity_end, private.room_objname );
cmn.AddSubscriber( "use_amuletinfinity", private.use_amuletinfinity_logic );
cmn.AddSubscriber( "use_amuletinfinity_inv", private.use_amuletinfinity_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletinfinity_beg", private.use_amuletinfinity_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletinfinity_end", private.use_amuletinfinity_end, private.room_objname );
cmn.AddSubscriber( "use_amuletinfinity_end", private.use_amuletinfinity_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletinfinity( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletinfinity" );
    cmn.CallEventHandler( "use_amuletinfinity_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletinfinity") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletinfinity_inv" );
  cmn.CallEventHandler( "use_amuletinfinity_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wardrobe_anm_left", "use_amulet", func_end );
  SoundSfx( "aud_use_amuletinfinity_laboratory" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_maple" ] = { type = "get", get_obj = "spr_wardrobe_maple", room = "rm_laboratory", zz = "zz_wardrobe", zz_gate = "gzz_laboratory_wardrobe" };

private.get_maple_logic = function()
  
end;
private.get_maple_inv = function()
  interface.InventoryItemAdd("inv_maple","spr_wardrobe_maple");
end;
private.get_maple_beg = function()
  ObjDelete("gfx_wardrobe_maple")
end;
private.get_maple_end = function()
  if common_impl.ZzCompleteCheck("get_maple") then ObjSet( common_impl.hint["get_maple"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_wardrobe_sh_maple");
  ObjDelete("spr_laboratory_tr_s5");
end;

cmn.AddSubscriber( "get_maple", private.get_maple_inv );
cmn.AddSubscriber( "get_maple", private.get_maple_beg, private.room_objname );
cmn.AddSubscriber( "get_maple", private.get_maple_end, private.room_objname );
cmn.AddSubscriber( "get_maple", private.get_maple_logic );
--------------------------------------------------------------------
function public.get_maple()
  cmn.SetEventDone( "get_maple" );
  cmn.CallEventHandler( "get_maple" );
  if common_impl.ZzCompleteCheck("get_maple") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doorinflor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_littlechest" ] = { type = "get", get_obj = "spr_doorinflor_littlechest", room = "rm_laboratory", zz = "zz_doorinflor", zz_gate = "gzz_laboratory_doorinflor" };

private.get_littlechest_logic = function()
  ObjSet( "gfx_doorinflor_cork_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_littlechest_inv = function()
  interface.InventoryItemAdd("inv_littlechest","spr_doorinflor_littlechest");
  ObjSet( "inv_littlechest", { drag = 0 } );
end;
private.get_littlechest_beg = function()
  ObjDelete("gfx_doorinflor_littlechest")
end;
private.get_littlechest_end = function()
  if common_impl.ZzCompleteCheck("get_littlechest") then ObjSet( common_impl.hint["get_littlechest"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_doorinflor_sh_littlechest");
  ObjDelete("spr_laboratory_tr_n5");
end;

cmn.AddSubscriber( "get_littlechest", private.get_littlechest_inv );
cmn.AddSubscriber( "get_littlechest", private.get_littlechest_beg, private.room_objname );
cmn.AddSubscriber( "get_littlechest", private.get_littlechest_end, private.room_objname );
cmn.AddSubscriber( "get_littlechest", private.get_littlechest_logic );
--------------------------------------------------------------------
function public.get_littlechest()
  cmn.SetEventDone( "get_littlechest" );
  cmn.CallEventHandler( "get_littlechest" );
  if common_impl.ZzCompleteCheck("get_littlechest") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_cork_zone_clk() --rm_laboratory.use_cork_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_cork' );
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_corks_laboratory" );
  for i=1,3,1 do 
     ld.AnimPlay( "anm_doorinflor_anm_"..i, i, function() end )  
  end;  
  ld.StartTimer( 0.5, func_end );   
end;  


common_impl.hint[ "use_cork" ] = { type = "use", inv_obj = "inv_cork", use_place = "gfx_doorinflor_cork_zone", room = "rm_laboratory", zz = "zz_doorinflor", zz_gate = "gzz_laboratory_doorinflor" };

private.use_cork_logic = function()
  ObjSet( "obj_doorinflor_mmg_root", { visible = 1, input = 1, active = 1 } )

end;
private.use_cork_inv = function()
  common_impl.ProcessMultiUseAll("cork", "cork")
end;
private.use_cork_beg = function()
  ObjDelete( "gfx_doorinflor_cork_zone" );
end;
private.use_cork_end = function()
  if common_impl.ZzCompleteCheck("use_cork") then ObjSet( common_impl.hint["use_cork"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doorinflor_anm", {animfunc = "end", frame = 0 } );
  ObjSet( "anm_doorinflor_anm_4", {visible = 1} );
  ObjSet( "spr_laboratory_tr_n3", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cork", private.use_cork_inv );
cmn.AddSubscriber( "use_cork", private.use_cork_beg, private.room_objname );
cmn.AddSubscriber( "use_cork", private.use_cork_end, private.room_objname );
cmn.AddSubscriber( "use_cork", private.use_cork_logic );
cmn.AddSubscriber( "use_cork_inv", private.use_cork_inv, private.room_objname );
cmn.AddSubscriber( "use_cork_beg", private.use_cork_beg, private.room_objname );
cmn.AddSubscriber( "use_cork_end", private.use_cork_end, private.room_objname );
cmn.AddSubscriber( "use_cork_end", private.use_cork_logic );
--------------------------------------------------------------------------------------------
function public.use_cork( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cork" );
    cmn.CallEventHandler( "use_cork_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cork") then ld.CloseSubRoom() end;
    private.init_corks()    
    cmn.MiniGameShow( "corks" );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cork_inv" );
  cmn.CallEventHandler( "use_cork_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doorinflor_anm", "use_bung", func_end );
  SoundSfx( "aud_use_cork_laboratory" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_corks" ] = { type = "click", use_place = "obj_doorinflor_mmg_root", room = "rm_laboratory", zz = "zz_doorinflor", zz_gate = "gzz_laboratory_doorinflor" };

private.win_corks_logic = function()
  if cmn.IsEventDone("win_corks") then 
    ObjSet( "spr_doorinflor_amuletinfinity", { visible = 1, input = 1, active = 1 } )
    ObjDelete("obj_doorinflor_mmg_root");
  end;
end;
private.win_corks_beg = function()
  if cmn.IsEventDone("win_corks") then 
    -- ObjDelete( "gfx_doorinflor_win_corks_zone" );
  end;
end;
private.win_corks_end = function()
  if cmn.IsEventDone("win_corks") then 
    ObjDelete("obj_doorinfloor_corks_anm_root");
    if common_impl.ZzCompleteCheck("win_corks") then ObjSet( common_impl.hint["win_corks"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjSet( "anm_doorinflor_anm", {animfunc = "open_end", frame = 0 } );
    ObjSet( "spr_doorinflor_sh_amuletinfinity", {visible = 1} );
    ObjDelete("spr_laboratory_tr_n1");
    ObjSet( "spr_laboratory_tr_n2", {visible = 1} );
    ObjSet( "spr_laboratory_tr_n4", {visible = 1} );
    ObjDelete("spr_laboratory_tr_n3");
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_corks", private.win_corks_beg, private.room_objname );
cmn.AddSubscriber( "win_corks", private.win_corks_end, private.room_objname );
cmn.AddSubscriber( "win_corks", private.win_corks_logic );
cmn.AddSubscriber( "win_corks_beg", private.win_corks_beg, private.room_objname );
cmn.AddSubscriber( "win_corks_end", private.win_corks_end, private.room_objname );
cmn.AddSubscriber( "win_corks_end", private.win_corks_logic );
--------------------------------------------------------------------------------------------
function public.win_corks()

  local func_end = function()
    cmn.MiniGameHide( "corks", true ); 
    cmn.SetEventDone( "win_corks" );
    cmn.CallEventHandler( "win_corks_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_corks") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_corks_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_mmg_corks_win" );
  --  func_end()
  ObjSet( "anm_doorinflor_anm", {animfunc = "open", frame = 0 } );
  ObjSet( "obj_doorinflor_mmg_root", {visible = 0} );
  ObjSet( "obj_doorinfloor_corks_anm_root", {visible = 0} );
  ld.AnimPlay( "anm_doorinflor_anm", "open", func_end )
end;
----------------------------------------------------------------------------------------
private.corks_fig_array={"clubs","diamonds","hearts","spades"};
private.corks_fig_fp_array={4,3,2,1};

function public.corks_mmg_fp_stand(with_state)
  for i=1,4,1 do 
    for j=1,4,1 do 
      ObjSet( "spr_doorinflor_"..private.corks_fig_array[j].."_"..i, {visible = 0} );
    end;  
  end;  
  for i=1,4,1 do 
    ObjSet( "spr_doorinflor_"..private.corks_fig_array[private.corks_fig_fp_array[i] ].."_"..i, {visible = 1} );
  end;  
end;  

---------------------------------------------------------
private.corks_parts_first_init_flag = false;
function private.corks_parts_first_init()
  if private.corks_parts_first_init_flag == false then 
    for i=1,4,1 do
      ObjSet( "obj_doorinflor_mmg_zone_"..i, {event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)", event_mdown="rm_laboratory.win_corks_part_mdown("..i..")"} );
    end;  
    
  end;

  private.corks_parts_first_init_flag = true;  
end;  


function private.init_corks()
  private.corks_parts_first_init();
  
  if not (cmn.IsEventStart("win_corks")) then
    ng_global.progress["std"]["win_corks"].state = {}
    ng_global.progress["std"]["win_corks"].state = ld.TableCopy(private.corks_fig_fp_array);
  else  
   
  end
  private.win_corks_stand_pos();  
end

function private.win_corks_stand_pos(without_win_ver)
  for i=1,4,1 do 
    for j=1,4,1 do 
      ObjSet( "spr_doorinflor_"..private.corks_fig_array[j].."_"..i, {visible = 0, alp=1} );
    end;  
  end;  
  for i=1,4,1 do 
    ObjSet( "spr_doorinflor_"..private.corks_fig_array[ ng_global.progress["std"]["win_corks"].state[i] ].."_"..i, {visible = 1, alp=1} );
  end; 
  
  if without_win_ver~=1 then 
     private.win_corks_win_ver();
  end;
end;  

function private.win_corks_win_ver()
  local count=0;
  for i=1,4,1 do 
    if ng_global.progress["std"]["win_corks"].state[i]==2 then count=count+1; end;
  end;  
  
  if count==4 then  public.win_corks(); end;
end

------------------------------------------------------------
private.corks_mdown_parts_connect_array={{1,4},{2,3},{1,3},{2,4}};
function public.win_corks_part_mdown(z_num)
  local func_end = function()
    ld.Lock(0);
    private.win_corks_stand_pos();
  end;  
  
  
  ld.Lock(1);
  public.win_corks_part_step(private.corks_mdown_parts_connect_array[z_num][1]); 
  public.win_corks_part_step(private.corks_mdown_parts_connect_array[z_num][2]); 
  local fuck_num = z_num;
  if fuck_num == 4 then fuck_num=3; elseif fuck_num==3 then fuck_num=4; end;
  SoundSfx( "aud_mmg_corks_click" )
  ld.AnimPlay( "anm_doorinflor_anm_"..fuck_num, fuck_num, func_end ) 
end;  
--------------------------------------------------------------
function  public.win_corks_part_step(num) --rm_laboratory.win_corks_part_mdown()
  local next_fig = ng_global.progress["std"]["win_corks"].state[num]+1;
  if next_fig>4 then next_fig=1; end;
  
  local func_end = function()
    ng_global.progress["std"]["win_corks"].state[num] = next_fig;
   -- ld.Lock(0);
  --  private.win_corks_stand_pos();
  end;  
  
 
 -- ld.Lock(1);
  ObjAnimate( "spr_doorinflor_"..private.corks_fig_array[ ng_global.progress["std"]["win_corks"].state[num] ].."_"..num, 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
 -- ld.LogTrace( "spr_doorinflor_"..private.corks_fig_array[ next_fig ].."_"..num );  
  ObjSet( "spr_doorinflor_"..private.corks_fig_array[ next_fig ].."_"..num, {visible=1, alp=0} );
  ObjAnimate( "spr_doorinflor_"..private.corks_fig_array[ next_fig ].."_"..num, 8, 0, 0, func_end, {0,0,0, 0.3,0,1} );   
end;  


function  private.win_corks_skip()
  local func_end = function()
      ng_global.progress["std"]["win_corks"].state={2,2,2,2};
      private.win_corks_stand_pos(1); --without win ver
      ObjAnimate( "obj_doorinflor_mmg_root", 8, 0, 0, function()  private.win_corks_stand_pos(); end, {0,0,0, 0.3,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_doorinflor_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  

function  private.win_corks_reset()
  local func_end = function()
     
      ng_global.progress["std"]["win_corks"].state=ld.TableCopy(private.corks_fig_fp_array);
      private.win_corks_stand_pos(); --without win ver
      ObjAnimate( "obj_doorinflor_mmg_root", 8, 0, 0, function()  ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_doorinflor_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletinfinity" ] = { type = "get", get_obj = "spr_doorinflor_amuletinfinity", room = "rm_laboratory", zz = "zz_doorinflor", zz_gate = "gzz_laboratory_doorinflor" };

private.get_amuletinfinity_logic = function()
  
end;
private.get_amuletinfinity_inv = function()
  interface.InventoryItemAdd("inv_amuletinfinity","spr_doorinflor_amuletinfinity");
end;
private.get_amuletinfinity_beg = function()
  ObjDelete("gfx_doorinflor_amuletinfinity")
end;
private.get_amuletinfinity_end = function()
  if common_impl.ZzCompleteCheck("get_amuletinfinity") then ObjSet( common_impl.hint["get_amuletinfinity"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_doorinflor_sh_amuletinfinity");
  ObjDelete("spr_laboratory_tr_n4");
end;

cmn.AddSubscriber( "get_amuletinfinity", private.get_amuletinfinity_inv );
cmn.AddSubscriber( "get_amuletinfinity", private.get_amuletinfinity_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletinfinity", private.get_amuletinfinity_end, private.room_objname );
cmn.AddSubscriber( "get_amuletinfinity", private.get_amuletinfinity_logic );
--------------------------------------------------------------------
function public.get_amuletinfinity()
  cmn.SetEventDone( "get_amuletinfinity" );
  cmn.CallEventHandler( "get_amuletinfinity" );
  if common_impl.ZzCompleteCheck("get_amuletinfinity") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_doorinflor" ) and not ld.CheckRequirements( { "win_corks" } ) then  
    private.win_corks_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_doorinflor" ) and not ld.CheckRequirements( { "win_corks" } ) then  
    private.win_corks_skip()
  end;
  
end
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_laboratory();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_laboratory_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_doorinflor" );
  function zz_doorinflor.Open()
  end;
  function zz_doorinflor.PreOpen()
    if not cmn.IsEventStart("win_corks") then 
      public.corks_mmg_fp_stand();
    end;  
    
    if cmn.IsEventStart("win_corks") and not cmn.IsEventDone("win_corks") then 
        cmn.MiniGameShow( "corks" ); 
        private.init_corks()
    end;  
  end;
  function zz_doorinflor.PreClose()
  end;
  function zz_doorinflor.Close()
    if cmn.IsEventStart("win_corks") and not cmn.IsEventDone("win_corks") then 
      cmn.MiniGameHide( "corks" ); 
    end; 
  end;

  subroom.Define( "zz_wardrobe" );
  function zz_wardrobe.Open()
  end;
  function zz_wardrobe.PreOpen()
  end;
  function zz_wardrobe.PreClose()
  end;
  function zz_wardrobe.Close()
  end;

  subroom.Define( "zz_boiler" );
  function zz_boiler.Open()
  end;
  function zz_boiler.PreOpen()
    SoundEnv("aud_bubbles_fire_env",1);
  end;
  function zz_boiler.PreClose()
  end;
  function zz_boiler.Close()
    SoundEnv("aud_bubbles_fire_env",0);
  end;

  subroom.Define( "zz_worktable" );
  function zz_worktable.Open()
  end;
  function zz_worktable.PreOpen()
  end;
  function zz_worktable.PreClose()
  end;
  function zz_worktable.Close()
  end;
  
end;
--*********************************************************************************************************************
function public.laboratory_idle_clk()  --rm_laboratory.laboratory_idle_clk()
  local func_end = function()
     ObjSet( "obj_laboratory_anm_clk_zone", {input=1} );
  end;  
  
  SoundSfx( "aud_touch_grass_chandelier_laboratory" ); 
  ObjSet( "obj_laboratory_anm_clk_zone", {input=0} );
  ld.AnimPlay( "anm_laboratory_anm_cklik", "cklik", func_end )
end;  
-------------------------------------------------------------------------------------------------
function public.laboratory_idle_clk1()  --rm_laboratory.laboratory_idle_clk1()
  local func_end = function()
     ObjSet( "obj_laboratory_anm_clk1_zone", {input=1} );
  end;  
  
  SoundSfx( "aud_touch_grass_laboratory" );  
  ObjSet( "obj_laboratory_anm_clk1_zone", {input=0} );
  ld.AnimPlay( "anm_laboratory_anm_cklik1", "cklik1", func_end )
end;  
------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------
function public.laboratory_idle_clk2()  --rm_laboratory.laboratory_idle_clk2()
  local func_end = function()
    ObjSet( "obj_laboratory_anm_clk2_zone", {input=1} );
  end;  
  
  SoundSfx( "aud_touch_grass_laboratory" ); 
  ObjSet( "obj_laboratory_anm_clk2_zone", {input=0} );
  ld.AnimPlay( "anm_laboratory_anm_cklik2", "cklik2", func_end )
end;  
------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------
function public.laboratory_idle_clk3()  --rm_laboratory.laboratory_idle_clk3()
  local func_end = function()
    ObjSet( "obj_laboratory_anm_clk3_zone", {input=1} );
  end;  
  
  SoundSfx( "aud_touch_grass_laboratory" ); 
  ObjSet( "obj_laboratory_anm_clk3_zone", {input=0} );
  ld.AnimPlay( "anm_laboratory_anm_cklik3", "cklik3", func_end )
end;  
------------------------------------------------------------------------