-- name=rm_nearhouse
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearhouse";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_nearhouse()
  if not ( cmn.IsEventDone( "opn_nearhouse" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_nearhouse" );
      cmn.CallEventHandler( "opn_nearhouse" )
      ld.ShowBbtOpn( private.room_objname )
  end;
    func_end();
  end;

  if cmn.IsEventDone("win_onroadwaymg") and not cmn.IsEventDone("win_onroadwaymg_nearhouse") then 
    public.win_onroadwaymg_nearhouse();
  end;
  
  if not cmn.IsEventDone("clk_nearmonument") then 
    public.clk_nearmonument();
  end;  
end;
--------------------------------------------------------------------
local opn_nearhouse = function() end;
local opn_nearhouse_logic = function() end;
cmn.AddSubscriber( "opn_nearhouse", opn_nearhouse_logic )
cmn.AddSubscriber( "opn_nearhouse", opn_nearhouse, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_nearmonument" ] = { type = "click", use_place = "gfx_nearhouse_clk_nearmonument_zone", room = "rm_nearhouse" };

private.clk_nearmonument_logic = function()
   ObjSet( "gzz_nearhouse_ivy", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_nearhouse_ontree", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_nearhouse_doorhouse", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_nearhouse_veranda", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_nearhouse_onroadway", {active=1, input = 1, visible = 1} );
   ObjSet( "gzz_nearhouse_girlstatue", {active=1, input = 1, visible = 1} );   
   
end;
private.clk_nearmonument_beg = function()
  ObjDelete( "gfx_nearhouse_clk_nearmonument_zone" );
end;
private.clk_nearmonument_end = function()
  ObjDelete("vid_nearhouse_vid_nearmonument");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_nearmonument", private.clk_nearmonument_beg, private.room_objname );
cmn.AddSubscriber( "clk_nearmonument", private.clk_nearmonument_end, private.room_objname );
cmn.AddSubscriber( "clk_nearmonument", private.clk_nearmonument_logic );
cmn.AddSubscriber( "clk_nearmonument_beg", private.clk_nearmonument_beg, private.room_objname );
cmn.AddSubscriber( "clk_nearmonument_end", private.clk_nearmonument_end, private.room_objname );
cmn.AddSubscriber( "clk_nearmonument_end", private.clk_nearmonument_logic );
--------------------------------------------------------------------------------------------
function public.clk_nearmonument()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_nearmonument" );
--    cmn.CallEventHandler( "clk_nearmonument_end" );
--    common_impl.Lock(0);
--    ld.ShowBbt("after_nearmonument");
--  end;
--
--  local func_preend = function()
--    -- ld.Lock(1)
--    -- SoundVid( 0 ); 
--     --  int.DialogVideoHide();
--     ld.StartTimer( 0.1, func_end )
--  end;  
--  
--  cmn.CallEventHandler( "clk_nearmonument_beg" );
--  --common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  --SoundSfx( "aud_clk_nearmonument" )
--  --func_end()
--  
--  ld.Lock(1)
--  --SoundEnv(0);
--  SoundSfx( "aud_anmfly" )
--  VidPlay( "vid_nearhouse_vid_nearmonument", func_preend )
--  --int.DialogVideoShow( "vid_nearhouse_vid_nearmonument", 1, func_preend, 1 );
--  

 local widget_settings = 
  {
    InterfaceWidget_Inventory,
    InterfaceWidget_BtnHint,
    InterfaceWidget_BtnGuide,
    InterfaceWidget_BtnMenu,
    InterfaceWidget_BtnMap,
  }

  local func_end = function()
    ld.ShowBbt("after_nearmonument");
    ObjAnimate( "vid_nearhouse_vid_nearmonument", 8, 0, 0, function()
      
      SoundEnv( "aud_nearhouse_env" ) 
      SoundTheme( "aud_danger_moment2_mus" );
      cmn.SetEventDone( "clk_nearmonument" );
      cmn.CallEventHandler( "clk_nearmonument_end" );
      common_impl.Lock(0);
      --  ld.ShowBbt("after_anmfly");
      level.tutorial_map1.first()
      end, {0,0,1, 0.5,0,0} );
    
  end;

  cmn.CallEventHandler( "clk_nearmonument_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  -- SoundSfx( "aud_clk_anmfly" )
  -- func_end()

  
  ------------------------------------------------
  
  local func_preend = function()
    ld.Lock(1)
    --SoundVid( 0 );
    
    int.DialogVideoHide();
    for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 1, true );
    end; 
    --ObjAnimate( "vid_square_vid_anmfly", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
    
      --ld.StartTimer( 0.5, func_end )
    func_end();  
  end;  
  
  
  for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 0, false );
  end;
  
  --ObjAttach("vid_square_vid_anmfly","rm_square");
  
  SoundTheme( 0 )
  SoundEnv(0);
--  SoundSfx( "aud_clk_nearmonument_nearhouse" )
--  VidPlay( "vid_nearhouse_vid_nearmonument", func_preend )
--  int.DialogVideoShow( "", 1,function() SoundSfx( 0 ); func_preend() end, 1 );
  SndPlay( "assets/levels/common/audio/aud_clk_nearmonument_nearhouse", "sfx", 0, 0.5 );
  --SoundSfx( "aud_clk_anmfly_square" )
  VidPlay( "vid_nearhouse_vid_nearmonument",function() func_preend(); ld.StartTimer( 3, function() SndStop( "assets/levels/common/audio/aud_clk_nearmonument_nearhouse", 0.5 ) end ); end)
  int.DialogVideoShow( "", 1,function()  SndStop( "assets/levels/common/audio/aud_clk_nearmonument_nearhouse", 0.5 ) func_preend(); end, 1 );
end;
--------------------------------------------------------------------------------------------
--common_impl.hint[ "win_onroadwaymg" ] = {type = "win", use_place = "mg_onroadwaymg", room = "rm_nearhouse", zz = "mg_onroadwaymg", zz_gate = "gmg_nearhouse_onroadwaymg" };

  local win_onroadwaymg_nearhouse_logic = function()
    ObjSet( "grm_nearhouse_roadway", {active=1, input = 1, visible = 1} );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearhouse_roadway_focus");
    end;
    ObjDelete("gmg_nearhouse_onroadwaymg");
  end;
  local win_onroadwaymg_nearhouse = function()
    ObjSet( "anm_nearhouse_anm_neardoktor_roadway", {animfunc = "open_roadway", frame = 999 } );
  end;
  cmn.AddSubscriber("win_onroadwaymg_nearhouse", win_onroadwaymg_nearhouse, private.room_objname )
  cmn.AddSubscriber("win_onroadwaymg_nearhouse", win_onroadwaymg_nearhouse_logic )
  
  function public.win_onroadwaymg_nearhouse()
    local func_end = function()
       ld.Lock(0);
       cmn.SetEventDone( "win_onroadwaymg_nearhouse" );
       cmn.CallEventHandler( "win_onroadwaymg_nearhouse" );
    end;  
    
    ld.Lock(1)
    ld.StartTimer( 0.3, function()
      SoundSfx( "aud_open_gate_2_nearhouse" );
      ld.AnimPlay( "anm_nearhouse_anm_neardoktor_roadway", "open_roadway", func_end )
    end )
  end;  
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_onroadway *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_leathergloves" ] = { type = "get", get_obj = "spr_onroadway_leathergloves", room = "rm_nearhouse", zz = "zz_onroadway", zz_gate = "gzz_nearhouse_onroadway" };

private.get_leathergloves_logic = function()
  ObjSet( "gfx_onroadway_partpattern_zone", {active=1, input = 1, visible = 1} );
end;
private.get_leathergloves_inv = function()
  interface.InventoryItemAdd("inv_leathergloves","spr_onroadway_leathergloves");
end;
private.get_leathergloves_beg = function()
  ObjDelete("gfx_onroadway_leathergloves")
end;
private.get_leathergloves_end = function()
  if common_impl.ZzCompleteCheck("get_leathergloves") then ObjSet( common_impl.hint["get_leathergloves"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_nearhouse_glove");
end;

cmn.AddSubscriber( "get_leathergloves", private.get_leathergloves_inv );
cmn.AddSubscriber( "get_leathergloves", private.get_leathergloves_beg, private.room_objname );
cmn.AddSubscriber( "get_leathergloves", private.get_leathergloves_end, private.room_objname );
cmn.AddSubscriber( "get_leathergloves", private.get_leathergloves_logic );
--------------------------------------------------------------------
function public.get_leathergloves()
  cmn.SetEventDone( "get_leathergloves" );
  cmn.CallEventHandler( "get_leathergloves" );
  if common_impl.ZzCompleteCheck("get_leathergloves") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_star_zone_clk()  --rm_nearhouse.use_star_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_star' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_star_place_nearhouse" )
  ld.AnimPlay( "anm_onroadway_anm_onroa_box", "idle_door", func_end )
end;  


common_impl.hint[ "use_star" ] = { type = "use", inv_obj = "inv_star", use_place = "gfx_onroadway_star_zone", room = "rm_nearhouse", zz = "zz_onroadway", zz_gate = "gzz_nearhouse_onroadway" };

private.use_star_logic = function()
  ObjSet( "spr_onroadway_camomile4", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_onroadway_scissors", { visible = 1, input = 1, active = 1 } )

end;
private.use_star_inv = function()
  common_impl.ProcessMultiUseAll("star", "star")
end;
private.use_star_beg = function()
  ObjDelete( "gfx_onroadway_star_zone" );
end;
private.use_star_end = function()
  if common_impl.ZzCompleteCheck("use_star") then ObjSet( common_impl.hint["use_star"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_onroadway_sh_camomile4", {visible = 1} );
  ObjDelete("anm_onroadway_anm_onroa_box");
  ObjDelete("spr_nearhouse_door_star");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_star", private.use_star_inv );
cmn.AddSubscriber( "use_star", private.use_star_beg, private.room_objname );
cmn.AddSubscriber( "use_star", private.use_star_end, private.room_objname );
cmn.AddSubscriber( "use_star", private.use_star_logic );
cmn.AddSubscriber( "use_star_inv", private.use_star_inv, private.room_objname );
cmn.AddSubscriber( "use_star_beg", private.use_star_beg, private.room_objname );
cmn.AddSubscriber( "use_star_end", private.use_star_end, private.room_objname );
cmn.AddSubscriber( "use_star_end", private.use_star_logic );
--------------------------------------------------------------------------------------------
function public.use_star( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_star" );
    cmn.CallEventHandler( "use_star_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_star") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_star_inv" );
  cmn.CallEventHandler( "use_star_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onroadway_anm_onroa_box", "use_door", func_end );
  SoundSfx( "aud_use_star_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_camomile4" ] = { type = "get", get_obj = "spr_onroadway_camomile4", room = "rm_nearhouse", zz = "zz_onroadway", zz_gate = "gzz_nearhouse_onroadway" };

private.get_camomile4_logic = function()
  
end;
private.get_camomile4_inv = function()
  interface.InventoryItemAdd("inv_camomile","spr_onroadway_camomile4",function() level_inv.ProcessGetCamomileAll( "get_camomile4" ) end);
end;
private.get_camomile4_beg = function()
  ObjDelete("gfx_onroadway_camomile4")
end;
private.get_camomile4_end = function()
  if common_impl.ZzCompleteCheck("get_camomile4") then ObjSet( common_impl.hint["get_camomile4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_onroadway_sh_camomile4")
  ObjDelete("spr_nearhouse_cham");
end;

cmn.AddSubscriber( "get_camomile4", private.get_camomile4_inv );
cmn.AddSubscriber( "get_camomile4", private.get_camomile4_beg, private.room_objname );
cmn.AddSubscriber( "get_camomile4", private.get_camomile4_end, private.room_objname );
cmn.AddSubscriber( "get_camomile4", private.get_camomile4_logic );
--------------------------------------------------------------------
function public.get_camomile4()
  cmn.SetEventDone( "get_camomile4" );
  cmn.CallEventHandler( "get_camomile4" );
  if common_impl.ZzCompleteCheck("get_camomile4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scissors" ] = { type = "get", get_obj = "spr_onroadway_scissors", room = "rm_nearhouse", zz = "zz_onroadway", zz_gate = "gzz_nearhouse_onroadway" };

private.get_scissors_logic = function()
  
end;
private.get_scissors_inv = function()
  interface.InventoryItemAdd("inv_scissors","spr_onroadway_scissors");
end;
private.get_scissors_beg = function()
  ObjDelete("gfx_onroadway_scissors")
end;
private.get_scissors_end = function()
  if common_impl.ZzCompleteCheck("get_scissors") then ObjSet( common_impl.hint["get_scissors"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_onroadway_sh_scissors");
  ObjDelete("spr_nearhouse_scissors");
end;

cmn.AddSubscriber( "get_scissors", private.get_scissors_inv );
cmn.AddSubscriber( "get_scissors", private.get_scissors_beg, private.room_objname );
cmn.AddSubscriber( "get_scissors", private.get_scissors_end, private.room_objname );
cmn.AddSubscriber( "get_scissors", private.get_scissors_logic );
--------------------------------------------------------------------
function public.get_scissors()
  cmn.SetEventDone( "get_scissors" );
  cmn.CallEventHandler( "get_scissors" );
  if common_impl.ZzCompleteCheck("get_scissors") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_partpattern" ] = { type = "use", inv_obj = "inv_partpattern", use_place = "gfx_onroadway_partpattern_zone", room = "rm_nearhouse", zz = "zz_onroadway", zz_gate = "gzz_nearhouse_onroadway" };

private.use_partpattern_logic = function()
  ObjSet( "gmg_nearhouse_onroadwaymg", { visible = 1, input = 1, active = 1 } )

end;
private.use_partpattern_inv = function()
  common_impl.ProcessMultiUseAll("partpattern", "partpattern")
end;
private.use_partpattern_beg = function()
  ObjDelete( "gfx_onroadway_partpattern_zone" );
end;
private.use_partpattern_end = function()
  if common_impl.ZzCompleteCheck("use_partpattern") then ObjSet( common_impl.hint["use_partpattern"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_onroadway_anm_onroa_am1", {animfunc = "use_am1", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_partpattern", private.use_partpattern_inv );
cmn.AddSubscriber( "use_partpattern", private.use_partpattern_beg, private.room_objname );
cmn.AddSubscriber( "use_partpattern", private.use_partpattern_end, private.room_objname );
cmn.AddSubscriber( "use_partpattern", private.use_partpattern_logic );
cmn.AddSubscriber( "use_partpattern_inv", private.use_partpattern_inv, private.room_objname );
cmn.AddSubscriber( "use_partpattern_beg", private.use_partpattern_beg, private.room_objname );
cmn.AddSubscriber( "use_partpattern_end", private.use_partpattern_end, private.room_objname );
cmn.AddSubscriber( "use_partpattern_end", private.use_partpattern_logic );
--------------------------------------------------------------------------------------------
function public.use_partpattern( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_partpattern" );
    cmn.CallEventHandler( "use_partpattern_end" );
    -- common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_partpattern") then ld.CloseSubRoom() end;
    ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_onroadwaymg" ); end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_partpattern_inv" );
  cmn.CallEventHandler( "use_partpattern_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onroadway_anm_onroa_am1", "use_am1", func_end );
  SoundSfx( "aud_use_partpattern_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_veranda *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
-- ObjSet( "gfx_veranda_leathergloves_zone", {active=1, input = 1, visible = 1} );


common_impl.hint[ "get_medicinebook" ] = { type = "get", get_obj = "spr_veranda_medicinebook", room = "rm_nearhouse", zz = "zz_veranda", zz_gate = "gzz_nearhouse_veranda" };

private.get_medicinebook_logic = function()
  ObjSet( "gfx_veranda_leathergloves_zone", {active=1, input = 1, visible = 1} );
end;
private.get_medicinebook_inv = function()
  interface.InventoryItemAdd("inv_medicinebook","spr_veranda_medicinebook");
  ObjSet( "inv_medicinebook", { drag = 0 } );
end;
private.get_medicinebook_beg = function()
  ObjDelete("gfx_veranda_medicinebook")
end;
private.get_medicinebook_end = function()
  if common_impl.ZzCompleteCheck("get_medicinebook") then ObjSet( common_impl.hint["get_medicinebook"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjDelete("spr_veranda_medicinebook_sh");
  --  ObjDelete("spr_housedoctor_tr15");
end;

cmn.AddSubscriber( "get_medicinebook", private.get_medicinebook_inv );
cmn.AddSubscriber( "get_medicinebook", private.get_medicinebook_beg, private.room_objname );
cmn.AddSubscriber( "get_medicinebook", private.get_medicinebook_end, private.room_objname );
cmn.AddSubscriber( "get_medicinebook", private.get_medicinebook_logic );
--------------------------------------------------------------------
function public.get_medicinebook()
  cmn.SetEventDone( "get_medicinebook" );
  cmn.CallEventHandler( "get_medicinebook" );
  if common_impl.ZzCompleteCheck("get_medicinebook") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_leathergloves" ] = { type = "use", inv_obj = "inv_leathergloves", use_place = "gfx_veranda_leathergloves_zone", room = "rm_nearhouse", zz = "zz_veranda", zz_gate = "gzz_nearhouse_veranda" };

private.use_leathergloves_logic = function()
  ObjSet( "spr_veranda_button", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_veranda_checker_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_leathergloves_inv = function()
  common_impl.ProcessMultiUseAll("leathergloves", "leathergloves")
end;
private.use_leathergloves_beg = function()
  ObjDelete( "gfx_veranda_leathergloves_zone" );
end;
private.use_leathergloves_end = function()
  if common_impl.ZzCompleteCheck("use_leathergloves") then ObjSet( common_impl.hint["use_leathergloves"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_veranda_anm_leatherglove");
  ObjDelete("spr_nearhouse_glass");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_leathergloves", private.use_leathergloves_inv );
cmn.AddSubscriber( "use_leathergloves", private.use_leathergloves_beg, private.room_objname );
cmn.AddSubscriber( "use_leathergloves", private.use_leathergloves_end, private.room_objname );
cmn.AddSubscriber( "use_leathergloves", private.use_leathergloves_logic );
cmn.AddSubscriber( "use_leathergloves_inv", private.use_leathergloves_inv, private.room_objname );
cmn.AddSubscriber( "use_leathergloves_beg", private.use_leathergloves_beg, private.room_objname );
cmn.AddSubscriber( "use_leathergloves_end", private.use_leathergloves_end, private.room_objname );
cmn.AddSubscriber( "use_leathergloves_end", private.use_leathergloves_logic );
--------------------------------------------------------------------------------------------
function public.use_leathergloves( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_leathergloves" );
    cmn.CallEventHandler( "use_leathergloves_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_leathergloves") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_leathergloves_inv" );
  cmn.CallEventHandler( "use_leathergloves_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_veranda_anm_leatherglove", "use_leatherglove", func_end );
  SoundSfx( "aud_use_leathergloves_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_button" ] = { type = "get", get_obj = "spr_veranda_button", room = "rm_nearhouse", zz = "zz_veranda", zz_gate = "gzz_nearhouse_veranda" };

private.get_button_logic = function()
  
end;
private.get_button_inv = function()
  interface.InventoryItemAdd("inv_button","spr_veranda_button");
end;
private.get_button_beg = function()
  ObjDelete("gfx_veranda_button")
end;
private.get_button_end = function()
  if common_impl.ZzCompleteCheck("get_button") then ObjSet( common_impl.hint["get_button"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_veranda_sh_button");
end;

cmn.AddSubscriber( "get_button", private.get_button_inv );
cmn.AddSubscriber( "get_button", private.get_button_beg, private.room_objname );
cmn.AddSubscriber( "get_button", private.get_button_end, private.room_objname );
cmn.AddSubscriber( "get_button", private.get_button_logic );
--------------------------------------------------------------------
function public.get_button()
  cmn.SetEventDone( "get_button" );
  cmn.CallEventHandler( "get_button" );
  if common_impl.ZzCompleteCheck("get_button") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_checker_zone_clk()  -- rm_nearhouse.use_checker_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_checker' )
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_box_nearhouse" );
  ld.AnimPlay( "anm_veranda_anm_checker", "idle_cap", func_end )
  
  
end;  



common_impl.hint[ "use_checker" ] = { type = "use", inv_obj = "inv_checker", use_place = "gfx_veranda_checker_zone", room = "rm_nearhouse", zz = "zz_veranda", zz_gate = "gzz_nearhouse_veranda" };

private.use_checker_logic = function()
  ObjSet( "spr_veranda_bird", { visible = 1, input = 1, active = 1 } )

end;
private.use_checker_inv = function()
  common_impl.ProcessMultiUseAll("checker", "checker")
end;
private.use_checker_beg = function()
  ObjDelete( "gfx_veranda_checker_zone" );
end;
private.use_checker_end = function()
  if common_impl.ZzCompleteCheck("use_checker") then ObjSet( common_impl.hint["use_checker"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_veranda_anm_checker", {animfunc = "use_checker", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_checker", private.use_checker_inv );
cmn.AddSubscriber( "use_checker", private.use_checker_beg, private.room_objname );
cmn.AddSubscriber( "use_checker", private.use_checker_end, private.room_objname );
cmn.AddSubscriber( "use_checker", private.use_checker_logic );
cmn.AddSubscriber( "use_checker_inv", private.use_checker_inv, private.room_objname );
cmn.AddSubscriber( "use_checker_beg", private.use_checker_beg, private.room_objname );
cmn.AddSubscriber( "use_checker_end", private.use_checker_end, private.room_objname );
cmn.AddSubscriber( "use_checker_end", private.use_checker_logic );
--------------------------------------------------------------------------------------------
function public.use_checker( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_checker" );
    cmn.CallEventHandler( "use_checker_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_checker") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_checker_inv" );
  cmn.CallEventHandler( "use_checker_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_veranda_anm_checker", "use_checker", func_end );
  SoundSfx( "aud_use_checker_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bird" ] = { type = "get", get_obj = "spr_veranda_bird", room = "rm_nearhouse", zz = "zz_veranda", zz_gate = "gzz_nearhouse_veranda" };

private.get_bird_logic = function()
  
end;
private.get_bird_inv = function()
  interface.InventoryItemAdd("inv_bird","spr_veranda_bird");
end;
private.get_bird_beg = function()
  ObjDelete("gfx_veranda_bird")
end;
private.get_bird_end = function()
  if common_impl.ZzCompleteCheck("get_bird") then ObjSet( common_impl.hint["get_bird"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_veranda_sh_bird");
end;

cmn.AddSubscriber( "get_bird", private.get_bird_inv );
cmn.AddSubscriber( "get_bird", private.get_bird_beg, private.room_objname );
cmn.AddSubscriber( "get_bird", private.get_bird_end, private.room_objname );
cmn.AddSubscriber( "get_bird", private.get_bird_logic );
--------------------------------------------------------------------
function public.get_bird()
  cmn.SetEventDone( "get_bird" );
  cmn.CallEventHandler( "get_bird" );
  if common_impl.ZzCompleteCheck("get_bird") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doorhouse *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_emblem_zone_clk() --rm_nearhouse.use_emblem_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_emblem' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_post_hole_nearhouse" )
  ld.AnimPlay( "anm_doorhouse_anm_doorhom", "idle_close", func_end )
end;  

common_impl.hint[ "use_emblem" ] = { type = "use", inv_obj = "inv_emblem", use_place = "gfx_doorhouse_emblem_zone", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.use_emblem_logic = function()
  ObjSet( "spr_doorhouse_camomile3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_doorhouse_checker", { visible = 1, input = 1, active = 1 } )

end;
private.use_emblem_inv = function()
  common_impl.ProcessMultiUseAll("emblem", "emblem")
end;
private.use_emblem_beg = function()
  ObjDelete( "gfx_doorhouse_emblem_zone" );
end;
private.use_emblem_end = function()
  if common_impl.ZzCompleteCheck("use_emblem") then ObjSet( common_impl.hint["use_emblem"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doorhouse_anm_doorhom", {animfunc = "end_am1", frame = 0 } );
  ObjSet( "spr_doorhouse_sh_checker", {visible = 1} );
  ObjSet( "spr_doorhouse_sh_camomile3", {visible = 1} );
  ObjDelete("obj_doorhouse_emblem_idle_clk_zone");
  ObjSet( "spr_doorhouse_tr_back", {visible = 1} );
  ObjSet( "spr_nearhouse_emblem", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_emblem", private.use_emblem_inv );
cmn.AddSubscriber( "use_emblem", private.use_emblem_beg, private.room_objname );
cmn.AddSubscriber( "use_emblem", private.use_emblem_end, private.room_objname );
cmn.AddSubscriber( "use_emblem", private.use_emblem_logic );
cmn.AddSubscriber( "use_emblem_inv", private.use_emblem_inv, private.room_objname );
cmn.AddSubscriber( "use_emblem_beg", private.use_emblem_beg, private.room_objname );
cmn.AddSubscriber( "use_emblem_end", private.use_emblem_end, private.room_objname );
cmn.AddSubscriber( "use_emblem_end", private.use_emblem_logic );
--------------------------------------------------------------------------------------------
function public.use_emblem( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_emblem" );
    cmn.CallEventHandler( "use_emblem_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_emblem") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_emblem_inv" );
  cmn.CallEventHandler( "use_emblem_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doorhouse_anm_doorhom", "use_am", func_end );
  SoundSfx( "aud_use_emblem_nearhouse" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_camomile3" ] = { type = "get", get_obj = "spr_doorhouse_camomile3", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.get_camomile3_logic = function()
  
end;
private.get_camomile3_inv = function()
  interface.InventoryItemAdd("inv_camomile","spr_doorhouse_camomile3",function() level_inv.ProcessGetCamomileAll( "get_camomile3" ) end);
end;
private.get_camomile3_beg = function()
  ObjDelete("gfx_doorhouse_camomile3")
end;
private.get_camomile3_end = function()
  if common_impl.ZzCompleteCheck("get_camomile3") then ObjSet( common_impl.hint["get_camomile3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_doorhouse_sh_camomile3");
end;

cmn.AddSubscriber( "get_camomile3", private.get_camomile3_inv );
cmn.AddSubscriber( "get_camomile3", private.get_camomile3_beg, private.room_objname );
cmn.AddSubscriber( "get_camomile3", private.get_camomile3_end, private.room_objname );
cmn.AddSubscriber( "get_camomile3", private.get_camomile3_logic );
--------------------------------------------------------------------
function public.get_camomile3()
  cmn.SetEventDone( "get_camomile3" );
  cmn.CallEventHandler( "get_camomile3" );
  if common_impl.ZzCompleteCheck("get_camomile3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_checker" ] = { type = "get", get_obj = "spr_doorhouse_checker", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.get_checker_logic = function()
  
end;
private.get_checker_inv = function()
  interface.InventoryItemAdd("inv_checker","spr_doorhouse_checker");
end;
private.get_checker_beg = function()
  ObjDelete("gfx_doorhouse_checker")
end;
private.get_checker_end = function()
  if common_impl.ZzCompleteCheck("get_checker") then ObjSet( common_impl.hint["get_checker"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_doorhouse_sh_checker");
end;

cmn.AddSubscriber( "get_checker", private.get_checker_inv );
cmn.AddSubscriber( "get_checker", private.get_checker_beg, private.room_objname );
cmn.AddSubscriber( "get_checker", private.get_checker_end, private.room_objname );
cmn.AddSubscriber( "get_checker", private.get_checker_logic );
--------------------------------------------------------------------
function public.get_checker()
  cmn.SetEventDone( "get_checker" );
  cmn.CallEventHandler( "get_checker" );
  if common_impl.ZzCompleteCheck("get_checker") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_scissors_zone_clk()  -- rm_nearhouse.use_scissors_zone_clk()  
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_scissors' )
  end;  
  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_paw_nearhouse" );
  ld.AnimPlay( "anm_doorhouse_anm_doorhom_use1", "idle_use_2", func_end )
end;  



common_impl.hint[ "use_scissors" ] = { type = "use", inv_obj = "inv_scissors", use_place = "gfx_doorhouse_scissors_zone", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.use_scissors_logic = function()
  ObjSet( "spr_doorhouse_paw1", { visible = 1, input = 1, active = 1 } )
  --  ObjSet( "spr_doorhouse_bee", { visible = 1, input = 1, active = 1 } )

end;
private.use_scissors_inv = function()
  common_impl.ProcessMultiUseAll("scissors", "scissors")
end;
private.use_scissors_beg = function()
  ObjDelete( "gfx_doorhouse_scissors_zone" );
end;
private.use_scissors_end = function()
  if common_impl.ZzCompleteCheck("use_scissors") then ObjSet( common_impl.hint["use_scissors"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_doorhouse_anm_doorhom_use1");
  --  ObjDelete("anm_doorhouse_anm_doorhom_use2");
  --  ObjDelete("spr_nearhouse_bee");
  ObjDelete("spr_nearhouse_leg");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissors", private.use_scissors_inv );
cmn.AddSubscriber( "use_scissors", private.use_scissors_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors", private.use_scissors_end, private.room_objname );
cmn.AddSubscriber( "use_scissors", private.use_scissors_logic );
cmn.AddSubscriber( "use_scissors_inv", private.use_scissors_inv, private.room_objname );
cmn.AddSubscriber( "use_scissors_beg", private.use_scissors_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_end", private.use_scissors_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_end", private.use_scissors_logic );
--------------------------------------------------------------------------------------------
function public.use_scissors( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    -- cmn.SetEventDone( "use_scissors" );
    public.get_paw1();
    private.use_scissors_all_end_flag_array[1]=1;
    private.use_scissors_all_end_flag_array[2]=1;
    
    cmn.CallEventHandler( "use_scissors_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scissors") then ld.CloseSubRoom() end;
    if private.use_scissors_all_end_flag_array[3]~=1 then public.use_scissors2(); else private.use_scissors_all_end(); end;
  end;

 
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissors_inv" );
  cmn.CallEventHandler( "use_scissors_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doorhouse_anm_doorhom_use1", "use_2", func_end );
  SoundSfx( "aud_use_scissors_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------

function public.use_scissors2_zone_clk()  -- rm_nearhouse.use_scissors2_zone_clk()  
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_scissors' )
  end;  
  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_flask_nearhouse" );
  ld.AnimPlay( "anm_doorhouse_anm_doorhom_use2", "idle_use_3", func_end )
end;  

common_impl.hint[ "use_scissors2" ] = { type = "use", inv_obj = "inv_scissors", use_place = "gfx_doorhouse_scissors2_zone", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.use_scissors2_logic = function()
  --ObjSet( "spr_doorhouse_paw1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_doorhouse_bee", { visible = 1, input = 1, active = 1 } )

end;
private.use_scissors2_inv = function()
  common_impl.ProcessMultiUseAll("scissors", "scissors2")
end;
private.use_scissors2_beg = function()
  ObjDelete( "gfx_doorhouse_scissors2_zone" );
end;
private.use_scissors2_end = function()
  if common_impl.ZzCompleteCheck("use_scissors2") then ObjSet( common_impl.hint["use_scissors2"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjDelete("anm_doorhouse_anm_doorhom_use1");
  -- ObjDelete("anm_doorhouse_anm_doorhom_use2");
  ObjDelete("spr_nearhouse_bee");
  -- ObjDelete("spr_nearhouse_leg");
  ObjSet( "anm_doorhouse_anm_doorhom_use2", {pos_z = 16, animfunc="use_3", frame = 999} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissors2", private.use_scissors2_inv );
cmn.AddSubscriber( "use_scissors2", private.use_scissors2_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors2", private.use_scissors2_end, private.room_objname );
cmn.AddSubscriber( "use_scissors2", private.use_scissors2_logic );
cmn.AddSubscriber( "use_scissors2_inv", private.use_scissors2_inv, private.room_objname );
cmn.AddSubscriber( "use_scissors2_beg", private.use_scissors2_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors2_end", private.use_scissors2_end, private.room_objname );
cmn.AddSubscriber( "use_scissors2_end", private.use_scissors2_logic );
--------------------------------------------------------------------------------------------
function public.use_scissors2( obj )

  local func_end = function()
    common_impl.Lock(0);
    ObjSet(obj,{visible = 1});
    -- cmn.SetEventDone( "use_scissors2" );
    -- cmn.SetEventDone( "get_paw1" );
    -- cmn.SetEventDone( "get_bee" );
    cmn.CallEventHandler( "use_scissors2_end" );
    public.get_bee();
    private.use_scissors_all_end_flag_array[3]=1;
    private.use_scissors_all_end_flag_array[4]=1;
    
    if common_impl.ZzCompleteCheck("use_scissors2") then ld.CloseSubRoom() end;
    if private.use_scissors_all_end_flag_array[1]~=1 then public.use_scissors();else private.use_scissors_all_end(); end;
    
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissors2_inv" );
  cmn.CallEventHandler( "use_scissors2_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_doorhouse_anm_doorhom_use2", {pos_z = 20} );
  
  ld.AnimPlay( "anm_doorhouse_anm_doorhom_use2", "use_3", func_end );
  SoundSfx( "aud_use_scissors2_nearhouse" )
  --SoundSfx( "aud_use_scissors2_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_paw1" ] = { type = "get", get_obj = "spr_doorhouse_paw1", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.get_paw1_logic = function()
  
end;
private.get_paw1_inv = function()
  interface.InventoryItemAdd("inv_paw1","spr_doorhouse_paw1");
end;
private.get_paw1_beg = function()
  ObjDelete("gfx_doorhouse_paw1")
end;
private.get_paw1_end = function()
  if common_impl.ZzCompleteCheck("get_paw1") then ObjSet( common_impl.hint["get_paw1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_paw1", private.get_paw1_inv );
cmn.AddSubscriber( "get_paw1", private.get_paw1_beg, private.room_objname );
cmn.AddSubscriber( "get_paw1", private.get_paw1_end, private.room_objname );
cmn.AddSubscriber( "get_paw1", private.get_paw1_logic );
--------------------------------------------------------------------
function public.get_paw1()
  ObjSet( "spr_doorhouse_paw1", {active = 1, visible = 1} );
  cmn.CallEventHandler( "get_paw1" );
  if common_impl.ZzCompleteCheck("get_paw1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bee" ] = { type = "get", get_obj = "spr_doorhouse_bee", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.get_bee_logic = function()
  
end;
private.get_bee_inv = function()
  interface.InventoryItemAdd("inv_bee","spr_doorhouse_bee");
end;
private.get_bee_beg = function()
  ObjDelete("gfx_doorhouse_bee")
end;
private.get_bee_end = function()
  if common_impl.ZzCompleteCheck("get_bee") then ObjSet( common_impl.hint["get_bee"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bee", private.get_bee_inv );
cmn.AddSubscriber( "get_bee", private.get_bee_beg, private.room_objname );
cmn.AddSubscriber( "get_bee", private.get_bee_end, private.room_objname );
cmn.AddSubscriber( "get_bee", private.get_bee_logic );
--------------------------------------------------------------------
function public.get_bee()
  ObjSet( "spr_doorhouse_bee", {active = 1, visible = 1} );
  cmn.CallEventHandler( "get_bee" );
  if common_impl.ZzCompleteCheck("get_bee") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
private.use_scissors_all_end_flag_array={0,0,0,0};
function private.use_scissors_all_end()
  local count =  0;
  for i=1,4,1 do 
    count=count+private.use_scissors_all_end_flag_array[i];
  end;  
  
  if count==4 then 
    cmn.SetEventDone( "use_scissors" );
    cmn.SetEventDone( "get_paw1" );
    cmn.SetEventDone( "use_scissors2" );
    cmn.SetEventDone( "get_bee" );
  end;
end;  



--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_onpaper" ] = { type = "click", use_place = "gfx_doorhouse_clk_onpaper_zone", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.clk_onpaper_logic = function()
  ObjSet( "gfx_doorhouse_keyhouse_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_onpaper_beg = function()
  ObjDelete( "gfx_doorhouse_clk_onpaper_zone" );
end;
private.clk_onpaper_end = function()
  if common_impl.ZzCompleteCheck("clk_onpaper") then ObjSet( common_impl.hint["clk_onpaper"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_doorhouse_anm_doorhom_pet");
  ObjDelete("spr_nearhouse_pet");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_onpaper", private.clk_onpaper_beg, private.room_objname );
cmn.AddSubscriber( "clk_onpaper", private.clk_onpaper_end, private.room_objname );
cmn.AddSubscriber( "clk_onpaper", private.clk_onpaper_logic );
cmn.AddSubscriber( "clk_onpaper_beg", private.clk_onpaper_beg, private.room_objname );
cmn.AddSubscriber( "clk_onpaper_end", private.clk_onpaper_end, private.room_objname );
cmn.AddSubscriber( "clk_onpaper_end", private.clk_onpaper_logic );
--------------------------------------------------------------------------------------------
function public.clk_onpaper()

  local func_end = function()
    cmn.SetEventDone( "clk_onpaper" );
    cmn.CallEventHandler( "clk_onpaper_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_onpaper") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_onpaper_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doorhouse_anm_doorhom_pet", "use_1", func_end );
  SoundSfx( "aud_clk_onpaper_nearhouse" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_keyhouse_zone_clk()  --rm_nearhouse.use_keyhouse_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_keyhouse' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_handle_nearhouse" );
  ld.AnimPlay( "anm_doorhouse_anm_doorhom_key", "idle_pas", func_end )
end;  

common_impl.hint[ "use_keyhouse" ] = { type = "use", inv_obj = "inv_keyhouse", use_place = "gfx_doorhouse_keyhouse_zone", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.use_keyhouse_logic = function()
  ObjSet( "gfx_doorhouse_clk_onkeyhouse_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_keyhouse_inv = function()
  common_impl.ProcessMultiUseAll("keyhouse", "keyhouse")
end;
private.use_keyhouse_beg = function()
  ObjDelete( "gfx_doorhouse_keyhouse_zone" );
end;
private.use_keyhouse_end = function()
  if common_impl.ZzCompleteCheck("use_keyhouse") then ObjSet( common_impl.hint["use_keyhouse"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_doorhouse_anm_doorhom_key", {animfunc = "idle_pas", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_keyhouse", private.use_keyhouse_inv );
cmn.AddSubscriber( "use_keyhouse", private.use_keyhouse_beg, private.room_objname );
cmn.AddSubscriber( "use_keyhouse", private.use_keyhouse_end, private.room_objname );
cmn.AddSubscriber( "use_keyhouse", private.use_keyhouse_logic );
cmn.AddSubscriber( "use_keyhouse_inv", private.use_keyhouse_inv, private.room_objname );
cmn.AddSubscriber( "use_keyhouse_beg", private.use_keyhouse_beg, private.room_objname );
cmn.AddSubscriber( "use_keyhouse_end", private.use_keyhouse_end, private.room_objname );
cmn.AddSubscriber( "use_keyhouse_end", private.use_keyhouse_logic );
--------------------------------------------------------------------------------------------
function public.use_keyhouse( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_keyhouse" );
    cmn.CallEventHandler( "use_keyhouse_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_keyhouse") then ld.CloseSubRoom() end;
  end;
  
  
  if cmn.IsEventDone("use_scissors") and cmn.IsEventDone("use_scissors2") then 
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_keyhouse_inv" );
  cmn.CallEventHandler( "use_keyhouse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doorhouse_anm_doorhom_key", "use_key", func_end );
  SoundSfx( "aud_use_keyhouse_nearhouse" )
  --func_end()

  end;
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_onkeyhouse" ] = { type = "click", use_place = "gfx_doorhouse_clk_onkeyhouse_zone", room = "rm_nearhouse", zz = "zz_doorhouse", zz_gate = "gzz_nearhouse_doorhouse" };

private.clk_onkeyhouse_logic = function()
  ObjSet( "grm_nearhouse_housedoctor", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_nearhouse_housedoctor_focus");
  end;
end;
private.clk_onkeyhouse_beg = function()
  ObjDelete( "gfx_doorhouse_clk_onkeyhouse_zone" );
end;
private.clk_onkeyhouse_end = function()
  if common_impl.ZzCompleteCheck("clk_onkeyhouse") then ObjSet( common_impl.hint["clk_onkeyhouse"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "anm_nearhouse_anm_neardoktor_door", {animfunc = "open_homedoktor", frame = 999 } );
   ObjDelete("spr_nearhouse_emblem");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_onkeyhouse", private.clk_onkeyhouse_beg, private.room_objname );
cmn.AddSubscriber( "clk_onkeyhouse", private.clk_onkeyhouse_end, private.room_objname );
cmn.AddSubscriber( "clk_onkeyhouse", private.clk_onkeyhouse_logic );
cmn.AddSubscriber( "clk_onkeyhouse_beg", private.clk_onkeyhouse_beg, private.room_objname );
cmn.AddSubscriber( "clk_onkeyhouse_end", private.clk_onkeyhouse_end, private.room_objname );
cmn.AddSubscriber( "clk_onkeyhouse_end", private.clk_onkeyhouse_logic );
--------------------------------------------------------------------------------------------
function public.clk_onkeyhouse()

  local func_end = function()
    cmn.SetEventDone( "clk_onkeyhouse" );
    cmn.CallEventHandler( "clk_onkeyhouse_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_onkeyhouse") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    ld.CloseSubRoom()
    ld.StartTimer( 0.3, function()
        ObjAnimate( "spr_nearhouse_emblem", 8, 0, 0, function() end, {0,0,1, 0.2,0,0} ); 
        SoundSfx( "aud_open_housedoctor_door" );  
        ld.AnimPlay( "anm_nearhouse_anm_neardoktor_door", "open_homedoktor", func_end )
      end )
  end;   
  
  cmn.CallEventHandler( "clk_onkeyhouse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doorhouse_anm_doorhom_key", "idle_pas", func_preend )
  SoundSfx( "aud_clk_onkeyhouse_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ontree *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_acid_zone_clk() --rm_nearhouse.use_acid_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_acid' );
  end;

  ld.Lock(1);  
  SoundSfx( "aud_touch_chain_nearhouse" );
  ld.AnimPlay( "anm_ontree_anm_acid", "idle_acid1", func_end )
end;  


common_impl.hint[ "use_acid" ] = { type = "use", inv_obj = "inv_acid", use_place = "gfx_ontree_acid_zone", room = "rm_nearhouse", zz = "zz_ontree", zz_gate = "gzz_nearhouse_ontree" };

private.use_acid_logic = function()
  ObjSet( "spr_ontree_star", { visible = 1, input = 1, active = 1 } )

end;
private.use_acid_inv = function()
  common_impl.ProcessMultiUseAll("acid", "acid")
end;
private.use_acid_beg = function()
  ObjDelete( "gfx_ontree_acid_zone" );
end;
private.use_acid_end = function()
  if common_impl.ZzCompleteCheck("use_acid") then ObjSet( common_impl.hint["use_acid"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ontree_anm_acid", {animfunc = "end_acid", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_acid", private.use_acid_inv );
cmn.AddSubscriber( "use_acid", private.use_acid_beg, private.room_objname );
cmn.AddSubscriber( "use_acid", private.use_acid_end, private.room_objname );
cmn.AddSubscriber( "use_acid", private.use_acid_logic );
cmn.AddSubscriber( "use_acid_inv", private.use_acid_inv, private.room_objname );
cmn.AddSubscriber( "use_acid_beg", private.use_acid_beg, private.room_objname );
cmn.AddSubscriber( "use_acid_end", private.use_acid_end, private.room_objname );
cmn.AddSubscriber( "use_acid_end", private.use_acid_logic );
--------------------------------------------------------------------------------------------
function public.use_acid( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_acid" );
    cmn.CallEventHandler( "use_acid_end" );
    public.get_star()
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_acid") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_acid_inv" );
  cmn.CallEventHandler( "use_acid_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ontree_anm_acid", "use_acid", func_end );
  SoundSfx( "aud_use_acid_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_star" ] = { type = "get", get_obj = "spr_ontree_star", room = "rm_nearhouse", zz = "zz_ontree", zz_gate = "gzz_nearhouse_ontree" };

private.get_star_logic = function()
  
end;
private.get_star_inv = function()
  interface.InventoryItemAdd("inv_star","spr_ontree_star");
end;
private.get_star_beg = function()
  ObjDelete("gfx_ontree_star")
end;
private.get_star_end = function()
  if common_impl.ZzCompleteCheck("get_star") then ObjSet( common_impl.hint["get_star"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_nearhouse_chain", {visible = 1} );
  ObjDelete("spr_nearhouse_star")
  ObjDelete("spr_nearhouse_chain1")
end;

cmn.AddSubscriber( "get_star", private.get_star_inv );
cmn.AddSubscriber( "get_star", private.get_star_beg, private.room_objname );
cmn.AddSubscriber( "get_star", private.get_star_end, private.room_objname );
cmn.AddSubscriber( "get_star", private.get_star_logic );
--------------------------------------------------------------------
function public.get_star()
  ObjSet( "spr_ontree_star", {visible = 1} );
  cmn.SetEventDone( "get_star" );
  cmn.CallEventHandler( "get_star" );
  if common_impl.ZzCompleteCheck("get_star") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_bee_zone_clk()  --rm_nearhouse.use_bee_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_bee' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_flower_nearhouse" );
  ld.AnimPlay( "anm_ontree_anm_use_bee", "idle_bee", func_end )
end;  


common_impl.hint[ "use_bee" ] = { type = "use", inv_obj = "inv_bee", use_place = "gfx_ontree_bee_zone", room = "rm_nearhouse", zz = "zz_ontree", zz_gate = "gzz_nearhouse_ontree" };

private.use_bee_logic = function()
  ObjSet( "gfx_ontree_win_bees_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_ontree_mg_back", {active=1, input=1, visible=1, alp=1} );
end;
private.use_bee_inv = function()
  common_impl.ProcessMultiUseAll("bee", "bee")
end;
private.use_bee_beg = function()
  ObjDelete( "gfx_ontree_bee_zone" );
end;
private.use_bee_end = function()
  if common_impl.ZzCompleteCheck("use_bee") then ObjSet( common_impl.hint["use_bee"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ontree_anm_use_bee", {animfunc = "use_bee", frame = 999 } );
  ObjSet( "anm_ontree_anm_bee", {playing=0} );
  ObjSet( "anm_ontree_anm_leaf", {playing=0} );
  ObjDelete("pfx_ontree_p_flare")
  ObjSet( "pfx_ontree_p_flare_2", {active=1, visible=1, alp=1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bee", private.use_bee_inv );
cmn.AddSubscriber( "use_bee", private.use_bee_beg, private.room_objname );
cmn.AddSubscriber( "use_bee", private.use_bee_end, private.room_objname );
cmn.AddSubscriber( "use_bee", private.use_bee_logic );
cmn.AddSubscriber( "use_bee_inv", private.use_bee_inv, private.room_objname );
cmn.AddSubscriber( "use_bee_beg", private.use_bee_beg, private.room_objname );
cmn.AddSubscriber( "use_bee_end", private.use_bee_end, private.room_objname );
cmn.AddSubscriber( "use_bee_end", private.use_bee_logic );
--------------------------------------------------------------------------------------------
function public.use_bee( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bee" );
    cmn.CallEventHandler( "use_bee_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bee") then ld.CloseSubRoom() end;
    private.init_bees()    
    cmn.MiniGameShow( "bees" );
  end;
  
  local func_preend = function()
     ObjSet( "spr_ontree_mg_back", {active=1, input=1, visible=1, alp=0} );
     ObjAnimate( "spr_ontree_mg_back", 8, 0, 0, func_end, {0,0,0, 0.3,0,1} );
     ObjSet( "pfx_ontree_p_flare_2", {active=1, visible=1, alp=0} );
     ObjAnimate( "pfx_ontree_p_flare", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
     ObjAnimate( "pfx_ontree_p_flare_2", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );  
  end;  
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bee_inv" );
  cmn.CallEventHandler( "use_bee_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ontree_anm_use_bee", "use_bee", func_preend );
  SoundSfx( "aud_use_bee_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_bees" ] = { type = "click", use_place = "spr_ontree_mg_back", room = "rm_nearhouse", zz = "zz_ontree", zz_gate = "gzz_nearhouse_ontree" };

private.win_bees_logic = function()
  if cmn.IsEventDone("win_bees") then 
    ObjSet( "gho_nearhouse_tree", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.win_bees_beg = function()
  if cmn.IsEventDone("win_bees") then 
     ObjDelete( "gfx_ontree_win_bees_zone" );
  end;   
end;
private.win_bees_end = function()
   if cmn.IsEventDone("win_bees") then 
      if common_impl.ZzCompleteCheck("win_bees") then ObjSet( common_impl.hint["win_bees"].zz_gate, { visible = 0, input = 0 } ); end;
      ObjSet( "spr_nearhouse_tr_xo", {visible = 1} );
   end;   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_bees", private.win_bees_beg, private.room_objname );
cmn.AddSubscriber( "win_bees", private.win_bees_end, private.room_objname );
cmn.AddSubscriber( "win_bees", private.win_bees_logic );
cmn.AddSubscriber( "win_bees_beg", private.win_bees_beg, private.room_objname );
cmn.AddSubscriber( "win_bees_end", private.win_bees_end, private.room_objname );
cmn.AddSubscriber( "win_bees_end", private.win_bees_logic );
--------------------------------------------------------------------------------------------
function public.win_bees()

  local func_end = function()
    cmn.SetEventDone( "win_bees" );
    cmn.CallEventHandler( "win_bees_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_bees") then ld.CloseSubRoom() end;
    level.tutorial_hosparkles.first()
  end;

  cmn.CallEventHandler( "win_bees_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  cmn.MiniGameHide( "bees", true); 
  ld.StartTimer( 0.5, func_end )
end;

private.win_bees_fp_array={0,0,0};
private.win_bees_array={{1,2},{3,5},{4,6}};
--private.win_bee_alfabet = {"a","b","c","d","e","f"};

private.win_bees_first_init_flag = false;
function private.win_bees_first_init()
  if private.win_bees_first_init_flag ==false then 
    for i=1,6,1 do 
      ObjSet( "obj_ontree_part_"..i, {input=1, event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="rm_nearhouse.win_bees_part_mdown("..i..");"} );
    end;  
  end;
  private.win_bees_first_init_flag =true;  
end;  


function private.init_bees()
  private.win_bees_first_init()
  if not (cmn.IsEventStart("win_bees")) then
    ng_global.progress["std"]["win_bees"].state = {}
    -- private.win_books_state= ld.TableCopy(private.win_books_fp_array);
    ng_global.progress["std"]["win_bees"].state = ld.TableCopy(private.win_bees_fp_array);
  else  
    --private.win_books_state=ng_global.progress["std"]["win_books"].state;
  end
  private.win_bees_stand_pos();  
end

function private.win_bees_stand_pos()
  private.win_bee_selected_part=0;
  for i=1,3,1 do 
    if ng_global.progress["std"]["win_bees"].state[i]==1 then 
      for j=1,2,1 do 
        ObjSet( "anm_ontree_anm_mg_"..private.win_bees_array[i][j], {animfunc = "close_"..private.win_bees_array[i][j], frame = 0 } );
        ObjSet( "obj_ontree_part_"..private.win_bees_array[i][j], {input=0} );
      end;
    else
      for j=1,2,1 do 
        ObjSet( "anm_ontree_anm_mg_"..private.win_bees_array[i][j], {animfunc = "open_"..private.win_bees_array[i][j], frame = 0 } );
        ObjSet( "obj_ontree_part_"..private.win_bees_array[i][j], {input=1} );
      end;
    end;  
  end;  
  private.win_bees_win_wer();
end;  
---------------------------------------------------------------
function private.win_bees_win_wer()
  local count=0;
  for i=1,3,1 do 
    if ng_global.progress["std"]["win_bees"].state[i]==1 then count=count+1; end;  
  end;  
  if count==3 then public.win_bees() end;
end;  
-----------------
function private.win_bees_search_part(num)
  for i=1,3,1 do 
    for j=1,2,1 do 
      if private.win_bees_array[i][j]==num then return i; end;
    end;  
  end;  
end;  
-----------------
private.win_bee_selected_part=0;
function public.win_bees_part_mdown(num)
  if private.win_bee_selected_part==0 then 
    ld.Lock(1);
    private.win_bee_selected_part = num;
    SoundSfx( "aud_mmg_bees_open" );
    ld.AnimPlay( "anm_ontree_anm_mg_"..num, "open_"..num, function() ld.Lock(0); end )
  elseif  private.win_bee_selected_part==num then
    private.win_bee_selected_part=0;
    ld.Lock(1);
    SoundSfx( "aud_mmg_bees_close" )
    ld.AnimPlay( "anm_ontree_anm_mg_"..num, "close_"..num, function() ld.Lock(0); end )
  else 
    if private.win_bees_search_part(num) == private.win_bees_search_part(private.win_bee_selected_part) then 
      local func_end = function()
         ld.Lock(0);
         ng_global.progress["std"]["win_bees"].state[private.win_bees_search_part(num)] =1;
         private.win_bees_stand_pos();
      end;
    
      ld.Lock(1);  
      SoundSfx( "aud_mmg_bees_open" );
      ld.AnimPlay( "anm_ontree_anm_mg_"..num, "open_"..num, func_end )
    else 
      local func_end = function()
         ld.Lock(0);
         ng_global.progress["std"]["win_bees"].state[private.win_bees_search_part(num)] =0;
         private.win_bees_stand_pos();
      end;
      
      local func_preend = function()
        SoundSfx( "aud_mmg_bees_close" )
        ld.AnimPlay( "anm_ontree_anm_mg_"..num, "close_"..num, function() end )
        ld.AnimPlay( "anm_ontree_anm_mg_"..private.win_bee_selected_part, "close_"..private.win_bee_selected_part, func_end )
      end;  
       
    
      ld.Lock(1);  
      SoundSfx( "aud_mmg_bees_open" );
      ld.AnimPlay( "anm_ontree_anm_mg_"..num, "open_"..num, func_preend )
    end;  
  end;   
end;  
----------------------------------
function  private.win_bees_reset()
  local func_end = function()
    ld.Lock(0);
    ng_global.progress["std"]["win_bees"].state={0,0,0};
    private.win_bees_stand_pos()
  end;  
  
  ld.Lock(1);
  for i=1,3,1 do 
    if ng_global.progress["std"]["win_bees"].state[i]==1 then 
        ld.AnimPlay( "anm_ontree_anm_mg_"..private.win_bees_array[i][1], "close_"..private.win_bees_array[i][1], function() end )
        ld.AnimPlay( "anm_ontree_anm_mg_"..private.win_bees_array[i][2], "close_"..private.win_bees_array[i][2], function() end )
    end;
  end;  
  if private.win_bee_selected_part~=0 then   ld.AnimPlay( "anm_ontree_anm_mg_".. private.win_bee_selected_part, "close_".. private.win_bee_selected_part, function() end ) end;  
  ld.StartTimer( 1, func_end )    
end;  
--------------------------------------------------------
function  private.win_bees_skip()
  local func_end = function()
    ld.Lock(0);
    ng_global.progress["std"]["win_bees"].state={1,1,1};
    private.win_bees_stand_pos()
  end;  
  
  ld.Lock(1);
  for i=1,3,1 do 
    if ng_global.progress["std"]["win_bees"].state[i]==0 then 
      if private.win_bee_selected_part~=private.win_bees_array[i][1] then 
         ld.AnimPlay( "anm_ontree_anm_mg_"..private.win_bees_array[i][1], "open_"..private.win_bees_array[i][1], function() end )
      end;   
      if private.win_bee_selected_part~=private.win_bees_array[i][2] then    
        ld.AnimPlay( "anm_ontree_anm_mg_"..private.win_bees_array[i][2], "open_"..private.win_bees_array[i][2], function() end )
      end;    
    end;
  end;  
  ld.StartTimer( 1, func_end )    
end;  
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ivy *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_sickle_zone_clk()  --rm_nearhouse.use_sickle_zone_clk();
  local func_end = function()
    common_impl.ShowBbt( 'need_sickle' )
    ld.Lock(0);
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_bush_nearhouse" );
  ld.AnimPlay( "anm_ivy_anm_sickle", "idle_sickle", func_end )
end;  


common_impl.hint[ "use_sickle" ] = { type = "use", inv_obj = "inv_sickle", use_place = "gfx_ivy_sickle_zone", room = "rm_nearhouse", zz = "zz_ivy", zz_gate = "gzz_nearhouse_ivy" };

private.use_sickle_logic = function()
  ObjSet( "spr_ivy_horn", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_ivy_horn", {active = 1, visible=1} );
  ObjSet( "spr_ivy_branches", {active=1, input=1, visible = 1} );
end;
private.use_sickle_inv = function()
  common_impl.ProcessMultiUseAll("sickle", "sickle")
end;
private.use_sickle_beg = function()
  ObjDelete( "gfx_ivy_sickle_zone" );
end;
private.use_sickle_end = function()
  if common_impl.ZzCompleteCheck("use_sickle") then ObjSet( common_impl.hint["use_sickle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ivy_anm_sickle", {animfunc = "use_sickle", frame = 999} );
  ObjDelete("spr_nearhouse_ivy");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sickle", private.use_sickle_inv );
cmn.AddSubscriber( "use_sickle", private.use_sickle_beg, private.room_objname );
cmn.AddSubscriber( "use_sickle", private.use_sickle_end, private.room_objname );
cmn.AddSubscriber( "use_sickle", private.use_sickle_logic );
cmn.AddSubscriber( "use_sickle_inv", private.use_sickle_inv, private.room_objname );
cmn.AddSubscriber( "use_sickle_beg", private.use_sickle_beg, private.room_objname );
cmn.AddSubscriber( "use_sickle_end", private.use_sickle_end, private.room_objname );
cmn.AddSubscriber( "use_sickle_end", private.use_sickle_logic );
--------------------------------------------------------------------------------------------
function public.use_sickle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sickle" );
    cmn.CallEventHandler( "use_sickle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sickle") then ld.CloseSubRoom() end;
    ObjSet( "spr_ivy_branches", {active=1, input=1, visible = 1} );
    public.get_branches();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sickle_inv" );
  cmn.CallEventHandler( "use_sickle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ivy_anm_sickle", "use_sickle", func_end );
  SoundSfx( "aud_use_sickle_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_horn" ] = { type = "get", get_obj = "spr_ivy_horn", room = "rm_nearhouse", zz = "zz_ivy", zz_gate = "gzz_nearhouse_ivy" };

private.get_horn_logic = function()
   ObjSet( "gfx_ivy_oakleaf_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_horn_inv = function()
  interface.InventoryItemAdd("inv_horn","spr_ivy_horn");
end;
private.get_horn_beg = function()
  ObjDelete("gfx_ivy_horn")
end;
private.get_horn_end = function()
  if common_impl.ZzCompleteCheck("get_horn") then ObjSet( common_impl.hint["get_horn"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ivy_anm_sickle", {animfunc = "idle_door", frame = 0} );
  ObjDelete("spr_nearhouse_horn");
end;

cmn.AddSubscriber( "get_horn", private.get_horn_inv );
cmn.AddSubscriber( "get_horn", private.get_horn_beg, private.room_objname );
cmn.AddSubscriber( "get_horn", private.get_horn_end, private.room_objname );
cmn.AddSubscriber( "get_horn", private.get_horn_logic );
--------------------------------------------------------------------
function public.get_horn()
  ObjSet( "spr_ivy_horn", {visible = 1} );
  cmn.SetEventDone( "get_horn" );
  cmn.CallEventHandler( "get_horn" );
  if common_impl.ZzCompleteCheck("get_horn") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_branches" ] = { type = "get", get_obj = "spr_ivy_branches", room = "rm_nearhouse", zz = "zz_ivy", zz_gate = "gzz_nearhouse_ivy" };

private.get_branches_logic = function()
  ObjSet( "inv_branches", {drag=0} );
end;
private.get_branches_inv = function()
  interface.InventoryItemAdd("inv_branches","spr_ivy_branches");
end;
private.get_branches_beg = function()
  ObjDelete("gfx_ivy_branches")
end;
private.get_branches_end = function()
  if common_impl.ZzCompleteCheck("get_branches") then ObjSet( common_impl.hint["get_branches"].zz_gate, { visible = 0, input = 0 } ); end;
  -- ObjDelete("spr_nearhouse_broom");
  -- ObjDelete("spr_ivy_sh_branches")
end;

cmn.AddSubscriber( "get_branches", private.get_branches_inv );
cmn.AddSubscriber( "get_branches", private.get_branches_beg, private.room_objname );
cmn.AddSubscriber( "get_branches", private.get_branches_end, private.room_objname );
cmn.AddSubscriber( "get_branches", private.get_branches_logic );
--------------------------------------------------------------------
function public.get_branches()
  ObjSet( "spr_ivy_branches", {active=1, visible = 1} );
  cmn.SetEventDone( "get_branches" );
  cmn.CallEventHandler( "get_branches" );
  if common_impl.ZzCompleteCheck("get_branches") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_oakleaf_zone_clk()  --rm_nearhouse.use_oakleaf_zone_clk();
  local func_end = function() 
    ld.Lock(0);
    common_impl.ShowBbt( 'need_oakleaf' );
  end;


  ld.Lock(1);
  SoundSfx( "aud_touch_big_wood" );
  ld.AnimPlay( "anm_ivy_anm_sickle", "idle_door", func_end )
end;
  


common_impl.hint[ "use_oakleaf" ] = { type = "use", inv_obj = "inv_oakleaf", use_place = "gfx_ivy_oakleaf_zone", room = "rm_nearhouse", zz = "zz_ivy", zz_gate = "gzz_nearhouse_ivy" };

private.use_oakleaf_logic = function()
  ObjSet( "grm_nearhouse_grove", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_nearhouse_grove_focus");
  end;
end;
private.use_oakleaf_inv = function()
  common_impl.ProcessMultiUseAll("oakleaf", "oakleaf")
end;
private.use_oakleaf_beg = function()
  ObjDelete( "gfx_ivy_oakleaf_zone" );
end;
private.use_oakleaf_end = function()
  if common_impl.ZzCompleteCheck("use_oakleaf") then ObjSet( common_impl.hint["use_oakleaf"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_ivy_anm_sickle", {animfunc = "use_door", frame = 999 } );
  ObjDelete("obj_nearhouse_ivy_tr_root");
  ObjSet( "anm_nearhouse_anm_neardoktor_door_grove", {animfunc = "end_grove", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_oakleaf", private.use_oakleaf_inv );
cmn.AddSubscriber( "use_oakleaf", private.use_oakleaf_beg, private.room_objname );
cmn.AddSubscriber( "use_oakleaf", private.use_oakleaf_end, private.room_objname );
cmn.AddSubscriber( "use_oakleaf", private.use_oakleaf_logic );
cmn.AddSubscriber( "use_oakleaf_inv", private.use_oakleaf_inv, private.room_objname );
cmn.AddSubscriber( "use_oakleaf_beg", private.use_oakleaf_beg, private.room_objname );
cmn.AddSubscriber( "use_oakleaf_end", private.use_oakleaf_end, private.room_objname );
cmn.AddSubscriber( "use_oakleaf_end", private.use_oakleaf_logic );
--------------------------------------------------------------------------------------------
function public.use_oakleaf( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_oakleaf" );
    cmn.CallEventHandler( "use_oakleaf_end" );
    common_impl.Lock(0);
    --  if common_impl.ZzCompleteCheck("use_oakleaf") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
    ObjSet( "obj_nearhouse_ivy_tr_root", {visible = 0} );
    ObjSet( "anm_nearhouse_anm_neardoktor_door_grove", {visible = 1} );
    ld.CloseSubRoom();
    ld.StartTimer( 0.3, function() SoundSfx( "aud_open_gate_nearhouse" ); ld.AnimPlay( "anm_nearhouse_anm_neardoktor_door_grove", "open_grove", func_end )  end )
  end
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_oakleaf_inv" );
  cmn.CallEventHandler( "use_oakleaf_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ivy_anm_sickle", "use_door", func_preend );
  SoundSfx( "aud_use_oakleaf_nearhouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_onroadwaymg_for_nearhouse = function()
    if ld.CheckRequirements( {"win_onroadwaymg"} ) then
      --ObjSet( "gmg_nearhouse_onroadwaymg", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_onroadwaymg", win_onroadwaymg_for_nearhouse, private.room_objname )
  local win_tree_for_nearhouse = function()
    if ld.CheckRequirements( {"win_tree"} ) then
      ObjSet( "gho_nearhouse_tree", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_tree", win_tree_for_nearhouse, private.room_objname )

end;
------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_ontree" ) and not ld.CheckRequirements( { "win_bees" } ) then  
    private.win_bees_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_ontree" ) and not ld.CheckRequirements( { "win_bees" } ) then
    private.win_bees_skip()
  end;
  
end
--*********************************************************************************************************************


--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_nearhouse();
  --разлочить когда будет карта
  level.tutorial_map1.first()
  level.tutorial_hosparkles.first()
end;
--*********************************************************************************************************************
function public.PreOpen()
  if cmn.IsEventDone("win_tree") then 
    ObjSet( "spr_nearhouse_tr_xo", {visible = 0} );
  end;  
  
  if not cmn.IsEventDone("clk_nearmonument") then 
    ObjAttach("vid_nearhouse_vid_nearmonument","rm_nearhouse");
  else  
     SoundEnv( "aud_nearhouse_env" );
  end;  
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_ivy" );
  function zz_ivy.Open()
  end;
  function zz_ivy.PreOpen()
  end;
  function zz_ivy.PreClose()
  end;
  function zz_ivy.Close()
  end;

  subroom.Define( "zz_ontree" );
  function zz_ontree.Open()
  end;
  function zz_ontree.PreOpen()
     if cmn.IsEventStart("win_bees") and not cmn.IsEventDone("win_bees") then 
       cmn.MiniGameShow( "bees" ); 
       private.init_bees()
     end;  
  end;
  function zz_ontree.PreClose()
  end;
  function zz_ontree.Close()
    if cmn.IsEventStart("win_bees") and not cmn.IsEventDone("win_bees") then 
       cmn.MiniGameHide( "bees" ); 
    end; 
  end;

  subroom.Define( "zz_doorhouse" );
  function zz_doorhouse.Open()
  end;
  function zz_doorhouse.PreOpen()
  end;
  function zz_doorhouse.PreClose()
  end;
  function zz_doorhouse.Close()
  end;

  subroom.Define( "zz_veranda" );
  function zz_veranda.Open()
  end;
  function zz_veranda.PreOpen()
  end;
  function zz_veranda.PreClose()
  end;
  function zz_veranda.Close()
  end;

  subroom.Define( "zz_onroadway" );
  function zz_onroadway.Open()
  end;
  function zz_onroadway.PreOpen()
  end;
  function zz_onroadway.PreClose()
  end;
  function zz_onroadway.Close()
  end;

  subroom.Define( "zz_girlstatue" );
  function zz_girlstatue.Open()
  end;
  function zz_girlstatue.PreOpen()
  end;
  function zz_girlstatue.PreClose()
  end;
  function zz_girlstatue.Close()
  end;  
end;
--*********************************************************************************************************************
------------------- other funcs -----------------------------
function public.nearhouse_idle1_zone_clk()  --rm_nearhouse.nearhouse_idle1_zone_clk()
  local func_end = function() 
    ObjSet( "obj_nearhouse_idle1_clk_zone", {input = 1} ); 
  end

  SoundSfx( "aud_touch_aid_nearhouse" );
  ld.AnimPlay( "anm_nearhouse_anm_neardoktor_idle", "idle_xl_1", func_end )
  ObjSet( "obj_nearhouse_idle1_clk_zone", {input = 0} ); 
end;  

------------------------------------