-- name=rm_terrace
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_terrace";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_terrace()
  if not ( cmn.IsEventDone( "opn_terrace" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_terrace" );
      cmn.CallEventHandler( "opn_terrace" )
      ld.ShowBbtOpn( private.room_objname )
      public.clk_animshadows3();
      SoundTheme( "aud_adventure1_mus" );
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_terrace = function() end;
local opn_terrace_logic = function() end;
cmn.AddSubscriber( "opn_terrace", opn_terrace_logic )
cmn.AddSubscriber( "opn_terrace", opn_terrace, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animshadows3" ] = { type = "click", use_place = "gfx_terrace_clk_animshadows3_zone", room = "rm_terrace" };

private.clk_animshadows3_logic = function()
  ObjSet("gzz_terrace_birdhouse", { visible = 1, input = 1, active = 1 })
  ObjSet("gzz_terrace_baskets", { visible = 1, input = 1, active = 1 })
  ObjSet("gzz_terrace_installation", { visible = 1, input = 1, active = 1 })
  ObjSet("gzz_terrace_pubdoor", { visible = 1, input = 1, active = 1 })  
end;
private.clk_animshadows3_beg = function()
  ObjDelete( "gfx_terrace_clk_animshadows3_zone" );
end;
private.clk_animshadows3_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animshadows3", private.clk_animshadows3_beg, private.room_objname );
cmn.AddSubscriber( "clk_animshadows3", private.clk_animshadows3_end, private.room_objname );
cmn.AddSubscriber( "clk_animshadows3", private.clk_animshadows3_logic );
cmn.AddSubscriber( "clk_animshadows3_beg", private.clk_animshadows3_beg, private.room_objname );
cmn.AddSubscriber( "clk_animshadows3_end", private.clk_animshadows3_end, private.room_objname );
cmn.AddSubscriber( "clk_animshadows3_end", private.clk_animshadows3_logic );
--------------------------------------------------------------------------------------------
function public.clk_animshadows3()

  local func_end = function()
    cmn.SetEventDone( "clk_animshadows3" );
    cmn.CallEventHandler( "clk_animshadows3_end" );
    common_impl.Lock(0);
    -- ld.ShowBbt("after_anmterrace");
  end;

  cmn.CallEventHandler( "clk_animshadows3_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_clk_animshadows3_terrace" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pubdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_dollhat" ] = { type = "get", get_obj = "spr_pubdoor_dollhat", room = "rm_terrace", zz = "zz_pubdoor", zz_gate = "gzz_terrace_pubdoor" };

private.get_dollhat_logic = function()
  
end;
private.get_dollhat_inv = function()
  interface.InventoryItemAdd("inv_dollhat","spr_pubdoor_dollhat");
end;
private.get_dollhat_beg = function()
  ObjDelete("gfx_pubdoor_dollhat")
end;
private.get_dollhat_end = function()
  if common_impl.ZzCompleteCheck("get_dollhat") then ObjSet( common_impl.hint["get_dollhat"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_pubdoor_sh_dollhat");
  ObjDelete("spr_terrace_dollhat")
end;

cmn.AddSubscriber( "get_dollhat", private.get_dollhat_inv );
cmn.AddSubscriber( "get_dollhat", private.get_dollhat_beg, private.room_objname );
cmn.AddSubscriber( "get_dollhat", private.get_dollhat_end, private.room_objname );
cmn.AddSubscriber( "get_dollhat", private.get_dollhat_logic );
--------------------------------------------------------------------
function public.get_dollhat()
  cmn.SetEventDone( "get_dollhat" );
  cmn.CallEventHandler( "get_dollhat" );
  if common_impl.ZzCompleteCheck("get_dollhat") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_hacksaw_zone_clk()  --rm_terrace.use_hacksaw_zone_clk()
  local func_end = function()
    common_impl.ShowBbt( 'need_hacksaw' );
    ld.Lock(0);
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_big_metal" );
  ld.AnimPlay( "anm_pubdoor_anm_pub_lock", "idle_lock", func_end )
end;  




common_impl.hint[ "use_hacksaw" ] = { type = "use", inv_obj = "inv_hacksaw", use_place = "gfx_pubdoor_hacksaw_zone", room = "rm_terrace", zz = "zz_pubdoor", zz_gate = "gzz_terrace_pubdoor" };

private.use_hacksaw_logic = function()
  ObjSet( "spr_pubdoor_padlock1", { visible = 1, input = 1, active = 1 } )

end;
private.use_hacksaw_inv = function()
  common_impl.ProcessMultiUseAll("hacksaw", "hacksaw")
end;
private.use_hacksaw_beg = function()
  ObjDelete( "gfx_pubdoor_hacksaw_zone" );
end;
private.use_hacksaw_end = function()
  if common_impl.ZzCompleteCheck("use_hacksaw") then ObjSet( common_impl.hint["use_hacksaw"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_pubdoor_anm_pub_lock");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hacksaw", private.use_hacksaw_inv );
cmn.AddSubscriber( "use_hacksaw", private.use_hacksaw_beg, private.room_objname );
cmn.AddSubscriber( "use_hacksaw", private.use_hacksaw_end, private.room_objname );
cmn.AddSubscriber( "use_hacksaw", private.use_hacksaw_logic );
cmn.AddSubscriber( "use_hacksaw_inv", private.use_hacksaw_inv, private.room_objname );
cmn.AddSubscriber( "use_hacksaw_beg", private.use_hacksaw_beg, private.room_objname );
cmn.AddSubscriber( "use_hacksaw_end", private.use_hacksaw_end, private.room_objname );
cmn.AddSubscriber( "use_hacksaw_end", private.use_hacksaw_logic );
--------------------------------------------------------------------------------------------
function public.use_hacksaw( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hacksaw" );
    cmn.CallEventHandler( "use_hacksaw_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hacksaw") then ld.CloseSubRoom() end;
    public.get_padlock1();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hacksaw_inv" );
  cmn.CallEventHandler( "use_hacksaw_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pubdoor_anm_pub_lock", "use_saw", func_end );
  SoundSfx( "aud_use_hacksaw_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_padlock1" ] = { type = "get", get_obj = "spr_pubdoor_padlock1", room = "rm_terrace", zz = "zz_pubdoor", zz_gate = "gzz_terrace_pubdoor" };

private.get_padlock1_logic = function()
  
end;
private.get_padlock1_inv = function()
  interface.InventoryItemAdd("inv_padlock1","spr_pubdoor_padlock1");
end;
private.get_padlock1_beg = function()
  ObjDelete("gfx_pubdoor_padlock1")
end;
private.get_padlock1_end = function()
  if common_impl.ZzCompleteCheck("get_padlock1") then ObjSet( common_impl.hint["get_padlock1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_terrace_padlock1");
end;

cmn.AddSubscriber( "get_padlock1", private.get_padlock1_inv );
cmn.AddSubscriber( "get_padlock1", private.get_padlock1_beg, private.room_objname );
cmn.AddSubscriber( "get_padlock1", private.get_padlock1_end, private.room_objname );
cmn.AddSubscriber( "get_padlock1", private.get_padlock1_logic );
--------------------------------------------------------------------
function public.get_padlock1()
  cmn.SetEventDone( "get_padlock1" );
  cmn.CallEventHandler( "get_padlock1" );
  if common_impl.ZzCompleteCheck("get_padlock1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_schilling_zone_clk()  -- rm_terrace.use_schilling_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_schilling' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_handle_terrace" )
  ld.AnimPlay( "anm_pubdoor_anm_pub", "idle_handle", func_end )
end;  



common_impl.hint[ "use_schilling" ] = { type = "use", inv_obj = "inv_schilling", use_place = "gfx_pubdoor_schilling_zone", room = "rm_terrace", zz = "zz_pubdoor", zz_gate = "gzz_terrace_pubdoor" };

private.use_schilling_logic = function()
  -- ObjSet( "grm_terrace_pub", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_pubdoor_clk_openpubdoor_zone", { active = 1, input=1, visible=1 } );
end;
private.use_schilling_inv = function()
  common_impl.ProcessMultiUseAll("schilling", "schilling")
end;
private.use_schilling_beg = function()
  ObjDelete( "gfx_pubdoor_schilling_zone" );
end;
private.use_schilling_end = function()
  if common_impl.ZzCompleteCheck("use_schilling") then ObjSet( common_impl.hint["use_schilling"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pubdoor_anm_pub", {animfunc = "open_door1", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_schilling", private.use_schilling_inv );
cmn.AddSubscriber( "use_schilling", private.use_schilling_beg, private.room_objname );
cmn.AddSubscriber( "use_schilling", private.use_schilling_end, private.room_objname );
cmn.AddSubscriber( "use_schilling", private.use_schilling_logic );
cmn.AddSubscriber( "use_schilling_inv", private.use_schilling_inv, private.room_objname );
cmn.AddSubscriber( "use_schilling_beg", private.use_schilling_beg, private.room_objname );
cmn.AddSubscriber( "use_schilling_end", private.use_schilling_end, private.room_objname );
cmn.AddSubscriber( "use_schilling_end", private.use_schilling_logic );
--------------------------------------------------------------------------------------------
function public.use_schilling( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_schilling" );
    cmn.CallEventHandler( "use_schilling_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_schilling") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_schilling_inv" );
  cmn.CallEventHandler( "use_schilling_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pubdoor_anm_pub", "open_door", func_end );
  SoundSfx( "aud_use_schilling_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_openpubdoor" ] = { type = "click", use_place = "gfx_pubdoor_clk_openpubdoor_zone", room = "rm_terrace" , zz = "zz_pubdoor", zz_gate = "gzz_terrace_pubdoor" };

private.clk_openpubdoor_logic = function()
  ObjSet( "grm_terrace_pub", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_terrace_pub_focus");
  end;
end;
private.clk_openpubdoor_beg = function()
  ObjDelete( "gfx_terrace_clk_openpubdoor_zone" );
end;
private.clk_openpubdoor_end = function()
   if common_impl.ZzCompleteCheck("clk_openpubdoor") then ObjSet( common_impl.hint["use_schilling"].zz_gate, { visible = 0, input = 0 } ); end;
   ObjSet( "spr_terrace_open_door", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_openpubdoor", private.clk_openpubdoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_openpubdoor", private.clk_openpubdoor_end, private.room_objname );
cmn.AddSubscriber( "clk_openpubdoor", private.clk_openpubdoor_logic );
cmn.AddSubscriber( "clk_openpubdoor_beg", private.clk_openpubdoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_openpubdoor_end", private.clk_openpubdoor_end, private.room_objname );
cmn.AddSubscriber( "clk_openpubdoor_end", private.clk_openpubdoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_openpubdoor()

  local func_end = function()
    cmn.SetEventDone( "clk_openpubdoor" );
    cmn.CallEventHandler( "clk_openpubdoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_openpubdoor") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_openpubdoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pubdoor_anm_pub", "open_door1", func_end );
  SoundSfx( "aud_touch_pab_door_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_installation *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_dollhat_zone_clk() -- rm_terrace.use_dollhat_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_dollhat' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_installation_anm_inst_bro", "idle_brograf", func_end )  
end;  


common_impl.hint[ "use_dollhat" ] = { type = "use", inv_obj = "inv_dollhat", use_place = "gfx_installation_dollhat_zone", room = "rm_terrace", zz = "zz_installation", zz_gate = "gzz_terrace_installation" };

private.use_dollhat_logic = function()
  ObjSet( "spr_installation_valve", { visible = 1, input = 1, active = 1 } )

end;
private.use_dollhat_inv = function()
  common_impl.ProcessMultiUseAll("dollhat", "dollhat")
end;
private.use_dollhat_beg = function()
  ObjDelete( "gfx_installation_dollhat_zone" );
end;
private.use_dollhat_end = function()
  if common_impl.ZzCompleteCheck("use_dollhat") then ObjSet( common_impl.hint["use_dollhat"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_installation_anm_inst_bro", {animfunc = "end_valve", frame = 0 } );
  ObjSet( "spr_installation_sh_valve", {visible = 1} );
  ObjSet( "spr_terrace_hat", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dollhat", private.use_dollhat_inv );
cmn.AddSubscriber( "use_dollhat", private.use_dollhat_beg, private.room_objname );
cmn.AddSubscriber( "use_dollhat", private.use_dollhat_end, private.room_objname );
cmn.AddSubscriber( "use_dollhat", private.use_dollhat_logic );
cmn.AddSubscriber( "use_dollhat_inv", private.use_dollhat_inv, private.room_objname );
cmn.AddSubscriber( "use_dollhat_beg", private.use_dollhat_beg, private.room_objname );
cmn.AddSubscriber( "use_dollhat_end", private.use_dollhat_end, private.room_objname );
cmn.AddSubscriber( "use_dollhat_end", private.use_dollhat_logic );
--------------------------------------------------------------------------------------------
function public.use_dollhat( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dollhat" );
    cmn.CallEventHandler( "use_dollhat_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dollhat") then ld.CloseSubRoom() end;
    --public.get_valve();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dollhat_inv" );
  cmn.CallEventHandler( "use_dollhat_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_installation_anm_inst_bro", "use_trbro", func_end );
  SoundSfx( "aud_use_dollhat_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_valve" ] = { type = "get", get_obj = "spr_installation_valve", room = "rm_terrace", zz = "zz_installation", zz_gate = "gzz_terrace_installation" };

private.get_valve_logic = function()
  
end;
private.get_valve_inv = function()
  interface.InventoryItemAdd("inv_valve","spr_installation_valve");
end;
private.get_valve_beg = function()
  ObjDelete("gfx_installation_valve")
end;
private.get_valve_end = function()
  if common_impl.ZzCompleteCheck("get_valve") then ObjSet( common_impl.hint["get_valve"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_installation_sh_valve");
end;

cmn.AddSubscriber( "get_valve", private.get_valve_inv );
cmn.AddSubscriber( "get_valve", private.get_valve_beg, private.room_objname );
cmn.AddSubscriber( "get_valve", private.get_valve_end, private.room_objname );
cmn.AddSubscriber( "get_valve", private.get_valve_logic );
--------------------------------------------------------------------
function public.get_valve()
  cmn.SetEventDone( "get_valve" );
  cmn.CallEventHandler( "get_valve" );
  if common_impl.ZzCompleteCheck("get_valve") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_bracelet_zone_clk() -- rm_terrace.use_bracelet_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_bracelet' )
  end;  
  
  SoundSfx( "aud_touch_clothes" );
  ld.Lock(1);
  ld.AnimPlay( "anm_installation_anm_inst_son", "idle_tr", func_end )  
end;  


common_impl.hint[ "use_bracelet" ] = { type = "use", inv_obj = "inv_bracelet", use_place = "gfx_installation_bracelet_zone", room = "rm_terrace", zz = "zz_installation", zz_gate = "gzz_terrace_installation" };

private.use_bracelet_logic = function()
  ObjSet( "spr_installation_fishingrod", { visible = 1, input = 1, active = 1 } )

end;
private.use_bracelet_inv = function()
  common_impl.ProcessMultiUseAll("bracelet", "bracelet")
end;
private.use_bracelet_beg = function()
  ObjDelete( "gfx_installation_bracelet_zone" );
end;
private.use_bracelet_end = function()
  if common_impl.ZzCompleteCheck("use_bracelet") then ObjSet( common_impl.hint["use_bracelet"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_installation_anm_inst_son", {animfunc = "end_fish", frame = 0 } );
  ObjSet( "spr_installation_sh_fishingrod", {visible = 1} );
  ObjSet( "spr_terrace_son", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_inv );
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_beg, private.room_objname );
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_end, private.room_objname );
cmn.AddSubscriber( "use_bracelet", private.use_bracelet_logic );
cmn.AddSubscriber( "use_bracelet_inv", private.use_bracelet_inv, private.room_objname );
cmn.AddSubscriber( "use_bracelet_beg", private.use_bracelet_beg, private.room_objname );
cmn.AddSubscriber( "use_bracelet_end", private.use_bracelet_end, private.room_objname );
cmn.AddSubscriber( "use_bracelet_end", private.use_bracelet_logic );
--------------------------------------------------------------------------------------------
function public.use_bracelet( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bracelet" );
    cmn.CallEventHandler( "use_bracelet_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bracelet") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bracelet_inv" );
  cmn.CallEventHandler( "use_bracelet_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_installation_anm_inst_son", "use_son", func_end );
  SoundSfx( "aud_use_sams_doll_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fishingrod" ] = { type = "get", get_obj = "spr_installation_fishingrod", room = "rm_terrace", zz = "zz_installation", zz_gate = "gzz_terrace_installation" };

private.get_fishingrod_logic = function()
  
end;
private.get_fishingrod_inv = function()
  interface.InventoryItemAdd("inv_fishingrod","spr_installation_fishingrod");
end;
private.get_fishingrod_beg = function()
  ObjDelete("gfx_installation_fishingrod")
end;
private.get_fishingrod_end = function()
  if common_impl.ZzCompleteCheck("get_fishingrod") then ObjSet( common_impl.hint["get_fishingrod"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_installation_sh_fishingrod");
  ObjDelete("spr_terrace_fishingrod");
end;

cmn.AddSubscriber( "get_fishingrod", private.get_fishingrod_inv );
cmn.AddSubscriber( "get_fishingrod", private.get_fishingrod_beg, private.room_objname );
cmn.AddSubscriber( "get_fishingrod", private.get_fishingrod_end, private.room_objname );
cmn.AddSubscriber( "get_fishingrod", private.get_fishingrod_logic );
--------------------------------------------------------------------
function public.get_fishingrod()
  cmn.SetEventDone( "get_fishingrod" );
  cmn.CallEventHandler( "get_fishingrod" );
  if common_impl.ZzCompleteCheck("get_fishingrod") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_dolly_zone_clk() -- rm_terrace.use_dolly_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_dolly' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_installation_anm_inst_door", "idle_door", func_end )  
end;  



common_impl.hint[ "use_dolly" ] = { type = "use", inv_obj = "inv_dolly", use_place = "gfx_installation_dolly_zone", room = "rm_terrace", zz = "zz_installation", zz_gate = "gzz_terrace_installation" };

private.use_dolly_logic = function()
  ObjSet( "gmg_terrace_dolls", { visible = 1, input = 1, active = 1 } )

end;
private.use_dolly_inv = function()
  common_impl.ProcessMultiUseAll("dolly", "dolly")
end;
private.use_dolly_beg = function()
  ObjDelete( "gfx_installation_dolly_zone" );
end;
private.use_dolly_end = function()
  if common_impl.ZzCompleteCheck("use_dolly") then ObjSet( common_impl.hint["use_dolly"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_installation_anm_inst_dolly", {animfunc = "use_countess", frame = 999 } );
  ObjDelete("obj_installation_door_clk_zone");
  ObjSet( "spr_terrace_countess", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dolly", private.use_dolly_inv );
cmn.AddSubscriber( "use_dolly", private.use_dolly_beg, private.room_objname );
cmn.AddSubscriber( "use_dolly", private.use_dolly_end, private.room_objname );
cmn.AddSubscriber( "use_dolly", private.use_dolly_logic );
cmn.AddSubscriber( "use_dolly_inv", private.use_dolly_inv, private.room_objname );
cmn.AddSubscriber( "use_dolly_beg", private.use_dolly_beg, private.room_objname );
cmn.AddSubscriber( "use_dolly_end", private.use_dolly_end, private.room_objname );
cmn.AddSubscriber( "use_dolly_end", private.use_dolly_logic );
--------------------------------------------------------------------------------------------
function public.use_dolly( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dolly" );
    cmn.CallEventHandler( "use_dolly_end" );
    --common_impl.Lock(0);
    ld.CloseSubRoom();
    ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_dolls" ); end )
    if common_impl.ZzCompleteCheck("use_dolly") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dolly_inv" );
  cmn.CallEventHandler( "use_dolly_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_installation_anm_inst_dolly", "use_countess", func_end );
  SoundSfx( "aud_use_dolly_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_baskets *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_valve" ] = { type = "use", inv_obj = "inv_valve", use_place = "gfx_baskets_valve_zone", room = "rm_terrace", zz = "zz_baskets", zz_gate = "gzz_terrace_baskets" };

private.use_valve_logic = function()
  -- ObjSet( "gfx_baskets_clk_turnvalve_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_baskets_glass", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_baskets_glass", { active = 1, visible = 1} );
end;
private.use_valve_inv = function()
  common_impl.ProcessMultiUseAll("valve", "valve")
end;
private.use_valve_beg = function()
  ObjDelete( "gfx_baskets_valve_zone" );
end;
private.use_valve_end = function()
  if common_impl.ZzCompleteCheck("use_valve") then ObjSet( common_impl.hint["use_valve"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_baskets_anm_water", {animfunc = "lever", frame = 999, playing=0 } );
  ObjDelete("anm_terrace_anm_water");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_valve", private.use_valve_inv );
cmn.AddSubscriber( "use_valve", private.use_valve_beg, private.room_objname );
cmn.AddSubscriber( "use_valve", private.use_valve_end, private.room_objname );
cmn.AddSubscriber( "use_valve", private.use_valve_logic );
cmn.AddSubscriber( "use_valve_inv", private.use_valve_inv, private.room_objname );
cmn.AddSubscriber( "use_valve_beg", private.use_valve_beg, private.room_objname );
cmn.AddSubscriber( "use_valve_end", private.use_valve_end, private.room_objname );
cmn.AddSubscriber( "use_valve_end", private.use_valve_logic );
--------------------------------------------------------------------------------------------
function public.use_valve( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_valve" );
    cmn.CallEventHandler( "use_valve_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_valve") then ld.CloseSubRoom() end;
    SoundEnv("aud_fountain_loc_terrace_env",0);
    SoundEnv("aud_fountain_zz_terrace_env",0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_valve_inv" );
  cmn.CallEventHandler( "use_valve_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_baskets_anm_water", "lever", func_end );
  SoundSfx( "aud_use_valve_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_turnvalve" ] = { type = "click", use_place = "gfx_baskets_clk_turnvalve_zone", room = "rm_terrace", zz = "zz_baskets", zz_gate = "gzz_terrace_baskets" };
--
--private.clk_turnvalve_logic = function()
--  ObjSet( "spr_baskets_glass", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.clk_turnvalve_beg = function()
--  ObjDelete( "gfx_baskets_clk_turnvalve_zone" );
--end;
--private.clk_turnvalve_end = function()
--  if common_impl.ZzCompleteCheck("clk_turnvalve") then ObjSet( common_impl.hint["clk_turnvalve"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_turnvalve", private.clk_turnvalve_beg, private.room_objname );
--cmn.AddSubscriber( "clk_turnvalve", private.clk_turnvalve_end, private.room_objname );
--cmn.AddSubscriber( "clk_turnvalve", private.clk_turnvalve_logic );
--cmn.AddSubscriber( "clk_turnvalve_beg", private.clk_turnvalve_beg, private.room_objname );
--cmn.AddSubscriber( "clk_turnvalve_end", private.clk_turnvalve_end, private.room_objname );
--cmn.AddSubscriber( "clk_turnvalve_end", private.clk_turnvalve_logic );
----------------------------------------------------------------------------------------------
--function public.clk_turnvalve()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_turnvalve" );
--    cmn.CallEventHandler( "clk_turnvalve_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_turnvalve") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_turnvalve_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  SoundSfx( "aud_clk_turnvalve_terrace" )
--  func_end()
--
--end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_glass" ] = { type = "get", get_obj = "spr_baskets_glass", room = "rm_terrace", zz = "zz_baskets", zz_gate = "gzz_terrace_baskets" };

private.get_glass_logic = function()
  
end;
private.get_glass_inv = function()
  interface.InventoryItemAdd("inv_glass","spr_baskets_glass");
end;
private.get_glass_beg = function()
  ObjDelete("gfx_baskets_glass")
end;
private.get_glass_end = function()
  if common_impl.ZzCompleteCheck("get_glass") then ObjSet( common_impl.hint["get_glass"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_baskets_sh_glass");
end;

cmn.AddSubscriber( "get_glass", private.get_glass_inv );
cmn.AddSubscriber( "get_glass", private.get_glass_beg, private.room_objname );
cmn.AddSubscriber( "get_glass", private.get_glass_end, private.room_objname );
cmn.AddSubscriber( "get_glass", private.get_glass_logic );
--------------------------------------------------------------------
function public.get_glass()
  cmn.SetEventDone( "get_glass" );
  cmn.CallEventHandler( "get_glass" );
  if common_impl.ZzCompleteCheck("get_glass") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_roosterpart_zone_clk()  -- rm_terrace.use_roosterpart_zone_clk()
  local func_end = function()
    ld.Lock(0); 
    common_impl.ShowBbt( 'need_roosterpart' );
  end
  
  SoundSfx( "aud_touch_small_plastic" );
  ld.Lock(1);
  ld.AnimPlay( "anm_baskets_anm_rooster", "rooster_static", func_end );
end;  

common_impl.hint[ "use_roosterpart" ] = { type = "use", inv_obj = "inv_roosterpart", use_place = "gfx_baskets_roosterpart_zone", room = "rm_terrace", zz = "zz_baskets", zz_gate = "gzz_terrace_baskets" };

private.use_roosterpart_logic = function()
  ObjSet( "spr_baskets_rooster", { visible = 1, input = 1, active = 1 } )

end;
private.use_roosterpart_inv = function()
  common_impl.ProcessMultiUseAll("roosterpart", "roosterpart")
end;
private.use_roosterpart_beg = function()
  ObjDelete( "gfx_baskets_roosterpart_zone" );
end;
private.use_roosterpart_end = function()
  if common_impl.ZzCompleteCheck("use_roosterpart") then ObjSet( common_impl.hint["use_roosterpart"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_baskets_anm_rooster");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_roosterpart", private.use_roosterpart_inv );
cmn.AddSubscriber( "use_roosterpart", private.use_roosterpart_beg, private.room_objname );
cmn.AddSubscriber( "use_roosterpart", private.use_roosterpart_end, private.room_objname );
cmn.AddSubscriber( "use_roosterpart", private.use_roosterpart_logic );
cmn.AddSubscriber( "use_roosterpart_inv", private.use_roosterpart_inv, private.room_objname );
cmn.AddSubscriber( "use_roosterpart_beg", private.use_roosterpart_beg, private.room_objname );
cmn.AddSubscriber( "use_roosterpart_end", private.use_roosterpart_end, private.room_objname );
cmn.AddSubscriber( "use_roosterpart_end", private.use_roosterpart_logic );
--------------------------------------------------------------------------------------------
function public.use_roosterpart( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_roosterpart" );
    cmn.CallEventHandler( "use_roosterpart_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_roosterpart") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_roosterpart_inv" );
  cmn.CallEventHandler( "use_roosterpart_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_baskets_anm_rooster", "rooster", func_end );
  SoundSfx( "aud_use_roosterpart_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_rooster" ] = { type = "get", get_obj = "spr_baskets_rooster", room = "rm_terrace", zz = "zz_baskets", zz_gate = "gzz_terrace_baskets" };

private.get_rooster_logic = function()
  
end;
private.get_rooster_inv = function()
  interface.InventoryItemAdd("inv_rooster","spr_baskets_rooster");
end;
private.get_rooster_beg = function()
  ObjDelete("gfx_baskets_rooster")
end;
private.get_rooster_end = function()
  if common_impl.ZzCompleteCheck("get_rooster") then ObjSet( common_impl.hint["get_rooster"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_rooster", private.get_rooster_inv );
cmn.AddSubscriber( "get_rooster", private.get_rooster_beg, private.room_objname );
cmn.AddSubscriber( "get_rooster", private.get_rooster_end, private.room_objname );
cmn.AddSubscriber( "get_rooster", private.get_rooster_logic );
--------------------------------------------------------------------
function public.get_rooster()
  cmn.SetEventDone( "get_rooster" );
  cmn.CallEventHandler( "get_rooster" );
  if common_impl.ZzCompleteCheck("get_rooster") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_birdhouse *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_grains_zone_clk()  --rm_terrace.use_grains_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_grains' );
    ObjSet( "anm_birdhouse_anm_bird", {animfunc = "statik_bird", frame = 0, playing=1 } );
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_birdhouse_anm_bird", "click_bird", func_end )
  SoundSfx( "aud_touch_birds_terrace" );
end;  



common_impl.hint[ "use_grains" ] = { type = "use", inv_obj = "inv_grains", use_place = "gfx_birdhouse_grains_zone", room = "rm_terrace", zz = "zz_birdhouse", zz_gate = "gzz_terrace_birdhouse" };

private.use_grains_logic = function()
  ObjSet( "spr_birdhouse_schilling1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_birdhouse_padlock2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_birdhouse_padlock2", { active = 1, visible = 1} );
  ObjSet( "gfx_birdhouse_schilling1", { active = 1, visible = 1} );
end;
private.use_grains_inv = function()
  common_impl.ProcessMultiUseAll("grains", "grains")
end;
private.use_grains_beg = function()
  ObjDelete( "gfx_birdhouse_grains_zone" );
end;
private.use_grains_end = function()
  if common_impl.ZzCompleteCheck("use_grains") then ObjSet( common_impl.hint["use_grains"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_birdhouse_anm_bird", {animfunc = "statik_bird", frame = 0, playing=1 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_grains", private.use_grains_inv );
cmn.AddSubscriber( "use_grains", private.use_grains_beg, private.room_objname );
cmn.AddSubscriber( "use_grains", private.use_grains_end, private.room_objname );
cmn.AddSubscriber( "use_grains", private.use_grains_logic );
cmn.AddSubscriber( "use_grains_inv", private.use_grains_inv, private.room_objname );
cmn.AddSubscriber( "use_grains_beg", private.use_grains_beg, private.room_objname );
cmn.AddSubscriber( "use_grains_end", private.use_grains_end, private.room_objname );
cmn.AddSubscriber( "use_grains_end", private.use_grains_logic );
--------------------------------------------------------------------------------------------
function public.use_grains( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_grains" );
    cmn.CallEventHandler( "use_grains_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_grains") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_grains_inv" );
  cmn.CallEventHandler( "use_grains_beg" );
  common_impl.Lock(1);

  
  ld.AnimPlay( "anm_birdhouse_anm_bird", "use_glass", func_end );
  SoundSfx( "aud_use_grains_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_schilling1" ] = { type = "get", get_obj = "spr_birdhouse_schilling1", room = "rm_terrace", zz = "zz_birdhouse", zz_gate = "gzz_terrace_birdhouse" };

private.get_schilling1_logic = function()
  
end;
private.get_schilling1_inv = function()
  interface.InventoryItemAdd("inv_schilling","spr_birdhouse_schilling1",function() level_inv.ProcessGetSchillingAll( "get_schilling1" ) end);
end;
private.get_schilling1_beg = function()
  ObjDelete("gfx_birdhouse_schilling1")
end;
private.get_schilling1_end = function()
  if common_impl.ZzCompleteCheck("get_schilling1") then ObjSet( common_impl.hint["get_schilling1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_birdhouse_sh_schilling1")
  ObjDelete("spr_terrace_schilling1");
end;

cmn.AddSubscriber( "get_schilling1", private.get_schilling1_inv );
cmn.AddSubscriber( "get_schilling1", private.get_schilling1_beg, private.room_objname );
cmn.AddSubscriber( "get_schilling1", private.get_schilling1_end, private.room_objname );
cmn.AddSubscriber( "get_schilling1", private.get_schilling1_logic );
--------------------------------------------------------------------
function public.get_schilling1()
  cmn.SetEventDone( "get_schilling1" );
  cmn.CallEventHandler( "get_schilling1" );
  if common_impl.ZzCompleteCheck("get_schilling1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_padlock2" ] = { type = "get", get_obj = "spr_birdhouse_padlock2", room = "rm_terrace", zz = "zz_birdhouse", zz_gate = "gzz_terrace_birdhouse" };

private.get_padlock2_logic = function()
  
end;
private.get_padlock2_inv = function()
  interface.InventoryItemAdd("inv_padlock2","spr_birdhouse_padlock2");
end;
private.get_padlock2_beg = function()
  ObjDelete("gfx_birdhouse_padlock2")
end;
private.get_padlock2_end = function()
  if common_impl.ZzCompleteCheck("get_padlock2") then ObjSet( common_impl.hint["get_padlock2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_birdhouse_sh_padlock2");
  ObjDelete("spr_terrace_padlock2");
end;

cmn.AddSubscriber( "get_padlock2", private.get_padlock2_inv );
cmn.AddSubscriber( "get_padlock2", private.get_padlock2_beg, private.room_objname );
cmn.AddSubscriber( "get_padlock2", private.get_padlock2_end, private.room_objname );
cmn.AddSubscriber( "get_padlock2", private.get_padlock2_logic );
--------------------------------------------------------------------
function public.get_padlock2()
  cmn.SetEventDone( "get_padlock2" );
  cmn.CallEventHandler( "get_padlock2" );
  if common_impl.ZzCompleteCheck("get_padlock2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_tube_zone_clk()  --- rm_terrace.use_tube_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_tube' );
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_birdhouse_anm_tube", "idle_tube1", func_end )
  SoundSfx( "aud_touch_clothes" );
end;  



common_impl.hint[ "use_tube" ] = { type = "use", inv_obj = "inv_tube", use_place = "gfx_birdhouse_tube_zone", room = "rm_terrace", zz = "zz_birdhouse", zz_gate = "gzz_terrace_birdhouse" };

private.use_tube_logic = function()
  ObjSet( "spr_birdhouse_shirt", { visible = 1, input = 1, active = 1 } )

end;
private.use_tube_inv = function()
  common_impl.ProcessMultiUseAll("tube", "tube")
end;
private.use_tube_beg = function()
  ObjDelete( "gfx_birdhouse_tube_zone" );
end;
private.use_tube_end = function()
  if common_impl.ZzCompleteCheck("use_tube") then ObjSet( common_impl.hint["use_tube"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_birdhouse_anm_tube",{anifunc = "use_tube", frame=999});
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tube", private.use_tube_inv );
cmn.AddSubscriber( "use_tube", private.use_tube_beg, private.room_objname );
cmn.AddSubscriber( "use_tube", private.use_tube_end, private.room_objname );
cmn.AddSubscriber( "use_tube", private.use_tube_logic );
cmn.AddSubscriber( "use_tube_inv", private.use_tube_inv, private.room_objname );
cmn.AddSubscriber( "use_tube_beg", private.use_tube_beg, private.room_objname );
cmn.AddSubscriber( "use_tube_end", private.use_tube_end, private.room_objname );
cmn.AddSubscriber( "use_tube_end", private.use_tube_logic );
--------------------------------------------------------------------------------------------
function public.use_tube( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tube" );
    cmn.CallEventHandler( "use_tube_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tube") then ld.CloseSubRoom() end;
    public.get_shirt();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tube_inv" );
  cmn.CallEventHandler( "use_tube_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_birdhouse_anm_tube", "use_tube", func_end );
  SoundSfx( "aud_use_tube_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_shirt" ] = { type = "get", get_obj = "spr_birdhouse_shirt", room = "rm_terrace", zz = "zz_birdhouse", zz_gate = "gzz_terrace_birdhouse" };

private.get_shirt_logic = function()
  
end;
private.get_shirt_inv = function()
  interface.InventoryItemAdd("inv_shirt","spr_birdhouse_shirt");
  ObjSet( "inv_shirt", { drag = 0 } );
end;
private.get_shirt_beg = function()
  ObjDelete("gfx_birdhouse_shirt")
end;
private.get_shirt_end = function()
  if common_impl.ZzCompleteCheck("get_shirt") then ObjSet( common_impl.hint["get_shirt"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_terrace_shirt");
end;

cmn.AddSubscriber( "get_shirt", private.get_shirt_inv );
cmn.AddSubscriber( "get_shirt", private.get_shirt_beg, private.room_objname );
cmn.AddSubscriber( "get_shirt", private.get_shirt_end, private.room_objname );
cmn.AddSubscriber( "get_shirt", private.get_shirt_logic );
--------------------------------------------------------------------
function public.get_shirt()
  cmn.SetEventDone( "get_shirt" );
  cmn.CallEventHandler( "get_shirt" );
  if common_impl.ZzCompleteCheck("get_shirt") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_vanepart_zone_clk()  --- rm_terrace.use_vanepart_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_vanepart' )
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_birdhouse_anm_vanepart", "idle_vanepart1", func_end )
  SoundSfx( "aud_touch_small_plastic" );
end;  


common_impl.hint[ "use_vanepart" ] = { type = "use", inv_obj = "inv_vanepart", use_place = "gfx_birdhouse_vanepart_zone", room = "rm_terrace", zz = "zz_birdhouse", zz_gate = "gzz_terrace_birdhouse" };

private.use_vanepart_logic = function()
  ObjSet( "spr_birdhouse_spoke", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_birdhouse_spoke", { active = 1, visible = 1} );
end;
private.use_vanepart_inv = function()
  common_impl.ProcessMultiUseAll("vanepart", "vanepart")
end;
private.use_vanepart_beg = function()
  ObjDelete( "gfx_birdhouse_vanepart_zone" );
end;
private.use_vanepart_end = function()
  if common_impl.ZzCompleteCheck("use_vanepart") then ObjSet( common_impl.hint["use_vanepart"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_birdhouse_anm_vanepart", {animfunc = "use_vanepart", frame = 999 } );
  ObjSet( "spr_terrace_vanepart", {visible = 1} );
  ObjSet( "spr_terrace_spoke", {visible = 1} );
  ObjSet( "spr_terrace_open_door2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_vanepart", private.use_vanepart_inv );
cmn.AddSubscriber( "use_vanepart", private.use_vanepart_beg, private.room_objname );
cmn.AddSubscriber( "use_vanepart", private.use_vanepart_end, private.room_objname );
cmn.AddSubscriber( "use_vanepart", private.use_vanepart_logic );
cmn.AddSubscriber( "use_vanepart_inv", private.use_vanepart_inv, private.room_objname );
cmn.AddSubscriber( "use_vanepart_beg", private.use_vanepart_beg, private.room_objname );
cmn.AddSubscriber( "use_vanepart_end", private.use_vanepart_end, private.room_objname );
cmn.AddSubscriber( "use_vanepart_end", private.use_vanepart_logic );
--------------------------------------------------------------------------------------------
function public.use_vanepart( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_vanepart" );
    cmn.CallEventHandler( "use_vanepart_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_vanepart") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_vanepart_inv" );
  cmn.CallEventHandler( "use_vanepart_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_birdhouse_anm_vanepart", "use_vanepart", func_end );
  SoundSfx( "aud_use_vanepart_terrace" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_spoke" ] = { type = "get", get_obj = "spr_birdhouse_spoke", room = "rm_terrace", zz = "zz_birdhouse", zz_gate = "gzz_terrace_birdhouse" };

private.get_spoke_logic = function()
  
end;
private.get_spoke_inv = function()
  interface.InventoryItemAdd("inv_spoke","spr_birdhouse_spoke");
end;
private.get_spoke_beg = function()
  ObjDelete("gfx_birdhouse_spoke")
end;
private.get_spoke_end = function()
  if common_impl.ZzCompleteCheck("get_spoke") then ObjSet( common_impl.hint["get_spoke"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_birdhouse_anm_vanepart", {animfunc = "end_vanepart1", frame = 0 } );
  ObjDelete("spr_terrace_spoke");
end;

cmn.AddSubscriber( "get_spoke", private.get_spoke_inv );
cmn.AddSubscriber( "get_spoke", private.get_spoke_beg, private.room_objname );
cmn.AddSubscriber( "get_spoke", private.get_spoke_end, private.room_objname );
cmn.AddSubscriber( "get_spoke", private.get_spoke_logic );
--------------------------------------------------------------------
function public.get_spoke()
  ObjSet( "spr_birdhouse_spoke", {visible = 1} );
  cmn.SetEventDone( "get_spoke" );
  cmn.CallEventHandler( "get_spoke" );
  if common_impl.ZzCompleteCheck("get_spoke") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_dolls_for_terrace = function()
    if ld.CheckRequirements( {"win_dolls","get_barkey"} ) then
      ObjSet( "gmg_terrace_dolls", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_dolls", win_dolls_for_terrace, private.room_objname )
  cmn.AddSubscriber("get_barkey", win_dolls_for_terrace, private.room_objname )
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_terrace();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_terrace_env" )
  SoundEnv("aud_birds_loc_terrace_env",1);
  
  if not cmn.IsEventDone("use_valve") then 
    SoundEnv("aud_fountain_loc_terrace_env",1);
  end;  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_birdhouse" );
  function zz_birdhouse.Open()
  end;
  function zz_birdhouse.PreOpen()
    SoundEnv("aud_birds_loc_terrace_env",0);
    SoundEnv("aud_birds_zz_terrace_env",1);
  end;
  function zz_birdhouse.PreClose()
  end;
  function zz_birdhouse.Close()
    SoundEnv("aud_birds_loc_terrace_env",1);
    SoundEnv("aud_birds_zz_terrace_env",0);
  end;

  subroom.Define( "zz_baskets" );
  function zz_baskets.Open()
  end;
  function zz_baskets.PreOpen()
    if not cmn.IsEventDone("use_valve") then 
      SoundEnv("aud_fountain_loc_terrace_env",0);
      SoundEnv("aud_fountain_zz_terrace_env",1);
    end;  
  end;
  function zz_baskets.PreClose()
  end;
  function zz_baskets.Close()
    if not cmn.IsEventDone("use_valve") then 
      SoundEnv("aud_fountain_loc_terrace_env",1);
      SoundEnv("aud_fountain_zz_terrace_env",0);
    end;
  end;

  subroom.Define( "zz_installation" );
  local zz_installation_open_flag = false;
  function zz_installation.Open()
    if zz_installation_open_flag == false then 
      ld.ShowBbt("opn_install");
    end; 
    zz_installation_open_flag  = true; 
  end;
  
  
  function zz_installation.PreOpen()
  end;
  function zz_installation.PreClose()
  end;
  function zz_installation.Close()
  end;

  subroom.Define( "zz_pubdoor" );
  function zz_pubdoor.Open()
  end;
  function zz_pubdoor.PreOpen()
  end;
  function zz_pubdoor.PreClose()
  end;
  function zz_pubdoor.Close()
  end;
  
end;
--*********************************************************************************************************************