-- name=ho_gothicext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "gothicext" );
  game.relations[ "ho_gothicext" ].exitroom = "rm_cryptext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gothicext" ] = { type = "win", room = "rm_cryptext", zz = "ho_gothicext", zz_gate = "gho_cryptext_gothicext" };
 
  local win_gothicext_func = function ()

    if ( cmn.IsEventDone( "win_gothicext" ) ) then
      interface.InventoryItemAdd( "inv_magicbranchesext", "spr_gothicext_win" );
      ObjSet( "inv_magicbranchesext", {drag=0} );
      ObjDelete( "gho_cryptext_gothicext" );
    end;

  end;
  cmn.AddSubscriber( "win_gothicext", win_gothicext_func );
  
  local start_gothicext_func = function ()
  if not cmn.IsEventDone("win_gothicext") then
    if #ng_global.progress["ext"]["win_gothicext"].found >= 12 then
         int_taskpanel_impl.ShowTask13() 
         ObjSet("spr_gothicext_mmm",{alp=1,input=1})  
        ObjSet("spr_gothicext_open",{alp=1,input=1}) 
      end
  end 
  end;
  cmn.AddSubscriber( "win_gothicext", start_gothicext_func, "ho_gothicext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_cryptext_env" )

  if ( not cmn.IsEventDone( "opn_gothicext" ) ) then

    cmn.InitHo( "gothicext" );

    cmn.SetEventDone( "opn_gothicext" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_gothicext_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_gothicext_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_gothicext_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_gothicext_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_gothicext_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_gothicext_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_gothicext_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_gothicext_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_gothicext_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_gothicext_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_gothicext_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_gothicext_lll" } } );
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "spr_gothicext_mmm" } } );  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["ext"]["win_gothicext"].found do

    local name = tostring( ng_global.progress["ext"]["win_gothicext"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
    int_taskpanel_impl.ResetTaskVisible()
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  if #ng_global.progress["ext"]["win_gothicext"].found  == 12 then
    local f_end=function()
      ld.Lock(0)
      ObjSet("spr_gothicext_mmm",{alp=1,input=1})  
      ObjSet("spr_gothicext_open",{alp=1,input=1})
    end
    ld.Lock(1)
    SoundSfx("aud_ho_gothicext_open")
    ObjAnimate( "spr_gothicext_open", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    int_taskpanel_impl.ShowTask13()     
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_gothicext_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_gothicext_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------