-- name=rm_groveext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_groveext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_groveext()
  if not ( cmn.IsEventDone( "opn_groveext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_groveext" );
      cmn.CallEventHandler( "opn_groveext" )
      ld.ShowBbtOpn( private.room_objname )
      
  end;
    public.clk_animspiritext1();
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_groveext = function() end;
local opn_groveext_logic = function() end;
cmn.AddSubscriber( "opn_groveext", opn_groveext_logic )
cmn.AddSubscriber( "opn_groveext", opn_groveext, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animspiritext1" ] = { type = "click", use_place = "gfx_groveext_clk_animspiritext1_zone", room = "rm_groveext" };

private.clk_animspiritext1_logic = function()
  ObjSet( "gzz_groveext_wellext", {input = 1, visible = 1} );
  ObjSet( "gzz_groveext_hedgehogsext", {input = 1, visible = 1} );
  ObjSet( "gzz_groveext_mossext", {input = 1, visible = 1} );
  ObjSet( "gzz_groveext_cryptentranceext", {input = 1, visible = 1} );
  ObjSet( "grm_groveext_nearhouseext", {input = 1, visible = 1} );
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_groveext_nearhouseext_focus");
  end;
end;
private.clk_animspiritext1_beg = function()
  ObjDelete( "gfx_groveext_clk_animspiritext1_zone" );
end;
private.clk_animspiritext1_end = function()
  ObjDelete("anm_groveext_anm_susie");  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animspiritext1", private.clk_animspiritext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext1", private.clk_animspiritext1_end, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext1", private.clk_animspiritext1_logic );
cmn.AddSubscriber( "clk_animspiritext1_beg", private.clk_animspiritext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext1_end", private.clk_animspiritext1_end, private.room_objname );
cmn.AddSubscriber( "clk_animspiritext1_end", private.clk_animspiritext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_animspiritext1()

  local func_end = function()
    cmn.SetEventDone( "clk_animspiritext1" );
    cmn.CallEventHandler( "clk_animspiritext1_end" );
    common_impl.Lock(0);
    SoundTheme( "aud_danger_moment1_mus" )
    ld.ShowBbt("after_animspiritext1");
  end;

  cmn.CallEventHandler( "clk_animspiritext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_groveext_anm_susie", "anim_suzi", func_end );
  SoundSfx( "aud_clk_animspiritext1_groveext" )
  SoundVoice("aud_clk_animspiritext1_groveext_voc");
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cryptentranceext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_candleext3" ] = { type = "get", get_obj = "spr_cryptentranceext_candleext3", room = "rm_groveext", zz = "zz_cryptentranceext", zz_gate = "gzz_groveext_cryptentranceext" };

private.get_candleext3_logic = function()
  
end;
private.get_candleext3_inv = function()
  interface.InventoryItemAdd("inv_candleext","spr_cryptentranceext_candleext3",function() level_inv.ProcessGetCandleextAll( "get_candleext3" ) end);
end;
private.get_candleext3_beg = function()
  ObjDelete("gfx_cryptentranceext_candleext3")
end;
private.get_candleext3_end = function()
  if common_impl.ZzCompleteCheck("get_candleext3") then ObjSet( common_impl.hint["get_candleext3"].zz_gate, { visible = 0, input = 0 } ); end;
  
end;

cmn.AddSubscriber( "get_candleext3", private.get_candleext3_inv );
cmn.AddSubscriber( "get_candleext3", private.get_candleext3_beg, private.room_objname );
cmn.AddSubscriber( "get_candleext3", private.get_candleext3_end, private.room_objname );
cmn.AddSubscriber( "get_candleext3", private.get_candleext3_logic );
--------------------------------------------------------------------
function public.get_candleext3()
  cmn.SetEventDone( "get_candleext3" );
  cmn.CallEventHandler( "get_candleext3" );
  if common_impl.ZzCompleteCheck("get_candleext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hookext" ] = { type = "use", inv_obj = "inv_hookext", use_place = "gfx_cryptentranceext_hookext_zone", room = "rm_groveext", zz = "zz_cryptentranceext", zz_gate = "gzz_groveext_cryptentranceext" };

private.use_hookext_logic = function()
  ObjSet( "spr_cryptentranceext_combext", { visible = 1, input = 1, active = 1 } )

end;
private.use_hookext_inv = function()
  common_impl.ProcessMultiUseAll("hookext", "hookext")
end;
private.use_hookext_beg = function()
  ObjDelete( "gfx_cryptentranceext_hookext_zone" );
end;
private.use_hookext_end = function()
  if common_impl.ZzCompleteCheck("use_hookext") then ObjSet( common_impl.hint["use_hookext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_cryptentranceext_anm_hook");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hookext", private.use_hookext_inv );
cmn.AddSubscriber( "use_hookext", private.use_hookext_beg, private.room_objname );
cmn.AddSubscriber( "use_hookext", private.use_hookext_end, private.room_objname );
cmn.AddSubscriber( "use_hookext", private.use_hookext_logic );
cmn.AddSubscriber( "use_hookext_inv", private.use_hookext_inv, private.room_objname );
cmn.AddSubscriber( "use_hookext_beg", private.use_hookext_beg, private.room_objname );
cmn.AddSubscriber( "use_hookext_end", private.use_hookext_end, private.room_objname );
cmn.AddSubscriber( "use_hookext_end", private.use_hookext_logic );
--------------------------------------------------------------------------------------------
function public.use_hookext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hookext" );
    cmn.CallEventHandler( "use_hookext_end" );

    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hookext") then ld.CloseSubRoom() end;
    public.get_combext()
  end;
  
  local func_preend = function()
    ObjSet( "spr_cryptentranceext_combext", {active=1,visible=1} );
    cmn.CallEventHandler( "get_combext" );
    func_end();
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hookext_inv" );
  cmn.CallEventHandler( "use_hookext_beg" );
  common_impl.Lock(1);

  
  ld.AnimPlay( "anm_cryptentranceext_anm_hook", "use_hook", func_preend );
  SoundSfx( "aud_use_hookext_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_combext" ] = { type = "get", get_obj = "spr_cryptentranceext_combext", room = "rm_groveext", zz = "zz_cryptentranceext", zz_gate = "gzz_groveext_cryptentranceext" };

private.get_combext_logic = function()
  
end;
private.get_combext_inv = function()
  interface.InventoryItemAdd("inv_combext","spr_cryptentranceext_combext");
end;
private.get_combext_beg = function()
  ObjDelete("gfx_cryptentranceext_combext")
end;
private.get_combext_end = function()
  if common_impl.ZzCompleteCheck("get_combext") then ObjSet( common_impl.hint["get_combext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_combext", private.get_combext_inv );
cmn.AddSubscriber( "get_combext", private.get_combext_beg, private.room_objname );
cmn.AddSubscriber( "get_combext", private.get_combext_end, private.room_objname );
cmn.AddSubscriber( "get_combext", private.get_combext_logic );
--------------------------------------------------------------------
function public.get_combext()
  cmn.SetEventDone( "get_combext" );
  cmn.CallEventHandler( "get_combext" );
  if common_impl.ZzCompleteCheck("get_combext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_skullext12_zone() 
  if ld.CheckRequirements( {"use_skullext1"} ) then
    common_impl.ShowBbt( 'need_skullext2' )
  elseif  ld.CheckRequirements( {"use_skullext2"} ) then
    common_impl.ShowBbt( 'need_skullext2' )
  elseif ld.CheckRequirements( {"use_skullext1","use_skullext2"}, true ) < 1 then
    SoundSfx( "aud_touch_small_stone" );
    ld.Lock(1)
    common_impl.ShowBbt( 'need_skullext1' )
    
    ld.AnimPlay("anm_cryptentranceext_anm_skull1","skull_static",function()ld.Lock(0)end)
  end
end;
  
common_impl.hint[ "use_skullext1" ] = { type = "use", inv_obj = "inv_skullext1", use_place = "gfx_cryptentranceext_skullext1_zone", room = "rm_groveext", zz = "zz_cryptentranceext", zz_gate = "gzz_groveext_cryptentranceext" };

private.use_skullext1_logic = function()
  if ld.CheckRequirements( {"use_skullext1","use_skullext2"} ) then
  ObjSet( "gmg_groveext_cryptdoorext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_skullext1_inv = function()
  common_impl.ProcessMultiUseAll("skullext1", "skullext1")
end;
private.use_skullext1_beg = function()
  ObjDelete( "gfx_cryptentranceext_skullext1_zone" );
end;
private.use_skullext1_end = function()
  if common_impl.ZzCompleteCheck("use_skullext1") then ObjSet( common_impl.hint["use_skullext1"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_skullext1","use_skullext2"} ) then
    ObjDelete("anm_cryptentranceext_anm_skull2");
    ObjSet( "anm_cryptentranceext_anm_skull1", {animfunc = "open_mmg", frame = 999 } );  
    ObjDelete("spr_groveext_skull1");  
    ObjDelete("spr_groveext_skull2"); 
    ObjDelete("spr_groveext_mmg_cap") ;
  else
    ObjSet( "anm_cryptentranceext_anm_skull1", {animfunc = "use_skull1", frame = 999 } );
    ObjSet( "spr_groveext_skull2", {visible = 1} );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_skullext1", private.use_skullext1_inv );
cmn.AddSubscriber( "use_skullext1", private.use_skullext1_beg, private.room_objname );
cmn.AddSubscriber( "use_skullext1", private.use_skullext1_end, private.room_objname );
cmn.AddSubscriber( "use_skullext1", private.use_skullext1_logic );
cmn.AddSubscriber( "use_skullext1_inv", private.use_skullext1_inv, private.room_objname );
cmn.AddSubscriber( "use_skullext1_beg", private.use_skullext1_beg, private.room_objname );
cmn.AddSubscriber( "use_skullext1_end", private.use_skullext1_end, private.room_objname );
cmn.AddSubscriber( "use_skullext1_end", private.use_skullext1_logic );
--------------------------------------------------------------------------------------------
function public.use_skullext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_skullext1" );
    cmn.CallEventHandler( "use_skullext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_skullext1") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_skullext1","use_skullext2"} ) then
      ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_cryptdoorext" ); end )
    end
  end;
  
  local func_preend = function()
    if ld.CheckRequirements( {"use_skullext2"} ) then
      ObjSet( "anm_cryptentranceext_anm_skull2", {visible = 0, frame = 0 } );
      SoundSfx( "aud_touch_skullext_groveext" )
      ld.AnimPlay( "anm_cryptentranceext_anm_skull1", "open_mmg", func_end );
    else
      func_end();  
    end;  
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_skullext1_inv" );
  cmn.CallEventHandler( "use_skullext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cryptentranceext_anm_skull1", "use_skull1", func_preend );
  SoundSfx( "aud_use_skullext1_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_skullext2" ] = { type = "use", inv_obj = "inv_skullext2", use_place = "gfx_cryptentranceext_skullext2_zone", room = "rm_groveext", zz = "zz_cryptentranceext", zz_gate = "gzz_groveext_cryptentranceext" };

private.use_skullext2_logic = function()
  if ld.CheckRequirements( {"use_skullext2","use_skullext1"} ) then
  ObjSet( "gmg_groveext_cryptdoorext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_skullext2_inv = function()
  common_impl.ProcessMultiUseAll("skullext2", "skullext2")
end;
private.use_skullext2_beg = function()
  ObjDelete( "gfx_cryptentranceext_skullext2_zone" );
end;
private.use_skullext2_end = function()
  if common_impl.ZzCompleteCheck("use_skullext2") then ObjSet( common_impl.hint["use_skullext2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_skullext1","use_skullext2"} ) then
    ObjDelete("anm_cryptentranceext_anm_skull2");
    ObjSet( "anm_cryptentranceext_anm_skull1", {animfunc = "open_mmg", frame = 999 } );
    ObjDelete("spr_groveext_skull1");  
    ObjDelete("spr_groveext_skull2"); 
    ObjDelete("spr_groveext_mmg_cap") ;
  else
    ObjSet( "anm_cryptentranceext_anm_skull2", {animfunc = "use_skull2", frame = 999 } );
    ObjSet( "spr_groveext_skull1", {visible = 1} );
    end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_skullext2", private.use_skullext2_inv );
cmn.AddSubscriber( "use_skullext2", private.use_skullext2_beg, private.room_objname );
cmn.AddSubscriber( "use_skullext2", private.use_skullext2_end, private.room_objname );
cmn.AddSubscriber( "use_skullext2", private.use_skullext2_logic );
cmn.AddSubscriber( "use_skullext2_inv", private.use_skullext2_inv, private.room_objname );
cmn.AddSubscriber( "use_skullext2_beg", private.use_skullext2_beg, private.room_objname );
cmn.AddSubscriber( "use_skullext2_end", private.use_skullext2_end, private.room_objname );
cmn.AddSubscriber( "use_skullext2_end", private.use_skullext2_logic );
--------------------------------------------------------------------------------------------
function public.use_skullext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_skullext2" );
    cmn.CallEventHandler( "use_skullext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_skullext2") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_skullext1","use_skullext2"} ) then
      ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_cryptdoorext" ); end )
    end    
  end;

  local func_preend = function()
    if ld.CheckRequirements( {"use_skullext1"} ) then
      ObjSet( "anm_cryptentranceext_anm_skull2", {visible = 0 } );
      SoundSfx( "aud_touch_skullext_groveext" )      
      ld.AnimPlay( "anm_cryptentranceext_anm_skull1", "open_mmg", func_end );
    else
      func_end();  
    end;  
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_skullext2_inv" );
  cmn.CallEventHandler( "use_skullext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cryptentranceext_anm_skull2", "use_skull2", func_preend );
  SoundSfx( "aud_use_skullext2_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mossext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_appleext" ] = { type = "get", get_obj = "spr_mossext_appleext", room = "rm_groveext", zz = "zz_mossext", zz_gate = "gzz_groveext_mossext" };

private.get_appleext_logic = function()
  
end;
private.get_appleext_inv = function()
  interface.InventoryItemAdd("inv_appleext","spr_mossext_appleext");
end;
private.get_appleext_beg = function()
  ObjDelete("gfx_mossext_appleext")
end;
private.get_appleext_end = function()
  if common_impl.ZzCompleteCheck("get_appleext") then ObjSet( common_impl.hint["get_appleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_groveext_appleext");
  ObjDelete("spr_mossext_appleext_sh");
end;

cmn.AddSubscriber( "get_appleext", private.get_appleext_inv );
cmn.AddSubscriber( "get_appleext", private.get_appleext_beg, private.room_objname );
cmn.AddSubscriber( "get_appleext", private.get_appleext_end, private.room_objname );
cmn.AddSubscriber( "get_appleext", private.get_appleext_logic );
--------------------------------------------------------------------
function public.get_appleext()
  cmn.SetEventDone( "get_appleext" );
  cmn.CallEventHandler( "get_appleext" );
  if common_impl.ZzCompleteCheck("get_appleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_combext_zone() 
  common_impl.ShowBbt( 'need_combext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_weed" );
  ld.AnimPlay("anm_mossext_anm_coin","coin_idle",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_combext" ] = { type = "use", inv_obj = "inv_combext", use_place = "gfx_mossext_combext_zone", room = "rm_groveext", zz = "zz_mossext", zz_gate = "gzz_groveext_mossext" };

private.use_combext_logic = function()
  ObjSet( "spr_mossext_childrencoinext", { visible = 1, input = 1, active = 1 } )

end;
private.use_combext_inv = function()
  common_impl.ProcessMultiUseAll("combext", "combext")
end;
private.use_combext_beg = function()
  ObjDelete( "gfx_mossext_combext_zone" );
end;
private.use_combext_end = function()
  if common_impl.ZzCompleteCheck("use_combext") then ObjSet( common_impl.hint["use_combext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_mossext_anm_coin");
  ObjDelete("spr_groveext_moss_trash");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_combext", private.use_combext_inv );
cmn.AddSubscriber( "use_combext", private.use_combext_beg, private.room_objname );
cmn.AddSubscriber( "use_combext", private.use_combext_end, private.room_objname );
cmn.AddSubscriber( "use_combext", private.use_combext_logic );
cmn.AddSubscriber( "use_combext_inv", private.use_combext_inv, private.room_objname );
cmn.AddSubscriber( "use_combext_beg", private.use_combext_beg, private.room_objname );
cmn.AddSubscriber( "use_combext_end", private.use_combext_end, private.room_objname );
cmn.AddSubscriber( "use_combext_end", private.use_combext_logic );
--------------------------------------------------------------------------------------------
function public.use_combext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_combext" );
    cmn.CallEventHandler( "use_combext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_combext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_combext_inv" );
  cmn.CallEventHandler( "use_combext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mossext_anm_coin", "use_comb", func_end );
  SoundSfx( "aud_use_combext_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_childrencoinext" ] = { type = "get", get_obj = "spr_mossext_childrencoinext", room = "rm_groveext", zz = "zz_mossext", zz_gate = "gzz_groveext_mossext" };

private.get_childrencoinext_logic = function()
  
end;
private.get_childrencoinext_inv = function()
  interface.InventoryItemAdd("inv_childrencoinext","spr_mossext_childrencoinext");
end;
private.get_childrencoinext_beg = function()
  ObjDelete("gfx_mossext_childrencoinext")
end;
private.get_childrencoinext_end = function()
  if common_impl.ZzCompleteCheck("get_childrencoinext") then ObjSet( common_impl.hint["get_childrencoinext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_groveext_childrencoinext");
end;

cmn.AddSubscriber( "get_childrencoinext", private.get_childrencoinext_inv );
cmn.AddSubscriber( "get_childrencoinext", private.get_childrencoinext_beg, private.room_objname );
cmn.AddSubscriber( "get_childrencoinext", private.get_childrencoinext_end, private.room_objname );
cmn.AddSubscriber( "get_childrencoinext", private.get_childrencoinext_logic );
--------------------------------------------------------------------
function public.get_childrencoinext()
  cmn.SetEventDone( "get_childrencoinext" );
  cmn.CallEventHandler( "get_childrencoinext" );
  if common_impl.ZzCompleteCheck("get_childrencoinext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_silverspoonext_zone() 
  common_impl.ShowBbt( 'need_silverspoonext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_snow" );
  ld.AnimPlay("anm_mossext_anm_candle","candle_idle",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_silverspoonext" ] = { type = "use", inv_obj = "inv_silverspoonext", use_place = "gfx_mossext_silverspoonext_zone", room = "rm_groveext", zz = "zz_mossext", zz_gate = "gzz_groveext_mossext" };

private.use_silverspoonext_logic = function()
  ObjSet( "spr_mossext_candleext5", { visible = 1, input = 1, active = 1 } )

end;
private.use_silverspoonext_inv = function()
  common_impl.ProcessMultiUseAll("silverspoonext", "silverspoonext")
end;
private.use_silverspoonext_beg = function()
  ObjDelete( "gfx_mossext_silverspoonext_zone" );
end;
private.use_silverspoonext_end = function()
  if common_impl.ZzCompleteCheck("use_silverspoonext") then ObjSet( common_impl.hint["use_silverspoonext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_mossext_anm_candle");
  ObjDelete("spr_groveext_soil");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_silverspoonext", private.use_silverspoonext_inv );
cmn.AddSubscriber( "use_silverspoonext", private.use_silverspoonext_beg, private.room_objname );
cmn.AddSubscriber( "use_silverspoonext", private.use_silverspoonext_end, private.room_objname );
cmn.AddSubscriber( "use_silverspoonext", private.use_silverspoonext_logic );
cmn.AddSubscriber( "use_silverspoonext_inv", private.use_silverspoonext_inv, private.room_objname );
cmn.AddSubscriber( "use_silverspoonext_beg", private.use_silverspoonext_beg, private.room_objname );
cmn.AddSubscriber( "use_silverspoonext_end", private.use_silverspoonext_end, private.room_objname );
cmn.AddSubscriber( "use_silverspoonext_end", private.use_silverspoonext_logic );
--------------------------------------------------------------------------------------------
function public.use_silverspoonext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_silverspoonext" );
    cmn.CallEventHandler( "use_silverspoonext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_silverspoonext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_silverspoonext_inv" );
  cmn.CallEventHandler( "use_silverspoonext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mossext_anm_candle", "use_spoon", func_end );
  SoundSfx( "aud_use_silverspoonext_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_candleext5" ] = { type = "get", get_obj = "spr_mossext_candleext5", room = "rm_groveext", zz = "zz_mossext", zz_gate = "gzz_groveext_mossext" };

private.get_candleext5_logic = function()
  
end;
private.get_candleext5_inv = function()
  interface.InventoryItemAdd("inv_candleext","spr_mossext_candleext5",function() level_inv.ProcessGetCandleextAll( "get_candleext5" ) end);
end;
private.get_candleext5_beg = function()
  ObjDelete("gfx_mossext_candleext5")
end;
private.get_candleext5_end = function()
  if common_impl.ZzCompleteCheck("get_candleext5") then ObjSet( common_impl.hint["get_candleext5"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_groveext_candleext4");
end;

cmn.AddSubscriber( "get_candleext5", private.get_candleext5_inv );
cmn.AddSubscriber( "get_candleext5", private.get_candleext5_beg, private.room_objname );
cmn.AddSubscriber( "get_candleext5", private.get_candleext5_end, private.room_objname );
cmn.AddSubscriber( "get_candleext5", private.get_candleext5_logic );
--------------------------------------------------------------------
function public.get_candleext5()
  cmn.SetEventDone( "get_candleext5" );
  cmn.CallEventHandler( "get_candleext5" );
  if common_impl.ZzCompleteCheck("get_candleext5") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_hedgehogsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_colorpyramidext" ] = { type = "get", get_obj = "spr_hedgehogsext_colorpyramidext", room = "rm_groveext", zz = "zz_hedgehogsext", zz_gate = "gzz_groveext_hedgehogsext" };

private.get_colorpyramidext_logic = function()
  
end;
private.get_colorpyramidext_inv = function()
  interface.InventoryItemAdd("inv_colorpyramidext","spr_hedgehogsext_colorpyramidext");
end;
private.get_colorpyramidext_beg = function()
  ObjDelete("gfx_hedgehogsext_colorpyramidext")
end;
private.get_colorpyramidext_end = function()
  if common_impl.ZzCompleteCheck("get_colorpyramidext") then ObjSet( common_impl.hint["get_colorpyramidext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hedgehogsext_colorextpyramidext_shad");
end;

cmn.AddSubscriber( "get_colorpyramidext", private.get_colorpyramidext_inv );
cmn.AddSubscriber( "get_colorpyramidext", private.get_colorpyramidext_beg, private.room_objname );
cmn.AddSubscriber( "get_colorpyramidext", private.get_colorpyramidext_end, private.room_objname );
cmn.AddSubscriber( "get_colorpyramidext", private.get_colorpyramidext_logic );
--------------------------------------------------------------------
function public.get_colorpyramidext()
  cmn.SetEventDone( "get_colorpyramidext" );
  cmn.CallEventHandler( "get_colorpyramidext" );
  if common_impl.ZzCompleteCheck("get_colorpyramidext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_appleext_zone() 
  common_impl.ShowBbt( 'need_appleext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay("anm_hedgehogsext_anm_apple","scoopnet_idle",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_appleext" ] = { type = "use", inv_obj = "inv_appleext", use_place = "gfx_hedgehogsext_appleext_zone", room = "rm_groveext", zz = "zz_hedgehogsext", zz_gate = "gzz_groveext_hedgehogsext" };

private.use_appleext_logic = function()
  ObjSet( "spr_hedgehogsext_scoopnetext", { visible = 1, input = 1, active = 1 } )

end;
private.use_appleext_inv = function()
  common_impl.ProcessMultiUseAll("appleext", "appleext")
end;
private.use_appleext_beg = function()
  ObjDelete( "gfx_hedgehogsext_appleext_zone" );
end;
private.use_appleext_end = function()
  if common_impl.ZzCompleteCheck("use_appleext") then ObjSet( common_impl.hint["use_appleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hedgehogsext_anm_apple", {animfunc = "apple_end", frame = 0 } );
  ObjSet( "spr_hedgehogsext_scoonetext_tr", {visible = 1} );
  ObjSet( "spr_groveext_apple", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_appleext", private.use_appleext_inv );
cmn.AddSubscriber( "use_appleext", private.use_appleext_beg, private.room_objname );
cmn.AddSubscriber( "use_appleext", private.use_appleext_end, private.room_objname );
cmn.AddSubscriber( "use_appleext", private.use_appleext_logic );
cmn.AddSubscriber( "use_appleext_inv", private.use_appleext_inv, private.room_objname );
cmn.AddSubscriber( "use_appleext_beg", private.use_appleext_beg, private.room_objname );
cmn.AddSubscriber( "use_appleext_end", private.use_appleext_end, private.room_objname );
cmn.AddSubscriber( "use_appleext_end", private.use_appleext_logic );
--------------------------------------------------------------------------------------------
function public.use_appleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_appleext" );
    cmn.CallEventHandler( "use_appleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_appleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_appleext_inv" );
  cmn.CallEventHandler( "use_appleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hedgehogsext_anm_apple", "use_apple", func_end );
  SoundSfx( "aud_use_appleext_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scoopnetext" ] = { type = "get", get_obj = "spr_hedgehogsext_scoopnetext", room = "rm_groveext", zz = "zz_hedgehogsext", zz_gate = "gzz_groveext_hedgehogsext" };

private.get_scoopnetext_logic = function()
  
end;
private.get_scoopnetext_inv = function()
  interface.InventoryItemAdd("inv_scoopnetext","spr_hedgehogsext_scoopnetext");
end;
private.get_scoopnetext_beg = function()
  ObjDelete("gfx_hedgehogsext_scoopnetext")
end;
private.get_scoopnetext_end = function()
  if common_impl.ZzCompleteCheck("get_scoopnetext") then ObjSet( common_impl.hint["get_scoopnetext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_groveext_scoopnetext");
end;

cmn.AddSubscriber( "get_scoopnetext", private.get_scoopnetext_inv );
cmn.AddSubscriber( "get_scoopnetext", private.get_scoopnetext_beg, private.room_objname );
cmn.AddSubscriber( "get_scoopnetext", private.get_scoopnetext_end, private.room_objname );
cmn.AddSubscriber( "get_scoopnetext", private.get_scoopnetext_logic );
--------------------------------------------------------------------
function public.get_scoopnetext()
  cmn.SetEventDone( "get_scoopnetext" );
  cmn.CallEventHandler( "get_scoopnetext" );
  if common_impl.ZzCompleteCheck("get_scoopnetext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_sunamuletext_zone() 
  common_impl.ShowBbt( 'need_sunamuletext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay("anm_hedgehogsext_anm_cap","cap_idle",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_sunamuletext" ] = { type = "use", inv_obj = "inv_sunamuletext", use_place = "gfx_hedgehogsext_sunamuletext_zone", room = "rm_groveext", zz = "zz_hedgehogsext", zz_gate = "gzz_groveext_hedgehogsext" };

private.use_sunamuletext_logic = function()
  ObjSet( "spr_hedgehogsext_silverspoonext", {  input = 1 } )

end;
private.use_sunamuletext_inv = function()
  common_impl.ProcessMultiUseAll("sunamuletext", "sunamuletext")
end;
private.use_sunamuletext_beg = function()
  ObjDelete( "gfx_hedgehogsext_sunamuletext_zone" );
end;
private.use_sunamuletext_end = function()
  if common_impl.ZzCompleteCheck("use_sunamuletext") then ObjSet( common_impl.hint["use_sunamuletext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hedgehogsext_anm_cap", {animfunc = "use_sun", frame = 999 } );
  ObjDelete("spr_groveext_cap_close")
  ObjSet( "spr_groveext_cap_open", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sunamuletext", private.use_sunamuletext_inv );
cmn.AddSubscriber( "use_sunamuletext", private.use_sunamuletext_beg, private.room_objname );
cmn.AddSubscriber( "use_sunamuletext", private.use_sunamuletext_end, private.room_objname );
cmn.AddSubscriber( "use_sunamuletext", private.use_sunamuletext_logic );
cmn.AddSubscriber( "use_sunamuletext_inv", private.use_sunamuletext_inv, private.room_objname );
cmn.AddSubscriber( "use_sunamuletext_beg", private.use_sunamuletext_beg, private.room_objname );
cmn.AddSubscriber( "use_sunamuletext_end", private.use_sunamuletext_end, private.room_objname );
cmn.AddSubscriber( "use_sunamuletext_end", private.use_sunamuletext_logic );
--------------------------------------------------------------------------------------------
function public.use_sunamuletext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sunamuletext" );
    cmn.CallEventHandler( "use_sunamuletext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sunamuletext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sunamuletext_inv" );
  cmn.CallEventHandler( "use_sunamuletext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hedgehogsext_anm_cap", "use_sun", func_end );
  SoundSfx( "aud_use_sunamuletext_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_silverspoonext" ] = { type = "get", get_obj = "spr_hedgehogsext_silverspoonext", room = "rm_groveext", zz = "zz_hedgehogsext", zz_gate = "gzz_groveext_hedgehogsext" };

private.get_silverspoonext_logic = function()
  
end;
private.get_silverspoonext_inv = function()
  interface.InventoryItemAdd("inv_silverspoonext","spr_hedgehogsext_silverspoonext");
end;
private.get_silverspoonext_beg = function()
  ObjDelete("gfx_hedgehogsext_silverspoonext")
end;
private.get_silverspoonext_end = function()
  if common_impl.ZzCompleteCheck("get_silverspoonext") then ObjSet( common_impl.hint["get_silverspoonext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hedgehogsext_silverspoonext_shad");
  ObjDelete("spr_groveext_silverspoonext");
end;

cmn.AddSubscriber( "get_silverspoonext", private.get_silverspoonext_inv );
cmn.AddSubscriber( "get_silverspoonext", private.get_silverspoonext_beg, private.room_objname );
cmn.AddSubscriber( "get_silverspoonext", private.get_silverspoonext_end, private.room_objname );
cmn.AddSubscriber( "get_silverspoonext", private.get_silverspoonext_logic );
--------------------------------------------------------------------
function public.get_silverspoonext()
  cmn.SetEventDone( "get_silverspoonext" );
  cmn.CallEventHandler( "get_silverspoonext" );
  if common_impl.ZzCompleteCheck("get_silverspoonext") then ld.CloseSubRoom() end;
end

function public.hedgehogsext_butterfly_clk()  --rm_roadway.roadway_idle_clk1()
  ObjSet( "obj_hedgehogsext_butterfly_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_butterfly_groveext" );
  ObjDelete("spr_groveext_butterfly");
  ld.AnimPlay( "anm_hedgehogsext_anm_butterfly", "butterfly", func_end )
end;

--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wellext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scoopnetext" ] = { type = "use", inv_obj = "inv_scoopnetext", use_place = "gfx_wellext_scoopnetext_zone", room = "rm_groveext", zz = "zz_wellext", zz_gate = "gzz_groveext_wellext" };

private.use_scoopnetext_logic = function()
  ObjSet( "spr_wellext_candleext4", { visible = 1, input = 1, active = 1 } )

end;
private.use_scoopnetext_inv = function()
  common_impl.ProcessMultiUseAll("scoopnetext", "scoopnetext")
end;
private.use_scoopnetext_beg = function()
  ObjDelete( "gfx_wellext_scoopnetext_zone" );
end;
private.use_scoopnetext_end = function()
  if common_impl.ZzCompleteCheck("use_scoopnetext") then ObjSet( common_impl.hint["use_scoopnetext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_wellext_anm_candle");
  ObjDelete("anm_wellext_anm_candle_idle");
  ObjSet( "spr_wellext_sh_candleext", {visible = 1} );
  ObjSet( "spr_groveext_candleext5", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scoopnetext", private.use_scoopnetext_inv );
cmn.AddSubscriber( "use_scoopnetext", private.use_scoopnetext_beg, private.room_objname );
cmn.AddSubscriber( "use_scoopnetext", private.use_scoopnetext_end, private.room_objname );
cmn.AddSubscriber( "use_scoopnetext", private.use_scoopnetext_logic );
cmn.AddSubscriber( "use_scoopnetext_inv", private.use_scoopnetext_inv, private.room_objname );
cmn.AddSubscriber( "use_scoopnetext_beg", private.use_scoopnetext_beg, private.room_objname );
cmn.AddSubscriber( "use_scoopnetext_end", private.use_scoopnetext_end, private.room_objname );
cmn.AddSubscriber( "use_scoopnetext_end", private.use_scoopnetext_logic );
--------------------------------------------------------------------------------------------
function public.use_scoopnetext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scoopnetext" );
    cmn.CallEventHandler( "use_scoopnetext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scoopnetext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scoopnetext_inv" );
  cmn.CallEventHandler( "use_scoopnetext_beg" );
  common_impl.Lock(1);

  
  ld.AnimPlay( "anm_wellext_anm_candle", "use_net", func_end ); 
  
  SoundSfx( "aud_use_scoopnetext_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_candleext4" ] = { type = "get", get_obj = "spr_wellext_candleext4", room = "rm_groveext", zz = "zz_wellext", zz_gate = "gzz_groveext_wellext" };

private.get_candleext4_logic = function()
  
end;
private.get_candleext4_inv = function()
  interface.InventoryItemAdd("inv_candleext","spr_wellext_candleext4",function() level_inv.ProcessGetCandleextAll( "get_candleext4" ) end);
end;
private.get_candleext4_beg = function()
  ObjDelete("gfx_wellext_candleext4")
end;
private.get_candleext4_end = function()
  if common_impl.ZzCompleteCheck("get_candleext4") then ObjSet( common_impl.hint["get_candleext4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_wellext_sh_candleext");
  ObjDelete("spr_groveext_candleext5");
end;

cmn.AddSubscriber( "get_candleext4", private.get_candleext4_inv );
cmn.AddSubscriber( "get_candleext4", private.get_candleext4_beg, private.room_objname );
cmn.AddSubscriber( "get_candleext4", private.get_candleext4_end, private.room_objname );
cmn.AddSubscriber( "get_candleext4", private.get_candleext4_logic );
--------------------------------------------------------------------
function public.get_candleext4()
  cmn.SetEventDone( "get_candleext4" );
  cmn.CallEventHandler( "get_candleext4" );
  if common_impl.ZzCompleteCheck("get_candleext4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_pickext_zone() 
  common_impl.ShowBbt( 'need_pickext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_very_small_metal" );
  ld.AnimPlay("anm_wellext_anm_diamond","diamond_idle",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_pickext" ] = { type = "use", inv_obj = "inv_pickext", use_place = "gfx_wellext_pickext_zone", room = "rm_groveext", zz = "zz_wellext", zz_gate = "gzz_groveext_wellext" };

private.use_pickext_logic = function()
  ObjSet( "spr_wellext_diamondext", { visible = 1, input = 1, active = 1 } )

end;
private.use_pickext_inv = function()
  common_impl.ProcessMultiUseAll("pickext", "pickext")
end;
private.use_pickext_beg = function()
  ObjDelete( "gfx_wellext_pickext_zone" );
end;
private.use_pickext_end = function()
  if common_impl.ZzCompleteCheck("use_pickext") then ObjSet( common_impl.hint["use_pickext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_wellext_anm_diamond", {animfunc = "diamond_end", frame = 0 } );
  ObjSet( "spr_wellext_sh_diamondext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pickext", private.use_pickext_inv );
cmn.AddSubscriber( "use_pickext", private.use_pickext_beg, private.room_objname );
cmn.AddSubscriber( "use_pickext", private.use_pickext_end, private.room_objname );
cmn.AddSubscriber( "use_pickext", private.use_pickext_logic );
cmn.AddSubscriber( "use_pickext_inv", private.use_pickext_inv, private.room_objname );
cmn.AddSubscriber( "use_pickext_beg", private.use_pickext_beg, private.room_objname );
cmn.AddSubscriber( "use_pickext_end", private.use_pickext_end, private.room_objname );
cmn.AddSubscriber( "use_pickext_end", private.use_pickext_logic );
--------------------------------------------------------------------------------------------
function public.use_pickext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pickext" );
    cmn.CallEventHandler( "use_pickext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pickext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pickext_inv" );
  cmn.CallEventHandler( "use_pickext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wellext_anm_diamond", "use_pick", func_end );
  SoundSfx( "aud_use_pickext_groveext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_diamondext" ] = { type = "get", get_obj = "spr_wellext_diamondext", room = "rm_groveext", zz = "zz_wellext", zz_gate = "gzz_groveext_wellext" };

private.get_diamondext_logic = function()
  
end;
private.get_diamondext_inv = function()
  interface.InventoryItemAdd("inv_diamondext","spr_wellext_diamondext");
end;
private.get_diamondext_beg = function()
  ObjDelete("gfx_wellext_diamondext")
end;
private.get_diamondext_end = function()
  if common_impl.ZzCompleteCheck("get_diamondext") then ObjSet( common_impl.hint["get_diamondext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_wellext_sh_diamondext");
end;

cmn.AddSubscriber( "get_diamondext", private.get_diamondext_inv );
cmn.AddSubscriber( "get_diamondext", private.get_diamondext_beg, private.room_objname );
cmn.AddSubscriber( "get_diamondext", private.get_diamondext_end, private.room_objname );
cmn.AddSubscriber( "get_diamondext", private.get_diamondext_logic );
--------------------------------------------------------------------
function public.get_diamondext()
  cmn.SetEventDone( "get_diamondext" );
  cmn.CallEventHandler( "get_diamondext" );
  if common_impl.ZzCompleteCheck("get_diamondext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_cryptdoorext_for_groveext = function()
    if ld.CheckRequirements( {"win_cryptdoorext"} ) then
      ObjSet( "grm_groveext_cryptext", {input = 1, visible = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_groveext_cryptext_focus");
      end;
      ObjSet( "gmg_groveext_cryptdoorext", {input = 0, visible = 0} );
      ObjSet( "spr_groveext_door_sclep", {visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_cryptdoorext", win_cryptdoorext_for_groveext, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_groveext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_groveext_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_wellext" );
  function zz_wellext.Open()
  end;
  function zz_wellext.PreOpen()
  end;
  function zz_wellext.PreClose()
  end;
  function zz_wellext.Close()
  end;

  subroom.Define( "zz_hedgehogsext" );
  function zz_hedgehogsext.Open()
  end;
  function zz_hedgehogsext.PreOpen()
  end;
  function zz_hedgehogsext.PreClose()
  end;
  function zz_hedgehogsext.Close()
  end;

  subroom.Define( "zz_mossext" );
  function zz_mossext.Open()
  end;
  function zz_mossext.PreOpen()
  end;
  function zz_mossext.PreClose()
  end;
  function zz_mossext.Close()
  end;

  subroom.Define( "zz_cryptentranceext" );
  function zz_cryptentranceext.Open()
  end;
  function zz_cryptentranceext.PreOpen()
  end;
  function zz_cryptentranceext.PreClose()
  end;
  function zz_cryptentranceext.Close()
  end;
  
end;
--*********************************************************************************************************************

function public.groveext_idle_clk1()  --rm_roadway.roadway_idle_clk1()
  local func_end = function() 
    ObjSet( "obj_groveext_idle1_clk_zone", {input = 1} );
  end
  
  ObjSet( "obj_groveext_idle1_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_weed" );
  ld.AnimPlay( "anm_groveext_anm_click", "roots", func_end )
end;