-- name=rm_housedoctorext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_housedoctorext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_boxsusieext_note", "spr_boxsusieext_note_open","boxsusieext_note")
  --------------------------------------------------------------------------------------------
function private.opn_housedoctorext()
  if not ( cmn.IsEventDone( "opn_housedoctorext" ) ) then
    private.SeeIntro();
  else 
    SoundEnv( "aud_housedoctorext_env" );
  end;
end;
--------------------------------------------------------------------
local opn_housedoctorext = function() end;
local opn_housedoctorext_logic = function() end;
cmn.AddSubscriber( "opn_housedoctorext", opn_housedoctorext_logic )
cmn.AddSubscriber( "opn_housedoctorext", opn_housedoctorext, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "lekarext4" then
      if  count_txt == 1 then
        
      elseif count_txt == 2 then    
        ld.Lock(1);
        AnimPlay( "anm_housedoctorext_lekarext4", "giv_moon", function() ld.Lock(0);  end);
        SoundSfx( "aud_get_to_us" )  
      elseif  count_txt == 3 then
        cmn.CallEventHandler( "get_moonext" );
        ObjSet( "spr_housedoctorext_moonext", {visible = 1, active = 1 } );
        ld.Lock(1);
        -- SoundSfx( "aud_touch_paper_barnes" );
        AnimPlay( "anm_housedoctorext_lekarext4", "giv1", function() ld.Lock(0);   end);  
        elseif count_txt == 4 then 
        --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" )  
        
      end;  
  end;
     
end;
  
  
  
function private.SeeIntro()
    local widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu,
    }  
    local func_end = function()
      -- SndStop( "assets/levels/common/audio/aud_intro4",0.25);      
      ld.Lock(1)
      ObjSet( "obj_int_dialog_video_input", {event_mdown = ""} );      
      ObjAnimate( "vid_housedoctorext_intro4", 8, 0, 0, function() ObjDetach("vid_housedoctorext_intro4") ld.Lock(0);ld.ShowBbt( "opn_housedoctorext" );SoundEnv( "aud_housedoctorext_env" );end, {0,0,1, 0.5,0,0} );
      int.DialogVideoHide();
      for i = 1, #widget_settings do

        interface.WidgetSetVisible( widget_settings[i], 1,true );

      end;      
      cmn.SetEventDone( "opn_housedoctorext" );
      cmn.CallEventHandler( "opn_housedoctorext" )
      SoundTheme( "aud_adventure2_mus" );   
       
    end
    
    
    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 0 );
    end;  
    
    ObjAttach("vid_housedoctorext_intro4","rm_housedoctorext")
    ObjAnimate( "vid_housedoctorext_intro4", 7,0,0, function() SoundVid( "aud_intro4" );SoundVoice("aud_intro4_voc"); end, { 0,0,0, 0,0,0 } )
    VidPlay("vid_housedoctorext_intro4",func_end)
    int.DialogVideoShow( "", 1, func_end, 3 );
end  
  
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_housedoctorext_lekarext4" ] = { type = "click", use_place = "gfx_housedoctorext_dlg_housedoctorext_lekarext4_zone", room = "rm_housedoctorext" };

private.dlg_housedoctorext_lekarext4_logic = function()
  --ObjSet( "spr_housedoctorext_moonext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_housedoctorext_roomentersext", {input = 1, visible = 1} );
  ObjSet( "gzz_housedoctorext_laboratorydoorext", {input = 1, visible = 1} );
  ObjSet( "gzz_housedoctorext_boxsusieext", {input = 1, visible = 1} );
  ObjSet( "gzz_housedoctorext_tableext", {input = 1, visible = 1} );
  ObjSet( "gzz_housedoctorext_windowext", {input = 1, visible = 1} );
  ObjSet( "grm_housedoctorext_nearhouseext", {input = 1, visible = 1} );
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_housedoctorext_nearhouseext_focus");
  end;
end;
private.dlg_housedoctorext_lekarext4_beg = function()
  ObjDelete( "gfx_housedoctorext_dlg_housedoctorext_lekarext4_zone" );
end;
private.dlg_housedoctorext_lekarext4_end = function()
  ObjDelete("anm_housedoctorext_anm_man");  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_housedoctorext_lekarext4", private.dlg_housedoctorext_lekarext4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_housedoctorext_lekarext4", private.dlg_housedoctorext_lekarext4_end, private.room_objname );
cmn.AddSubscriber( "dlg_housedoctorext_lekarext4", private.dlg_housedoctorext_lekarext4_logic );
cmn.AddSubscriber( "dlg_housedoctorext_lekarext4_beg", private.dlg_housedoctorext_lekarext4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_housedoctorext_lekarext4_end", private.dlg_housedoctorext_lekarext4_end, private.room_objname );
cmn.AddSubscriber( "dlg_housedoctorext_lekarext4_end", private.dlg_housedoctorext_lekarext4_logic );
--------------------------------------------------------------------------------------------
function public.dlg_housedoctorext_lekarext4( obj )
   local func_end = function()
      cmn.SetEventDone( "dlg_housedoctorext_lekarext4" );
      cmn.CallEventHandler( "dlg_housedoctorext_lekarext4_end" );
      cmn.SetEventDone( "get_moonext" );
    if ObjGetRelations( "inv_moonext" ).parent == "levelext_inv_hub" then
       ObjSet( "spr_housedoctorext_moonext", {visible = 1} );
       cmn.CallEventHandler( "get_moonext" );
      end
    common_impl.Lock(0);
    ld.ShowBbt("after_lekarext4");
  end;

  function public.dlg_housedoctorext_lekarext4_end()
   ObjSet( "dlg_housedoctorext_lekarext4", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_housedoctorext_lekarext4_beg" );
  

  common_impl.dialog_character_loc = "anm_housedoctorext_anm_man"
  common_impl.continue_visible = false;
  common_impl.Start( "lekarext4", 3, nil, nil, true, "dlg_housedoctorext_lekarext4_end",{"aud_barnes_9_voc","aud_barnes_10_voc"} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_moonext" ] = { type = "get", get_obj = "spr_housedoctorext_moonext", room = "rm_housedoctorext" };

private.get_moonext_logic = function()
  
end;
private.get_moonext_inv = function()
  interface.InventoryItemAdd("inv_moonext","spr_housedoctorext_moonext");
end;
private.get_moonext_beg = function()
  ObjDelete("gfx_housedoctorext_moonext")
end;
private.get_moonext_end = function()
  
end;

cmn.AddSubscriber( "get_moonext", private.get_moonext_inv );
cmn.AddSubscriber( "get_moonext", private.get_moonext_beg, private.room_objname );
cmn.AddSubscriber( "get_moonext", private.get_moonext_end, private.room_objname );
cmn.AddSubscriber( "get_moonext", private.get_moonext_logic );
--------------------------------------------------------------------
function public.get_moonext()
  cmn.SetEventDone( "get_moonext" );
  cmn.CallEventHandler( "get_moonext" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tableext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_dictionarydreamsext" ] = { type = "get", get_obj = "spr_tableext_dictionarydreamsext", room = "rm_housedoctorext", zz = "zz_tableext", zz_gate = "gzz_housedoctorext_tableext" };

private.get_dictionarydreamsext_logic = function()
  
end;
private.get_dictionarydreamsext_inv = function()
  interface.InventoryItemAdd("inv_dictionarydreamsext","spr_tableext_dictionarydreamsext");
  ObjSet( "inv_dictionarydreamsext", { drag = 0 } );
end;
private.get_dictionarydreamsext_beg = function()
  ObjDelete("gfx_tableext_dictionarydreamsext")
end;
private.get_dictionarydreamsext_end = function()
  if common_impl.ZzCompleteCheck("get_dictionarydreamsext") then ObjSet( common_impl.hint["get_dictionarydreamsext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tableext_dictionarydreamsext_shadow");
  ObjDelete("spr_housedoctorext_book");
end;

cmn.AddSubscriber( "get_dictionarydreamsext", private.get_dictionarydreamsext_inv );
cmn.AddSubscriber( "get_dictionarydreamsext", private.get_dictionarydreamsext_beg, private.room_objname );
cmn.AddSubscriber( "get_dictionarydreamsext", private.get_dictionarydreamsext_end, private.room_objname );
cmn.AddSubscriber( "get_dictionarydreamsext", private.get_dictionarydreamsext_logic );
--------------------------------------------------------------------
function public.get_dictionarydreamsext()
  cmn.SetEventDone( "get_dictionarydreamsext" );
  cmn.CallEventHandler( "get_dictionarydreamsext" );
  if common_impl.ZzCompleteCheck("get_dictionarydreamsext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_spannerext_zone() 
  common_impl.ShowBbt( 'need_spannerext_tableext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_mechanism_housedoctorext" );
  ld.AnimPlay("anm_tableext_anm","click",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_spannerext_tableext" ] = { type = "use", inv_obj = "inv_spannerext", use_place = "gfx_tableext_spannerext_tableext_zone", room = "rm_housedoctorext", zz = "zz_tableext", zz_gate = "gzz_housedoctorext_tableext" };

private.use_spannerext_tableext_logic = function()
  --ObjSet( "spr_tableext_wandext", { visible = 1, input = 1, active = 1 } )

end;
private.use_spannerext_tableext_inv = function()
  common_impl.ProcessMultiUseAll("spannerext", "spannerext_tableext")
end;
private.use_spannerext_tableext_beg = function()
  ObjDelete( "gfx_tableext_spannerext_tableext_zone" );
end;
private.use_spannerext_tableext_end = function()
  if common_impl.ZzCompleteCheck("use_spannerext_tableext") then ObjSet( common_impl.hint["use_spannerext_tableext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_tableext_anm", {animfunc = "end", frame = 0 } );
  ObjSet( "spr_housedoctorext_tr_globe", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_spannerext_tableext", private.use_spannerext_tableext_inv );
cmn.AddSubscriber( "use_spannerext_tableext", private.use_spannerext_tableext_beg, private.room_objname );
cmn.AddSubscriber( "use_spannerext_tableext", private.use_spannerext_tableext_end, private.room_objname );
cmn.AddSubscriber( "use_spannerext_tableext", private.use_spannerext_tableext_logic );
cmn.AddSubscriber( "use_spannerext_tableext_inv", private.use_spannerext_tableext_inv, private.room_objname );
cmn.AddSubscriber( "use_spannerext_tableext_beg", private.use_spannerext_tableext_beg, private.room_objname );
cmn.AddSubscriber( "use_spannerext_tableext_end", private.use_spannerext_tableext_end, private.room_objname );
cmn.AddSubscriber( "use_spannerext_tableext_end", private.use_spannerext_tableext_logic );
--------------------------------------------------------------------------------------------
function public.use_spannerext_tableext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_spannerext_tableext" );
    cmn.CallEventHandler( "use_spannerext_tableext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_spannerext_tableext") then ld.CloseSubRoom() end;
    public.get_wandext();
  end;
  
  local func_preend = function()
    func_end();
  end; 
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_spannerext_tableext_inv" );
  cmn.CallEventHandler( "use_spannerext_tableext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tableext_anm", "pliers", func_preend );
  SoundSfx( "aud_use_spannerext_tableext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wandext" ] = { type = "get", get_obj = "spr_tableext_wandext", room = "rm_housedoctorext", zz = "zz_tableext", zz_gate = "gzz_housedoctorext_tableext" };

private.get_wandext_logic = function()
  
end;
private.get_wandext_inv = function()
  interface.InventoryItemAdd("inv_wandext","spr_tableext_wandext");
end;
private.get_wandext_beg = function()
  ObjDelete("gfx_tableext_wandext")
end;
private.get_wandext_end = function()
  if common_impl.ZzCompleteCheck("get_wandext") then ObjSet( common_impl.hint["get_wandext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_wandext", private.get_wandext_inv );
cmn.AddSubscriber( "get_wandext", private.get_wandext_beg, private.room_objname );
cmn.AddSubscriber( "get_wandext", private.get_wandext_end, private.room_objname );
cmn.AddSubscriber( "get_wandext", private.get_wandext_logic );
--------------------------------------------------------------------
function public.get_wandext()
   ObjSet( "spr_tableext_wandext", {active=1,visible=1} );
  cmn.SetEventDone( "get_wandext" );
  cmn.CallEventHandler( "get_wandext" );
  if common_impl.ZzCompleteCheck("get_wandext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_windowext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_candleext1" ] = { type = "get", get_obj = "spr_windowext_candleext1", room = "rm_housedoctorext", zz = "zz_windowext", zz_gate = "gzz_housedoctorext_windowext" };

private.get_candleext1_logic = function()
  
end;
private.get_candleext1_inv = function()
  interface.InventoryItemAdd("inv_candleext","spr_windowext_candleext1",function() level_inv.ProcessGetCandleextAll( "get_candleext1" ) end);
end;
private.get_candleext1_beg = function()
  ObjDelete("gfx_windowext_candleext1")
end;
private.get_candleext1_end = function()
  if common_impl.ZzCompleteCheck("get_candleext1") then ObjSet( common_impl.hint["get_candleext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_windowext_sh_candleext1");
end;

cmn.AddSubscriber( "get_candleext1", private.get_candleext1_inv );
cmn.AddSubscriber( "get_candleext1", private.get_candleext1_beg, private.room_objname );
cmn.AddSubscriber( "get_candleext1", private.get_candleext1_end, private.room_objname );
cmn.AddSubscriber( "get_candleext1", private.get_candleext1_logic );
--------------------------------------------------------------------
function public.get_candleext1()
  cmn.SetEventDone( "get_candleext1" );
  cmn.CallEventHandler( "get_candleext1" );
  if common_impl.ZzCompleteCheck("get_candleext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_invitationext" ] = { type = "get", get_obj = "spr_windowext_invitationext", room = "rm_housedoctorext", zz = "zz_windowext", zz_gate = "gzz_housedoctorext_windowext" };

private.get_invitationext_logic = function()
  
end;
private.get_invitationext_inv = function()
  interface.InventoryItemAdd("inv_invitationext","spr_windowext_invitationext");
  ObjSet( "inv_invitationext", { drag = 0 } );
end;
private.get_invitationext_beg = function()
  ObjDelete("gfx_windowext_invitationext")
end;
private.get_invitationext_end = function()
  if common_impl.ZzCompleteCheck("get_invitationext") then ObjSet( common_impl.hint["get_invitationext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_windowext_tr_cat2");
  ObjDelete("anm_windowext_anm_cat2");
end;

cmn.AddSubscriber( "get_invitationext", private.get_invitationext_inv );
cmn.AddSubscriber( "get_invitationext", private.get_invitationext_beg, private.room_objname );
cmn.AddSubscriber( "get_invitationext", private.get_invitationext_end, private.room_objname );
cmn.AddSubscriber( "get_invitationext", private.get_invitationext_logic );
--------------------------------------------------------------------
function public.get_invitationext()
  
  local func_end = function()
    ld.Lock(0)
    cmn.SetEventDone( "get_invitationext" );
    cmn.CallEventHandler( "get_invitationext" );
    if common_impl.ZzCompleteCheck("get_invitationext") then ld.CloseSubRoom() end;
  end
  
  ld.Lock(1)
  SoundSfx( "aud_touch_cat_right_housedoctorext" )
  ObjSet( "spr_windowext_tr_cat2", {visible = 0} );
  ld.AnimPlay( "anm_windowext_anm_cat2", "cat_blue", func_end );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_catpawext_zone() 
  common_impl.ShowBbt( 'need_catpawext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay("anm_windowext_anm_cat1","clic_heart",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_catpawext" ] = { type = "use", inv_obj = "inv_catpawext", use_place = "gfx_windowext_catpawext_zone", room = "rm_housedoctorext", zz = "zz_windowext", zz_gate = "gzz_housedoctorext_windowext" };

private.use_catpawext_logic = function()
  ObjSet( "spr_windowext_heartext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_catpawext_inv = function()
  common_impl.ProcessMultiUseAll("catpawext", "catpawext")
end;
private.use_catpawext_beg = function()
  ObjDelete( "gfx_windowext_catpawext_zone" );
end;
private.use_catpawext_end = function()
  if common_impl.ZzCompleteCheck("use_catpawext") then ObjSet( common_impl.hint["use_catpawext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowext_anm_cat1", {animfunc = "red_hand_end", frame = 0 } );
  ObjSet( "spr_windowext_sh_heartext2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_catpawext", private.use_catpawext_inv );
cmn.AddSubscriber( "use_catpawext", private.use_catpawext_beg, private.room_objname );
cmn.AddSubscriber( "use_catpawext", private.use_catpawext_end, private.room_objname );
cmn.AddSubscriber( "use_catpawext", private.use_catpawext_logic );
cmn.AddSubscriber( "use_catpawext_inv", private.use_catpawext_inv, private.room_objname );
cmn.AddSubscriber( "use_catpawext_beg", private.use_catpawext_beg, private.room_objname );
cmn.AddSubscriber( "use_catpawext_end", private.use_catpawext_end, private.room_objname );
cmn.AddSubscriber( "use_catpawext_end", private.use_catpawext_logic );
--------------------------------------------------------------------------------------------
function public.use_catpawext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_catpawext" );
    cmn.CallEventHandler( "use_catpawext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_catpawext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_catpawext_inv" );
  cmn.CallEventHandler( "use_catpawext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowext_anm_cat1", "red_hand", func_end );
  SoundSfx( "aud_use_catpawext_housedoctorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_heartext2" ] = { type = "get", get_obj = "spr_windowext_heartext2", room = "rm_housedoctorext", zz = "zz_windowext", zz_gate = "gzz_housedoctorext_windowext" };

private.get_heartext2_logic = function()
  
end;
private.get_heartext2_inv = function()
  interface.InventoryItemAdd("inv_heartext2","spr_windowext_heartext2");
end;
private.get_heartext2_beg = function()
  ObjDelete("gfx_windowext_heartext2")
end;
private.get_heartext2_end = function()
  if common_impl.ZzCompleteCheck("get_heartext2") then ObjSet( common_impl.hint["get_heartext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_windowext_sh_heartext2");
end;

cmn.AddSubscriber( "get_heartext2", private.get_heartext2_inv );
cmn.AddSubscriber( "get_heartext2", private.get_heartext2_beg, private.room_objname );
cmn.AddSubscriber( "get_heartext2", private.get_heartext2_end, private.room_objname );
cmn.AddSubscriber( "get_heartext2", private.get_heartext2_logic );
--------------------------------------------------------------------
function public.get_heartext2()
  cmn.SetEventDone( "get_heartext2" );
  cmn.CallEventHandler( "get_heartext2" );
  if common_impl.ZzCompleteCheck("get_heartext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_brokenbouquetext" ] = { type = "click", use_place = "gfx_windowext_clk_brokenbouquetext_zone", room = "rm_housedoctorext", zz = "zz_windowext", zz_gate = "gzz_housedoctorext_windowext" };

private.clk_brokenbouquetext_logic = function()
  ObjSet( "gfx_windowext_bouquetext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_brokenbouquetext_beg = function()
  ObjDelete( "gfx_windowext_clk_brokenbouquetext_zone" );
end;
private.clk_brokenbouquetext_end = function()
  if common_impl.ZzCompleteCheck("clk_brokenbouquetext") then ObjSet( common_impl.hint["clk_brokenbouquetext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowext_anm_doll", {animfunc = "clic_girl", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_brokenbouquetext", private.clk_brokenbouquetext_beg, private.room_objname );
cmn.AddSubscriber( "clk_brokenbouquetext", private.clk_brokenbouquetext_end, private.room_objname );
cmn.AddSubscriber( "clk_brokenbouquetext", private.clk_brokenbouquetext_logic );
cmn.AddSubscriber( "clk_brokenbouquetext_beg", private.clk_brokenbouquetext_beg, private.room_objname );
cmn.AddSubscriber( "clk_brokenbouquetext_end", private.clk_brokenbouquetext_end, private.room_objname );
cmn.AddSubscriber( "clk_brokenbouquetext_end", private.clk_brokenbouquetext_logic );
--------------------------------------------------------------------------------------------
function public.clk_brokenbouquetext()

  local func_end = function()
    cmn.SetEventDone( "clk_brokenbouquetext" );
    cmn.CallEventHandler( "clk_brokenbouquetext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_brokenbouquetext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_brokenbouquetext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowext_anm_doll", "girl", func_end );
  SoundSfx( "aud_clk_brokenbouquetext_housedoctorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_bouquetext_zone() 
  common_impl.ShowBbt( 'need_bouquetext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_very_small_metal" );
  ld.AnimPlay("anm_windowext_anm_doll","clic_girl",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_bouquetext" ] = { type = "use", inv_obj = "inv_bouquetext", use_place = "gfx_windowext_bouquetext_zone", room = "rm_housedoctorext", zz = "zz_windowext", zz_gate = "gzz_housedoctorext_windowext" };

private.use_bouquetext_logic = function()
  ObjSet( "spr_windowext_clockext", { visible = 1, input = 1, active = 1 } )

end;
private.use_bouquetext_inv = function()
  common_impl.ProcessMultiUseAll("bouquetext", "bouquetext")
end;
private.use_bouquetext_beg = function()
  ObjDelete( "gfx_windowext_bouquetext_zone" );
end;
private.use_bouquetext_end = function()
  if common_impl.ZzCompleteCheck("use_bouquetext") then ObjSet( common_impl.hint["use_bouquetext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_windowext_anm_doll", {animfunc = "girl_flower_end", frame = 0 } );
  ObjSet( "spr_windowext_sh_clockext", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bouquetext", private.use_bouquetext_inv );
cmn.AddSubscriber( "use_bouquetext", private.use_bouquetext_beg, private.room_objname );
cmn.AddSubscriber( "use_bouquetext", private.use_bouquetext_end, private.room_objname );
cmn.AddSubscriber( "use_bouquetext", private.use_bouquetext_logic );
cmn.AddSubscriber( "use_bouquetext_inv", private.use_bouquetext_inv, private.room_objname );
cmn.AddSubscriber( "use_bouquetext_beg", private.use_bouquetext_beg, private.room_objname );
cmn.AddSubscriber( "use_bouquetext_end", private.use_bouquetext_end, private.room_objname );
cmn.AddSubscriber( "use_bouquetext_end", private.use_bouquetext_logic );
--------------------------------------------------------------------------------------------
function public.use_bouquetext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bouquetext" );
    cmn.CallEventHandler( "use_bouquetext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bouquetext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bouquetext_inv" );
  cmn.CallEventHandler( "use_bouquetext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_windowext_anm_doll", "girl_flower", func_end );
  SoundSfx( "aud_use_bouquetext_housedoctorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_clockext" ] = { type = "get", get_obj = "spr_windowext_clockext", room = "rm_housedoctorext", zz = "zz_windowext", zz_gate = "gzz_housedoctorext_windowext" };

private.get_clockext_logic = function()
  
end;
private.get_clockext_inv = function()
  interface.InventoryItemAdd("inv_clockext","spr_windowext_clockext");
  ObjSet( "inv_clockext", { drag = 0 } );
end;
private.get_clockext_beg = function()
  ObjDelete("gfx_windowext_clockext")
end;
private.get_clockext_end = function()
  if common_impl.ZzCompleteCheck("get_clockext") then ObjSet( common_impl.hint["get_clockext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_windowext_sh_clockext");
end;

cmn.AddSubscriber( "get_clockext", private.get_clockext_inv );
cmn.AddSubscriber( "get_clockext", private.get_clockext_beg, private.room_objname );
cmn.AddSubscriber( "get_clockext", private.get_clockext_end, private.room_objname );
cmn.AddSubscriber( "get_clockext", private.get_clockext_logic );
--------------------------------------------------------------------
function public.get_clockext()
  cmn.SetEventDone( "get_clockext" );
  cmn.CallEventHandler( "get_clockext" );
  if common_impl.ZzCompleteCheck("get_clockext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_boxsusieext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_idle_pieceglassext_zone() 
  common_impl.ShowBbt( 'need_pieceglassext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_box_housedoctorext" );
  ld.AnimPlay("anm_boxsusieext_anm_open","box_click",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_pieceglassext" ] = { type = "use", inv_obj = "inv_pieceglassext", use_place = "gfx_boxsusieext_pieceglassext_zone", room = "rm_housedoctorext", zz = "zz_boxsusieext", zz_gate = "gzz_housedoctorext_boxsusieext" };

private.use_pieceglassext_logic = function()
  ObjSet( "spr_boxsusieext_tapeext", {  input = 1} )
  ObjSet( "spr_boxsusieext_susiebagext", {  input = 1 } )
  ObjSet( "spr_boxsusieext_note", {  input = 1 } )
end;
private.use_pieceglassext_inv = function()
  common_impl.ProcessMultiUseAll("pieceglassext", "pieceglassext")
end;
private.use_pieceglassext_beg = function()
  ObjDelete( "gfx_boxsusieext_pieceglassext_zone" );
end;
private.use_pieceglassext_end = function()
  if common_impl.ZzCompleteCheck("use_pieceglassext") then ObjSet( common_impl.hint["use_pieceglassext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boxsusieext_anm_open", {animfunc = "box_open", frame = 999, pos_z = 1 } );
  ObjSet( "spr_housedoctorext_open_box", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pieceglassext", private.use_pieceglassext_inv );
cmn.AddSubscriber( "use_pieceglassext", private.use_pieceglassext_beg, private.room_objname );
cmn.AddSubscriber( "use_pieceglassext", private.use_pieceglassext_end, private.room_objname );
cmn.AddSubscriber( "use_pieceglassext", private.use_pieceglassext_logic );
cmn.AddSubscriber( "use_pieceglassext_inv", private.use_pieceglassext_inv, private.room_objname );
cmn.AddSubscriber( "use_pieceglassext_beg", private.use_pieceglassext_beg, private.room_objname );
cmn.AddSubscriber( "use_pieceglassext_end", private.use_pieceglassext_end, private.room_objname );
cmn.AddSubscriber( "use_pieceglassext_end", private.use_pieceglassext_logic );
--------------------------------------------------------------------------------------------
function public.use_pieceglassext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pieceglassext" );
    cmn.CallEventHandler( "use_pieceglassext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pieceglassext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pieceglassext_inv" );
  cmn.CallEventHandler( "use_pieceglassext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxsusieext_anm_open", "box_open", func_end );
  SoundSfx( "aud_use_pieceglassext_housedoctorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tapeext" ] = { type = "get", get_obj = "spr_boxsusieext_tapeext", room = "rm_housedoctorext", zz = "zz_boxsusieext", zz_gate = "gzz_housedoctorext_boxsusieext" };

private.get_tapeext_logic = function()
  
end;
private.get_tapeext_inv = function()
  interface.InventoryItemAdd("inv_tapeext","spr_boxsusieext_tapeext");
end;
private.get_tapeext_beg = function()
  ObjDelete("gfx_boxsusieext_tapeext")
end;
private.get_tapeext_end = function()
  if common_impl.ZzCompleteCheck("get_tapeext") then ObjSet( common_impl.hint["get_tapeext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "obj_boxsusieext_bearext_clk_zone", {visible = 1, input = 1} );
  ObjDelete("anm_boxsusieext_anm_tape");
end;

cmn.AddSubscriber( "get_tapeext", private.get_tapeext_inv );
cmn.AddSubscriber( "get_tapeext", private.get_tapeext_beg, private.room_objname );
cmn.AddSubscriber( "get_tapeext", private.get_tapeext_end, private.room_objname );
cmn.AddSubscriber( "get_tapeext", private.get_tapeext_logic );
--------------------------------------------------------------------
function public.get_tapeext()
  local func_end = function()
  ld.Lock(0)    
    cmn.SetEventDone( "get_tapeext" );
    cmn.CallEventHandler( "get_tapeext" );
    if common_impl.ZzCompleteCheck("get_tapeext") then ld.CloseSubRoom() end;
  end
  ld.Lock(1)
  SoundSfx( "aud_click_ribbon_housedoctorext" )
  ld.AnimPlay( "anm_boxsusieext_anm_tape", "tape_use", func_end );
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_susiebagext" ] = { type = "get", get_obj = "spr_boxsusieext_susiebagext", room = "rm_housedoctorext", zz = "zz_boxsusieext", zz_gate = "gzz_housedoctorext_boxsusieext" };

private.get_susiebagext_logic = function()
  
end;
private.get_susiebagext_inv = function()
  interface.InventoryItemAdd("inv_susiebagext","spr_boxsusieext_susiebagext");
  ObjSet( "inv_susiebagext", { drag = 0 } );
end;
private.get_susiebagext_beg = function()
  ObjDelete("gfx_boxsusieext_susiebagext")
end;
private.get_susiebagext_end = function()
  if common_impl.ZzCompleteCheck("get_susiebagext") then ObjSet( common_impl.hint["get_susiebagext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boxsusieext_susiebagext_shadow");
end;

cmn.AddSubscriber( "get_susiebagext", private.get_susiebagext_inv );
cmn.AddSubscriber( "get_susiebagext", private.get_susiebagext_beg, private.room_objname );
cmn.AddSubscriber( "get_susiebagext", private.get_susiebagext_end, private.room_objname );
cmn.AddSubscriber( "get_susiebagext", private.get_susiebagext_logic );
--------------------------------------------------------------------
function public.get_susiebagext()
  cmn.SetEventDone( "get_susiebagext" );
  cmn.CallEventHandler( "get_susiebagext" );
  if common_impl.ZzCompleteCheck("get_susiebagext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.boxsusieext_bearext_clk()  --rm_roadway.roadway_idle_clk1()
  local func_end = function() 
     ObjSet( "obj_boxsusieext_bearext_clk_zone", {input = 1} );
  end
  
  ObjSet( "obj_boxsusieext_bearext_clk_zone", {input = 0} );
  SoundSfx( "aud_touch_clothes" );
  ld.AnimPlay( "anm_boxsusieext_anm_bear", "bear_click", func_end )
end;

function public.clk_idle_foxfigureext_zone() 
  common_impl.ShowBbt( 'need_foxfigureext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay("anm_boxsusieext_anm_cascet","cascet_click",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_foxfigureext" ] = { type = "use", inv_obj = "inv_foxfigureext", use_place = "gfx_boxsusieext_foxfigureext_zone", room = "rm_housedoctorext", zz = "zz_boxsusieext", zz_gate = "gzz_housedoctorext_boxsusieext" };

private.use_foxfigureext_logic = function()
  ObjSet( "spr_boxsusieext_starext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_boxsusieext_childrenrivetext", { visible = 1, input = 1, active = 1 } )

end;
private.use_foxfigureext_inv = function()
  common_impl.ProcessMultiUseAll("foxfigureext", "foxfigureext")
end;
private.use_foxfigureext_beg = function()
  ObjDelete( "gfx_boxsusieext_foxfigureext_zone" );
end;
private.use_foxfigureext_end = function()
  if common_impl.ZzCompleteCheck("use_foxfigureext") then ObjSet( common_impl.hint["use_foxfigureext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_boxsusieext_anm_cascet", {animfunc = "cascet_end", frame = 0} );
  ObjSet( "spr_boxsusieext_starext_shadow", {visible = 1} );
  ObjSet( "spr_boxsusieext_rivet_shadow", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_foxfigureext", private.use_foxfigureext_inv );
cmn.AddSubscriber( "use_foxfigureext", private.use_foxfigureext_beg, private.room_objname );
cmn.AddSubscriber( "use_foxfigureext", private.use_foxfigureext_end, private.room_objname );
cmn.AddSubscriber( "use_foxfigureext", private.use_foxfigureext_logic );
cmn.AddSubscriber( "use_foxfigureext_inv", private.use_foxfigureext_inv, private.room_objname );
cmn.AddSubscriber( "use_foxfigureext_beg", private.use_foxfigureext_beg, private.room_objname );
cmn.AddSubscriber( "use_foxfigureext_end", private.use_foxfigureext_end, private.room_objname );
cmn.AddSubscriber( "use_foxfigureext_end", private.use_foxfigureext_logic );
--------------------------------------------------------------------------------------------
function public.use_foxfigureext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_foxfigureext" );
    cmn.CallEventHandler( "use_foxfigureext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_foxfigureext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_foxfigureext_inv" );
  cmn.CallEventHandler( "use_foxfigureext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxsusieext_anm_cascet", "cascet_open", func_end );
  SoundSfx( "aud_use_foxfigureext_housedoctorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_starext" ] = { type = "get", get_obj = "spr_boxsusieext_starext", room = "rm_housedoctorext", zz = "zz_boxsusieext", zz_gate = "gzz_housedoctorext_boxsusieext" };

private.get_starext_logic = function()
  
end;
private.get_starext_inv = function()
  interface.InventoryItemAdd("inv_starext","spr_boxsusieext_starext");
  ObjSet( "inv_starext", { drag = 0 } );
end;
private.get_starext_beg = function()
  ObjDelete("gfx_boxsusieext_starext")
end;
private.get_starext_end = function()
  if common_impl.ZzCompleteCheck("get_starext") then ObjSet( common_impl.hint["get_starext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boxsusieext_starext_shadow");
end;

cmn.AddSubscriber( "get_starext", private.get_starext_inv );
cmn.AddSubscriber( "get_starext", private.get_starext_beg, private.room_objname );
cmn.AddSubscriber( "get_starext", private.get_starext_end, private.room_objname );
cmn.AddSubscriber( "get_starext", private.get_starext_logic );
--------------------------------------------------------------------
function public.get_starext()
  cmn.SetEventDone( "get_starext" );
  cmn.CallEventHandler( "get_starext" );
  if common_impl.ZzCompleteCheck("get_starext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_childrenrivetext" ] = { type = "get", get_obj = "spr_boxsusieext_childrenrivetext", room = "rm_housedoctorext", zz = "zz_boxsusieext", zz_gate = "gzz_housedoctorext_boxsusieext" };

private.get_childrenrivetext_logic = function()
  
end;
private.get_childrenrivetext_inv = function()
  interface.InventoryItemAdd("inv_childrenrivetext","spr_boxsusieext_childrenrivetext");
end;
private.get_childrenrivetext_beg = function()
  ObjDelete("gfx_boxsusieext_childrenrivetext")
end;
private.get_childrenrivetext_end = function()
  if common_impl.ZzCompleteCheck("get_childrenrivetext") then ObjSet( common_impl.hint["get_childrenrivetext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_boxsusieext_rivet_shadow");
end;

cmn.AddSubscriber( "get_childrenrivetext", private.get_childrenrivetext_inv );
cmn.AddSubscriber( "get_childrenrivetext", private.get_childrenrivetext_beg, private.room_objname );
cmn.AddSubscriber( "get_childrenrivetext", private.get_childrenrivetext_end, private.room_objname );
cmn.AddSubscriber( "get_childrenrivetext", private.get_childrenrivetext_logic );
--------------------------------------------------------------------
function public.get_childrenrivetext()
  cmn.SetEventDone( "get_childrenrivetext" );
  cmn.CallEventHandler( "get_childrenrivetext" );
  if common_impl.ZzCompleteCheck("get_childrenrivetext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_laboratorydoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_idle_laboratorydoorext_zone() 
  common_impl.ShowBbt( 'need_widebulbext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_laboratory_door_housedoctorext" );
  ld.AnimPlay("anm_laboratorydoorext_anm_click","door_click",function()ld.Lock(0)end)
end;


common_impl.hint[ "use_widebulbext" ] = { type = "use", inv_obj = "inv_widebulbext", use_place = "gfx_laboratorydoorext_widebulbext_zone", room = "rm_housedoctorext", zz = "zz_laboratorydoorext", zz_gate = "gzz_housedoctorext_laboratorydoorext" };

private.use_widebulbext_logic = function()
  --ObjSet( "gfx_laboratorydoorext_win_laboratoryext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_widebulbext_inv = function()
  common_impl.ProcessMultiUseAll("widebulbext", "widebulbext")
end;
private.use_widebulbext_beg = function()
  ObjDelete( "gfx_laboratorydoorext_widebulbext_zone" );
end;
private.use_widebulbext_end = function()
  if common_impl.ZzCompleteCheck("use_widebulbext") then ObjSet( common_impl.hint["use_widebulbext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_laboratorydoorext_anm", {animfunc = "use_flask", frame = 999 } );
  ObjAttach("obj_laboratorydoorext_mmg_root","zz_laboratorydoorext")
  ObjSet( "obj_laboratorydoorext_mmg_root", {input = 1, alp = 1,pos_z = 50} ); 
  ObjDelete("anm_laboratorydoorext_anm_click");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_widebulbext", private.use_widebulbext_inv );
cmn.AddSubscriber( "use_widebulbext", private.use_widebulbext_beg, private.room_objname );
cmn.AddSubscriber( "use_widebulbext", private.use_widebulbext_end, private.room_objname );
cmn.AddSubscriber( "use_widebulbext", private.use_widebulbext_logic );
cmn.AddSubscriber( "use_widebulbext_inv", private.use_widebulbext_inv, private.room_objname );
cmn.AddSubscriber( "use_widebulbext_beg", private.use_widebulbext_beg, private.room_objname );
cmn.AddSubscriber( "use_widebulbext_end", private.use_widebulbext_end, private.room_objname );
cmn.AddSubscriber( "use_widebulbext_end", private.use_widebulbext_logic );
--------------------------------------------------------------------------------------------
function public.use_widebulbext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_widebulbext" );
    cmn.CallEventHandler( "use_widebulbext_end" );
    cmn.MiniGameShow( "laboratoryext" );    
    public.laboratoryext_load();
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_widebulbext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_widebulbext_inv" );
  cmn.CallEventHandler( "use_widebulbext_beg" );
  common_impl.Lock(1);
  
  local func_preend = function()
        ObjAttach("obj_laboratorydoorext_mmg_root","zz_laboratorydoorext")
        ObjSet( "obj_laboratorydoorext_mmg_root", { pos_z = 50} ); 
        ObjAnimate( "obj_laboratorydoorext_mmg_root", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );  
    
  end
  
  ld.AnimPlay( "anm_laboratorydoorext_anm", "use_flask", func_preend );
  SoundSfx( "aud_use_widebulbext_housedoctorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_laboratoryext" ] = { type = "click", use_place = "obj_laboratorydoorext_mmg_root", room = "rm_housedoctorext", zz = "zz_laboratorydoorext", zz_gate = "gzz_housedoctorext_laboratorydoorext" };

private.win_laboratoryext_logic = function()
  if cmn.IsEventDone("win_laboratoryext") then 
    ObjSet( "grm_housedoctorext_laboratoryext", { visible = 1, input = 1, active = 1 } )
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_housedoctorext_laboratoryext_focus");
    end;
  end
end;
private.win_laboratoryext_beg = function()
  --ObjDelete( "gfx_laboratorydoorext_win_laboratoryext_zone" );
end;
private.win_laboratoryext_end = function()
  if cmn.IsEventDone("win_laboratoryext") then 
    if common_impl.ZzCompleteCheck("win_laboratoryext") then ObjSet( common_impl.hint["win_laboratoryext"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjDelete ("obj_laboratorydoorext_mmg_root");
    ObjSet( "spr_housedoctorext_door2", {visible = 1} );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_laboratoryext", private.win_laboratoryext_beg, private.room_objname );
cmn.AddSubscriber( "win_laboratoryext", private.win_laboratoryext_end, private.room_objname );
cmn.AddSubscriber( "win_laboratoryext", private.win_laboratoryext_logic );
cmn.AddSubscriber( "win_laboratoryext_beg", private.win_laboratoryext_beg, private.room_objname );
cmn.AddSubscriber( "win_laboratoryext_end", private.win_laboratoryext_end, private.room_objname );
cmn.AddSubscriber( "win_laboratoryext_end", private.win_laboratoryext_logic );
--------------------------------------------------------------------------------------------
function public.win_laboratoryext()

  local func_end = function()
    cmn.SetEventDone( "win_laboratoryext" );
    cmn.CallEventHandler( "win_laboratoryext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_laboratoryext") then ld.CloseSubRoom() end;
  end;
  cmn.MiniGameHide( "laboratoryext", true );
  cmn.CallEventHandler( "win_laboratoryext_beg" );
  common_impl.Lock(1);
  SoundSfx( "aud_mg_laboratorydoor_win" )
  ObjSet( "anm_laboratorydoorext_anm", {animfunc = "door_open", frame = 0 } );
  ObjAnimate( "obj_laboratorydoorext_mmg_root", 8, 0, 0,function() ld.AnimPlay( "anm_laboratorydoorext_anm", "door_open", func_end );  end , {0,0,1, 0.5,0,0} );
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

end;

--------------------------------------------------------------------------------------------
local pos_arr = {{-74,-78},{-147,-8},{146,-9},{72,62},{74,-83},{-73,63}}
local graf = {{2,4},{1,3,6},{2,4,5},{1,3},{3,6},{5,2}}
local select_tile = 0;
local color_arr = {{0,0.3,1},{0.3,1,0},{1,0,0.2},{1,0,1}}

function public.laboratoryext_load(skip)
  if not ng_global.progress["ext"]["win_laboratoryext"].state then
    ng_global.progress["ext"]["win_laboratoryext"].state = {0,2,0,1,4,3}
  end
 
  for i = 1,6 do
    if (ng_global.progress["ext"]["win_laboratoryext"].state[i] ~= 0) then 
      ObjSet("spr_laboratorydoorext_mmg_chip"..ng_global.progress["ext"]["win_laboratoryext"].state[i],{pos_x = pos_arr[i][1], pos_y = pos_arr[i][2]})
    end
  end    
  if not skip then
    private.laboratoryext_check()
  end
end


function public.laboratoryext_mdown(num) 
    select_tile = num;
    local pos = 0;
    local alp_value = 0;
    SoundSfx( "aud_mg_laboratorydoor_click" )
    for j = 1,6 do
      ObjSet( "spr_laboratorydoorext_mmg_place"..j, {input = 0} );
      if ng_global.progress["ext"]["win_laboratoryext"].state[j] == num then
        pos = j;
      end
    end
      ld.Lock(1);
      for i = 1, #graf[pos] do
        if (ng_global.progress["ext"]["win_laboratoryext"].state[graf[pos][i] ] == 0) then
            ObjSet( "spr_laboratorydoorext_mmg_place"..graf[pos][i], {input = 1} );
            ObjAnimate( "spr_laboratorydoorext_mmg_place"..graf[pos][i], 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_place"..graf[pos][i]).alp, 0.3,0, 0.6} );
          end
        end
        for n = 1,6 do
            if (ObjGet("spr_laboratorydoorext_mmg_place"..n).input == false) then
              ObjAnimate( "spr_laboratorydoorext_mmg_place"..n, 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_place"..n).alp, 0.3,0, 0} );
            end
        end
        for k = 1,4 do
          if k~=select_tile then
            if ( ng_global.progress["ext"]["win_laboratoryext"].state[k] ~= k) then
              ObjAnimate( "spr_laboratorydoorext_mmg_chip"..k.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..k.."_focus").alp, 0.3,0,0} );    
           end
        end
      end
      ld.StartTimer( 0.3, function() ld.Lock(0);  end )
     
end

function public.laboratoryext_secondclick(num) 
  ld.Lock(1);
  ObjAnimate( "spr_laboratorydoorext_mmg_chip"..select_tile, 3, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..select_tile).pos_x, ObjGet("spr_laboratorydoorext_mmg_chip"..select_tile).pos_y, 0.5,0,pos_arr[num][1], pos_y = pos_arr[num][2]} ); 
  SoundSfx( "aud_mg_laboratorydoor_move" )  
  for i = 1,6 do
    ObjSet( "spr_laboratorydoorext_mmg_place"..i, {input = 0} );
    if ng_global.progress["ext"]["win_laboratoryext"].state[i] == select_tile then
      ng_global.progress["ext"]["win_laboratoryext"].state[i] = 0;
    end
    
      ObjAnimate( "spr_laboratorydoorext_mmg_place"..i, 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_place"..i).alp, 0.3,0, 0} );
   
  end  
  ng_global.progress["ext"]["win_laboratoryext"].state[num] = select_tile;
  select_tile = 0;
  ld.StartTimer( 0.5, function() ld.Lock(0); private.laboratoryext_check();  end )
end

function private.laboratoryext_check()
  local count = 0
  for i=1,4 do
    if (i==ng_global.progress["ext"]["win_laboratoryext"].state[i]) then 
      count=count + 1 ;
      if not private.aud_mg_laboratorydoor_true then
        private.aud_mg_laboratorydoor_true = true 
        SoundSfx( "aud_mg_laboratorydoor_true" )
      end
      ObjAnimate( "spr_laboratorydoorext_mmg_chip"..i.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").alp, 0.3,0,0.6} );
      ObjAnimate( "spr_laboratorydoorext_mmg_chip"..i.."_focus", 12, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").color_r,ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").color_g, ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").color_b, 0.3,0,color_arr[i][1],color_arr[i][2],color_arr[i][3]} );
    else
      ObjAnimate( "spr_laboratorydoorext_mmg_chip"..i.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").alp, 0.3,0,0} );  
      ObjAnimate( "spr_laboratorydoorext_mmg_chip"..i.."_focus", 12, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").color_r,ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").color_g, ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").color_b, 0.3,0,1,1,1} );
    end
  end
  
 local func_f = function() 
    ld.Lock(0); 
    
    if count == 4 then 
      ld.Lock(1);
      for i=1,4 do
        ObjAnimate( "spr_laboratorydoorext_mmg_chip"..i.."_focus", 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..i.."_focus").alp, 0.3,0,0} );  
      end
      ld.StartTimer(0.5, function() ld.Lock(0); public.win_laboratoryext() end)
    end  
 end
 
 ld.StartTimer( 0.3, function() func_f() end );
end

function public.laboratoryext_menter(obj)
  ld.ShCur(CURSOR_HAND)
  ObjSet( obj, {pos_z = 10} );
  ObjAnimate( obj.."_focus", 8, 0, 0, "", {0,0,ObjGet(obj.."_focus").alp, 0.3,0,0.6} );
end

function public.laboratoryext_mleave(num)
  ld.ShCur(CURSOR_DEFAULT)
  if (select_tile ~= num) then
    if ( ng_global.progress["ext"]["win_laboratoryext"].state[num] ~= num) then
      ObjAnimate( "spr_laboratorydoorext_mmg_chip"..num.."_focus", 8, 0, 0, function() ObjSet( "spr_laboratorydoorext_mmg_chip"..num, {pos_z = 5} ); end, {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..num.."_focus").alp, 0.3,0,0} );  
    end
  end
end

function  private.win_laboratoryext_reset()
  ng_global.progress["ext"]["win_laboratoryext"].state = {0,2,0,1,4,3}
  select_tile = 0;
    local f_end = function ()
      for i = 1,6 do
        if (ng_global.progress["ext"]["win_laboratoryext"].state[i] ~= 0) then 
          ObjSet("spr_laboratorydoorext_mmg_chip"..ng_global.progress["ext"]["win_laboratoryext"].state[i],{pos_x = pos_arr[i][1], pos_y = pos_arr[i][2]})
        end
      end 
      for k = 1, 4 do
        ObjAnimate( "spr_laboratorydoorext_mmg_chip"..k, 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..k).alp, 0.3,0,1} );
      end 
      ld.StartTimer( 0.3, function() ld.Lock(0) private.laboratoryext_check(); end )
    end
    ld.Lock(1)
    for j = 1, 4 do
      ObjAnimate( "spr_laboratorydoorext_mmg_chip"..j, 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..j).alp, 0.3,0,0} );
    end
    
    ld.StartTimer( 0.3, function() f_end() end )
end

function  private.win_laboratoryext_skip()
  ng_global.progress["ext"]["win_laboratoryext"].state = {1,2,3,4,0,0}
  select_tile = 0;
    local f_end = function ()
       for i = 1,6 do
        if (ng_global.progress["ext"]["win_laboratoryext"].state[i] ~= 0) then 
          ObjSet("spr_laboratorydoorext_mmg_chip"..ng_global.progress["ext"]["win_laboratoryext"].state[i],{pos_x = pos_arr[i][1], pos_y = pos_arr[i][2]})
        end
      end 
      for k = 1, 4 do
        ObjAnimate( "spr_laboratorydoorext_mmg_chip"..k, 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..k).alp, 0.3,0,1} );
      end 
      ld.StartTimer( 0.3, function()  private.laboratoryext_check() end )
     
    end
    ld.Lock(1)
    for j = 1, 4 do
      ObjAnimate( "spr_laboratorydoorext_mmg_chip"..j, 8, 0, 0, "", {0,0,ObjGet("spr_laboratorydoorext_mmg_chip"..j).alp, 0.3,0,0} );
    end
    ld.StartTimer( 0.3, function() f_end() end )
end
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_roomentersext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_idle_susiekeyext_zone() 
  common_impl.ShowBbt( 'need_susiekeyext' )
  ld.Lock(1)
  SoundSfx( "aud_touch_big_wood" );
  ld.AnimPlay("anm_roomentersext_anm","click",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_susiekeyext" ] = { type = "use", inv_obj = "inv_susiekeyext", use_place = "gfx_roomentersext_susiekeyext_zone", room = "rm_housedoctorext", zz = "zz_roomentersext", zz_gate = "gzz_housedoctorext_roomentersext" };

private.use_susiekeyext_logic = function()
  ObjSet( "grm_housedoctorext_susieroomext", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_housedoctorext_susieroomext_focus");
  end;
end;
private.use_susiekeyext_inv = function()
  common_impl.ProcessMultiUseAll("susiekeyext", "susiekeyext")
end;
private.use_susiekeyext_beg = function()
  ObjDelete( "gfx_roomentersext_susiekeyext_zone" );
end;
private.use_susiekeyext_end = function()
  if common_impl.ZzCompleteCheck("use_susiekeyext") then ObjSet( common_impl.hint["use_susiekeyext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_roomentersext_anm", {animfunc = "use_key", frame = 999 } );
  ObjSet( "spr_housedoctorext_door1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_susiekeyext", private.use_susiekeyext_inv );
cmn.AddSubscriber( "use_susiekeyext", private.use_susiekeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_susiekeyext", private.use_susiekeyext_end, private.room_objname );
cmn.AddSubscriber( "use_susiekeyext", private.use_susiekeyext_logic );
cmn.AddSubscriber( "use_susiekeyext_inv", private.use_susiekeyext_inv, private.room_objname );
cmn.AddSubscriber( "use_susiekeyext_beg", private.use_susiekeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_susiekeyext_end", private.use_susiekeyext_end, private.room_objname );
cmn.AddSubscriber( "use_susiekeyext_end", private.use_susiekeyext_logic );
--------------------------------------------------------------------------------------------
function public.use_susiekeyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_susiekeyext" );
    cmn.CallEventHandler( "use_susiekeyext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_susiekeyext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_susiekeyext_inv" );
  cmn.CallEventHandler( "use_susiekeyext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_roomentersext_anm", "use_key", func_end );
  SoundSfx( "aud_use_susiekeyext_housedoctorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
end;

function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
 
  if ( mg_name == "zz_laboratorydoorext" ) and not ld.CheckRequirements( { "win_laboratoryext" } ) then  
    private.win_laboratoryext_reset();
  end;
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_laboratorydoorext" ) and not ld.CheckRequirements( { "win_laboratoryext" } ) then
    private.win_laboratoryext_skip();
  end;
end

--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

end;
--*********************************************************************************************************************
function public.PreOpen()
  private.opn_housedoctorext();
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_roomentersext" );
  function zz_roomentersext.Open()
  end;
  function zz_roomentersext.PreOpen()
  end;
  function zz_roomentersext.PreClose()
  end;
  function zz_roomentersext.Close()
  end;

  subroom.Define( "zz_laboratorydoorext" );
  function zz_laboratorydoorext.Open()
  end;
  function zz_laboratorydoorext.PreOpen()
     if cmn.IsEventStart("win_laboratoryext") and not cmn.IsEventDone("win_laboratoryext") then 
      cmn.MiniGameShow( "laboratoryext" ); 
      public.laboratoryext_load()
     end;  
  end;
  function zz_laboratorydoorext.PreClose()
  end;
  function zz_laboratorydoorext.Close()
  end;

  subroom.Define( "zz_boxsusieext" );
  function zz_boxsusieext.Open()
  end;
  function zz_boxsusieext.PreOpen()
  end;
  function zz_boxsusieext.PreClose()
  end;
  function zz_boxsusieext.Close()
  end;

  subroom.Define( "zz_windowext" );
  function zz_windowext.Open()
  end;
  function zz_windowext.PreOpen()
  end;
  function zz_windowext.PreClose()
  end;
  function zz_windowext.Close()
  end;

  subroom.Define( "zz_tableext" );
  function zz_tableext.Open()
  end;
  function zz_tableext.PreOpen()
  end;
  function zz_tableext.PreClose()
  end;
  function zz_tableext.Close()
  end;
  
end;
--*********************************************************************************************************************