-- name=ho_gothicextscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "gothicextscr" );
  game.relations[ "ho_gothicextscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gothicextscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_gothicextscr", zz_gate = "gho_cryptext_gothicextscr" };
 
  local win_gothicextscr_func = function ()

    if ( cmn.IsEventDone( "win_gothicextscr" ) ) then
      ObjDetach("spr_gothicextscr_win" );

    end;

  end;
  cmn.AddSubscriber( "win_gothicextscr", win_gothicextscr_func );
  
  local start_gothicextscr_func = function ()
  if not cmn.IsEventDone("win_gothicextscr") then
    if #ng_global.progress["scr"]["win_gothicextscr"].found >= 12 then
         int_taskpanel_impl.ShowTask13() 
         ObjSet("spr_gothicextscr_mmm",{alp=1,input=1})  
        ObjSet("spr_gothicextscr_open",{alp=1,input=1}) 
      end
  end 
  end;
  cmn.AddSubscriber( "win_gothicextscr", start_gothicextscr_func, "ho_gothicextscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_cryptext_env" )

  if ( not cmn.IsEventDone( "opn_gothicextscr" ) ) then

    cmn.InitHo( "gothicextscr" );

    cmn.SetEventDone( "opn_gothicextscr" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_gothicextscr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_gothicextscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_gothicextscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_gothicextscr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_gothicextscr_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_gothicextscr_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_gothicextscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_gothicextscr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_gothicextscr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_gothicextscr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_gothicextscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_gothicextscr_lll" } } );
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "spr_gothicextscr_mmm" } } );  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["scr"]["win_gothicextscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_gothicextscr"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
      ObjDetach("spr_gothicextscr_win" );
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
    int_taskpanel_impl.ResetTaskVisible()
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  if #ng_global.progress["scr"]["win_gothicextscr"].found  == 12 then
    local f_end=function()
      ld.Lock(0)
      ObjSet("spr_gothicextscr_mmm",{alp=1,input=1})  
      ObjSet("spr_gothicextscr_open",{alp=1,input=1})
    end
    ld.Lock(1)
    SoundSfx("aud_ho_gothicext_open")
    ObjAnimate( "spr_gothicextscr_open", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    int_taskpanel_impl.ShowTask13()     
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_gothicextscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_gothicextscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------