-- name=mg_againstdemonextscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_againstdemonextscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_againstdemonextscr" ] = {type = "win", use_place = "mg_againstdemonextscr", room = "rm_secretroomscr", zz = "mg_againstdemonextscr", zz_gate = "gmg_secretroomscr_againstdemonextscr" };

  local win_againstdemonextscr_logic = function()
    if ld.CheckRequirements( {"win_againstdemonextscr"} ) then
      
    end
  end;
  local win_againstdemonextscr = function()
    if ld.CheckRequirements( {"win_againstdemonextscr"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_againstdemonextscr", win_againstdemonextscr, private.room_objname )
  cmn.AddSubscriber("win_againstdemonextscr", win_againstdemonextscr_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_againstdemonextscr"} ) then
  SoundMgTheme( true )
    cmn.MiniGameShow( "againstdemonextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  iOS_NeedDrag(0);
  interface.WidgetSetInput(InterfaceWidget_BtnMap, 0)
  SoundEnv( "aud_mg_againstdemonextscr_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_againstdemonextscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "againstdemonextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  iOS_NeedDrag(1);
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  ld.Lock( 1 )
  gm.life_bar_life_reset()
  gm.no_moves_drop()

end;
--*********************************************************************************************************************
function public.Skip()
  ld.Lock( 1 )
  SoundSfx( "aud_mg_againstdemonext_skip" )  
  gm.life_bar_life_add( true )
  --private.Win();
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_againstdemonextscr" );
  cmn.CallEventHandler( "win_againstdemonextscr" );
  if common_impl.ZzCompleteCheck( "win_againstdemonextscr" ) then rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ) end;

end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  gm.win_anim_now = true;
  cmn.MiniGameHide( false, true);
  ld.StartTimer( 2.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

gm.BLOCK_TYPES = 4
gm.X = 224;
gm.Y = -44;
gm.W = 78;
gm.pole = {
  "xxxxxxxxx";
  "xx     xx";
  "x       x";
  "x       x";
  "x       x";
  "x       x";
  "x       x";
  "xx     xx";
  "xxxxxxxxx";  
}
gm.block={};
gm.life_counter = 0

gm.dictionary = {"drop","fire","lightning","star","sword"}
--*********************************************************************************************************************
function gm.load()
  if gm.loaded then return end;
  gm.build_control()

  local s = ng_global.progress["scr"]["win_againstdemonextscr"].state;
  if s then
    gm.map = gm.table_copy( s.map )
    gm.build_blocks( gm.map )
   
    gm.life_counter  = s.life_counter
    --gm.anim_obj(false) 
  else
    ld.Lock( 1 )
    gm.no_moves_drop()
  end;

  gm.set_lifebar()
  gm.blocks_set_pos()
  
  gm.loaded = true;
end;

--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_againstdemonextscr"].state = ng_global.progress["scr"]["win_againstdemonextscr"].state or {}
  local s = ng_global.progress["scr"]["win_againstdemonextscr"].state;
  s.map = gm.table_copy( gm.map )
  s.life_counter = gm.life_counter
end;

--*********************************************************************************************************************
function gm.set_lifebar()
  
  -- local t = 0;
  ObjSet( "anm_againstdemonextscr_anm_demon", {alp = 1 - (1/9)*gm.life_counter} );
  if gm.life_counter > 0 then
    for i = 1, gm.life_counter  do
     ObjSet( "spr_againstdemonextscr_life"..i, {alp = 1} ); 
    -- ld.StartTimer( t, function() 
      -- ObjAnimate( "anm_againstdemonextscr_anm_life"..i, 0, 0, 0, function() end, {0,0,-310, 0.5,0,-40} );  
        -- end )
        -- t = t+0.1;
       end;
  end
end;

--*********************************************************************************************************************
function gm.build_control()
  ObjCreate( "obj_againstdemonextscr_block_root", "obj" )
  ObjSet( "obj_againstdemonextscr_block_root", { pos_z = 22 } )
  ObjAttach( "obj_againstdemonextscr_block_root", "mg_againstdemonextscr" )
  gm.map = {};
  for i = 1, #gm.pole do
    gm.map[i] = {};
    for j = 1, gm.pole[i]:len() do
      local v = gm.pole[i]:sub(j,j);
      if v == "x" then
        gm.map[i][j] = { type = 0; };
      elseif v == "o" then
        gm.map[i][j] = { type = -2; };
      elseif v == " " then
        gm.control_new( i, j )
        gm.map[i][j] = { type = math.random( 1, gm.BLOCK_TYPES ) }
      end;
    end;
  end;
end;

--*********************************************************************************************************************
function gm.build_blocks( map )
  math.randomseed(7);
  for i = 1, #map do
    for j = 1, #map[i] do
      if map[i][j].type > 0 then
        map[i][j] = gm.block_new( gm.map[i][j].type, true );
      end;
    end;
  end;
  
  gm.remove_connected_blocks()
end;

--*********************************************************************************************************************
function gm.remove_connected_blocks( )
  --destroying cinnections of 3 in line
  
  local blows = gm.is_map_have_blows()
  
  if blows then
    local c = 1
    while #blows > c do
      if #blows[c] > #blows[c+1] then
        table.remove( blows, c+1 )
      elseif #blows[c] < #blows[c+1] then
        table.remove( blows, c )
      else
        c = c + 1
      end;
    end;

    for i = 1, #blows do
      for k,v in pairs(blows[i]) do
        if gm.map[v.y][v.x].type ~= 99 then
          ObjDelete( gm.map[v.y][v.x].obj )
          gm.map[v.y][v.x].type = 99
        end
      end;
    end;
    for i = 1, #blows do
      for k,v in pairs(blows[i]) do
        if gm.map[v.y][v.x].type == 99 then
          gm.map[v.y][v.x] = gm.block_new( math.random( 1, gm.BLOCK_TYPES ) );
        end
      end;
    end;
    
    gm.remove_connected_blocks()
  end
end

--*********************************************************************************************************************
function gm.blocks_set_pos()
  for i = 1, #gm.map do
    for j = 1, #gm.map[i] do
      local b = gm.map[i][j]
      if b.type > 0 then
        ObjSet( b.obj, { pos_x = gm.X + j * gm.W, pos_y = gm.Y + i * gm.W } )
      end;
    end;
  end;
end;

--*********************************************************************************************************************
function gm.block_set_pos(b,y,x)
  ObjSet( b.obj, { pos_x = gm.X + x * gm.W, pos_y = gm.Y + y * gm.W } )
end

--*********************************************************************************************************************
function gm.control_new( y, x )
  local obj = "obj_againstdemonextscr_control_"..y.."_"..x;
  ObjCreate( obj, "obj" )
  ObjSet( obj, {  
    event_mdown = function() gm.mdown( obj ) end;
    event_menter = function() gm.menter( obj ) end;
    event_mleave = function() gm.mleave( obj ) end;
    inputrect_init = 1;
    inputrect_x = - gm.W/2;
    inputrect_y = - gm.W/2;
    inputrect_w = gm.W;
    inputrect_h = gm.W;
    pos_x = gm.X + x * gm.W;
    pos_y = gm.Y + y * gm.W;
    input = 1;
    pos_z = 33;

    drag = 1;
    realdrag = 1;
    event_startdrag = function() gm.control_startdrag( obj ) end;
    event_drag = function() gm.control_drag( obj ) end;
    event_dragdrop = function() gm.control_dragdrop( obj ) end;
  } )
  ObjAttach( obj, "obj_againstdemonextscr_block_root" )
end

--*********************************************************************************************************************
function gm.control_startdrag( obj )
  gm.drag_pos = GetZoomCursorPos()
end

--*********************************************************************************************************************
function gm.control_drag( obj )

  if gm.mdown_anim_start_for_drag or not gm.drag_pos then return end
  local obj = obj or ld.LogTrace( "!!!gm.control_drag( obj )" )
  local d = ld.StringDivide( obj )
  local y = tonumber( d[#d-1] )
  local x = tonumber( d[#d] )

  local pos1 = GetZoomCursorPos()
  local pos2 = gm.drag_pos
  local dx = pos1[1] - pos2[1]
  local dy = pos1[2] - pos2[2]
  if math.abs( dx ) > gm.W / 2 or math.abs( dy ) > gm.W / 2 then

    if math.abs( dx ) >= math.abs( dy ) then
      local w = dx > 0 and 1 or -1;
      if gm.map[y][x+w] and gm.map[y][x+w].type > 0 then
        gm.drag_pos = false
        gm.mdown( "obj_againstdemonextscr_control_"..y.."_"..(x+w) )
      end;


    else
      local w = dy > 0 and 1 or -1;
      if gm.map[y+w] and gm.map[y+w][x] and gm.map[y+w][x].type > 0 then
        gm.drag_pos = false
        gm.mdown( "obj_againstdemonextscr_control_"..(y+w).."_"..(x) )
      end;  
    end;
  end;

end

--*********************************************************************************************************************
function gm.control_dragdrop( obj )
  gm.drag_pos = false;
end

--*********************************************************************************************************************
function gm.block_new( type_value, building )
  if ( type_value == 5 ) then
    SoundSfx( "aud_mg_againstdemonext_sword" );  
  end;
  
  if not building and type_value == 5 then
    type_value = math.random(1,gm.BLOCK_TYPES-1)
  end;

  if gm.destroyed[ type_value ] and #gm.destroyed[ type_value ] > 13 then

    ObjSet( gm.destroyed[ type_value ][ 1 ].obj , { visible = 1 } );
    return table.remove( gm.destroyed[ type_value ], 1 );

  else

    gm.block_counter = gm.block_counter or 1
    local b = {};
    b.id = gm.block_counter;
    b.obj = "obj_againstdemonextscr_block_"..gm.block_counter;
    b.type = type_value;

    ObjCreate( b.obj, "obj" )
    ObjSet( b.obj, {  
      scale_x = 0.95;
      scale_y = 0.95;
      input = 0;
    } )
    ObjAttach( b.obj, "obj_againstdemonextscr_block_root" )

    local obj = b.obj.."_block"
    ObjCreate( obj, "spr" )
    ObjSet( obj, {  
      res = "assets/levels/levelext/mg_againstdemonext/"..gm.dictionary[b.type];
      input = 0;
    } )
    ObjAttach( obj, b.obj )

    local obj = b.obj.."_choice"
    ObjCreate( obj, "spr" )
    ObjSet( obj, {  
      res = "assets/levels/levelext/mg_againstdemonext/lig_"..gm.dictionary[b.type];
      input = 0;
      pos_z = 3;
      blendmode = 1;
      alp = 0;
    } )
    ObjAttach( obj, b.obj )

    -- if b.type == 5 then
      -- local obj = b.obj.."_fire"
      --  ObjCreate( obj, "partsys" )
      --  ObjSet( obj, {  
      --  res = "assets/levels/levelext/mg_againstdemonextscr/block"..b.type.."_fire_fx";
      -- input = 0;
    -- } )
    --  ObjAttach( obj, b.obj )
    -- end

    gm.block_counter = gm.block_counter + 1
    return b;

  end;
end;

--*********************************************************************************************************************
function gm.is_map_have_blows()
  local blows
  for i = 1, #gm.map do
    for j = 1, #gm.map[i] do
      local b = gm.map[i][j]
      if b.type > 0 then
        local blow = gm.is_block_have_blows( i, j )
         
        if blow then
          blows = blows or {}
          table.insert( blows, blow );
        end;
      end;
    end;
  end;
  
  return blows
end;

--*********************************************************************************************************************
function gm.is_block_have_blows( y, x, blows )
  local blows = blows;
  local w = {{0,1};{-1,0};{0,-1};{1,0};};
  local b = gm.map[y][x];
  for i = 1, #w do
    if  ( gm.map[y+w[i][1]] and gm.map[y-w[i][1]] )
    and ( gm.map[y+w[i][1]][x+w[i][2]] and gm.map[y-w[i][1]][x-w[i][2]] )
    then
      
      if ( gm.map[y+w[i][1]][x+w[i][2]].type == b.type and gm.map[y-w[i][1]][x-w[i][2]].type == b.type ) then
        blows = blows or {}
        blows[b.obj]={y=y,x=x};

        if not blows[gm.map[y+w[i][1]][x+w[i][2]].obj] then
          gm.is_block_have_blows( y+w[i][1], x+w[i][2], blows )
        end
        blows[gm.map[y+w[i][1]][x+w[i][2]].obj] = {y=y+w[i][1];x=x+w[i][2]}

        if not blows[gm.map[y-w[i][1]][x-w[i][2]].obj] then
          gm.is_block_have_blows( y-w[i][1], x-w[i][2], blows )
        end
        blows[gm.map[y-w[i][1]][x-w[i][2]].obj] = {y=y-w[i][1];x=x-w[i][2]}

      elseif ( gm.map[y+w[i][1]][x+w[i][2]].type == b.type and gm.map[y+w[i][1]*2][x+w[i][2]*2].type == b.type ) then
        blows = blows or {}
        blows[b.obj]={y=y,x=x};

        if not blows[gm.map[y+w[i][1]][x+w[i][2]].obj] then
          gm.is_block_have_blows( y+w[i][1], x+w[i][2], blows )
        end
        blows[gm.map[y+w[i][1]][x+w[i][2]].obj] = {y=y+w[i][1];x=x+w[i][2]}

      end;
    end
  end;
  
  return blows;
end;

--*********************************************************************************************************************
function gm.mdown( obj )
  local obj = obj or ld.LogTrace( "!!!gm.mdown( obj )" )
  local d = ld.StringDivide( obj )
  local y = tonumber( d[#d-1] )
  local x = tonumber( d[#d] )

  local b = gm.map[y][x]
  
  if not gm.mdown_now then
    SoundSfx( "aud_mg_againstdemonext_click" )
    gm.mdown_now = { y = y, x = x };
    local o = ObjGet( b.obj )
    local sc1 = o.scale_x
    local sc2 = 1.05;
    local t = (sc2-sc1)*2
    ObjAnimate( o.name, 6,0,0, "", { 0,0,sc1,sc1, t,2,sc2,sc2 } )
    ObjSet( o.name, { pos_z = 1 } )
    local o = ObjGet( b.obj.."_choice" )
    ObjAnimate( o.name, 8,0,0, "", { 0,0,o.alp, t,0,1 } )
  elseif gm.mdown_now.x == x and gm.mdown_now.y == y then
    SoundSfx( "aud_mg_againstdemonext_click" )
    gm.mdown_now = false
    gm.menter( obj )
    local o = ObjGet( b.obj.."_choice" )
    ObjAnimate( o.name, 8,0,0, "", { 0,0,o.alp, (o.alp)/3,0,0 } )
  elseif ( math.abs( x - gm.mdown_now.x ) == 1 and math.abs( y - gm.mdown_now.y ) == 0 ) or ( math.abs( x - gm.mdown_now.x ) == 0 and math.abs( y - gm.mdown_now.y ) == 1 ) then

    ld.Lock( 1 )
    local t = 0.2
    local o = ObjGet( gm.map[gm.mdown_now.y][gm.mdown_now.x].obj.."_choice" )
    ObjAnimate( o.name, 8,0,0, "", { 0,0,o.alp, t,0,0 } )

    local o1 = ObjGet( b.obj )
    local o2 = ObjGet( gm.map[gm.mdown_now.y][gm.mdown_now.x].obj )

    gm.map[y][x],gm.map[gm.mdown_now.y][gm.mdown_now.x] = gm.map[gm.mdown_now.y][gm.mdown_now.x], gm.map[y][x]
    local blows = gm.is_map_have_blows()

    gm.mdown_anim_start_for_drag = true;

    if blows then
      SoundSfx( "aud_mg_againstdemonext_move" )
      ObjAnimate( o1.name, 3,0,0, _, { 0,0,o1.pos_x,o1.pos_y, t,3,o2.pos_x,o2.pos_y } )
      ObjAnimate( o2.name, 3,0,0, _, { 0,0,o2.pos_x,o2.pos_y, t,3,o1.pos_x,o1.pos_y } )
      ObjAnimate( o1.name, 6,0,0, _, { 0,0,o1.scale_x,o1.scale_x, t/2,1,1.2,1.2, t,2,0.95,0.95 } )
      ObjAnimate( o2.name, 6,0,0, function() gm.mdown_anim_start_for_drag = false; gm.blow_up_blocks({x=x,y=y},{x=gm.mdown_now.x,y=gm.mdown_now.y});gm.mdown_now = false; end, { 0,0,o2.scale_x,o2.scale_x, t/2,1,1.1,1.1, t,2,0.95,0.95 } )
      ObjSet( o1.name, { pos_z = o1.pos_z + 2 } )
      ObjSet( o2.name, { pos_z = o2.pos_z + 1 } )
    else
      SoundSfx( "aud_mg_againstdemonext_move" )
      ld.StartTimer( t*1.5, function() SoundSfx( "aud_mg_againstdemonext_move") end )
      gm.map[y][x],gm.map[gm.mdown_now.y][gm.mdown_now.x] = gm.map[gm.mdown_now.y][gm.mdown_now.x], gm.map[y][x]
      ObjAnimate( o1.name, 3,0,0, function() ObjSet( o1.name, { pos_z = 0 } ) end, { 0,0,o1.pos_x,o1.pos_y, t,3,o2.pos_x,o2.pos_y, t*1.5,3,o2.pos_x,o2.pos_y, t*2.5,0,o1.pos_x,o1.pos_y, } )
      ObjAnimate( o2.name, 3,0,0, function() ObjSet( o2.name, { pos_z = 0 } ); gm.mdown_anim_start_for_drag = false; gm.mdown_now = false; ld.Lock( 0 ) end, { 0,0,o2.pos_x,o2.pos_y, t,3,o1.pos_x,o1.pos_y, t*1.5,3,o1.pos_x,o1.pos_y, t*2.5,0,o2.pos_x,o2.pos_y } )
      ObjAnimate( o1.name, 6,0,0, _, { 0,0,o1.scale_x,o1.scale_x, t/2,1,1.2,1.2, t,2,0.95,0.95, t*1.5,2,0.95,0.95, t*2,1,1.2,1.2, t*2.5,2,0.95,0.95 } )
      ObjAnimate( o2.name, 6,0,0, _, { 0,0,o2.scale_x,o2.scale_x, t/2,1,1.1,1.1, t,2,0.95,0.95, t*1.5,2,0.95,0.95, t*2,1,1.1,1.1, t*2.5,2,0.95,0.95 } )
      ObjSet( o1.name, { pos_z = o1.pos_z + 2 } )
      ObjSet( o2.name, { pos_z = o2.pos_z + 1 } )
    end;
    gm.mdown_now = { y = y, x = x };
  else
    gm.mdown( "obj_againstdemonextscr_control_"..gm.mdown_now.y.."_"..gm.mdown_now.x )
    gm.mdown_now = false;
    gm.mdown( "obj_againstdemonextscr_control_"..y.."_"..x )
  end;

end;

--*********************************************************************************************************************
function gm.blow_up_blocks(p1,p2)
  local blows = gm.is_map_have_blows()

  ld.Lock( 1 )

  if blows then
    PlaySfx( "assets/levels/common/audio/aud_mg_againstdemonext_hide", 0, "", 0.0 )
    local c = 1
    while #blows > c do
      if #blows[c] > #blows[c+1] then
        table.remove( blows, c+1 )
      elseif #blows[c] < #blows[c+1] then
        table.remove( blows, c )
      else
        c = c + 1;
      end;
    end;

    local shoted = nil
    for i = 1, #blows do
      local c = 0
      local pp = {}
      local shot = nil
      for k,v in pairs(blows[i]) do

        if gm.map[v.y][v.x].type == 5 then
          shot = shot or 0;
          shot = shot + 1;
          shoted = shoted or shot
          shoted = math.max(shoted,shot);
        end;
        table.insert(pp,v);
        
        gm.block_destroy( v, shot );
        
        for ii = 1, #blows do
          if ii ~= i then
            for kk,vv in pairs(blows[ii]) do
              if kk == k then
                blows[ii][kk] = nil;
              end;
            end;
          end;
        end
        c = c + 1
      end;

      if c > 3 then
        
        c = c - 3
        local created = false;
        if p1 and p2 then
          for k,v in pairs(blows[i]) do
            if v.x == p1.x and v.y == p1.y and gm.map[p1.y][p1.x].type == -1 then
              gm.map[p1.y][p1.x] = gm.block_new( 5, true )
              gm.block_set_pos(gm.map[p1.y][p1.x],p1.y,p1.x)
              created = true;
              c = c - 1
            elseif v.x == p2.x and v.y == p2.y and gm.map[p2.y][p2.x].type == -1 then
              gm.map[p2.y][p2.x] = gm.block_new( 5, true )
              gm.block_set_pos(gm.map[p2.y][p2.x],p2.y,p2.x)
              created = true;
              c = c - 1
            end
          end;
        end;

        --random
        while not shot and c > 0 and #pp > 0 do
          p = table.remove( pp, math.random(1,#pp) );
          if gm.map[p.y][p.x].type == -1 then
            gm.map[p.y][p.x] = gm.block_new( 5, true )
            gm.block_set_pos(gm.map[p.y][p.x],p.y,p.x)
            c = c - 1
          end
        end

        --end;
      end;

    end;
   

    gm.blocks_drop_down()

   
    if shoted then
        PlaySfx( "assets/levels/common/audio/aud_mg_againstdemonext_attack", 0, "", 0.0 )
        ld.StartTimer( shoted*0.1+0.4, gm.life_bar_life_add )
    end;
  else
    if not gm.win_anim_now then
      gm.save()
      ld.Lock( 0 )
    end
  end;
end;

--*********************************************************************************************************************
function gm.coal_shot( b, dt )
  ObjSet( b, { pos_z = 22 } )
  local o = ObjGet( b )
  local t = 0.2

  local blow = function( obj )
    ObjSet( obj, { pos_z = 0; } )
    local anm = "anm_"..obj.."_blow"
        local pos = GetObjPosByObj( obj )
        if not ObjGet( anm ) then
          ObjCreate( anm, "anim" )
          ObjSet( anm, { res = "assets/levels/levelext/mg_againstdemonext/anm_againstdemon", animfunc = "sword_boom", playing = 1 } )
          ObjAttach( anm, "mg_againstdemonextscr" )
        else
          ObjSet( anm, {playing = 1} ) 
        end
        ObjSet( anm, {  pos_x = pos[1], pos_y = pos[2], pos_z = 33 } )
        ObjSet( obj, { visible = 0, pos_x = -100, pos_y = -100 } )
  end;
      
      -- local pos = GetObjPosByObj("anm_againstdemonextscr_anm_life"..gm.life_counter+1)
  ObjAnimate( b, 6,0,0, _, { 0,0,1,1, t*0.75,0,1.25,1.25, t*0.5+dt,0,1.25,1.25, t*3+dt,1,1,1 } )
  ObjAnimate( b, 3,0,0, function() blow( b ) end, { 0,0,o.pos_x,o.pos_y, t*0.5+dt,0,o.pos_x,o.pos_y, t*3+dt,1,615, 300+math.random(-50,50) } )
  
end;

--*********************************************************************************************************************
function gm.life_bar_life_reset()
  ObjAnimate( "anm_againstdemonextscr_anm_demon", 8, 0, 0, function() end, {0,0,ObjGet("anm_againstdemonextscr_anm_demon").alp, 0.3,0,1} );
  if ( gm.life_counter ~= 0 ) then
    --  local t = 0;
    -- local f = 0;
    for i =  1  , gm.life_counter do
       ObjAnimate( "spr_againstdemonextscr_life"..i, 8, 0, 0, function()  end, {0,0,1, 0.3,0,0} );
        --   t = t + 0.1;
        --  f = f+10;
    end;
    gm.life_counter = 0;
  end;
  
 
end;

--*********************************************************************************************************************
function gm.life_bar_life_add( skip )
  if gm.life_counter < 8 then
   
    gm.life_counter = gm.life_counter + 1
    --SoundSfx( "aud_mg_againstdemonext_sword" );
    local func_skip = function()
       ObjAnimate( "anm_againstdemonextscr_anm_demon", 8, 0, 0, function() end, {0,0,ObjGet("anm_againstdemonextscr_anm_demon").alp, (9 - gm.life_counter)*0.1,0,0} );
       local t = 0;
       for i = gm.life_counter,9 do
          
          ld.StartTimer( t, function()  ObjAnimate( "spr_againstdemonextscr_life"..i, 8, 0, 0, function()  end, {0,0,0, 0.3,0,1} );  end ) 
            
          t = t + 0.1;
        end;
        ld.StartTimer( (9 - gm.life_counter)*0.1, function() private.Win(); end ) 
     end
    
    
    if skip then 
      AnimPlay( "anm_againstdemonextscr_anm_sword", "use_sword" , function() func_skip() end )
      
      
    else
          
        AnimPlay( "anm_againstdemonextscr_anm_sword", "use_sword" , function() ObjAnimate( "spr_againstdemonextscr_life"..gm.life_counter, 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );  ObjAnimate( "anm_againstdemonextscr_anm_demon", 8, 0, 0, function() end, {0,0,ObjGet("anm_againstdemonextscr_anm_demon").alp, 0.3,0,(ObjGet("anm_againstdemonextscr_anm_demon").alp - 1/9)} ); end )
    end;  
  else
        AnimPlay( "anm_againstdemonextscr_anm_sword", "use_sword" , function ()  ObjAnimate( "anm_againstdemonextscr_anm_demon", 8, 0, 0, function() end, {0,0,ObjGet("anm_againstdemonextscr_anm_demon").alp, 0.3,0,0} ); ObjAnimate( "spr_againstdemonextscr_life"..gm.life_counter+1, 8, 0, 0, function() private.Win(); end, {0,0,0, 0.3,0,1} ); end )
  end;
end;

--*********************************************************************************************************************
function gm.life_bar_life_remove()
 
  if gm.life_counter > 0 then
    
    gm.life_counter = gm.life_counter - 1;
    ObjAnimate( "spr_againstdemonextscr_life"..gm.life_counter+1, 8, 0, 0, function()  end, {0,0,1, 0.3,0,0} );
      ObjAnimate( "anm_againstdemonextscr_anm_demon", 8, 0, 0, function() end, {0,0,ObjGet("anm_againstdemonextscr_anm_demon").alp, 0.3,0,(ObjGet("anm_againstdemonextscr_anm_demon").alp + 1/9)} );
  end;
end;

--*********************************************************************************************************************
function gm.blocks_drop_down()
  
  local jump_h = 8
  local jump_t = 0.125
  gm.blocks_drop_down_sfx = {}
  gm.blocks_drop_down_anims = gm.blocks_drop_down_anims or {}
  gm.blocks_drop_down_new_blocks = gm.blocks_drop_down_new_blocks or {}
  local bool = false
  for i = #gm.map, 1, -1 do
    for j = 1, #gm.map[i] do
      if gm.map[i][j].type == -1 then
        if gm.map[i-1][j].type > 0 then


          local c = 1
          while gm.map[i+c][j].type == -1 do
            c=c+1
          end;
          c=c-1

          gm.map[i+c][j],gm.map[i-1][j] = gm.map[i-1][j],gm.map[i+c][j]

          local o = ObjGet( gm.map[i+c][j].obj ) 
          gm.blocks_drop_down_anims[o.name]=true;

          --ObjSet( o.name, { pos_x = gm.X + j * gm.W } )

          local h = math.abs(o.pos_y -( gm.Y + (i+c) * gm.W ) )
          local g = 3000
          local t = (2*h/g)^0.5
          local ts = (#gm.map-i)*0.04
          bool = true
          ObjAnimate( o.name, 1,0,0, function() gm.blocks_drop_down_end( o.name, o.pos_y+h ) end, { 0,0,o.pos_y, ts,0,o.pos_y, t+ts,1,o.pos_y+h+jump_h, t+ts+jump_t,2,o.pos_y+h } )

        end;
      end;
    end;
  end;
  if bool then
    gm.blocks_drop_down()
    return
  end
  local bool = false
  for i = #gm.map, 1, -1 do
    for j = 1, #gm.map[i] do
      
      if gm.map[i][j].type == -1 then
        if gm.map[i-1][j].type == 0 then
          local c = 1
          while gm.map[i+c][j].type == -1 do
            c=c+1
          end;
          c=c-1
          local b = gm.block_new( math.random(1,gm.BLOCK_TYPES) )
          gm.map[i+c][j] = b;
          ObjSet( b.obj, { pos_x = gm.X + j * gm.W, pos_y = - gm.W * ( #gm.map - c ) } )
          local o = ObjGet( b.obj )
          

          gm.blocks_drop_down_anims[o.name]=true;
          gm.blocks_drop_down_new_blocks[o.name]={y=o.pos_y,i=i,c=c};
         
          bool = true
        end;
      end;
    end;
  end;
  if bool then
    gm.blocks_drop_down()
    return
  end
  local y_max = -9999;
  for k,v in pairs( gm.blocks_drop_down_new_blocks ) do
    y_max = math.max( y_max, v.y )
  end;
  
  for k,v in pairs( gm.blocks_drop_down_new_blocks ) do
    ObjSet( k, { pos_y = v.y - y_max - gm.W / 2 } )
    local o = ObjGet( k )
   
    local h = math.abs(o.pos_y -( gm.Y + (v.i+v.c) * gm.W ) )
    local g = 3000
    local t = (2*h/g)^0.5
    local ts = (#gm.map-v.i-v.c)*0.04
    
    ObjAnimate( o.name, 1,0,0, function() gm.blocks_drop_down_end( o.name, gm.Y + (v.i+v.c) * gm.W ) end, { 0,0,o.pos_y, ts,0,o.pos_y, t+ts,1,( gm.Y + (v.i+v.c) * gm.W )+jump_h, t+ts+jump_t,2,( gm.Y + (v.i+v.c) * gm.W ) } )
    
    if not gm.blocks_drop_down_sfx[ gm.Y + (v.i+v.c) * gm.W ] then
      ld.StartTimer( "tmr_againstdemonextscr_"..o.name, t+ts, function() PlaySfx( "assets/levels/common/audio/aud_mg_againstdemonext_fall", 0, "", 0.0 ) end )
      gm.blocks_drop_down_sfx[ gm.Y + (v.i+v.c) * gm.W ] = true
    end

  end;
  gm.blocks_drop_down_new_blocks = {}
 
end

--*********************************************************************************************************************
function gm.blocks_drop_down_end( obj, sfx_y )

  gm.blocks_drop_down_anims[obj]=nil;
  local count = 0;
  for k,v in pairs( gm.blocks_drop_down_anims ) do
    count = count + 1
  end;
  if count == 0 then
    gm.blocks_drop_down_new_blocks = nil;
    if gm.win_anim_now then
      gm.blocks_drop_down_anims = nil
    else
      gm.blocks_drop_down_anims = nil
      
      local blows = gm.is_map_have_blows()
      if blows then
        gm.blow_up_blocks()
      else
        if gm.check_moves() then
          if not gm.win_anim_now then
            gm.save()
            ld.Lock( 0 )
          end
        else
          
          gm.no_moves_drop()
        end;
      end;

    end;
  else
   
  end;
end;

--*********************************************************************************************************************
function gm.no_moves_drop( trg )
  trg = trg or gm.blocks_drop_down
  local destroy = {}
  for i = 1, #gm.map do
    for j = 1, #gm.map[i] do
      if gm.map[i][j].type > 0 then
        table.insert( destroy, {y=i,x=j} )
      end;
    end;
  end;

  local t = 0.15
  local ts = 0.025
  local ta = 0.15
  local sfx = 0;
  while #destroy > 0 do
    local d = table.remove( destroy, math.random( 1, #destroy ) )
    local o = ObjGet( gm.map[d.y][d.x].obj )
    if o then
      sfx = sfx + 1
      if sfx % 4 == 0 then 
        ld.StartTimer( "tmr_againstdemonextscr_sfx_"..o.name, t, function() PlaySfx( "assets/levels/common/audio/aud_mg_againstdemonext_hide", 0, "", 0.0 ) end )
      end
      ObjAnimate( o.name, 6,0,0, function() gm.block_destroy( {y=d.y,x=d.x} ) end, { 0,0,o.scale_x,o.scale_y, t,0,o.scale_x,o.scale_y, t+ta,0,1,1 } )
      t = t + ts;
    else
      gm.block_destroy( {y=d.y,x=d.x} )
    end;
  end;

  --SoundSfx( "aud_witch_reset" )
  
  
  ld.StartTimer( t,   gm.life_bar_life_remove )
  ld.StartTimer( t+ta, trg )
  
end;

--*********************************************************************************************************************


function gm.check_moves()
  --dostupnost hodov
  local w = {{0,1};{-1,0};{0,-1};{1,0};};
  for i = 1, #gm.map do
    for j = 1, #gm.map[i] do
      for z = 1, #w do
        if  gm.map[i][j].type > 0
        and gm.map[i+w[z][1]]
        and gm.map[i][j].type == gm.map[i+w[z][1]][j+w[z][2]].type
        and ((gm.map[i+w[z][1]*2] and gm.map[i+w[z][1]*2][j+w[z][2]*2] and gm.map[i+w[z][1]*2][j+w[z][2]*2].type >0 and gm.map[i+w[z][1]*3] and gm.map[i+w[z][1]*3][j+w[z][2]*3] and gm.map[i+w[z][1]*3][j+w[z][2]*3].type == gm.map[i+w[z][1]][j+w[z][2]].type )
          or (gm.map[i+w[z][1]*2] and gm.map[i+w[z][1]*2][j+w[z][2]*2] and gm.map[i+w[z][1]*2][j+w[z][2]*2].type >0 and gm.map[i+w[z][1]*2+w[z][2]] and gm.map[i+w[z][1]*2+w[z][2]][j+w[z][2]*2+w[z][1]] and gm.map[i+w[z][1]*2+w[z][2]][j+w[z][2]*2+w[z][1]].type == gm.map[i+w[z][1]][j+w[z][2]].type )
          or (gm.map[i+w[z][1]*2] and gm.map[i+w[z][1]*2][j+w[z][2]*2] and gm.map[i+w[z][1]*2][j+w[z][2]*2].type >0 and gm.map[i+w[z][1]*2-w[z][2]] and gm.map[i+w[z][1]*2-w[z][2]][j+w[z][2]*2-w[z][1]] and gm.map[i+w[z][1]*2-w[z][2]][j+w[z][2]*2-w[z][1]].type == gm.map[i+w[z][1]][j+w[z][2]].type ))
        then
      
          return true
        end;

        if  gm.map[i][j].type > 0

        and gm.map[i+w[z][1]]
        and gm.map[i+w[z][1]][j+w[z][2]]
        and gm.map[i+w[z][1]][j+w[z][2]].type > 0

        and gm.map[i+w[z][1]+w[z][2]]
        and gm.map[i+w[z][1]-w[z][2]]
        and gm.map[i+w[z][1]+w[z][2]][j+w[z][2]+w[z][1]]
        and gm.map[i+w[z][1]-w[z][2]][j+w[z][2]-w[z][1]]
        and gm.map[i][j].type == gm.map[i+w[z][1]+w[z][2]][j+w[z][2]+w[z][1]].type
        and gm.map[i][j].type == gm.map[i+w[z][1]-w[z][2]][j+w[z][2]-w[z][1]].type
        then
      
          return true
        end;

      end;
    end;
  end;
  return false
end;

--*********************************************************************************************************************
gm.destroyed = {}
function gm.block_destroy( yx, dt )


    local block = gm.map[yx.y][yx.x]
    if block.obj then
      if dt then
        local obj = block.obj
          gm.coal_shot( obj, dt*0.1 )     
      else
        local anm = "anm_"..block.obj.."_blow"
        local pos = GetObjPosByObj( block.obj )
        if not ObjGet( anm ) then
          ObjCreate( anm, "anim" )
          ObjSet( anm, { res = "assets/levels/levelext/mg_againstdemonext/anm_againstdemon", animfunc = gm.dictionary[block.type].."_boom", playing = 1 } )
          ObjAttach( anm, "mg_againstdemonextscr" )
        else
          ObjSet( anm, {playing = 1} ) 
        end
        ObjSet( anm, {  pos_x = pos[1], pos_y = pos[2], pos_z = 33 } )
        ObjSet( block.obj, { visible = 0, pos_x = -100, pos_y = -100 } )
      end


        gm.destroyed[ block.type ] = gm.destroyed[ block.type ] or {}
        table.insert( gm.destroyed[ block.type ], block )
       

    end;
    gm.map[yx.y][yx.x] = {type=-1};
   
end;

--*********************************************************************************************************************
function gm.menter( obj )
  local obj = obj or ld.LogTrace( "!!!gm.menter( obj )" )
  local d = ld.StringDivide( obj )
  local y = tonumber( d[#d-1] )
  local x = tonumber( d[#d] )
  ld.ShCur(CURSOR_HAND)
 
  if not gm.mdown_now or gm.mdown_now.x ~= x or gm.mdown_now.y ~= y then
    local o = ObjGet( gm.map[y][x].obj )
    local sc1 = o.scale_x
    local sc2 = 1.00;
    local t = math.abs( (sc2-sc1)*2 )
    ObjAnimate( o.name, 6,0,0, "", { 0,0,sc1,sc1, t,2,sc2,sc2 } )
  end;
end;

--*********************************************************************************************************************
function gm.mleave( obj )
  local obj = obj or ld.LogTrace( "!!!gm.mleave( obj )" )
  local d = ld.StringDivide( obj )
  local y = tonumber( d[#d-1] )
  local x = tonumber( d[#d] )
  ld.ShCur(CURSOR_DEFAULT)
 
  if not gm.mdown_now or gm.mdown_now.x ~= x or gm.mdown_now.y ~= y then
    local o = ObjGet( gm.map[y][x].obj )
    local sc1 = o.scale_x
    local sc2 = 0.95;
    local t = math.abs( (sc1-sc2)*2 )
    ObjAnimate( o.name, 6,0,0, "", { 0,0,sc1,sc1, t,1,sc2,sc2 } )
  end
end;



--*********************************************************************************************************************

function gm.print(...)
  local s = "";
  for i = 1, #arg do
    s = s..tostring( arg[i] );
    if #arg > 1 then
      s = s.."; ";
    end;
  end;
  -- ld.LogTrace( s );
end;

--*********************************************************************************************************************

--[[*********************************]]
--[[     возвращает копию таблицы    ]]
--[[---------------------------------]]
--[[]]function gm.table_copy( t )
--[[]]  local out = {}
--[[]]  for k,v in pairs( t ) do
--[[]]    if type( v ) == "table" then
--[[]]      out[k]=gm.table_copy( v );
--[[]]    else
--[[]]      out[k]=v;
--[[]]    end;
--[[]]  end;
--[[]]  return out;
--[[]]end;
--[[---------------------------------]]
--[[                                 ]]
--[[*********************************]]

function gm.table_show( t, space )
  space = space or "";
  local s = space
  for k,v in pairs( t ) do
    --local s = space
    if type( v ) == "table" then
      s = s.."\n"..space.."\t"..tostring(k).." :: "..tostring(v).."\n";
      --gm.print( s.."\t"..tostring(k).." ::" );
      s = s..gm.table_show( v, space.."\t" )
    else
      s = s.."\t"..tostring(k).." => "..tostring(v);
      --gm.print( s.."\t"..tostring(k).." => "..tostring(v) );
    end;
  end;
  if space == "" then gm.print( s ) end
  return s;
end;