-- name=mg_cryptdoorextscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_cryptdoorextscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_cryptdoorextscr" ] = {type = "win", use_place = "mg_cryptdoorextscr", room = "rm_secretroomscr", zz = "mg_cryptdoorextscr", zz_gate = "gmg_secretroomscr_cryptdoorextscr" };

  local win_cryptdoorextscr_logic = function()
    if ld.CheckRequirements( {"win_cryptdoorextscr"} ) then
      
    end
  end;
  local win_cryptdoorextscr = function()
    if ld.CheckRequirements( {"win_cryptdoorextscr"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_cryptdoorextscr", win_cryptdoorextscr, private.room_objname )
  cmn.AddSubscriber("win_cryptdoorextscr", win_cryptdoorextscr_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
end;

--*********************************************************************************************************************
private.cryptdoorextscr_start_arr = {5,6,20,3};
local cryptdoorextscr_new_pos = {0,0,0,0};

function private.set_pos(pos)
  local first_pos_x  = 205;
  local first_pos_y  = 250;
  local tile_w = 102;
  local tile_h = 113;
  local pos_skull_x, pos_skull_y;
  if ( pos%7 == 0 ) then
    pos_skull_x = first_pos_x + 6 * tile_w;
  else
    pos_skull_x = first_pos_x + (pos%7 - 1 ) * tile_w;   
  end;
  pos_skull_y = first_pos_y + math.floor(pos/7.1) * tile_h;
  return pos_skull_x, pos_skull_y;
end

function private.cryptdoorextscr_init(fast)  
  for i = 1, 4 do
    local skull_pos_x, skull_pos_y = private.set_pos(ng_global.progress["scr"]["win_cryptdoorextscr"].state[i]);
    ObjSet( "spr_cryptdoorextscr_skull"..i, {pos_x = skull_pos_x, pos_y = skull_pos_y} );  
    if fast then
      ObjSet( "spr_cryptdoorextscr_skull"..i, { alp = 1} );  
    else
      
      ObjAnimate( "spr_cryptdoorextscr_skull"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
    end  
  end 
  if not fast then 
    ld.Lock(1);
    ld.StartTimer( 0.5, function() ld.Lock(0) private.cryptdoorextscr_check() end );
  end
end 

function private.cryptdoorextscr_arrow_up() 
  cryptdoorextscr_new_pos = {0,0,0,0};
  local min_pos = 22;
  local min_num = 0;
  local new_pos = 0;
  for j = 1,4 do
    min_pos = 22;
    for i = 1,4 do
      if ( ng_global.progress["scr"]["win_cryptdoorextscr"].state[i] < min_pos ) and (cryptdoorextscr_new_pos[i] == 0) then
        min_pos = ng_global.progress["scr"]["win_cryptdoorextscr"].state[i]; 
        min_num = i; 
      end;
    end;
    new_pos = min_pos%7; 
    if min_pos%7 == 0 then
      new_pos = 7;
    end  
    if (min_pos > 7) then
      for k = 1, math.floor(min_pos/7.1)  do
        for n = 1,4 do
          if ( (min_pos - 7*k) == cryptdoorextscr_new_pos[n] or ((min_pos - 7*k) == 10) or ((min_pos - 7*k) == 13)) then
            new_pos = min_pos - 7*(k - 1);
            break;
         end;
          
        end 
        if (new_pos == min_pos - 7*(k - 1)) then
          break;  
        end;   
      end;
    end;
    cryptdoorextscr_new_pos[min_num] = new_pos;
  end;    
end

function private.cryptdoorextscr_arrow_down() 
  cryptdoorextscr_new_pos = {0,0,0,0};
  local max_pos = 0;
  local max_num = 0;
  local new_pos = 0;
  for j = 1,4 do
    max_pos = 0;
    for i = 1,4 do
      if ( ng_global.progress["scr"]["win_cryptdoorextscr"].state[i] > max_pos ) and (cryptdoorextscr_new_pos[i] == 0) then
        max_pos = ng_global.progress["scr"]["win_cryptdoorextscr"].state[i]; 
        max_num = i; 
      end;
    end;
    new_pos = max_pos + math.floor((22-max_pos)/7.1)*7; 
    -- ld.LogTrace( new_pos );
    --if max_pos%7 == 0 then
     --new_pos = max_pos + math.floor((22-max_pos)/7.1)*7;
     -- end  
    if (max_pos < 15) then
      for k = 1, math.floor((22-max_pos)/7.1)  do
        for n = 1,4 do
          if ( (max_pos + 7*k) == cryptdoorextscr_new_pos[n] or ((max_pos + 7*k) == 10) or ((max_pos + 7*k) == 13)) then
            new_pos = max_pos + 7*(k - 1);
            break;
          end;
          
        end 
        if (new_pos == max_pos + 7*(k - 1)) then
          break;  
        end;   
      end;
    end;
    cryptdoorextscr_new_pos[max_num] = new_pos;
  end;      
end

function private.cryptdoorextscr_arrow_left()  
  cryptdoorextscr_new_pos = {0,0,0,0};
  local min_pos = 22;
  local min_num = 0;
  local new_pos = 0;
  for j = 1,4 do
    min_pos = 22;
    for i = 1,4 do
      if ( ng_global.progress["scr"]["win_cryptdoorextscr"].state[i] < min_pos ) and (cryptdoorextscr_new_pos[i] == 0) then
        min_pos = ng_global.progress["scr"]["win_cryptdoorextscr"].state[i]; 
        min_num = i; 
      end;
    end;
    new_pos = math.floor(min_pos/7.1) * 7 + 1; 
    for k = min_pos, (new_pos + 1) , -1 do
      for n = 1,4 do
        if ( (k - 1 == cryptdoorextscr_new_pos[n]) or (k - 1 == 13) or (k - 1 == 11) or (k - 1 == 10)) then
          new_pos = k;
          break;  
        end;
      end
      if ( new_pos == k ) then
        break;  
      end;
    end
    cryptdoorextscr_new_pos[min_num] = new_pos;
  end;
end

function private.cryptdoorextscr_arrow_right() 
  cryptdoorextscr_new_pos = {0,0,0,0};
  local max_pos = 0;
  local max_num = 0;
  local new_pos = 0;
  for j = 1,4 do
    max_pos = 0;
    for i = 1,4 do
      if ( ng_global.progress["scr"]["win_cryptdoorextscr"].state[i] > max_pos ) and (cryptdoorextscr_new_pos[i] == 0) then
        max_pos = ng_global.progress["scr"]["win_cryptdoorextscr"].state[i]; 
        max_num = i; 
      end;
    end;
    new_pos = math.ceil(max_pos/7.1) * 7; 
    for k = max_pos, (new_pos - 1)  do
      for n = 1,4 do
        if ( k + 1 == cryptdoorextscr_new_pos[n] or (k + 1 == 13) or (k + 1 == 12) or (k + 1 == 10)) then
          new_pos = k;
          break;  
        end;
      end
      if ( new_pos == k ) then
        break;  
      end;
    end
    cryptdoorextscr_new_pos[max_num] = new_pos;
  end;  
end

function private.cryptdoorextscr_check() 
  local count = 0;
  for i = 1,3 do
    if ( ng_global.progress["scr"]["win_cryptdoorextscr"].state[i]%7 == 1  ) then
      count = count + 1;  
      ld.Lock(1);
      if ObjGet("spr_cryptdoorextscr_lig_skull"..i).alp ~= 1 then
        SoundSfx( "aud_mg_cryptdoorext_light_skull" );
      end
      ObjAnimate( "spr_cryptdoorextscr_lig_skull"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_cryptdoorextscr_lig_skull"..i).alp, 0.3,0,1} );
    else
      if ObjGet("spr_cryptdoorextscr_lig_skull"..i).alp == 1 then
        ld.Lock(1);
        ObjAnimate( "spr_cryptdoorextscr_lig_skull"..i, 8, 0, 0, function() end, {0,0,ObjGet("spr_cryptdoorextscr_lig_skull"..i).alp, 0.3,0,0} );  
      end
    end;
  end;
  ld.StartTimer( 0.3, function() ld.Lock(0) end )
    if count == 3 and not private.win_start then
    ld.StartTimer( 0.3, function() private.win_start = true;SoundSfx( "aud_mg_cryptdoorext_win" );private.Win(); end )
  end
end

function private.cryptdoorextscr_skip() 
  ng_global.progress["scr"]["win_cryptdoorextscr"].state = {1,8,15,16}
  ld.Lock(1)
  for i = 1,4 do
    ObjAnimate( "spr_cryptdoorextscr_skull"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  end
  ld.StartTimer( 0.5, function() ld.Lock(0); private.cryptdoorextscr_init()  end )
end

function private.cryptdoorextscr_reset() 
  ng_global.progress["scr"]["win_cryptdoorextscr"].state = ld.TableCopy(private.cryptdoorextscr_start_arr);
  ld.Lock(1)
  for i = 1,4 do
    ObjAnimate( "spr_cryptdoorextscr_skull"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  end
  ld.StartTimer( 0.5, function() ld.Lock(0); private.cryptdoorextscr_init()  end )  
end
--------------------------------------------------------------------------
function public.cryptdoorextscr_hand(obj) 
  ld.SetCursor( CURSOR_HAND );  
  ObjAnimate( obj, 8, 0, 0, "", {0,0,ObjGet(obj).alp, 0.3,0,1} );
end

function public.cryptdoorextscr_hand_default(obj) 
  ld.SetCursor( CURSOR_DEFAULT );
  ObjAnimate( obj, 8, 0, 0, "", {0,0,ObjGet(obj).alp, 0.3,0,0} );
end   

function public.cryptdoorextscr_click_arrow(name) 
  SoundSfx( "aud_mg_cryptdoorextscr_click_arrow" );
  if ( name == "up" ) then
    private.cryptdoorextscr_arrow_up()  
  elseif ( name == "down" ) then
    private.cryptdoorextscr_arrow_down() 
  elseif ( name == "left" ) then
    private.cryptdoorextscr_arrow_left() 
  elseif ( name == "right" ) then
    private.cryptdoorextscr_arrow_right()
  end;
  
  ld.Lock(1)
  
  for i = 1,4 do
    local skull_pos_x, skull_pos_y = private.set_pos(cryptdoorextscr_new_pos[i]);
    local o = ObjGet("spr_cryptdoorextscr_skull"..i);
    if ng_global.progress["scr"]["win_cryptdoorextscr"].state[i] ~= cryptdoorextscr_new_pos[i]  then
      SoundSfx( "aud_mg_cryptdoorext_move_skull" );
    end    
    ObjAnimate( o.name, 3, 0, 0, function() end, {0,0,o.pos_x,o.pos_y, 0.5,0,skull_pos_x, skull_pos_y} );  
    ng_global.progress["scr"]["win_cryptdoorextscr"].state[i] = cryptdoorextscr_new_pos[i]; 

  end
  ld.StartTimer( 0.5, function() ld.Lock(0); private.cryptdoorextscr_check(); end )
end  



--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_cryptdoorextscr"} ) then
  SoundMgTheme( true )
    cmn.MiniGameShow( "cryptdoorextscr" );
  end

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  SoundEnv( "aud_groveext_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_cryptdoorextscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "cryptdoorextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  private.cryptdoorextscr_reset()
end;
--*********************************************************************************************************************
function public.Skip()
  private.cryptdoorextscr_skip() ;
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_cryptdoorextscr" );
  cmn.CallEventHandler( "win_cryptdoorextscr" );
  if common_impl.ZzCompleteCheck( "win_cryptdoorextscr" ) then rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ) end;
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_cryptdoorextscr"].state then
      gm.state = ld.TableCopy( ng_global.progress["scr"]["win_cryptdoorextscr"].state )
    else  
      ng_global.progress["scr"]["win_cryptdoorextscr"].state = ld.TableCopy(private.cryptdoorextscr_start_arr);
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.cryptdoorextscr_init(1);  
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_cryptdoorextscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;