-- name=mg_dollsscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_dollsscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_dollsscr" ] = {type = "win", use_place = "mg_dollsscr", room = "rm_secretroomscr", zz = "mg_dollsscr", zz_gate = "gmg_secretroomscr_dollsscr" };

  local win_dollsscr_logic = function()
    if ld.CheckRequirements( {"win_dollsscr"} ) then

    end
  end;
  local win_dollsscr = function()
    if ld.CheckRequirements( {"win_dollsscr"} ) then
      ObjSet( "obj_dollsscr_mg_root", {input = 0} );
      ObjDelete("obj_dollsscr_idle_default_clk_zone");
      ObjSet( "anm_dollsscr_anm_dollsscr_door", {animfunc = "open_default", frame = 999 } );
    end
  end;
  cmn.AddSubscriber("win_dollsscr", win_dollsscr, private.room_objname )
  cmn.AddSubscriber("win_dollsscr", win_dollsscr_logic )
  --------------------------------------------------------------------------------------------
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;


private.dollsscr_anim_array = {"graph","son","countess","brother"};

private.dollsscr_fp_array = {{1,1,1,1},{1,1,1,1},{0,1,2,0}};
private.dollsscr_click_array = {3,2,3,4};

private.dollsscr_connect = {3,1,4,2};

function private.dollsscr_stand_on_pos(without_win_ver)
  for i=1,4,1 do 
    if  ng_global.progress["scr"]["win_dollsscr"].state[1][i] ==1 then 
      ObjSet( "spr_dollsscr_"..private.dollsscr_anim_array[i].."1", {visible=1} );ObjSet( "spr_dollsscr_"..private.dollsscr_anim_array[i].."2", {visible=0} );
    else 
      ObjSet( "spr_dollsscr_"..private.dollsscr_anim_array[i].."2", {visible=1} );ObjSet( "spr_dollsscr_"..private.dollsscr_anim_array[i].."1", {visible=0} );
    end;  
    
     if  ng_global.progress["scr"]["win_dollsscr"].state[2][i] == 1 then
    --   ld.LogTrace( "stand_on_pos "..private.dollsscr_anim_array[i].."1" );
       ObjSet( "anm_dollsscr_anm_dollsscr"..i, {animfunc = private.dollsscr_anim_array[i].."1", frame = 0, playing=0 } );
     else 
    --   ld.LogTrace( "stand_on_pos "..private.dollsscr_anim_array[i].."2" );
       ObjSet( "anm_dollsscr_anm_dollsscr"..i, {animfunc = private.dollsscr_anim_array[i].."2", frame = 0, playing=0 } );
     end;  
    
   end; 
  
   
   if without_win_ver~=1 then  private.dollsscr_win_ver(); end;
 --  ld.LogTrace( ng_global.progress["scr"]["win_dollsscr"].state ); 
end;  


function private.dollsscr_win_ver()
  local count=0;
  for i=1,4,1 do 
    if ng_global.progress["scr"]["win_dollsscr"].state[1][i]==1 and ng_global.progress["scr"]["win_dollsscr"].state[2][i] == 2 then count=count+1; end;
  end;  
  
  if count==4 then private.Win(); end;
end;  



private.dollsscr_first_init_flag = false; 
function private.dollsscr_first_init()
  if private.dollsscr_first_init_flag==false then 
    for i=1,4,1 do 
      ObjSet( "obj_dollsscr_"..private.dollsscr_anim_array[i], {input=1, event_mdown="mg_dollsscr.dollsscr_mdown("..i..");", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
    end;  
  end;
  
  private.dollsscr_first_init_flag = true;
end;  
 
 
 
 
function public.dollsscr_mdown(num)
   SoundSfx( "aud_mg_dolls_click" );
   private.dollsscr_rotate(num);
   private.dollsscr_rotate(private.dollsscr_connect[num],1);
end;  
 
 
 
function private.dollsscr_rotate(num, with_stand_on_pos)
  local num1,num2 = 0,0;
  
  local func_end3 = function()
    if with_stand_on_pos==1 then  ld.Lock(0); private.dollsscr_stand_on_pos(); end;
  end;  
  
  local func_end2 = function()
    ng_global.progress["scr"]["win_dollsscr"].state[3][num] = ng_global.progress["scr"]["win_dollsscr"].state[3][num]+1;
    if ng_global.progress["scr"]["win_dollsscr"].state[3][num]>=private.dollsscr_click_array[num] then  
      ng_global.progress["scr"]["win_dollsscr"].state[3][num]=0; 
      local anim_num = 1;
      if ng_global.progress["scr"]["win_dollsscr"].state[2][num]==1 then 
        ng_global.progress["scr"]["win_dollsscr"].state[2][num]=2;
        anim_num=1; 
        SoundSfx( "aud_mg_dolls_hands_on" ); 
      else 
        ng_global.progress["scr"]["win_dollsscr"].state[2][num]=1;
        anim_num=2;
        SoundSfx("aud_mg_dolls_hands_off");  
      end;
      --ld.LogTrace( private.dollsscr_anim_array[num]..""..anim_num );
      ObjSet( "anm_dollsscr_anm_dollsscr"..num, {animfunc = private.dollsscr_anim_array[num]..""..anim_num, frame=0, playing=0 } );
      ld.AnimPlay( "anm_dollsscr_anm_dollsscr"..num,  private.dollsscr_anim_array[num]..""..anim_num, func_end3 )
    else  
      ld.StartTimer( 0.41, function() func_end3(); end);
    end;  
  end;  
  
  
  local func_end1 = function()
    if ng_global.progress["scr"]["win_dollsscr"].state[1][num]==1 then ng_global.progress["scr"]["win_dollsscr"].state[1][num]=2; else ng_global.progress["scr"]["win_dollsscr"].state[1][num]=1; end;

    ObjSet( "spr_dollsscr_"..private.dollsscr_anim_array[num]..num1, {visible = 0} );
    ObjSet( "spr_dollsscr_"..private.dollsscr_anim_array[num]..num2, {visible = 1} );
    ObjAnimate( "obj_dollsscr_"..private.dollsscr_anim_array[num], 8, 0, 0, func_end2, {0,0,0, 0.25,0,1} );
  end;  
  
  ld.Lock(1);
  if  ng_global.progress["scr"]["win_dollsscr"].state[1][num]==1 then num1=1; num2=2; else num1=2; num2 = 1; end;
  ObjAnimate( "obj_dollsscr_"..private.dollsscr_anim_array[num], 8, 0, 0, func_end1, {0,0,1, 0.25,0,0} );
  ObjAnimate( "spr_dollsscr_lig"..num, 8, 0, 0, function() end, {0,0,0, 0.25,0,1, 0.5,0,0} );
end;  


 
 
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_dollsscr"} ) then
  SoundMgTheme( true )
   
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( {"win_dollsscr"} ) then
     cmn.MiniGameShow( "dollsscr" );  
  end;
  
  private.dollsscr_first_init()
  
  SoundEnv( "aud_terrace_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_dollsscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "dollsscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function() 
      ng_global.progress["scr"]["win_dollsscr"].state  = ld.TableCopy(private.dollsscr_fp_array);
      private.dollsscr_stand_on_pos();
      ObjAnimate( "obj_dollsscr_mg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end
  
  
  ld.Lock(1);
  ObjAnimate( "obj_dollsscr_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
  
end;
--*********************************************************************************************************************
function public.Skip()
   local func_end = function() 
      ng_global.progress["scr"]["win_dollsscr"].state  = {{1,1,1,1},{2,2,2,2},{0,0,0,0}};
      private.dollsscr_stand_on_pos(1);
      ObjAnimate( "obj_dollsscr_mg_root", 8, 0, 0, function()  private.dollsscr_stand_on_pos(); end, {0,0,0, 0.25,0,1} );
  end
  
  
  ld.Lock(1);
  ObjAnimate( "obj_dollsscr_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_dollsscr" );
  cmn.CallEventHandler( "win_dollsscr" );
  if common_impl.ZzCompleteCheck( "win_dollsscr" ) then rm_secretroomscr.GotoRoom( 'rm_secretroomscr' ) end;

end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, function()  SoundSfx( "aud_mg_dolls_win" ); ld.AnimPlay( "anm_dollsscr_anm_dollsscr_door", "open_default", private.WinEnd  ); end );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_dollsscr"].state then
      gm.state = ld.TableCopy( ng_global.progress["scr"]["win_dollsscr"].state )
    else  
       ng_global.progress["scr"]["win_dollsscr"].state  = ld.TableCopy(private.dollsscr_fp_array);
      
    end
  
    gm.loaded  = true;
  else
  
  end;
  
  if not cmn.IsEventDone("win_dollsscr") then 
     private.dollsscr_stand_on_pos();
  else
     private.dollsscr_stand_on_pos(1);
  end;    
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_dollsscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;


------------------------------ other funcs -----------------------------
function public.dollsscr_idle_default_clk_zone()
  local func_end = function() 
      ld.Lock(0); 
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_dollsscr_anm_dollsscr_door", "idle_default", func_end )
end;  