-- name=mg_onbalconyscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_onbalconyscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_onbalconyscr" ] = {type = "win", use_place = "mg_onbalconyscr", room = "rm_secretroomscr", zz = "mg_onbalconyscr", zz_gate = "gmg_secretroomscr_onbalconyscr" };

  local win_onbalconyscr_logic = function()
    if ld.CheckRequirements( {"win_onbalconyscr"} ) then
      
    end
  end;
  local win_onbalconyscr = function()
    if ld.CheckRequirements( {"win_onbalconyscr"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_onbalconyscr", win_onbalconyscr, private.room_objname )
  cmn.AddSubscriber("win_onbalconyscr", win_onbalconyscr_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

local onbalconyscr_big_part_drag_flag = false;
private.onbalconyscr_mg_lp_name_array = {"a","b","c","d"};
private.onbalconyscr_act_array={};   --{{{p,1},{p,2},{p2,1},{p2,2}},{..}}

private.onbalconyscr_fp_field={{{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}},
                            {{0,0},{0,0},{0,0},{0,0},{0,0},{4,5},{0,0}},
                            {{0,0},{0,0},{0,0},{3,3},{3,4},{2,3},{2,4}},
                            {{1,3},{0,0},{1,4},{2,5},{1,5},{4,6},{1,6}},
                            {{0,0},{0,0},{0,0},{3,5},{4,3},{3,6},{0,0}},
                            {{0,0},{0,0},{0,0},{2,6},{0,0},{0,0},{0,0}},
                            {{0,0},{0,0},{0,0},{0,0},{4,4},{0,0},{0,0}}}

private.onbalconyscr_first_init_flag = false;
function private.onbalconyscr_first_init()
  if private.onbalconyscr_first_init_flag == false then 
    ------ create little parts ---
    local parts_count = 0;
    for i=1,4,1 do 
      private.onbalconyscr_act_array[i]={};
      local array_count = 0;
      for j=1,2,1 do 
        parts_count=parts_count+1;
        ObjCreate("spr_onbalconyscr_lp_"..parts_count.."_"..1,"spr");
        ObjAttach("spr_onbalconyscr_lp_"..parts_count.."_"..1,"obj_onbalconyscr_mmg_root");
        ObjSet( "spr_onbalconyscr_lp_"..parts_count.."_"..1, {res="assets/levels/level/mg_onbalcony/"..private.onbalconyscr_mg_lp_name_array[i]..1, input=1, inputrect_init=1, inputrect_w=56, inputrect_h=56, inputrect_x=-28, inputrect_y=-28,
        drag=1, event_menter="mg_onbalconyscr.onbalconyscr_lpart_menter("..parts_count..",1)", event_mleave="mg_onbalconyscr.onbalconyscr_lpart_mleave("..parts_count..",1)", event_startdrag = "mg_onbalconyscr.onbalconyscr_lp_startdrag("..parts_count..",1)", event_dragdrop="mg_onbalconyscr.onbalconyscr_lp_dragdrop("..parts_count..",1)"});
        array_count=array_count+1;
         private.onbalconyscr_act_array[i][array_count]={parts_count,1};
        
        ObjCreate("spr_onbalconyscr_lp_"..parts_count.."_"..2,"spr");
        ObjAttach("spr_onbalconyscr_lp_"..parts_count.."_"..2,"obj_onbalconyscr_mmg_root");
        ObjSet( "spr_onbalconyscr_lp_"..parts_count.."_"..2, {res="assets/levels/level/mg_onbalcony/"..private.onbalconyscr_mg_lp_name_array[i]..2,input=1, inputrect_init=1, inputrect_w=56, inputrect_h=56, inputrect_x=-28, inputrect_y=-28,
        drag=1, event_menter="mg_onbalconyscr.onbalconyscr_lpart_menter("..parts_count..",2)", event_mleave="mg_onbalconyscr.onbalconyscr_lpart_mleave("..parts_count..",2)", event_startdrag = "mg_onbalconyscr.onbalconyscr_lp_startdrag("..parts_count..",2)", event_dragdrop="mg_onbalconyscr.onbalconyscr_lp_dragdrop("..parts_count..",2)";})
        array_count=array_count+1;
        private.onbalconyscr_act_array[i][array_count]={parts_count,2};
      end;  
    end;  
       -- create lights
    for i=1,parts_count,1 do 
      for j=1,2,1 do 
         ObjCreate("spr_onbalconyscr_lp_light_"..i.."_"..j,"spr");
         ObjAttach("spr_onbalconyscr_lp_light_"..i.."_"..j, "spr_onbalconyscr_lp_"..i.."_"..j);
         ObjSet( "spr_onbalconyscr_lp_light_"..i.."_"..j, {res="assets/levels/level/mg_onbalcony/lig_a", input=0, alp=0} );
      end;  
    end;  
    ------------------------------
    -- create panels 
    local panel_fp = 222;
    local panel_step = 67;
    
    for i=1,2,1 do 
      for j=1,8,1 do 
        ObjCreate("obj_onbalconyscr_panel_pole_"..i.."_"..j,"obj");
        ObjAttach("obj_onbalconyscr_panel_pole_"..i.."_"..j,"obj_onbalconyscr_panel"..i)
        ObjSet( "obj_onbalconyscr_panel_pole_"..i.."_"..j, {pos_y = panel_fp+(j-1)*panel_step, input=1, inputrect_init=1, inputrect_w=60, inputrect_h=60, inputrect_x=-30, inputrect_y=-30 } );
        if j>4 then 
          ObjSet( "obj_onbalconyscr_panel_pole_"..i.."_"..j, {input=0, alp=0} );
        end;  
      end;  
    end;  
    ------------------------------
    -- creat field 
    local field_fp = {311,155};
    local field_step = {67,67};
    ObjCreate("obj_onbalconyscr_field","obj");
    ObjAttach("obj_onbalconyscr_field","obj_onbalconyscr_mmg_root");
    ObjSet( "obj_onbalconyscr_field", {input=1} );
    for i=1,7,1 do 
      for j=1,7,1 do 
        ObjCreate("obj_onbalconyscr_field_p_"..i.."_"..j,"obj");
        ObjAttach("obj_onbalconyscr_field_p_"..i.."_"..j,"obj_onbalconyscr_field")
        ObjSet( "obj_onbalconyscr_field_p_"..i.."_"..j, {input=1, inputrect_init=1, inputrect_w=10, inputrect_h=10, inputrect_x=-5, inputrect_y=-5, pos_x=field_step[1]*(j-1)+field_fp[1], pos_y = field_step[2]*(i-1)+field_fp[2] } );
      end;  
    end;  
    
    ------------------------------
    --create trashs ------------------------
    
  --  ObjCreate("spr_onbalconyscr_tr_c1","spr")
  --  ObjAttach("spr_onbalconyscr_tr_c1","obj_onbalconyscr_mmg_root");
  --  ObjSet( "spr_onbalconyscr_tr_c1", {pos_x = 810, pos_y = 323, pos_z = 0, res="assets/levels/level/mg_onbalcony/tr_c1", input=0} );
  --  
  --  ObjCreate("spr_onbalconyscr_tr_c","spr")
  --  ObjAttach("spr_onbalconyscr_tr_c","obj_onbalconyscr_mmg_root");
  --  ObjSet( "spr_onbalconyscr_tr_c", {pos_x = 210, pos_y = 324, pos_z = 0, res="assets/levels/level/mg_onbalcony/tr_c", input=0} );
  end;
  private.onbalconyscr_first_init_flag = true;  
end;  

function private.onbalconyscr_stand_new_part_on_panel(p_num, obj)
   for i=1,8,1 do 
    -- ld.LogTrace(ObjGetRelations( "obj_onbalconyscr_panel_pole_"..p_num.."_"..i ) );
     if not ObjGetRelations( "obj_onbalconyscr_panel_pole_"..p_num.."_"..i ).childs[1] then 
       ObjAttach(obj,"obj_onbalconyscr_panel_pole_"..p_num.."_"..i);
       return;
     end;  
   end;  
   --  ld.LogTrace( "net mesta" );
end;  

private.onbalconyscr_panels_fp = {}
private.onbalconyscr_panels_fp[1] = {7,2,5,1,3,4,6,8};
private.onbalconyscr_panels_fp[2] = {1,3,6,5,2,4,8,7};

function private.onbalconyscr_stand_all_parts_on_panel()
  for i=1,8,1 do 
    for j=1,2,1 do 
      local obj =  "spr_onbalconyscr_lp_"..private.onbalconyscr_panels_fp[j][i].."_"..j;
      --ld.LogTrace( ObjGet( "spr_onbalconyscr_lp_"..private.onbalconyscr_panels_fp[i].."_"..j ) );
      if ObjGetRelations( "spr_onbalconyscr_lp_"..private.onbalconyscr_panels_fp[j][i].."_"..j ).parent~=nil then 
        private.onbalconyscr_stand_new_part_on_panel(j, obj)
      end;  
    end;  
  end;  
  
  for i=1,2,1 do 
    if private.onbaclony_panel_motion_count[i]~=0 then 
      local step=math.abs(private.onbaclony_panel_motion_count[i])/private.onbaclony_panel_motion_count[i];
      for j=1,math.abs(private.onbaclony_panel_motion_count[i]),1 do
        -- ld.LogTrace( "onbalconyscr_stand_all_parts_on_panel" );
           private.onbalconyscr_panel_motion(i,step); 
      end;  
    end;  
  end;  
end;  
---------------
function private.onbalconyscr_return_parts_count_on_panel(p_num)
  local count=0;
  for i=1,8,1 do 
    if ObjGetRelations( "obj_onbalconyscr_panel_pole_"..p_num.."_"..i ).childs[1] then 
      count=count+1;
    end;  
  end;  
  return count;
end; 
--------------------
function private.onbalconyscr_get_panel_childs(p_num)
   local child_array={};
   local count=0;
   for i=1,8,1 do 
    if ObjGetRelations( "obj_onbalconyscr_panel_pole_"..p_num.."_"..i ).childs[1] then 
      count=count+1;
      child_array[count] = ObjGetRelations( "obj_onbalconyscr_panel_pole_"..p_num.."_"..i ).childs[1];
    end;  
  end;  
  return child_array;
end;  
-------------
private.onbaclony_panel_motion_count={0,0};

function private.onbalconyscr_panel_motion(p_num,napr, without_anim) -- 1 - up, -1 - down 
 -- ld.LogTrace( "p_num = "..p_num );
  local func_end = function() 
      if private.onbalconyscr_return_parts_count_on_panel(p_num)>0 then -- ne pustaya li panel
        
        if napr == 1 then 
          local childs_list =  private.onbalconyscr_get_panel_childs(p_num);
          local obj_count = private.onbalconyscr_return_parts_count_on_panel(p_num);
          ObjAttach(childs_list[1],"obj_onbalconyscr_panel_pole_"..p_num.."_"..obj_count);
          for i=2,obj_count,1 do 
             ObjAttach(childs_list[i],"obj_onbalconyscr_panel_pole_"..p_num.."_"..(i-1));
          end;  
        else 
          local childs_list =  private.onbalconyscr_get_panel_childs(p_num);
        --  ld.LogTrace( childs_list );
          local obj_count = private.onbalconyscr_return_parts_count_on_panel(p_num);
        --  ld.LogTrace( "obj_count = "..obj_count );
          ObjAttach(childs_list[obj_count],"obj_onbalconyscr_panel_pole_"..p_num.."_"..1);
          for i=1,obj_count-1,1 do 
            ObjAttach(childs_list[i],"obj_onbalconyscr_panel_pole_"..p_num.."_"..(i+1));
          end;  
        end; 
       
        private.onbaclony_panel_motion_count[p_num] = private.onbaclony_panel_motion_count[p_num]+napr; 
      end;  
      
      ObjAnimate( "obj_onbalconyscr_panel"..p_num, 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );  
  end
  
  if without_anim ~=1  and private.onbalconyscr_return_parts_count_on_panel(p_num)>0 then 
    ld.Lock(1);
    local last_num =  private.onbalconyscr_return_parts_count_on_panel(p_num);
    local pole8y = ObjGet("obj_onbalconyscr_panel_pole_"..p_num.."_"..last_num).pos_y;
    
   -- if napr == -1 then  
   --    ObjSet( "obj_onbalconyscr_panel_pole_"..p_num.."_"..last_num, {visible=1, alp=1, pos_y = 155 } );
   -- else   
   --    ObjSet( "obj_onbalconyscr_panel_pole_"..p_num.."_"..5, {visible = 1, alp=1} );
   -- end;  
    ObjAnimate( "obj_onbalconyscr_panel"..p_num, 8, 0, 0, function()  func_end(); 
     -- ObjAnimate( "obj_onbalconyscr_panel"..p_num, 1, 0, 0, function() ld.Lock(0); func_end();
     -- ObjSet( "obj_onbalconyscr_panel"..p_num, {pos_y=0} );ObjSet( "obj_onbalconyscr_panel_pole_"..p_num.."_"..5, {visible=0, alp=0} ); 
     -- if last_num > 4 then 
     --   ObjSet( "obj_onbalconyscr_panel_pole_"..p_num.."_"..last_num, {visible=0, alp=0, pos_y = pole8y } );
     -- else   
     --   ObjSet( "obj_onbalconyscr_panel_pole_"..p_num.."_"..last_num, {pos_y = pole8y } );
     -- end;  
      --  end, {0,0,0, 0.3,0,-67*napr} );
     end, {0,0,1, 0.25,0,0} );  
  else 
    func_end();
  end;  
end;  

--------------------------------------
function public.onbalconyscr_menter_func(obj) -- mg_onbalconyscr.onbalconyscr_menter_func(ne_params.sender);
   ld.SetCursor(CURSOR_HAND)
   ObjSet( obj, {alp=1} );
end;  
--------------------------------------
function public.onbalconyscr_mleave_func(obj)  --mg_onbalconyscr.onbalconyscr_mleave_func(ne_params.sender);
   ObjSet( obj, {alp=0} );
   ld.SetCursor(CURSOR_DEFAULT);
end;  
------------------------------------

function public.onbalconyscr_panel_str_mdown(p_num, napr) --mg_onbalconyscr.onbalconyscr_panel_str_mdown(p_num,napr);
 --local func_end = function()
 --  private.onbalconyscr_panel_motion(p_num,napr)
 --  ObjAnimate( "obj_onbalconyscr_panel"..p_num, 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.1,0,1} ); 
 --end;

 --ld.Lock(0);
 --ObjAnimate( "obj_onbalconyscr_panel"..p_num, 8, 0, 0, func_end, {0,0,1, 0.1,0,0} );

   SoundSfx( "aud_mg_onbalcony_click" );
   private.onbalconyscr_panel_motion(p_num,napr)  
end;  
-----------------------------------

------------------little parts --------------------------
function public.onbalconyscr_lpart_menter(num1,num2) --mg_onbalconyscr.onbalconyscr_part_menter(num1,num2)
  ld.SetCursor(CURSOR_HAND)
  ObjSet( "spr_onbalconyscr_lp_light_"..num1.."_"..num2, {alp=1} );
end;  

function public.onbalconyscr_lpart_mleave(num1,num2)  --mg_onbalconyscr.onbalconyscr_part_mleave(num1,num2)
  ld.SetCursor(CURSOR_DEFAULT)
  ObjSet( "spr_onbalconyscr_lp_light_"..num1.."_"..num2, {alp=0} );
end;  
-----------------------------------
private.onbalconyscr_current_part_root = false;
function public.onbalconyscr_lp_startdrag(num1,num2) --mg_onbalconyscr.onbalconyscr_lp_startdrag(num1,num2)
  onbalconyscr_big_part_drag_flag = true;
  ld.SetCursor(CURSOR_HAND)
  private.onbalconyscr_current_part_root = ObjGetRelations("spr_onbalconyscr_lp_"..num1.."_"..num2 ).parent
  ObjAttach("spr_onbalconyscr_lp_"..num1.."_"..num2,"obj_onbalconyscr_mmg_root");
  ObjSet( "spr_onbalconyscr_lp_"..num1.."_"..num2, {pos_z=40} );
 -- ld.LogTrace( "start drag "..obj.." pos_z = "..ObjGet(obj).pos_z );
 SoundSfx( "aud_mg_onbalcony_get" )
end;  

----------------------------------------------------------
function private.onbalconyscr_create_new_big_part(ptype,num)
  ObjCreate("spr_onbalconyscr_part_"..ptype.."_"..num,"spr");
  ObjSet( "spr_onbalconyscr_part_"..ptype.."_"..num, {res = "assets/levels/level/mg_onbalcony/z"..ptype, input=1, drag=1, event_menter="mg_onbalconyscr.onbalconyscr_part_menter("..ptype..","..num..");", event_mleave="mg_onbalconyscr.onbalconyscr_part_mleave("..ptype..","..num..");", event_startdrag="mg_onbalconyscr.onbalconyscr_part_start_drag("..ptype..","..num..");", event_dragdrop="mg_onbalconyscr.onbalconyscr_part_dragdrop("..ptype..","..num..");"} );
  
  --create light 
  ObjCreate("spr_onbalconyscr_part_light"..ptype.."_"..num,"spr");
  ObjSet( "spr_onbalconyscr_part_light"..ptype.."_"..num, {res = "assets/levels/level/mg_onbalcony/lig_a1", input=0, alp=0} );
  ObjAttach("spr_onbalconyscr_part_light"..ptype.."_"..num, "spr_onbalconyscr_part_"..ptype.."_"..num);
  
end;  
-----------------------------------------------------------
function public.onbalconyscr_lp_dragdrop(num1,num2) --mg_onbalconyscr.onbalconyscr_lp_dragdrop(num1,num2)
  onbalconyscr_big_part_drag_flag = false;
  
  local apply_num1, apply_num2=0,0;
  local pl_group = private.on_balcony_search_partgroup_on_onbalconyscr_act_array(num1);
  for i=1,#private.onbalconyscr_act_array[pl_group],1 do
    if ApplyObj("spr_onbalconyscr_lp_"..num1.."_"..num2,"spr_onbalconyscr_lp_"..private.onbalconyscr_act_array[pl_group][i][1].."_"..private.onbalconyscr_act_array[pl_group][i][2]) and num2~=private.onbalconyscr_act_array[pl_group][i][2] then 
      apply_num1,apply_num2 = private.onbalconyscr_act_array[pl_group][i][1],private.onbalconyscr_act_array[pl_group][i][2];
    end;  
  end;  
  
  if apply_num1~=0 then 
     local apply_num_parent = ObjGetRelations( "spr_onbalconyscr_lp_"..apply_num1.."_"..apply_num2 ).parent;
     ObjDelete("spr_onbalconyscr_lp_"..num1.."_"..num2);
     ObjDelete("spr_onbalconyscr_lp_"..apply_num1.."_"..apply_num2);
     
     local num=1;
     
     --   ld.LogTrace( "search num = "..(pl_group-1)*2 );
     if  ng_global.progress["scr"]["win_onbalconyscr"].state[1][(pl_group*2)-1]==0 then num=1 else num=2 end;
     private.onbalconyscr_create_new_big_part(pl_group,num)
     -- ld.LogTrace( "onbalconyscr_lp_dragdrop" );
     private.onbalconyscr_panel_motion(num2,-1)
     
     local obj = "spr_onbalconyscr_part_"..pl_group.."_"..num
     --private.onbalconyscr_stand_new_part_on_panel(apply_num2, obj);
     SoundSfx( "aud_mg_onbalcony_square" );
     ObjAttach(obj,apply_num_parent);
     ------------------------ fx ------------
     ObjCreate("pfx_onbalconyscr_part_fx_"..pl_group.."_"..num,"partsys_pm");
     ObjAttach("pfx_onbalconyscr_part_fx_"..pl_group.."_"..num,obj);
     ObjSet( "pfx_onbalconyscr_part_fx_"..pl_group.."_"..num, {input=0, res="assets/levels/level/mg_onbalcony/p_lig", active=1, visible=1} );
     ld.StartTimer( 2, function() ObjDelete("spr_onbalconyscr_part_fx_"..pl_group.."_"..num);  end )
     ------------------------------------------
     ng_global.progress["scr"]["win_onbalconyscr"].state[1][pl_group*2+(num-2)]=apply_num2;
     -- ld.LogTrace( "write num = "..(pl_group-1)*2+(num-1) );
     --  ld.LogTrace( ng_global.progress["scr"]["win_onbalconyscr"].state[1] );
     ld.SetCursor(CURSOR_DEFAULT);
  else 
    SoundSfx( "aud_mg_onbalcony_set" ); 
    ObjAttach("spr_onbalconyscr_lp_"..num1.."_"..num2, private.onbalconyscr_current_part_root) 
    ld.SetCursor(CURSOR_DEFAULT)
    ObjSet( "spr_onbalconyscr_lp_"..num1.."_"..num2, {pos_z=1} );
  end;  
  
 -- private.onbalconyscr_stand_on_pos();
end;  
---------------------------------------------------------------------
function private.on_balcony_search_partgroup_on_onbalconyscr_act_array(num1) --{{{p,1},{p,2},{p2,1},{p2,2}},{..}}
  for i=1,#private.onbalconyscr_act_array,1 do 
    for j=1,#private.onbalconyscr_act_array[i],1 do 
      if private.onbalconyscr_act_array[i][j][1] == num1 then return i; end;
    end;  
  end;  
end;  
--------------------------------------------------------------------------------------------------------


--------------------------------------------------------------------------------------------------------
private.onbalocny_create_parts_on_field_flag = false;
function private.onbalocny_create_parts_on_field()
  if private.onbalocny_create_parts_on_field_flag == false then 
    --create parts on field 
    for i=1,7,1 do 
      for j=1,7,1 do
        local num = ld.TableCopy(ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][j]);  
        if num[1]~=0 then 
          ObjCreate("spr_onbalconyscr_part_"..num[1].."_"..num[2],"spr");
          ObjSet( "spr_onbalconyscr_part_"..num[1].."_"..num[2], {res="assets/levels/level/mg_onbalcony/z"..num[1], input=0, visible=1} );
        end;
      end;  
    end;  
  
  end;
  private.onbalocny_create_parts_on_field_flag = true;
end;  


------------------------------------------------------------



function private.onbalconyscr_stand_on_pos()
  --ld.LogTrace( ng_global.progress["scr"]["win_onbalconyscr"].state );
  
  -- little parts and big on panel
  for i=1,8,1 do 
    if  ng_global.progress["scr"]["win_onbalconyscr"].state[1][i]==1 or  ng_global.progress["scr"]["win_onbalconyscr"].state[1][i]==2 then  -- if 0 then load little parts, if 1 or 2 then big parts, if 3 then nothing
      ObjDelete("spr_onbalconyscr_lp_"..i.."_"..1);
      ObjDelete("spr_onbalconyscr_lp_"..i.."_"..2);
      
      local ptype = private.on_balcony_search_partgroup_on_onbalconyscr_act_array(i);
      local num=1;
      if i==(ptype*2)-1 then num=1 else num=2 end;
      private.onbalconyscr_create_new_big_part(ptype,num)
      
      local obj = "spr_onbalconyscr_part_"..ptype.."_"..num;
      private.onbalconyscr_stand_new_part_on_panel(ng_global.progress["scr"]["win_onbalconyscr"].state[1][i], obj);
    elseif ng_global.progress["scr"]["win_onbalconyscr"].state[1][i]==3 then 
       ObjDelete("spr_onbalconyscr_lp_"..i.."_"..1);
       ObjDelete("spr_onbalconyscr_lp_"..i.."_"..2);
    end;  
  end;  
  
  private.onbalconyscr_stand_all_parts_on_panel();
  
  ---
  private.onbalocny_create_parts_on_field();
 
  for i=1,7,1 do 
    for j=1,7,1 do 
       local num = ld.TableCopy(ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][j]); 
       if num[1]~=0 then
         ObjAttach("spr_onbalconyscr_part_"..num[1].."_"..num[2],"obj_onbalconyscr_field_p_"..i.."_"..j);
       end;  
    end;  
  end; 
  
   private.onbalconyscr_win_ver();
   
   if cmn.IsEventDone("win_onbalconyscr") then private.Win() end;
end;  
------------------------------------

function private.onbalconyscr_win_ver()
  local count=0;
  for i=1,7,1 do 
    for j=1,7,1 do 
      if ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][j][1]~=0 then count= count+1; end;
    end;  
  end;  
  if count==0 then
    private.Win();
  else  
    if  private.onbalconyscr_return_parts_count_on_panel(1)==0 and  private.onbalconyscr_return_parts_count_on_panel(2)==0 and onbalconyscr_big_part_drag_flag==false then 
      SoundSfx( "aud_mgreset" );
      public.Reset();
    else  
      ld.Lock(0);
    end;  
  end;
  
  if private.onbalconyscr_current_part_root then 
   local panel_obj = ObjGetRelations( private.onbalconyscr_current_part_root ).parent; 
 --  ld.LogTrace( "panel_obj = "..panel_obj );
   
   local pan_num = string.sub(panel_obj,string.len(panel_obj),string.len(panel_obj)+1);
  -- ld.LogTrace( pan_num );
   --- huynia ----
   if onbalconyscr_big_part_drag_flag == false then 
     if pan_num=="1" then 
       -- ld.LogTrace( "onbalconyscr_win_ver" );
       private.onbalconyscr_panel_motion(1,-1)
     else 
       -- ld.LogTrace( "onbalconyscr_win_ver" ); 
       private.onbalconyscr_panel_motion(2,-1)
     end; 
   end; 
  end; 
end;  

----------------------------------------------------------------------

function public.onbalconyscr_part_menter(num1,num2) --mg_onbalconyscr.onbalconyscr_part_menter(num1,num2)
  ld.SetCursor(CURSOR_HAND);
  ObjSet( "spr_onbalconyscr_part_light"..num1.."_"..num2, {alp=1} );
end;

function public.onbalconyscr_part_mleave(num1,num2)  --mg_onbalconyscr.onbalconyscr_part_mleave(num1,num2)
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet( "spr_onbalconyscr_part_light"..num1.."_"..num2, {alp=0} );
end;  

function public.onbalconyscr_part_start_drag(num1,num2) --mg_onbalconyscr.onbalconyscr_part_start_drag(num1,num2)
  onbalconyscr_big_part_drag_flag = true;
  ld.SetCursor(CURSOR_HAND);
  private.onbalconyscr_current_part_root = ObjGetRelations("spr_onbalconyscr_part_"..num1.."_"..num2 ).parent  
  ObjAttach("spr_onbalconyscr_part_"..num1.."_"..num2,"obj_onbalconyscr_mmg_root");
  ObjSet( "spr_onbalconyscr_part_"..num1.."_"..num2, {pos_z=40} );
  SoundSfx( "aud_mg_onbalcony_get" );
end;  

function public.onbalconyscr_part_dragdrop(num1,num2) --mg_onbalconyscr.onbalconyscr_part_dragdrop(num1,num2);
  onbalconyscr_big_part_drag_flag = false;
  local apply_field={0,0};
  local apply_flag = false;
  
  for i=1,7,1 do 
    for j=1,7,1 do 
      if ApplyObj("spr_onbalconyscr_part_"..num1.."_"..num2, "obj_onbalconyscr_field_p_"..i.."_"..j) and ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][j][1]==0  then apply_field={i,j};apply_flag=true; end;
    end;  
  end;  
  
  if apply_flag == true then 
    SoundSfx( "aud_mg_onbalcony_set" )
    local num_on_ar1 = (num1*2)+(num2-2);
    ng_global.progress["scr"]["win_onbalconyscr"].state[1][num_on_ar1]=3;
    ng_global.progress["scr"]["win_onbalconyscr"].state[2][apply_field[1] ][apply_field[2] ] = {num1,num2};
    
    local panel_obj = ObjGetRelations( private.onbalconyscr_current_part_root ).parent; 
    private.pan_num = string.sub(panel_obj,string.len(panel_obj),string.len(panel_obj)+1);
   -- ld.LogTrace( "select panel = "..pan_num );  
   -- ld.LogTrace( panel_obj );  
    
    
    ObjSet( "spr_onbalconyscr_part_"..num1.."_"..num2, {pos_z = 1 , input=0, drag=0} );
    ObjAttach("spr_onbalconyscr_part_"..num1.."_"..num2,"obj_onbalconyscr_field_p_"..apply_field[1].."_"..apply_field[2]); 
    ld.Lock(1)
    ld.StartTimer( 0.3, function() private.onbalconyscr_search_true_parts(apply_field[1],apply_field[2],num1,num2); ld.Lock(0); end )
  --  private.onbalconyscr_panel_motion(private.pan_num,-1)
  else  
    SoundSfx( "aud_mg_onbalcony_set" )
    ObjSet( "spr_onbalconyscr_part_"..num1.."_"..num2, {pos_z = 1} );
    ObjAttach("spr_onbalconyscr_part_"..num1.."_"..num2,private.onbalconyscr_current_part_root); 
  end;  
 
  
  ld.SetCursor(CURSOR_DEFAULT);
end;  


function private.onbalconyscr_search_true_parts(fi,fj,ptype,pnum)
--  ld.LogTrace( "serach pole = "..fi.." , "..fj.."  search type = "..ptype );
  
  local delete_array={};
  
  local hor_count=0;
  local ver_count=0;
  
  -----------vertical search -------------------------------
  ---- up ----
  local up_step = 0;
  if fi-2>0 then up_step=2; 
  elseif fi-1>0 then up_step=1; 
  else up_step=0; end;

 -- ld.LogTrace( "up_step = "..up_step );
  local find_fl = true;
  if up_step>0 then 
    for i=fi-1,fi-up_step,-1 do 
      if find_fl==true and ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][fj][1]==ptype then 
     --   ld.LogTrace( "find" );
        ver_count=ver_count+1;
       -- delete_array[#delete_array+1] = {ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][fj][1],ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][fj][2]};
        delete_array[#delete_array+1] = {i,fj}
      else find_fl=false; end;
    end;  
  end;  
  ----down------
  
 
  local down_step = 0;
  if fi+2<8 then down_step=2; 
  elseif fi+1<8 then down_step=1; 
  else down_step=0; end;
  
--  ld.LogTrace( "down_step = "..down_step );
  find_fl = true;
  if down_step>0 then 
    for i=fi+1,fi+down_step,1 do 
      if find_fl==true and ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][fj][1]==ptype then
      --   ld.LogTrace( "find" );
         ver_count=ver_count+1;
        --  delete_array[#delete_array+1] = {ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][fj][1],ng_global.progress["scr"]["win_onbalconyscr"].state[2][i][fj][2]};
         delete_array[#delete_array+1] = {i,fj}
      else find_fl=false; end;
    end;  
  end;  
  
  ---------------horizontal search-------------------
  ---left 
  local left_step = 0;
  if fj-2>0 then left_step=2; 
  elseif fj-1>0 then left_step=1; 
  else left_step=0; end;

--  ld.LogTrace( "left_step = "..left_step );
  find_fl = true;
  if left_step>0 then 
    for j=fj-1,fj-left_step,-1 do 
      if find_fl==true and ng_global.progress["scr"]["win_onbalconyscr"].state[2][fi][j][1]==ptype then 
     --   ld.LogTrace( "find" );
        hor_count=hor_count+1;
        delete_array[#delete_array+1] = {fi,j}
      --  delete_array[#delete_array+1] = {ng_global.progress["scr"]["win_onbalconyscr"].state[2][fi][j][1],ng_global.progress["scr"]["win_onbalconyscr"].state[2][fi][j][2]};
      else find_fl=false; end;
    end;  
  end;  
  
  -----right 
  local right_step = 0;
  if fj+2<8 then right_step=2; 
  elseif fj+1<8 then right_step=1; 
  else right_step=0; end;

--  ld.LogTrace( "right_step = "..right_step );
  find_fl = true;
  if right_step>0 then 
    for j=fj+1,fj+right_step,1 do 
      if find_fl==true and ng_global.progress["scr"]["win_onbalconyscr"].state[2][fi][j][1]==ptype then 
     --   ld.LogTrace( "find" );
        hor_count=hor_count+1;
        -- delete_array[#delete_array+1] = {ng_global.progress["scr"]["win_onbalconyscr"].state[2][fi][j][1],ng_global.progress["scr"]["win_onbalconyscr"].state[2][fi][j][2]};
        delete_array[#delete_array+1] = {fi,j}
      else find_fl=false; end;
    end;  
  end;    
  ------------------------------------------------------  
  
  --- delete select parts 
  
--  ld.LogTrace( "hor_count = "..hor_count );
--  ld.LogTrace( "ver_count = "..ver_count );
  if hor_count>1 or ver_count>1 then   
     ld.Lock(1);
      SoundSfx( "aud_mg_onbalcony_hide" );  
      
      for i=1,#delete_array,1 do 
        if delete_array[i][1]==fi and hor_count>=2 then 
          
          local ptype = ng_global.progress["scr"]["win_onbalconyscr"].state[2][delete_array[i][1] ][delete_array[i][2] ][1];
          local pnum = ng_global.progress["scr"]["win_onbalconyscr"].state[2][delete_array[i][1] ][delete_array[i][2] ][2];
          ObjAnimate( "spr_onbalconyscr_part_"..ptype.."_"..pnum, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
          ld.StartTimer( 0.5, function() ObjDelete("spr_onbalconyscr_part_"..ptype.."_"..pnum); end ) 
          ng_global.progress["scr"]["win_onbalconyscr"].state[2][delete_array[i][1] ][delete_array[i][2] ] = {0,0};   
          
         ObjCreate("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2],"partsys_pm");
         ObjAttach("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2],"obj_onbalconyscr_field_p_"..delete_array[i][1].."_"..delete_array[i][2]);
         ObjSet( "pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2], {input=0, res="assets/levels/level/mg_onbalconyscr/p_lig", active=1, visible=1} );
         ObjAnimate( "pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2], 8, 0, 0, function() ObjDelete("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2]); end, {0,0,1, 0.5,0,1, 1,0,0} );
           -- ld.StartTimer( 2, function() ObjDelete("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2]);  end )
          
        end;  
        if delete_array[i][2]==fj and ver_count>=2 then
          local ptype = ng_global.progress["scr"]["win_onbalconyscr"].state[2][delete_array[i][1] ][delete_array[i][2] ][1];
          local pnum = ng_global.progress["scr"]["win_onbalconyscr"].state[2][delete_array[i][1] ][delete_array[i][2] ][2];
          ObjAnimate( "spr_onbalconyscr_part_"..ptype.."_"..pnum, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
          ld.StartTimer( 0.5, function() ObjDelete("spr_onbalconyscr_part_"..ptype.."_"..pnum); end);
          ng_global.progress["scr"]["win_onbalconyscr"].state[2][delete_array[i][1] ][delete_array[i][2] ] = {0,0};   
          
         ObjCreate("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2],"partsys_pm");
         ObjAttach("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2],"obj_onbalconyscr_field_p_"..delete_array[i][1].."_"..delete_array[i][2]);
         ObjSet( "pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2], {input=0, res="assets/levels/level/mg_onbalcony/p_lig", active=1, visible=1} );
         ObjAnimate( "pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2], 8, 0, 0, function() ObjDelete("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2]); end, {0,0,1, 0.5,0,1, 1,0,0} );
         --ld.StartTimer( 2, function() ObjDelete("pfx_onbalconyscr_part_fx_"..delete_array[i][1].."_"..delete_array[i][2]);  end )
        end;  
      end;  
      if hor_count>1 or ver_count>1 then 
        ng_global.progress["scr"]["win_onbalconyscr"].state[2][fi][fj] = {0,0}; 
        ObjAnimate( "spr_onbalconyscr_part_"..ptype.."_"..pnum, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
        ld.StartTimer( 0.5, function() ObjDelete("spr_onbalconyscr_part_"..ptype.."_"..pnum); end);
        
        ObjCreate("pfx_onbalconyscr_part_fx_"..fi.."_"..fj,"partsys_pm");
        ObjAttach("pfx_onbalconyscr_part_fx_"..fi.."_"..fj,"obj_onbalconyscr_field_p_"..fi.."_"..fj);
        ObjSet( "pfx_onbalconyscr_part_fx_"..fi.."_"..fj, {input=0, res="assets/levels/level/mg_onbalcony/p_lig", active=1, visible=1} );
        ObjAnimate( "pfx_onbalconyscr_part_fx_"..fi.."_"..fj, 8, 0, 0, function() ObjDelete("pfx_onbalconyscr_part_fx_"..fi.."_"..fj); end, {0,0,1, 0.5,0,1, 1,0,0} );
        --ld.StartTimer( 2, function() ObjDelete("pfx_onbalconyscr_part_fx_"..fi.."_"..fj);  end )
      end;
      ld.StartTimer( 0, function() --ld.Lock(0); 
         private.onbalconyscr_win_ver()
      end )  
   else
       private.onbalconyscr_win_ver(); 
   end;  
  
end;  
  
--  private.onbalconyscr_current_part_root = ObjGetRelations("spr_onbalconyscr_part"..num1.."_"..num2 ).parent  
--  ObjAttach("spr_onbalconyscr_part"..num1.."_"..num2,"obj_onbalconyscr_mmg_root");
--  ObjSet( "spr_onbalconyscr_part"..num1.."_"..num2, {pos_z=40} );
--end;  

--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_onbalconyscr"} ) then
  SoundMgTheme( true )
  -- cmn.MiniGameShow( "onbalconyscr" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( {"win_onbalconyscr"} ) then
    cmn.MiniGameShow( "onbalconyscr" );
  end
  SoundEnv( "aud_livingroom_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_onbalconyscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "onbalconyscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
  --  ObjDelete("spr_onbalconyscr_tr_c1");
  --  ObjDelete("spr_onbalconyscr_tr_c")
    
    ObjDelete("obj_onbalconyscr_panel1");
    ObjDelete("obj_onbalconyscr_panel2");
    ObjDelete("obj_onbalconyscr_field");
    
    ObjCreate("obj_onbalconyscr_panel1","obj")
    ObjAttach("obj_onbalconyscr_panel1","obj_onbalconyscr_panel_root");
    ObjSet( "obj_onbalconyscr_panel1", {pos_x=209, input=1} );
    
    ObjCreate("obj_onbalconyscr_panel2","obj")
    ObjAttach("obj_onbalconyscr_panel2","obj_onbalconyscr_panel_root");
    ObjSet( "obj_onbalconyscr_panel2", {pos_x=811, input=1} );
    
    ng_global.progress["scr"]["win_onbalconyscr"].state = {}
    ng_global.progress["scr"]["win_onbalconyscr"].state[1]={0,0,0,0,0,0,0,0} -- full parts 
    ng_global.progress["scr"]["win_onbalconyscr"].state[2]=ld.TableCopy(private.onbalconyscr_fp_field);
    
    private.onbaclony_panel_motion_count={0,0};
    
     private.onbalconyscr_current_part_root = false;
    
    private.onbalconyscr_first_init_flag = false;
    private.onbalconyscr_first_init();
    private.onbalocny_create_parts_on_field_flag = false;
   -- private.onbalocny_create_parts_on_field();
    private.onbalconyscr_stand_on_pos();
    
    ObjAnimate( "obj_onbalconyscr_mmg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_onbalconyscr_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;
--*********************************************************************************************************************
function public.Skip()
  private.Win();
end;
--*********************************************************************************************************************
function private.WinEnd()
  --ld.Lock(0);
  cmn.SetEventDone( "win_onbalconyscr" );
  cmn.CallEventHandler( "win_onbalconyscr" );
  ld.StartTimer( 0.5, function() ld.Lock(0); rm_secretroomscr.GotoRoom( 'rm_secretroomscr' )  end ) 

end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 1.5, private.WinEnd  );
  ld.StartTimer( 1, function() SoundSfx( "aud_mg_onbalcony_win" ); end ) 
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  private.onbalconyscr_first_init();
  
  
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_onbalconyscr"].state then
      gm.state = ld.TableCopy( ng_global.progress["scr"]["win_onbalconyscr"].state )
    else 
      ng_global.progress["scr"]["win_onbalconyscr"].state = {}
      ng_global.progress["scr"]["win_onbalconyscr"].state[1]={0,0,0,0,0,0,0,0} -- full parts 
      ng_global.progress["scr"]["win_onbalconyscr"].state[2]=ld.TableCopy(private.onbalconyscr_fp_field);
    end
  
    gm.loaded  = true;
  else
  
  end;
  
  private.onbalconyscr_stand_on_pos()
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_onbalconyscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;